/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief I2C ѯģʽ² EEPROM ̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. PIOB_6  EEPROM  SCL ţ
 *   2. PIOB_7  EEPROM  SDA š
 *
 * - ʵ
 *   1.  EEPROM 豸д 16 ֽݣ
 *   2. ȡ EEPROM еͨڴӡ
 *   3. дݺͶȡһ£УͨLED0  200ms ˸
 *
 * \note
 *    1. LED0 Ҫ̽ J9 ñܱ PIOB_1 ƣ
 *    2. ۲촮ڴӡĵϢҪ PIOA_9  PC ڵ RXD
 *    3. ǰ I2C  SCL ʹõ PIOB_6SDA ʹõ PIOB_7
 *       ɸʵš
 *
 * \par Դ
 * \snippet demo_aml165_core_hw_i2c_master_poll.c src_aml165_core_hw_i2c_master_poll
 *
 * \internal
 * \par History
 * - 1.00 15-07-13  win, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_aml165_core_hw_i2c_master_poll
 * \copydoc demo_aml165_core_hw_i2c_master_poll.c
 */

/** [src_aml165_core_hw_i2c_master_poll] */
#include "ametal.h"
#include "am_clk.h"
#include "am_gpio.h"
#include "am_vdebug.h"
#include "am_zml165.h"
#include "am_zml165_clk.h"
#include "hw/amhw_zlg_i2c.h"
#include "demo_zlg_entries.h"
#include "demo_aml165_core_entries.h"

/**
 * \brief 
 */
void demo_aml165_core_hw_i2c_master_poll_entry (void)
{
    am_kprintf("demo aml165_core hw i2c master poll!\r\n");

    am_gpio_pin_cfg(PIOB_6, PIOB_6_I2C_SCL | PIOB_6_AF_OD | PIOB_6_SPEED_20MHz);
    am_gpio_pin_cfg(PIOB_7, PIOB_7_I2C_SDA | PIOB_7_AF_OD | PIOB_7_SPEED_20MHz);

    am_clk_enable(CLK_I2C1);
    am_zml165_clk_reset(CLK_I2C1);

    demo_zlg_hw_i2c_master_poll_entry(ZML165_I2C, am_clk_rate_get (CLK_APB1));
}
/** [src_aml165_core_hw_i2c_master_poll] */

/* end of file */
