/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader ̡
 *
 * - 裨
 *   1. eclipse̴demo_aml166_core_bootloader.ldļɸݾbootСò£
 *          FLASH  (rx) : ORIGIN = 0x00000000, LENGTH = 0X6600  //Ϊ26.5K
 *
 *      keil̴demo_aml66_core_bootloader.sctļʾ޸bootС£
 *          #define     ALL_SIZE      0X00006600     //ֻɸĴ˲
 *
 *      湤ļ֮⣬Ҫ/user_config/../am_bootconf_hc32l19x_single.cļڵϢṹ
 *
 *      Ĭflash£
 *      򻮷:    |----------|----------------------------|
 *      :        bootloader         application
 *      С:           25.5K                 114k
 *
 *   2. ӿλ֣Ϊ115200ʹô1
 *   
 *   3. ر̱ĳ򣬸λС
 *
 *   4. ִӡ5뵹ʱ5ַͨݸ壬׼չ̼
 *
 *   5. õĹַ̼ͨ͸壨ڷ͵Ĺ̳½չ̼λ·ͣ
 *
 *   6. ճɹתӦóִУڴӡӦóϢLED˸
 *
 * \note
 *    ̼
 *
 *    ametal/tools/bootloader/̼У/ ļУĿ¼һbin_chek_sum.binִļ
 *    ԵӦù̱binļbin_chek_sum.binͬһĿ¼£
 *    ڸĿ¼´cmd룺
 *         bin_chek_sum.exe  xxx.binbinļƣ xxx.binĿļȡ
 *
 *    ִһûԼȡĿļļҪ͵Ĺ̼
 *    
 *
 * \internal
 * \par Modification History
 * - 1.00 20-08-19  yrz, first implementation
 * \endinternal
 */


#include "am_uart.h"
#include "am_vdebug.h"
#include "am_boot_firmware.h"
#include "am_boot_flash.h"
#include "am_bootconf_aml166.h"
#include "am_aml166_inst_init.h"
#include "am_boot_enter_check_uart.h"
#include "am_boot_firmware_recv_uart.h"
#include "demo_boot_entries.h"

void demo_aml166_core_single_bootloader_uart_entry (void)
{
    am_uart_handle_t           uart_handle;
    am_boot_firmware_handle_t  firmware_handle;

    /* bootloader ׼ӿڳʼ  */
    am_aml166_boot_single_inst_init();

    firmware_handle = am_aml166_boot_single_firmware_flash_inst_init();

    uart_handle = am_zlg116_uart1_inst_init();
    am_debug_init(uart_handle, 115200);

    //check_handle = am_boot_enter_check_key_init(PIOA_7, AM_GPIO_INPUT | AM_GPIO_PULLUP);

    demo_std_single_bootloader_entry(
        am_boot_firwa_recv_uart_init(firmware_handle, uart_handle),
        am_boot_enter_check_uart_init(uart_handle));
}

/* end of file */
