/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief CLK ̣ͨ HW ӿʵ
 *
 * - ʵ
 *   1. ڴӡƵʣ
 *   2. PIOA_9 ϵͳʱӣSYSCLK
 *
 * \note
 *    1. ĬϵԴ TXD Ϊ PIOA_9ʱųͻԱеĵϢ
 *       ͨ PIOA_2 ۲촮ڴӡĵϢҪ PIOA_2  PC 
 *       ڵ RXD
 * 
 * \par Դ
 * \snippet demo_aml166_core_hw_clk.c src_aml166_core_hw_clk
 * 
 * \internal
 * \par Modification History
 * - 1.00 15-7-13  sss, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_aml166_core_hw_clk
 * \copydoc demo_aml166_core_hw_clk.c
 */

/** [src_aml166_core_hw_clk] */
#include <am_aml166_inst_init.h>
#include "ametal.h"
#include "am_vdebug.h"
#include "am_zlg116.h"
#include "demo_zlg_entries.h"
#include "demo_aml166_core_entries.h"

/** \brief õԴĲ */
#define __DEBUG_BAUDRATE        115200

/**
 * \brief ʼ 2 ΪԴ
 */
am_local void __uart_init (void)
{
    am_uart_handle_t handle = NULL;

    handle = am_zlg116_uart2_inst_init();

    /* Գʼ */
    am_debug_init(handle, __DEBUG_BAUDRATE);
}

/**
 * \brief 
 */
void demo_aml166_core_hw_clk_entry (void)
{
    am_clk_id_t clk_id[] = {CLK_PLLIN,
                            CLK_PLLOUT,
                            CLK_AHB,
                            CLK_APB1,
                            CLK_APB2,
                            CLK_HSEOSC,
                            CLK_LSI,
                            CLK_HSI};

    __uart_init();

    AM_DBG_INFO("demo aml166_core hw clk!\r\n");

    am_gpio_pin_cfg(PIOA_9, PIOA_9_MCO | PIOA_9_AF_PP | PIOA_9_SPEED_50MHz);

    amhw_zlg116_rcc_mco_src_set(4);

    demo_zlg_hw_clk_entry(&clk_id[0], AM_NELEMENTS(clk_id));
}
/** [src_aml166_core_hw_clk] */

/* end of file */
