/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief UART DMA ̣ͨ HW ӿʵ
 *
 * - ʵ
 *   1.ڴӡʾַ "DMA tx transfer start:"
 *   2. Ȼ󴮿ڴӡһڴ涨ֱַΪ
 *      uart tx dma test running
 *      uart tx dma test done
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_9  PC ڵ RXD
 *    2. Դʹ뱾ͬӦںʹõϢ
 *      磺AM_DBG_INFO()
 *    3.  DMA ڼ䲻ҪԴݼĴв
 *
 * \par Դ
 * \snippet demo_aml166_core_hw_uart_tx_dma.c src_aml166_core_hw_uart_tx_dma
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 15-07-10  ari, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_aml166_core_hw_uart_tx_dma
 * \copydoc demo_aml166_core_hw_uart_tx_dma.c
 */

/** [src_aml166_core_hw_uart_tx_dma] */
#include "ametal.h"
#include "am_gpio.h"
#include "am_vdebug.h"
#include "am_zlg116.h"
#include "demo_zlg_entries.h"
#include "demo_aml166_core_entries.h"

/**
 * \brief 
 */
void demo_aml166_core_hw_uart_tx_dma_entry (void)
{
    AM_DBG_INFO("demo aml166_core hw uart tx dma!\r\n");
    am_gpio_pin_cfg(PIOA_9, PIOA_9_UART1_TX | PIOA_9_AF_PP);
    am_gpio_pin_cfg(PIOA_10, PIOA_10_UART1_RX| PIOA_10_INPUT_FLOAT);
    demo_zlg_hw_uart_tx_dma_entry(ZLG116_UART1,
                                  am_clk_rate_get(CLK_UART1),
                                  DMA_CHAN_UART1_TX);
}
/** [src_aml166_core_hw_uart_tx_dma] */

/* end of file */
