/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader ̼洢Ľӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-16  yrh, first implementation
 * \endinternal
 */

#ifndef __AM_BOOT_FIRMWARE_H
#define __AM_BOOT_FIRMWARE_H

#include "ametal.h"
/**
 * \brief bootloaderչ̼ͷ
 */
typedef struct am_boot_firmware_verify_info {
    /** \brief ̼־ */
    uint32_t flag;

    /** \brief ̼ */
    uint32_t len;

    /** \brief ̼У */
    uint32_t verify_value;

} am_boot_firmware_verify_info_t;

struct am_boot_firmware_drv_funcs {
    /**< \brief ̼洢ʼ*/
    int (*pfn_store_start)(void *p_drv);

    /**< \brief ̼洢*/
    int (*pfn_store_bytes)(void *p_drv, uint8_t *p_data, uint32_t size);

    /**< \brief ̼洢*/
    int (*pfn_store_final)(void *p_drv);

    /**< \brief ̼У*/
    int (*pfn_verify)(void *p_drv, am_boot_firmware_verify_info_t *p_verify_info);

};

/**< \brief ̼洢׼ */
typedef struct am_boot_firmware_serv {
    /**< \brief ׼ṹָ */
    struct am_boot_firmware_drv_funcs *pfn_funcs;

    /**< \brief ĵһ */
    void                              *p_drv;
} am_boot_firmware_serv_t;

/**< \brief ̼洢׼Ͷ */
typedef am_boot_firmware_serv_t *am_boot_firmware_handle_t;

/**
 * \brief ̼洢Ŀʼ
 *
 *
 * \retval AM_ENOMEM   ̼ڴС
 * \retval AM_EFAULT   ̼ŵĵַ1.ַ󣬲Ĵ洢Χ2.׵ַ
 * \retval AM_EINVAL   ĲϷ
 * \retval AM_OK       ɹ
 */
am_static_inline
int am_boot_firmware_store_start(am_boot_firmware_handle_t  handle)
{
    return handle->pfn_funcs->pfn_store_start(handle->p_drv);
}

/**
 * \brief ̼ݴ洢
 *
 * am_boot_firmware_store_bytesִҪһʱ䣬ʱע̼ʱ䣬ֹݴ䶪ʧ
 *
 * \param[in] p_data        : Ĺ̼׵ַ
 * \param[in] firmware_size : Ĺ̼
 *
 * \retval AM_EINVAL   Ч
 * \retval AM_ENOMEM   ռ䣨ڴ棩
 * \retval AM_ERROR    дʧ
 * \retval AM_OK       ɹ
 */
am_static_inline
int am_boot_firmware_store_bytes(am_boot_firmware_handle_t handle,
                                 uint8_t                  *p_data,
                                 uint32_t                  size)
{
    return handle->pfn_funcs->pfn_store_bytes(handle->p_drv, p_data, size);
}

/**
 * \brief ̼洢Ľ
 *
 * \retval AM_ERROR 
 * \retval AM_OK    ɹ
 */
am_static_inline
int am_boot_firmware_store_final(am_boot_firmware_handle_t handle)
{
    return handle->pfn_funcs->pfn_store_final(handle->p_drv);
}

/**
 * \brief ̼У
 *
 * У鴫Ĺ̼Ƿȷ
 *
 * \param[in] handle        : 
 * \param[in] p_verify_info : УϢĽṹ壬̼ȺУ
 *
 * \retval AM_ERROR 
 * \retval AM_OK    ɹ
 */
am_static_inline
int am_boot_firmware_verify(am_boot_firmware_handle_t handle, am_boot_firmware_verify_info_t *p_verify_info)
{
    return handle->pfn_funcs->pfn_verify(handle->p_drv, p_verify_info);
}


#endif /* __AM_BOOT_FIRMWARE_H */

/* end of file */
