/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief λѡGPIO
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-18  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_DIGITRON_COM_GPIO_H
#define __AM_DIGITRON_COM_GPIO_H

#include "ametal.h"
#include "am_digitron_base.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_digitron_com_gpio
 * \copydoc am_digitron_com_gpio.h
 * @{
 */

/**
 * \brief GPIOλѡ豸
 */
typedef struct am_digitron_com_gpio {
    am_digitron_base_selector_com_t    selector;
    const am_digitron_base_info_t     *p_info;
    int                                last_com;
    const int                         *p_pins;
    int                                pin_num;
} am_digitron_com_gpio_dev_t;

/**
 * \brief GPIOλѡʼ
 *
 * \param[in] p_dev  : GPIOλѡ豸ʵ
 * \param[in] p_info : ܻϢ
 * \param[in] p_pins : űĿɨ跽ʽܸ
 *                     - ɨʱȣ
 *                     - ɨʱȡ
 *
 * \return ׼λѡɹɨʹã
 */
am_digitron_base_selector_com_t *am_digitron_com_gpio_init (
        am_digitron_com_gpio_dev_t        *p_dev,
        const am_digitron_base_info_t     *p_info,
        const int                         *p_pins);

/* @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_DIGITRON_COM_GPIO_H */

/* end of file */
