/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief FM175XXĴ
 *
 * \internal
 * \par Modification history
 * - 1.00 15-12-21  sky, first implementation.
 * - 1.01 17-10-31  sdq, make somd changes.
 * \endinternal
 */
 
#ifndef __FM175XX_REG_H
#define __FM175XX_REG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_fm175xx.h"
/** 
 * \addtogroup am_if_fm175xx_reg
 * \copydoc am_fm175xx_reg.h
 * @{
 */

/**
 * \name FM175XX_REG FM175XXĴ
 * @{
 */
#define AM_FM175XX_COMMAND_REG           0x01   /**< \brief ִֹͣ */
#define AM_FM175XX_COMIEN_REG            0x02   /**< \brief жʹֹλ */
#define AM_FM175XX_DIVIEN_REG            0x03   /**< \brief жʹֹλ */
#define AM_FM175XX_COMIRQ_REG            0x04   /**< \brief жλ */
#define AM_FM175XX_DIVIRQ_REG            0x05   /**< \brief жλ */
#define AM_FM175XX_ERROR_REG             0x06   /**< \brief ʾһִָĴ״̬ */
#define AM_FM175XX_STATUS1_REG           0x07   /**< \brief ͨѶ״̬λ */
#define AM_FM175XX_STATUS2_REG           0x08   /**< \brief ջͷĿ״̬λ */
#define AM_FM175XX_FIFODATA_REG          0x09   /**< \brief 64λfifo */
#define AM_FM175XX_FIFOLEVEL_REG         0x0a   /**< \brief fifoЧ */
#define AM_FM175XX_WATERLEVEL_REG        0x0b   /**< \brief fifo羯ļ */
#define AM_FM175XX_CONTROL_REG           0x0c   /**< \brief ƼĴ */
#define AM_FM175XX_BITFRAMING_REG        0x0d   /**< \brief λ֡ʽ */
#define AM_FM175XX_COLL_REG              0x0e   /**< \brief RFӿڼ⵽һͻλλ */
#define AM_FM175XX_EX_REG                0x0f   /**< \brief չĴ */
#define AM_FM175XX_MODE_REG              0x11   /**< \brief շģʽ */
#define AM_FM175XX_TXMODE_REG            0x12   /**< \brief ʺ֡ʽ*/
#define AM_FM175XX_RXMODE_REG            0x13   /**< \brief ʺ֡ʽ */
#define AM_FM175XX_TXCONTROL_REG         0x14   /**< \brief TX1TX2 */
#define AM_FM175XX_TXASK_REG             0x15   /**< \brief  */
#define AM_FM175XX_TXSEL_REG             0x16   /**< \brief źԴѡ */
#define AM_FM175XX_RXSEL_REG             0x17   /**< \brief ڲ */
#define AM_FM175XX_RXTHRESHOLD_REG       0x18   /**< \brief ֵѡ */
#define AM_FM175XX_DEMOD_REG             0x19   /**< \brief  */
#define AM_FM175XX_TX_REG                0x1c   /**< \brief ƲISO/IEC 14443 */
#define AM_FM175XX_RX_REG                0x1d   /**< \brief ƲISO/IEC 14443ղ */
#define AM_FM175XX_TYPEB_REG             0x1e   /**< \brief ISO/IEC 14443B ƣFM17510üĴδʹã */
#define AM_FM175XX_SERIALSPEED_REG       0x1f   /**< \brief ѡUARTӿٶȣFM17510üĴδʹã */
#define AM_FM175XX_CRCMSB_REG            0x21   /**< \brief CRC߶ */
#define AM_FM175XX_CRCLSB_REG            0x22   /**< \brief CRCͶ */
#define AM_FM175XX_MODWIDTH_REG          0x24   /**< \brief ƿȿ */
#define AM_FM175XX_RFCFG_REG             0x26   /**< \brief ýRFƽ */
#define AM_FM175XX_GSN_REG               0x27   /**< \brief ѡTX1TX2ĵ絼 */
#define AM_FM175XX_CWGSP_REG             0x28   /**< \brief ѡTX1TX2ĵ絼 */
#define AM_FM175XX_MODGSP_REG            0x29   /**< \brief ѡTX1TX2ĵ絼 */
#define AM_FM175XX_TMODE_REG             0x2a   /**< \brief ڲʱģʽ */
#define AM_FM175XX_TPRESCALER_REG        0x2b   /**< \brief ڲʱԤ */
#define AM_FM175XX_TRELOADMSB_REG        0x2c   /**< \brief ڲʱ16λֵλ */
#define AM_FM175XX_TRELOADLSB_REG        0x2d   /**< \brief ڲʱ16λֵλ */
#define AM_FM175XX_TCOUNTERVALMSB_REG    0x2e   /**< \brief ڲʱ16λֵλ */
#define AM_FM175XX_TCOUNTERVALLSB_REG    0x2f   /**< \brief ڲʱ16λֵλ */
#define AM_FM175XX_TESTSEL1_REG          0x31   /**< \brief ź */
#define AM_FM175XX_TESTSEL2_REG          0x32   /**< \brief źüPRBS */
#define AM_FM175XX_TESTPINEN_REG         0x33   /**< \brief D1-D7ʹܣFM17510üĴδʹã */
#define AM_FM175XX_TESTPINVALUE_REG      0x34   /**< \brief I/Oʱ,D1-D7ŵֵFM17510üĴδʹã */
#define AM_FM175XX_TESTBUS_REG           0x35   /**< \brief ʾڲߵ״̬ */
#define AM_FM175XX_TESTCTRL_REG          0x36   /**< \brief Կ */
#define AM_FM175XX_VERSION_REG           0x37   /**< \brief оƬ汾*/
#define AM_FM175XX_ANALOGTEST_REG        0x38   /**< \brief AUX1AUX2 */
#define AM_FM175XX_TESTDAC1_REG          0x39   /**< \brief ΪTestDAC1ֵ */
#define AM_FM175XX_TESTDAC2_REG          0x3a   /**< \brief ΪTestDAC2ֵFM17510üĴδʹã */
#define AM_FM175XX_TESTADC_REG           0x3b   /**< \brief ʾADC IQʵֵ */

/** @} */


/**
 * \name FM175XX_REG FM175XXչĴ
 * @{
 */
#define AM_FM175XX_LPCD_CTRL1            0x01
#define AM_FM175XX_LCPD_CTRL2            0X02
#define AM_FM175XX_LPCD_CTRL3            0x03
#define AM_FM175XX_LPCD_CTRL4            0x04
#define AM_FM175XX_LPCD_BIAS_CURRENT     0x05
#define AM_FM175XX_LPCD_ACD_REFERECE     0x06
#define AM_FM175XX_LPCD_SLEEP_CFG        0x07
#define AM_FM175XX_LPCD_READY_CFG        0x08
#define AM_FM175XX_LPCD_DETECT_CFG       0x09
#define AM_FM175XX_LPCD_VMIDBD_CFG       0x0A
#define AM_FM175XX_LPCD_AUTO_WUP_CFG     0x0B
#define AM_FM175XX_LPCD_ADC_RESULT_L     0x0C
#define AM_FM175XX_LPCD_ADC_RESULT_H     0x0D
#define AM_FM175XX_LPCD_THRESHOLD_MIN_L  0x0E
#define AM_FM175XX_LPCD_THRESHOLD_MIN_H  0x0F
#define AM_FM175XX_LPCD_THRESHOLD_MAX_L  0X10
#define AM_FM175XX_LPCD_THRESHOLD_MAX_H  0x11
#define AM_FM175XX_LPCD_IRQ              0x12
#define AM_FM175XX_LPCD_RFT1             0x13
#define AM_FM175XX_LPCD_RFT2             0x14
#define AM_FM175XX_LPCD_RFT3             0x15
#define AM_FM175XX_LPCD_RFT4             0x16
#define AM_FM175XX_LPCD_RFT5             0x1B
#define AM_FM175XX_LPCD_MISC             0x1C


/** @} */


/**
 * \name CommandĴ (0x01)
 * @{
 */

#define AM_FM175XX_COMMAND_RCV_OFF         0x20        /**< \brief Ƶģر */
#define AM_FM175XX_COMMAND_POWER_DOWN      0x10        /**< \brief ģʽ */
#define AM_FM175XX_COMMAND_MASK            0x0F        /**< \brief ָĴ */

/** @} */


/**
 * \name CommIENжʹֹƼĴ (0x02)
 * @{
 */

#define AM_FM175XX_COMMIEN_IRQ_INV         0x80    /**< \brief IRQźȡ ȱʡΪ1 */
#define AM_FM175XX_COMMIEN_TX_IEN          0x40    /**< \brief TXIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_RX_IEN          0x20    /**< \brief RXIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_IDLE_IEN        0x10    /**< \brief IDLEIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_HIALERT_IEN     0x08    /**< \brief HIALERTIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_LOALERT_IEN     0x04    /**< \brief HIALERTIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_ERR_IEN         0x02    /**< \brief ERRIRQж󴫵ݵIRQ */
#define AM_FM175XX_COMMIEN_TIMER_IEN       0x01    /**< \brief TIMERIRQʱж󴫵ݵIRQ */

/** @} */


/**
 * \name DivIENжʹֹƼĴ (0x03)
 * @{
 */
 
#define AM_FM175XX_DIVIEN_IRQ_PUSHPULL     0x80    /**< \brief IRQŹģʽ 1CMOS 0© */
#define AM_FM175XX_DIVIEN_TINACT_IEN       0x10    /**< \brief TINж󴫵ݵIRQFM17510֧֣ */
#define AM_FM175XX_DIVIEN_CRC_IEN          0x04    /**< \brief CRCж󴫵ݵIRQ */

/** @} */


/**
 * \name CommIRqжϿĴ (0x04)
 * @{
 */
 
#define AM_FM175XX_COMMIRQ_SET1            0x80    /**< \brief COMMIRQжϱ д00Ĵб */
#define AM_FM175XX_COMMIRQ_TX_IRQ          0x40    /**< \brief ݵһλ1 */
#define AM_FM175XX_COMMIRQ_RX_IRQ          0x20    /**< \brief յĩβʱ1 */
#define AM_FM175XX_COMMIRQ_IDLE_IRQ        0x10    /**< \brief ִеδָ֪ʱ1 */
#define AM_FM175XX_COMMIRQ_HIALERT_IRQ     0x08    /**< \brief STATUS1ĴHIALERT1ʱ1 */
#define AM_FM175XX_COMMIRQ_LOALERT_IRQ     0x04    /**< \brief STATUS1ĴLOALERT1ʱ1 */
#define AM_FM175XX_COMMIRQ_ERR_IRQ         0x02    /**< \brief ERRĴκerrλʱ1 */
#define AM_FM175XX_COMMIRQ_TIMER_IRQ       0x01    /**< \brief TimerValue0ʱ1 */

/** @} */


/**
 * \name DivIRqжϿĴ (0x05)
 * @{
 */
 
#define AM_FM175XX_DIVIRQ_SET2             0x80    /**< \brief DIVIRQжϱ д10Ĵб */
#define AM_FM175XX_DIVIRQ_TINACT_IRQ       0x10    /**< \brief TINʱ 1FM17510֧֣ */
#define AM_FM175XX_DIVIRQ_CRC_IRQ          0x04    /**< \brief CRCָݴɺ1 */

/** @} */


/**
 * \name ErrorĴ (0x06)
 * @{
 */
 
#define AM_FM175XX_ERROR_WR_ERR            0x80    /**< \brief ݱдfifoʱλ */
#define AM_FM175XX_ERROR_TEMP_ERR          0x40    /**< \brief ڲ¶ȴʱ1 */
#define AM_FM175XX_ERROR_BUFFER_ERR        0x10    /**< \brief fifoʱͼдfifo1 */
#define AM_FM175XX_ERROR_COLL_ERR          0x08    /**< \brief ⵽ͻ1(AЭ106kbitʱЧ),ʱԶ */
#define AM_FM175XX_ERROR_CRC_ERR           0x04    /**< \brief RxModeĴRxCRCEN1CRCʧʱ1,ʱԶ */
#define AM_FM175XX_ERROR_PARITY_ERR        0x02    /**< \brief żУʧʱ1(AЭ106kbitʱЧ),ʱԶ */
#define AM_FM175XX_ERROR_PROTOCOL_ERR      0x01    /**< \brief SOFAuthentֽȷʱ1 */

/** @} */


/**
 * \name Status1״̬Ĵ1 (0x07)
 * @{
 */
 
#define AM_FM175XX_STATUS1_CRC_OK          0x40    /**< \brief CRCΪ0 */
#define AM_FM175XX_STATUS1_CRC_READY       0x20    /**< \brief CRC */
#define AM_FM175XX_STATUS1_IRQ             0x10    /**< \brief ж */
#define AM_FM175XX_STATUS1_TRUNING         0x08    /**< \brief ʱ */
#define AM_FM175XX_STATUS1_HIALERT         0x02    /**< \brief fifoеHIALERT ֽСWaterLevel */
#define AM_FM175XX_STATUS1_LOALERT         0x01    /**< \brief fifoеLOALERT ֽСWaterLevel */

/** @} */


/**
 * \name Status2״̬Ĵ2 (0x08)
 * @{
 */
 
#define AM_FM175XX_STATUS2_TEMP_SENS_CLEAR     0x80    /**< \brief ¶125澯ʱ,øλ¶ȴ */
#define AM_FM175XX_STATUS2_I2C_FORCE_HS        0x40    /**< \brief I2C˲.1Ϊģʽ,0ӦõI2CЭ. */
#define AM_FM175XX_STATUS2_CRYPTO1_ON          0x08    /**< \brief M1 Crypto1Ԫ.M1Ч,ڳɹִAuthentָ1, */
#define AM_FM175XX_STATUS2_MODEM_STATE_MASK    0x07    /**< \brief ״̬״̬ */
#define AM_FM175XX_STATUS2_MODEM_STATE_IDLE    0x00    /**< \brief ״̬ */
#define AM_FM175XX_STATUS2_MODEM_STATE_SS      0x01    /**< \brief ״̬ȴStartSendЧ */
#define AM_FM175XX_STATUS2_MODEM_STATE_TW      0x02    /**< \brief ״̬TxWait,ֱRF */
#define AM_FM175XX_STATUS2_MODEM_STATE_SEND    0x03    /**< \brief ״̬ */
#define AM_FM175XX_STATUS2_MODEM_STATE_RW      0x04    /**< \brief ״̬RxWait,ֱRF */
#define AM_FM175XX_STATUS2_MODEM_STATE_DW      0x05    /**< \brief ״̬DataWait */
#define AM_FM175XX_STATUS2_MODEM_STATE_RECV    0x06    /**< \brief ״̬ */

/** @} */


/**
 * \name FIFOLevelĴ (0x0a)
 * @{
 */
 
#define AM_FM175XX_FIFOLEVEL_FLUSH_BUFFER      0x80    /**< \brief 1ڲfifoĶдָERRĴеBufferOvflλ,Ϊ0 */
#define AM_FM175XX_FIFOLEVEL_MASK              0x7f    /**< \brief fifoеֽ,д+1,ȡ-1 */

/** @} */


/**
 * \name WaterLevelĴ (0x0b)
 * @{
 */
 
#define AM_FM175XX_WATERLEVEL_MASK         0x3F    /**< \brief fifoˮ,ֽ */

/** @} */


/**
 * \name ControlƼĴ (0x0c)
 * @{
 */
 
#define AM_FM175XX_CONTROL_TSTOPNOW        0x80    /**< \brief ʱֹͣ */
#define AM_FM175XX_CONTROL_TSTARTNOW       0x40    /**< \brief ʱ */
#define AM_FM175XX_CONTROL_RX_LAST_BITS    0x07    /**< \brief ֽڵЧλ,Ϊ0ȫЧ */

/** @} */


/**
 * \name BitFramingĴ,λ֡ʽ (0x0d)
 * @{
 */
 
#define AM_FM175XX_BITFRAMING_STARTSEND    0x80    /**< \brief ݷ俪ʼ,λֻTransceiverִʱЧ */
#define AM_FM175XX_BITFRAMING_RXALIGN_0    0x00    /**< \brief λڵ0λ,λ˳ */
#define AM_FM175XX_BITFRAMING_RXALIGN_1    0x10    /**< \brief λڵ1λ,λ˳ */
#define AM_FM175XX_BITFRAMING_RXALIGN_7    0x70    /**< \brief λڵ7λ,λ˳ */
#define AM_FM175XX_BITFRAMING_TXLASTBITS   0x07    /**< \brief ֽڵ跢͵λ,Ϊ0ȫҪ */

/** @} */


/**
 * \name CollIRqĴ,RFӿڼ⵽ĵһͻλ (0x0e)
 * @{
 */

/** \brief 0ͻλ֮нλ(106kbitЧ,1) */
#define AM_FM175XX_COLLIRQ_VALUES_AFTERCOLL    0x80

/** \brief û⵽ͻͻCollPosΧʱ1(λֻ14443Aдģʽ±) */
#define AM_FM175XX_COLLIRQ_COLLPOS_NOTVALID    0x20

/** \brief һͻλλ,00ʾ32λ,01ʾ1λ(λֻ14443Aдģʽ,COLLPOS_NOTVALIDΪ0ʱ) */
#define AM_FM175XX_COLLIRQ_COLLPOS             0x1f

/** @} */


/**
 * \name EXչĴ (0x0f)
 * @{
 */

#define AM_FM175XX_EX_MODE                 0xc0    /**< \brief չĴģʽ */
#define AM_FM175XX_EX_MODE_W_ADDR          0x40    /**< \brief չĴдַ */
#define AM_FM175XX_EX_MODE_R_ADDR          0x80    /**< \brief չĴַ */
#define AM_FM175XX_EX_MODE_W_DATA          0xc0    /**< \brief չĴдչ */
#define AM_FM175XX_EX_MODE_R_DATA          0x00    /**< \brief չĴչ */
#define AM_FM175XX_EX_MODE_ADDR_DATA       0x3f    /**< \brief ַ */

/** @} */

/**
 * \name ModeĴ,巢ͽģʽ (0x11)
 * @{
 */

#define AM_FM175XX_MODE_MSB_FIRST          0x80    /**< \brief CRCЭMSBλȼCRC,CRCResultĴжMSBLSBҲλת */
#define AM_FM175XX_MODE_TXWAIT_RF          0x20    /**< \brief дģʽʱֻRF· */
#define AM_FM175XX_MODE_POLTIN             0x08    /**< \brief TINŵļ,1ߵƽЧ,0͵ƽЧFM17510֧֣ */
#define AM_FM175XX_MODE_CRC_PRESET_MASK    0x03    /**< \brief CRCУԤֵ */
#define AM_FM175XX_MODE_CRC_PRESET_0000    0x00    /**< \brief CRCУԤֵ0000 */
#define AM_FM175XX_MODE_CRC_PRESET_6363    0x01    /**< \brief CRCУԤֵ6363 */
#define AM_FM175XX_MODE_CRC_PRESET_a671    0x02    /**< \brief CRCУԤֵa671 */
#define AM_FM175XX_MODE_CRC_PRESET_ffff    0x03    /**< \brief CRCУԤֵffff */

/** @} */


/**
 * \name TxModeĴ,巢ʺ֡ʽ (0x12)
 * @{
 */
 
#define AM_FM175XX_TXMODE_TXCRC_EN         0x80    /**< \brief 1ݷʱʹCRCУ(106kbit0) */
#define AM_FM175XX_TXMODE_TXSPEED_MASK     0x70    /**< \brief  */
#define AM_FM175XX_TXMODE_TXSPEED_106KBIT  0x00    /**< \brief 106kbit */
#define AM_FM175XX_TXMODE_TXSPEED_212KBIT  0x10    /**< \brief 212kbit */
#define AM_FM175XX_TXMODE_TXSPEED_424KBIT  0x20    /**< \brief 424kbit */
#define AM_FM175XX_TXMODE_TXSPEED_848KBIT  0x30    /**< \brief 848kbit */
#define AM_FM175XX_TXMODE_INV_MOD          0x08    /**< \brief 1,ݵĵƷ */

/** @} */


/**
 * \name RxModeĴ,ʺ֡ʽ (0x13)
 * @{
 */
 
#define AM_FM175XX_RXMODE_RXCRC_EN         0x80    /**< \brief 1ݽʱʹCRCУ(106kbit0) */
#define AM_FM175XX_RXMODE_RXSPEED_MASK     0x70    /**< \brief  */
#define AM_FM175XX_RXMODE_RXSPEED_106KBIT  0x00    /**< \brief 106kbit */
#define AM_FM175XX_RXMODE_RXSPEED_212KBIT  0x10    /**< \brief 212kbit */
#define AM_FM175XX_RXMODE_RXSPEED_424KBIT  0x20    /**< \brief 424kbit */
#define AM_FM175XX_RXMODE_RXSPEED_848KBIT  0x30    /**< \brief 848kbit */
#define AM_FM175XX_RXMODE_RXNOERR          0x08    /**< \brief 1,Ч,ּ.14443B,RxSOFReqΪ1 */
#define AM_FM175XX_RXMODE_RXMULTIPLE       0x04    /**< \brief 0,յһ֮֡ٽ.1,ն֡ */

/** @} */


/**
 * \name TxControlĴ,Tx1Tx2 (0x14)
 *
 * \note FM17510ûTX2صĶ
 * @{
 */
#define AM_FM175XX_TXCONTROL_INV_TX2RF_ON  0x80    /**< \brief 1,TX2ʹ,TX2źȡ */
#define AM_FM175XX_TXCONTROL_INV_TX1RF_ON  0x40    /**< \brief 1,TX1ʹ,TX2źȡ */
#define AM_FM175XX_TXCONTROL_INV_TX2RF_OFF 0x20    /**< \brief 1,TX2ر,TX2źȡ */
#define AM_FM175XX_TXCONTROL_INV_TX1RF_OFF 0x10    /**< \brief 1,TX1ر,TX2źȡ */
#define AM_FM175XX_TXCONTROL_TX2_CW        0x08    /**< \brief 1,TX2δƵ13.56MHzز;0, */
#define AM_FM175XX_TXCONTROL_TX2RF_EN      0x02    /**< \brief 1,TX2ɷݵƵ13.56MHzز */
#define AM_FM175XX_TXCONTROL_TX1RF_EN      0x01    /**< \brief 1,TX1ɷݵƵ13.56MHzز */

/** @} */


/**
 * \name TxASKĴ, (0x15)
 * @{
 */

#define AM_FM175XX_TXASK_FORCE_100ASK      0x40    /**< \brief 1,Force100ASKǿһ100%ASK */

/** @} */


/**
 * \name TxSelĴ,źԴѡ (0x16)
 * @{
 */
 
#define AM_FM175XX_TXSEL_DRIVER_SEL_MASK       0x30    /**< \brief Tx1Tx2 */
#define AM_FM175XX_TXSEL_DRIVER_SEL_TRISTATE   0x00    /**< \brief Tx1Tx2ѡ̬ */
#define AM_FM175XX_TXSEL_DRIVER_SEL_IN         0x10    /**< \brief Tx1Tx2ѡڲĵź */
#define AM_FM175XX_TXSEL_DRIVER_SEL_TIN        0x20    /**< \brief Tx1Tx2ѡTINĵź */
#define AM_FM175XX_TXSEL_DRIVER_SEL_HIGH       0x30    /**< \brief Tx1Tx2ѡߵƽ */
#define AM_FM175XX_TXSEL_TOUT_SEL_MASK         0x0f    /**< \brief Tx1Tx2ѡߵƽ */

/**
 * \name TOUTŵѡFM17510֧֣
 * @{
 */
#define AM_FM175XX_TXSEL_TOUT_SEL_TRISTATE     0x00    /**< \brief TOUTŵѡ̬ */
#define AM_FM175XX_TXSEL_TOUT_SEL_LOW          0x01    /**< \brief TOUTŵѡ͵ƽ */
#define AM_FM175XX_TXSEL_TOUT_SEL_HIGH         0x02    /**< \brief TOUTŵѡߵƽ */
#define AM_FM175XX_TXSEL_TOUT_SEL_Testbus      0x03    /**< \brief TOUTŵѡTestBus */
#define AM_FM175XX_TXSEL_TOUT_SEL_in           0x04    /**< \brief TOUTŵѡڲĵź */
#define AM_FM175XX_TXSEL_TOUT_SEL_rcevs        0x05    /**< \brief TOUTŵѡ͵Ĵ */
#define AM_FM175XX_TXSEL_TOUT_SEL_sends        0x07    /**< \brief TOUTŵѡյĴ(ҪM1ģʽʹ) */

/** @} */

/** @} */


/**
 * \name RxSelĴ,ڲ (0x17)
 * @{
 */
 
#define AM_FM175XX_RXSEL_UARTSEL_MASK          0xc0    /**< \brief ѡǽӴUART */
#define AM_FM175XX_RXSEL_UARTSEL_LOW           0x00    /**< \brief ǽӴUART̶͵ƽ */
#define AM_FM175XX_RXSEL_UARTSEL_TIN           0x40    /**< \brief TINİźţFM17510֧֣ */
#define AM_FM175XX_RXSEL_UARTSEL_IN            0x80    /**< \brief ڲģ·ĵź */
#define AM_FM175XX_RXSEL_UARTSEL_TIN_M         0xc0    /**< \brief TINĵźţٶȸ424kbitʱЧFM17510֧֣ */
#define AM_FM175XX_RXSEL_RXWAIT                0x3f    /**< \brief ɷ,Rxwaitʱӳٺ󱻼 */

/** @} */


/**
 * \name RxThresholdĴ,ֵѡ (0x18)
 * @{
 */

/** \brief ܽյСźǿ(ˮƽ) */
#define AM_FM175XX_RXTHRESHOLD_MINLEVEL   0xf0

/** \brief 뵽˹رbitǿbitͻλСźǿ */
#define AM_FM175XX_RXTHRESHOLD_COLLLEVEL  0x07    

/** @} */


/**
 * \name DemodĴ, (0x19)
 * @{
 */
 
#define AM_FM175XX_DEMOD_ADDIQ_MASK        0xc0    /**< \brief չIQͨʹ */
#define AM_FM175XX_DEMOD_ADDIQ_S           0x00    /**< \brief ѡǿͨ */
#define AM_FM175XX_DEMOD_ADDIQ_KEEP_S      0x40    /**< \brief ѡǿͨ,ͨѶбֲ */
#define AM_FM175XX_DEMOD_ADDIQ_IQ          0x80    /**< \brief ϲIQͨ */
#define AM_FM175XX_DEMOD_FIXIQ             0x20    /**< \brief 1ʱADDIQΪX0չ̶Iͨ,ΪX1չ̶Qͨ  */
#define AM_FM175XX_DEMOD_TYPEB_EOF_MODE    0x10    /**< \brief 0:߼0+1+޸ز 1:߼0+޸زƣFM17510֧֣ */
#define AM_FM175XX_DEMOD_TAU_RCV           0x0c    /**< \brief ݽչиıڲʱ䳣(ע:Ϊ00,PLLݽж) */
#define AM_FM175XX_DEMOD_TAU_SYNC          0x03    /**< \brief burstиıڲPLLʱ䳣 */

/** @} */


/**
 * \name TxĴ,ƲISO/IEC 14443A (0x1c)
 * @{
 */
 
#define AM_FM175XX_TX_WAIT         0x03    /**< \brief λ˸Ӧʱ.ȱʡֵΪλֵ7bit */

/** @} */


/**
 * \name RxĴ (0x1d)
 * @{
 */
 
#define AM_FM175XX_RX_PARITY_DIS   0x10    /**< \brief λ1,շżУ鶼ر,УλΪͨλ */

/** @} */


/**
 * \name TypeBĴ,ISO/IEC 14443B (0x1e)FM17510֧֣
 * @{
 */

#define AM_FM175XX_TYPEB_RXSOF_REQ         0x80    /**< \brief λ1,SOFʼᱻ */
#define AM_FM175XX_TYPEB_RXEOF_REQ         0x40    /**< \brief λ1,EOFᴥЭ */
#define AM_FM175XX_TYPEB_EOFSOF_WIDTH      0x10    /**< \brief 1,SOFEOFISO/IEC 14443Bж󳤶;0,С */
#define AM_FM175XX_TYPEB_NO_TXSOF          0x08    /**< \brief 1,SOF */
#define AM_FM175XX_TYPEB_NO_TXEOF          0x04    /**< \brief 1,EOF */
#define AM_FM175XX_TYPEB_TX_EGT            0x03    /**< \brief EGT,Ϊ0,1,23 */

/** @} */


/**
 * \name SerialSpeedĴ,ѡUARTӿڵٶȣFM17510֧֣ (0x1f)
 * @{
 */

#define AM_FM175XX_SERIALSPEED_BR_T0       0xe0    /**< \brief BR_T0ڵڴٶ */
#define AM_FM175XX_SERIALSPEED_BR_T1       0x0f    /**< \brief BR_T1ڵڴٶ */

/** @} */


/**
 * \name RFCfgĴ,ý (0x26)
 * @{
 */
 
#define AM_FM175XX_RFCFG_RXGAIN_MASK       0x70    /**< \brief ѹָ */
#define AM_FM175XX_RFCFG_RXGAIN_18DB       0x00    /**< \brief ѹָ18dB */
#define AM_FM175XX_RFCFG_RXGAIN_23DB       0x10    /**< \brief ѹָ23dB */
#define AM_FM175XX_RFCFG_RXGAIN_18DB_TOO   0x20    /**< \brief ѹָ18dB */
#define AM_FM175XX_RFCFG_RXGAIN_23DB_TOO   0x30    /**< \brief ѹָ23dB */
#define AM_FM175XX_RFCFG_RXGAIN_33DB       0x40    /**< \brief ѹָ33dB */
#define AM_FM175XX_RFCFG_RXGAIN_38DB       0x50    /**< \brief ѹָ38dB */
#define AM_FM175XX_RFCFG_RXGAIN_43DB       0x60    /**< \brief ѹָ43dB */
#define AM_FM175XX_RFCFG_RXGAIN_48DB       0x70    /**< \brief ѹָ48dB */

/** @} */


/**
 * \name GsNĴ,ʱ,ѡTX1TX2Nĵ絼 (0x27)
 * @{
 */

/**
 * \brief ޵ʱNĵ絼,,:
 *        1.絼ֵλƼȨ
 *        2.soft Power-downģʽλǿλ 
 *        3.üĴֵֻTX1,TX2ʱʹ
 */
#define AM_FM175XX_CWGSN                   0xf0

/**
 * \brief ʱNĵ絼,ɿƵ:
 *        1.絼ֵλƼȨ
 *        2.soft Power-downģʽλǿλ 
 *        3.üĴֵֻTX1,TX2ʱʹ
 */
#define AM_FM175XX_MODGSN                  0x0f

/** @} */


/**
 * \name CWGsPĴ,޵ʱPĵ絼 (0x28)
 * @{
 */

/**
 * \brief ޵ʱPĵ絼,,ļ:
 *        1.絼ֵλƼȨ
 *        2.soft Power-downģʽλǿλ 
 */
#define AM_FM175XX_CWGSP                   0x3f

/** @} */


/**
 * \name ModGsPĴ (0x29)
 * @{
 */

/**
 * \brief ʱPĵ絼,,ļ:
 *        1.絼ֵλƼȨ
 *        2.soft Power-downģʽλǿλ 
 */
#define AM_FM175XX_MODGSP                  0x3f

/** @} */


/**
 * \name TModeĴ,TPrescalerĴ,˶ʱ (0x2A)
 * @{
 */
 
#define AM_FM175XX_T_AUTO                  0x80    /**< \brief 0ʱЭӰ 1ʱԶ */
#define AM_FM175XX_T_GATE_MASK             0x60    /**< \brief ʱſ */
#define AM_FM175XX_T_GATE_NONE             0x00    /**< \brief ʱſ */
#define AM_FM175XX_T_GATE_TIN              0x20    /**< \brief ʱTINſ */
#define AM_FM175XX_T_GATE_AUX1             0x40    /**< \brief ʱAUX1ſ */
#define AM_FM175XX_T_AUTO_RESTART          0x10    /**< \brief 1ʱװֵԶ,00ʱֹͣ */

/**
 * \brief TPrescalerĸλ
 *        ʱƵ f=13.56Mhz/(2*TPrescaler+1)
 *        TPrescaler=[TPrescaler_HI:TPrescaler_Lo]
 */
#define AM_FM175XX_T_PRESCALER_HI          0x0f    /**< \brief TPrescalerĸλ */

/** @} */


/**
 * \name TestSel1Ĵ,ź (0x31)
 * @{
 */
 
#define AM_FM175XX_TSTBUS_BITSEL           0x07    /**< \brief ӲѡλTOUT */

/** @} */


/**
 * \name TestSel2Ĵ,źúPRBS (0x32)
 * @{
 */
 
#define AM_FM175XX_TSTBUS_FLIP             0x80    /**< \brief 1 ߰D432651˳ӳ䵽ж˿ */
#define AM_FM175XX_PRBS9                   0x40    /**< \brief ITU-TO150ʹPRBS9 */
#define AM_FM175XX_PRBS15                  0x20    /**< \brief ITU-TO150ʹPRBS15 */
#define AM_FM175XX_TSTBUS_SEL              0x1f    /**< \brief ѡ */

/** @} */


/**
 * \name TestPinEnĴ,D1~D6ʹ FM17510֧֣(0x33)
 * @{
 */
#define AM_FM175XX_RS232LINE_EN            0x80    /**< \brief 0 UARTMXDTRQЧ */

/**
 * \brief ʹD1~D6
 *        bit11,ʹD1;bit51,ʹD5
 *        ֻʹܴнӿʱЧ.SPI=>D1~D4 UARTRS232LineEn1ʱ=>D1~D4
 */
#define AM_FM175XX_TESTPIN_EN              0x7e

/** @} */


/**
 * \name TestPinValueĴ,I/Oʱ,7λж˿ڵֵFM17510֧֣ (0x34)
 * @{
 */
 
#define AM_FM175XX_U_SEL_O                 0x80    /**< \brief 1 ͨλ7ж˿ڵI/O */

/**
 * \brief I/Oʱ,7λж˿ڵֵ.ÿ˿ڶɼĴTestPinEnĴ
 *        еTestPinEnλʹ.
 *        ע:UselO1,ĴʾD6~D1ʵ״̬
 *           UselO0,ĴõTestPinValueĴֵ
 */
#define AM_FM175XX_TEST_PIN_VALUE          0x7e

/** @} */


/**
 * \name TestCtrlĴ,Կ (0x36)
 * @{
 */
 
/** \brief 1 ڲźŴԵִ,106kbitͨѶģʽµĲ */
#define AM_FM175XX_AMP_RCV                 0x40

/** @} */


/**
 * \name AnalogTestĴ,AUX1AUX2FM17510֧AUX2 (0x38)
 * @{
 */
 
#define AM_FM175XX_ANALOG_SEL_AUX1_MASK        0xf0    /**< \brief AUX1 */
#define AM_FM175XX_ANALOG_SEL_AUX1_TRISTATE    0x00    /**< \brief AUX1̬ */
#define AM_FM175XX_ANALOG_SEL_AUX1_DAC1        0x10    /**< \brief TestDAC1(AUX1) */
#define AM_FM175XX_ANALOG_SEL_AUX1_CORR1       0x20    /**< \brief źCorr1 */
#define AM_FM175XX_ANALOG_SEL_AUX1_CORR2       0x30    /**< \brief źCorr2 */
#define AM_FM175XX_ANALOG_SEL_AUX1_MINLEVEL    0x40    /**< \brief źMINLEVEL */
#define AM_FM175XX_ANALOG_SEL_AUX1_ADC_I       0x50    /**< \brief źADCͨI */
#define AM_FM175XX_ANALOG_SEL_AUX1_ADC_Q       0x60    /**< \brief źADCͨQ */
#define AM_FM175XX_ANALOG_SEL_AUX1_ADC_IQ      0x70    /**< \brief źADCͨIQϲ */
#define AM_FM175XX_ANALOG_SEL_AUX1_HIGH        0xa0    /**< \brief HIGH */
#define AM_FM175XX_ANALOG_SEL_AUX1_LOW         0xb0    /**< \brief LOW */
#define AM_FM175XX_ANALOG_SEL_AUX1_T           0xc0    /**< \brief Ч״̬ */
#define AM_FM175XX_ANALOG_SEL_AUX1_R           0xd0    /**< \brief Ч״̬ */
#define AM_FM175XX_ANALOG_SEL_AUX1_SC          0xe0    /**< \brief ⵽ز */
#define AM_FM175XX_ANALOG_SEL_AUX1_TESTBUS_BIT 0xf0    /**< \brief TestSel1ĴTstBusBitSelλ */

#define AM_FM175XX_ANALOG_SEL_AUX2_MASK        0x0f    /**< \brief AUX2 */
#define AM_FM175XX_ANALOG_SEL_AUX2_TRISTATE    0x00    /**< \brief AUX1̬ */
#define AM_FM175XX_ANALOG_SEL_AUX2_DAC1        0x01    /**< \brief TestDAC2(AUX2) */
#define AM_FM175XX_ANALOG_SEL_AUX2_CORR1       0x02    /**< \brief źCorr1 */
#define AM_FM175XX_ANALOG_SEL_AUX2_CORR2       0x03    /**< \brief źCorr2 */
#define AM_FM175XX_ANALOG_SEL_AUX2_MINLEVEL    0x04    /**< \brief źMINLEVEL */
#define AM_FM175XX_ANALOG_SEL_AUX2_ADC_I       0x05    /**< \brief źADCͨI */
#define AM_FM175XX_ANALOG_SEL_AUX2_ADC_Q       0x06    /**< \brief źADCͨQ */
#define AM_FM175XX_ANALOG_SEL_AUX2_ADC_IQ      0x07    /**< \brief źADCͨIQϲ */
#define AM_FM175XX_ANALOG_SEL_AUX2_HIGH        0x0a    /**< \brief HIGH */
#define AM_FM175XX_ANALOG_SEL_AUX2_LOW         0x0b    /**< \brief LOW */
#define AM_FM175XX_ANALOG_SEL_AUX2_T           0x0c    /**< \brief Ч״̬ */
#define AM_FM175XX_ANALOG_SEL_AUX2_R           0x0d    /**< \brief Ч״̬ */
#define AM_FM175XX_ANALOG_SEL_AUX2_SC          0x0e    /**< \brief ⵽ز */
#define AM_FM175XX_ANALOG_SEL_AUX2_TESTBUS_BIT 0x0f    /**< \brief TestSel1ĴTstBusBitSelλ */

/** @} */


/**
 * \name TestDAC1Ĵ,TestDAC1Ĳֵ (0x39)
 * @{
 */
 
/** \brief TestDAC1Ĳֵ.DAC1ͨüĴAnalogTestAUX10001лAUX1 */
#define AM_FM175XX_TESTDAC1        0x3f

/** @} */


/**
 * \name TestDAC2Ĵ,TestDAC2Ĳֵ (0x3a)
 * @{
 */
 
/** \brief TestDAC2Ĳֵ.DAC2ͨüĴAnalogTestAUX20001лAUX2 */
#define AM_FM175XX_TESTDAC2        0x3f

/** @} */


/**
 * \name TestADCĴ,ʾADC IQͨʵֵ (0x3b)
 * @{
 */
 
#define AM_FM175XX_ADC_I           0xf0    /**< \brief ʾADC Iͨʵֵ */
#define AM_FM175XX_ADC_Q           0x0f    /**< \brief ʾADC Qͨʵֵ */

/** @} */


/**
 * \name LpcdCtrlչĴ (0x0f/0x01)
 * @{
 */
#define AM_
#define AM_FM175XX_LPCD_EN          0x01    /**< \brief ʹ LPCDģʽ  */
#define AM_FM175XX_LPCD_RSTN        0x02    /**< \brief LPCDλ   */
#define AM_FM175XX_LPCD_CALIBRA_EN  0x04    /**< \brief LPCD ģʽʹ   */
#define AM_FM175XX_LPCD_CMP_1       0x08    /**< \brief Ƚϴ 1   */
#define AM_FM175XX_LPCD_CMP_3       0x13    /**< \brief Ƚϴ3    */
#define AM_FM175XX_LPCD_IE          0x10    /**< \brief ʹLPCDж  */
#define AM_FM175XX_CTRL_SET         0x20    /**< \brief LPCD Ĵλ   */
#define AM_FM175XX_CTRL_CLR         0x00    /**< \brief LPCD Ĵλ  */
/** @} */


/**
 * \name HpdCtrlչĴ (0x0f/0x03)
 * @{
 */

#define AM_FM175XX_EXMODE          0xc0    /**< \brief չĴģʽ,ʼ0 */

/**
 * \brief ͹ģʽ
 *        0 pin NPD=0LPCDEn=0(ȱʡ)ʱ,оƬDPDģʽ
 *        1 pin NPD=0LPCDEn=0(ȱʡ)ʱ,оƬHPDģʽ
 */
#define AM_FM175XX_HPDEN           0x20

/** @} */

/**
 * \name Lpcd IrqչĴ (0x0f/0x12)
 * @{
 */
#define AM_FM175XX_LPCD_INT_IDLE          0x00  /**< \brief ж*/
#define AM_FM175XX_LPCD_CARD_IRQ          0x01  /**< \brief ж*/
#define AM_FM175XX_LPCD_CALIB_IRQ         0x04  /**< \brief Уж */
#define AM_FM175XX_LPCD_WUP_IRQ           0x10  /**< \brief Զж */
/** @} */

/**
 * \name UseRetչĴ (0x0f/0x1b)
 * @{
 */

/**
 * \brief ͹ģʽ
 *        0 ṩؼݵı湦
 *        1 ʾHPDģʽLPCDģʽ±ؼĴ,˳ʱĳʼ
 */
#define AM_FM175XX_USERET          0x10

/** @} */

/**
 * \name LPCD MISCչĴ (0x0f/0x1c)
 * @{
 */

#define AM_FM175XX_LCPD_CALIB_VMID_EN  0x01    /**< \brief LPCD ģʽеVmindʹ*/

/** @} */


/**
 * \name LVDctrlչĴ,͵ѹ (0x0f/0x1d)
 * @{
 */

#define AM_FM175XX_LVD_IRQ         0x10    /**< \brief 1ʾ͵ѹ,д0˼Ĵ */
#define AM_FM175XX_LVD_EFF         0x08    /**< \brief ͵ѹʱ1ֵ·λ,0жϱ־ */
#define AM_FM175XX_LVD_LE          0x04    /**< \brief 1͵ѹжʹ,ȱʡʹ */
#define AM_FM175XX_LVD_CTRL_MASK   0x03    /**< \brief ѹ */
#define AM_FM175XX_LVD_CTRL_NONE   0x00    /**< \brief ʹLVD */
#define AM_FM175XX_LVD_CTRL_1_9V   0x01    /**< \brief 1.9V */
#define AM_FM175XX_LVD_CTRL_2_1V   0x02    /**< \brief 2.1V(ȱʡ) */
#define AM_FM175XX_LVD_CTRL_2_4V   0x03    /**< \brief 2.4V */

/** @} */


/**
 * @} am_if_fm175xx_reg
 */

#ifdef __cplusplus
}
#endif
 
#endif /* __FM175XX_REG_H */

/* end of file */
