/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief HC595׼豸ʵ֣GPIO
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-23  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_HC595_GPIO_H
#define __AM_HC595_GPIO_H

#include "am_common.h"
#include "am_errno.h"
#include "am_hc595.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_hc595_gpio
 * \copydoc am_hc595_gpio.h
 * @{
 */

/**
 * \brief GPIOHC595豸Ϣ
 *
 * δʹõţOE̶Ϊ͵ƽʱԽ oeŵֵΪ -1
 */
typedef struct am_hc595_gpio_info {
    int data_pin;            /**< \brief                             */
    int clk_pin;             /**< \brief λʱ                        */
    int lock_pin;            /**< \brief                         */
    int oe_pin;              /**< \brief ʹţδʹʱΪ -1 */

    /**
     * \brief HC595ݷǷλȷͣĬϸλȷͣ
     *
     *  ֵΪ AM_TRUE  λȷͣ λͳ Q7λ
     *  ֵΪ AM_FALSE  λȷͣ λͳ Q7λ
     *
     *  磺
     *  - Q0  'a'ӣ  LSB Ӧȷ
     *  - Q7  'a'ӣ  MSB Ӧȷ
     */
    am_bool_t  lsb_first;

    /** λʱ ͵ƽʱʱ  (λus) */
    uint16_t clk_low_udelay;

    /** λʱ ߵƽʱʱ  (λus) */
    uint16_t clk_high_udelay;

} am_hc595_gpio_info_t;

/**
 * \brief GPIOHC595豸
 */
typedef struct am_hc595_gpio_dev {
    am_hc595_dev_t                isa;       /**< \brief ׼HC595    */
    const am_hc595_gpio_info_t   *p_info;    /**< \brief 豸Ϣ           */
} am_hc595_gpio_dev_t;


/**
 * \brief  GPIOHC595豸ʼ
 *
 * \param[in] p_dev  : GPIO HC595豸
 * \param[in] p_info : GPIO HC595豸Ϣ
 *
 * \return hc595ΪNULLʼʧ
 */
am_hc595_handle_t am_hc595_gpio_init (am_hc595_gpio_dev_t        *p_dev,
                                      const am_hc595_gpio_info_t *p_info);

/**
 * \brief  GPIOHC595豸ʼ
 * \param[in] p_dev  : GPIO HC595豸
 * \return AM_OKʼɹֵʼʧ
 */
int am_hc595_gpio_deinit (am_hc595_gpio_dev_t *p_dev);

/** @} am_if_hc595_gpio */

#ifdef __cplusplus
}
#endif

#endif /* __AM_HC595_H */
