/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief HC595׼豸ʵ֣SPI
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-23  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_HC595_SPI_H
#define __AM_HC595_SPI_H

#include "am_common.h"
#include "am_hc595.h"
#include "am_spi.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_hc595_spi
 * \copydoc am_hc595_spi.h
 * @{
 */

/**
 * \brief SPIHC595豸Ϣ
 *
 * δʹõţOE̶Ϊ͵ƽʱԽ oeŵֵΪ -1
 */
typedef struct am_hc595_spi_info {

    int         pin_lock;     /**< \brief                         */
    int         pin_oe;       /**< \brief ʹţδʹʱΪ -1 */
    uint32_t    clk_speed;    /**< \brief SPIʱƵ                   */

    /**
     * \brief HC595ݷǷλȷͣĬϸλȷͣ
     *
     *  ֵΪ AM_TRUE  λȷͣ λͳ Q7λ
     *  ֵΪ AM_FALSE  λȷͣ λͳ Q7λ
     *
     *  磺
     *  - Q0  'a'ӣ  LSB Ӧȷ
     *  - Q7  'a'ӣ  MSB Ӧȷ
     */
    am_bool_t  lsb_first;

} am_hc595_spi_info_t;

/**
 * \brief SPIHC595豸
 */
typedef struct am_hc595_spi_dev {
    am_hc595_dev_t             isa;        /**< \brief ׼HC595 */
    am_spi_device_t            spi_dev;    /**< \brief SPI 豸        */
    const am_hc595_spi_info_t *p_info;
} am_hc595_spi_dev_t;

/**
 * \brief SPIHC595豸ʼ
 *
 * \param[in] p_dev     : GPIO HC595豸
 * \param[in] handle    : SPI׼
 * \param[in] pin_lock  : ŽΪƬѡ
 * \param[in] clk_speed : ʱƵʣ 3000000Hz
 * \param[in] lsb_first : Ƿλȷ
 *
 * \return hc595ΪNULLʼʧ
 */
am_hc595_handle_t am_hc595_spi_init (am_hc595_spi_dev_t        *p_dev,
                                     const am_hc595_spi_info_t *p_info,
                                     am_spi_handle_t            handle);

/**
 * \brief SPIHC595豸ʼ
 * \param[in] p_dev  : GPIO HC595豸
 * \return AM_OKʼɹֵʼʧ
 */
int am_hc595_spi_deinit (am_hc595_spi_dev_t *p_dev);

/** @} am_if_hc595_spi */

#ifdef __cplusplus
}
#endif

#endif /* __AM_HC595_SPI_H */
