/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief ͨ˾MB85ϵMB85RSXXоƬ 
 * 
 * ֪оƬ 
 *   - MB85RS64
 * 
 * \internal
 * \par Modification history
 * - 1.00 19-12-09  RZ, first implementation.
 * \endinternal
 */
 
#ifndef __AM_MB85RSXX_H
#define __AM_MB85RSXX_H

#ifdef __cplusplus
extern "C" {
#endif
    
#include "ametal.h"
#include "am_types.h"
#include "am_gpio.h"
#include "am_spi.h"
#include "am_nvram.h"

/**
 * \addtogroup am_if_mb85rsxx
 * \copydoc am_mb85rsxx.h
 * @{
 */


/**
 * \brief MB85RSXX ʵϢ
 */
typedef struct am_mb85rsxx_devinfo {
 
    uint16_t          spi_mode;      /**< \brief ʹõSPIģʽ */
    int               spi_cs_pin;    /**< \brief SPIƬѡ       */
    uint32_t          spi_speed;     /**< \brief ʹõSPI     */
} am_mb85rsxx_devinfo_t;
     
/**
 * \brief MB85RSXX ʵ
 */
typedef struct am_mb85rsxx_dev {

    /**< \brief SPI豸              */
    am_spi_device_t              spi_dev;

    /**< \brief mb85rsxx豸ṩ NVRAM ׼ */
    am_nvram_dev_t               *p_serv;

    /**< \brief ʵϢ             */
    const am_mb85rsxx_devinfo_t  *p_devinfo;

} am_mb85rsxx_dev_t;

/** \brief  MB85RSXX ʵ */
typedef struct am_mb85rsxx_dev *am_mb85rsxx_handle_t;


/** 
 * \brief ʼ MB85RSXXȡ MB85RSXX  handle
 * 
 * \param[in] p_dev      : ָ MB85RSXX ʵָ
 * \param[in] p_devinfo  : ָ MB85RSXX ʵϢָ
 * \param[in] handle     : SPI׼handle,ʹø handle  MB85RSXX ͨ
 *
 * \return MB85RSXX ʼʧܣ򷵻ֵΪNULL
 */
am_mb85rsxx_handle_t am_mb85rsxx_init(am_mb85rsxx_dev_t            *p_dev,
                                      const am_mb85rsxx_devinfo_t  *p_devinfo,
                                      am_spi_handle_t               spi_handle);

/**
 * \brief ȡ
 *
 * \param[in] handle : MB85RSXX 
 * \param[in] addr   : ȡݵ׵ַ
 * \param[in] p_buf  : ȡݴŵĻ
 * \param[in] len    : ݶȡĳ
 *
 * \retval  AM_OK     : ȡݳɹ
 * \retval -AM_EINVAL : ȡʧ, 
 * \retval -AM_EIO    : ȡʧ, SPIͨų
 */
int am_mb85rsxx_read(am_mb85rsxx_handle_t  handle,
                     uint32_t              addr,
                     uint8_t              *p_buf,
                     uint32_t              len);


/** 
 * \brief д
 *
 * \param[in] handle : MB85RSXX 
 * \param[in] addr   : дݵ׵ַ
 * \param[in] p_buf  : дݴŵĻ
 * \param[in] len    : ݶȡĳ
 *
 * \retval  AM_OK     : ȡݳɹ
 * \retval -AM_EINVAL : ȡʧ, 
 * \retval -AM_EIO    : ȡʧ, SPIͨų
 */
int am_mb85rsxx_write(am_mb85rsxx_handle_t  handle,
                      uint32_t              addr,
                      uint8_t              *p_buf,
                      uint32_t              len);

                            
/** 
 * \brief ȡMB85RSXX״̬Ĵֵ
 * 
 * \param[in]  handle : MB85RSXX 
 * \param[out] p_stat : ȡ״̬Ĵֵ
 *
 * \retval  AM_OK     : ȡ״̬Ĵɹ
 * \retval -AM_EINVAL : ȡʧ, 
 * \retval -AM_EIO    : ȡʧ, SPIͨų
 */
int am_mb85rsxx_status_read(am_mb85rsxx_handle_t  handle,
                            uint8_t              *p_stat);

/** 
 * \brief MB85RSXX״̬Ĵֵ
 * 
 * \param[in] handle : MB85RSXX 
 * \param[in] val    : д״̬Ĵֵ
 *
 * \retval  AM_OK     : д״̬Ĵɹ
 * \retval -AM_EINVAL : дʧ, 
 * \retval -AM_EIO    : дʧ, SPIͨų
 *
 */
int am_mb85rsxx_status_write(am_mb85rsxx_handle_t  handle,
                             uint8_t               val);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif
 
#endif /* __AM_MB85RSXX_H */

/* end of file */
