/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief MiniPort-View  MiniPort-Keyʹ
 *
 * ʺ
 * 1. ܶʹGPIO
 * 2. λʹGPIO
 * 3. ̲ɨ跽ʽλѡ߸
 * 4. ̵ļֵȡʹGPIOȡGPIOܶ
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-12  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_DIGITRON_MINIPORT_VIEW_KEY_H
#define __AM_DIGITRON_MINIPORT_VIEW_KEY_H

#include "ametal.h"
#include "am_digitron_scan_gpio.h"
#include "am_key_matrix_read_gpio.h"

#ifdef __cplusplus
extern "C" {
#endif
 
/**
 * \addtogroup am_if_miniport_view_key
 * @{
 */
 
/**
 * \brief MiniPort View + MiniPort Key Ϣ
 */
typedef struct am_miniport_view_key_info {
    am_digitron_scan_gpio_info_t scan_info;    /**< \brief ̬ܶɨϢ */
    am_key_matrix_base_info_t    key_info;     /**< \brief Ϣ */
    const int                   *p_pins_row;   /**< \brief ţ߸ã  */
} am_miniport_view_key_info_t;

/**
 * \brief MiniPort View + MiniPort Key 豸
 */
typedef struct am_miniport_view_key_dev {
    am_digitron_scan_gpio_dev_t        scan_gpio_dev;
    am_key_matrix_t                    key_dev;
    am_key_matrix_read_gpio_t          read;
    const am_miniport_view_key_info_t *p_info;
} am_miniport_view_key_dev_t;

/**
 * \brief ̬ɨܳʼ
 *
 * \param[in] p_dev  : ̬ɨ豸ʵ
 * \param[in] p_info : ̬ɨ豸ʵϢ
 *
 * \retval AM_OK      : ʼɹ
 * \retval -AM_EINVAL ʼʧܣڴ
 */
int am_miniport_view_key_init (am_miniport_view_key_dev_t        *p_dev,
                               const am_miniport_view_key_info_t *p_info);

/**
 * \brief ̬ɨܽʼ
 *
 * \param[in] p_dev   : ̬ɨ豸ʵ
 *
 * \retval AM_OK      : ʼɹ
 * \retval -AM_EINVAL ʼʧܣڴ
 */
int am_miniport_view_key_deinit (am_miniport_view_key_dev_t *p_dev);

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_DIGITRON_MINIPORT_VIEW_KEY_H */

/* end of file */
