/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief RS200ӿں
 *
 * \internal
 * \par Modification History
 * - 1.00 19-12-12  RZ, first implementation.
 * \endinternal
 */

#ifndef __AM_RS200_H
#define __AM_RS200_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_types.h"
#include "am_uart_rngbuf.h"

/**
 * @addtogroup am_if_rs200
 * @copydoc am_rs200.h
 * @{
 */

/**
 * \name RS200
 * 
 *      am_rs200_ioctl()  cmd p_argʵ
 * Ĳͬͬ
 *
 * @{
 */

/**
 * \brief ȡRS200̼汾
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾ̼汾
 *
 */
#define  AM_RS200_VERSION_GET                      1

/**
 * \brief ȡ״̬
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾ״̬
 *
 */
#define  AM_RS200_RAIN_STA_GET                     2

/**
 * \brief ȡϵͳ״̬
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾϵͳ״̬
 *
 */
#define  AM_RS200_SYS_STA_GET                      3

/**
 * \brief ȡѧϵͳУ׼ֵ
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾѧϵͳУ׼ֵ
 *
 */
#define  AM_RS200_OPTICAL_SYS_VALUE_GET            4

/**
 * \brief ״̬Ƶ
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾ״̬Ƶ
 *
 */
#define  AM_RS200_RAIN_STA_OUT_FRE_SET             5

/**
 * \brief ȡ״̬Ƶ
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾ״̬Ƶ
 *
 */
#define  AM_RS200_RAIN_STA_OUT_FRE_GET             6

/**
 * \brief СֵV1
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾСֵV1
 *
 */
#define  AM_RS200_THRESHOLD_V1_SET                 7

/**
 * \brief ȡСֵV1
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾСֵV1
 *
 */
#define  AM_RS200_THRESHOLD_V1_GET                 8

/**
 * \brief СֵV2
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾСֵV2
 *
 */
#define  AM_RS200_THRESHOLD_V2_SET                 9

/**
 * \brief ȡСֵV2
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾСֵV2
 *
 */
#define  AM_RS200_THRESHOLD_V2_GET                 10

/**
 * \brief ֵV3
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾСֵV2
 *
 */
#define  AM_RS200_THRESHOLD_V3_SET                 11

/**
 * \brief ȡֵV3
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾСֵV2
 *
 */
#define  AM_RS200_THRESHOLD_V3_GET                 12

/**
 * \brief СֵS1
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾСֵS1
 *
 */
#define  AM_RS200_THRESHOLD_S1_SET                 13

/**
 * \brief ȡСֵS1
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾСֵS1
 *
 */
#define  AM_RS200_THRESHOLD_S1_GET                 14

/**
 * \brief СֵS2
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾСֵS2
 *
 */
#define  AM_RS200_THRESHOLD_S2_SET                 15

/**
 * \brief ȡСֵS2
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾСֵS2
 *
 */
#define  AM_RS200_THRESHOLD_S2_GET                 16

/**
 * \brief ֵS3
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾֵS3
 *
 */
#define  AM_RS200_THRESHOLD_S3_SET                 17

/**
 * \brief ȡֵS3
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾֵS3
 *
 */
#define  AM_RS200_THRESHOLD_S3_GET                 18

/**
 * \brief 10жΪֵN1
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾ10жΪֵN1
 *
 */
#define  AM_RS200_THRESHOLD_N1_SET                 19

/**
 * \brief ȡ10жΪֵN1
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾ10жΪֵN1
 *
 */
#define  AM_RS200_THRESHOLD_N1_GET                 20

/**
 * \brief 10жΪֵN2
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾ10жΪֵN2
 *
 */
#define  AM_RS200_THRESHOLD_N2_SET                 21

/**
 * \brief ȡ10жΪֵN2
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾ10жΪֵN2
 *
 */
#define  AM_RS200_THRESHOLD_N2_GET                 22

/**
 * \brief 10жΪֵN3
 *
 * ʱ p_arg Ϊ  uint16_t ֵͣʾ10жΪֵN3
 *
 */
#define  AM_RS200_THRESHOLD_N3_SET                 23

/**
 * \brief ȡ10жΪֵN3
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾ10жΪֵN3
 *
 */
#define  AM_RS200_THRESHOLD_N3_GET                 24

/**
 * \brief ûģʽ
 *
 * ʱ p_arg Ϊ  uint16_t 
 * 0˳ģʽ1뻷ģʽ
 *
 */
#define  AM_RS200_OPTICAL_TEST_MODE_SET            25

/**
 * \brief ȡֵ
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾֵ
 *
 */
#define  AM_RS200_OPTICAL_TEST_VALUE_GET           26

/**
 * \brief ȡоƬ¶
 *
 * ʱ p_arg Ϊ  uint16_t ֵָͣʾоƬ¶
 *
 */
#define  AM_RS200_TEMP_GET                         27

/**
 * \brief ùѧ˯״̬
 *
 * ʱ p_arg Ϊ  uint16_t 
 * 0˳ѧߣ1ѧ˯
 *
 */
#define  AM_RS200_LIGHT_SLEEP_MODE_SET             28

/**
 * \brief RS200ʵϢṹ嶨
 */
typedef struct am_rs200_devinfo {

    /** \brief ڴڽյĻС32     */
    uint8_t     *p_uart_rxbuf;

    /** \brief ڴڷ͵ĻС32     */
    uint8_t     *p_uart_txbuf;

    /** \brief ڴڽյĻС */
    uint16_t     rxbuf_size;

    /** \brief ڴڷ͵ĻС */
    uint16_t     txbuf_size;

    /** \brief ôڽճʱ */
    uint32_t     timeout_ms;
} am_rs200_devinfo_t;

/**
 * \brief RS200豸ṹ嶨
 */
typedef struct am_rs200_dev {

    /** \brief UARTλ豸 */
    am_uart_rngbuf_dev_t      rngbuf_dev;
    
    /** \brief UARTλʵ */
    am_uart_rngbuf_handle_t   rngbuf_handle;
    
    /** \brief UARTʵ */
    am_uart_handle_t          uart_handle;

    /** \brief ڱ豸Ϣָ */
    const am_rs200_devinfo_t *p_devinfo;

} am_rs200_dev_t;

/** \brief RS200  */
typedef struct am_rs200_dev *am_rs200_handle_t;

/**
 * \brief RS200ʼ
 *
 * ʹRS200ǰӦȵøóʼԻȡRS200handle
 *
 * \param[in] p_dev      : ָRS200豸ָ
 * \param[in] p_devinfo  : ָRS200豸Ϣָ
 * \param[in] handle     : UART׼ʹøUARTRS200ͨţ
 *
 * \return RS200handleʼʧܣ򷵻ֵΪNULL
 *
 * \note 豸ָp_devָ豸ֻҪ壬Ҫڵñǰʼ
 */
am_rs200_handle_t am_rs200_init (am_rs200_dev_t           *p_dev,
                                 const am_rs200_devinfo_t *p_devinfo,
                                 am_uart_handle_t          handle);

/**
 * \brief RS200ƺ
 *
 * \param[in] handle    : RS200ʵ
 * \param[in] cmd       : ָ磺#AM_RS200_RAIN_STA_OUT_FRE_SET
 * \param[in,out] p_arg : ӦĲ磺2
 *
 * \retval AM_OK       : ִָгɹ
 * \retval -AM_EIO     : ִд
 * \retval -AM_ENOTSUP : ָ֧
 *
 * \note 
 */
int am_rs200_ioctl (am_rs200_handle_t  handle,
                    int                cmd,
                    void              *p_arg);

/**
 * \brief ȡRS200״̬
 *
 * \param[in] handle : RS200ʵ
 * \param[in] p_data : ״̬ŵַ
 *
 * \retval AM_OK     : ִָгɹ
 * \retval       : ִд
 *
 */
int am_rs200_rain_sta_get (am_rs200_handle_t handle, uint16_t *p_data);

/**
 * \brief ȡRS200յ
 *
 * \param[in] handle : RS200ʵ
 * \param[in] p_buf  : ݴŵַ 
 * \param[in] len    : յݳ               
 *
 * \retval ճɹֽ
 *
 */
int am_rs200_recv (am_rs200_handle_t  handle,
                   uint8_t           *p_buf,
                   uint32_t           len);

/** 
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_RS200_H */

/* end of file */
