/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ״ AS7262 (UARTģʽ) ͷļ
 *
 * \internal
 * \par modification history
 * - 1.00 20-04-26  fzb, first implementation.
 * \endinternal
 */

#ifndef __AM_SENSOR_AS7262_UART_H
#define __AM_SENSOR_AS7262_UART_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_sensor_as7262.h"
#include "am_uart_rngbuf.h"

/* \brief  AS7262 ʶ */
#define AM_AS7262_RECEIVE_INVALID       0x01    /* Ч */
#define AM_AS7262_PARAMETER_INVALID     0x02    /* زʧ */

/**
 * \brief  AS7262 (UARTģʽ) 豸Ϣṹ
 */
typedef struct am_sensor_as7262_uart_devinfo {

    const am_sensor_as7262_devinfo_t       *p_devinfo;

    am_uart_handle_t (*pfn_uart_handle_get) (void);         /**< \brief UARTȡ */

    void (*pfn_uart_deinit) (am_uart_handle_t uart_handle); /**< \brief UARTʼ */

    uint32_t                                baudrate;       /**< \brief UART */

    uint8_t                                *p_uart_rxbuf;   /**< \brief ڴڽյĻС32     */

    uint8_t                                *p_uart_txbuf;   /**< \brief ڴڷ͵ĻС32     */

    uint16_t                                rxbuf_size;     /**< \brief ڴڽյĻС */

    uint16_t                                txbuf_size;     /**< \brief ڴڷ͵ĻС */

} am_sensor_as7262_uart_devinfo_t;

/**
 * \breif  AS7262 (UARTģʽ) 豸ṹ嶨
 */
typedef struct am_sensor_as7262_uart_dev {
    am_sensor_as7262_dev_t                  isa;                    /**< \breif ׼ */

    volatile int                            cmd_proc_state;         /**< \brief ״̬  */

    am_uart_handle_t                        uart_handle;            /**< \brief UART*/

    struct am_rngbuf                        rx_rngbuf;              /**< \brief ݻλ      */

    struct am_rngbuf                        tx_rngbuf;              /**< \brief ݻλ      */

    const am_sensor_as7262_uart_devinfo_t  *sensor_uart_dev_info;   /**< \brief 豸Ϣ */

    am_wait_t                               ack_wait;               /**< \brief ڽӦĵȴṹ       */

    am_wait_t                               rx_wait;                /**< \brief ڽݵĵȴṹ   */

    volatile uint32_t                       timeout_ms;             /**< \brief ճʱʱ                */

    uint8_t                                *p_cmd_rxbuf;            /**< \brief Ӧջ  */

    volatile int                            cmd_rxbuf_len;          /**< \brief Ӧջĳ  */

    volatile int                            cmd_rx_len;             /**< \brief ӦѾյĳ  */

    am_softimer_t                           timer;                  /**< \brief ʱжһ֡Ƿ */
} am_sensor_as7262_uart_dev_t;

/**
 * \brief  AS7262 (UARTģʽ) ʼ
 *
 * \param[in] p_dev     : ָ򴫸AS7262(UARTģʽ)豸ָ
 * \param[in] p_devinfo : ָ򴫸AS7262(UARTģʽ)豸Ϣָ
 *
 * \return ׼Ϊ NULLʼʧ
 */
am_sensor_handle_t am_sensor_as7262_uart_init (
        am_sensor_as7262_uart_dev_t             *p_dev,
        const am_sensor_as7262_uart_devinfo_t   *p_devinfo);

/**
 * \brief  AS7262 (UARTģʽ) ȥʼ
 *
 * \param[in] handle : am_sensor_as7262_uart_init()ʼõĴ׼
 *
 * \return 
 */
am_err_t am_sensor_as7262_uart_deinit (am_sensor_handle_t handle);


#ifdef __cplusplus
}
#endif

#endif /* __AM_SENSOR_AS7262_UART_H */

/* end of file */

