/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief CPU PLUS׼
 *
 * \internal
 * \par Modification History
 * - 1.00 16-01-06  hetaigang, first implementation.
 * \endinternal
 */
#ifndef __AM_DR_IC_CPU_PLUS_H
#define __AM_DR_IC_CPU_PLUS_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"
#include "am_uartcmd_cpu_plus.h"
#include "am_uartcmd_ic_iso14443.h"

/**
 * \brief CPU PLUS豸ṹ
 */
typedef struct amdr_ic_cpu_plus_dev {

    /** \brief CPU PLUSṹ */
    am_ic_cpu_plus_serv_t   serv;

    /** \brief ISO14443 */
    am_ic_iso14443_handle_t iso14443_handle;

    uint8_t  pcd_vector[16];   /** \brief PCDܳʼ */
    uint8_t  picc_vector[16];  /** \brief PICCܳʼ */
    uint8_t  random[16];       /** \brief  */

    /** \brief ״֤ɣʹ */
    uint8_t  ti[4];

    uint8_t  picc_cap2[6];     /** \brief PICC */
    uint8_t  subkey1[16];      /** \brief CMACԿ1 */
    uint8_t  subkey2[16];      /** \brief CMACԿ2 */

    /** \brief  ܻỰԿ */
    uint8_t  session_key_enc[16];

    /** \brief MAC ỰԿ */
    uint8_t  session_key_mac[16];

    am_bool_t   enckey_expand;    /** \brief Կչ־ */
    am_bool_t   mackey_expand;    /** \brief MACԿչ־ */
    am_bool_t   subkey_expand;    /** \brief CMACԿչ־ */

    uint16_t read_count;       /** \brief  */
    uint16_t write_count;      /** \brief д */

} amdr_ic_cpu_plus_dev_t;


/**
 * \brief CPU PLUSʼ
 *
 * \param[in] p_dev : CPU PLUS豸ṹָ
 *
 * \return CPU PLUS׼
 */
am_ic_cpu_plus_handle_t amdr_ic_cpu_plus_init (amdr_ic_cpu_plus_dev_t  *p_dev,
                                               am_ic_iso14443_handle_t  iso14443_handle);

/**
 * \brief CPU PLUSʼ
 *
 * \param[in] p_dev : CPU PLUS豸ṹָ
 *
 * \return 
 */
void amdr_ic_cpu_plus_deinit (amdr_ic_cpu_plus_dev_t *p_dev);

#ifdef __cplusplus
}
#endif

#endif /* __AMDR_IC_CPU_PLUS_H */

/* end of file */
