/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG52810ӿں
 *
 * \internal
 * \par Modification History
 * - 1.00 19-01-22  htf, first implementation.
 * \endinternal
 */

#ifndef __AM_ZLG52810_H
#define __AM_ZLG52810_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_types.h"
#include "am_i2c.h"
#include "am_softimer.h"
#include "am_uart_rngbuf.h"

/**
 * @addtogroup am_if_zlg52810
 * @copydoc am_zlg52810.h
 * @{
 */

/* \brief  ZLG52810 ʶ */
#define  AM_ZLG52810_RECVIVE_INVALID       0x01  /* Ч */
#define  AM_ZLG52810_PARAMETER_INVALID     0x02  /* Ч */
#define  AM_ZLG52810_COMMAND_INVALID       0x03  /* Ч */

/* \brief ZLG52810 ñʶ */
#define  AM_ZLG52810_BAUD_4800             0
#define  AM_ZLG52810_BAUD_9600             1
#define  AM_ZLG52810_BAUD_19200            2
#define  AM_ZLG52810_BAUD_38400            3
#define  AM_ZLG52810_BAUD_57600            4
#define  AM_ZLG52810_BAUD_115200           5
#define  AM_ZLG52810_BAUD_230400           6
#define  AM_ZLG52810_BAUD_460800           7
#define  AM_ZLG52810_BAUD_1000000          8

/* \brief ZLG52810 ñʶ */
#define  AM_ZLG52810_FLOWC_DISABLE         0
#define  AM_ZLG52810_FLOWC_EN_NOFLOW       1
#define  AM_ZLG52810_FLOWC_EN_FLOW         2

/**
 * \name ZLG52810
 * 
 *      am_zlg52810_ioctl()  cmd p_argʵ
 * Ĳͬͬ
 *
 * @{
 */

/**
 * \brief ѯԶӼλms
 *
 * ʱ p_arg Ϊ  char ֵָͣʾȡBLEԶӼ
 * ΧΪ 0006~0C80  Ϊ4ַ
 * 4 ַһ 16 λø16 λ 1.25 ΪϣõӼλ ms
 */
#define  AM_ZLG52180_ACOMA_GET                    1

/**
 * \brief ȡBLEӼλms
 *
 * ʱ p_arg Ϊ char ֵָͣʾõBLEԶӼ
 * ΧΪ 0006~0C80
 * 4 ַһ 16 λø16 λ 1.25 ΪϣõӼλ ms
 */
#define  AM_ZLG52810_ACOMA_SET                     2

/**
 * \brief ѯԶӲ
 *
 * ʱ p_arg Ϊuint32_t ָ
 * ЧֵУ0 Զ²     1 ʹԶ²
 */
#define  AM_ZLG52810_ACOUP_GET                    3

/**
 * \brief ԶӲ
 *
 * ʱ p_arg Ϊuint32_t ָ
 * ЧֵУ0 Զ²     1 ʹԶ²
 */
#define  AM_ZLG52810_ACOUP_SET                    4

/**
 * \brief ѯ豸ַ
 *
 * ʱ p_arg Ϊ  char ָָͣһʾ豸ַַ
 */
#define  AM_ZLG52810_ADDR_GET                         5

/**
 * \brief ѯ㲥
 *
 * Ϊ  uint32_t ͵ָ  ָģõĹ㲥
 *  0 ɷֿӣĬϣ   1 ɷֲ
 */
#define  AM_ZLG52810_ADTY_GET                         6

/**
 * \brief ù㲥
 *
 * Ϊ  uint32_t    õĹ㲥
 *  0 ɷֿӣĬϣ   1 ɷֲ
 */
#define  AM_ZLG52810_ADTY_SET                         7

/**
 * \brief ѯ㲥ʱ
 *
 * ʱ p_arg Ϊ  char ָָͣ㲥ʱ
 * Ч 0~F  0:100ms   1:152.5ms   2:211.25ms(Ĭ)   3:318.75ms
 *            4:417.5ms    5:546.25ms   6:760ms         7:852.5ms
 *            8:1022.5ms   9:1285ms     A:2000ms        B:3000ms
 *            C:4000ms     D:5000ms     E:6000ms        F:10000ms
 *
 */
#define  AM_ZLG52810_ADVI_GET                         8

/**
 * \brief ù㲥ʱ  ޸Ĺ㲥Ч͹
 *
 * ʱ p_arg Ϊ  char ͣʾ㲥ʱ
 * Ч 0~F  0:100ms   1:152.5ms   2:211.25ms(Ĭ)   3:318.75ms
 *            4:417.5ms    5:546.25ms   6:760ms         7:852.5ms
 *            8:1022.5ms   9:1285ms     A:2000ms        B:3000ms
 *            C:4000ms     D:5000ms     E:6000ms        F:10000ms
 *
 */
#define  AM_ZLG52810_ADVI_SET                         9

/**
 * \brief ȡ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡ
 * ЧֵУ0:4800  1:9600  2:19200  3:38400  4:57600  5:115200
 *        6:230400  7:460800  8:1000000
 */
#define  AM_ZLG52810_BAUD_GET                         10

/**
 * \brief ò
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣʾõĲʣ
 * ЧֵУ0:4800  1:9600  2:19200  3:38400  4:57600  5:115200
 *        6:230400  7:460800  8:1000000
 */
#define  AM_ZLG52810_BAUD_SET                         11

/**
 * \brief ȡǰ״̬
 *
 * ʱ p_arg Ϊ  am_bool_t ָͣڻȡ״̬
 * ֵΪ AM_TRUEӣֵΪ AM_FALSEδ
 */
#define  AM_ZLG52810_CONS_GET                         12

/**
 * \brief Ͽǰ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define  AM_ZLG52810_DISCONNECT                       13

/**
 * \brief ѯʱӲ
 *
 * ʱ p_arg Ϊ  char ָָͣһ4ַĻ
 * ص4ַһ16λø1.25ΪǰӼλms
 * ЧΧ  0006~0C80
 */
#define  AM_ZLG52810_COPS_GET                         14

/**
 * \brief ʱӲ
 *
 * ʱ p_arg Ϊ  char ָָͣһ4ֵַ
 * ص4ַһ16λø1.25ΪǰӼλms
 * ЧΧ  0006~0C80
 */
#define  AM_ZLG52810_COPS_SET                         15

/**
 * \brief 豸аϢ
 *
 * ʱ p_arg ΪNULL
 */
#define  AM_ZLG52810_ERASE                            16

/**
 * \brief ָ
 *
 * ʱ p_arg ΪNULL
 */
#define  AM_ZLG52810_FARESET                          17

/**
 * \brief ѯع
 *
 * ʱ p_arg Ϊ  int32_t ָͣԻȡǰع״̬
 * ЧֵУ 0:رգĬϣ  1:
 */
#define  AM_ZLG52810_FLC_GET                          18

/**
 * \brief ôع
 *
 * ʱ p_arg Ϊ  int32_t ͣ    ǰع״̬
 * ЧֵУ 0:رգĬϣ  1:
 */
#define  AM_ZLG52810_FLC_SET                          19

/**
 * \brief ѯLE secure connection ܿ
 *
 * ʱ p_arg Ϊ  int32_t ָͣԻȡLE secure connection ܿ״̬
 * Чֵ: 0:رգĬϣ   1:
 */
#define  AM_ZLG52810_LESC_GET                         20

/**
 * \brief LE secure connection ܿ
 *
 * ʱ p_arg Ϊ  int32_t ͣLE secure connection ܿ״̬
 * Чֵ: 0:رգĬϣ   1:
 */
#define  AM_ZLG52810_LESC_SET                         21

/**
 * \brief ѯ͹ĵȼ
 *
 * ʱ p_arg Ϊ  uint32_t ֵָͣڻȡ͹ĵȼ
 * ЧֵУ0:ȫУĬϣ     1:͹1     2:͹2
 */
#define  AM_ZLG52810_LOWL_GET                         22

/**
 * \brief õ͹ĵȼ
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣõ͹ĵȼ
 * ЧֵУ0:ȫУĬϣ     1:͹1     2:͹2
 */
#define  AM_ZLG52810_LOWL_SET                         23

/**
 * \brief ѯ㲥Զֶ
 *
 * ʱ p_arg Ϊ  char ָͣڻȡ㲥Զֶ
 */
#define  AM_ZLG52810_MFSD_GET                         24

/**
 * \brief ù㲥Զֶ
 *
 * ʱ p_arg Ϊ  char ָͣù㲥Զֶ
 * ЧΧΪ  0~52ַ         26ֽڲ5216Ƶַ
 */
#define  AM_ZLG52810_MFSD_SET                         25

/**
 * \brief ѯ豸
 *
 * ʱ p_arg Ϊchar ָͣڴŲѯ豸
 */
#define  AM_ZLG52810_NAME_GET                         26

/**
 * \brief 豸
 *
 * ʱ p_arg Ϊchar ָͣڴõ豸
 */
#define  AM_ZLG52810_NAME_SET                         27

/**
 * \brief ģ
 *
 * ʱ p_arg Ϊ  char ָָͣһʾַַ
 * ǡ0~9е6ַĬ123456
 */
#define  AM_ZLG52810_PASS_SET                          28

/**
 * \brief ȡģ
 *
 * ʱ p_arg Ϊ  char ָָͣһת루ַĻ
 * СΪ6ֽڣĬΪ123456
 */
#define  AM_ZLG52810_PASS_GET                          29

/**
 * \brief ѯ书
 *
 * ʱ p_arg Ϊ  uint32_t ָָͣѯķ书ʣ
 * Чֵ:  0:-20dbm   1:-12dbm   2:-4dbm  3:0dbm(Ĭ)  4:4dbm
 */
#define  AM_ZLG52810_POWE_GET                         30

/**
 * \brief ѯ书
 *
 * ʱ p_arg Ϊ  uint32_t ָͣõķ书ʣ
 * Чֵ:  0:-20dbm   1:-12dbm   2:-4dbm  3:0dbm(Ĭ)  4:4dbm
 */
#define  AM_ZLG52810_POWE_SET                         31

/**
 * \brief λ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define  AM_ZLG52810_RESET                            32

/**
 * \brief ѯģӡ
 *
 * ʱ p_arg Ϊ  uint32_t ָָͣȡģӡ
 * Чֵ: 0:ر       1:(Ĭ)
 */
#define  AM_ZLG52810_RSPI_GET                         33

/**
 * \brief ģӡ
 *
 * ʱ p_arg Ϊ  uint32_t ͣʾõģӡ
 * Чֵ: 0:ر       1:(Ĭ)
 */
#define  AM_ZLG52810_RSPI_SET                         34

/**
 * \brief ѯURATEʱ
 *
 * ʱ p_arg Ϊ  uint32_t ָָͣȡURATEʱ
 * Чֵ: 0:10ms     1:20ms  3:30ms   4:40ms  5:50ms  6:100ms  7:500ms
 */
#define  AM_ZLG52810_UTDT_GET                         35

/**
 * \brief URATEʱ
 *
 * ʱ p_arg Ϊ  uint32_t ͣʾõURATEʱ
 * Чֵ: 0:10ms     1:20ms  3:30ms   4:40ms  5:50ms  6:100ms  7:500ms
 */
#define  AM_ZLG52810_UTDT_SET                         36

/**
 * \brief ѯ豸ȫȼ
 *
 * ʱ p_arg Ϊ  uint32_t ָָͣȡ豸ȫȼ
 * Чֵ: 0:֤        1:֤          3:֤          4:֤
 */
#define  AM_ZLG52810_SECL_GET                         37

/**
 * \brief 豸ȫȼ
 *
 * ʱ p_arg Ϊ  uint32_t ͣʾõ豸ȫȼ
 * Чֵ: 0:֤        1:֤          3:֤          4:֤
 */
#define  AM_ZLG52810_SECL_SET                         38

/**
 * \brief ѯTX characteristic UUID
 *
 * ʱ p_arg Ϊ  char ָָͣȡTX  UUID
 * Чֵ: 0000~FFFF
 */
#define  AM_ZLG52810_UUTX_GET                         39

/**
 * \brief TX characteristic UUID
 *
 * ʱ p_arg Ϊ  char ͣʾõTX  UUID
 *  Чֵ: 0000~FFFF
 */
#define  AM_ZLG52810_UUTX_SET                         40

/**
 * \brief ѯRX characteristic UUID
 *
 * ʱ p_arg Ϊ  char ָָͣȡRX  UUID
 * Чֵ: 0000~FFFF
 */
#define  AM_ZLG52810_UURX_GET                         41

/**
 * \brief RX characteristic UUID
 *
 * ʱ p_arg Ϊ  char ָͣʾõRX  UUID
 *  Чֵ: 0000~FFFF
 */
#define  AM_ZLG52810_UURX_SET                         42

/**
 * \brief ѯ͸UUID
 *
 * ʱ p_arg Ϊ  char ָͣʾѯ͸  UUID
 */
#define  AM_ZLG52810_UUSE_GET                         43

/**
 * \brief ͸UUID
 *
 * ʱ p_arg Ϊ  char ָͣʾõ͸  UUID
 */
#define  AM_ZLG52810_UUSE_SET                         44

/**
 * \brief ȡ̼汾
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡ汾
 */
#define  AM_ZLG52810_VERS_GET                         45

/**
 * \name ZLG52810֧һЩڿ
 * @{
 */

/**
 * \brief ȡջѽյݸ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡջѽյݸ
 */
#define AM_ZLG52810_NREAD                             46

/**
 * \brief ȡͻдݸ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡͻдݸ
 */
#define AM_ZLG52810_NWRITE                            47

/**
 * \brief շͻͽջ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG52810_FLUSH                             48

/**
 * \brief շͻ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG52810_WFLUSH                            49

/**
 * \brief սջ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG52810_RFLUSH                            50

/**
 * \brief ýճʱʱ䣨λms
 *
 * ʱ p_arg Ϊ  uint32_t 
 */
#define AM_ZLG52810_TIMEOUT                           51

/** @} */
 
/**
 * \brief ZLG52810ʵϢṹ嶨
 */
typedef struct am_zlg52810_devinfo {
    /** \brief RTSţ
     * ͵ƽ:ʾģܹMCUĴݣMCUɼ
     * ߵƽ:ʾģ鲻ܹMCUĴݣMCUӦֹͣ
     */
    int          pin_rts;

    /** \brief CTSţ
     * ͵ƽ:ǰûMCUܽʱӦ
     * ߵƽ:ǰûMCUܽʱӦ
     */
    int          pin_cts;

    /** \brief Ӳλ   ͵ƽЧ */
    int          pin_rst;

    /** \brief RESTOREţڻָ   ȫģʽ5sָ */
    int          pin_restore;

    /** \brief WAKEUPţڻѵ͹ģʽ½Ч */
    int          pin_wakeup;

    /** \brief ģʼ        */
    uint32_t     baudrate;

    /** \brief ڴڽյĻС32     */
    uint8_t     *p_uart_rxbuf;

    /** \brief ڴڷ͵ĻС32     */
    uint8_t     *p_uart_txbuf;

    /** \brief ڴڽյĻС */
    uint16_t     rxbuf_size;

    /** \brief ڴڷ͵ĻС */
    uint16_t     txbuf_size;

} am_zlg52810_devinfo_t;

/**
 * \brief ZLG52810豸ṹ嶨
 */
typedef struct am_zlg52810_dev {

    /** \brief ڷǷع */
    volatile uint8_t            flowc_state;

    /** \brief BLE is connected? */
    volatile int                connect_state;

    /** \brief ״̬  */
    volatile int                cmd_proc_state;

    /** \brief ˴Ѿݵĸ*/
    volatile int                stat_rep_cnt;

    /** \brief UARTʵ                    */
    am_uart_handle_t            uart_handle;

    /** \brief ݻλ      */
    struct am_rngbuf            rx_rngbuf;

    /** \brief ݻλ      */
    struct am_rngbuf            tx_rngbuf;

    /** \brief ڱ豸Ϣָ */
    const am_zlg52810_devinfo_t *p_devinfo;

    /** \brief ڽӦĵȴṹ       */
    am_wait_t                   ack_wait;

    /** \brief ڽݵĵȴṹ   */
    am_wait_t                   rx_wait;

    /** \brief ճʱʱ                */
    volatile uint32_t           timeout_ms;

    /** \brief Ӧջ  */
    uint8_t                    *p_cmd_rxbuf;

    /** \brief Ӧջĳ  */
    volatile int                cmd_rxbuf_len;

    /** \brief ӦѾյĳ  */
    volatile int                cmd_rx_len;

    /** \brief ʱжһ֡Ƿ */
    am_softimer_t               timer;
} am_zlg52810_dev_t;


/** \brief ZLG52810  */
typedef struct am_zlg52810_dev *am_zlg52810_handle_t;
                                      
/**
 * \brief ZLG52810ʼ
 *
 * ʹZLG52810ǰӦȵøóʼԻȡZLG52810handle
 *
 * \param[in] p_dev      : ָZLG52810豸ָ
 * \param[in] p_devinfo  : ָZLG52810豸Ϣָ
 * \param[in] uart_handle : UART׼ʹøUARTZLG52810ͨţ
 *
 * \return ZLG52810handleʼʧܣ򷵻ֵΪNULL
 *
 * \note 豸ָp_devָ豸ֻҪ壬Ҫڵñǰʼ
 */
am_zlg52810_handle_t am_zlg52810_init (am_zlg52810_dev_t           *p_dev,
                                       const am_zlg52810_devinfo_t *p_devinfo,
                                       am_uart_handle_t             uart_handle);


/**
 * \brief ZLG52810ƺ
 *
 * \param[in] handle    : ZLG52810ʵ
 * \param[in] cmd       : ָ磺#AM_ZLG52810_BAUD_SET
 * \param[in,out] p_arg : ӦĲ磺 115200
 *
 * \retval AM_OK       : ִָгɹ
 * \retval -AM_EIO     : ִд
 * \retval -AM_ENOTSUP : ָ֧
 *
 * \note 
 */
int am_zlg52810_ioctl(am_zlg52810_handle_t  handle,
                      int                   cmd,
                      void                 *p_arg);


/**
 * \brief ͸
 *
 * \param[in] handle : ZLG52810ʵ
 * \param[in] p_buf  : ͵
 * \param[in] len    : ݳ
 *
 * \return Ǹʵʷ͵ֽʧ
 */
int am_zlg52810_send (am_zlg52810_handle_t  handle,
                     const uint8_t         *p_buf,
                     int                    len);


/**
 * \brief ͸
 *
 * \param[in] handle : ZLG52810ʵ
 * \param[in] p_buf  : ݵĻ
 * \param[out] len   : ݳ
 *
 * \return Ǹʵʽյֽʧ
 */
int am_zlg52810_recv (am_zlg52810_handle_t  handle,
                     uint8_t               *p_buf,
                     int                    len);
 
/**
 * \brief ZLG52810 ͹ģʽ
 *
 * \param[in] handle : ZLG52810ʵ
 *
 * \retval AM_OK       : ִָгɹ
 * \retval AM_FALSE    : ִд  Ӧ
 */
int am_zlg52810_lpower_wakeup(am_zlg52810_handle_t  handle);

/**
 * \brief ZLG52810 ָ
 *
 * \param[in] handle : ZLG52810ʵ
 *
 * \retval AM_OK       : ִָгɹ
 * \retval AM_FALSE    : ִд  Ӧ
 */
int am_zlg52810_fareset(am_zlg52810_handle_t  handle);

/**
 * \brief ZLG52810 Ӳλ
 *
 * \param[in] handle : ZLG52810ʵ
 *
 * \retval AM_OK       : ִָгɹ
 * \retval AM_FALSE    : ִд  Ӧ
 */
int am_zlg52810_reset(am_zlg52810_handle_t  handle);
/** 
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG52810_H */

/* end of file */
