/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG72128ͨýӿڣܽӿںͰӿڣ
 *
 * \internal
 * \par Modification History
 * - 1.01 19-04-21  xgg, adjust new frame
 * - 1.00 17-05-22  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_ZLG72128_STD_H
#define __AM_ZLG72128_STD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"
#include "am_digitron_dev.h"
#include "zlg72128.h"

/**
 * @addtogroup am_if_zlg72128_std
 * @copydoc am_zlg72128_std.h
 * @{
 */

#define AM_ZLG72128_STD_KEY_ROW_0  (1 << 0) /**< \brief ʹõ0      */
#define AM_ZLG72128_STD_KEY_ROW_1  (1 << 1) /**< \brief ʹõ1      */
#define AM_ZLG72128_STD_KEY_ROW_2  (1 << 2) /**< \brief ʹõ2      */
#define AM_ZLG72128_STD_KEY_ROW_3  (1 << 3) /**< \brief ʹõ3УܰУ*/
                                                 
#define AM_ZLG72128_STD_KEY_COL_0  (1 << 0) /**< \brief ʹõ0      */
#define AM_ZLG72128_STD_KEY_COL_1  (1 << 1) /**< \brief ʹõ1      */
#define AM_ZLG72128_STD_KEY_COL_2  (1 << 2) /**< \brief ʹõ2      */
#define AM_ZLG72128_STD_KEY_COL_3  (1 << 3) /**< \brief ʹõ3      */
#define AM_ZLG72128_STD_KEY_COL_4  (1 << 4) /**< \brief ʹõ4      */
#define AM_ZLG72128_STD_KEY_COL_5  (1 << 5) /**< \brief ʹõ5      */
#define AM_ZLG72128_STD_KEY_COL_6  (1 << 6) /**< \brief ʹõ6      */
#define AM_ZLG72128_STD_KEY_COL_7  (1 << 7) /**< \brief ʹõ7      */

/**
 * \brief ZLG72128ͨܺͰ豸Ϣ
 */
typedef struct am_zlg72128_std_devinfo {
    zlg72128_devinfo_t     base_info;         /**< \brief 豸Ϣ         */
    am_digitron_devinfo_t  id_info;           /**< \brief ʾID         */
    uint16_t               blink_on_time;     /**< \brief һ˸ڣʱ䣬 500ms */
    uint16_t               blink_off_time;    /**< \brief һ˸ڣϨʱ䣬 500ms */
    uint8_t                key_use_row_flags; /**< \brief ʵʹõб־  */
    uint8_t                key_use_col_flags; /**< \brief ʵʹõб־ */
    const int             *p_key_codes;  /**< \brief 룬 СΪ key_rows * key_cols */
    uint8_t                num_digitron; /**< \brief ʵʹõܸ */
} am_zlg72128_std_devinfo_t;

/**
 * \brief ZLG72128ͨܺͰ豸
 */
typedef struct am_zlg72128_std_digitron_key_dev {

    /** ʹõײZLG72128    */
    zlg72128_dev_t        zlg72128_dev;

    /** \brief 豸      */
    am_digitron_dev_t     digitron_dev;

    /** \brief ZLG72128      */
    zlg72128_handle_t     handle;

    /** \brief ֵܼܼתΪͨðʹ      */
    uint8_t               f_key;
    
    /** \brief ʵʹõİ  */
    uint8_t               num_rows;

    /** \brief ʵʹð */
    uint8_t               num_cols;

    /** \brief ˸  */
    uint16_t              blink_flags;

    /** \brief Զ뺯  */
    uint16_t  (*pfn_decode)(uint16_t code);

    /** \brief ڱ豸Ϣָ */
    const am_zlg72128_std_devinfo_t  *p_info;

} am_zlg72128_std_dev_t;

/**
 * \brief ZLG72128ʼ
 *
 * ʹZLG72128ǰӦȵøóʼԻȡZLG72128handle
 *
 * \param[in] p_dev      : ָZLG72128豸ָ
 * \param[in] p_info     : ָZLG72128豸Ϣָ
 * \param[in] i2c_handle : I2C׼ʹøI2CZLG72128ͨţ
 *
 * \return AM_OKʼɹ򣬳ʼʧ
 */
int am_zlg72128_std_init (am_zlg72128_std_dev_t           *p_dev,
                          const am_zlg72128_std_devinfo_t *p_info);

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG72128_STD_H */

/* end of file */
