/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG9021ӿں
 *
 * \internal
 * \par Modification History
 * - 1.00 16-09-06  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_ZLG9021_H
#define __AM_ZLG9021_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_types.h"
#include "am_i2c.h"
#include "am_softimer.h"
#include "am_uart_rngbuf.h"

/**
 * @addtogroup am_if_zlg9021
 * @copydoc am_zlg9021.h
 * @{
 */

/**
 * \name ZLG9021
 * 
 *      am_zlg9021_ioctl()  cmd p_argʵ
 * Ĳͬͬ
 *
 * @{
 */

/**
 * \brief BLEӼλms
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣʾõBLEʱ
 * ЧֵУ2050100200300400500100015002000
 */
#define  AM_ZLG9021_BLE_CONNECT_INTERVAL_SET     1

/**
 * \brief ȡBLEӼλms
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡBLEʱ
 */
#define  AM_ZLG9021_BLE_CONNECT_INTERVAL_GET     2

/**
 * \brief ģ
 *
 * ʱ p_arg Ϊ  char ָָͣһʾģַַ
 * Ҫ15ַڡ
 */
#define  AM_ZLG9021_RENAME                       3

/**
 * \brief ģԶģMACַ
 *
 * ʱ p_arg Ϊ  char ָָͣһʾģַַ
 * Ҫ15ַڡºģᱻΪ NAME(xxxxxx)Ϊģ MAC
 * ַ 3 ֽڵ Hex 룬  iOS ϵͳʶģ
 */
#define  AM_ZLG9021_RENAME_MAC_STR              4


/**
 * \brief ȡģ
 *
 * ʱ p_arg Ϊ  char ָָͣһתģĻ飩
 * СΪ15ֽڡ
 */
#define  AM_ZLG9021_NAME_GET                     5

/**
 * \brief ò
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣʾõĲʣ
 * ЧֵУ48009600192003840057600115200
 */
#define  AM_ZLG9021_BAUD_SET                     6


/**
 * \brief ȡ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡ
 */
#define  AM_ZLG9021_BAUD_GET                     7



/**
 * \brief ȡMACַ
 *
 * ʱ p_arg Ϊ  char ָָͣһ13ַĻ
 */
#define  AM_ZLG9021_MAC_GET                       8



/**
 * \brief λZLG9021
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define  AM_ZLG9021_RESET                         9


/**
 * \brief BLEĹ㲥ڣλ:ms
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣʾ㲥
 * ЧֵУ2005001000150020002500300040005000
 */
#define  AM_ZLG9021_BLE_ADV_PERIOD_SET            10


/**
 * \brief ȡBLEĹ㲥ڣλ:ms
 *
 * ʱ p_arg Ϊ  uint32_t ָͣԻȡ㲥
 */
#define  AM_ZLG9021_BLE_ADV_PERIOD_GET            11


/**
 * \brief ÷͹ʣdBm
 *
 * ʱ p_arg Ϊ  int ֵͣʾ书
 * ЧֵУ-20-18-16-14-12-10-8-6-4-2024
 */
#define  AM_ZLG9021_TX_POWER_SET                  12


/**
 * \brief ȡ͹ʣdBm
 *
 * ʱ p_arg Ϊ  int ָͣԻȡ㲥
 */
#define  AM_ZLG9021_TX_POWER_GET                  13


/**
 * \brief BCTS͵ƽ֮ʱλ:ms
 *
 * ʱ p_arg Ϊ  uint32_t ֵͣʾʱʱ
 * ЧֵУ0102030
 */
#define  AM_ZLG9021_BCTS_DELAY_SET                14


/**
 * \brief ȡBCTS͵ƽ֮ʱλ:ms
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡʱʱ
 */
#define  AM_ZLG9021_BCTS_DELAY_GET                15


/**
 * \brief ͹ģʽ
 *
 * ʱ p_arg Ϊ am_bool_tֵΪAM_TRUEʱ͹ģʽֵΪAM_FALSEʱ˳͹ģʽ
 *
 * p_argֵΪ AM_TRUEúʹZLG9021͹ģʽʱENЧʼʱ
 * ʵϢṩENţģ鲻ͣENЧʹ
 * ʹZLG9021͹ģʽ
 *
 * p_argֵΪFLASEʾ˳͹ģʽģָ
 */
#define  AM_ZLG9021_POWERDOWN                     16

/**
 * \brief ȡ̼汾
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡ汾
 * ȡֵΪ磺100Ӧ1.00汾101Ӧ1.01汾
 */
#define  AM_ZLG9021_VERSION_GET                   17

/**
 * \brief ȡǰ״̬
 *
 * ʱ p_arg Ϊ  am_bool_t ָͣڻȡ״̬
 * ֵΪ AM_TRUEӣֵΪ AM_FALSEδ
 */
#define  AM_ZLG9021_CONSTATE_GET                  18

/**
 * \brief Ͽǰ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define  AM_ZLG9021_DISCONNECT                    19

/**
 * \brief ģ
 *
 * ʱ p_arg Ϊ  char ָָͣһʾַַ
 * Ҫ15ַڡºģᱻΪ NAME(xxxxxx)Ϊģ MAC
 * ַ 3 ֽڵ Hex 룬  iOS ϵͳʶģ
 */
#define  AM_ZLG9021_PWD_SET                       20

/**
 * \brief ȡģ
 *
 * ʱ p_arg Ϊ  char ָָͣһת루ַĻ
 * СΪ15ֽڡ
 */
#define  AM_ZLG9021_PWD_GET                       21

/**
 * \brief Ƿܴ
 *
 * ʱ p_arg Ϊ  am_bool_t ͣ ֵΪAM_TRUEʱܹܣֵΪAM_FALSE
 * ʱرմܹܡ
 */
#define  AM_ZLG9021_ENC_SET                       22

/**
 * \brief ȡģļ״̬
 *
 * ʱ p_arg Ϊ  am_bool_t ָͣ  ڻȡǰǷܡ
 */
#define  AM_ZLG9021_ENC_GET                       23

/**
 * \brief ָ
 *
 * p_argΪNULL
 *
 * ϵͳ 30s ִУȷָã򣬿ָܻ
 * ʧܡʹøʱҪȷʵϢе RESTORE ЧΪ-1
 */
#define  AM_ZLG9021_RESTORE                       30

/** @} */

/**
 * \name ZLG9021֧һЩڿ
 * @{
 */

/**
 * \brief ȡջѽյݸ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡջѽյݸ
 */
#define AM_ZLG9021_NREAD                         24

/**
 * \brief ȡͻдݸ
 *
 * ʱ p_arg Ϊ  uint32_t ָͣڻȡͻдݸ
 */
#define AM_ZLG9021_NWRITE                        25

/**
 * \brief շͻͽջ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG9021_FLUSH                         26

/**
 * \brief շͻ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG9021_WFLUSH                        27

/**
 * \brief սջ
 *
 * ʱ p_arg δʹãֵΪNULL
 */
#define AM_ZLG9021_RFLUSH                       28

/**
 * \brief ýճʱʱ䣨λms
 *
 * ʱ p_arg Ϊ  uint32_t 
 */
#define AM_ZLG9021_TIMEOUT                      29

/** @} */
 
/**
 * \brief ZLG9021ʵϢṹ嶨
 */
typedef struct am_zlg9021_devinfo {

    /** \brief ENţENŹ̶ӵ͵ƽMCUƣʱֵΪ -1 */
    int          pin_en;

    /** \brief BRTSţÿηZLG9021ǰͣ  */
    int          pin_brts;

    /** \brief λ  */
    int          pin_rst;

    /** \brief RESTOREţڻָ   */
    int          pin_restore;

    /** \brief ģ鵱ǰʹõĲ        */
    uint32_t     baudrate;

    /** \brief ڴڽյĻС32     */
    uint8_t     *p_uart_rxbuf;

    /** \brief ڴڷ͵ĻС32     */
    uint8_t     *p_uart_txbuf;

    /** \brief ڴڽյĻС */
    uint16_t     rxbuf_size;

    /** \brief ڴڷ͵ĻС */
    uint16_t     txbuf_size;

} am_zlg9021_devinfo_t;

/**
 * \brief ZLG9021豸ṹ嶨
 */
typedef struct am_zlg9021_dev {

    /** \brief Ƿڷ֮  */
    volatile am_bool_t          in_send;

    /** \brief brts ǷҪΪߵƽ */
    volatile am_bool_t          is_brts;

    /** \brief BLE is connected? */
    volatile int                connect_state;

    /** \brief ״̬  */
    volatile int                cmd_proc_state;

    /** \brief ȡ "TIM:CONNECT"״̬  */
    volatile int                stat_rep_type;

    /** \brief ȡ "TIM:DISCONNECT"״̬  */
    volatile int                stat_rep_cnt;

    /** \brief UARTʵ                    */
    am_uart_handle_t            uart_handle;

    /** \brief ݻλ      */
    struct am_rngbuf            rx_rngbuf;

    /** \brief ݻλ      */
    struct am_rngbuf            tx_rngbuf;

    /** \brief ڱ豸Ϣָ */
    const am_zlg9021_devinfo_t *p_devinfo;

    /** \brief ڽӦĵȴṹ       */
    am_wait_t                   ack_wait;

    /** \brief ڽݵĵȴṹ   */
    am_wait_t                   rx_wait;

    /** \brief ճʱʱ                */
    volatile uint32_t           timeout_ms;

    /** \brief Ӧջ  */
    uint8_t                    *p_cmd_rxbuf;

    /** \brief Ӧջĳ  */
    volatile int                cmd_rxbuf_len;

    /** \brief ӦѾյĳ  */
    volatile int                cmd_rx_len;

    /** \brief The Timer for timeout */
    am_softimer_t               timer;

    /** \brief The Timer for BRTS */
    am_softimer_t               timer_brts;

} am_zlg9021_dev_t;


/** \brief ZLG9021  */
typedef struct am_zlg9021_dev *am_zlg9021_handle_t;
                                      
/**
 * \brief ZLG9021ʼ
 *
 * ʹZLG9021ǰӦȵøóʼԻȡZLG9021handle
 *
 * \param[in] p_dev      : ָZLG9021豸ָ
 * \param[in] p_devinfo  : ָZLG9021豸Ϣָ
 * \param[in] uart_handle : UART׼ʹøUARTZLG9021ͨţ
 *
 * \return ZLG9021handleʼʧܣ򷵻ֵΪNULL
 *
 * \note 豸ָp_devָ豸ֻҪ壬Ҫڵñǰʼ
 */
am_zlg9021_handle_t am_zlg9021_init (am_zlg9021_dev_t           *p_dev,
                                     const am_zlg9021_devinfo_t *p_devinfo,
                                     am_uart_handle_t            uart_handle);


/**
 * \brief ZLG9021ƺ
 *
 * \param[in] handle    : ZLG9021ʵ
 * \param[in] cmd       : ָ磺#AM_ZLG9021_BAUD_SET
 * \param[in,out] p_arg : ӦĲ磺 115200
 *
 * \retval AM_OK       : ִָгɹ
 * \retval -AM_EIO     : ִд
 * \retval -AM_ENOTSUP : ָ֧
 *
 * \note 
 */
int am_zlg9021_ioctl(am_zlg9021_handle_t  handle,
                     int                  cmd,
                     void                *p_arg);


/**
 * \brief ͸
 *
 * \param[in] handle : ZLG9021ʵ
 * \param[in] p_buf  : ͵
 * \param[in] len    : ݳ
 *
 * \return Ǹʵʷ͵ֽʧ
 */
int am_zlg9021_send (am_zlg9021_handle_t  handle,
                     const uint8_t       *p_buf,
                     int                  len);


/**
 * \brief ͸
 *
 * \param[in] handle : ZLG9021ʵ
 * \param[in] p_buf  : ͵
 * \param[in] len    : ݳ
 *
 * \return Ǹʵʽյֽʧ
 */
int am_zlg9021_recv (am_zlg9021_handle_t  handle,
                     uint8_t             *p_buf,
                     int                  len);
 
/** 
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG9021_H */

/* end of file */
