/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2019 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG72128ͨ
 *
 * \note
 * ZLG72128ԣI2CĴzlg72128_platform.h
 * ѾI2CصĴ亯˶壬ûʹʱҪƽ̨
 * 䣬ZLG72128ģӦãֻҪעڵĽӿںɡ
 * zlg72128_platform.hвI2C亯ƽ̨صĳʼ
 * ʱûҲҪƽ̨䣬zlg72128_platform.h
 * ļ
 *
 * \internal
 * \par Modification History
 * - 1.00 18-11-13  xgg first implementation.
 * \endinternal
 */

#ifndef __ZLG72128_H
#define __ZLG72128_H

#include "zlg72128_platform.h"

#ifdef __cplusplus
extern "C" {
#endif


/**
 * @addtogroup if_zlg72128
 * @copydoc zlg72128.h
 * @{
 */

/**
 * \name ͨ1 ~ 3аֵ궨
 *
 *  оٳ zlg72128_key_cb_t صе key_val ܵһϵֵ
 *  ʹkey_valֵһϵкֵӦԱȣжһ¡
 *  ZLG72128_KEY_x_y УxһУ1 ~ 3yʾһУ1 ~ 8)
 *
 * @{
 */

#define  ZLG72128_KEY_1_1     1     /**< \brief 1ŵ1  */
#define  ZLG72128_KEY_1_2     2     /**< \brief 1ŵ2  */
#define  ZLG72128_KEY_1_3     3     /**< \brief 1ŵ3  */
#define  ZLG72128_KEY_1_4     4     /**< \brief 1ŵ4  */
#define  ZLG72128_KEY_1_5     5     /**< \brief 1ŵ5  */
#define  ZLG72128_KEY_1_6     6     /**< \brief 1ŵ6  */
#define  ZLG72128_KEY_1_7     7     /**< \brief 1ŵ7  */
#define  ZLG72128_KEY_1_8     8     /**< \brief 1ŵ8  */

#define  ZLG72128_KEY_2_1     9     /**< \brief 2ŵ1  */
#define  ZLG72128_KEY_2_2     10    /**< \brief 2ŵ2  */
#define  ZLG72128_KEY_2_3     11    /**< \brief 2ŵ3  */
#define  ZLG72128_KEY_2_4     12    /**< \brief 2ŵ4  */
#define  ZLG72128_KEY_2_5     13    /**< \brief 2ŵ5  */
#define  ZLG72128_KEY_2_6     14    /**< \brief 2ŵ6  */
#define  ZLG72128_KEY_2_7     15    /**< \brief 2ŵ7  */
#define  ZLG72128_KEY_2_8     16    /**< \brief 2ŵ8  */


#define  ZLG72128_KEY_3_1     17    /**< \brief 3ŵ1  */
#define  ZLG72128_KEY_3_2     18    /**< \brief 3ŵ2  */
#define  ZLG72128_KEY_3_3     19    /**< \brief 3ŵ3  */
#define  ZLG72128_KEY_3_4     20    /**< \brief 3ŵ4  */
#define  ZLG72128_KEY_3_5     21    /**< \brief 3ŵ5  */
#define  ZLG72128_KEY_3_6     22    /**< \brief 3ŵ6  */
#define  ZLG72128_KEY_3_7     23    /**< \brief 3ŵ7  */
#define  ZLG72128_KEY_3_8     24    /**< \brief 3ŵ8  */

/** @} */

/**
 * \name ܰ4аź궨
 *
 *   ܰӵ4пʼңζΪ F0 ~ F7״ֱ̬밴
 * е funkey_val ֵ bit0 ~ bit7 Ӧ0λ£1Ϊͷš
 * funkey_val8ֱֵܼʹ8λֵʵֽΪ
 * İơֻҪ򵥵ļĳܼ״̬ʹ
 * #ZLG72128_FUNKEY_CHECK()ĳһܼ״̬
 * #ZLG72128_FUNKEY_CHECK()funkey_numΪ0 ~ 7ʹ
 *  ˴ĺֵ#ZLG72128_FUNKEY_0 ~ #ZLG72128_FUNKEY_7
 *
 * @{
 */

#define  ZLG72128_FUNKEY_0     0     /**< \brief ܼ1  */
#define  ZLG72128_FUNKEY_1     1     /**< \brief ܼ2  */
#define  ZLG72128_FUNKEY_2     2     /**< \brief ܼ3  */
#define  ZLG72128_FUNKEY_3     3     /**< \brief ܼ4  */
#define  ZLG72128_FUNKEY_4     4     /**< \brief ܼ4  */
#define  ZLG72128_FUNKEY_5     5     /**< \brief ܼ5  */
#define  ZLG72128_FUNKEY_6     6     /**< \brief ܼ6  */
#define  ZLG72128_FUNKEY_7     7     /**< \brief ܼ7  */

/** @} */

/**
 * \name ʾλķ
 *  \sa zlg72128_digitron_shift()  \a dir 
 * @{
 */
#define  ZLG72128_DIGITRON_SHIFT_RIGHT  0   /**< \brief   */
#define  ZLG72128_DIGITRON_SHIFT_LEFT   1   /**< \brief   */

/** @} */

/**
 * \name ܰ4а״̬
 *
 *   ܰӵ4пʼңζΪ F0 ~ F7״ֱ̬밴ص
 * е funkey_val ֵ bit0 ~ bit7 Ӧ0λ£1Ϊͷšfunkey_val8
 * ֱֵܼʹ8λֵʵֽΪӵİơֻҪ
 * ļĳܼ״̬ʹøúĳһܼ״̬
 *
 * \param[in] funkey_val : صлȡĹֵܼ
 * \param[in] funkey_num : ܼţЧֵ0 ~ 7ֱӦ F0 ~ F7ʹ
 *                         ֵ#ZLG72128_FUNKEY_0 ~ #ZLG72128_FUNKEY_7
 *
 * \retval 1 : Ӧܼǰǰ״̬
 * \retval 0 : Ӧܼǰͷ״̬
 * @{
 */

#define  ZLG72128_FUNKEY_CHECK(funkey_val, funkey_num)  \
               (((funkey_val) & (1 << ((funkey_num) & 0x07))) ? 0 : 1)

/** @} */

/**
 * \name ܶ
 *  \sa zlg72128_digitron_seg_ctrl() οƺ \a seg 
 * @{
 */

#define  ZLG72128_DIGITRON_SEG_A    0        /**< \brief a    */
#define  ZLG72128_DIGITRON_SEG_B    1        /**< \brief b    */
#define  ZLG72128_DIGITRON_SEG_C    2        /**< \brief c    */
#define  ZLG72128_DIGITRON_SEG_D    3        /**< \brief d    */
#define  ZLG72128_DIGITRON_SEG_E    4        /**< \brief e    */
#define  ZLG72128_DIGITRON_SEG_F    5        /**< \brief f    */
#define  ZLG72128_DIGITRON_SEG_G    6        /**< \brief g    */
#define  ZLG72128_DIGITRON_SEG_DP   7        /**< \brief dp   */

/** @} */

/** \brief ֽӿڵZLG72128_TRUEZLG72128_FLASE */
#define  ZLG72128_TRUE              1
#define  ZLG72128_FALSE             0

/**
 * \brief ZLG72128ӻַûɼA4ĵƽȷǰZLG72128ģĴӻַ
 *        A4Ϊջ߸ߵƽӻַΪ0x30
 *        A4Ϊ͵ƽӻַΪ0x20
 */
#define  ZLG72128_PIN_HIGH_SLV_ADDR  0x30
#define  ZLG72128_PIN_LOW_SLV_ADDR   0x20

/**
 * \brief ͨ1 ~ 3Уص
 *
 *    ʹ zlg72128_key_cb_set() øûصϵͳ֮Уа
 * ¼ʱûص
 *
 * \param[in] p_arg      : ûصʱ趨ûԶ
 *
 * \param[in] key_val    : ֵӵ1пʼ˳š1е1
 *                         ֵΪ11е2ֵΪ2Դơʹ
 *                         ֱֵ ZLG72128_KEY_*_*(#ZLG72128_KEY_1_1)
 *                         Ƚϣжһ¡أ0ʾκͨ
 *                         ¡
 *
 * \param[in] repeat_cnt : ֵ֧ͨڸ
 *                         key_val0Ӧͨfunkey_val
 *                         Ĺܼûйϵ0 ʾ״ΰδֵ
 *                         ʾʶ𵽵סʱ䳬2s󣬿ʼ
 *                         ЧЧʱԼ200msÿ200ms
 *                         repeat_cnt1һθúֱͷšֵ
 *                         Ϊ255255򽫽׶Σ
 *                         ûʱûص
 *
 * \param[in] funkey_val : ֵܼ8λֱ4иӦλ
 *                         4е1Ӧθλ4е2Ӧ
 *                         λ4е8ӦλֵΪ0Ӧ£λ
 *                         ֵΪ1Ӧδ¡ֻҪֵı䣬ͻ
 *                         Ļص
 *
 * \note ڹܼͨʵϼӦãPCϵAltShiftȰ
 *
 *     羭õһܣ༭ʱTABƣסShiftTAB
 * ΪơԺʵƵĹܣ繦ܼ0Shiftͨ0TA
 * B
 */
typedef void (*zlg72128_key_cb_t) (void       *p_arg,
                                   uint8_t     key_val,
                                   uint8_t     repeat_cnt,
                                   uint8_t     funkey_val);

/**
 * \brief ZLG72128豸Ϣṹ嶨
 */
typedef struct zlg72128_devinfo {

    /** \brief ƽ̨Ϣṹ*/
    zlg72128_plfm_init_info_t  plfm_info;

}zlg72128_devinfo_t;

/**
 * \brief ZLG72128豸ṹ嶨
 *
 * \note Ϊǵƽ̨ûŵĶ岻ͬ˵
 * λźжŵԼ򵥵ģZLG72128вû
 * ŵúZLG72128ĸλźǵ͵ƽЧûλ
 * 5-10msԴﵽλЧͬж˵Ҳǵ͵ƽЧ
 * ûԽжϴʽΪ½ػ͵ƽûص
 * zlg72128_platform.hжzlg72128_plfm_init
 * С
 *
 */
typedef struct zlg72128_dev {

    /** \brief ƽ̨ص豸*/
    zlg72128_plfm_t     plfm;

    /** \brief ͨص */
    zlg72128_key_cb_t   pfn_key_cb;

    /** \brief 水ص */
    void               *pfn_key_arg;

} zlg72128_dev_t;


/** \brief ZLG72128  */
typedef zlg72128_dev_t   *zlg72128_handle_t;

/**
 * \brief ZLG72128ʼ
 *  ZLG72128ӿǰӦȵøóʼԻȡ
 *  ZLG72128handleȡľڵô󲿷ֽӿʱ贫뵽
 *  ڵĵһhandleСʼڲzlg72128_platform.h
 *  жzlg72128_plfm_initƽ̨صϢгʼ
 *
 * \param[in] p_dev     : ָZLG72128豸ָ
 * \param[in] p_devinfo : 豸Ϣṹ壬Ϣṹбzlg72128_platform.h
 *                        жzlg72128_plfm_init_info_tṹ壬ڲ
 *                        zlg72128_plfm_initʱᴫڶp_plfm_init_infoС
 *
 * \return ִгɹزZLG72128handle
 *         NULLЧƽ̨ʼִʧܡ
 *
 * \note 豸ָp_devָ豸ֻҪ壬Ҫڵñǰʼ
 */
zlg72128_handle_t zlg72128_init (zlg72128_dev_t           *p_dev,
                                 const zlg72128_devinfo_t *p_devinfo);

/**
 * \brief ͨ1 ~ 3аصע
 *
 * а¼ʱô˴õĻص¼3
 *  1. ͨ
 *  2. ͨһֱ£״̬
 *  3. һܰ״̬仯ͷ->  ->ͷ
 *
 * \param[in] handle      : ZLG72128Ĳ
 * \param[in] pfn_key_cb  : ص
 * \param[in] p_arg       : صĲ
 *
 * \retval -2 : 
 * \retval  0 : ִгɹ
 */
int zlg72128_key_cb_set (zlg72128_handle_t   handle,
                         zlg72128_key_cb_t   pfn_key_cb,
                         void               *p_arg);

/**
 * \brief ˸ʱ䣬趨ĳλ˸ʱʱϨʱ
 *
 *     ΪʱΪ500msʱ䵥λΪmsЧʱΪ
 *  150200250800850900 150ms ~ 900ms50msΪࡣ
 *  ʱ䲻ǡΪЩֵһӽֵ
 *
 * \param[in] handle : ZLG72128Ĳ
 * \param[in] on_ms  : ʱ䣬ЧֵΪ 150ms ~ 900ms50msΪ
 * \param[in] off_ms : Ϩʱ䣬ЧֵΪ 150ms ~ 900ms50msΪ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 *
 * \note ˸ʱ䲢˸ĳλ˸غܿ
 * ˸ \sa zlg72128_digitron_flash_ctrl()
 */
int zlg72128_digitron_flash_time_cfg (zlg72128_handle_t  handle,
                                      uint16_t           on_ms,
                                      uint16_t           off_ms);

/**
 * \brief ƣ򿪻رգ˸ĬϾ˸
 *
 * \param[in] handle   : ZLG72128Ĳ
 * \param[in] ctrl_val : ֵλ0 ~ 11ֱӦҵܡֵΪ1ʱ˸
 *                       ֵΪ0ʱ˸
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_flash_ctrl (zlg72128_handle_t  handle,
                                  uint16_t           ctrl_val);

/**
 * \brief ܵʾԣʾرʾ
 *
 *    Ĭ£ܾڴʾ״̬򽫰12λɨ裬ʵУ
 * Ҫʾλ12λʱʹøúرĳЩλʾ
 *
 * \param[in] handle   : ZLG72128Ĳ
 * \param[in] ctrl_val : ֵλ0 ~ λ11ֱӦҵܡ
 *                       ֵΪ1رʾֵΪ0ʾ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 *
 * \note öΪϨ벻ͬöΪϨʱͬɨ裬ͬ
 * ҪÿɨʱӦĶ롣ʹøúرĳЩλʾǴӸϲ
 * ɨλ
 */
int zlg72128_digitron_disp_ctrl (zlg72128_handle_t  handle,
                                 uint16_t           ctrl_val);

/**
 * \brief ʾַ
 *
 *      ZLG72128Ѿṩ˳10ֺ21ĸֱʾҪʾֵ֧
 *  ͼΣֱʹ \sa zlg72128_digitron_dispbuf_set() ֱö롣
 *
 * \param[in] handle     : ZLG72128Ĳ
 * \param[in] pos        : ʾλãЧֵ 0 ~ 11
 * \param[in] ch         : ʾַַ֧ 0123456789AbCdEFGHiJLopqrtUychT
 *                         Լո(ʾ)
 * \param[in] is_dp_disp : ǷʾС
 *                        - ZLG72128_TRUE :ʾ
 *                        - ZLG72128_FALSE:ʾ
 * \param[in] is_flash   : λǷ˸
 *                        - ZLG72128_TRUE :˸
 *                        - ZLG72128_FALSE:˸
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_disp_char (zlg72128_handle_t  handle,
                                 uint8_t            pos,
                                 char               ch,
                                 bool_t             is_dp_disp,
                                 bool_t             is_flash);

/**
 * \brief ָλÿʼʾһַ
 *
 * \param[in] handle    : ZLG72128Ĳ
 * \param[in] start_pos : ַʼλ
 * \param[in] p_str     : ʾַ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 *
 * \note ֵַַ֧λʾ
 */
int zlg72128_digitron_disp_str (zlg72128_handle_t  handle,
                                uint8_t            start_pos,
                                const char        *p_str);

/**
 * \brief ʾ֣0 ~ 9
 *
 * \param[in] handle     : ZLG72128Ĳ
 * \param[in] pos        : ʾλãЧֵ 0 ~ 11
 * \param[in] num        : ʾ֣0 ~ 9
 * \param[in] is_dp_disp : ǷʾС
 *                        - ZLG72128_TRUE :ʾ
 *                        - ZLG72128_FALSE:ʾ
 * \param[in] is_flash   : λǷ˸
 *                        - ZLG72128_TRUE :˸
 *                        - ZLG72128_FALSE:˸
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_disp_num (zlg72128_handle_t  handle,
                                uint8_t            pos,
                                uint8_t            num,
                                bool_t             is_dp_disp,
                                bool_t             is_flash);

/**
 * \brief ֱʾݣ룩
 *
 *      ûҪʾһЩԶͼʱʹøúֱö롣һ
 *  ZLG72128Ѿṩ˳10ֺ21ĸֱʾûʹ
 *  ˺ֱö룬ֱʹ \sa ʾֻĸ
 *      ΪöλʾĶ룬һд
 *  ʾĶ롣
 *
 * \param[in] handle    : ZLG72128Ĳ
 * \param[in] start_pos : öʼλãЧֵ 0 ~ 11
 * \param[in] p_buf     : ŵĻ
 * \param[in] num       : õܶĸ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 *
 * \note  start_pos + num ֵ 12 Ļݱ
 */
int zlg72128_digitron_dispbuf_set (zlg72128_handle_t  handle,
                                   uint8_t            start_pos,
                                   uint8_t           *p_buf,
                                   uint8_t            num);

/**
 * \brief ֱӿƶεĵϨ
 *
 *   Ϊ˸Ŀʾṩֱӿĳһεԣ𣩡
 *
 * \param[in] handle : ZLG72128Ĳ
 * \param[in] pos    : ƶλЧֵ 0 ~ 11
 * \param[in] seg    : ΣЧֵ 0 ~ 7ֱӦa,b,c,d,e,f,g,dp
 *                     ʹк꣺
 *                       - ZLG72128_DIGITRON_SEG_A
 *                       - ZLG72128_DIGITRON_SEG_B
 *                       - ZLG72128_DIGITRON_SEG_C
 *                       - ZLG72128_DIGITRON_SEG_D
 *                       - ZLG72128_DIGITRON_SEG_E
 *                       - ZLG72128_DIGITRON_SEG_F
 *                       - ZLG72128_DIGITRON_SEG_G
 *                       - ZLG72128_DIGITRON_SEG_DP
 *
 * \param[in] is_on  : Ƿö
 *                    - ZLG72128_TRUE :
 *                    - ZLG72128_FALSE:Ϩ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_seg_ctrl (zlg72128_handle_t  handle,
                                uint8_t            pos,
                                char               seg,
                                bool_t             is_on);

/**
 * \brief ʾλ
 *
 *      ʹǰܵʾƻƣָǷѭƶѭ
 *   λλұ߿ճλƣ߿ճλƣʾκݡ
 *   ѭƶճλʾƳλݡ
 *
 * \param[in] handle    : ZLG72128Ĳ
 * \param[in] dir       : λ
 *                       - ZLG72128_DIGITRON_SHIFT_LEFT   
 *                       - ZLG72128_DIGITRON_SHIFT_RIGHT  
 * \param[in] is_cyclic : Ƿѭλ
 *                       - ZLG72128_TRUE :ѭλ
 *                       - ZLG72128_FALSE:ѭλ
 * \param[in] num       : λλЧֵ 0ƶ ~ 11ֵЧ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 *
 * \note λ˵
 *
 *   ʵУܻᷢλ෴ڿܴӲƣ
 *   1 ұΪ0ܣΪ111098765432 1 0
 *   2 Ϊ0ܣΪ 0 1234567891011
 *   ҪȡӲʱ COM0 ~ COM11 Ӧλá
 *
 *       ˴ƺƵĸԡֲᡷеӦõ·Ϊοģұ
 *   Ϊ0ܡôƺƵĸֱΪ
 *   ƣ0ʾл11ʾл210ʾл11
 *   ƣ11ʾл101ʾл210ʾл11
 *
 *   ɼӲ·λ෴ģλЧҲǡǡ෴ģ˴
 * ֻҪ΢ע⼴ɡ
 */
int zlg72128_digitron_shift (zlg72128_handle_t  handle,
                             uint8_t            dir,
                             bool_t             is_cyclic,
                             uint8_t            num);

/**
 * \brief ɨλɨλ
 *
 * \param[in] handle : ZLG72128Ĳ
 * \param[in] num    : ʾλ(ЧֵΪ0~12)
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_scan_set (zlg72128_handle_t  handle,
                                uint8_t            num);
/**
 * \brief λܵLEDϨ
 *
 * \param[in] handle : ZLG72128Ĳ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_disp_reset (zlg72128_handle_t handle);

/**
 * \brief LED0.5S˸ڲʾǷ
 *
 * \param[in] handle : ZLG72128Ĳ
 *
 * \retval -2     : 
 * \retval  0     : ִгɹ
 * \retval ֵ : I2Cдʧ
 */
int zlg72128_digitron_disp_test (zlg72128_handle_t handle);

/**
 * \brief ZLG72128ʼ
 *
 *  ʹָZLG72128豸ʱʹøúʼ豸ͷԴ
 *
 * \param[in] handle : ZLG72128Ĳ
 *
 * \retval -2     : 
 * \retval ֵ : ƽ̨ʼʧ
 */
int zlg72128_deinit(zlg72128_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __ZLG72128_H */

/* end of file */
