/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2019 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG72128ƽ̨ļ
 *
 *  Ӧʵƽ̨޸Ƹļ͡ͺĶ塣
 *
 * \internal
 * \par Modification History
 * - 1.00 19-4-22  xgg, first implementation.
 * \endinternal
 */

#ifndef __ZLG72128_PLATFORM_H
#define __ZLG72128_PLATFORM_H

#ifdef __cplusplus
extern "C" {
#endif  /* __cplusplus  */

#include "ametal.h"
#include "am_wait.h"
#include "am_delay.h"
#include "am_gpio.h"
#include "am_i2c.h"
#include "am_types.h"

/**
 * \name Ͷ
 *
 * Ӧʵƽ̨Щ͵Ķ塣ƽ̨ѾЩ͵Ķ壬ֱӰ
 * ͵ͷļɾ͵Ķ塣
 *
 * @{
 */
typedef unsigned char  bool_t;

/** @} */

/**
 * \name 
 * @{
 */

/** \brief NULL  */
#ifndef NULL
#define NULL ((void *)0)
#endif

/** @} */

/**
 * \name ߺ
 * @{
 */

/**
 * \brief ms ʱ
 * \param[in] ms : ʱʱ䣨λms
 * \return 
 */
void zlg72128_plfm_delay_ms (uint32_t ms);

/** @} */


/**
 * \brief ZLG72128 ƽ̨صĳʼϢ
 *
 * ڳʼZLG72128ʱҪһЩƽ̨صϢϢI2CϢ
 *
 * ڲͬƽ̨УŵϢıʾܲͬӦͿܲͬ
 *
 * ͵ģԶΪһṹͣаƽ̨صϢ磬ϵͳʹ
 * int͵IDʾI2C߱ţint͵ֵʾűţͿԶΪ
 *
 * typedef struct {
 *     int  pin_rst;       // RST ű
 *     int  i2c_id;        // I2C߱
 * } zlg72128_plfm_init_info_t;
 *
 * ȫƽ̨߶壬ûڸƽ̨ʹZLG72128ʱҪݵ
 * һЩƽ̨صĻϢ
 *
 * ڵƽ̨ʼ zlg72128_plfm_init() ʱԭⲻĽƽ̨صĳ
 * ʼϢݸƽ̨ʼ
 *
 * гԱĸֵʹãƽ̨غZLG72128е
 * Աκβ
 *
 * ƽ̨ʹøͣĬΪ void * ͡
 */
typedef struct {

    /* 豸ӻַ*/
    uint8_t    slv_addr;

    /** \brief λ */
    int        rst_pin;

    /**
     * \brief ǷʹжţΪʡһIOԴɲʹжϷʽ
     * AM_TRUE  : ʹж(int_pin ָź)жлȡֵ
     * AM_FALSE : һʱinterval_msָѯֵ
     */
    am_bool_t  use_int_pin;

    /** \brief ж */
    int        int_pin;

    /** \brief  use_int_pin Ϊ FALSE ʱòЧָѯʱ */
    uint32_t   interval_ms;

    /** \brief I2Cȡ*/
    am_i2c_handle_t (*pfn_i2c_handle_get) (void);

    /** \brief I2Cʼ*/
    void (*pfn_i2c_deinit) (am_i2c_handle_t i2c_handle);

}zlg72128_plfm_init_info_t;

/**
 * \brief ƽ̨
 *
 * ͵ľ嶨ƽ̨أ͵ģԶΪһṹͣаһЩ
 * ԱԱƽ̨Ҫ״̬
 *
 * 磬I2C첽ܷΪ׶ɣԶһ state ԱԱI2C
 * 첽䵱ǰ״̬:
 *
 * typedef struct {
 *     int state;
 * } zlg72128_plfm_t;
 *
 * ZLG72128豸͵ĶУһ͵ĳԱڵƽ̨غʱ
 * óԱĵַΪһݡ
 *
 * ƽ̨ʹøͣĬΪ void * ͡
 *
 * гԱĸֵʹãƽ̨غZLG72128е
 * Աκβͨ£еĳԱӦ zlg72128_plfm_init()гʼ
 * ƽ̨ʹá
 */
typedef struct {

    /* */
    uint8_t            r_buff[4];

    /* ʱ */
    am_softimer_t      timer;

    /* дʱҪI2C豸*/
    am_i2c_device_t    i2c_dev;

    /* I2CʱҪĴṹ*/
    am_i2c_transfer_t  trans[4];

    /* ڴI2CϢ*/
    am_i2c_message_t   msg;

    /* I2C׼handle */
    am_i2c_handle_t    i2c_handle;

    /* ֵѯ*/
    void              *p_key_arg;

    /* ֵѯ*/
    void  (*pfn_keyval_report) (void *, uint8_t reg0_3[4]);

    /* ڱ豸Ϣָ */
    const zlg72128_plfm_init_info_t  *p_devinfo;

}zlg72128_plfm_t;

/**
 * \brief ƽ̨ʼú zlg72128_init()Уȵ
 *
 * ƽ̨صĳʼ磬ʼšжϵ
 *
 * \param[in] p_plfm            : ƽ̨ṹ
 * \param[in] p_plfm_init_info  : ƽ̨ҪûṩһЩʼϢ
 * \param[in] pfn_keyval_report : ƽ̨ҪŻõġֵϱ
 * \param[in] p_key_arg         : ƽ̨ڵáֵϱʱݸһֵ
 *
 * \retval 0   : ʼɹ
 * \retval 0 : ʼʧ
 *
 * \note  pfn_keyval_report  p_key_arg Ľһ˵
 *
 *  pfn_keyval_report()ƽ̨ϱݣƽ̨ѡʵʱϱ
 *  Ĵ0x01 ~ 0x03 3Ĵеĵǰֵȡϱɣκζ
 *  ļʹƽ̨ʱ3Ĵľ庬壩ʽ£
 *
 *       uint8_t reg1_3[4];
 *       // ȡ Ĵ1 ~ Ĵ3 3Ĵֵ reg1_3 С
 *       pfn_keyval_report(p_key_arg, reg0_3);
 *
 *  ֮ƽֱ̨ϱֵI2CҪԭ
 *
 *  1. ҪȡļĴַ0x01 ~ 0x03ǹ̶ģҪȡַ
 *     ġͬƽ̨ŻŻ
 *
 *  2. ڲͬƽ̨УȡЩݵʱܲͬ磺
 *
 *     - ƽ̨
 *           1. KEY_INTжֱӻȡ
 *           2. KEY_INTһ־Ȼѭв鿴ñ־
 *           3. ʹKEY_INTţֱѭѯ
 *           4. ʹKEY_INTţʹһʱѯ

 *    - вϵͳƽ̨
 *           1. KEY_INTжֱӻȡ
 *           2. KEY_INTжͷһźȻһȡź
 *           3. ʹKEY_INTţֱһѯ
 *           4. ʹKEY_INTţʹһʱѯ
 *
 *     ڲͬĵʱI2CȡҪҲܲͬ磬жжȡ
 *  I2Cȡ4Ҫmsʱ䣬ˣжеȴI2Cݴɣ
 *  ἫӰϵͳʵʱԡڴˣI2CʱҪ첽ķʽԱж
 *  Ծ磬KEY_INTжֻI2CжϣȻж֪ͨI2CӲ
 *  ȡreg0ϵͳĴֵЧһȥȡreg1 ~ reg3֤ϵͳʵʱԣ
 *  ѭͨжȡͬȡI2Cȡռõʱ䲢Ӱϵͳʵʱԡ
 *
 *  ϣֱϱֵķʽΪƽ̨ԣԵʱI2C
 *  ݵķʽͬ첽ûκƣƽ̨ԸҪѡʵķʽ
 */
int zlg72128_plfm_init (zlg72128_plfm_t                  *p_plfm,
                        const zlg72128_plfm_init_info_t  *p_plfm_init_info,
                        void  (*pfn_keyval_report)  (void *, uint8_t reg1_3[3]),
                        void                             *p_key_arg);

/**
 * \brief ƽ̨ʼ
 *
 * ͷƽ̨صԴ粿ƽ̨ҪͷšرжϡɾŻص
 * ͷi2cصԴ
 * ûƽ̨ҪͷκԴڲԲκβ
 *
 * \param[in] p_plfm : ƽ̨ṹڱһЩҪ״̬
 *
 * \retval 0   : ʼɹ
 * \retval 0 : ʼʧ
 */
int zlg72128_plfm_deinit (zlg72128_plfm_t *p_plfm);

/**
 * \brief I2Cд
 *
 * ָеĳһĴʼдָֽݣúҪ
 * ZLG72128ʾ
 *
 * \param[in] p_plfm    : ƽ̨ṹ
 * \param[in] sub_addr  : Ĵַ
 * \param[in] p_buf     : ݻ
 * \param[in] nbytes    : һζдֽ
 *
 * \retval 0   : дɹ
 * \retval 0 : дʧܣֵԭⲻķظϲӦã
 */
int zlg72128_plfm_i2c_write(zlg72128_plfm_t *p_plfm,
                            uint8_t          sub_addr,
                            uint8_t         *p_buf,
                            uint8_t          nbytes);
/**
 * @}
 */

#ifdef __cplusplus
}
#endif    /* __cplusplus */

#endif /* __ZLG72128_PLATFORM_H */

