#ifndef __ZSN603_PLATFORM_H
#define __ZSN603_PLATFORM_H
#include "am_wait.h"
#include "am_uart.h"
#include "am_uart_rngbuf.h"
#include "am_i2c.h"
typedef  unsigned char   uint8_t;
typedef  unsigned short  uint16_t;
//typedef  unsigned int    uint32_t;

/**************************************************************
 * UARTģʽͨƽ̨ؽṹ
 **************************************************************/
/** \brief zsn603 ƽ̨ʼжϻصṹ
 *   ע⣬ûʹв޸Ĵ˽ṹ
 *  úṹڴƽ̨ʼýṹ2ԱԱǺָ
 *
 * zsn603_uart_rx ΪڽպûΪڽպصڴڽжֱӵ
 *   úһΪûԶĲòΪڳʼp_argûֱӽдݼɡ
 *   úڶΪڽյݡ
 * zsn603_int_pin_cb ΪжŻصûΪжϻصжϺֱӵøúɡ
 *   Ҫֵעǣڴģʽ£ֻнԶģʽжϲǲŻжϣΪ½ж
 *   ˺ֻһΪƽ̨ʼдݵp_argûֱӽдݼɡ
 */
typedef struct zsn603_uart_funcs {
    /** \brief ڽݻص*/
    void (*zsn603_uart_rx)    (void *p_arg, char data);
    /** \brief жŻص*/
    void (*zsn603_int_pin_cb) (void *p_arg);
}zsn603_uart_funcs_t;


/** \brief ûUARTͨģʽ ƽ̨豸Ϣṹ嶨
 *   ýṹΪûʼUARTͨģʽʱҪõĲ
 *   ýṹUARTͨģʽƽ̨ʼ(line186)неãΪUARTʼʹ
 *   ýṹпԱʼUARTõϢӲ豸šʼʡСϢ
 *
 *   ȻûҲԲԸýṹ䣬ֱӽýṹĶעͼɡ
 *   ƵĿûʹֱ޸ĸýṹĲUARTͨԵ޸ġ
 */
typedef struct am_zsn603_platform_uart_devinfo{
    int8_t                 rst_pin;
    uint8_t                int_pin;
    am_uart_handle_t     (*pfn_handle_get)(void);
    void                 (*pfn_handle_deinit)(am_uart_handle_t);
    uint32_t               baud_rate;
}am_zsn603_platform_uart_devinfo_t;


/** \brief ûUARTͨģʽ ƽ̨豸ؽṹ嶨
 *   ýṹΪûƽ̨ʵUARTģʽͨʱҪĳԱ
 *   ڽշͻȡ
 *
 *   ýṹͬʱΪûUARTƽ̨ʼ(line-183)Լ亯(line-168)ĵһ
 *
 *   ûԶýṹԼṹгԱ͡
 *
 *   ȻûҲԲԸýṹ(ṹ嶨עͼ)
 *   Ƽʹô˷ʽ,ʹַʽʵָõĶUARTͨ豸йͬʱҲڿƽ̨á
 */
typedef struct am_zsn603_platform_uart_dev{
    am_uart_handle_t                          handle;
    const am_zsn603_platform_uart_devinfo_t  *p_devinfo;
}am_zsn603_platform_uart_dev_t;


/**\brief ûƽ̨豸Ϣṹͱ
 *  ûвҪʹƽ̨豸Ϣṹ䣬Զƽ̨豸¶
 *   typedef  void *  zsn603_platform_uart_devinfo_t;
 *  Ҳǽƽ̨豸ͶΪ(void *)ͼɡ
 */
typedef  am_zsn603_platform_uart_dev_t        zsn603_platform_uart_t;

/**\brief ûƽ̨豸ṹͱ
 *  ûвҪʹƽ̨豸ṹ䣬Զƽ̨豸¶
 *   typedef  void *   zsn603_platform_uart_t;
 *  ƽ̨豸ͶΪ(void *)ͼɡ
 */
typedef  am_zsn603_platform_uart_devinfo_t    zsn603_platform_uart_devinfo_t;


/**************************************************************
 * I2Cģʽͨƽ̨ؽṹ
 **************************************************************/
/** \brief ûI2Cͨģʽ ƽ̨豸Ϣṹ嶨
 *   ýṹΪûʼI2CͨģʽʱҪõĲ
 *   ýṹI2Cƽ̨ʼ(line-241)неãΪI2Cʼݡ
 *   ýṹпԱʼI2CõϢӲI2C豸šʼӻַжŵȡ
 *
 *   ȻûҲԲԸýṹ(ע͸ýṹ嶨弴)ֱڳʼнûʹõI2Cߵĳʼ
 */
typedef struct am_zsn603_platform_i2c_devinfo{
    int8_t                 rst_pin;
    uint8_t                int_pin;
    am_i2c_handle_t      (*pfn_handle_get)(void);
    void                 (*pfn_handle_deinit)(am_i2c_handle_t);
}am_zsn603_platform_i2c_devinfo_t;


/** \brief ûI2Cͨģʽ ƽ̨豸ؽṹ嶨
 *   ýṹΪûƽ̨ʵI2CģʽͨʱҪĳԱ
 *   I2Cĵǰʵȡ
 *   ýṹͬʱΪûI2Cƽ̨ʼ(line254)Լд(line217line236)ĵһ,
 *   ûԶýṹԼṹԱ
 *
 *   ȻûҲԲԸýṹ,ֱע͸ýṹ嶨弴ɡ
 */
typedef struct am_zsn603_platform_i2c_dev{
    am_i2c_handle_t                          handle;
    const am_zsn603_platform_i2c_devinfo_t  *p_devinfo;
}am_zsn603_platform_i2c_dev_t;


/**\brief ûƽ̨豸Ϣṹͱ
 *
 *  ûСҪʹƽ̨豸Ϣṹ䣬Զƽ̨豸¶:
 *        typedef  void *  zsn603_platform_i2c_devinfo_t;
 *  Ҳǽƽ̨豸ͶΪ(void *)ͼɡ
 */
typedef    am_zsn603_platform_i2c_dev_t        zsn603_platform_i2c_t;

/**\brief ûƽ̨豸ṹͱ
 *  ûСҪʹƽ̨豸ṹ䣬Զƽ̨豸¶
 *   typedef  void * zsn603_platform_i2c_t;
 *  ƽ̨豸ͶΪ(void *)͡
 */
typedef    am_zsn603_platform_i2c_devinfo_t    zsn603_platform_i2c_devinfo_t;


/******************************************************************************
 *   ZSN603ͨҪûһЩڶźĺ궨
 *   Щ궨I2Cģʽ  ȡжźŲԱȡӦ֡ϢҪûʹƽ̨
 ******************************************************************************/
/*
 * \brief źȡɹʶ
 */
#define ZSN603_SEMB_TAKE_SUCCESS          0
/*
 * \brief źȡʱʶ
 */
#define ZSN603_SEMB_TAKE_TIMEOUT          1

/*
 * \brief ź(жϱ־)
 *    ZSN603豸ṹнʹãȡжź
 */
#define ZSN603_SEMB_DECL(semb)            am_wait_t semb

/*
 * \brief ź(жϱ־)ȡ
 *    ZSN603豸ʼнеãʾź(жϱ־)
 */
#define ZSN603_SEMB_INIT(semb)            am_wait_init(&semb)

/*
 * \brief ź(жϱ־)ȡ
 *  ָʱʱtimeoutڻȡź(жϱ־)I2C֮֡󣬵ȴ֡ɡ
 *  £ӻղִ֡ɹָʱʱڣжϻصͷŸź(жϱ־)
 *    (1)ȡɹ򷵻  ZSN603_SEMB_TAKE_SUCCESS
 *    (2)ȡʱ򷵻  ZSN603_SEMB_TAKE_TIMEOUT
 */
#define ZSN603_SEMB_TAKE(semb, timeout)   am_wait_on_timeout(&semb, timeout)

/*
 * \brief ź(жϱ־)ͷ
 *   ⲿжŻصеãͷ֡ϺĵȴĶź(жϱ־)
 */
#define ZSN603_SEMB_GIVE(semb)            am_wait_done(&semb)

/*
 * \brief ź(жϱ־)ӳʼ
 *   ڶźڴͷ,û޴˹ֱӺԴ˺궨伴
 */
#define ZSN603_SEMB_DEINIT(sem)

/******************************************************************************
 *   ZSN603ͨҪûĴϢ
 *   ЩʹZSN603ĴģʽʱãI2CģʽغԲҪ
 ******************************************************************************/
/* \brief
 *  ûԼƽ̨,ʵֹΪ:
 *           ʹôڷ  p_dataеnbytes
 *
 * \param[in] p_dev           : ZSN603ƽ̨豸(UARTģʽ)
 * \param[in] p_data          : ͨ跢ݵĵַ
 * \param[in] nbytes          : ͵ֽ
 * \retval     ֵҪע
 *                  (1)ȫͳɹ򷵻 0
 *                  (2)ʧܻ߷ֽСnbytesʱ򷵻0ֵ,
 *                     ÷ִֵʧܵʱзأûԶغ꣬ʾͨش
 */
int zsn603_platform_uart_tx(zsn603_platform_uart_t *p_dev,
                            uint8_t                *p_data,
                            uint32_t                nbytes);


/* \brief ZSN603ƽ̨豸(UARTģʽ)ʼ
 *  úzsn603_uart_init()неá
 *  ûԼƽ̨,úڿɽUARTͨųʼڹʱڴԼûԶӵĳʼ
 * \param[in] p_dev       : ZSN603ƽ̨豸(UARTģʽ)
 * \param[in] p_info      : ZSN603ƽ̨豸Ϣ(UARTģʽ)
 * \param[in] p_funcs     : ZSN603ҪûжԼжеõĻص
 *                            Line-9
 * \param[in] p_arg       : ZSN603ҪûжԼжеõĻص
 * \retval     ʼɹ,ֱӷ 0 ɣʼɹֵɡ
 */
uint8_t  zsn603_platform_uart_init(zsn603_platform_uart_t                *p_dev,
                                   const zsn603_platform_uart_devinfo_t  *p_info,
                                   zsn603_uart_funcs_t                   *p_funcs,
                                   void                                  *p_arg);


/* \brief ZSN603ƽ̨豸(UARTģʽ)ʼ
 *  ûԼʹõƽ̨,ʹZSN603豸,ƽ̨豸ʼнгʼ豸ڴ˺
 *  ннʼ,Ҳڴ˺ɶZSN603ƽ̨豸ڴͷŵȹ
 *
 * \param[in] p_dev  : ZSN603ƽ̨豸(UARTģʽ)
 * \retval     ʼɹ,ֱӷ0ɣʼɹֵɡ
 */
uint8_t  zsn603_platform_uart_deinit(zsn603_platform_uart_t  *p_dev);


/******************************************************************************
 *   ZSN603ͨҪûĴϢ
 *   ЩʹZSN603ĴģʽʱãI2CģʽغԲҪ
 ******************************************************************************/
/* \brief I2Cд
 *
 *  ûԼƽ̨,ʵֹΪ:
 *           ӻַΪslv_addrӵַΪsub_addr(2ֽ)豸дp_dataڵnbytes
 *
 * \param[in] p_dev           : ZSN603ƽ̨豸(I2Cģʽ)
 * \param[in] slv_addr        : ӻַ(7λЧ)
 * \param[in] sub_addr        : ӵַ(2ֽ)
 * \param[in] p_data          : дݵĵַ
 * \param[in] nbytes          : Ҫдֽ
 * \retval     ֵҪע
 *                (1)I2Cдɹ  0
 *                (2)I2Cдʧ 򷵻0ֵ,÷ִֵʧܵʱзأûԶغ꣬ʾI2Cͨش
 */
int zsn603_platform_i2c_write(zsn603_platform_i2c_t *p_dev,
                              uint8_t                slv_addr,
                              uint16_t               sub_addr,
                              uint8_t               *p_data,
                              uint32_t               nbytes);


/* \brief I2C߶
 *
 *  ûԼƽ̨,ʵֹΪ:
 *           ӴӻַΪslv_addrӵַΪsub_addr(2ֽ)豸nbytesݴp_data
 * \param[in] p_dev           : ZSN603ƽ̨豸(I2Cģʽ)
 * \param[in] slv_addr        : ӻַ(7λЧ)
 * \param[in] sub_addr        : ӵַ(2ֽ)
 * \param[in] p_data          : i2cȡݵʼַ
 * \param[in] nbytes          : Ҫȡֽ
 * \retval     ֵҪע
 *               (1)IICɹ  0
 *               (2)IICʧ 򷵻0ֵ,÷ִֵʧܵʱзأûԶغ꣬ʾͨش
 */
int zsn603_platform_i2c_read(zsn603_platform_i2c_t  *p_dev,
                             uint8_t                 slv_addr,
                             uint16_t                sub_addr,
                             uint8_t                *p_data,
                             uint32_t                nbytes);


/* \brief ZSN603ƽ̨豸(I2Cģʽ)ʼ
 *  úzsn603_i2c_init()неá
 *    ûԼƽ̨,úڿɽI2CͨųʼҪڴ롢жųʼԼûԶӵĳʼ
 *    Ҫֵע : Ϊһָ룬ָжŵĻصжΪ½شûøúΪжϻصжϺеøú
 *               úΪ,ZSN603ִ֮ܵ֡Ӧ֮󣬻һ½أ֪ͨͨI2CִϣԽлӦ֡ȡ
 *               ĸΪָĲ,òΪ(void *)ͣûĸòֻҪ䴫ݸĺָ뼴
 * \param[in] p_dev                      : ZSN603ƽ̨豸(I2Cģʽ)
 * \param[in] p_info                     : ZSN603ƽ̨豸Ϣ(I2Cģʽ)
 * \param[in] int_pin_callback_function  : жŻص
 * \param[in] p_arg                      : ص
 * \retval     ʼɹ,ֱӷ0ɣʼɹֵɡ
 */
uint8_t  zsn603_platform_i2c_init(zsn603_platform_i2c_t                *p_dev,
                                  const zsn603_platform_i2c_devinfo_t  *p_info,
                                  void(*int_pin_callback_function)     (void *),
                                  void                                 *p_arg);


/* \brief ZSN603ƽ̨豸(I2Cģʽ)ʼ
 *  ú
 *    ûԼʹõƽ̨,ʹZSN603豸,ƽ̨豸ʼнгʼ豸ڴ˺
 *    ннʼ,Ҳڴ˺ɶZSN603ƽ̨豸ڴͷŵȹ
 *
 * \param[in] p_dev  : ZSN603ƽ̨豸(I2Cģʽ)
 * \retval     ʼɹ,ֱӷ0ɣʼɹֵɡ
 */
uint8_t  zsn603_platform_i2c_deinit(zsn603_platform_i2c_t    *p_dev);
#endif
