/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ARM LIB 
 *
 * \internal
 * \par Modification History
 * - 1.00 17-08-23  pea, first implementation.
 * \endinternal
 */

#ifndef __MICROLIB

/** \brief ֹʹðģʽ */
#pragma import(__use_no_semihosting)

/** \brief ʹheap2 */
#pragma import(__use_realtime_heap)

/*******************************************************************************
  ͷļ
*******************************************************************************/
#include "ametal.h"
#include "am_mem.h"
#include "am_armlib_adapter.h"
#include <stdio.h>
#include <errno.h>
#include <rt_sys.h>
#include <rt_locale.h>
#include <rt_misc.h>
#include <time.h>

/*******************************************************************************
  ȫֱ
*******************************************************************************/

/** \brief ARM LIBṹ */
typedef struct am_armlib_adapter {
    const am_armlib_adapter_ops_t *p_ops; /** < \brief  */
    void                          *p_arg; /** < \brief  */
} am_armlib_adapter_t;

/*******************************************************************************
  ȫֱ
*******************************************************************************/

static am_armlib_adapter_t __g_adapter; /**< \brief ARM LIB */

const char __stdin_name[]  = ":tt";     /**< \brief stdinļ */
const char __stdout_name[] = ":tt";     /**< \brief stdoutļ */
const char __stderr_name[] = ":tt";     /**< \brief stderrļ */

/*******************************************************************************
  غ
*******************************************************************************/

/** 
 * \brief һַ
 *
 * \param[in] ch       Ҫַ
 * \param[in] p_stream ָFILEָ
 *
 * \return ûз󣬷رַ򷵻EOF
 */
int fputc (int ch, FILE *p_stream) 
{
    if ((p_stream->handle >= 0) && (p_stream->handle < 3)) {
        if(__g_adapter.p_ops && __g_adapter.p_ops->pfn_putc) {
            return __g_adapter.p_ops->pfn_putc(__g_adapter.p_arg, (char)ch);
        }
    }

    return EOF;
}

/** 
 * \brief һַ
 *
 * \param[in] p_stream ָFILEָ
 *
 * \return ûз󣬷ַ򷵻EOF
 */
int fgetc (FILE *p_stream)
{        
    if ((p_stream->handle >= 0) && (p_stream->handle < 3)) {
        if (__g_adapter.p_ops && __g_adapter.p_ops->pfn_getc) {
            return __g_adapter.p_ops->pfn_getc(__g_adapter.p_arg);
        }
    }
        
    return EOF;
};

/** 
 * \brief ϴζȡַصFILE
 *
 * \param[in] p_stream ָFILEָ
 *
 * \retval 0   ɹ
 * \retval EOF ʧ
 */
int __backspace (FILE *p_stream)
{
    return EOF;
}

/** 
 * \brief ARM LIB˳ɷ
 *
 * \param[in] return_code øúķֵ
 *
 * \return 
 */
void _sys_exit (int return_code)
{
    AM_FOREVER;
}

/** 
 * \brief ʧܴ
 *
 * \param[in] p_expr ʽ
 * \param[in] p_file ļ
 * \param[in] line   к
 *
 * \return 
 */
void __aeabi_assert (const char *p_expr, const char *p_file, int line)
{
    printf("*** assertion failed: %s, %s, %d\r\n", p_expr, p_file, line);

    abort();
}

/** 
 * \brief ļ
 *
 * \param[in] p_name   ļ
 * \param[in] openmode ģʽ
 *
 * \return ɹļʧܷ-1
 */
FILEHANDLE _sys_open (const char *p_name, int openmode)
{
    return 1;
}

/** 
 * \brief رļ
 *
 * \param[in] fh ļ
 *
 * \return ɹ0ʧܷظֵ
 */
int _sys_close (FILEHANDLE fh)
{
    return -1;
}

/** 
 * \brief дļ
 *
 * \param[in] fh    ļ
 * \param[in] p_buf ַ
 * \param[in] len   дֽ
 * \param[in] mode  ģʽ(Ϊʷԭ)
 *
 * \return ɹ0ʧܷظֵҴСΪдʧֽܵ
 */
int _sys_write (FILEHANDLE           fh, 
                const unsigned char *p_buf,
                unsigned             len, 
                int                  mode)
{
    return -1;
}

/** 
 * \brief ļ
 *
 * \param[in]  fh    ļ
 * \param[out] p_buf ַ
 * \param[in]  len   дֽ
 * \param[in]  mode  ģʽ(Ϊʷԭ)
 *
 * \return ɹ0ȡļĩβʱEOF
 *         ֻɹȡʱδȡֽ
 *         ļĩβʼȡֻɹȡʱδȡֽҽλλ
 *         ʧܷ-1
 */
int _sys_read (FILEHANDLE     fh, 
               unsigned char *p_buf,
               unsigned       len, 
               int            mode)
{
    return -1;
}

/** 
 * \brief նһַ
 *
 * \param[in] ch ַ
 *
 * \return 
 */
void _ttywrch (int ch)
{
    fputc(ch, stdout);
}

/** 
 * \brief жһļǷΪն
 *
 * \param[in] fh ļ
 *
 * \return ն˷ط0ն˷0
 */
int _sys_istty (FILEHANDLE fh)
{
    return 0;
}

/** 
 * \brief ƶļָ
 *
 * \param[in] fh  ļ
 * \param[in] pos ƶλ(0ַƫ)
 *
 * \return ɹ>=0, ʧܷ<0
 */
int _sys_seek (FILEHANDLE fh, long pos)
{
    return -1;
}

/** 
 * \brief Flush
 *
 * \param[in] fh ļ
 *
 * \return ɹ>=0, ʧܷ<0
 */
int _sys_ensure(FILEHANDLE fh)
{
    return -1;
}

/** 
 * \brief ļ
 *
 * \param[in] fh ļ
 *
 * \return ɹļ, ʧܷ<0
 */
long _sys_flen (FILEHANDLE fh)
{
    return -1;
}

/** 
 * \brief ȡʱ
 *
 * \param 
 *
 * \return ʱ
 */
clock_t clock (void)
{
    return (clock_t)-1;
}

/** 
 * \brief ʱӳʼ
 */
void _clock_init (void)
{
    /* VOID */
}

/**
 * \brief һڴռ䣨ڴռᱻʼΪ0
 *
 * \param[in] nmemb Ԫظ
 * \param[in] size  һԪصĴСڴռĴСΪ nmemb * size
 *
 * \return ռ׵ַNULLʧ
 *
 * \note ڴռᱻʼΪ0
 */
void *calloc (size_t nmemb, size_t size)
{
    return am_mem_calloc(nmemb, size);
}

/**
 * \brief ͷѷڴռ
 *
 * \param[in] ptr ѷڴռ׵ַ
 *
 * \return 
 */
void free (void *ptr)
{
    am_mem_free(ptr);
}

/**
 * \brief һڴռ
 *
 * \param[in] size ռĴС
 *
 * \return ռ׵ַNULLʧ
 */
void *malloc (size_t size)
{
    return am_mem_alloc(size);
}

/**
 * \brief ̬ڴıѷռĴС
 *
 * \param[in] ptr  ѷռ׵ַ
 * \param[in] size ·ĿռĴС
 *
 * \return ·ռ׵ַNULLʧ
 *
 * \note жϵǰָǷ㹻ռ䣬У ptr ַָ
 * ռ䣬ֱӽptrֵءռ䲻ȰsizeָĴСռ䣬
 * ԭݴͷβ·ڴ򣬶ͷԭptrָڴԭ
 * ָԶͷţҪ am_memheap_free()ͬʱ·ڴ׵ַ
 */
void *realloc (void *ptr, size_t size)
{
    return am_mem_realloc(ptr, size);
}

/*******************************************************************************
  ⲿ
*******************************************************************************/

/**
 * \brief ʼ
 *
 * \param[in] p_ops 
 * \param[in] p_arg 
 *
 * \return AM_OK
 */
int am_armlib_adapter_init (const am_armlib_adapter_ops_t *p_ops,
                            void                          *p_arg)
{
    __g_adapter.p_ops = p_ops;
    __g_adapter.p_arg = p_arg;

    return AM_OK;
}

#endif /* __MICROLIB */

/* end of file */
