/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Micro LIB 
 *
 * \internal
 * \par Modification History
 * - 1.00 17-08-17  pea, first implementation.
 * \endinternal
 */
 
#ifdef __MICROLIB

/** \brief ֹʹðģʽ */
#pragma import(__use_no_semihosting)

/*******************************************************************************
  ͷļ
*******************************************************************************/
#include "ametal.h"
#include "am_mem.h"
#include "am_microlib_adapter.h"
#include <stdio.h>
#include <errno.h>

/*******************************************************************************
  ȫֱ
*******************************************************************************/

/** \brief Micro LIBṹ */
typedef struct am_microlib_adapter {
    const am_microlib_adapter_ops_t *p_ops; /** < \brief  */
    void                            *p_arg; /** < \brief  */
} am_microlib_adapter_t;

/*******************************************************************************
  ȫֱ
*******************************************************************************/

/** \brief Micro LIB */
static am_microlib_adapter_t __g_adapter;

#ifdef __MICROLIB

/** \brief ׼ļ */
FILE __stdin  = {0};

/** \brief ׼ļ */
FILE __stdout = {1};

/** \brief ׼ļ */
FILE __stderr = {2};

#endif /* __MICROLIB */

/*******************************************************************************
  غ
*******************************************************************************/

/** 
 * \brief һַ
 *
 * \param[in] ch       Ҫַ
 * \param[in] p_stream ָFILEָ
 *
 * \return ûз󣬷رַ򷵻EOF
 */
int fputc (int ch, FILE *p_stream) 
{
    if ((p_stream->handle >= 0) && (p_stream->handle < 3)) {
        if(__g_adapter.p_ops && __g_adapter.p_ops->pfn_putc) {
            return __g_adapter.p_ops->pfn_putc(__g_adapter.p_arg, (char)ch);
        }
    }

    return EOF;
}

/** 
 * \brief һַ
 *
 * \param[in] p_stream ָFILEָ
 *
 * \return ûз󣬷ַ򷵻EOF
 */
int fgetc (FILE *p_stream)
{        
    if ((p_stream->handle >= 0) && (p_stream->handle < 3)) {
        if (__g_adapter.p_ops && __g_adapter.p_ops->pfn_getc) {
            return __g_adapter.p_ops->pfn_getc(__g_adapter.p_arg);
        }
    }
        
    return EOF;
};

/** 
 * \brief ϴζȡַصFILE
 *
 * \param[in] p_stream ָFILEָ
 *
 * \retval 0   ɹ
 * \retval EOF ʧ
 */
int __backspace (FILE *p_stream)
{
    return EOF;
}

/** 
 * \brief ʧܴ
 *
 * \param[in] p_expr ʽ
 * \param[in] p_file ļ
 * \param[in] line   к
 *
 * \return 
 */
void __aeabi_assert (const char *p_expr, const char *p_file, int line)
{
    printf("*** assertion failed: %s, %s, %d\r\n", p_expr, p_file, line);

    abort();
}

/**
 * \brief һڴռ䣨ڴռᱻʼΪ0
 *
 * \param[in] nmemb Ԫظ
 * \param[in] size  һԪصĴСڴռĴСΪ nmemb * size
 *
 * \return ռ׵ַNULLʧ
 *
 * \note ڴռᱻʼΪ0
 */
void *calloc (size_t nmemb, size_t size)
{
    return am_mem_calloc(nmemb, size);
}

/**
 * \brief ͷѷڴռ
 *
 * \param[in] ptr ѷڴռ׵ַ
 *
 * \return 
 */
void free (void *ptr)
{
    am_mem_free(ptr);
}

/**
 * \brief һڴռ
 *
 * \param[in] size ռĴС
 *
 * \return ռ׵ַNULLʧ
 */
void *malloc (size_t size)
{
    return am_mem_alloc(size);
}

/**
 * \brief ̬ڴıѷռĴС
 *
 * \param[in] ptr  ѷռ׵ַ
 * \param[in] size ·ĿռĴС
 *
 * \return ·ռ׵ַNULLʧ
 *
 * \note жϵǰָǷ㹻ռ䣬У ptr ַָ
 * ռ䣬ֱӽptrֵءռ䲻ȰsizeָĴСռ䣬
 * ԭݴͷβ·ڴ򣬶ͷԭptrָڴԭ
 * ָԶͷţҪ am_memheap_free()ͬʱ·ڴ׵ַ
 */
void *realloc (void *ptr, size_t size)
{
    return am_mem_realloc(ptr, size);
}

/*******************************************************************************
  ⲿ
*******************************************************************************/

/**
 * \brief ʼ
 *
 * \param[in] p_ops 
 * \param[in] p_arg 
 *
 * \return AM_OK
 */
int am_microlib_adapter_init (const am_microlib_adapter_ops_t *p_ops,
                              void                            *p_arg)
{
    __g_adapter.p_ops = p_ops;
    __g_adapter.p_arg = p_arg;

    return AM_OK;
}

#endif /* __MICROLIB */

/* end of file */
