/*******************************************************************************
*                                 AWORKS
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      apollo.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief Modbusûļ
 *
 * \internal
 * \par modification history
 * - 1.03 2017-03-29  mkr, transplant from aworks
 * - 1.02 2015-05-13  cod, Modify for aworks1.0, fix code style
 * - 1.01 2012-12-04  liuweiyun, Modify for aworks1.0, fix code style
 * - 1.00 2012-05-13  ygy, first implementation
 * \endinternal
 */

#ifndef __AM_MB_CONFIG_H
#define __AM_MB_CONFIG_H

/**
 * \addtogroup grp_am_if_mb_config
 * \copydoc am_mb_config.h
 * @{
 */

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 * Modbus Common Configuration
 ******************************************************************************/

/**
 * \brief ADU
 * - óȰӻַͼݳ
 * - ĳЩӦãܲҪܳһ֡ݣԿʵԽRAMʹ
 * - RTUģʽΪ4~256 ASCIIģʽΪ3~255
 */
#define AM_MB_MAX_SER_ADU_LENGTH   256

/**
 * \brief TCPģʽADU
 * - ĳЩӦãܲҪܳһ֡ݣԿʵԽRAMʹ
 */
#define AM_MB_MAX_TCP_ADU_LENGTH   256

/**
 * \brief RTUģʽT3.5ʱãλ΢룩
 * - RTUģʽУŶt3.5֡ӳʱ䣩ĴжϵĴ
 *   ڽϸߵͨŲ£⽫CPUأ
 *   ˵Сڻ19200λ/£ϸʱ
 * - ʴ19200λ/ʱӦʹù̶ֵ֡ӳʱΪ1.750ms
 * - ʹASCIIģʽʱҪԸú
 */
#define AM_MB_SERIAL_RTU_BAUDRATE_OVER_19200_FRAME_DELAY_US    1750ul

/**
 * \brief ASCIIģʽַ䳬ʱ
 * ASCIIģʽУַ䳬ʱʱûй̶Ըݾ
 */
#define AM_MB_ASCII_TIMEOUT_SEC    1

/*******************************************************************************
 * Modbus Slave Station Configuration
 ******************************************************************************/
/** ӻͨģʽ */
#define AM_MB_SERIAL_ASCII_ENABLE  1   /**< \brief ASCIIģʽ */
#define AM_MB_SERIAL_RTU_ENABLE    1   /**< \brief RTUģʽ */
#define AM_MB_TCP_ENABLE           0   /**< \brief TCP/IPģʽ,ݲ֧TCP/IPģʽ */

/**
 * \brief ʹܽ˫壨RTUASCIIģʽ
 * ʹܸãʹ2*AM_MB_MAX_SER_ADU_LENGTH RAMռPDU֡
 * ʹøùܣԱ֤ڵһ֡ʱһ֡ݵʱ֤ڶ֡
 */
#define AM_MB_SER_PDU_RECV_BUF_ENABLE  1

/*******************************************************************************
 * Modbus Master Station Configuration
 ******************************************************************************/
/** վͨģʽ */
#define AM_MB_MASTER_RTU_ENABLE    1   /**< \brief RTUģʽ */
#define AM_MB_MASTER_ASCII_ENABLE  1   /**< \brief ASCIIģʽ */
#define AM_MB_MASTER_TCP_ENABLE    0   /**< \brief TCP/IPģʽ */

/**
 * \brief վȴվӦʱʱ䣨룩
 */
#define AM_MB_MASTER_TIMEOUT_MS_RESPOND  2000
#if ((AM_MB_MASTER_TIMEOUT_MS_RESPOND < 50)  ||\
     (AM_MB_MASTER_TIMEOUT_MS_RESPOND > 100000))
#error "AM_MB_MASTER_TIMEOUT_MS_RESPOND value must be in 50~100000ms"
#endif

/**
 * \brief վ㲥ʱתӳʱ䣨룩
 */
#define AM_MB_MASTER_DELAY_MS_CONVERT   100

/**
 * \brief TCPģʽµԪʾʹôվַʹ
 * - ĳЩӦãModbusӵ·ʹõԪʾʶվַ
 * - ʹܣԪʾĿվַʹãʹܣԪʾֵĬΪ0xFF
 */
#define AM_MB_TCP_UID_AS_SLAVEADDR   0

/**
 * \brief վTCPģʽ£Ĭӳʱʱ(ms)
 */
#define AM_MB_TCP_CONNECT_TIMEOUT    5000

#ifdef __cplusplus
}
#endif

/* @} grp_am_if_mb_config */

#endif /* } __AM_MB_CONFIG_H */


/* end of file */
