/*******************************************************************************
*                                 AWORKS
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2012 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      apollo.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief modbus register function code head file.
 *
 * \internal
 * \par modification history
 * - 1.03 2017-03-29  mkr, transplant from aworks.
 * - 1.02 2015-05-22  cod, fix code style and comments, a little improve.
 * - 1.01 2013-03-29  liuweiyun, fix code style and comments, a little improve.
 * - 1.00 2012-07-05  ygy, first implementation
 * \endinternal
 */

#ifndef __AM_MB_REGFUNCTION_H /* { */
#define __AM_MB_REGFUNCTION_H

/**
 * \addtogroup grp_am_if_mb_regfunction
 * \copydoc am_mb_regfunction.h
 * @{
 */

#include "am_mb_slave.h"
#include "am_mb_utils.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief ȡվϢ
 * @note  ȡModbusջ˵ǰ״̬һЩϢ
 *
 * @param[in]     : slave ӻ
 * @param[in,out] : p_frame վϢ
 *
 * @return IDվϢ
 */
uint16_t am_mb_get_slave_id (am_mb_slave_handle slave, uint8_t *p_frame);

/**
 * \brief ȡĴ
 *
 * @param[in] : funCode 
 *
 * @return    : ӦĴ
 */
am_mb_fn_code_handler_t am_mb_fn_code_handler_get (am_mb_slave_handle slave,
                                                   uint8_t       funcode);

/**
 * \brief Ȧ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 *		      עȦص
 *
 * @param[in]     slave   : ӻ
 * @param[in,out] p_pdu   : PDU
 * @param[in,out] p_len   : PDUָ
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_read_coils (am_mb_slave_handle slave,
                                   	   uint8_t 	    *p_pdu,
                                       uint16_t 	*p_len);

/**
 * \brief ɢ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mb_register_funcode_callback
 * 		      עɢص
 *
 * @param[in]    slave   : ӻ
 * @param[in,out] p_pdu  : PDU
 * @param[in,out] p_len  : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_read_discrete_inputs (am_mb_slave_handle slave,
                                                 uint8_t 	  *p_pdu,
                                                 uint16_t 	  *p_len);

/**
 * \brief Ĵ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 	                עĴص
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_read_hold_regs (am_mb_slave_handle slave,
                                           uint8_t 	    *p_pdu,
                                           uint16_t 	*p_len);

/**
 * \brief Ĵ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 		     עĴص
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_read_input_regs (am_mb_slave_handle slave,
                                            uint8_t 	 *p_pdu,
                                            uint16_t 	 *p_len);

/**
 * \brief дȦ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 		     עдȦصдȦѾעдȦص
 * 		     ͲҪעᡣ
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_write_single_coil (am_mb_slave_handle slave,
                                         	  uint8_t 	   *p_pdu,
                                              uint16_t 	   *p_len);

/**
 * \brief дĴ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 *        ͬʱҪʹam_mbRegisterFunCodeCallback
 *        עдĴصдĴѾעдĴ
 *        صͲҪע
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_write_single_reg (am_mb_slave_handle slave,
                                             uint8_t 	  *p_pdu,
                                             uint16_t 	  *p_len);

/**
 * \brief дȦ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 		     עдȦصдȦѾעдȦص
 * 		     ͲҪע
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_write_multiple_coils (am_mb_slave_handle slave,
                                                 uint8_t 	  *p_pdu,
                                                 uint16_t 	  *p_len);

/**
 * \brief дĴ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 		     עдĴصдĴѾעдĴ
 * 		     صͲҪע
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_write_multiple_regs (am_mb_slave_handle slave,
                                                uint8_t 	 *p_pdu,
                                                uint16_t 	 *p_len);

/**
 * \brief дĴ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ͬʱҪʹam_mbRegisterFunCodeCallback
 * 		     עдĴصѾעдĴ
 * 		     صͲҪע
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu :PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 */
am_mb_exception_t am_mb_fn_rw_multiple_regs (am_mb_slave_handle slave,
										     uint8_t 	  *p_pdu,
										     uint16_t 	  *p_len);

/**
 * \brief ӻϢ봦.
 * @note  ҪùܣҪʹúam_mb_slave_register_handlerעᡣ
 * 		     ӻʹam_mb_slave_set_idôӻϢ
 *
 * @param[in]     slave : ӻ
 * @param[in,out] p_pdu : PDU
 * @param[in,out] p_len : PDU
 * @return û쳣am_MB_EXP_NONE򷵻ضӦ쳣
 * @see am_mb_slave_set_id
 */
am_mb_exception_t am_mb_fn_report_slave_id (am_mb_slave_handle slave,
                                       	    uint8_t 	 *p_pdu,
                                            uint16_t     *p_len);

#ifdef __cplusplus
}
#endif

/* @} grp_am_if_mb_regfunction */

#endif /* @} __AM_MB_REGFUNCTION_H */

