/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Զʷ񣬿ʵδ֪ʵĴ豸Զƥ䲨(ģʵ)
 *
 *
 * \internal
 * \par Modification history
 * - 1.00 18-10-25  ipk, first implementation
 * \endinternal
 */

#ifndef __AM_BAUDRATE_DETECT_H__
#define __AM_BAUDRATE_DETECT_H__

#include "ametal.h"
#include "am_cap.h"
#include "am_uart.h"
#include "am_timer.h"
#include "am_softimer.h"

/**
 * \brief Զ豸Ϣ
 */
typedef struct am_baudrate_detect_devinfo {
    int        cap_pin;                /**< \brief  */
    uint8_t    cap_chanel;             /**< \brief CAPͨ */
    uint8_t    timer_width;            /**< \brief TIMERʱλ */
    uint16_t   timer_out;              /**< \brief һݵĳʱʱ䣬λms*/
    uint32_t   cap_trigger;            /**< \brief CAPطʽѡѡ */
    void     (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ʼ */
} am_baudrate_detect_devinfo_t;

/**
 * \brief Զ豸ṹ
 */
typedef struct am_baudrate_detect_dev {

    /** \brief CAP*/
    am_cap_handle_t         cap_handle;

    /** \brief softimerʱṹ*/
    am_softimer_t           softimer;

    /** \brief */
    int                     cap_pin;

    /** \brief жϱ־*/
    volatile am_bool_t      cap_flag;

    /** \brief ڽ*/
    uint16_t                uart_data;

    /** \brief ݵ˫ؼ*/
    uint32_t                data_edge;

    /** \brief ݵ*/
    uint32_t                data_pulses;

    /** \brief ݳʱʱ*/
    uint16_t                time_out_ms;

    /** \brief ݵ*/
    uint32_t                data_pulse_width[32];

    /** \brief Զ豸Ϣ*/
    am_baudrate_detect_devinfo_t  *p_devinfo;
} am_baudrate_detect_dev_t;

/** \brief Զ ׼Ͷ */
typedef am_baudrate_detect_dev_t  *am_baudrate_detect_handle_t;


/**
 * \brief ȡʺӿ
 */
int am_baudrate_get (am_baudrate_detect_handle_t handle, uint32_t *p_baudrate);

/**
 * \brief Զʳʼ
 *
 * \param[in] p_dev        : ָԶʷָ
 * \param[in] p_devinfo    : ָԶʷϢָ
 * \param[in] cap_handle   : CAP׼
 * \param[in] uart_handle  : UARTڱ׼
 *
 * \return Զʷ
 */
am_baudrate_detect_handle_t am_baudrate_detect_init (am_baudrate_detect_dev_t     *p_dev,
                                                     am_baudrate_detect_devinfo_t *p_devinfo,
                                                     am_cap_handle_t               cap_handle);

/**
 * \brief Զʽʼ
 *
 * \param[in] handle        : Զʷ
 *
 * \return 
 */
void am_baudrate_detect_deinit (am_baudrate_detect_handle_t handle);

#endif

/* end of file */
