/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief ѭУ(CRC) ʵ
 *
 * \internal
 * \par modification history
 * - 1.00 18-01-19  tee, first implementation
 * \endinternal
 */

#ifndef __AM_CRC_SOFT_H
#define __AM_CRC_SOFT_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_crc_soft
 * \copydoc am_crc_soft.h
 * @{
 */
#include "am_common.h"
#include "am_crc.h"

/**
 * \brief CRC TABLE
 *
 *     Ϊ˼ӿ CRC ٶȣʹ˲ҪڳʼһCRC
 * ʱ(\sa am_crc_soft_init())ṩһCRCıñľCRCģ
 * Уwidthpoly  refin ԱֵأֻҪһģֵȣ
 * ǾͿʹͬһ table 
 */
typedef struct am_crc_table {

    uint8_t     width;                     /**< \brief CRC                */
    uint32_t    poly;                      /**< \brief CRCɶʽ          */
    am_bool_t   refin;                     /**< \brief ֽbit        */

    /**
     * \brief ָʵ TABLE Ϣ ָ
     *
     * TBALEĳȹ̶Ϊ256ʵ widthֵ
     *     - 8λ8λ£p_data ָ  TABLE ԭӦΪ uint8_t data[256]
     *     - 9  16λ    p_data ָ  TABLE ԭӦΪuint16_t data[256]
     *     - 17 32λ   p_data ָ  TABLE ԭӦΪuint32_t data[256]
     */
    const void *p_data;

} am_crc_table_t;

/**
 * \brief CRC
 */
typedef struct am_crc_soft {

    /** \brief CRCܹṩ׼CRC    */
    am_crc_serv_t            serv;

    /** \brief CRCʹõTABLE */
    const am_crc_table_t    *p_table;

    /* ǰ CRC ģ  */
    am_crc_pattern_t        *p_pattern;

    /** \brief CRCֵ          */
    uint32_t                 value;

} am_crc_soft_t;

/**
 * \brief һͨõ CRC table 
 *
 *   Ϊ˼ӿ CRC ʣʹ˲ҪڳʼһCRC
 * ʱ(\sa am_crc_soft_init())ṩһCRCıñľCRC
 * ģУwidthpoly  refin ԱֵأֻҪһģֵȣ
 * ǾͿʹͬһ table 
 *
 * \param[in] p_table : TABLEʵ
 * \param[in] width   : CRC
 * \param[in] poly    : ɶʽ
 * \param[in] refin   : ֽbit
 * \param[in] p_data  : 洢ݵռ䣬ʵ widthֵء
 *                     - 8λ8λ£ָ TABLE ԭΪuint8_t  data[256]
 *                     - 9  16λ   ָ TABLE ԭΪuint16_t data[256]
 *                     - 17 32λ   ָ TABLE ԭΪuint32_t data[256]
 *
 * \retval AM_OK      : ɳɹ
 * \retval -AM_EINVAL : ʧܣڴ
 *
 * \note Ϊ˱ûʹãѾṩ˳ table  \ref am_if_crc_table_def.
 * ûֱʹЩTABLEΪʼ p_table ֵṩtable
 * δҵʹõCRCģ͡ʹ úһtable
 */
int am_crc_table_create (am_crc_table_t  *p_table,
                         uint8_t          width,
                         uint32_t         poly,
                         am_bool_t        refin,
                         void            *p_data);

/**
 * \brief ʼһ CRC 
 *
 * \param[in] p_crc   : CRC ʵ
 * \param[in] p_table :  CRC ʹõ TABLE TABLEʹõCRCģأ
 *                       \ref am_if_crc_table_def. ṩtableбδ
 *                      ҵʹõCRCģ͡ʹ \sa am_crc_table_create()
 *                      һtable
 *
 * \return ׼CRCΪNULL ʾʼʧ
 *
 * \warning ﴫTABLE˸ CRC ֵ֧CRCģֵ֧ͣCRCģ \n
 * Уwidthpolyrefin ֵ TABLE ֵһ¡
 *
 * \note ʹøúʼCRCԱֲֶ֧ͬģ͵CRC
 */
am_crc_handle_t am_crc_soft_init (am_crc_soft_t         *p_crc,
                                  const am_crc_table_t  *p_table);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_CRC_SOFT_H */

/* end of file */
