/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief CRC TABLE 壬  CRC 
 *
 * ļ ֳCRC TABLEֱ (\sa am_crc_soft_init()) 
 * p_table .
 *
 * \internal
 * \par modification history
 * - 1.00 18-01-19  tee, first implementation
 * \endinternal
 */

#ifndef __AM_CRC_TABLE_DEF_H
#define __AM_CRC_TABLE_DEF_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_crc_table
 * \copydoc am_crc_table.h
 * @{
 */
#include "am_common.h"
#include "am_crc.h"
#include "am_crc_soft.h"

/**
 * \name 8λ8λcrc table
 *
 * ǰѾֵ֧ģͣѾã½ֱʹüɡ
 * g_crc_table_X_Y(_ref)[256] XYһ֡
 *   -  g_crc_table Xʾcrcȣcrc5Ӧ g_crc_table_5
 *   - »ߺYʾpoly,ɶʽ
 *      - 8λ8λ£polyʹ8λʾ  09,ʡ0
 *      - 916λ     polyʹ16λʾ8005,ʡ0
 *      - 17 32λ   polyʹ32λʾ04C11DB7,ʡ0.
 *   - ׺refıʾñΪcrcģrefin == TRUEʱ
 *     Ӧô׺refı
 *
 * ˣʹõcrcģ֪ͣʹĸcrcģΪ
 *     width = 5poly = 0x09,refin = TRUE.
 * ֱʹ g_crc_table_5_09_ref ɡ
 *
 * \note ͬʺλCRC table
 * @{
 */

/** \brief crc4  poly = 0x03, refin = TRUE  */
am_import am_const am_crc_table_t g_crc_table_4_03_ref;

/** \brief crc5  poly = 0x09, refin = FALSE */
am_import am_const am_crc_table_t g_crc_table_5_09;

/** \brief crc5  poly = 0x15, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_5_15_ref;

/** \brief crc5  poly = 0x05, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_5_05_ref;

/** \brief crc6  poly = 0x03, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_6_03_ref;

/** \brief crc7  poly = 0x09, refin = FALSE */
am_import am_const am_crc_table_t g_crc_table_7_09;

/** \brief crc8  poly = 0x07, refin = FALSE */
am_import am_const am_crc_table_t g_crc_table_8_07;

/** \brief crc8  poly = 0x07, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_8_07_ref;

/** \brief crc8  poly = 0x31, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_8_31_ref;

/** @} */

/**
 * \name 9λ16λcrc table
 * @{
 */

/** \brief crc16  poly = 0x8005, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_16_8005_ref;

/** \brief crc16  poly = 0x1021, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_16_1021_ref;

/** \brief crc16  poly = 0x1021, refin = FALSE */
am_import am_const am_crc_table_t g_crc_table_16_1021;

/** \brief crc16  poly = 0x3D65, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_16_3d65_ref;

/** @} */

/**
 * \name 17λ32λcrc table
 * @{
 */

/** \brief crc32  poly = 0x04c11db7, refin = TRUE */
am_import am_const am_crc_table_t g_crc_table_32_04c11db7_ref;

/** \brief crc32  poly = 0x04c11db7, refin = FALSE */
am_import am_const am_crc_table_t g_crc_table_32_04c11db7;

/** @} */

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_CRC_TABLE_H */

/* end of file */
