/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ͨö̬ɨ
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-18  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_DIGITRON_SCAN_H
#define __AM_DIGITRON_SCAN_H

#include "ametal.h"
#include "am_digitron_disp.h"
#include "am_softimer.h"
#include "am_digitron_dev.h"
#include "am_digitron_base.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \name am_if_digitron_scan
 * @{
 */

/**
 * \brief ̬ɨϢ
 */
typedef struct am_digitron_scan_devinfo {

    /** \brief ׼豸ϢID */
    am_digitron_devinfo_t devinfo; 

    /** \brief ܵɨƵʣһ 50Hz */
    uint8_t               scan_freq;
 
    /** \brief һ˸ڣʱ䣬 500ms */
    uint16_t              blink_on_time;
    
    /** \brief һ˸ڣϨʱ䣬 500ms */
    uint16_t              blink_off_time; 

    /**
     * \brief Դ棬ܶ
     *
     * ܶ 1 ~ 8 Ϊ uint8_tСܸһ
     * ܶ 8 ~ 16Ϊ uint16_tСܸһ
     */
    void                  *p_disp_buf;

    /**
     * \brief ɨԴ棬ڴŵɨľܶ
     *
     * ܶ 1 ~ 8 Ϊ uint8_tС뵥ɨĸһ
     * ܶ 8 ~ 16Ϊ uint16_tС뵥ɨĸһ
     *
     * 簴ɨ裬С num_rows ͬ
     * 簴ɨ裬С num_cols ͬ
     *
     * ھ󲿷Ӧõ·һֻɨһܣСΪ1
     */
    void                  *p_scan_buf;

} am_digitron_scan_devinfo_t;


/**
 * \brief λѡֿУӦɾṩ
 *
 * λֿͣԶӰ⣬Ӱڣִпռص
 *
 */
typedef struct am_digitron_scan_ops_separate {
   am_digitron_base_sender_seg_t      *p_send_seg; /**< \brief 뷢 */
   am_digitron_base_selector_com_t    *p_sel_com;  /**< \brief λѡ */
} am_digitron_scan_ops_separate_t;

/**
 * \brief λѡͬʱУӦɾṩ
 *
 *     λͬʱͣҪдӰ⣬µܼ󣬶ѡλѡ
 * Ч״̬
 */
typedef struct am_digitron_scan_ops_unite {
    am_digitron_base_sender_data_t   *p_send_data; /**< \brief 뷢 */
} am_digitron_scan_ops_unite_t;

/**
 * \brief лصŸã
 *
 * λʼɨʱøûص밴õӦóϡ
 * ڻصִڼ䣬λѡЧ״̬ѡЧ״̬
 *
 * \param[in] p_cookie : Զ
 * \param[in] scan_idx : ǰλѡ
 *
 * \return 
 */
typedef void (*am_digitron_scan_cb_t) (void *p_cookie, int scan_idx);

/**
 * \brief ͨö̬ɨ豸
 */
typedef struct am_digitron_scan_dev {

    am_digitron_dev_t isa;             /**< \brief Ǳ׼豸      */
    am_softimer_t     timer;           /**< \brief ʹʱ          */

    uint8_t           scan_idx;        /**< \brief ǰɨ            */
    uint8_t           scan_interval;   /**< \brief ɨʱ            */
    uint8_t           num_scan;        /**< \brief ɨĸһΪ1 */
    uint8_t           num_digitron;    /**< \brief ܸ              */
    uint32_t          blink_flags;     /**< \brief ˸(bit map)       */
    uint16_t          blink_cnt;       /**< \brief ˸                */

    uint16_t  (*pfn_decode)(uint16_t code);

    const void                       *pfn_buf_access; 
    am_bool_t                         is_separate;
    void                             *p_ops;
    am_digitron_scan_cb_t             pfn_black_cb;
    void                             *p_arg;
    const am_digitron_scan_devinfo_t *p_info;
    const am_digitron_base_info_t    *p_baseinfo;
} am_digitron_scan_dev_t;

/**
 * \brief ̬ɨܳʼ
 *
 * \param[in] p_dev       : ̬ɨ豸ʵ
 * \param[in] p_info      : ̬ɨ豸ʵϢ
 * \param[in] is_separate : λǷΪͣ  p_ops ʵ
 *                         - AM_TRUE Ϊam_digitron_scan_ops_unite_t *
 *                         - AM_FALSEΪam_digitron_scan_ops_separate_t *
 *
 * \retval AM_OK      : ʼɹ
 * \retval -AM_EINVAL ʼʧܣڴ
 */
int am_digitron_scan_init (am_digitron_scan_dev_t           *p_dev,
                           const am_digitron_scan_devinfo_t *p_info,
                           const am_digitron_base_info_t    *p_baseinfo,
                           am_bool_t                         is_separate,
                           void                             *p_ops);

/**
 * \brief ɨصһ
 *
 *     һµλʼɨʱøûص
 * 
 * \param[in] p_dev  : ̬ɨ豸ʵ
 * \param[in] pfn_cb : ص
 * \param[in] p_arg  : صû
 *
 * \retval AM_OK      : óɹ
 * \retval -AM_EINVAL ʧܣڴ
 */
int am_digitron_scan_cb_set (am_digitron_scan_dev_t *p_dev,
                             am_digitron_scan_cb_t   pfn_cb,
                             void                   *p_arg);

/**
 * \brief ̬ɨܽʼ
 *
 * \param[in] p_dev   : ̬ɨ豸ʵ
 *
 * \retval AM_OK      : ʼɹ
 * \retval -AM_EINVAL ʼʧܣڴ
 */
int am_digitron_scan_deinit (am_digitron_scan_dev_t *p_dev);

/* @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_DIGITRON_SCAN_H */

/* end of file */
