/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief ¼
 *
 * \internal
 * \par Modification history
 * - 1.00 16-08-23  tee, first implementation.
 * \endinternal
 */
#ifndef __AM_EVENT_INPUT_KEY_H
#define __AM_EVENT_INPUT_KEY_H

#include "am_common.h"
#include "am_event.h"
#include "am_softimer.h"

#ifdef __cplusplus
extern "C" {
#endif
 
/**
 * \brief ڰû˽Աڴ
 */
typedef struct am_event_input_key_long_press {
    am_softimer_t timer;         /**< \brief ʱڰʱ     */
    int           key_code;      /**< \brief ǰİ룬-1ΪЧֵ   */
    int           keep_time;     /**< \brief ʱ                         */
} am_event_input_key_long_press_t;

/**
 * \brief ϵͳϢ
 */
typedef struct am_event_input_key_info {

    /**
     * \brief ೤ʱʼϱ¼
     *
     * 磬Ҫ1sʼϱ¼ֵΪ 1000
     */
    int  key_long_press_time_start_ms;

    /**
     * \biref ﵽʱÿһʱϱһγ¼
     *
     * 磬ã
     *  - key_long_press_time_start_ms  Ϊ 1000
     *  - key_long_press_time_period_ms Ϊ 200
     *
     *  ʾס1sϱһγ¼Ժÿ200msϱһγ¼
     */
    int  key_long_press_time_period_ms;

    /**
     * \brief ͬʱİ
     *
     *  - ְֵ֧Ϊ0
     *  - ְֵ֧Ϊͬһʱ̳ͨΪ1
     *
     * һ£ͬһʱ᳤ֻһ㲻ͬʱ
     * ֧ͬʱΪʱҪڴռ䡣
     *
     * \note ﲢֳ֧İͬʱ
     */
    int  key_long_press_max_num;

    /**
     * \brief ر棬СΪ key_long_press_max_num
     *
     * û趨壬ڴ䣬ûԳԱֵ
     *
     *  key_long_press_max_num Ϊ 0ֳֵ֧ΪNULL
     */
    am_event_input_key_long_press_t *p_buf;

} am_event_input_key_info_t;

/**
 * \brief ϵͳʼ
 *
 * \return 
 *
 * \note  "¼" һ࣬ڳʼģǰӦȷ
 * Ѿʹ am_event_category_input_init() ¼ĳʼ
 */
void am_event_input_key_init (const am_event_input_key_info_t *p_info);


/**
 * \brief ϱ¼ײ㰴ãͨ
 *
 * ͨڰ»ͷʱӦϱ¼AMetalϲ㽫ڽյ
 * ¼ʱʱʹ˸ùܣڰͷǰӦ
 * ϱ¼
 *
 * ðͷţͷ¼Ӧڰ
 * ʱ am_event_input_key_released() 
 *
 * \param[in] key_code   : 
 *
 * \return ׼
 */
int am_event_input_key_pressed  (int key_code);

/**
 * \brief ϱͷ¼ײ㰴ãͨ
 *
 * ͨڰ»ͷʱӦϱ¼AMetalϲ㽫ڽյ
 * ¼ʱʱʹ˸ùܣڰͷǰӦ
 * ϱ¼
 *
 * úָ֪ͨͷţϲӦֹͣðĳʱ
 *
 * \param[in] key_code   : 
 *
 * \return ׼
 */
int am_event_input_key_released (int key_code);

/**
 * \brief ϱ¼ײ㰴ãⰴʱ
 *
 * һЩⰴ/̣ҪӼģʱZLG72128̣ܲ
 * AMetalϲгʱҪ
 *
 * 1.ģֻϱ¼ϱͷ¼ھ󲿷Ӧã
 *   ܲİͷţ ްͷţ޷Գ׼ȷʱ
 *
 * 2. ֳ֧ʱZLG72128̡PS/2̣ʱ䱾ᶨ
 * ϱ¼ʱAMetalϲٶԳκζ⴦Ӧòͬʹ
 * óܣֻʱɾģɵģAMetalϲ롣
 *
 * \param[in] key_code  : 
 * \param[in] keep_time : ʱ䣨λmsģ鱾ֳ֧ܣ
 * ֵΪģ鱾ļʱ0Ϊ״ΰ£ģ鱾ֳ֧ܣ
 * ֵΪ-1
 *
 * \return ׼
 */
int am_event_input_key_pressed_without_timing (int key_code, int keep_time);


#ifdef __cplusplus
}
#endif

#endif /* __AM_EVENT_INPUT_KEY_H */
