/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ͨþӿڣʵ־ļֵȡ
 *
 * \internal
 * \par modification history:
 * - 15-09-15 tee, first implementation.
 * \endinternal
 */

#ifndef __AM_KEY_MATRIX_H
#define __AM_KEY_MATRIX_H

#include "ametal.h"
#include "am_types.h"
#include "am_key_matrix_base.h"
 
/**
 * \addtogroup am_if_key_matrix
 * @{
 */

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief ֵȡ׼
 */
typedef struct am_key_matrix_prepare {
    
    /** \brief ȡֵ׼úڼֵȡǰ */
    int (*pfn_prepare) (void *p_cookie, int idx);

    /** \brief ȡֵúڼֵȡ */
    int (*pfn_finish) (void *p_cookie, int idx); 
    
    /** \brief Զ */
    void *p_cookie;

} am_key_matrix_prepare_t;

/**
 * \brief ֵȡȡһлһеļֵ
 */
typedef struct am_key_matrix_read {

    /** \brief ֵȡȡһлһеļֵ */
    uint32_t (*pfn_val_read) (void *p_cookie, int idx);

    /** \brief Զ */
    void      *p_cookie;

} am_key_matrix_read_t;


/** \brief 豸  */
typedef struct am_key_matrix {
    const am_key_matrix_base_info_t *p_info;
    uint32_t                         key_samp_last;
    uint32_t                         key_samp_cur;
    uint32_t                         key_final;
    am_key_matrix_prepare_t         *p_prepare;
    am_key_matrix_read_t            *p_read;
} am_key_matrix_t;

/**
 * \brief 豸ʼ
 *
 * \param[in] p_dev      : 豸ʵ
 * \param[in] p_info     : Ϣ
 * \param[in] p_prepare  : ֵȡ׼׼ΪNULL
 * \param[in] p_read     : ֵȡ
 *
 * \return  AM_OKʼɹ; ֵʼʧܣʧԭ鿴
 */
int am_key_matrix_init (am_key_matrix_t                 *p_dev,
                        const am_key_matrix_base_info_t *p_info,
                        am_key_matrix_prepare_t         *p_prepare,
                        am_key_matrix_read_t            *p_read);

/**
 * \brief ִһɨ裬ɨһлһУԶɨ裬һܸʱ
 *
 * \param[in] p_dev    : 豸ʵ
 * \param[in] scan_idx : ɨкŻк
 *
 * \return  AM_OKʼɹ; ֵʼʧܣʧԭ鿴
 * \note ɨУУǰȷݾȷȡЧ
 */
int am_key_matrix_scan (am_key_matrix_t *p_dev, int scan_idx);

/**
 * \brief ȡɨ
 * \param[in] p_dev  : 豸ʵ
 * \return  ɨ
 */
int am_key_matrix_scan_idx_max_get (am_key_matrix_t *p_dev);

#ifdef __cplusplus
}
#endif

/** @} */

#endif /* __AM_KEY_MATRIX_H */

/* end of file */
