/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ڱ׼̵ĻϣʱʵԶɨ
 *
 * \internal
 * \par modification history:
 * - 15-09-15 tee, first implementation.
 * \endinternal
 */

#ifndef __AM_KEY_MATRIX_SOFTIMER_H
#define __AM_KEY_MATRIX_SOFTIMER_H

#include "ametal.h"
#include "am_types.h"
#include "am_key_matrix_base.h"
#include "am_key_matrix.h"
#include "am_softimer.h"

/**
 * \addtogroup am_if_key_matrix_softimer
 * @{
 */

#ifdef __cplusplus
extern "C" {
#endif

/** \brief 豸  */
typedef struct am_key_matrix_softimer {
    am_key_matrix_t  *p_real;
    am_softimer_t     timer;
    int               scan_idx;
} am_key_matrix_softimer_t;

/**
 * \brief ʼʱʵԶɨ
 *
 * \param[in] p_dev            : 豸ʵ
 * \param[in] p_timer          : ʱʵ
 * \param[in] scan_interval_ms : ɨо̵ʱ λ ms
 *
 * \return  AM_OKʼɹ; ֵʼʧܣʧԭ鿴
 * \note ɨУУǰȷݾȷȡЧ
 */
int am_key_matrix_softimer_init (am_key_matrix_softimer_t *p_dev,
                                 am_key_matrix_t          *p_key,
                                 int                       scan_interval_ms);

/**
 * \brief ʼֹͣʱֹԶɨ
 *
 * \param[in] p_dev  : 豸ʵ
 *
 * \return  AM_OKʼɹ; ֵʼʧܣʧԭ鿴
 *
 * \note ֹٴʹʱʵԶɨ裬Ҫµ \sa
 * am_key_matrix_softimer_init()
 */
int am_key_matrix_softimer_deinit (am_key_matrix_softimer_t *p_dev);

#ifdef __cplusplus
}
#endif

/** @} */

#endif /* __AM_KEY_MATRIX_SOFTIMER_H */

/* end of file */
