/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116 ʵʼ
 *
 * 豸I2CSPIADC...ʵʼڱͷļʹʵ
 * ʼɻһľȻʹصĽӿںв
 *
 * \sa am_zlg116_inst_init.h
 * \internal
 * \par Modification history
 * - 1.00 16-10-26  nwt, first implementation.
 * \endinternal
 */
 
#ifndef __AM_ZLG116_INST_INIT_H
#define __AM_ZLG116_INST_INIT_H

#include "ametal.h"
#include "am_adc.h"
#include "am_crc.h"
#include "am_i2c.h"
#include "am_i2c_slv.h"
#include "am_timer.h"
#include "am_cap.h"
#include "am_pwm.h"
#include "am_wdt.h"
#include "am_spi.h"
#include "am_spi_slv.h"
#include "am_uart.h"
#include "am_zlg116_pwr.h"
#include "am_hwconf_led_gpio.h"
#include "am_hwconf_key_gpio.h"
#include "am_hwconf_buzzer_pwm.h"
#include "am_hwconf_debug_uart.h"
#include "am_hwconf_system_tick_softimer.h"
#include "am_hwconf_lm75.h"
#include "am_hwconf_microport.h"
#include "am_hwconf_miniport_zlg72128.h"
#include "am_hwconf_miniport_595.h"
#include "am_hwconf_miniport_view.h"
#include "am_hwconf_miniport_led.h"
#include "am_hwconf_miniport_key.h"
#include "am_hwconf_miniport_view_key.h"

/**
 * \addtogroup am_if_zlg116_inst_init
 * \copydoc am_zlg116_inst_init.h
 * @{
 */

/**
 * \brief жʵʼʼж
 *
 * \param 
 *
 * \return  AW_OK ΪʼɹΪʼʧ
 */
int am_zlg116_nvic_inst_init (void);

/**
 * \brief жʵʼ
 *
 * \param 
 *
 * \return 
 */
void am_zlg116_nvic_inst_deinit (void);

/**
 * \brief ADC ʵʼ ADC ׼
 *
 * \param 
 *
 * \return ADC ׼Ϊ NULLʼʧ
 */
am_adc_handle_t am_zlg116_adc_inst_init (void);

/**
 * \brief ADC ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_adc_inst_init() õ ADC ׼
 *
 * \return 
 */
void am_zlg116_adc_inst_deinit (am_adc_handle_t handle);

/**
 * \brief CLK ʵʼʼϵͳʱ
 *
 * \param 
 *
 * \return  AW_OK ΪʼɹΪʼʧ
 */
int am_zlg116_clk_inst_init (void);

/**
 * \brief DMA ʵʼ
 *
 * \param 
 *
 * \return  AW_OK ΪʼɹΪʼʧ
 */
int am_zlg116_dma_inst_init (void);

/**
 * \brief DMA ʵʼ
 *
 * \param 
 *
 * \return 
 */
void am_zlg116_dma_inst_deinit (void);

/**
 * \brief GPIO ʵʼ
 *
 * \param 
 *
 * \return  AW_OK ΪʼɹΪʼʧ
 */
int am_zlg116_gpio_inst_init (void);

/**
 * \brief GPIO ʵʼ
 *
 * \param 
 *
 * \return 
 */
void am_zlg116_gpio_inst_deinit (void);

/**
 * \brief I2C1 ʵʼ I2C ׼
 *
 * \param 
 *
 * \return I2C ׼Ϊ NULLʼʧ
 */
am_i2c_handle_t am_zlg116_i2c1_inst_init (void);

/**
 * \brief I2C1 ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_i2c1_inst_init() õ I2C ׼
 *
 * \return 
 */
void am_zlg116_i2c1_inst_deinit (am_i2c_handle_t handle);

/**
 * \brief I2C1 ӻʵʼ I2C ӻ׼
 *
 * \param 
 *
 * \return I2C ӻ׼Ϊ NULLʼʧ
 */
am_i2c_slv_handle_t  am_zlg116_i2c1_slv_inst_init (void);

/**
 * \brief I2C1 ӻʵʼ
 *
 * \param[in] handle ͨ am_zlg116_i2c1_slv_inst_init() 
 *                   õ I2C ӻ׼
 *
 * \return 
 */
void am_zlg116_i2c1_slv_inst_deinit (am_i2c_slv_handle_t handle);

/**
 * \brief IWDT ʵʼ WDT ׼
 *
 * \param 
 *
 * \return WDT ׼Ϊ NULLʼʧ
 */
am_wdt_handle_t am_zlg116_iwdg_inst_init (void);

/**
 * \brief IWDT ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_iwdg_inst_init() õ WDT ׼
 *
 * \return 
 */
void am_zlg116_iwdg_inst_deinit (am_wdt_handle_t handle);

/**
 * \brief PWR ʵʼ
 *
 * \param 
 *
 * \return PWR ׼Ϊ NULLʼʧ
 */
am_zlg116_pwr_handle_t am_zlg116_pwr_inst_init (void);

/**
 * \brief PWR ʵʼ
 *
 * \param 
 *
 * \return 
 */
void am_zlg116_pwr_inst_deinit (void);

/**
 * \brief SPI1 DMA ʵʼ SPI ׼
 *
 * \param 
 *
 * \return SPI ׼Ϊ NULLʼʧ
 */
am_spi_handle_t am_zlg116_spi1_dma_inst_init (void);

/**
 * \brief SPI1 DMA ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi1_dma_inst_init() 
 *                   õ SPI ׼
 *
 * \return 
 */
void am_zlg116_spi1_dma_inst_deinit (am_spi_handle_t handle);

/**
 * \brief SPI2 DMA ʵʼ SPI ׼
 *
 * \param 
 *
 * \return SPI ׼Ϊ NULLʼʧ
 */
am_spi_handle_t am_zlg116_spi2_dma_inst_init (void);

/**
 * \brief SPI2 DMA ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi2_dma_inst_init() 
 *                   õ SPI ׼
 *
 * \return 
 */
void am_zlg116_spi2_dma_inst_deinit (am_spi_handle_t handle);

/**
 * \brief SPI1 INT ʵʼ SPI ׼
 *
 * \param 
 *
 * \return SPI ׼Ϊ NULLʼʧ
 */
am_spi_handle_t am_zlg116_spi1_int_inst_init (void);

/**
 * \brief SPI1 INT ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi1_int_inst_init() 
 *                   õ SPI ׼
 *
 * \return 
 */
void am_zlg116_spi1_int_inst_deinit (am_spi_handle_t handle);

/**
 * \brief SPI2 INT ʵʼ SPI ׼
 *
 * \param 
 *
 * \return SPI ׼Ϊ NULLʼʧ
 */
am_spi_handle_t am_zlg116_spi2_int_inst_init (void);

/**
 * \brief SPI2 INT ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi2_int_inst_init() 
 *                   õ SPI ׼
 *
 * \return 
 */
void am_zlg116_spi2_int_inst_deinit (am_spi_handle_t handle);

/**
 * \brief SPI1 ӻʵʼ SPI ӻ׼
 *
 * \param 
 *
 * \return SPI ӻ׼Ϊ NULLʼʧ
 */
am_spi_slv_handle_t am_zlg116_spi1_slv_dma_inst_init (void);

/**
 * \brief SPI1 ӻʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi1_slv_dma_inst_init() 
 *                   õ SPI ӻ׼
 *
 * \return 
 */
void am_zlg116_spi1_slv_dma_inst_deinit (am_spi_slv_handle_t handle);

/**
 * \brief SPI1 ӻʵʼ SPI ӻ׼
 *
 * \param 
 *
 * \return SPI ӻ׼Ϊ NULLʼʧ
 */
am_spi_slv_handle_t am_zlg116_spi2_slv_dma_inst_init (void);

/**
 * \brief SPI1 ӻʵʼ
 *
 * \param[in] handle ͨ am_zlg116_spi2_slv_dma_inst_init() 
 *                   õ SPI ӻ׼
 *
 * \return 
 */
void am_zlg116_spi2_slv_dma_inst_deinit (am_spi_slv_handle_t handle);

/**
 * \brief SYSTICK ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return TIMER ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_systick_inst_init (void);

/**
 * \brief SYSTICK ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_systick_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_systick_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM1 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim1_cap_inst_init (void);

/**
 * \brief TIM1 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim1_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim1_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM2 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim2_cap_inst_init (void);

/**
 * \brief TIM2 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim2_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim2_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM3 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim3_cap_inst_init (void);

/**
 * \brief TIM3 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim3_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim3_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM14 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim14_cap_inst_init (void);

/**
 * \brief TIM14 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim14_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim14_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM16 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim16_cap_inst_init (void);

/**
 * \brief TIM16 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim16_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim16_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM17 CAP ʵʼ CAP ׼
 *
 * \param 
 *
 * \return CAP ׼Ϊ NULLʼʧ
 */
am_cap_handle_t am_zlg116_tim17_cap_inst_init (void);

/**
 * \brief TIM17 CAP ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim17_cap_inst_init() 
 *                   õ CAP ׼
 *
 * \return 
 */
void am_zlg116_tim17_cap_inst_deinit (am_cap_handle_t handle);

/**
 * \brief TIM1 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim1_pwm_inst_init (void);

/**
 * \brief TIM1 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim1_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim1_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM2 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim2_pwm_inst_init (void);

/**
 * \brief TIM2 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim2_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim2_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM3 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim3_pwm_inst_init (void);

/**
 * \brief TIM3 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim3_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim3_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM14 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim14_pwm_inst_init (void);

/**
 * \brief TIM14 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim14_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim14_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM16 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim16_pwm_inst_init (void);

/**
 * \brief TIM16 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim16_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim16_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM17 PWM ʵʼ PWM ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_pwm_handle_t am_zlg116_tim17_pwm_inst_init (void);

/**
 * \brief TIM17 PWM ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim17_pwm_inst_init() 
 *                   õ PWM ׼
 *
 * \return 
 */
void am_zlg116_tim17_pwm_inst_deinit (am_pwm_handle_t handle);

/**
 * \brief TIM1 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim1_timing_inst_init (void);

/**
 * \brief TIM1 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim1_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim1_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM2 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim2_timing_inst_init (void);

/**
 * \brief TIM2 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim2_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim2_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM3 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim3_timing_inst_init (void);

/**
 * \brief TIM3 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim3_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim3_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM14 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim14_timing_inst_init (void);

/**
 * \brief TIM14 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim14_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim14_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM16 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim16_timing_inst_init (void);

/**
 * \brief TIM16 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim16_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim16_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief TIM17 TIMING ʵʼ TIMER ׼
 *
 * \param 
 *
 * \return PWM ׼Ϊ NULLʼʧ
 */
am_timer_handle_t am_zlg116_tim17_timing_inst_init (void);

/**
 * \brief TIM17 TIMING ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_tim17_timing_inst_init() 
 *                   õ TIMER ׼
 *
 * \return 
 */
void am_zlg116_tim17_timing_inst_deinit (am_timer_handle_t handle);

/**
 * \brief UART1 ʵʼ UART ׼
 *
 * \param 
 *
 * \return UART ׼Ϊ NULLʼʧ
 */
am_uart_handle_t am_zlg116_uart1_inst_init (void);

/**
 * \brief UART1 ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_uart1_inst_init() õ UART ׼
 *
 * \return 
 */
void am_zlg116_uart1_inst_deinit (am_uart_handle_t handle);

/**
 * \brief UART2 ʵʼ UART ׼
 *
 * \param 
 *
 * \return UART ׼Ϊ NULLʼʧ
 */
am_uart_handle_t am_zlg116_uart2_inst_init (void);

/**
 * \brief UART2 ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_uart2_inst_init() õ UART ׼
 *
 * \return 
 */
void am_zlg116_uart2_inst_deinit (am_uart_handle_t handle);

/**
 * \brief WWDG ʵʼ WDT ׼
 *
 * \param 
 *
 * \return WDT ׼Ϊ NULLʼʧ
 */
am_wdt_handle_t am_zlg116_wwdg_inst_init (void);

/**
 * \brief WWDG ʵʼ
 *
 * \param[in] handle ͨ am_zlg116_wwdg_inst_init() õ WDT ׼
 *
 * \return 
 */
void am_zlg116_wwdg_inst_deinit (am_wdt_handle_t handle);

/**
 * \brief SPI0 ʵʼSPI׼(POLLʽ)
 * \return SPI0ֵΪNULLʼʧ
 */
am_spi_handle_t am_zlg116_spi1_poll_inst_init (void);

/**
 * \brief SPI0 ʵʼ(POLLʽ)
 * \param[in] handle : ͨ am_zlg116_spi0_poll_inst_init() õSPI0
 * \retval 
 */
void am_zlg116_spi1_poll_inst_deinit (am_spi_handle_t handle);

/**
 * @}
 */


#endif  /* __AM_ZLG116_INST_INIT_H */

/* end of file */
