/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief HC32 CLK ûļ
 * \sa am_hwconf_hc32_clk.c
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-04  zp, first implementation
 * \endinternal
 */
#include "am_gpio.h"
#include "am_hc32_clk.h"
#include "hw/amhw_hc32_rcc.h"
#include "hc32_pin.h"
/**
 * \addtogroup am_if_src_hwconf_hc32_clk
 * \copydoc am_hwconf_hc32_clk.c
 * @{
 */
/** \brief CLK ƽ̨ʼ */
static void __hc32_clk_plfm_init (void)
{
}

/** \brief CLK ƽ̨ʼ */
static void __hc32_clk_plfm_deinit (void)
{
}

/*
 * PLLѡXTHɵʱӡXTHӹܽPF00ʱӡRCHʱΪPLLʱԴ
 * PLLıƵϵõһƵʣӶϵͳʱӡ
 *
 * ϵͳʱԴѡҪ֣  RCH  ---  ڲʱ
 *                       XTH  ---  ⲿʱ
 *                       RCL  ---  ڲʱ
 *                       XTL  ---  ⲿʱ
 *                       PLL  ---  ڲPLLʱ  = PLLʱ * PLLƵϵ
 *
 * ϵͳʱԴѡõ¹ϵ
 *
 * SYSCLK = ѡϵͳʱԴ
 * HCLK   = SYSCLK / (2 ^ hclk_div)
 * PCLK   = HCLK   / (2 ^ pclk_div)
 *
 * \note ϵͳDeepSleepģʽʱӣRCHXTHԶرգ
 *       ֶлʱӣRCLXTLΪϵͳʱԴ
 */
/** \brief CLK豸Ϣ */
static const am_hc32_clk_devinfo_t __g_clk_devinfo =
{
    /**
     * \brief XTHⲿʱӾƵʣHz
     */
    32000000,

    /**
     * \brief XTLⲿʱӾƵʣHz
     */
    32768,

    /**
     * \brief RCHڲʱӾƵʣHz
     *
     * \note Ƶѡ    24M 22.12M16M 8M4M
     *       ƵʣĬʹ4M
     */
    AMHW_HC32_RCH_FRE_4MHz,

    /**
     * \brief RCLڲʱӾƵʣHz
     *
     * \note Ƶѡ    38.4k        32.768K
     *       ƵʣĬʹ38.4k
     */
    AMHW_HC32_RCl_FRE_38400Hz,

    /** \brief
     *    PLLʱԴѡ
     *    -# AMHW_HC32_PLL_INPUT_FRE_SRC_XTH_XTAL : XTHɵʱ
     *    -# AMHW_HC32_PLL_INPUT_FRE_SRC_XTH_PF00 : XTHӹܽPF00ʱ
     *    -# AMHW_HC32_PLL_INPUT_FRE_SRC_RCH      : RCHʱ
     */
    AMHW_HC32_PLL_INPUT_FRE_SRC_RCH,

    /**
     * \brief PLL ƵϵΧ 2 ~ 12
     *        PLLOUT = PLLIN * pll_mul
     */
    12,

    /** \brief
     *    ϵͳ ʱԴѡ
     *    -# AMHW_HC32_SYSCLK_RCH : ڲʱΪϵͳʱ
     *    -# AMHW_HC32_SYSCLK_XTH : ⲿʱΪϵͳʱ
     *    -# AMHW_HC32_SYSCLK_RCL : ڲʱΪϵͳʱ
     *    -# AMHW_HC32_SYSCLK_XTL   ⲿʱΪϵͳʱ
     *    -# AMHW_HC32_SYSCLK_PLL  ڲPLLΪϵͳʱ
     */
	AMHW_HC32_SYSCLK_RCH,

    /**
     * \brief HCLKƵϵHCLK = SYSCLK / (2 ^ hclk_div)
     */
    0,

    /**
     * \brief PCLKƵϵPCLK = HCLK / (2 ^ pclk_div)
     */
    0,

    /** \brief ƽ̨ʼŵȹ */
    __hc32_clk_plfm_init,

    /** \brief ƽ̨ʼ */
    __hc32_clk_plfm_deinit,
};

/** \brief ʱ豸ʵ */
static am_hc32_clk_dev_t __g_clk_dev;

/**
 * \brief CLK ʵʼʼϵͳʱ
 *
 * \retval AM_OK : ʱӳɹʼ
 */
int am_hc32_clk_inst_deinit (void)
{
    return am_hc32_clk_init(&__g_clk_dev, &__g_clk_devinfo);
}

/**
 * @}
 */

/* end of file */
