/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116 GPIO ûļ
 * \sa am_hwconf_zlg116_gpio.c
 * 
 * \internal
 * \par Modification history
 * - 1.00 17-04-12  nwt, first implementation.
 * \endinternal
 */

#include "am_zlg116.h"
#include "am_gpio.h"
#include "am_zlg116_gpio.h"
#include "hw/amhw_zlg_gpio.h"
#include "am_zlg116_clk.h"

/**
 * \addtogroup am_if_src_hwconf_zlg116_gpio
 * \copydoc am_hwconf_zlg116_gpio.c
 * @{
 */

/** \brief GPIOƽ̨ʼ */
void __zlg116_plfm_gpio_init (void)
{

    /* ʹGPIOʱ */

    /* GPIO˿ʱ */
    am_clk_enable(CLK_GPIOA );
    am_clk_enable(CLK_GPIOB);
    am_clk_enable(CLK_GPIOC);
    am_clk_enable(CLK_GPIOD);

    /* ϵͳʱʹ(ȼAFIOʱ) */
    am_clk_enable(CLK_SYSCFG);

    /* λGPIO */
    am_zlg116_clk_reset(CLK_GPIOA);
    am_zlg116_clk_reset(CLK_GPIOB);
    am_zlg116_clk_reset(CLK_GPIOC);
    am_zlg116_clk_reset(CLK_GPIOD);
    am_zlg116_clk_reset(CLK_SYSCFG);
}

/** \brief GPIOƽ̨ȥʼ */
void __zlg116_plfm_gpio_deinit (void)
{

    /* λGPIO */
    am_zlg116_clk_reset(CLK_GPIOA);
    am_zlg116_clk_reset(CLK_GPIOB);
    am_zlg116_clk_reset(CLK_GPIOC);
    am_zlg116_clk_reset(CLK_GPIOD);
    am_zlg116_clk_reset(CLK_SYSCFG);

    /* GPIOʱ */

    /* GPIO˿ʱ */
    am_clk_disable(CLK_GPIOA);
    am_clk_disable(CLK_GPIOB);
    am_clk_disable(CLK_GPIOC);
    am_clk_disable(CLK_GPIOD);

    /* ϵͳʱӽ(ȼAFIOʱ) */
    am_clk_disable(CLK_SYSCFG);
}

/** \brief ŴϢڴ */
static struct am_zlg116_gpio_trigger_info __g_gpio_triginfos[PIN_INT_MAX];

/** \brief ŴϢӳ */
static uint8_t __g_gpio_infomap[PIN_INT_MAX];

/** \brief GPIO豸Ϣ */
const am_zlg116_gpio_devinfo_t __g_gpio_devinfo = {
     ZLG116_GPIO_BASE,          /**< \brief GPIOĴַ */
     ZLG116_SYSCFG_BASE,        /**< \brief SYSCFGüĴַ */
     ZLG116_EXTI_BASE,          /**< \brief ⲿ¼Ĵַ */

     {
          INUM_EXTI0_1,         /**< \brief ⲿж01 */
          INUM_EXTI2_3,         /**< \brief ⲿж23 */
          INUM_EXTI4_15         /**< \brief ⲿж415 */

     },

     PIN_INT_MAX,               /**< \brief GPIOֵ֧жϺ */
    __g_gpio_infomap,           /**< \brief ŴϢӳ */
    __g_gpio_triginfos,         /**< \brief ŴϢڴ */
    __zlg116_plfm_gpio_init,
    __zlg116_plfm_gpio_deinit
};

/** \brief GPIO豸ʵ */
am_zlg116_gpio_dev_t __g_gpio_dev;

/** \brief GPIO ʵʼ */
int am_zlg116_gpio_inst_init (void)
{
    return am_zlg116_gpio_init(&__g_gpio_dev, &__g_gpio_devinfo);
}

/** \brief GPIO ʵʼ */
void am_zlg116_gpio_inst_deinit (void)
{
    am_zlg116_gpio_deinit();
}


/**
 * @}
 */

/* end of file */
