/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116 SYSTICK ûļ
 * \sa am_hwconf_zlg116_systick.c
 *
 * \internal
 * \par Modification History
 * - 1.00 17-12-04  pea, first implementation
 * \endinternal
 */

#include "am_arm_systick.h"
#include "am_zlg116.h"
#include "hw/amhw_arm_systick.h"

/**
 * \addtogroup am_if_src_hwconf_zlg116_systick
 * \copydoc am_hwconf_zlg116_systick.c
 * @{
 */

/**
 * \brief 豸Ϣ
 * \note ʱԴΪϵͳʱӣ#AMHW_ARM_SYSTICK_CONFIG_CLKSRC_SYSTEMϵͳʱӵ 1/2
 *       #AMHW_ARM_SYSTICK_CONFIG_CLKSRC_SYSTEM_HALF
 */
static const am_arm_systick_devinfo_t __g_systick_devinfo = {
    ZLG116_SYSTICK_BASE,                   /**< \brief ָ SYSTICK Ĵָ */
    CLK_SYSCFG,                            /**< \brief SYSTICK ʱ ID */
    AMHW_ARM_SYSTICK_CONFIG_CLKSRC_SYSTEM, /**< \brief SYSTICK ʱѡϵͳʱ */

    NULL,                                  /**< \brief ƽ̨ʼ */
    NULL                                   /**< \brief ƽ̨ȥʼ */
};

/** \brief 豸ʵ */
static am_arm_systick_dev_t __g_systick_dev;
static am_timer_handle_t    __g_systick_timer_handle = NULL;

/** \brief SYSTICK ʵʼ TIMER ׼ */
am_timer_handle_t am_zlg116_systick_inst_init (void)
{
    if (__g_systick_timer_handle == NULL) {
        __g_systick_timer_handle = am_arm_systick_init(&__g_systick_dev,
                                                       &__g_systick_devinfo);
    }

    return __g_systick_timer_handle;
}

/** \brief SYSTICK ʵʼ */
void am_zlg116_systick_inst_deinit (am_timer_handle_t handle)
{
    if (__g_systick_timer_handle == handle) {
        am_arm_systick_deinit(handle);
        __g_systick_timer_handle = NULL;
    }

}

/**
 * @}
 */

/* end of file */
