/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief HC32 CLK ûļ
 * \sa am_hwconf_hc32_clk.c
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-04  zp, first implementation
 * \endinternal
 */
#include "am_gpio.h"
#include "am_zlg116_clk.h"
#include "hw/amhw_zlg116_rcc.h"
#include "zlg116_pin.h"
/**
 * \addtogroup am_if_src_hwconf_hc32_clk
 * \copydoc am_hwconf_hc32_clk.c
 * @{
 */
/** \brief CLK ƽ̨ʼ */
static void __zlg_clk_plfm_init (void)
{
}

/** \brief CLK豸Ϣ */
static const am_zlg116_clk_devinfo_t __g_clk_devinfo =
{
    /**
     * \brief HSEOSCⲿƵ
     *
     *  pllin_srcѡ AMHW_ZLG116_PLLCLK_HSE  PLLIN = hse_osc
     *  PLLIN = 12000000
     */
    16000000,
    /** \brief
     *    PLL ʱԴѡ
     *    -# AMHW_ZLG116_PLLCLK_HSI_DIV4 : HSI   4 ƵΪPLLʱ
     *    -# AMHW_ZLG116_PLLCLK_HSE      : HSE ΪPLLʱ
     */
    AMHW_ZLG116_PLLCLK_HSE,
    /**
     * \brief PLL Ƶϵѡ1-64
     *        PLLOUT = PLLIN * pll_mul / pll_div
     *        PLLOUT  = 12000000 * 4 / 1 = 48Mhz
     */
    3,
    /**
     * \brief PLL Ƶϵѡ1-8
     *        PLLOUT = PLLIN * pll_mul / pll_div
     *        PLLOUT  = 12000000 * 4 / 1 = 48Mhz
     */
    1,
    /** \brief USBƵϵUSBCLK = PLLOUT / (usb_div + 1),ó48Mhz */
    0,
    /**
     * \brief AHBƵϵAHBCLK = PLLOUT / DIV,AHBƵΪ48Mhz
     *
     *    ahb_div |  DIV
     *   ---------------------
     *        0-7 |   1
     *        8   |   2
     *        9   |   4
     *        10  |   8
     *        11  |   16
     *        12  |   64
     *        13  |  128
     *        14  |  256
     *        15  |  512
     */
    0,
    /**
     * \brief APB1ƵϵAPB1CLK = AHBCLK / (2 ^ apb1_div)
     *        APB1ƵΪ24Mhz
     */
    1,
    /**
     * \brief APB2ƵϵAPB2CLK = AHBCLK / (2 ^ apb2_div)
     *        APB2ƵΪ48Mhz
     */
    0,
    /* ƽ̨ʼʱŵȲ */
    __zlg_clk_plfm_init,
    /* CLKƽ̨ȥʼ */
    NULL
};

/** \brief ʱ豸ʵ */
static am_zlg116_clk_dev_t __g_clk_dev;

/**
 * \brief CLK ʵʼʼϵͳʱ
 *
 * \retval AM_OK : ʱӳɹʼ
 */
int am_aml166_clk_inst_deinit (void)
{
    return am_zlg116_clk_init(&__g_clk_dev, &__g_clk_devinfo);
}

/**
 * @}
 */

/* end of file */
