/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116Դ(͹ģʽļ)
 * \sa am_hwconf_zlg116_pwr.c
 * 
 * \internal
 * \par Modification history
 * - 1.00 17-04-18  nwt, first implementation.
 * \endinternal
 */

#include "am_zlg116.h"
#include "am_zlg116_pwr.h"
#include "am_zlg116_clk.h"

/**
 * \addtogroup am_if_src_hwconf_zlg116_pwr
 * \copydoc am_hwconf_zlg116_pwr.c
 * @{
 */

/** \brief PWRƽ̨ʼ */
void __zlg116_plfm_pwr_init (void)
{

    /* PWRԴӿʱʹ */
    am_clk_enable(CLK_PWR);

    /* λPWRԴӿ */
    am_zlg116_clk_reset(CLK_PWR);
}

/** \brief PWRƽ̨ȥʼ */
void __zlg116_plfm_pwr_deinit (void)
{

    /* λPWRԴӿ */
    am_zlg116_clk_reset(CLK_PWR);

    /* PWRʱ */
    am_clk_disable(CLK_PWR);

}
/** \brief ŴϢڴ */
static struct am_zlg116_pwr_mode_init __g_pwr_mode_init[3] = {
     {AM_ZLG116_PWR_MODE_SLEEP,   PIOA_8},
     {AM_ZLG116_PWR_MODE_STOP,    PIOA_8},
     {AM_ZLG116_PWR_MODE_STANBY,  PIOA_0},
};

/** \brief PVDϢڴ */
static struct am_zlg116_pwr_pvd_info __g_pwr_pvd_info = {
     AMHW_ZLG_PVD_LEVER_3_3V,    /**< \brief PVDصѹ */
     2,                          /**< \brief صѹģʽ */
     AM_TRUE                     /**< \brief ʹܼصѹ */
};

/** \brief PWR豸Ϣ */
const am_zlg116_pwr_devinfo_t __g_pwr_devinfo = {
    ZLG116_PWR_BASE,        /**< \brief PWRĴַ */
    ZLG116_BKP_BASE,        /**< \brief BKPüĴַ */
	ZLG116_EXTI_BASE,       /**< \brief EXTIĴַ */
    CLK_AHB,                /**< \brief AHBʱID */
    CLK_APB1,               /**< \brief APB1ʱID */
    CLK_APB2,               /**< \brief APB2ʱID */
    INUM_PVD,               /**< \brief pvdжID */
    __g_pwr_mode_init,      /**< \brief ָpwrģʽָ */
    &__g_pwr_pvd_info,      /**< \brief ָpvdѹϢָ */
    __zlg116_plfm_pwr_init,
    __zlg116_plfm_pwr_deinit
};

/** \brief PWR豸ʵ */
am_zlg116_pwr_dev_t __g_pwr_dev;

/** \brief PWR ʵʼ */
am_zlg116_pwr_handle_t am_zlg116_pwr_inst_init (void)
{
    return am_zlg116_pwr_init(&__g_pwr_dev, &__g_pwr_devinfo);
}

/** \brief PWR ʵʼ */
void am_zlg116_pwr_inst_deinit (void)
{
    am_zlg116_pwr_deinit();
}

/**
 * @}
 */

/* end of file */
