/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116 TIMڲܵûļ
 * \sa am_hwconf_zlg116_tim_cap.c
 * 
 * \internal
 * \par Modification history
 * - 1.00 17-04-21  nwt, first implementation.
 * \endinternal
 */

#include "ametal.h"
#include "am_zlg116.h"
#include "am_zlg_tim_cap.h"
#include "am_gpio.h"
#include "am_clk.h"
#include "am_zlg116_clk.h"

/**
 * \addtogroup am_if_src_hwconf_zlg116_tim_cap
 * \copydoc am_hwconf_zlg116_tim_cap.c
 * @{
 */
 
/*******************************************************************************
 * TIM1 
 ******************************************************************************/

/** \brief TIM1ڲܵƽ̨ʼ */
void __zlg_plfm_tim1_cap_init (void)
{

    /* ʹܸ߼ʱ1ʱ */
    am_clk_enable(CLK_TIM1);

    /* λ߼ʱ1 */
    am_zlg116_clk_reset(CLK_TIM1);
}

/** \brief TIM1ƽ̨ʼ */
void __zlg_plfm_tim1_cap_deinit (void)
{

    /* λ߼ʱ1 */
    am_zlg116_clk_reset(CLK_TIM1);

    /* ܸ߼ʱ1ʱ */
    am_clk_disable(CLK_TIM1);
}

/** \brief TIM1ڲܵϢб */
am_zlg_tim_cap_ioinfo_t __g_tim1_cap_ioinfo_list[] = {

    /** \brief ͨ1 */
    {PIOA_8,  PIOA_8_TIM1_CH1  | PIOA_8_INPUT_FLOAT,  PIOA_8_GPIO  | PIOA_8_INPUT_FLOAT},

    /** \brief ͨ2 */
    {PIOA_9,  PIOA_9_TIM1_CH2  | PIOA_9_INPUT_FLOAT,  PIOA_9_GPIO  | PIOA_9_INPUT_FLOAT},

    /** \brief ͨ3 */
    {PIOA_10, PIOA_10_TIM1_CH3 | PIOA_10_INPUT_FLOAT, PIOA_10_GPIO | PIOA_10_INPUT_FLOAT},

    /** \brief ͨ4 */
    {PIOA_11, PIOA_11_TIM1_CH4 | PIOA_11_INPUT_FLOAT, PIOA_11_GPIO | PIOA_11_INPUT_FLOAT}
};

/** \brief TIM1ڲܵ豸Ϣ */
const am_zlg_tim_cap_devinfo_t  __g_tim1_cap_devinfo = {
    ZLG116_TIM1_BASE,               /**< \brief TIM1ĴĻַ */
    INUM_TIM1_CC,                   /**< \brief TIM1жϱ */
    CLK_TIM1,                       /**< \brief TIM1ʱID */
    4,                              /**< \brief 4ͨ */
    &__g_tim1_cap_ioinfo_list[0],   /**< \brief Ϣб */
    AMHW_ZLG_TIM_TYPE0,             /**< \brief ʱ */
    __zlg_plfm_tim1_cap_init,       /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim1_cap_deinit      /**< \brief ƽ̨ʼ */
};

/** \brief TIM1ڲܵ豸 */
am_zlg_tim_cap_dev_t  __g_tim1_cap_dev;

/** \brief tim1 capʵʼcap׼ */
am_cap_handle_t am_zlg116_tim1_cap_inst_init (void)
{
    return am_zlg_tim_cap_init(&__g_tim1_cap_dev,
                               &__g_tim1_cap_devinfo);
}

/** \brief tim1 capʵʼ */
void am_zlg116_tim1_cap_inst_deinit (am_cap_handle_t handle)
{
    am_zlg_tim_cap_deinit(handle);
}

/*******************************************************************************
 * TIM2 
 ******************************************************************************/

/** \brief TIM2ڲܵƽ̨ʼ */
void __zlg_plfm_tim2_cap_init (void)
{

    /* ʹͨöʱ2ʱ */
    am_clk_enable(CLK_TIM2);

    /* λͨöʱ2 */
    am_zlg116_clk_reset(CLK_TIM2);
}

/** \brief TIM2ƽ̨ʼ */
void __zlg_plfm_tim2_cap_deinit (void)
{

    /* λͨöʱ2 */
    am_zlg116_clk_reset(CLK_TIM2);

    /* ͨöʱ2ʱ */
    am_clk_disable(CLK_TIM2);
}

/** \brief TIM2ڲܵϢб */
am_zlg_tim_cap_ioinfo_t __g_tim2_cap_ioinfo_list[] = {

    /** \brief ͨ1 */
    {PIOA_0, PIOA_0_TIM2_CH1_ETR | PIOA_0_INPUT_FLOAT, PIOA_0_GPIO | PIOA_0_INPUT_FLOAT},

    /** \brief ͨ2 */
    {PIOA_1, PIOA_1_TIM2_CH2     | PIOA_1_INPUT_FLOAT, PIOA_1_GPIO | PIOA_1_INPUT_FLOAT},
};

/** \brief TIM2ڲܵ豸Ϣ */
const am_zlg_tim_cap_devinfo_t  __g_tim2_cap_devinfo = {
    ZLG116_TIM2_BASE,               /**< \brief TIM2ĴĻַ */
    INUM_TIM2,                      /**< \brief TIM2жϱ */
    CLK_TIM2,                       /**< \brief TIM2ʱID */
    2,                              /**< \brief 4ͨ */
    &__g_tim2_cap_ioinfo_list[0],   /**< \brief Ϣб */
    AMHW_ZLG_TIM_TYPE1,             /**< \brief ʱ */
    __zlg_plfm_tim2_cap_init,       /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim2_cap_deinit      /**< \brief ƽ̨ʼ */
};

/** \brief TIM2ڲܵ豸 */
am_zlg_tim_cap_dev_t  __g_tim2_cap_dev;

/** \brief tim2 capʵʼcap׼ */
am_cap_handle_t am_zlg116_tim2_cap_inst_init (void)
{
    return am_zlg_tim_cap_init(&__g_tim2_cap_dev,
                                  &__g_tim2_cap_devinfo);
}

/** \brief tim2 capʵʼ */
void am_zlg116_tim2_cap_inst_deinit (am_cap_handle_t handle)
{
    am_zlg_tim_cap_deinit(handle);
}

/*******************************************************************************
 * TIM3 
 ******************************************************************************/

/** \brief TIM3ڲܵƽ̨ʼ */
void __zlg_plfm_tim3_cap_init (void)
{

    /* ʹͨöʱ3ʱ */
    am_clk_enable(CLK_TIM3);

    /* λͨöʱ3 */
    am_zlg116_clk_reset(CLK_TIM3);
}

/** \brief TIM3ƽ̨ʼ */
void __zlg_plfm_tim3_cap_deinit (void)
{

    /* λͨöʱ3 */
    am_zlg116_clk_reset(CLK_TIM3);

    /* ͨöʱ3ʱ */
    am_clk_disable(CLK_TIM3);
}

/** \brief TIM3ڲܵϢб */
am_zlg_tim_cap_ioinfo_t __g_tim3_cap_ioinfo_list[] = {

    /** \brief ͨ1 */
    {PIOB_4,  PIOB_4_TIM3_CH1 | PIOB_4_INPUT_FLOAT, PIOB_4_GPIO | PIOB_4_INPUT_FLOAT},

    /** \brief ͨ2 */
    {PIOB_5,  PIOB_5_TIM3_CH2 | PIOB_5_INPUT_FLOAT, PIOB_5_GPIO | PIOB_5_INPUT_FLOAT},
};

/** \brief TIM3ڲܵ豸Ϣ */
const am_zlg_tim_cap_devinfo_t  __g_tim3_cap_devinfo = {
    ZLG116_TIM3_BASE,               /**< \brief TIM3ĴĻַ */
    INUM_TIM3,                      /**< \brief TIM3жϱ */
    CLK_TIM3,                       /**< \brief TIM3ʱID */
    2,                              /**< \brief 4ͨ */
    &__g_tim3_cap_ioinfo_list[0],   /**< \brief Ϣб */
    AMHW_ZLG_TIM_TYPE1,             /**< \brief ʱ */
    __zlg_plfm_tim3_cap_init,       /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim3_cap_deinit      /**< \brief ƽ̨ʼ */

};

/** \brief TIM3ڲܵ豸 */
am_zlg_tim_cap_dev_t  __g_tim3_cap_dev;

/** \brief tim3 capʵʼcap׼ */
am_cap_handle_t am_zlg116_tim3_cap_inst_init (void)
{
    return am_zlg_tim_cap_init(&__g_tim3_cap_dev,
                                  &__g_tim3_cap_devinfo);
}

/** \brief tim3 capʵʼ */
void am_zlg116_tim3_cap_inst_deinit (am_cap_handle_t handle)
{
    am_zlg_tim_cap_deinit(handle);
}

/**
 * @}
 */

/* end of file */
