/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZLG116 TIM ʱûļ
 * \sa am_hwconf_zlg116_tim_timing.c
 * 
 * \internal
 * \par Modification history
 * - 1.00 17-04-21  nwt, first implementation.
 * \endinternal
 */

#include "ametal.h"
#include "am_clk.h"
#include "am_zlg116.h"
#include "am_zlg116_clk.h"
#include "am_zlg_tim_timing.h"

/**
 * \addtogroup am_if_src_hwconf_zlg116_tim_timing
 * \copydoc am_hwconf_zlg116_tim_timing.c
 * @{
 */

/*******************************************************************************
 * TIM1 
 ******************************************************************************/

/** \brief TIM1 ƽ̨ʼ */
void __zlg_plfm_tim1_timing_init (void)
{

    /* ʹܸ߼ʱ1ʱ */
    am_clk_enable(CLK_TIM1);

    /* λ߼ʱ1 */
    am_zlg116_clk_reset(CLK_TIM1);
}

/** \brief  TIM1 ƽ̨ʼ */
void __zlg_plfm_tim1_timing_deinit (void)
{

    /* λ߼ʱ1 */
    am_zlg116_clk_reset(CLK_TIM1);

    /* ܸ߼ʱ1ʱ */
    am_clk_disable(CLK_TIM1);
}


/** \brief TIM1 豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim1_timing_devinfo = {
    ZLG116_TIM1_BASE,                /**< \brief TIM1ĴĻַ */
    INUM_TIM1_BRK_UP_TRG_COM,        /**< \brief TIM1жϱ */
    CLK_TIM1,                        /**< \brief TIM1ʱID */
    AMHW_ZLG_TIM_TYPE0,              /**< \brief ʱ */
    __zlg_plfm_tim1_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim1_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM1 豸 */
am_zlg_tim_timing_dev_t  __g_tim1_timing_dev;

/** \brief ʱTIM1 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim1_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim1_timing_dev,
                                  &__g_tim1_timing_devinfo);
}

/** \brief TIM1 Timingʵʼ */
void am_zlg116_tim1_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}

/*******************************************************************************
 * TIM2 
 ******************************************************************************/

/** \brief TIM2 ƽ̨ʼ */
void __zlg_plfm_tim2_timing_init (void)
{

    /* ʹͨöʱ2ʱ */
    am_clk_enable(CLK_TIM2);

    /* λͨöʱ2 */
    am_zlg116_clk_reset(CLK_TIM2);
}

/** \brief  TIM2 ƽ̨ʼ */
void __zlg_plfm_tim2_timing_deinit (void)
{

    /* λͨöʱ2 */
    am_zlg116_clk_reset(CLK_TIM2);

    /* ͨöʱ2ʱ */
    am_clk_disable(CLK_TIM2);
}

/** \brief TIM2 豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim2_timing_devinfo = {
    ZLG116_TIM2_BASE,                /**< \brief TIM2ĴĻַ */
    INUM_TIM2,                       /**< \brief TIM2жϱ */
    CLK_TIM2,                        /**< \brief TIM2ʱID */
    AMHW_ZLG_TIM_TYPE1,              /**< \brief ʱ */
    __zlg_plfm_tim2_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim2_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM2 豸 */
am_zlg_tim_timing_dev_t  __g_tim2_timing_dev;

/** \brief TIM2 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim2_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim2_timing_dev,
                                  &__g_tim2_timing_devinfo);
}

/** \brief TIM2 Timingʵʼ */
void am_zlg116_tim2_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}


/*******************************************************************************
 * TIM3
 ******************************************************************************/
/** \brief TIM3ƽ̨ʼ */
void __zlg_plfm_tim3_timing_init (void)
{

    /* ʹͨöʱ3ʱ */
    am_clk_enable(CLK_TIM3);

    /* λͨöʱ3 */
    am_zlg116_clk_reset(CLK_TIM3);
}

/** \brief TIM3ƽ̨ʼ */
void __zlg_plfm_tim3_timing_deinit (void)
{

    /* λͨöʱ3 */
    am_zlg116_clk_reset(CLK_TIM3);

    /* ͨöʱ3ʱ */
    am_clk_disable(CLK_TIM3);
}

/** \brief TIM3 豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim3_timing_devinfo = {
    ZLG116_TIM3_BASE,                /**< \brief TIM3ĴĻַ */
    INUM_TIM3,                       /**< \brief TIM3жϱ */
    CLK_TIM3,                        /**< \brief TIM3ʱID */
    AMHW_ZLG_TIM_TYPE2,              /**< \brief ʱ */
    __zlg_plfm_tim3_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim3_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM3豸 */
am_zlg_tim_timing_dev_t  __g_tim3_timing_dev;

/** \brief TIM3 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim3_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim3_timing_dev,
                                  &__g_tim3_timing_devinfo);
}

/** \brief TIM3 Timingʵʼ */
void am_zlg116_tim3_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}

/*******************************************************************************
 * TIM14
 ******************************************************************************/
/** \brief TIM14ƽ̨ʼ */
void __zlg_plfm_tim14_timing_init (void)
{

    /* ʹͨöʱ14ʱ */
    am_clk_enable(CLK_TIM14);

    /* λͨöʱ14 */
    am_zlg116_clk_reset(CLK_TIM14);
}

/** \brief TIM14ƽ̨ʼ */
void __zlg_plfm_tim14_timing_deinit (void)
{

    /* λͨöʱ14 */
    am_zlg116_clk_reset(CLK_TIM14);

    /* ͨöʱ14ʱ */
    am_clk_disable(CLK_TIM14);
}

/** \brief TIM14豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim14_timing_devinfo = {
    ZLG116_TIM14_BASE,                /**< \brief TIM14ĴĻַ */
    INUM_TIM14,                       /**< \brief TIM14жϱ */
    CLK_TIM14,                        /**< \brief TIM14ʱID */
    AMHW_ZLG_TIM_TYPE3,               /**< \brief ʱ */
    __zlg_plfm_tim14_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim14_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM14豸 */
am_zlg_tim_timing_dev_t  __g_tim14_timing_dev;

/** \brief TIM14 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim14_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim14_timing_dev,
                                  &__g_tim14_timing_devinfo);
}

/** \brief TIM14 Timingʵʼ */
void am_zlg116_tim14_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}

/*******************************************************************************
 * TIM16
 ******************************************************************************/

/** \brief TIM16ƽ̨ʼ */
void __zlg_plfm_tim16_timing_init (void)
{

    /* ʹͨöʱ16ʱ */
    am_clk_enable(CLK_TIM16);

    /* λͨöʱ16 */
    am_zlg116_clk_reset(CLK_TIM16);
}

/** \brief TIM16ƽ̨ʼ */
void __zlg_plfm_tim16_timing_deinit (void)
{

    /* λͨöʱ16 */
    am_zlg116_clk_reset(CLK_TIM16);

    /* ͨöʱ16ʱ */
    am_clk_disable(CLK_TIM16);
}

/** \brief TIM16豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim16_timing_devinfo = {
    ZLG116_TIM16_BASE,                /**< \brief TIM16ĴĻַ */
    INUM_TIM16,                       /**< \brief TIM16жϱ */
    CLK_TIM16,                        /**< \brief TIM16ʱID */
    AMHW_ZLG_TIM_TYPE3,               /**< \brief ʱ */
    __zlg_plfm_tim16_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim16_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM16豸 */
am_zlg_tim_timing_dev_t  __g_tim16_timing_dev;

/** \brief ʱTIM16 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim16_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim16_timing_dev,
                                  &__g_tim16_timing_devinfo);
}

/** \brief TIM16 Timingʵʼ */
void am_zlg116_tim16_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}

/*******************************************************************************
 * TIM17
 ******************************************************************************/

/** \brief TIM17ƽ̨ʼ */
void __zlg_plfm_tim17_timing_init (void)
{

    /* ʹͨöʱ17ʱ */
    am_clk_enable(CLK_TIM17);

    /* λͨöʱ17 */
    am_zlg116_clk_reset(CLK_TIM17);
}

/** \brief TIM17ƽ̨ʼ */
void __zlg_plfm_tim17_timing_deinit (void)
{

    /* λͨöʱ17 */
    am_zlg116_clk_reset(CLK_TIM17);

    /* ͨöʱ17ʱ */
    am_clk_disable(CLK_TIM17);
}

/** \brief TIM17豸Ϣ */
const am_zlg_tim_timing_devinfo_t  __g_tim17_timing_devinfo = {
    ZLG116_TIM17_BASE,                /**< \brief TIM17ĴĻַ */
    INUM_TIM17,                       /**< \brief TIM17жϱ */
    CLK_TIM17,                        /**< \brief TIM17ʱID */
    AMHW_ZLG_TIM_TYPE3,               /**< \brief ʱ */
    __zlg_plfm_tim17_timing_init,     /**< \brief ƽ̨ʼ */
    __zlg_plfm_tim17_timing_deinit    /**< \brief ƽ̨ʼ */
};

/** \brief TIM17豸 */
am_zlg_tim_timing_dev_t  __g_tim17_timing_dev;

/** \brief ʱTIM17 TimingʵʼTimer׼ */
am_timer_handle_t am_zlg116_tim17_timing_inst_init (void)
{
    return am_zlg_tim_timing_init(&__g_tim17_timing_dev,
                                     &__g_tim17_timing_devinfo);
}

/** \brief TIM17 Timingʵʼ */
void am_zlg116_tim17_timing_inst_deinit (am_timer_handle_t handle)
{
    am_zlg_tim_timing_deinit(handle);
}

/**
 * @}
 */

/* end of file */
