/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief MicroPort ļ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-11-13  pea, first implementation
 * \endinternal
 */

#ifndef __AM_HWCONF_MICROPORT_H
#define __AM_HWCONF_MICROPORT_H

#include "ametal.h"
#include "am_time.h"
#include "am_alarm_clk.h"
#include "am_ds1302.h"
#include "am_pcf85063.h"
#include "am_rx8025t.h"
#include "am_mtd.h"
#include "am_ftl.h"
#include "am_mx25xx.h"
#include "am_ep24cxx.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/*******************************************************************************
  MicroPort DS1302 ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort DS1302 ʵʼʹоƬ⹦ܣ
 *
 * \param 
 *
 * \return DS1302 ׼ΪNULLʼʧ
 */
am_ds1302_handle_t am_microport_ds1302_inst_init (void);

/**
 * \brief MicroPort DS1302 ʵʼʹͨõ RTC ܣ
 *
 * \param 
 *
 * \return RTC ׼ΪNULLʼʧ
 */
am_rtc_handle_t am_microport_ds1302_rtc_inst_init (void);

/**
 * \brief MicroPort DS1302 ʵʼ DS1302 ϵͳʱ䣩
 *
 * \param 
 *
 * \retval AM_OK       ɹ
 * \retval -AM_EINVAL  
 */
int am_microport_ds1302_time_inst_init (void);

/*******************************************************************************
  MicroPort RTC(PCF85063) ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort RTC(PCF85063) ʵʼʹоƬ⹦ܣ
 * \param 
 * \return PCF85063 ׼ΪNULLʼʧ
 */
am_pcf85063_handle_t am_microport_rtc_inst_init (void);

/**
 * \brief MicroPort RTC(PCF85063) ʵʼʹͨõ RTC ܣ
 * \param 
 * \return RTC ׼ΪNULLʼʧ
 */
am_rtc_handle_t am_microport_rtc_std_inst_init (void);

#if 0
/**
 * \brief MicroPort RTC(PCF85063) ʵʼʹͨõӹܣ
 *
 * \param 
 *
 * \return ALARM_CLK ׼ΪNULLʼʧ
 */
am_alarm_clk_handle_t am_microport_rtc_alarm_clk_inst_init (void);
#endif

/**
 * \brief MicroPort RTC(PCF85063) ʵʼ PCF85063 ϵͳʱ䣩
 *
 * \param 
 *
 * \retval AM_OK       ɹ
 * \retval -AM_EINVAL  
 */
int am_microport_rtc_time_inst_init (void);

/*******************************************************************************
  MicroPort RX8025T ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort RX8025T ʵʼʹоƬ⹦ܣ
 *
 * \param 
 *
 * \return RX8025T ׼ΪNULLʼʧ
 */
am_rx8025t_handle_t am_microport_rx8025t_inst_init (void);

/**
 * \brief MicroPort RX8025T ʵʼʹͨõ RTC ܣ
 *
 * \param 
 *
 * \return RTC ׼ΪNULLʼʧ
 */
am_rtc_handle_t am_microport_rx8025t_rtc_inst_init (void);

#if 0
/**
 * \brief MicroPort RX8025T ʵʼʹͨõӹܣ
 *
 * \param 
 *
 * \return ALARM_CLK ׼ΪNULLʼʧ
 */
am_alarm_clk_handle_t  am_microport_rx8025t_alarm_clk_inst_init (void);
#endif

/**
 * \brief MicroPort RX8025T ʵʼ RX8025T ϵͳʱ䣩
 *
 * \param 
 *
 * \retval AM_OK       ɹ
 * \retval -AM_EINVAL  
 */
int am_microport_rx8025t_time_inst_init (void);

/*******************************************************************************
  MicroPort FLASH(MX25xx) ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort FLASH(MX25xx) ʵʼ
 *
 * \param 
 *
 * \return MX25XX ׼ΪNULLʼʧ
 */
am_mx25xx_handle_t am_microport_flash_inst_init (void);

/**
 * \brief MicroPort FLASH(MX25xx) ʵʼ(ʹ MTD ׼ӿ)
 *
 * \param 
 *
 * \return MTD ׼ΪNULLʼʧ
 */
am_mtd_handle_t am_microport_flash_mtd_inst_init (void);

/**
 * \brief MicroPort FLASH(MX25xx) ʵʼ(ʹ FTL ׼ӿ)
 *
 * \param 
 *
 * \return FTL ׼ΪNULLʼʧ
 */
am_ftl_handle_t am_microport_flash_ftl_inst_init (void);

/*******************************************************************************
  MicroPort EEPROM ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort EEPROM ʵʼʹоƬܣ
 *
 * \param 
 *
 * \return EP24CXX ׼ΪNULLʼʧ
 */
am_ep24cxx_handle_t am_microport_eeprom_inst_init (void);

/**
 * \brief MicroPort EEPROM ʵʼ FM24C02 ׼ NVRAM 豸
 *
 * \param 
 *
 * \return AM_OK, ṩNVRAMɹֵṩNVRAMʧܡ
 */
int am_microport_eeprom_nvram_inst_init (void);

/*******************************************************************************
  MicroPort RS485 ʵʼ
*******************************************************************************/

/**
 * \brief MicroPort RS485 ʵʼ
 *
 * \param 
 *
 * \return UART ׼ΪNULLʼʧ
 */
am_uart_handle_t am_microport_rs485_inst_init (void);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __AM_HWCONF_MICROPORT_H */

/* end of file */
