/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief MiniPort-View ļ
 * \sa am_hwconf_miniport_view.c
 *
 * ԵʹãҲԺ MiniPort-595 ʹãԽʡš
 *
 * ǰֵ֧÷У
 * 1. MiniPort-View                : am_miniport_view_inst_init();
 * 2. MiniPort-View + MiniPort-595 : am_miniport_view_595_inst_init();
 *
 * \internal
 * \par Modification history
 * - 1.00 17-07-25  tee, first implementation.
 * \endinternal
 */

#include <am_aml166_inst_init.h>
#include "ametal.h"
#include "am_key_matrix_gpio.h"
#include "am_key_matrix_softimer.h"
#include "am_digitron_scan_gpio.h"
#include "am_digitron_scan_hc595_gpio.h"
#include "am_miniport_view_key.h"
#include "zlg116_pin.h"
#include "am_input.h"
#include "am_miniport_view_key_595.h"

/**
 * \addtogroup am_if_src_hwconf_miniport_view
 * \copydoc am_hwconf_miniport_view.c
 * @{
 */

/*******************************************************************************
   ɨϢ am_digitron_scan_devinfo_tͣ
*******************************************************************************/

/* ʾ棬8ܣΪuint8_tСΪܸ2 */
static uint8_t __g_disp_buf[2];

/* ɨ軺棬8ܣΪuint8_tÿνɨһܣ˴СΪ1 */
static uint8_t __g_scan_buf[1];

/*******************************************************************************
   GPIOϢ
*******************************************************************************/
static const int __g_digitron_seg_pins[] = {
    PIOB_7, PIOB_6, PIOA_7, PIOA_5, PIOA_11, PIOA_6, PIOA_4, PIOA_0
};

/*******************************************************************************
   GPIOλϢ
*******************************************************************************/
static const int __g_digitron_com_pins[] = {
    PIOA_1, PIOA_15 //todo
};

/*******************************************************************************
   Public functions
*******************************************************************************/

/* MiniPort-View ʹʵʼ */
int am_miniport_view_inst_init (void)
{
    static am_digitron_scan_gpio_dev_t         miniport_view;
    static const am_digitron_scan_gpio_info_t  miniport_view_info = {
        {
            {
                0,                       /* ܶӦʾIDΪ0 */
            },
            50,                          /* ɨƵʣ 50Hz */
            500,                         /* ˸ʱʱ500ms */
            500,                         /* ˸ʱʱ500ms */
            __g_disp_buf,                /* ʾ */
            __g_scan_buf,                /* ɨ軺 */
        },
        {
            8,                           /* 8 */
            1,                           /*  */
            2,                           /*  */
            AM_DIGITRON_SCAN_MODE_COL,   /* ɨ跽ʽɨ */
            AM_TRUE,                     /* ͵ƽЧ */
            AM_FALSE,                     /* λѡ͵ƽЧ */
        },
        __g_digitron_seg_pins,
        __g_digitron_com_pins,
    };

    return am_digitron_scan_gpio_init(&miniport_view, &miniport_view_info);
}

/******************************************************************************/

/* MiniPort-View   MiniPort-595 ʹʵʼ */
int am_miniport_view_595_inst_init (void)
{
    static am_digitron_scan_hc595_gpio_dev_t         miniport_view_595;
    static const am_digitron_scan_hc595_gpio_info_t  miniport_view_595_info = {
        {
            {
                0,                       /* ܶӦʾIDΪ0 */
            },
            50,                          /* ɨƵʣ 50Hz */
            500,                         /* ˸ʱʱ500ms */
            500,                         /* ˸ʱʱ500ms */
            __g_disp_buf,                /* ʾ */
            __g_scan_buf,                /* ɨ軺 */
        },
        {
            8,                           /* 8 */
            1,                           /*  */
            2,                           /*  */
            AM_DIGITRON_SCAN_MODE_COL,   /* ɨ跽ʽɨ */
            AM_TRUE,                     /* ͵ƽЧ */
            AM_TRUE,                     /* λѡ͵ƽЧ */
        },
        __g_digitron_com_pins,
    };

    return am_digitron_scan_hc595_gpio_init(&miniport_view_595,
                                            &miniport_view_595_info,
                                            am_miniport_595_inst_init());
}

/**
 * @}
 */

/* end of file */
