/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ISR DEFER 弶֧
 *
 * \internal
 * \par modification history
 * - 1.00 12-10-23  orz, first implementation
 * \endinternal
 */

#include "ametal.h"
#include "am_isr_defer.h"
#include "am_bsp_isr_defer_pendsv.h"

/*******************************************************************************
  ڲ궨
*******************************************************************************/

/** \brief жϿƺ״̬Ĵ,0xE000ED04ڴPendSVж */
#define  __ICSR_ADDRESS  0xE000ED04    

/** \brief ϵͳ쳣ȼüĴַ 0xE000ED20  */
#define  __SHP2_ADDRESS  0xE000ED20    

/*******************************************************************************
  ڲ
*******************************************************************************/
static void __isr_defer_trigger (void *p_arg)
{
    /* PendSVж */
    *(volatile unsigned int *)__ICSR_ADDRESS |= 0x10000000;
}

/*******************************************************************************
  жϴ
*******************************************************************************/
void PendSV_Handler (void)
{
    am_isr_defer_job_process();
}
 
/*******************************************************************************
  ȼĿ
*******************************************************************************/
AM_ISR_DEFER_PRIORITY_NUM_DEF(AM_BSP_ISR_DEFER_PRIORITY_NUM);

/*******************************************************************************
  
*******************************************************************************/
void am_bsp_isr_defer_pendsv_init (void)
{
    /* PendSVȼΪ */
    *(volatile unsigned int *)__SHP2_ADDRESS  |= (0xC0ul << 16);
 
    am_isr_defer_init(__isr_defer_trigger, NULL);
}
 
/* end of file */
