/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief FM175xx LPCDģʽ
 *
 * - 裺
 *   1. ȷӲúôڡ
 *   2. ȷӺߡ
 *
 * - ʵ
 *   1. ִв1 2 󿨽͹ԶƬ⣨LPCDģʽ
 *   2. øӦFM175xx豸жϱ־ִӦ趨
 *   3. ƿƬ󣬴ﵽ趨AUTO_WUP_TIMEʱʱFM175xxԶ˳LPCDģʽԶеУ
 *
 * \par Դ
 * \snippet demo_fm175xx_picca_lpcd_read_id.c src_fm175xx_picca_lpcd_read_id
 *
 * \internal
 * \par Modification history
 * - 1.00 18-08-20  htf, first implementation.
 * \endinternal
 */

/**
 * \addtogroup demo_if_fm175xx_picca_lpcd_read_id
 * \copydoc demo_fm175xx_picca_lpcd_read_id.c
 */

/** [src_fm175xx_picca_lpcd_read_id] */
#include "am_fm175xx.h"
#include "am_fm175xx_reg.h"
#include "am_vdebug.h"
#include "am_delay.h"

/**
 * \brief ص  ûԼ   ԶȡIDΪ
 */
static int8_t  picca_active_info(am_fm175xx_handle_t handle)
{
    uint8_t      tag_type[2]  = { 0 };      /* ATQA */
    uint8_t      uid[10]      = { 0 };      /* UID */
    uint8_t      uid_real_len =   0;        /* յUIDĳ */
    uint8_t      sak[3]       = { 0 };      /* SAK */
    uint8_t      i;

    /*   */
    if (AM_FM175XX_STATUS_SUCCESS == am_fm175xx_picca_active\
                                              (handle,
                                               AM_FM175XX_PICCA_REQ_ALL,
                                               tag_type,
                                               uid,
                                               &uid_real_len,
                                               sak)) {
        am_kprintf("ATQA :%02x %02x\n", tag_type[0], tag_type[1]);

        /* ӡUID */
        am_kprintf("UID  :");
        for (i = 0; i < uid_real_len; i++) {
            am_kprintf("%02x ", uid[i]);
        }
        am_kprintf("\n");

        /* ӡSAK */
        am_kprintf("SAK  :");
        for (i = 4; i <= uid_real_len; i+=3) {
            am_kprintf("%02x ", sak[(i - 4) / 3]);
        }
        am_kprintf("\n\n");
        return AM_OK;
    }else{
        return AM_ERROR;
    }
}

/**
 * \brief ûص
 *
 *  ж֮󽫻Զ˳LPCDģʽ  ٴνûam_fm175xx_lpcd_mode_entry
 *  ½LPCDģʽ
 */
static void  __fm175xx_lpcd_cb(void *p_arg)
{
    int *p_flag = (int *)p_arg;
    *p_flag =1;
}

/**
 * \brief LPCDģʽ
 */
void demo_fm175xx_picca_lpcd_mode (am_fm175xx_handle_t handle)
{
    int int_flag = 0;

    am_kprintf("FM175xx LPCD mode test!\n");

    /* ûص
     * ע⣬ʹINT SPI жϻصУFM175xxͨš
     * 򽫻ᷢͬȼжǶף³һֱжеȴжϷ
     */
    am_fm175xx_lpcd_cb_set(handle, __fm175xx_lpcd_cb, &int_flag);

    /* LPCDģʽ */
    am_fm175xx_lpcd_mode_entry(handle);

    while(1){
        uint8_t isr;

         /* ص 
          * ע⣬LPCDģʽֻᴥжϣжԼԶж
          */
        if(int_flag == 1){

            int_flag = 0;

            isr = am_fm175xx_get_reg_ext(handle, AM_FM175XX_LPCD_IRQ);

            if((isr & AM_FM175XX_LPCD_CARD_IRQ) == AM_FM175XX_LPCD_CARD_IRQ){

                /* ˳LPCDģʽҪԲFM175xx½ */
                am_fm175xx_exit_lpcd_config(handle);

                /*ڴ˽ӦĿ*/
                picca_active_info(handle);

                /* ʱԶж */
            }else if((isr & AM_FM175XX_LPCD_WUP_IRQ) == AM_FM175XX_LPCD_WUP_IRQ){
                am_fm175xx_lpcd_init(handle);
            }
            /* ٴνLPCDģʽ */
            am_fm175xx_lpcd_mode_entry(handle);

        }
    }
}

/** [src_fm175xx_picca_lpcd_read_id] */

/* end of file */
