/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2017 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ģԶ̣ͨ׼ӿʵ
 *
 * - ʵ
 *   1. Ƭֱͨ 48009600192003840057600  115200 Ĳ
 *      ZLG7021
 *   2. ӳɹͨڴӡǰĲʲ 500 ms ļ˸ LED0
 *      LED0  100 ms ļ˸
 *
 * \note
 *    1. LED0 Ҫ̽ J9 ñܱ PIO0_8 ƣ
 *    2. ۲촮ڴӡĵϢҪ PIO0_0  PC ڵ TXD
 *       PIO0_4  PC ڵ RXD
 *    3. Ա Demo  am_prj_config.h ڽ AM_CFG_KEY_GPIO_ENABLE
 *       AM_CFG_KEY_ENABLE  AM_CFG_SOFTIMER_ENABLE Ϊ 1Щ
 *       ѾĬΪ 1 ûٴã
 *    4. ZLG9021 ģӹϵ£
 * <pre>
 *           PIO0_26  <-->  ZLG9021_RX
 *           PIO0_27  <-->  ZLG9021_TX
 *           PIO0_16  <-->  ZLG9021_EN
 *           PIO0_25  <-->  ZLG9021_BRTS
 *           PIO0_28  <-->  ZLG9021_RESET
 * </pre>
 *       Ҫʹ ZLG9021Щ IO ڲ;
 *
 * \par Դ
 * \snippet demo_zlg9021_baudrate.c src_zlg9021_baudrate
 *
 * \internal
 * \par Modification history
 * - 1.00 17-12-08  pea, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg9021_baudrate
 * \copydoc demo_zlg9021_baudrate.c
 */

/** [src_zlg9021_baudrate] */
#include "ametal.h"
#include "am_zlg9021.h"
#include "am_vdebug.h"
#include "am_delay.h"
#include "am_led.h"

/**
 * \brief ˸ LED0
 */
static void flash_led (void)
{
    while (1) {
        am_led_on(0);
        am_mdelay(100);
        am_led_off(0);
        am_mdelay(100);
    }
}

/**
 * \brief 
 */
void demo_zlg9021_baudrate_entry (am_zlg9021_handle_t zlg9021_handle)
{
    int32_t   i                      = 0;
    uint32_t  zlg9021_baudrate       = 0;
    uint32_t  zlg9021_baudrate_tab[] = {4800, 9600, 19200, 38400, 57600, 115200};

    /* ȴģʼ(ģʼ֮ᷢ "TTM:ZLG9021P0-1-TC") */
    am_mdelay(500);

    /* ģ */
    for (i = 0; i < AM_NELEMENTS(zlg9021_baudrate_tab); i++) {

        /*  ZLG9021 ͨŵĴڵĲ */
        am_uart_ioctl(zlg9021_handle->uart_handle,
                      AM_UART_BAUD_SET,
                      (void *)zlg9021_baudrate_tab[i]);

        /* Իȡ ZLG9021 Ĳ */
        am_zlg9021_ioctl(zlg9021_handle,
                         AM_ZLG9021_BAUD_GET,
                         (void *)&zlg9021_baudrate);

        if (zlg9021_baudrate_tab[i] == zlg9021_baudrate) {
            AM_DBG_INFO("ZLG9021 BAUDRATE: %d\r\n", zlg9021_baudrate);
            break;
        }
    }

    if (i == AM_NELEMENTS(zlg9021_baudrate_tab)) {
        AM_DBG_INFO("AM_ZLG9021_BAUD_GET failed\r\n");
        flash_led();
    }

    while (1) {
        am_led_on(0);
        am_mdelay(500);
        am_led_off(0);
        am_mdelay(500);
    }
}

/** [src_zlg9021_baudrate] */

/* end of file */
