/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief MTD 
 *
 * - ʵ
 *   1. ڴӡԽ
 *
 * \par Դ
 * \snippet demo_mtd.c src_mtd
 *
 * \internal
 * \par Modification history
 * - 1.00  17-11-13  pea, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_mtd
 * \copydoc demo_mtd.c
 */

/** [src_mtd] */
#include "ametal.h"
#include "am_mtd.h"
#include "am_delay.h"
#include "am_vdebug.h"

#define __BUF_SIZE 16 /**< \brief С */

/**
 * \brief 
 */
void demo_mtd_entry (am_mtd_handle_t mtd_handle, int32_t test_lenth)
{
    int     ret;
    uint8_t i;
    uint8_t wr_buf[__BUF_SIZE] = {0};    /* дݻ涨 */
    uint8_t rd_buf[__BUF_SIZE] = {0};    /* ݻ涨 */

    if (__BUF_SIZE < test_lenth) {
        test_lenth = __BUF_SIZE;
    }

    /* ䷢ͻ */
    for (i = 0;i < test_lenth; i++) {
        wr_buf[i] = i;
    }

    /*  */
    am_mtd_erase(mtd_handle, 0x001000, test_lenth);

    /* д */
    ret = am_mtd_write(mtd_handle, 0x001000, &wr_buf[0], test_lenth);

    if (ret != AM_OK) {
        AM_DBG_INFO("am_mtd_write error(id: %d).\r\n", ret);
        return;
    }
    am_mdelay(5);

    /*  */
    ret = am_mtd_read(mtd_handle, 0x001000, &rd_buf[0], test_lenth);

    if (ret != AM_OK) {
        AM_DBG_INFO("am_mtd_read error(id: %d).\r\n", ret);
        return;
    }

    /* УдͶȡǷһ */
    for (i = 0; i < test_lenth; i++) {
        AM_DBG_INFO("Read FLASH the %2dth data is %2x\r\n", i ,rd_buf[i]);

        /* Уʧ */
        if(wr_buf[i] != rd_buf[i]) {
            AM_DBG_INFO("verify failed at index %d.\r\n", i);
            break;
        }
    }

    if (test_lenth == i) {
        AM_DBG_INFO("verify success!\r\n");
    }

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_mtd] */

/* end of file */
