/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Stock Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief xmodemʾ̣ͨ׼ӿʵ
 *
 * - :
 *    1崮ӵڵôdemo֮ǰ
 *      ʼشڡ
 *    2֧Xmodemλ(Tera_termXshell)
 *      λѡصļʹXmodemЭ鴫䡣
 *
 * - ʵ:
 *   ļÿ֡涨ֽ(1281024ֽ)͵նˣն˶ݽнգ
 *   пܳһ¼:
 *   1ǽյ֡ݣͨڽȡһ֡ݴӡ¸ʽӡ:
 *     Current : %d data: %s
 *
 *   2ǷͷȡͣͨڴӡϢThe sender cancels the transmission!
 *
 *   3ļճɹͨڴӡϢFile received successfully !
 *
 *   4ݳͨڴӡ֡ϢCurrent data err !
 *
 *   5δӵλͨڴӡConnection Failed!
 *
 *   6ǳʱȻδܽյݣӡϢNo data was received for the timeout!
 *
 *   7ǵǰ֡УӡϢCurrent data check code err!
 *
 * \note ӡϢĴҪXmodemĴڷֿӡϢXmodem
 *       XmodemôΪuart0ӡϢӦΪuart1ǴԴޣ
 *       ԽӡϢע͵ļ128жԽյݽдӡʱм
 *       ַ'\0'ӡֹ̽ӡʣµݡ
 *
 * \internal
 * \par Modification history
 * - 1.00 18-09-6  xgg, first implementation.
 * \endinternal
 */

/**
 * \addtogroup demo_if_xmodem_receive
 * \copydoc demo_xmodem_receive.c
 */
/** [src_xmodem_receive] */
#include "ametal.h"
#include "am_xmodem.h"
#include "am_vdebug.h"

/*******************************************************************************
ȫֱ
*******************************************************************************/
/* ջص־*/
volatile static int __g_rx_flag  = 0;

/* ǰ¼*/
volatile static int __g_rx_event = 0;

/* յݻָ*/
volatile static void *__gp_rx_buff = NULL;

/**
 * \breif ûص
 * \param[in] p_arg    : ûصĲûڻص
 *                       ʹXmodemɽ˲
 * \param[in] p_frames : Xmodemյһ֡ݱĵַûֱ
 *                       ʹøõַȡյһ֡
 * \param[in] event    : жeventֵ0һ֡ݽ
 *                       ɹeventǽյֽɹܵһ
 *                       ֡ݺ󣬿Եam_xmodem_rec_ack_setӿ
 *                       һ֡ݣeventֵΪʧܣ
 *                       eventֵжִ
 *                       -AM_ETIME       : һ֡ݳʱδյ
 *                       -AM_EBADMSG     : δʱطû涨ĴȻ
 *                       -AM_DATA_CAN    : ͷȡ͵´
 *                       -AM_DATA_SUC    : ļ
 *                       -AM_XMODEM_DOWN : λδڳʱʱλ
 *                       -AM_XMODEM_CHECK_ERR : һ֡У
 *
 * \note event¼δɲοam_xmodem.ham_xmodem_user_rx_t
 *    صע
 */
static void demo_rec_callback(void *p_arg, void *p_frames, int event)
{
    /* ջص־1*/
    __g_rx_flag  = 1;
    /* ¼*/
    __g_rx_event = event;
    /* ݻָ*/
    __gp_rx_buff = p_frames;
}

/* */
void demo_xmodem_rec_entry (am_xmodem_rec_handle_t  handle)
{
    /* 浱ǰѽյ֡*/
    uint32_t index_rx_frames = 0;

    if (handle == NULL) {
        return;
    }

    /* עջص*/
    am_xmodem_rec_cb_reg(handle, demo_rec_callback, (void *)handle);

    /* ַ*/
    am_xmodem_rec_start(handle);

    while (1) {
        /* жϵǰǷлص¼*/
        if (__g_rx_flag) {

            __g_rx_flag = 0;

            if (__g_rx_event > 0) {
                __g_rx_event = 0;
                index_rx_frames++;
                /* ܵݴӡ*/
                am_kprintf("Current %d data: %s\r\n",
                           index_rx_frames,
                           __gp_rx_buff);
                am_xmodem_rec_ack_set(handle);
                continue;
            }

            /* жϵǰص¼*/
            switch (__g_rx_event) {

            /* ļɺ󣬴ӡɹļϢ*/
            case -AM_DATA_SUC:
                /* ¼־0*/
                __g_rx_event    = 0;
                index_rx_frames = 0;
                am_kprintf("File received successfully !\r\n");
                return;

            /* 쳣ȡͲӡһ֡ݳ*/
            case -AM_EBADMSG:
                /* ¼־0*/
                __g_rx_event = 0;
                /* ֡1ǳ֡*/
                index_rx_frames++;
                am_kprintf("Current %d data err !\r\n", index_rx_frames);
                am_xmodem_rec_can_set(handle);
                return;

            /* δӵλ*/
            case -AM_XMODEM_DOWN:
                /* ¼־0*/
                __g_rx_event = 0;
                am_kprintf("Connection Failed !\r\n");
                return;

            /* ͷȡ*/
            case -AM_DATA_CAN:
                /* ¼־0*/
                __g_rx_event    = 0;
                index_rx_frames = 0;
                am_kprintf("The sender cancels the transmission!\r\n");
                return;

            /* ʱδܽյ*/
            case -AM_ETIME:
                /* ¼־0*/
                __g_rx_event    = 0;
                index_rx_frames = 0;
                am_kprintf("No data was received for the timeout!\r\n");
                return;

            /* ǰ֡У*/
            case -AM_XMODEM_CHECK_ERR:
                /* ¼־0*/
                __g_rx_event = 0;
                index_rx_frames++;
                am_kprintf("Current %d data check code err!\r\n", index_rx_frames);
                am_xmodem_rec_can_set(handle);
                return;

            default:
                break;
            }
        }
        /* û*/
    }
}

/** [src_xmodem_receive] */

/* end of file */
