/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ADCͨͨDMA䣬ͨӿʵ
 *
 * - ʵ
 *   1. ӦADCͨӡѹֵ
 *
 * \par Դ
 * \snippet demo_zlg_adc_dma.c src_zlg_adc_dma
 *
 * \internal
 * \par Modification History
 * - 1.00 19-02-27  ipk, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg_adc_dma
 * \copydoc demo_zlg_adc_dma.c
 */

/** [src_zlg_adc_dma] */
#include "ametal.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zlg_dma.h"
#include "hw/amhw_zlg_dma.h"
#include "hw/amhw_zlg_adc.h"

#define  BUF_SIZE    10

static uint32_t __g_buf_dst[BUF_SIZE];   /**< \brief Ŀݻ */

static uint16_t __g_adc_dat[8];          /**< \brief ADCݻ */

static am_bool_t g_trans_done;           /**< \brief ɱ־ */

static amhw_zlg_dma_xfer_desc_t g_desc;  /**< \brief DMA */

static int *__gp_adc_chan = NULL;        /* ָADCͨб */

static int __g_adc_chan_num;             /* ADCͨ */

/**
 * \brief DMA жϷ
 */
static void dma_isr (void *p_arg , uint32_t flag)
{
    int i;
    int j;
    int cur_chan;

    if (flag == AM_ZLG_DMA_INT_NORMAL) {

        for (i = 0; i < BUF_SIZE; i++) {

            /* ȡǰDMAADCͨ */
            cur_chan = (__g_buf_dst[i] >> 16) & 0x0f;

            /* ADCͨǷϷ */
            for (j = 0; j < __g_adc_chan_num; j++) {
                if (cur_chan == __gp_adc_chan[j]) {
                    break;
                }
                if (j == __g_adc_chan_num - 1) {
                    return;
                }
            }

            /* 12λΪADCɼ */
            __g_adc_dat[cur_chan] = __g_buf_dst[i] & 0xfff;
        }

        g_trans_done = AM_TRUE;
    }
}

static void __zlg_adc_init (amhw_zlg_adc_t *p_hw_adc,
                            int            *p_adc_chan,
                            int             adc_chan_num)
{
    int i;

    __gp_adc_chan    = p_adc_chan;
    __g_adc_chan_num = adc_chan_num;

    amhw_zlg_adc_data_resolution(p_hw_adc, AMHW_ZLG_ADC_DATA_VALID_12BIT);
    amhw_zlg_adc_prescaler_val(p_hw_adc, 4);
    amhw_zlg_adc_chan_sample_time(p_hw_adc, AMHW_ZLG_ADC_CHAN_ST55_5);

    for (i = 0; i < adc_chan_num; i++) {
        amhw_zlg_adc_input_chan_enable(p_hw_adc, p_adc_chan[i]);
    }

    amhw_zlg_adc_cgf_reg_set(p_hw_adc, AMHW_ZLG_ADC_MODULE_EN_MASK);

    /* ʹADC DMA */
    amhw_zlg_adc_ctrl_reg_set(p_hw_adc,
                              AMHW_ZLG_ADC_DMA_EN_MASK);

    amhw_zlg_adc_data_scan_set(p_hw_adc, AMHW_ZLG_ADC_CONTINUE_SCAN);

    amhw_zlg_adc_data_transfer_set(p_hw_adc, AMHW_ZLG_ADC_DATA_TRANSFER_START);
}

/**
 * \brief 
 */
void demo_zlg_hw_adc_dma_entry (amhw_zlg_adc_t *p_hw_adc,
                                int            *p_adc_chan,
                                int             adc_chan_num,
                                uint8_t         dma_chan)
{
    uint32_t adc_mv = 0;    /* ѹ */
    uint32_t flags;
    int      i;

    am_kprintf("The ADC HW dma Demo\r\n");

    __zlg_adc_init(p_hw_adc, p_adc_chan, adc_chan_num);

    /*  DMA жϷ */
    am_zlg_dma_isr_connect(dma_chan, dma_isr, (void *)p_hw_adc);

    /* DMA  */
    flags = AMHW_ZLG_DMA_CHAN_PRIORITY_HIGH         |  /* жȼ  */
            AMHW_ZLG_DMA_CHAN_MEM_SIZE_32BIT        |  /* ڴݿ 2 ֽ */
            AMHW_ZLG_DMA_CHAN_PER_SIZE_32BIT        |  /* ݿ 2 ֽ */
            AMHW_ZLG_DMA_CHAN_MEM_ADD_INC_ENABLE    |  /* ڴַ */
            AMHW_ZLG_DMA_CHAN_PER_ADD_INC_DISABLE   |  /* ַ */
            AMHW_ZLG_DMA_CHAN_CIRCULAR_MODE_ENABLE  |  /* ѭģʽ */
            AMHW_ZLG_DMA_CHAN_INT_TX_CMP_ENABLE;       /* ʹDMAж */

        /* ͨ */
    am_zlg_dma_xfer_desc_build(&g_desc,                      /* ͨ */
                               (uint32_t)(&p_hw_adc->addata), /* Դݻ */
                               (uint32_t)(__g_buf_dst),    /* Ŀݻ */
                               sizeof(__g_buf_dst),         /* ֽ */
                               flags);                                     /*  */

    am_zlg_dma_xfer_desc_chan_cfg(&g_desc,
                                   AMHW_ZLG_DMA_PER_TO_MER, /* 赽ڴ */
                                   dma_chan);

    /*  DMA 䣬Ͽʼ */
    am_zlg_dma_chan_start(dma_chan);

    while(1) {

        while(g_trans_done == AM_FALSE); /* ȴ */

        for (i = 0; i < adc_chan_num; i++) {

            /* תΪѹֵӦֵ */
            adc_mv = __g_adc_dat[p_adc_chan[i]] * 3300 / ((1UL << 12) -1);

            am_kprintf("chan: %d, Sample : %d, Vol: %d mv\r\n", p_adc_chan[i],
                                                                __g_adc_dat[p_adc_chan[i]],
                                                                adc_mv);
        }

        am_kprintf("\r\n");
        am_mdelay(500);

        g_trans_done = AM_FALSE;
    }
}
/** [src_zlg_adc_dma] */

/* end of file */
