/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief CANжʾ
 *
 * - 裺
 *   1. ۲촮ڴӡĵϢҪ PIOA_3  PC ڵ TXD
 *      PIOA_2  PC ڵ RXD
 *   2. CAN1ŵCANշٽCANշӿUSBCAN-II豸
 *   3. CANλòΪ궨CAN_BAUDֵ
 *   4. 򿪴ڵնˣ115200-8-N-1.
 *
 * - ʵ
 *   1. жϺ󣬴ӡʾϢ
 *
 *      жϣڴӡȴʾϢλһݺ󣬳ɹѣӡʾϢ
 *      жϣÿյһݣڴӡIDţֽݡ
 *      жϣFIFO(3)󣬴ڴӡFIFOյĵһݣIDţֽݡ
 *      жϣÿ500mswhileѭзһݣݷͳɹ뷢жϣڴӡʾϢ
 *      󾯸жϣڴӡʾϢҴӡʹֵմֵ
 *      󱻶жϣڴӡʾϢҴӡʹֵմֵ
 *
 *      Ľṹcan_rcv_msgdemo_zlg237_can_int_entry()ʹõȫֱ(ѻ)
 *      ˽ջжϺλ͵ݣԹ̻ÿ500msظλ
 *
 *   2. ڴӡصϢ
 *
 * \par Դ
 * \snippet src_zlg237_can_int.c
 *
 * \internal
 * \par Modification History
 * - 19-08-08, zp, first implementation.
 * - 19-12-18, zc, add filter table extern 
 * \endinternal
 */

/**
 * \addtogroup demo_zlg237_can_int
 * \copydoc demo_zlg237_can_int.c
 */

/** [src_std_can] */
#include "ametal.h"
#include "am_can.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "amhw_zlg237_can.h"
#include "am_zlg237_can.h"

am_bool_t int_err_flag   = AM_FALSE;
am_bool_t int_sleep_flag = AM_FALSE;

am_can_message_t can_rcv_msg;

/* жϷжϺҪֶӦ־λһֱж*/
void can_int_handle(void *p_arg)
{

    am_zlg237_can_dev_t *p_dev    = (am_zlg237_can_dev_t *)p_arg;
    amhw_zlg237_can_t   *p_hw_can = NULL;

    am_can_int_type_t p_int_type     = 0;
    am_can_bus_err_t  p_bus_err      = 0;
    uint8_t           i              = 0;

    p_hw_can = (amhw_zlg237_can_t *)p_dev->p_devinfo->regbase;

    am_can_status_get(p_arg, &p_int_type , &p_bus_err);

    /* FIFOΪ3>3־Ч */
    if(p_int_type & AM_CAN_INT_DATAOVER) {

        am_kprintf("\r\nCAN int data over!\r\n");

        /* Զȡ */
        if(am_can_msg_recv(p_arg, &can_rcv_msg) == AM_CAN_NOERROR){

            am_kprintf("can recv id: 0x%x data:",can_rcv_msg.id);
            for (i = 0; i < can_rcv_msg.msglen; i++) {
                am_kprintf("0x%x  ",can_rcv_msg.msgdata[i]);
            }
            am_kprintf("\r\n");
        }

        /* FIFOԡȡһ֮ݼһ顣
         * ִһζȡɲִʵΪͷFIFOһΣ
         * ȡͷֻһֲݶʧ
         */

//        /* ͷһFIFO 0ñ־ */
//        amhw_zlg237_can_clear_itstatus (p_hw_can, AMHW_ZLG237_CAN_INT_FOVIE0);
//
//        /* ͷһFIFO 1ñ־ */
//        amhw_zlg237_can_clear_itstatus (p_hw_can, AMHW_ZLG237_CAN_INT_FOVIE1);
    }

    /* FIFOǿգΪ3>0ձ־Ч */
    if(p_int_type & AM_CAN_INT_RX) {

        am_kprintf("\r\nCAN int rx!\r\n");

        /* Զȡ */
        if(am_can_msg_recv(p_arg, &can_rcv_msg) == AM_CAN_NOERROR){

            am_kprintf("can recv id: 0x%x\r\ndata:",can_rcv_msg.id);
            for (i = 0; i < can_rcv_msg.msglen; i++) {
                am_kprintf("0x%x  ",can_rcv_msg.msgdata[i]);
            }
            am_kprintf("\r\n");
        }

        /* FIFOԡȡһ֮ݼһ顣
         * ִһζȡɲִʵΪͷFIFOһΣ
         * ȡͷֻһֲݶʧ
         */

//        /* ͷһFIFO 0FIFOΪʱñ־*/
//        amhw_zlg237_can_clear_itstatus(p_hw_can, AMHW_ZLG237_CAN_INT_FMPIE0);
//
//        /* ͷһFIFO 1FIFOΪʱñ־*/
//        amhw_zlg237_can_clear_itstatus(p_hw_can, AMHW_ZLG237_CAN_INT_FMPIE1);
    }

    /* ͽͱ־Ч */
    if(p_int_type & AM_CAN_INT_TX) {

        am_kprintf("\r\nCAN int tx!\r\n");

        /* ͷһFIFOFIFOΪʱñ־*/
        amhw_zlg237_can_clear_itstatus (p_hw_can, AMHW_ZLG237_CAN_INT_TMEIE);
    }

    /* ˯ģʽ£յ֡SOFλѱ־Ч */
    if(p_int_type & AM_CAN_INT_WAKE_UP) {
        am_kprintf("\r\nCAN int wake up!\r\n");

        int_sleep_flag = AM_FALSE;

        /* ѱ־ */
        amhw_zlg237_can_clear_itstatus (p_hw_can, AMHW_ZLG237_CAN_INT_WKUIE);
    }

    /* ̶ֵɸģͬ־յȷݣֵС1 */
    if(p_int_type & AM_CAN_INT_ERROR) {

        int_err_flag = AM_TRUE;

        am_kprintf("\r\nCAN int error  ");

        /* ֵ>96,󾯸־Ч */
        if(p_int_type & AM_CAN_INT_WARN) {
            am_kprintf("warning!");
        }

        /* ֵ>127,󱻶־Ч */
        if(p_int_type & AM_CAN_INT_ERROR_PASSIVE) {
            am_kprintf("passive!");
        }

        /* ֵ>255,߱־Ч */
        if(p_int_type & AM_CAN_INT_BUS_OFF) {
            am_kprintf("off!");
        }

        /* ־*/
        amhw_zlg237_can_clear_itstatus (p_hw_can, AMHW_ZLG237_CAN_INT_ERRIE);
    }
}

/* Ϣӡ */
void can_err_printf(am_can_handle_t  handle)
{
    int_err_flag = AM_FALSE;

    am_can_int_type_t p_int_type     = 0;
    am_can_bus_err_t  p_bus_err      = 0;
    am_can_err_cnt_t  am_can_err_cnt = {0, 0};

    am_can_status_get(handle, &p_int_type , &p_bus_err);

    /* ʽ */
    if (AM_CAN_BUS_ERR_FORM & p_bus_err) {
        am_kprintf("  lasterror_code form!");
    }

    /*  */
    if (AM_CAN_BUS_ERR_STUFF & p_bus_err) {
        am_kprintf("  lasterror_code stuff!");
    }

    /* δ֪     Դ   Դ  ô*/
    if (AM_CAN_BUS_ERR_UNKNOWN & p_bus_err) {
        am_kprintf("  lasterror_code unknown!");
    }

    /* ACK */
    if (AM_CAN_BUS_ERR_ACK & p_bus_err) {
        am_kprintf("  lasterror_code ack!");
    }

    /* CRC */
    if (AM_CAN_BUS_ERR_CRC & p_bus_err) {

    }

    /* ȡֵ */
    am_can_err_cnt_get (handle, &am_can_err_cnt);

    /* ӡ*/
    am_kprintf("   err_rx:%d , err_tx:%d\r\n",
               am_can_err_cnt.rx_error_cnt,
               am_can_err_cnt.tx_error_cnt);
}

/**
 * \brief 
 */
void demo_zlg237_can_int_entry (am_can_handle_t     can_handle,
                                am_can_bps_param_t *can_btr_baud,
                                am_can_int_type_t   int_type,
                                am_can_filter_t    *p_filterbuff,
                                size_t              lenth)
{
    am_can_err_t ret;

    can_rcv_msg.id         = 0x54;
    can_rcv_msg.msglen     = 3;
    can_rcv_msg.msgdata[0] = 0x78;
    can_rcv_msg.msgdata[0] = 0xfd;
    can_rcv_msg.msgdata[0] = 0xa8;

    /* ò */
    ret = am_can_baudrate_set (can_handle, can_btr_baud);

    if (ret == AM_CAN_NOERROR) {
        am_kprintf("\r\nCAN: controller baudrate set ok. \r\n");
    } else {
        am_kprintf("\r\nCAN: controller baudrate set error! %d \r\n", ret);
    }

    /* ˲ */
    ret = am_can_filter_tab_ext_set(can_handle,p_filterbuff, lenth);

    if (ret == AM_CAN_NOERROR) {
        am_kprintf("\r\nCAN: controller filter tab set ok. \r\n");
    } else {
        am_kprintf("\r\nCAN: controller filter tab set error! %d \r\n", ret);
    }

    /* жϷ  */
    /* ڶΪNULLʱڲĬжϷ __can_zlg237_int_handle
     * ɵam_can_intcb_connectûжϻص
     */
    am_can_connect(can_handle,can_int_handle,(void *)can_handle->p_drv);

    /* CANжʹܺ */
    am_can_int_enable(can_handle,int_type);

    /* can */
    ret = am_can_start (can_handle);

    if (ret == AM_CAN_NOERROR) {
        am_kprintf("\r\nCAN: controller start \r\n");
    } else {
        am_kprintf("\r\nCAN: controller start error! %d \r\n", ret);
    }

    if(int_type & AM_CAN_INT_WAKE_UP)
    {
        if(am_can_sleep(can_handle) == AM_CAN_NOERROR) {
            int_sleep_flag = AM_TRUE;
        }
    }

    AM_FOREVER {

        /* ڵȴ״̬ʱ */
        if(int_sleep_flag == AM_FALSE) {

            /* ͱ */
            am_can_msg_send(can_handle, &can_rcv_msg);
        } else {

            /* ڵȴ״̬ӡʾϢCANҪܱģߵûѺ*/
            am_kprintf("\r\nCAN: sleep mode! waiting for wakeup!\r\n");
        }

        /* ־Чôӡ */
        if(AM_TRUE == int_err_flag) {
            can_err_printf(can_handle);
        } else {
            am_mdelay(500);
        }

    }
}
/** [src_zlg237_can_int] */

/* end of file */
