/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief DACת DMẠͨ HW ӿʵ
 *
 * - ʵ
 *
 *   1. ڴӡ "DMA transfer done!"
 *   2. ӡǰDACѹֵ(ѹΪһҲֵ0mv ֵ 3300 mv)
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_10  PC ڵ TXD
 *       PIOA_9  PC ڵ RXD
 *    2. Դʹ뱾ͬӦںʹõϢ
 *      磺AM_DBG_INFO()
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_dac_dma.c src_zsl42x_hw_dac_dma
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-23  ly, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_dac_dma
 * \copydoc demo_zsl42x_hw_dac_dma.c
 */

/** [src_zsl42x_hw_dac_dma] */

#include "ametal.h"
#include "am_int.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zsl42x_dma.h"
#include "hw/amhw_zsl42x_dac.h"

/*******************************************************************************
  궨
*******************************************************************************/
static amhw_zsl42x_dac_t      *gp_hw_dac = NULL;     /**< \brief dac  */

/*******************************************************************************
  ȫֱ
*******************************************************************************/
static amhw_zsl42x_dma_xfer_desc_t g_desc;             /**< \brief DMA  */

static volatile am_bool_t       g_trans_done = AM_FALSE; /**< \brief ɱ־ */

static int32_t                  g_dma_chan = 0;        /**< \brief DMA ͨ */

static uint16_t                 vol_data = 0;          /**< \brief Ŀݻ */

/**
 * \brief DMA жϷ
 *
 * \param[in] p_arg : ûԶͨ am_zsl42x_dma_isr_connect() 
 * \param[in] flag  : DMAжϱ־ɵײ룬òĿȡֵ
 *                    (#AM_ZLG116_DMA_INT_ERROR)  (#AM_ZLG116_DMA_INT_NORMAL)
 *
 * \return 
 */
static void dac_dma_isr (void *p_arg , uint32_t flag)
{
    int flag_chan  = (int)p_arg;

    if (flag == AM_ZSL42x_DMA_INT_COMPLETE) {
        if (flag_chan == g_dma_chan) {

            g_trans_done = AM_TRUE;
        }
    } else {
        /* ûԶִд */
    }
}

/**
 * \brief DAC DMA
 */
static int dac_dma_tran_cfg (amhw_zsl42x_dac_t *p_hw_dac,
                             int32_t           dma_chan)
{

    uint32_t flags;

    /* DMAжϷ */
    am_zsl42x_dma_isr_connect(dma_chan, dac_dma_isr, (void *)dma_chan);

    /* DMA  */
    flags = AMHW_ZSL42x_DMA_CHAN_TRANSFER_MODE_BLOCK    | /* SPIֻп鴫ģʽ */
            AMHW_ZSL42x_DMA_CHAN_SIZE_16BIT             | /* λ 8bit */

            AMHW_ZSL42x_DMA_CHAN_SRC_ADD_INC_DISABLE     | /* Դַ */
            AMHW_ZSL42x_DMA_CHAN_RELOAD_SRC_ADD_ENABLE   | /* Դַ*/

            AMHW_ZSL42x_DMA_CHAN_DST_ADD_INC_DISABLE   | /* Ŀַ */
            AMHW_ZSL42x_DMA_CHAN_RELOAD_DST_ADD_ENABLE | /* Ŀַ */

            AMHW_ZSL42x_DMA_CHAN_RELOAD_COUNTER_ENABLE  | /*  */
            AMHW_ZSL42x_DMA_CHAN_INT_ERR_DISABLE        | /* жϽ */
            AMHW_ZSL42x_DMA_CHAN_INT_TX_CMP_ENABLE      | /* жʹ */
            AMHW_ZSL42x_DMA_CHAN_CIRCULAR_MODE_ENABLE ;   /* ѭģʽ */

    /* ͨ */
    am_zsl42x_dma_xfer_desc_build(&g_desc,                      /* ͨ */
                                   (uint32_t)(&vol_data),       /* Դݻ */
                                   (uint32_t)(&(p_hw_dac->dacdhr12r0)), /* Ŀݻ */
                                   1,                           /*  */
                                   flags);                      /*  */

    /* DMA䣬Ͽʼ */
    if (am_zsl42x_dma_xfer_desc_chan_cfg(&g_desc,
                                          AMHW_ZSL42x_DMA_PER_TO_MER, /* 赽 ڴ */
                                          (uint8_t)dma_chan) == AM_ERROR) {
        return AM_ERROR;
    } else {
        /*  */
    }

    return AM_OK;
}

/**
 * \brief DACʼ
 */
static void dac_hw_init(amhw_zsl42x_dac_t *p_hw_dac,
                        uint32_t           verf)
{

    if (p_hw_dac == NULL){
        return ;
    }

    /* òοѹԴ */
    amhw_zsl42x_dac_chan_sref_sel(p_hw_dac, verf);

    /* ʧ*/
    amhw_zsl42x_dac_chan_output_buf_disable(p_hw_dac);

    /* ʹ */
    amhw_zsl42x_dac_chan_trg_enable(p_hw_dac);

    /* ʽѡ  */
    amhw_zsl42x_dac_chan_trg_sel(p_hw_dac, AMHW_ZSL42x_DAC_CHAN_SOFTWARE_TRG);

    /* ʹdacͨ */
    amhw_zsl42x_dac_chan_enable(p_hw_dac);

}

/**
 * \brief DAC DMAʼ
 */
static void dac_hw_dma_init(amhw_zsl42x_dac_t *p_hw_dac)
{
    if (p_hw_dac == NULL){
        return ;
    }

    /* ʹDAC DMA */
    amhw_zsl42x_dac_chan_dma_enbale (p_hw_dac);
}

/**
 * \brief DACѹ̣hwӿڲʵ
 */
void demo_zsl42x_hw_dac_dma_entry(void     *p_hw_dac,
                                int32_t   dma_src,
                                int32_t   dma_chan,
                                uint16_t *p_vol_val)
{

    int i = 0;

    vol_data = p_vol_val[0];

    g_dma_chan = dma_chan;

    gp_hw_dac = (amhw_zsl42x_dac_t *)p_hw_dac;

    /* DAC ʼ Ĭϲοѹ ⲿοѹԴ  PB01*/
    dac_hw_init(gp_hw_dac, AMHW_ZSL42x_DAC_CHAN_MASK_AVCC_VOLT);

    /* DAC DMAʹ */
    dac_hw_dma_init(gp_hw_dac);

    /* ʼDMA */
    dac_dma_tran_cfg(gp_hw_dac, dma_chan);

    /* Ĭͨ0ͨ1ȼһѯ*/
    am_zsl42x_dma_priority_same();

    /* ôźԴ */
    am_zsl42x_dma_chan_src_set (dma_chan, dma_src);

    /* ʼͨ */
    am_zsl42x_dma_chan_start(dma_chan);

    AM_FOREVER {

        /*  */
        amhw_zsl42x_dac_chan_software_trg_enable(gp_hw_dac);

        /* ȴ */
        while (g_trans_done == AM_FALSE);

        g_trans_done = AM_FALSE;


        if (i == 128 )
        {
            vol_data = p_vol_val[0];
            i = 0;
        }else{
            i++;
            vol_data = p_vol_val[i];
        }
    }
}

