/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZSL42xϵ̺
 * \sa    demo_zsl42x_entries.h
 *
 * \internal
 * \par Modification history
 * - 1.00 17-05-02  tee, first implementation
 * \endinternal
 */

#ifndef __DEMO_ZSL42x_ENTRIES_H
#define __DEMO_ZSL42x_ENTRIES_H

#include "am_clk.h"
#include "am_timer.h"
#include "am_can.h"

#include "hw/amhw_zsl42x_adc.h"
#include "hw/amhw_zsl42x_flash.h"
#include "hw/amhw_zsl42x_gpio.h"
#include "hw/amhw_zsl42x_i2c.h"
#include "hw/amhw_zsl42x_spi.h"
#include "hw/amhw_zsl42x_dma.h"
#include "hw/amhw_zsl42x_tim.h"
#include "hw/amhw_zsl42x_uart.h"
#include "hw/amhw_zsl42x_wdt.h"
#include "hw/amhw_zsl42x_lvd.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief ADC Ӳ㣨ʹжϣ
 *
 * \param[in] p_hw_adc  : ָ ADC Ĵָ
 * \param[in] int_num   : жϺ
 * \param[in] chan      : ŶӦ ADCͨ
 * \param[in] vref_mv   : ADCοѹԽADCתΪѹֵʾ
 *
 * \note  һ£ʹñ demo ǰ ADC ģӦʱӣ
 *         ADC ͨӦţЩöоƬء
 *
 * \retval 
 */
void demo_zsl42x_hw_adc_int_entry (void    *p_hw_adc,
                                 int      int_num,
                                 uint8_t  chan,
                                 uint32_t vref_mv);

/**
 * \brief ADC Ӳ㣨ʹжϣ
 *
 * \param[in] p_hw_adc   : ָ ADC Ĵָ
 * \param[in] int_num    : жϺ
 * \param[in] vref_mv    : ADCοѹԽADCתΪѹֵʾ
 * \param[in] p_adc_chan : ADCָͨ
 * \param[in] sqr_num    : ͨ
 * \param[in] jqr_num    : ͨ
 *
 * \note һ£ʹñ demo ǰ ADC ģӦʱӣ
 *        ADC ͨӦţЩöоƬء
 *
 * \retval 
 */
void demo_zsl42x_hw_multichan_adc_entry (void    *p_hw_adc,
                                       int      int_num,
                                       uint32_t vref_mv,
                                       int     *p_adc_chan,
                                       uint8_t  sqr_num,
                                       uint8_t  jqr_num);

/**
 * \brief ADC Ӳ㣨DMA
 *
 * \param[in] p_hw_adc   : ָ ADC Ĵָ
 * \param[in] p_adc_chan : ADCָͨ
 * \param[in] chan_num   : ADCͨ
 * \param[in] vref_mv    : ADCοѹԽADCתΪѹֵʾ
 * \param[in] dma_chan   : DMAͨ
 * \param[in] dma_src    : DMA䴥Դ
 *
 * \note һ£ʹñ demo ǰ ADCģӦʱӣ
 *        ADC ͨӦţЩöоƬء
 *
 * \retval 
 */
void demo_zsl42x_hw_adc_dma_entry (void    *p_hw_adc,
                                 int     *p_adc_chan,
                                 int      chan_num,
                                 uint32_t vref_mv,
                                 int      dma_chan,
                                 uint8_t  dma_src);

/**
 * \brief CLK ̣ͨ HW ӿʵ
 *
 * \param[in] p_clk_id_buf ʱӺŵĻ
 * \param[in] buf_lenth    ʱӺŻС
 *
 * \retval 
 */
void demo_zsl42x_hw_clk_entry (am_clk_id_t *p_clk_id_buf, uint8_t buf_lenth);

/**
 * \brief DMA ڴ浽ڴ̣ͨӿʵ
 *
 * \param[in] dma_chan  DMA ͨ
 *
 * \retval 
 */
void demo_zsl42x_drv_dma_m2m_entry (uint32_t dma_chan);

/**
 * \brief FLASH ̣ͨӿʵ
 *
 * \param[in] p_hw_flash ָ FLASH Ĵָ
 * \param[in] sector     ʹ FLASH 
 *
 * \retval 
 */
void demo_zsl42x_drv_flash_entry (void *p_hw_flash, uint16_t sector);

/**
 * \brief GPIO ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_gpio  ָ GPIOĴָ
 * \param[in] input_pin  ź
 * \param[in] output_pin ź
 *
 * \retval 
 */
void demo_zsl42x_hw_gpio_entry (void    *p_hw_gpio,
                              int32_t  input_pin,
                              int32_t  output_pin);

/**
 * \brief GPIO ж̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_gpio     ָ GPIO Ĵָ
 * \param[in] pin           жź
 *
 * \retval 
 */
void demo_zsl42x_hw_gpio_trigger_entry (void *p_hw_gpio, int32_t pin);

/**
 * \brief SPI ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_spi ָ SPI Ĵָ
 * \param[in] cs_pin   Ƭѡź
 *
 * \retval 
 */
void demo_zsl42x_hw_spi_master_entry (void    *p_hw_spi,
                                    int32_t  cs_pin);

/**
 * \brief ʱ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim ָʱĴָ
 * \param[in] chan     ʱͨ
 * \param[in] clk_rate ʱʱԴƵ
 * \param[in] inum     жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_cap_entry (void     *p_hw_tim,
                                 uint32_t  chan,
                                 uint32_t  clk_rate,
                                 int32_t   inum);

/**
 * \brief ʱͨȽƥŷת̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim ָʱĴָ
 * \param[in] type     ʱ
 * \param[in] chan     ʱͨ
 * \param[in] clk_rate ʱʱԴƵ
 * \param[in] clk_div  ʱʱԴƵϵ
 * \param[in] inum     жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_cmp_toggle_entry (void    *p_hw_tim,
                                        uint8_t  type,
                                        uint32_t chan,
                                        uint32_t clk_rate,
                                        uint8_t  clk_div,
                                        uint8_t  inum);

/**
 * \brief ʱͨĻPWṂͨ HW ӿʵ
 *
 * \param[in] p_hw_tim  ָʱĴָ
 * \param[in] type      ʱ
 * \param[in] chan_a    ʱPWMͨA
 * \param[in] chan_b    ʱPWMͨB
 * \param[in] duty_us   ʱ䣨us
 * \param[in] period_us ʱ䣨us
 * \param[in] dead_us   ʱãus
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_pwm_dead_entry (void    *p_hw_tim,
                                      uint8_t  type,
                                      uint8_t  chan_a,
                                      uint8_t  chan_b,
                                      uint32_t duty_us,
                                      uint32_t period_us,
                                      uint16_t dead_us);

/**
 * \brief ߼ʱͬʼֹ̣ͬͣͬͨ HWӿʵ
 *
 * \param[in] p_tim_cfg ָͬýṹָ루amhw_zsl42x_adtim_sw_sync_t
 *
 * \retval 
 */
void demo_zsl42x_hw_adtim_swsync_entry (void *p_tim_cfg);

/**
 * \brief ߼ʱ˿ڡɲ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_adtim ָʱĴָ
 * \param[in] chan       ʱͨ
 * \param[in] duty_ns    ʱ
 * \param[in] period_ns  ʱ
 * \param[in] output_pin 
 * \param[in] src        ADT˿ڴ - Դѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_adtim_port_sw_brake_entry (void          *p_hw_adtim,
                                             uint8_t        chan,
                                             unsigned long  duty_ns,
                                             unsigned long  period_ns,
                                             int            output_pin,
                                             uint8_t        src);

/**
 * \brief ߼ʱVCɲ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_adtim ָʱĴָ
 * \param[in] chan       ʱͨ
 * \param[in] duty_ns    ʱ
 * \param[in] period_ns  ʱ
 * \param[in] p_hw_vc    ָVCĴָ
 * \param[in] vc0_n      VC0 ѹȽ -ѡ
 * \param[in] vc0_p      VC0 ѹȽ +ѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_adtim_vc_brake_entry (void         *p_hw_adtim,
                                        uint8_t       chan,
                                        unsigned long duty_ns,
                                        unsigned long period_ns,
                                        void         *p_hw_vc,
                                        uint8_t       vc0_n,
                                        uint8_t       vc0_p);

/**
 * \brief ߼ʱʱADCת̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_adtim  ָʱĴָ
 * \param[in] period_us   ʱ
 * \param[in] p_hw_adc    ָADCĴָ
 * \param[in] adc_int_num ADCжϺ
 * \param[in] p_adc_chan  ADCͨ
 * \param[in] sqr_num     ADC˳ͨ
 *
 * \retval 
 */
void demo_zsl42x_hw_adtim_trig_adc_sqr_entry (void    *p_hw_adtim,
                                            uint32_t period_us,
                                            void    *p_hw_adc,
                                            int      adc_int_num,
                                            int     *p_adc_chan,
                                            uint8_t  sqr_num);

/**
 * \brief ͨöʱ˿ɲ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim   ָʱĴָ
 * \param[in] type       ʱ
 * \param[in] chan       ʱͨ
 * \param[in] inum       ʱжϺ
 * \param[in] duty_ns    ʱ
 * \param[in] period_ns  ʱ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_port_brake_entry (void    *p_hw_tim,
                                        uint8_t  type,
                                        uint8_t  chan,
                                        int      inum,
                                        uint32_t duty_ns,
                                        uint32_t period_ns);

/**
 * \brief ͨöʱVCɲ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_adtim ָʱĴָ
 * \param[in] chan       ʱͨ
 * \param[in] duty_ns    ʱ
 * \param[in] period_ns  ʱ
 * \param[in] p_hw_vc    ָVCĴָ
 * \param[in] vc0_n      VC0 ѹȽ -ѡ
 * \param[in] vc0_p      VC0 ѹȽ +ѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_vc_brake_entry (void         *p_hw_tim,
                                      uint8_t       chan,
                                      unsigned long duty_ns,
                                      unsigned long period_ns,
                                      void         *p_hw_vc,
                                      uint8_t       vc0_n,
                                      uint8_t       vc0_p);

/**
 * \brief ʱ PWM ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim ָʱĴָ
 * \param[in] type     ʱ
 * \param[in] chan     ʱͨ
 * \param[in] clk_rate ʱʱԴƵ
 * \param[in] clk_div  ʱʱԴƵϵ
 * \param[in] inum     жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_pwm_entry (void    *p_hw_tim,
                                 uint8_t  type,
                                 uint32_t chan,
                                 uint32_t clk_rate,
                                 uint8_t  clk_div,
                                 int32_t  inum);

/**
 * \brief ʱʱ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim ָʱĴָ
 * \param[in] type     ʱ
 * \param[in] clk_rate ʱʱԴƵ
 * \param[in] int_num  жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_timing_entry (void    *p_hw_tim,
                                    uint8_t  type,
                                    uint32_t clk_rate,
                                    int32_t  int_num);

/**
 * \brief ͨöʱʱADCת̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_tim    ָʱĴָ
 * \param[in] type        ʱ
 * \param[in] chan        ʱͨ
 * \param[in] duty_us     ʱ
 * \param[in] period_us   ʱ
 * \param[in] p_hw_adc    ָADCĴָ
 * \param[in] adc_int_num ADCжϺ
 * \param[in] p_adc_chan  ADCͨ
 * \param[in] sqr_num     ADC˳ͨ
 *
 * \retval 
 */
void demo_zsl42x_hw_tim_trig_adc_sqr_entry (void    *p_hw_tim,
                                          uint8_t  type,
                                          uint8_t  chan,
                                          uint32_t duty_us,
                                          uint32_t period_us,
                                          void    *p_hw_adc,
                                          int      adc_int_num,
                                          int     *p_adc_chan,
                                          uint8_t  sqr_num);

/**
 * \brief UART жϷ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_uart ָ UART Ĵָ
 * \param[in] pfn_init  ָ UART ųʼָ
 * \param[in] clk_rate  UART ʱԴƵ
 * \param[in] uart_base UART ַ
 * \param[in] inum_uart UART жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_uart_int_entry (void             *p_hw_uart,
                                  void            (*pfn_init) (void),
                                  uint32_t          clk_rate,
                                  unsigned long     uart_base,
                                  unsigned char     inum_uart);

/**
 * \brief UART ѯʽ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_uart ָ UART Ĵָ
 * \param[in] clk_rate  UART ʱԴƵ
 *
 * \retval 
 */
void demo_zsl42x_hw_uart_polling_entry (void     *p_hw_uart,
                                      uint32_t  clk_rate);

/**
 * \brief UART DMA ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_uart ָ UART Ĵָ
 * \param[in] clk_rate  UART ʱԴƵ
 * \param[in] dma_chan  DMA ͨ
 * \param[in] dma_src   DMA Դѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_uart_rx_dma_entry (void    *p_hw_uart,
                                     uint32_t clk_rate,
                                     int32_t  dma_chan,
                                     int32_t  dma_src);

/**
 * \brief UART DMA ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_uart ָ UART Ĵָ
 * \param[in] clk_rate  UART ʱԴƵ
 * \param[in] dma_chan  DMA ͨ
 * \param[in] dma_src   DMA Դѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_uart_tx_dma_entry (void    *p_hw_uart,
                                     uint32_t clk_rate,
                                     int32_t  dma_chan,
                                     int32_t  dma_src);

/**
 * \brief LPUART жϷ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_lpuart   ָLPUART Ĵָ
 * \param[in] pfn_init      ָ LPUART ųʼָ
 * \param[in] sclk_src      LPUART ʱԴѡ
 * \param[in] clk_rate      LPUART ʱԴƵ
 * \param[in] baudrate      LPUART 
 * \param[in] inum_lpuart   LPUART жϺ
 *
 * \retval 
 */
void demo_zsl42x_hw_lpuart_int_entry (void             *p_hw_lpuart,
                                    void            (*pfn_init) (void),
                                    uint8_t           sclk_src,
                                    uint32_t          clk_rate,
                                    uint32_t          baudrate,
                                    unsigned char     inum_lpuart);

/**
 * \brief LPUART ѯʽ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_lpuart ָ LPUART Ĵָ
 * \param[in] clk_src     LPUART ʱԴѡ
 * \param[in] clk_rate    LPUART ʱԴƵ
 * \param[in] baudrate    LPUART 
 *
 * \retval 
 */
void demo_zsl42x_hw_lpuart_polling_entry (void     *p_hw_lpuart,
                                        uint8_t   clk_src,
                                        uint32_t  clk_rate,
                                        uint32_t  baudrate);

/**
 * \brief LPUART DMA ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_lpuart ָ LPUART Ĵָ
 * \param[in] clk_src     LPUART ʱԴѡ
 * \param[in] clk_rate    LPUART ʱԴƵ
 * \param[in] baudrate    LPUART 
 * \param[in] dma_chan    DMA ͨ
 * \param[in] dma_src     DMA Դѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_lpuart_rx_dma_entry (void    *p_hw_lpuart,
                                       uint8_t  clk_src,
                                       uint32_t clk_rate,
                                       uint32_t baudrate,
                                       int32_t  dma_chan,
                                       int32_t  dma_src);

/**
 * \brief LPUART DMA ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_lpuart ָ LPUART Ĵָ
 * \param[in] clk_src     LPUART ʱԴѡ
 * \param[in] clk_rate    LPUART ʱԴƵ
 * \param[in] baudrate    LPUART 
 * \param[in] dma_chan    DMA ͨ
 * \param[in] dma_src     DMA Դѡ
 *
 * \retval 
 */
void demo_zsl42x_hw_lpuart_tx_dma_entry (void    *p_hw_lpuart,
                                       uint8_t  clk_src,
                                       uint32_t clk_rate,
                                       uint32_t baudrate,
                                       int32_t  dma_chan,
                                       int32_t  dma_src);

/**
 * \brief ZSL42x I2C ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_i2c     ָ I2C Ĵָ
 * \param[in] clk_rate     I2cƵ
 *
 * \return 
 */
void demo_zsl42x_hw_i2c_master_poll_entry (void      *p_hw_i2c,
                                         uint32_t   clk_rate);

/**
 * \brief ZSL42x I2C ӻ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_i2c     ָ I2C Ĵָ
 * \param[in] inum_num     I2cжϺ
 *
 * \return 
 */
void demo_zsl42x_hw_i2c_slave_int_entry (void    *p_hw_i2c,
                                       int      inum_num);

/**
 * \brief ZSL42x WDT ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_wdt     ָ WDT Ĵָ
 * \param[in] time_out_ms  Źʱʱ
 * \param[in] feed_time_ms ιʱ
 *
 * \retval 
 */
void demo_zsl42x_hw_wdt_entry (void     *p_hw_wdt,
                             uint32_t  time_out_ms,
                             uint32_t  feed_time_ms);

/**
 * \brief DACѹ̣hwӿڲʵ
 *
 * \param[in] p_hw_dac  ָDACĴָ
 * \param[in] dma_src   DMAԴ
 * \param[in] dma_chan  DMAͨ
 * \param[in] p_vol_val ѹֵ
 *
 * \retval 
 */
void demo_zsl42x_hw_dac_dma_entry(void     *p_hw_dac,
                                int32_t   dma_src,
                                int32_t   dma_chan,
                                uint16_t *p_vol_val);

/**
 * \brief VCжϴ̣hwӿڲʵ
 *
 * \param[in] p_hw_vc   ָVCĴָ
 * \param[in] pfn_cb_t  жϴص
 * \param[in] p_arg     жϴص
 * \param[in] p_hw_dac  ָADCĴָ
 * \param[in] mv_val    DAC ѹ
 *
 */
void demo_zsl42x_hw_vc_int_entry (void      *p_hw_vc,
                                void     (*pfn_cb_t) (void *),
                                void      *p_arg,
                                void      *p_hw_dac,
                                uint16_t   mv_val);

/**
 * \brief LVDϵͳλ̣hwӿڲʵ
 *
 * \param[in] p_hw_lvd : ָLVDĴָ
 * \param[in] lvd_vids : LVD ֵѹamhw_zsl42x_lvd_vids_t
 * \param[in] lvd_src  : LVD Դѡ񣬺궨 AMHW_ZSL42x_LVD_SRC_
 *
 * \retval 
 */
void demo_zsl42x_hw_lvd_system_reset_entry (amhw_zsl42x_lvd_t     *p_hw_base,
                                          amhw_zsl42x_lvd_vids_t lvd_vids,
                                          uint32_t             lvd_src);

/**
 * \brief LVDϵͳλ̣hwӿڲʵ
 *
 * \param[in] p_hw_lvd   : ָLVDĴָ
 * \param[in] lvd_vids   : LVD ֵѹamhw_zsl42x_lvd_vids_t
 * \param[in] lvd_src    : LVD Դѡ񣬺궨 AMHW_ZSL42x_LVD_SRC_
 * \param[in] pfn_lvd_cb : ûص
 * \param[in] p_arg      : ûص
 *
 * \retval 
 */
void demo_zsl42x_hw_lvd_int_entry (amhw_zsl42x_lvd_t      *p_hw_base,
                                 amhw_zsl42x_lvd_vids_t  lvd_vids,
                                 uint32_t              lvd_src,
                                 am_pfnvoid_t          pfn_lvd_cb,
                                 void                 *p_arg);

/**
 * \brief OPA ͨŴģʽͨ HW ӿʵ
 *
 * \param[in] p_hw_opa :ָOPAĴָ
 *
 * \retval 
 */
void demo_zsl42x_hw_opa_entry (void *p_hw_opa);

/**
 * \brief OPA DACѹ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_opa  : ָOPAĴָ
 * \param[in] p_hw_dac  : ָDACĴָ
 * \param[in] mode      : OPAģʽ
 * \param[in] p_vol_val : DACõѹֵ
 * \param[in] number    : DACõѹֵ鳤
 *
 * \retval 
 */
void demo_zsl42x_hw_opa_dac_entry (void      *p_hw_opa,
                                 void      *p_hw_dac,
                                 uint8_t    mode,
                                 uint16_t  *p_vol_val,
                                 uint32_t   number);

/**
 * \brief AES ̣ܽͨ HW ӿʵ
 *
 * \param[in] p_hw_aes    : ָAESĴָ
 * \param[in] key_len     : Կ
 * \param[in] p_aes_data  : AES
 * \param[in] p_key_data  : AESԿ
 *
 * \retval 
 */
void demo_zsl42x_hw_aes_ency_decy_entry (void     *p_hw_aes,
                                       uint8_t   key_len,
                                       uint32_t *p_aes_data,
                                       uint32_t *p_key_data);

/**
 * \brief TRNG ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_trng   : ָTRNGĴָ
 *
 * \retval 
 */
void demo_zsl42x_hw_trng_generate_entry (void *p_hw_trng);

/**
 * \brief LCD ʾ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_lcd   : ָlcdĴָ
 * \param[in] p_data     : LCDʾ
 *
 * \retval 
 */
void demo_zsl42x_hw_lcd_entry (void *p_hw_lcd, uint32_t *p_data);


/******************************************************************************/

/**
 * \brief zsl42xx3x OPẠͨ첽׼ӿʵ
 *
 * \param[in] handle      OPA ׼
 * \param[in] ch          OPAͨ
 *
 * \return 
 */
void demo_zsl42xx3x_drv_opa_entry (void *p_handle, uint8_t ch);

/**
 * \brief zsl42xx3x OPA ѹ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_opa :ָOPAĴָ
 * \param[in] mode     :OPAģʽ
 * \param[in] ch       :OPAͨ
 *
 * \retval :
 */
void demo_zsl42xx3x_hw_opa_entry (void *p_hw_opa, uint8_t mode, uint8_t ch);

/**
 * \brief RTC ʵʱʱ̣ͨ HW ӿʵ
 *
 * \param[in] p_hw_rtc    : ָRTCĴָ
 *
 * \retval 
 */
void demo_zsl42x_hw_rtc_entry (void *p_hw_rtc);

#ifdef __cplusplus
}
#endif

#endif /* __DEMO_ZSL42x_ENTRIES_H */

/* end of file */
