/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIO ж̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. ʹӦжϲ½ء
 *
 * - ʵ
 *   1. жϲʱԴ "the gpio interrupt happen!"
 *
 * \par Դ
 * \snippet demo_zlg_hw_gpio_trigger.c src_zlg_hw_gpio_trigger
 *
 * \internal
 * \par Modification History
 * - 1.00 17-04-15  nwt, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg_hw_gpio_trigger
 * \copydoc demo_zlg_hw_gpio_trigger.c
 */

/** [src_zlg_hw_gpio_trigger] */
#include "ametal.h"
#include "am_gpio.h"
#include "am_vdebug.h"
#include "hw/amhw_zlg_exti.h"
#include "hw/amhw_zlg_gpio.h"
#include "hw/amhw_zlg_syscfg.h"

/**
 * \brief жϷ
 */
static void __gpio_isr (void *p_arg)
{
    AM_DBG_INFO("the gpio interrupt happen!\r\n");
}

/**
 * \brief 
 */
void demo_zlg_hw_gpio_trigger_entry (amhw_zlg_gpio_t         *p_hw_gpio,
                                     amhw_zlg_syscfg_t       *p_hw_syscfg,
                                     amhw_zlg_exti_t         *p_hw_exti,
                                     int32_t                  pin,
                                     uint8_t                  portsource,
                                     uint8_t                  pinsource,
                                     amhw_zlg_exti_line_num_t exti_line_num)
{

    /* ȡŸù */
    amhw_zlg_gpio_pin_afr_set(p_hw_gpio, AMHW_ZLG_GPIO_AF_DEFAULT, pin);

    /* ŷΪ뼰ŵģʽ */
    amhw_zlg_gpio_pin_set(p_hw_gpio, AMHW_ZLG_GPIO_MODE_IPU << 2 | 0x00, pin);

    /* ʹ */
    amhw_zlg_gpio_pin_out_high(p_hw_gpio, pin);

    /*
     * ж 0 ֻһ˿ڱΪ 0  GPIO ţ˵PIOA_0 ӵж 0
     * PIOB_0PIOC_0PIOD_0 Ͳж 0, ʱ PIOA_1 ӵж 1
     * Ӧϵ: PIOA_8 ӦⲿжϵԴΪ AMHW_ZLG_EXTI_PINSOURCE8
     */
    amhw_zlg_syscfg_exti_line_config(p_hw_syscfg, portsource, pinsource);

    /* ж */
    amhw_zlg_exti_imr_clear(p_hw_exti, exti_line_num);
    amhw_zlg_exti_emr_clear(p_hw_exti, exti_line_num);

    /* жߴʽ */
    amhw_zlg_exti_rtsr_clear(p_hw_exti, exti_line_num);
    amhw_zlg_exti_ftsr_clear(p_hw_exti, exti_line_num);

    /* ½ش */
    amhw_zlg_exti_ftsr_set(p_hw_exti, exti_line_num);

    /* ж߱־λ */
    amhw_zlg_exti_pending_clear(p_hw_exti, exti_line_num);

    /* ûעжϻص */
    am_gpio_trigger_connect(pin, __gpio_isr, NULL);

    /* ÿж */
    amhw_zlg_exti_imr_set(p_hw_exti,  exti_line_num);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zlg_hw_gpio_trigger] */

/* end of file */
