/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIO ж̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. ʹӦжϲ½ء
 *
 * - ʵ
 *   1. жϲʱԴ "the gpio interrupt happen!"
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_gpio_trigger.c src_zsl42x_hw_gpio_trigger
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-20  nwt, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_gpio_trigger
 * \copydoc demo_zsl42x_hw_gpio_trigger.c
 */

/** [src_zsl42x_hw_gpio_trigger] */
#include "ametal.h"
#include "am_gpio.h"
#include "am_vdebug.h"
#include "hw/amhw_zsl42x_gpio.h"
#include "hw/amhw_zsl42x_rcc.h"

/**
 * \brief жϷ
 */
static void __gpio_isr (void *p_arg)
{
    AM_DBG_INFO("the gpio interrupt happen!\r\n");
}

/**
 * \brief 
 */
void demo_zsl42x_hw_gpio_trigger_entry (void *p_hw_gpio, int32_t pin)
{
	amhw_zsl42x_gpio_t *p_gpio = (amhw_zsl42x_gpio_t *)p_hw_gpio;

    /* ȡŵĸù */
    amhw_zsl42x_gpio_afio_set(p_gpio, AMHW_ZSL42x_AFIO_NO, pin);

    /* ֶ˿*/
    amhw_zsl42x_gpio_pin_digital_set(p_gpio, pin);

    /*  */
    amhw_zsl42x_gpio_pin_dir_input(p_gpio, pin);

    /* ʹŵ */
    amhw_zsl42x_gpio_pin_pu_enable(p_gpio, pin);

    /* ½ش */
    amhw_zsl42x_gpio_pin_falling_int_enable(p_gpio, pin);

    /* ûעжϻص */
    am_gpio_trigger_connect(pin, __gpio_isr, NULL);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zsl42x_hw_gpio_trigger] */

/* end of file */
