/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LCD ʾ̣ͨ HW ӿʵ
 *
 * - ʵ
 *
 *   LCDѭʾ"0000~9999"
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_10  PC ڵ TXD
 *       PIOA_9  PC ڵ RXD
 *    2. Դʹ뱾ͬӦںʹõϢ
 *      磺AM_DBG_INFO()
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_lcd.c src_zsl42x_hw_lcd
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-10  ly, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_lcd
 * \copydoc demo_zsl42x_hw_lcd.c
 */

/** [src_zsl42x_hw_lcd] */
#include "ametal.h"
#include "am_zsl42x.h"
#include "am_int.h"
#include "am_delay.h"
#include "am_board.h"
#include "am_zsl42x_lcd.h"
#include "hw/amhw_zsl42x_lcd.h"

/*******************************************************************************
  궨
*******************************************************************************/
#define LCD_CLK_SRC   AMHW_ZSL42x_LCD_CLK_SRC_RCL   /**< \brief ʱԴ */
#define LCD_BIAS_SRC  AMHW_ZSL42x_LCD_BIAS_CAP_DIV  /**< \brief ƫõѹԴ */
#define LCD_DUTY      AMHW_ZSL42x_DUTY_1_4          /**< \brief ռձ */
#define LCD_BIAS      AMHW_ZSL42x_BIAS_1_3          /**< \brief ƫõѹ */
#define LCD_CPCLK     AMHW_ZSL42x_CPCLK_2K_HZ       /**< \brief ѹƵ */
#define LCD_SCAN_CLK  AMHW_ZSL42x_LCDCLK_128_HZ     /**< \brief ɨƵ */

/*******************************************************************************
  ȫֱ
*******************************************************************************/
static amhw_zsl42x_lcd_t       *gp_hw_lcd   = NULL;  /**< \brief lcd  */

/**
 * \brief LCD˿ڳʼ
 */
static void lcd_port_init ()
{
    /*  SEG0-SEG7 */
    amhw_zsl42x_seg0_31_ctr (gp_hw_lcd, 0x000000ff);

    /* رSEG32-51 Com0-8 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_ALL_CLOSE,
                                     0xffffffff);

    /* Com0-3 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_COM0_3_CTR,
                                     0xf);

    /* SEG32-35˿ڹѡ */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_MUX_CTR,
                                     0x1);

    /* ö˿SEG32-SEG35 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_SEG32_35_CTR,
                                     0xf);
    /* ö˿seg40-51 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_SEG40_51_CTR,
                                     0x10);

    /* SEG36-39 COM4-7 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                     AMHW_ZSL42x_LCD_COMSEG_CTR,
                                     0x0);
                                     
#ifdef ZSL42xL136
    /* ö˿COM0-3 */
    amhw_zsl42x_seg32_51_com0_8_ctr (gp_hw_lcd,
                                   AMHW_ZSL42x_LCD_SEG40_51_CTR,
                                   0x1f);
#endif
}

/**
 * \brief LCDʼ
 */
static void lcd_init ()
{
	int peri = 0;

    /* ʱԴѡ */
    amhw_zsl42x_lcd_clk_rsc_sel (gp_hw_lcd, LCD_CLK_SRC);

    /* RCLʱƵУ׼ֵ 32.768KHz*/
    amhw_zsl42x_rcc_rcl_trim_set(*((uint16_t*)0x00100C22));

    amhw_zsl42x_rcc_rcl_waittime_set(AMHW_ZSL42x_RCL_WAITTIME_256);

    amhw_zsl42x_rcc_set_start(0x5A5A);
    amhw_zsl42x_rcc_set_start(0xA5A5);

    amhw_zsl42x_rcc_rcl_enable();

    /* ȴȶ*/
    while(amhw_zsl42x_rcc_rcl_state_get() == AM_FALSE);

    /* LCDʱ */
    peri = CLK_LCD & 0xff;

    amhw_zsl42x_rcc_peripheral_enable((amhw_zsl42x_peripheral)peri);

    /* ѡƫõѹԴ */
    amhw_zsl42x_lcd_bias_rsc_sel (gp_hw_lcd, LCD_BIAS_SRC);

    /* ռձ */
    amhw_zsl42x_lcd_duty_sel (gp_hw_lcd, LCD_DUTY);

    /* ƫõѹ */
    amhw_zsl42x_lcd_bias_sel (gp_hw_lcd, LCD_BIAS);

    /* ѹʱƵѡ */
    amhw_zsl42x_lcd_cpclk_sel (gp_hw_lcd, LCD_CPCLK);

    /* ɨƵѡ */
    amhw_zsl42x_lcd_cldclk_sel (gp_hw_lcd, LCD_SCAN_CLK);

    /* жϽ */
    amhw_zsl42x_lcd_int_disable (gp_hw_lcd);

    /* DMA */
    amhw_zsl42x_lcd_dma_disable (gp_hw_lcd);
}

/**
 * \brief LCD ʾ̣ͨ HW ӿʵ
 */
void demo_zsl42x_hw_lcd_entry (void *p_hw_lcd, uint32_t *p_data)
{
    int i = 0;

    gp_hw_lcd  = (amhw_zsl42x_lcd_t *)p_hw_lcd;

    /* LCDʼ */
    lcd_init ();

    /* LCD˿ڳʼ */
    lcd_port_init ();
    
    /* LCD ģʽѡ */
    amhw_zsl42x_lcd_mode_sel (gp_hw_lcd, AMHW_ZSL42x_LCD_MODE_0);

    /* ʹLCD */
    amhw_zsl42x_lcd_enable (gp_hw_lcd);

    /* Դ */
    for (i = 0; i < 2; i++){

        amhw_zsl42x_lcd_ram_write (gp_hw_lcd, 0, i);
    }

    while (1)
    {
        for (i = 0; i < 12; i++){

            /* дݵԴ */
            amhw_zsl42x_lcd_ram_write (gp_hw_lcd, p_data[i], 0);
            /* дݵԴ */
            amhw_zsl42x_lcd_ram_write (gp_hw_lcd, p_data[i], 1);

            am_mdelay (1000);
        }

        i = 0;
    }
}

/* end of file */
