/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LPUART DMA ̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. ͨλһ MCU  5 ַ
 *
 * - ʵ
 *   1. ָڴӡյݣ
 *   2. Ȼָڴӡ "DMA transfer done!"
 *
 * \par Դ
 * \snippet demo_zlg118_hw_lpuart_rx_dma.c src_zlg118_hw_lpuart_rx_dma
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-26  zp, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg118_hw_lpuart_rx_dma
 * \copydoc demo_zlg118_hw_lpuart_rx_dma.c
 */

/** [src_zlg118_hw_lpuart_rx_dma] */
#include "ametal.h"
#include "am_int.h"
#include "am_zlg118_dma.h"
#include "hw/amhw_zlg118_lpuart.h"
#include "hw/amhw_zlg118_rcc.h"

/*******************************************************************************
  ȫֱ
*******************************************************************************/
static amhw_zlg118_dma_xfer_desc_t g_desc;           /**< \brief DMA  */
static volatile am_bool_t       g_trans_done = AM_FALSE; /**< \brief ɱ־ */
static uint8_t                  g_buf_dst[5] = {0};  /**< \brief Ŀݻ */
static int32_t                  g_dma_chan   = 0;    /**< \brief DMA ͨ */
static amhw_zlg118_lpuart_t    *gp_hw_lpuart = NULL; /**< \brief LPUART  */

static uint32_t lpuart_baudrate = 0;

/**
 * \brief DMA жϷ
 *
 * \param[in] p_arg : ûԶͨ am_zlg118_dma_isr_connect() 
 * \param[in] flag  : DMAжϱ־ɵײ룬òĿȡֵ
 *
 * \return 
 */
static void lpuart_dma_isr (void *p_arg , uint32_t flag)
{
    int flag_chan  = (int)p_arg;

    if (flag == AM_ZLG118_DMA_INT_COMPLETE) {
        if (flag_chan == g_dma_chan) {

            /* LPUARTʱʹDMA */
            amhw_zlg118_lpuart_disable(gp_hw_lpuart, AMHW_ZLG118_LPUART_DMA_RX);

            g_trans_done = AM_TRUE;
        }
    } else {
        /* ûԶִд */
    }
}

/**
 * \brief LPUARTDMA
 */
static int lpuart_rx_dma_tran_cfg (amhw_zlg118_lpuart_t *p_hw_lpuart,
                                 int32_t          dma_chan,
                                 uint32_t         dma_tran_len)
{
    uint32_t i;
    uint32_t flags;

    for (i = 0; i < sizeof(g_buf_dst); i++) {
        g_buf_dst[i] = 0;
    }

    /* DMAжϷ */
    am_zlg118_dma_isr_connect(dma_chan, lpuart_dma_isr, (void *)dma_chan);

    /* DMA  */
    flags = AMHW_ZLG118_DMA_CHAN_TRANSFER_MODE_BLOCK    | /* SPIֻп鴫ģʽ */
            AMHW_ZLG118_DMA_CHAN_SIZE_8BIT              | /* λ 8bit */

            AMHW_ZLG118_DMA_CHAN_SRC_ADD_INC_DISABLE    | /* Դַ */
            AMHW_ZLG118_DMA_CHAN_RELOAD_SRC_ADD_ENABLE  | /* Դַ*/

            AMHW_ZLG118_DMA_CHAN_DST_ADD_INC_ENABLE     | /* Ŀַ */
            AMHW_ZLG118_DMA_CHAN_RELOAD_DST_ADD_DISABLE | /* Ŀַ */

            AMHW_ZLG118_DMA_CHAN_RELOAD_COUNTER_ENABLE  | /*  */
            AMHW_ZLG118_DMA_CHAN_INT_ERR_DISABLE        | /* жϽ */
            AMHW_ZLG118_DMA_CHAN_INT_TX_CMP_ENABLE      | /* жʹ */
            AMHW_ZLG118_DMA_CHAN_CIRCULAR_MODE_DISABLE ;  /* رѭģʽ */

    /* ͨ */
    am_zlg118_dma_xfer_desc_build(&g_desc,                      /* ͨ */
                                   (uint32_t)(&(p_hw_lpuart->sbuf)), /* Դݻ */
                                   (uint32_t)(g_buf_dst),       /* Ŀݻ */
                                   (uint32_t)dma_tran_len,      /* ֽ */
                                   flags);                      /*  */

    /* DMA䣬Ͽʼ */
    if (am_zlg118_dma_xfer_desc_chan_cfg(&g_desc,
                                          AMHW_ZLG118_DMA_PER_TO_MER, /* 赽 ڴ */
                                          (uint8_t)dma_chan) == AM_ERROR) {
        return AM_ERROR;
    } else {
        /*  */
    }

    return AM_OK;
}

/**
 * \brief LPUART ʼ
 */
static void lpuart_hw_init (amhw_zlg118_lpuart_t *p_hw_lpuart,
                            uint8_t               clk_src,
                            uint32_t              clk_rate)
{
    /* ģʽ  */
    amhw_zlg118_lpuart_mode_sel(p_hw_lpuart, AMHW_ZLG118_LPUART_WORK_MODE_1);

    /* ͨʱԴ */
    amhw_zlg118_lpuart_clk_src_sel(p_hw_lpuart,
                                   (amhw_zlg118_lpuart_sclk_src_t)clk_src);

    if(clk_src == AMHW_ZLG118_LPUART_SCLK_SRC_XTL) {

        /* ⲿѡ */
        amhw_zlg118_rcc_xtl_xtal_driver_set(AMHW_ZLG118_XTL_XTAL_DRIVER_DEFAULT);

        /* XTL񵴷ȵĵ */
        amhw_zlg118_rcc_xtl_xtal_amplitude_set(
            AMHW_ZLG118_XTL_XTAL_AMPLITUDE_BIG_DEFAULT);

        /* ⲿʱXTLȶʱѡ */
        amhw_zlg118_rcc_xtl_waittime_set(AMHW_ZLG118_XTL_WAITTIME_16384);

        amhw_zlg118_rcc_set_start(0x5A5A);
        amhw_zlg118_rcc_set_start(0xA5A5);

        amhw_zlg118_rcc_xtl_enable();

        /* ȴȶ*/
        while(amhw_zlg118_rcc_xtl_state_get() == AM_FALSE);

    } else if(clk_src == AMHW_ZLG118_LPUART_SCLK_SRC_RCL) {

        /* RCLʱƵУ׼ֵ 38.4KHz*/
        amhw_zlg118_rcc_rcl_trim_set(*((uint16_t*)0x00100C20));

        amhw_zlg118_rcc_rcl_waittime_set(AMHW_ZLG118_RCL_WAITTIME_256);

        amhw_zlg118_rcc_set_start(0x5A5A);
        amhw_zlg118_rcc_set_start(0xA5A5);

        amhw_zlg118_rcc_rcl_enable();

        /* ȴȶ*/
        while(amhw_zlg118_rcc_rcl_state_get() == AM_FALSE);
    }

    /* Ƶϵ  */
    amhw_zlg118_lpuart_clk_div_sel(p_hw_lpuart,
                                   AMHW_ZLG118_LPUART_SCLK_DIV_MODE13_8);

    /* ȴͿ */
    while (amhw_zlg118_lpuart_flag_check(p_hw_lpuart,
                                       AMHW_ZLG118_LPUART_FLAG_TX_EMPTY) ==
                                       AM_FALSE);

    /* ֹͣλ */
    amhw_zlg118_lpuart_stop_bit_sel(p_hw_lpuart,
                                    AMHW_ZLG118_LPUART_STOP_1_0_BIT);

    /* У */
    amhw_zlg118_lpuart_parity_bit_sel(p_hw_lpuart,
                                      AMHW_ZLG118_LPUART_PARITY_NO);

    /*  */
    amhw_zlg118_lpuart_baudrate_set( p_hw_lpuart, clk_rate, lpuart_baudrate);

    /* رдж */
    amhw_zlg118_lpuart_int_disable(p_hw_lpuart, AMHW_ZLG118_LPUART_INT_ALL);
}

/**
 * \brief LPUARTմʱDMAʼ
 */
static void lpuart_hw_dma_init (amhw_zlg118_lpuart_t *p_hw_lpuart)
{
    /* ڷDMAʹ */
    amhw_zlg118_lpuart_enable(p_hw_lpuart, AMHW_ZLG118_LPUART_DMA_RX);

    /* ʹ
     * Mode0:     0; 1
     * Mode1/2/3: 0; 1 /
     */
    amhw_zlg118_lpuart_enable(p_hw_lpuart,AMHW_ZLG118_LPUART_RX);
}

/**
 * \brief 
 */
void demo_zlg118_hw_lpuart_rx_dma_entry (void    *p_hw_lpuart,
                                         uint8_t  clk_src,
                                         uint32_t clk_rate,
                                         uint32_t baudrate,
                                         int32_t  dma_chan,
                                         int32_t  dma_src)
{
    gp_hw_lpuart = (amhw_zlg118_lpuart_t *)p_hw_lpuart;
    g_dma_chan = dma_chan;

    lpuart_baudrate = baudrate;

    /* LPUARTʼ */
    lpuart_hw_init(gp_hw_lpuart, clk_src, clk_rate);

    /* LPUARTDMAĳʼ */
    lpuart_hw_dma_init(gp_hw_lpuart);

    amhw_zlg118_lpuart_poll_send(gp_hw_lpuart,
                                 (uint8_t *)"LPUART DMA RX start:\r\n",
                                 sizeof("LPUART DMA RX start:\r\n") - 1);
    /* ʼDMA */
    lpuart_rx_dma_tran_cfg(gp_hw_lpuart, dma_chan, sizeof(g_buf_dst));

    /* Ĭͨ0ͨ1ȼһѯ*/
    am_zlg118_dma_priority_same();

    /* ôźԴ */
    am_zlg118_dma_chan_src_set (dma_chan, dma_src);

    /* ÿDMAСΪѿͨ1 */
    am_zlg118_dma_block_data_size(dma_chan, 1);

    /* ʼͨ */
    am_zlg118_dma_chan_start(dma_chan);

    /* ȴ */
    while (g_trans_done == AM_FALSE);

    g_trans_done = AM_FALSE;

    amhw_zlg118_lpuart_poll_send(gp_hw_lpuart, g_buf_dst, sizeof(g_buf_dst));
    amhw_zlg118_lpuart_poll_send(gp_hw_lpuart,
                                 (uint8_t *)"\r\nDMA transfer done!\r\n",
                                  sizeof("\r\nDMA transfer done!\r\n") - 1);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zlg118_hw_lpuart_rx_dma] */

/* end of file */
