/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LVD ж̣ͨ HW ӿʵ
 *
 * - ʵ
 *
 *   PIOB_7ѹӸڻ׼ѹΪڻ׼ѹLVDжϡ
 *   ڴӡ "LVD interrupt"
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_10  PC ڵ TXD
 *       PIOA_9  PC ڵ RXD
 *    2. Դʹ뱾ͬӦںʹõϢ
 *      磺AM_DBG_INFO()
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_lvd_int.c src_zsl42x_hw_lvd_int
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-09  ly, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_lvd_int
 * \copydoc demo_zsl42x_hw_lvd_int.c
 */

/** [src_zsl42x_hw_lvd_int] */

#include "ametal.h"
#include "am_zsl42x.h"
#include "am_int.h"
#include "am_board.h"
#include "am_zsl42x_lvd.h"
#include "hw/amhw_zsl42x_lvd.h"
#include "hw/amhw_zsl42x_rcc_reset.h"

/** \brief LVD */
#define __LVD_TRI_TYPE         AMHW_ZSL42x_LVD_RTEN

/** \brief LVD˲ʱ */
#define __LVD_DEB_TIME         AMHW_ZSL42x_LVD_DEB_TIME_7P2_MS

/** \brief LVD*/
#define __LVD_TRI_ACT          AMHW_ZSL42x_LVD_TRI_ACT_NVIC_INT


/** \brief ûص*/
static am_pfnvoid_t            __gpfn_app_lvd_cb;
/** \brief ûص*/
static void                   *__gp_arg;


/**
 * \brief LVDжϷ
 */
static void __lvd_irq_handler (void *p_arg)
{
    amhw_zsl42x_lvd_t *p_hw_base = (amhw_zsl42x_lvd_t *)p_arg;

    if (amhw_zsl42x_int_status_check (p_hw_base) == 0){
        return;
    }

    /* жϱ־ */
    amhw_zsl42x_int_falg_clr (p_hw_base);

    /* ûص */
    if (__gpfn_app_lvd_cb) {
        __gpfn_app_lvd_cb(__gp_arg);
    }
}

/**
 * \brief LVD ʼ
 */
static void __lvd_hw_init (amhw_zsl42x_lvd_t       *p_hw_base,
                           amhw_zsl42x_lvd_vids_t   lvd_vids,
                           uint32_t               lvd_src)
{
    /* CR Ĵ */
    amhw_zsl42x_lvd_cr_clr(p_hw_base);

    /* ʹ */
    amhw_zsl42x_lvd_tri_enable(p_hw_base, __LVD_TRI_TYPE);

    /* ˲ʱѡ */
    amhw_zsl42x_lvd_deb_time_sel(p_hw_base, __LVD_DEB_TIME);

    /* ʹ˲ */
    amhw_zsl42x_lvd_deb_time_enable(p_hw_base);

    /* ֵѹѡ */
    amhw_zsl42x_lvd_vids_sel(p_hw_base, lvd_vids);

    /* Դѡ */
    amhw_zsl42x_lvd_src_sel(p_hw_base, lvd_src);

    /*  */
    amhw_zsl42x_lvd_tri_act_sel(p_hw_base, __LVD_TRI_ACT);
}

/**
 * \brief LVDжϳʼ
 */
static void __lvd_int_init (amhw_zsl42x_lvd_t  *p_hw_base)
{
    /* ж״̬־ */
    amhw_zsl42x_int_falg_clr (p_hw_base);

    /* ʹж */
    amhw_zsl42x_lvd_int_enable (p_hw_base);

    /* ж */
    am_int_connect(INUM_LVD, __lvd_irq_handler, p_hw_base);

    /* ж */
    am_int_enable (INUM_LVD);
}

/**
 * \brief LVDϵͳλ̣hwӿڲʵ
 */
void demo_zsl42x_hw_lvd_int_entry (amhw_zsl42x_lvd_t      *p_hw_base,
                                 amhw_zsl42x_lvd_vids_t  lvd_vids,
                                 uint32_t              lvd_src,
                                 am_pfnvoid_t          pfn_lvd_cb,
                                 void                 *p_arg)
{
    if (p_hw_base == NULL) {
        return;
    }

    /* ûص */
    __gpfn_app_lvd_cb = pfn_lvd_cb;
    __gp_arg          = p_arg;

    /* LVD ʼ */
    __lvd_hw_init(p_hw_base, lvd_vids, lvd_src);

    /* жϳʼ */
    __lvd_int_init(p_hw_base);

    /* LVD ʹ */
    amhw_zsl42x_lvd_enable (p_hw_base);

    AM_FOREVER {
        ;
    }
}

/* end of file */
