/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LVD ϵͳλ̣ͨ HW ӿʵ
 *
 * - ʵ
 *
 *   PIOB_7ƽõĻ׼ѹϵͳڸλ״̬ٴθڻ׼ѹLED˸һΣϵͳ
 *   ӡ "Mcu is running!"
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_10  PC ڵ TXD
 *       PIOA_9  PC ڵ RXD
 *    2. Դʹ뱾ͬӦںʹõϢ
 *      磺AM_DBG_INFO()
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_lvd_int.c src_zsl42x_hw_lvd_int
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-09  ly, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_lvd_int
 * \copydoc demo_zsl42x_hw_lvd_int.c
 */

/** [src_zsl42x_hw_lvd_int] */
#include "ametal.h"
#include "am_zsl42x.h"
#include "am_int.h"
#include "am_board.h"
#include "am_zsl42x_lvd.h"
#include "hw/amhw_zsl42x_lvd.h"
#include "hw/amhw_zsl42x_rcc_reset.h"

/** \brief LVD */
#define __LVD_TRI_TYPE         AMHW_ZSL42x_LVD_HTEN

/** \brief LVD˲ʱ */
#define __LVD_DEB_TIME         AMHW_ZSL42x_LVD_DEB_TIME_7P2_MS

/** \brief LVD*/
#define __LVD_TRI_ACT          AMHW_ZSL42x_LVD_TRI_ACT_SYSTEM_RESET

/**
 * \brief LVD ʼ
 */
static void __lvd_hw_init (amhw_zsl42x_lvd_t       *p_hw_base,
                           amhw_zsl42x_lvd_vids_t   lvd_vids,
                           uint32_t               lvd_src)
{
    /* CR Ĵ */
    amhw_zsl42x_lvd_cr_clr (p_hw_base);

    /* ʹ */
    amhw_zsl42x_lvd_tri_enable (p_hw_base, __LVD_TRI_TYPE);

    /* ˲ʱѡ */
    amhw_zsl42x_lvd_deb_time_sel (p_hw_base, __LVD_DEB_TIME);

    /* ʹ˲ */
    amhw_zsl42x_lvd_deb_time_enable (p_hw_base);

    /* ֵѹѡ */
    amhw_zsl42x_lvd_vids_sel (p_hw_base, lvd_vids);

    /* Դѡ */
    amhw_zsl42x_lvd_src_sel (p_hw_base, lvd_src);

    /*  */
    amhw_zsl42x_lvd_tri_act_sel (p_hw_base, __LVD_TRI_ACT);
}

/**
 * \brief LVDϵͳλ̣hwӿڲʵ
 */
void demo_zsl42x_hw_lvd_system_reset_entry (amhw_zsl42x_lvd_t     *p_hw_base,
                                          amhw_zsl42x_lvd_vids_t lvd_vids,
                                          uint32_t             lvd_src)
{
    if (p_hw_base == NULL) {
        return;
    }

    /* жϸλ־ */
    if (amhw_zsl42x_rcc_reset_flag_check (AMHW_ZSL42x_RCC_RESET_FLAG_LVD)) {

        am_led_off(LED0);
        am_mdelay(500);
        am_led_on(LED0);
        am_mdelay(500);
        am_led_off(LED0);

        /* λ־ */
        amhw_zsl42x_rcc_reset_flag_clr(AMHW_ZSL42x_RCC_RESET_FLAG_LVD);
    }

    /* LVDʼ */
    __lvd_hw_init(p_hw_base, lvd_vids, lvd_src);

    /* LVDʹ */
    amhw_zsl42x_lvd_enable (p_hw_base);

    AM_FOREVER {

        am_kprintf ("Mcu is running!\r\n");

        am_mdelay(1000);
    }
}

/* end of file */
