/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief OPA DACѹ̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. ʾ J8 PA4 
 *   2.  ZSL420_EVK USB ӿӣ򿪴
 *
 * - ʵ
 *   1. DAC Ҳ  OPA  PA4 
 *
 * \note
 *   1. ۲촮ϢҪ am_prj_config.h ʹ AM_CFG_DEBUG_ENABLE
 *
 * \par Դ
 * \snippet demo_zsl42x_hw_opa_dac.c src_zsl42x_hw_opa_dac
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-10  ly, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsl42x_hw_opa_dac
 * \copydoc demo_zsl42x_hw_opa_dac.c
 */

/** [src_zsl42x_hw_opa_dac] */
#include "ametal.h"
#include "am_zsl42x.h"
#include "am_int.h"
#include "am_delay.h"
#include "am_board.h"
#include "am_zsl42x_opa.h"
#include "hw/amhw_zsl42x_dac.h"
#include "hw/amhw_zsl42x_opa.h"

/*******************************************************************************
  궨
*******************************************************************************/
#define OPA_CLK      AMHW_ZSL42x_OPA_CLK_16    /**< \brief У׼ */
#define OPA_AZ_WAY   AMHW_ZSL42x_OPA_AZ_SW     /**< \brief У׼ʽ */

/*******************************************************************************
  ȫֱ
*******************************************************************************/
static amhw_zsl42x_opa_t *gp_hw_opa   = NULL;  /**< \brief OPA  */
static amhw_zsl42x_dac_t *gp_hw_dac   = NULL;  /**< \brief DAC  */

/**
 * \brief DACʼ
 */
static void dac_hw_init(amhw_zsl42x_dac_t *p_hw_dac,
                        uint32_t           verf)
{

    if (p_hw_dac == NULL){
        return ;
    }

    /* òοѹԴ */
    amhw_zsl42x_dac_chan_sref_sel(p_hw_dac, verf);

    /* ʧ*/
    amhw_zsl42x_dac_chan_output_buf_disable(p_hw_dac);

    /* ʹ */
    amhw_zsl42x_dac_chan_trg_enable(p_hw_dac);

    /* ʽѡ  */
    amhw_zsl42x_dac_chan_trg_sel(p_hw_dac, AMHW_ZSL42x_DAC_CHAN_SOFTWARE_TRG);

    /* ʹdacͨ */
    amhw_zsl42x_dac_chan_enable(p_hw_dac);

}

/**
 * \brief OPAʼ
 */
void opa_hw_init (uint8_t mode)
{
    if (mode == AM_ZSL42x_OPA_DAC){

        /* DACʹOP3λӻʹ */
        amhw_zsl42x_opabuf_en (gp_hw_opa);
    }else{
        ;
    }
}

/**
 * \brief OPA DACѹ̣ͨ HW ӿʵ
 */
void demo_zsl42x_hw_opa_dac_entry (void      *p_hw_opa,
                                 void      *p_hw_dac,
                                 uint8_t    mode,
                                 uint16_t  *p_vol_val,
                                 uint32_t   number)
{
    int i = 0;

    gp_hw_opa = (amhw_zsl42x_opa_t *)p_hw_opa;
    gp_hw_dac = (amhw_zsl42x_dac_t *)p_hw_dac;

    /* ʹBGR */
    amhw_zsl42x_bgr_enable(AM_TRUE);

    /* OPAʼ */
    opa_hw_init (mode);

    /* DAC ʼ Ĭϲοѹ ⲿοѹԴ  PB01*/
    dac_hw_init(gp_hw_dac, AMHW_ZSL42x_DAC_CHAN_MASK_EXTER_REF);

    AM_FOREVER {

        /*  */
        amhw_zsl42x_dac_chan_software_trg_enable(gp_hw_dac);

        if (i < number) {
            amhw_zsl42x_dac_chan_12bit_right_aligned_data(gp_hw_dac,
                                                        p_vol_val[i]);
            i++;
        }else{
            i = 0;
        }
        am_mdelay(1000);
    }
}

/* end of file */
