/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱ˿ɲж̣ͨ HW ӿʵ
 *
 * - 裺
 *   1. PIOB_5͵ƽӣTIM1_CHAPIOA_0ռձΪ25%2HzPWM
 *   2. PIOB_5ߵƽӣɲжϣڴӡ"brake int!"TIM1_CHAPIOA_0PWM
 *      ֹͣٴνPIOB_5͵ƽӣָ
 *
 * \par Դ
 * \snippet demo_zlg118116_hw_tim_port_brake.c src_zlg118116_hw_tim_port_brake
 *
 * \internal
 * \par Modification history
 * - 1.00 19-10-12  zp, first implementation
 * \endinternal
 */ 

/**
 * \addtogroup demo_if_zlg118116_hw_tim_port_brake
 * \copydoc demo_zlg118116_hw_tim_port_brake.c
 */

/** [src_zlg118116_hw_tim_port_brake] */
#include "ametal.h"
#include "am_clk.h"
#include "am_clk.h"
#include "am_int.h"
#include "am_gpio.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zlg118.h"
#include "hw/amhw_zlg118_tim.h"

/**
  * \brief жϷ
  */
static void __irq_handler (void *p_arg)
{
    amhw_zlg118_tim_t *p_hw_tim = (amhw_zlg118_tim_t *)p_arg;

    if(amhw_zlg118_tim_mode23_int_flag_check(
           p_hw_tim,
           AMHW_ZLG118_TIM_INT_FLAG_BRAKE) ==
           AM_TRUE) {

        amhw_zlg118_tim_mode23_int_flag_clr(p_hw_tim,
                                            AMHW_ZLG118_TIM_INT_FLAG_BRAKE);

        AM_DBG_INFO("brake int!\r\n");
    }

}

static am_bool_t __zlg118_hw_tim_init (amhw_zlg118_tim_t *p_hw_tim,
                                       uint8_t            type,
                                       uint8_t            chan,
                                       uint32_t           duty_ns,
                                       uint32_t           period_ns)
{
    uint32_t clkfreq;
    uint16_t fre_div = 1;
    uint32_t period_c, duty_c;

    /* öʱģʽ2(ݲģʽ) */
    amhw_zlg118_tim_mode_set(p_hw_tim, AMHW_ZLG118_TIM_MODE_ZIGZAG);

    /* ϼ */
    amhw_zlg118_tim_mode23_counter_up(p_hw_tim);

    /* ͨΪȽģʽ */
    if((chan % 2) == 0) {
        amhw_zlg118_tim_mode23_csa_compare(p_hw_tim, chan);
    } else {
        amhw_zlg118_tim_mode23_csb_compare(p_hw_tim, chan);
    }

    /* ʱʱΪڲʱ */
    amhw_zlg118_tim_mode_clk_src_set(p_hw_tim,AMHW_ZLG118_TIM_CLK_SRC_TCLK);

    /* ȡʱƵ */
    clkfreq = am_clk_rate_get(CLK_TIM012);

    /* õǼֵCNT, ʽns * 10e-9= cnt * (1/clkfrq) */
    period_c = (uint64_t)(period_ns) * (clkfreq) / (uint64_t)1000000000;
    duty_c   = (uint64_t)(duty_ns)   * (clkfreq) / (uint64_t)1000000000;

    /* ÷Ƶֵ */
    amhw_zlg118_tim_mode_clkdiv_set(p_hw_tim, AMHW_ZLG118_TIM_CLK_DIV64);

    fre_div = 64;

    /* ¼PWMڼƵ */
    period_c = period_c / fre_div;
    duty_c   = duty_c   / fre_div;

    /* Ϸ */
    if ((period_c == 0) || (period_c > 65535UL)) {
        return AM_FALSE;
    }

    /* ԶװĴֵ */
    amhw_zlg118_tim_arr_count_set(p_hw_tim, period_c - 1);

    /*  */
    amhw_zlg118_tim_cnt16_count_set(p_hw_tim, 0);

    duty_c = period_c - duty_c;

    /* ĳһͨıȽֵ */
    amhw_zlg118_tim_mode23_ccrxy_set(p_hw_tim, chan, duty_c - 1);

    /* PWMģʽΪPWM2 */
    amhw_zlg118_tim_mode23_compare_set(
       p_hw_tim,
       (amhw_zlg118_tim_compare_type_t)(chan * 4),
       AMHW_ZLG118_TIM_COMPARE_PWM2);

    /*  */
    amhw_zlg118_tim_mode23_phase_same(
       p_hw_tim,
       (amhw_zlg118_tim_phase_type_t)(chan * 4 + 3));

    /* PWMʹ */
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_MOE);
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_AOE);

    /* TIM1/2ʹñĵɲ */
    amhw_zlg118_tim_mode23_bksel_mine(p_hw_tim);

    /* ɲƽѡ */
    if((chan % 2) == 0) {
        amhw_zlg118_tim_mode23_bksa_set(p_hw_tim,
                                        chan,
                                        AMHW_ZLG118_TIM_CMP_BRAKEOUT_LOW);
    } else {
        amhw_zlg118_tim_mode23_bksb_set(p_hw_tim,
                                        chan,
                                        AMHW_ZLG118_TIM_CMP_BRAKEOUT_LOW);
    }

    /* ɲBKλͬࣨߵƽɲ */
    amhw_zlg118_tim_mode23_phase_same(p_hw_tim, AMHW_ZLG118_TIM_PHASE_BKP);

    /* ɲ˲pclk 3Ч */
    amhw_zlg118_tim_mode23_fliter_set(p_hw_tim,
                                      AMHW_ZLG118_TIM_FLITER_TYPE_FLTBK,
                                      AMHW_ZLG118_TIM_FILTER_PCLKDIV1_3);

    /* ɲʹ */
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_BKE);

    /* ɲжʹ */
    amhw_zlg118_tim_mode23_int_enable(p_hw_tim, AMHW_ZLG118_TIM_INT_BIE);

    return AM_TRUE;
}

/**
 * \brief 
 */
void demo_zlg118_hw_tim_port_brake_entry (void    *p_hw_tim,
                                          uint8_t  type,
                                          uint8_t  chan,
                                          int      inum,
                                          uint32_t duty_ns,
                                          uint32_t period_ns)
{

    amhw_zlg118_tim_t *p_tim = (amhw_zlg118_tim_t *)p_hw_tim;

    /* ʱ */
    if((__zlg118_hw_tim_init(p_tim, type, chan, duty_ns , period_ns)) ==
       AM_FALSE) {
        return;
    }

    am_int_connect(inum, __irq_handler, (void *)p_hw_tim);
    am_int_enable(inum);

    /* жϱ־ */
    amhw_zlg118_tim_mode23_int_flag_clr(p_hw_tim, AMHW_ZLG118_TIM_INT_FLAG_ALL);


    /* ʹܶʱTIM */
    amhw_zlg118_tim_enable(p_tim);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zlg118116_hw_tim_port_brake] */

/* end of file */
