/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ͨöʱVCɲ̣ͨ HWӿʵ
 *
 * - 裺
 *   1.VC0_P("+"PA1)һģѹ鲻3.3V
 *   2.VC0_N("-"PA0)һģѹ鲻3.3V
 *   3.VC0_PVC0_N֮ĴСϵʵ
 *
 * - ʵ
 *   1.VC0_P("+"PA1)ĵѹVC0_N("-"PA0)ĵѹVC0_OUT(PA6)ߵƽ
 *     VC0ж(ߵƽһֱж)ʱ4ɲЧTIM1_CHB(PIOB_6)PWMֹͣ
 *   2.VC0_P("+"PA1)ĵѹСVC0_N("-"PA0)ĵѹVC0_OUT(PA6)͵ƽ
 *     VC0жϲTIM1_CHB(PIOB_6)PWM
 *
 * \note ʵͨöʱTIM012
 *       VCĬʹVC0˿Ϊʾʵ
 *
 * \par Դ
 * \snippet demo_zlg118_hw_tim_vc_brake.c src_zlg118_hw_tim_vc_brake
 *
 * \internal
 * \par Modification history
 * - 1.00 19-10-12  zp, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zlg118_hw_tim_vc_brake
 * \copydoc demo_zlg118_hw_tim_vc_brake.c
 */

/** [src_zlg118_hw_tim_vc_brake] */
#include "ametal.h"
#include "am_clk.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_int.h"
#include "am_zlg118.h"
#include "hw/amhw_zlg118_tim.h"
#include "hw/amhw_zlg118_vc.h"

/*
 * \brief VCжϷ
 */
static void __vc0_irq_handler (void *p_arg)
{

    amhw_zlg118_vc_t *p_hw_vc = (amhw_zlg118_vc_t *)p_arg;

    //VCߵƽжЧʱTimer3PWMɲMOEԶ㣬AOEҪʹܣ
    //MOEԶ㣬PWMͻضϣҪָPWMҪٴʹMOE
    /* VC0 ͨЧ */
    if(amhw_zlg118_vc_int_status_check(p_hw_vc, AMHW_ZLG118_VC0_FLT_INT_FLAG)) {
        amhw_zlg118_vc_int_status_clr(p_hw_vc,AMHW_ZLG118_VC0_FLT_INT_FLAG_CLR);

        AM_DBG_INFO("vc int!\r\n");
    }
}

/*
 * \brief VCʼ
 */
static am_bool_t __vc_init (amhw_zlg118_vc_t       *p_hw_vc,
                            amhw_zlg118_vc0_n_sel_t vc0_n,
                            amhw_zlg118_vc0_p_sel_t vc0_p)
{
    /* ʹBGR */
    amhw_zlg118_bgr_enable(AM_TRUE);

    /* òοѹΪVCC */
    amhw_zlg118_vc_ref2p5_sel(p_hw_vc, AMHW_ZLG118_VC_REF2P5_VCC);

    /* òοѹѹ */
    amhw_zlg118_vc_div_enable(p_hw_vc);
    amhw_zlg118_vc_div_sel(p_hw_vc, AMHW_ZLG118_VC_DIV_1);

    /* ѡ ͵ѹ*/
    amhw_zlg118_vc0_hys_sel(p_hw_vc, AMHW_ZLG118_VC0_HYS_10_MV);
    amhw_zlg118_vc0_bias_sel(p_hw_vc, AMHW_ZLG118_VC0_BIAS_10_UA);

    /*  ͨN롢ͨP */
    amhw_zlg118_vc0_n_sel(p_hw_vc, vc0_n);
    amhw_zlg118_vc0_p_sel(p_hw_vc, vc0_p);

    /* ߵƽж */
    amhw_zlg118_vc0_out_tri_int_sel(p_hw_vc,
                                    AMHW_ZLG118_VC_OUT_TRI_INT_HIGH_LEVEL);

    /* VC0ʹAdvanced Timerɲ */
    amhw_zlg118_vc_outcfg_enable(p_hw_vc,
                                 AMHW_ZLG118_VC_OUT_CFG_FIT_DATA_TIM0_1_2_3_EN,
                                 AMHW_ZLG118_VC0);

    /*  */
    amhw_zlg118_vc_outcfg_enable(p_hw_vc,
                                 AMHW_ZLG118_VC_OUT_CFG_DISABLE,
                                 AMHW_ZLG118_VC0);

    /* ˲ʹ */
    amhw_zlg118_vc_flt_disable (p_hw_vc, AMHW_ZLG118_VC0);

    /* жʹ */
    amhw_zlg118_vc_int_enable (p_hw_vc, AMHW_ZLG118_VC0);

    am_int_connect(INUM_VC0, __vc0_irq_handler, (void *)p_hw_vc);
    am_int_enable (INUM_VC0);

    return AM_TRUE;
}

static am_bool_t __zlg118_hw_tim_init (amhw_zlg118_tim_t *p_hw_tim,
                                       uint8_t            chan,
                                       uint32_t           duty_ns,
                                       uint32_t           period_ns)
{
    uint32_t clkfreq;
    uint16_t fre_div = 1;
    uint32_t period_c, duty_c;

    /* öʱģʽ2(ݲģʽ) */
    amhw_zlg118_tim_mode_set(p_hw_tim, AMHW_ZLG118_TIM_MODE_ZIGZAG);

    /* ϼ */
    amhw_zlg118_tim_mode23_counter_up(p_hw_tim);

    /* ͨΪȽģʽ */
    if((chan % 2) == 0) {
        amhw_zlg118_tim_mode23_csa_compare(p_hw_tim, chan);
    } else {
        amhw_zlg118_tim_mode23_csb_compare(p_hw_tim, chan);
    }

    /* ʱʱΪڲʱ */
    amhw_zlg118_tim_mode_clk_src_set(p_hw_tim,AMHW_ZLG118_TIM_CLK_SRC_TCLK);

    /* ȡʱƵ */
    clkfreq = am_clk_rate_get(CLK_TIM012);

    /* õǼֵCNT, ʽns * 10e-9= cnt * (1/clkfrq) */
    period_c = (uint64_t)(period_ns) * (clkfreq) / (uint64_t)1000000000;
    duty_c   = (uint64_t)(duty_ns)   * (clkfreq) / (uint64_t)1000000000;

    /* ÷Ƶֵ */
    amhw_zlg118_tim_mode_clkdiv_set(p_hw_tim, AMHW_ZLG118_TIM_CLK_DIV64);

    fre_div = 64;

    /* ¼PWMڼƵ */
    period_c = period_c / fre_div;
    duty_c   = duty_c   / fre_div;

    /* Ϸ */
    if ((period_c == 0) || (period_c > 65535UL)) {
        return AM_FALSE;
    }

    /* ԶװĴֵ */
    amhw_zlg118_tim_arr_count_set(p_hw_tim, period_c - 1);

    /*  */
    amhw_zlg118_tim_cnt16_count_set(p_hw_tim, 0);

    duty_c = period_c - duty_c;

    /* ĳһͨıȽֵ */
    amhw_zlg118_tim_mode23_ccrxy_set(p_hw_tim, chan, duty_c - 1);

    /* PWMģʽΪPWM2 */
    amhw_zlg118_tim_mode23_compare_set(
       p_hw_tim,
       (amhw_zlg118_tim_compare_type_t)(chan * 4),
       AMHW_ZLG118_TIM_COMPARE_PWM2);

    /*  */
    amhw_zlg118_tim_mode23_phase_same(
       p_hw_tim,
       (amhw_zlg118_tim_phase_type_t)(chan * 4 + 3));

    /* PWMʹ */
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_MOE);
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_AOE);

    /* TIM1/2ʹñĵɲ */
    amhw_zlg118_tim_mode23_bksel_mine(p_hw_tim);

    /* ɲƽѡ */
    if((chan % 2) == 0) {
        amhw_zlg118_tim_mode23_bksa_set(p_hw_tim,
                                        chan,
                                        AMHW_ZLG118_TIM_CMP_BRAKEOUT_LOW);
    } else {
        amhw_zlg118_tim_mode23_bksb_set(p_hw_tim,
                                        chan,
                                        AMHW_ZLG118_TIM_CMP_BRAKEOUT_LOW);
    }

    /* ɲBKλͬࣨߵƽɲ */
    amhw_zlg118_tim_mode23_phase_same(p_hw_tim, AMHW_ZLG118_TIM_PHASE_BKP);

    /* ɲ˲pclk 3Ч */
    amhw_zlg118_tim_mode23_fliter_set(p_hw_tim,
                                      AMHW_ZLG118_TIM_FLITER_TYPE_FLTBK,
                                      AMHW_ZLG118_TIM_FILTER_PCLKDIV1_3);

    /* VCɲʹ */
    amhw_zlg118_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZLG118_TIM_DTR_VCE);

    return AM_TRUE;
}

/**
 * \brief 
 */
void demo_zlg118_hw_tim_vc_brake_entry (void         *p_hw_tim,
                                        uint8_t       chan,
                                        unsigned long duty_ns,
                                        unsigned long period_ns,
                                        void         *p_hw_vc,
                                        uint8_t       vc0_n,
                                        uint8_t       vc0_p)
{
    amhw_zlg118_tim_t *p_tim = (amhw_zlg118_tim_t *)p_hw_tim;
    amhw_zlg118_vc_t  *p_vc  = (amhw_zlg118_vc_t *)p_hw_vc;
    /* ʱʼ */
    if(__zlg118_hw_tim_init(p_tim, chan, duty_ns, period_ns) ==
       AM_FALSE) {
        return;
    }

    /* VCʼ */
    if(__vc_init(p_vc, 
			           (amhw_zlg118_vc0_n_sel_t)vc0_n, 
		             (amhw_zlg118_vc0_p_sel_t)vc0_p) == AM_FALSE) {
        return;
    }

    /* ʹܶʱTIM */
    amhw_zlg118_tim_enable(p_tim);

    /* ʹܵѹȽ */
    amhw_zlg118_vc_volt_cmp_enable(p_vc, AMHW_ZLG118_VC0);

    while (1) {
        ;
    }
}
/** [src_zlg118_hw_tim_vc_brake] */

/* end of file */
