/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱʱ̣ͨ HW ӿʵ
 *
 * - ʵ
 *   1. жʱԴڴӡϢ
 *   2. LED0 ת
 *
 * \par Դ
 * \snippet demo_zlg_hw_tim_timing.c src_zlg_hw_tim_timing
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-22  nwt, first implementation
 * \endinternal
 */ 

/**
 * \addtogroup demo_if_zlg_hw_tim_timing
 * \copydoc demo_zlg_hw_tim_timing.c
 */

/** [src_zlg_hw_tim_timing] */
#include "ametal.h"
#include "am_int.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "hw/amhw_zlg_tim.h"
#include "am_led.h"

#define LED0   0
/**
 * \brief PWM жϷ
 */
static void __zlg_tim_hw_timing_irq_handler (void *p_arg)
{
    amhw_zlg_tim_t *p_hw_tim = (amhw_zlg_tim_t *)p_arg;

    AM_DBG_INFO("timing irq!\r\n");

    am_led_toggle(LED0);

    /* ±־ */
    amhw_zlg_tim_status_flg_clr(p_hw_tim, AMHW_ZLG_TIM_UIF);
}

/**
 * \brief öʱTIMΪʱtiming
 *
 * \param[in] p_hw_tim : ָʱĴָ
 * \param[in] cnt      : ֵڶʱʱƵ
 *
 * \return 
 */
void tim_timing_chan_config (amhw_zlg_tim_t *p_hw_tim, uint32_t cnt)
{
    uint32_t match, temp;
    uint16_t pre_real = 1, pre_reg = 0;

    {
        temp = cnt;

        /* 16λֵ65536, Ƶֵ65536 */
        if (temp  > 4294967295UL) {
            return ;
        }

        /* С65536ʱƵ(ֵΪ1,1Ϊ1Ƶ) */
        temp = cnt  / 65536 + 1;

        /* 16λʱҪȡúʵķƵֵ */
        for (pre_real = 1; pre_real < temp; ) {
            pre_reg++;           /* дĴķƵֵ0,1,2,... */
            pre_real++;          /* Ƶ */
        }
    }

    /* Զֵ */
    match = cnt / pre_real ;

    /* ÷Ƶֵ */
    amhw_zlg_tim_prescale_set(p_hw_tim, pre_reg);

    /* ԶװĴֵ */
    amhw_zlg_tim_arr_set(p_hw_tim, match - 1);

    /*  0 */
    amhw_zlg_tim_count_set(p_hw_tim, 0);
}

/**
 * \brief ʹܶʱΪʱ
 */
void tim_timing_enable (amhw_zlg_tim_t *p_hw_tim, uint8_t int_num)
{

    /* ¼³ʼPrescaler Repetition */
    amhw_zlg_tim_egr_set(p_hw_tim, AMHW_ZLG_TIM_UG);

    if (amhw_zlg_tim_status_flg_get(p_hw_tim, AMHW_ZLG_TIM_UG) != 0) {

        /* ¶ʱʱ¼,־λ */
        amhw_zlg_tim_status_flg_clr(p_hw_tim, AMHW_ZLG_TIM_UG);
    }

    /* жϻص */
    am_int_connect(int_num, __zlg_tim_hw_timing_irq_handler, (void *)p_hw_tim);

    /* ʹܸж */
    amhw_zlg_tim_int_enable(p_hw_tim, AMHW_ZLG_TIM_UIE);

    am_int_enable(int_num);

    /*ʹܶʱTIM */
    amhw_zlg_tim_enable(p_hw_tim);
}

/**
 * \brief ʱTIM timingʼ
 */
void tim_timing_init (amhw_zlg_tim_t *p_hw_tim, amhw_zlg_tim_type_t type)
{
    if ((AMHW_ZLG_TIM_TYPE0 == type) || (AMHW_ZLG_TIM_TYPE1 == type)) {

        /* ضģʽ */
        amhw_zlg_tim_cms_set(p_hw_tim, 0);

        /* ϼ */
        amhw_zlg_tim_dir_set(p_hw_tim, 0);
    }

    /* ʱӷָ:TDTS = Tck_tin */
    amhw_zlg_tim_ckd_set(p_hw_tim, 0);

    /* ¼ */
    amhw_zlg_tim_udis_enable(p_hw_tim);

}

/**
 * \brief 
 */
void demo_zlg_hw_tim_timing_entry (amhw_zlg_tim_t     *p_hw_tim,
                                   amhw_zlg_tim_type_t type,
                                   uint32_t            clk_rate,
                                   int32_t             int_num)
{

    /* ʼʱΪʱ */
    tim_timing_init(p_hw_tim, type);

    tim_timing_chan_config(p_hw_tim, clk_rate / 2);

    tim_timing_enable(p_hw_tim, int_num);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zlg_hw_tim_timing] */

/* end of file */
