/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ͨöʱĻPWṂͨ HWӿʵ
 *
 * - ʵ
 *   1.ڴӡʾϢ.
 *   2.PIOA_2(TIM0_CHA)PIOA_1(TIM0_CHB)ռձ25%20HzPWMʱΪ100us
 *
 * \note
 *    1. ۲촮ڴӡĵϢҪ PIOA_10  PC ڵ TXD
 *       PIOA_9  PC ڵ RXD
 *    2. ʹʾ߼ǲPWMʱ䡣
 *    3. ʱӦСPWMʱ䡣ʱ趨Χ62686usҪ趨ʱ䣬
 *       Ҫdemo_zsl42x_hw_tim_pwm_dead.cеķƵϵʱ
 *
 * \par Դ
 * \snippet demo_zsl42x116_hw_tim_pwm_dead.c src_zsl42x116_hw_tim_pwm_dead
 *
 * \internal
 * \par Modification history
 * - 1.00 19-10-12  zp, first implementation
 * \endinternal
 */ 

/**
 * \addtogroup demo_if_zsl42x116_hw_tim_pwm_dead
 * \copydoc demo_zsl42x116_hw_tim_pwm_dead.c
 */

/** [src_zsl42x116_hw_tim_pwm_dead] */
#include "ametal.h"
#include "am_clk.h"
#include "am_clk.h"
#include "am_int.h"
#include "am_gpio.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zsl42x.h"
#include "hw/amhw_zsl42x_tim.h"

static am_bool_t __zsl42x_hw_tim_init (amhw_zsl42x_tim_t *p_hw_tim,
                                       uint8_t            type,
                                       uint8_t            chan_a,
                                       uint8_t            chan_b,
                                       uint32_t           duty_us,
                                       uint32_t           period_us,
                                       uint16_t           dead_us)
{
	float    deadtime = 0.0;
    uint32_t clkfreq  = 0;
    uint16_t fre_div  = 1;
    uint32_t period_c, duty_c;

    /* öʱģʽ2(ݲģʽ) */
    amhw_zsl42x_tim_mode_set(p_hw_tim, AMHW_ZSL42x_TIM_MODE_ZIGZAG);

    /* ϼ */
    amhw_zsl42x_tim_mode23_counter_up(p_hw_tim);

    /* ʹܻ */
    amhw_zsl42x_tim_mode23_enable(p_hw_tim, AMHW_ZSL42x_TIM_COMP);

    /* ͨAΪȽģʽ */
    amhw_zsl42x_tim_mode23_csa_compare(p_hw_tim, chan_a);

    /* ͨ BΪȽģʽ */
    amhw_zsl42x_tim_mode23_csb_compare(p_hw_tim, chan_b);

    /* ʱʱΪڲʱ */
    amhw_zsl42x_tim_mode_clk_src_set(p_hw_tim,AMHW_ZSL42x_TIM_CLK_SRC_TCLK);

    /* ȡʱƵ */
    clkfreq = am_clk_rate_get(CLK_TIM012);

    /* õǼֵCNT, ʽus * 10e-6= cnt * (1/clkfrq) */
    period_c = (uint64_t)(period_us) * (clkfreq) / (uint64_t)1000000;
    duty_c   = (uint64_t)(duty_us)   * (clkfreq) / (uint64_t)1000000;

    /* ÷Ƶֵ */
    amhw_zsl42x_tim_mode_clkdiv_set(p_hw_tim, AMHW_ZSL42x_TIM_CLK_DIV64);

    fre_div = 64;

    /* ¼PWMڼƵ */
    period_c = period_c / fre_div;
    duty_c   = duty_c   / fre_div;

    /* Ϸ */
    if ((period_c == 0) || (period_c > 65535UL)) {
        return AM_FALSE;
    }

    /* ԶװĴֵ */
    amhw_zsl42x_tim_arr_count_set(p_hw_tim, period_c - 1);

    /*  */
    amhw_zsl42x_tim_cnt16_count_set(p_hw_tim, 0);

    /* ĳһͨAıȽֵ */
    amhw_zsl42x_tim_mode23_ccr_set(p_hw_tim, chan_a, duty_c - 1);

    /* ĳһͨBıȽֵ */
    amhw_zsl42x_tim_mode23_ccr_set(p_hw_tim, chan_b, duty_c - 1);

    /* ͨAPWMģʽΪPWM2 */
    amhw_zsl42x_tim_mode23_compare_set(
       p_hw_tim,
       (amhw_zsl42x_tim_compare_type_t)(chan_a * 4),
       AMHW_ZSL42x_TIM_COMPARE_PWM2);

    /* ͨBPWMģʽΪPWM2 */
    amhw_zsl42x_tim_mode23_compare_set(
       p_hw_tim,
       (amhw_zsl42x_tim_compare_type_t)(chan_b * 4),
       AMHW_ZSL42x_TIM_COMPARE_PWM2);

    /* ͨA */
    amhw_zsl42x_tim_mode23_phase_same(
       p_hw_tim,
       (amhw_zsl42x_tim_phase_type_t)(chan_a * 4 + 3));

    /* ͨA */
    amhw_zsl42x_tim_mode23_phase_same(
       p_hw_tim,
       (amhw_zsl42x_tim_phase_type_t)(chan_b * 4 + 3));

    /* ־λ */
    amhw_zsl42x_tim_mode23_int_flag_clr(p_hw_tim, AMHW_ZSL42x_TIM_INT_FLAG_ALL);

    /* ʹ  */
    amhw_zsl42x_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZSL42x_TIM_DTR_DTEN);

    deadtime = (float)dead_us * (float)clkfreq / (float)(fre_div * 1000000) + 0.5;

    /* ʱ  */
    amhw_zsl42x_tim_mode23_dtr_set(p_hw_tim, (uint8_t)deadtime);

    /* PWMʹ */
    amhw_zsl42x_tim_mode23_dtr_enable(p_hw_tim, AMHW_ZSL42x_TIM_DTR_MOE);

    return AM_TRUE;
}

/**
 * \brief ʱͨĻPWṂͨ HW ӿʵ
 */
void demo_zsl42x_hw_tim_pwm_dead_entry (void    *p_hw_tim,
                                      uint8_t  type,
                                      uint8_t  chan_a,
                                      uint8_t  chan_b,
                                      uint32_t duty_us,
                                      uint32_t period_us,
                                      uint16_t dead_us)
{

    amhw_zsl42x_tim_t *p_tim = (amhw_zsl42x_tim_t *)p_hw_tim;

    /* ʱ */
    if((__zsl42x_hw_tim_init(p_tim,
                             type,
                             chan_a,
                             chan_b,
                             duty_us ,
                             period_us,
                             dead_us)) ==
       AM_FALSE) {
        return;
    }

    /* ʹܶʱTIM */
    amhw_zsl42x_tim_enable(p_tim);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zsl42x116_hw_tim_pwm_dead] */

/* end of file */
