/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱʱ̣ͨ HW ӿʵ
 *
 * - ʵ
 *   1. жʱԴڴӡϢ
 *   2. LED0 ת
 *
 * \par Դ
 * \snippet demo_zsn700_hw_tim_timing.c src_zsn700_hw_tim_timing
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-23  zp, first implementation
 * \endinternal
 */ 

/**
 * \addtogroup demo_if_zsn700_hw_tim_timing
 * \copydoc demo_zsn700_hw_tim_timing.c
 */

/** [src_zsn700_hw_tim_timing] */
#include "ametal.h"
#include "am_int.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "hw/amhw_zsn700_tim.h"
#include "am_led.h"

#define LED0   0

/**
 * \brief PWM жϷ
 */
static void __zsn700_tim_hw_timing_irq_handler (void *p_arg)
{
    amhw_zsn700_tim_t *p_hw_tim = (amhw_zsn700_tim_t *)p_arg;

    if (amhw_zsn700_tim_mode0_int_update_flag_check(p_hw_tim) == AM_TRUE ) {

        AM_DBG_INFO("timing irq!\r\n");

        am_led_toggle(LED0);

        /* ־ */
        amhw_zsn700_tim_mode0_int_update_flag_clr(p_hw_tim);
    }
}

/**
 * \brief öʱTIMΪʱtiming
 *
 * \param[in] p_hw_tim : ָʱĴָ
 * \param[in] cnt      : ֵڶʱʱƵ
 *
 * \return 
 */
void tim_timing_chan_config (amhw_zsn700_tim_t *p_hw_tim, uint32_t cnt)
{
    uint32_t match;
    uint16_t pre_real = 1;

    /* ÷Ƶֵ */
    amhw_zsn700_tim_mode_clkdiv_set(p_hw_tim, AMHW_ZSN700_TIM_CLK_DIV256);

    pre_real = 256;

    /* Զֵ */
    match = cnt / pre_real ;

    if(match > 65535) {
        return;
    }

    /* ԶװĴֵ */
    amhw_zsn700_tim_arr_count_set(p_hw_tim, 65535 - (match - 1));

    /* ü */
    amhw_zsn700_tim_cnt16_count_set(p_hw_tim, 65535 - (match - 1));
}

/**
 * \brief ʹܶʱΪʱ
 */
void tim_timing_enable (amhw_zsn700_tim_t *p_hw_tim, uint8_t int_num)
{

    /* жϻص */
    am_int_connect(int_num, __zsn700_tim_hw_timing_irq_handler, (void *)p_hw_tim);

    am_int_enable(int_num);

    /* ¶ʱʱ¼,־λ */
    amhw_zsn700_tim_mode0_int_update_flag_clr(p_hw_tim);

    /* ж */
    amhw_zsn700_tim_mode0_int_update_enable(p_hw_tim);

    /* ʹܶʱTIM */
    amhw_zsn700_tim_enable(p_hw_tim);
}

/**
 * \brief ʱTIM timingʼ
 */
void tim_timing_init (amhw_zsn700_tim_t *p_hw_tim, amhw_zsn700_tim_type_t type)
{
    /* 16λؼ */
    amhw_zsn700_tim_mode0_counter_set(p_hw_tim,
                                      AMHW_ZSN700_TIM_MODE0_COUNTER_16);

    /* öʱģʽ0 */
    amhw_zsn700_tim_mode_set(p_hw_tim, AMHW_ZSN700_TIM_MODE_TIMING);

    /* ʱ */
    amhw_zsn700_tim_mode_clk_src_set(p_hw_tim,AMHW_ZSN700_TIM_CLK_SRC_TCLK);
}

/**
 * \brief 
 */
void demo_zsn700_hw_tim_timing_entry (void    *p_hw_tim,
                                      uint8_t  type,
                                      uint32_t clk_rate,
                                      int32_t  int_num)
{
    amhw_zsn700_tim_t *p_tim = (amhw_zsn700_tim_t *)p_hw_tim;

    /* ʼʱΪʱ */
    tim_timing_init(p_tim, (amhw_zsn700_tim_type_t)type);

    tim_timing_chan_config(p_tim, clk_rate / 20);

    tim_timing_enable(p_tim, int_num);

    AM_FOREVER {
        ; /* VOID */
    }
}
/** [src_zsn700_hw_tim_timing] */

/* end of file */
