/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief UART DMA ̣ͨ HW ӿʵ
 *
 * - ʵ
 *   1. ָڴӡʾַ "DMA tx transfer start:"
 *   2. Ȼָڴӡһڴ涨ֱַΪ
 *      uart tx dma test running
 *      uart tx dma test done
 *
 * \note
 *    1.  DMA ڼ䲻ҪԴݼĴв
 *
 * \par Դ
 * \snippet demo_zsn700_hw_uart_tx_dma.c src_zsn700_hw_uart_tx_dma
 *
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-23  zp, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zsn700_hw_uart_tx_dma
 * \copydoc demo_zsn700_hw_uart_tx_dma.c
 */

/** [src_zsn700_hw_uart_tx_dma] */
#include "ametal.h"
#include "am_int.h"
#include "am_zsn700_dma.h"
#include "hw/amhw_zsn700_uart.h"

/*******************************************************************************
  궨
*******************************************************************************/
#define UART_BAUDRATE      (115200)             /**< \brief  */

/*******************************************************************************
  ȫֱ
*******************************************************************************/

/** \brief DMA  */
static amhw_zsn700_dma_xfer_desc_t g_desc;

/** \brief ɱ־ */
static volatile am_bool_t g_trans_done = AM_FALSE;

/** \brief Ŀݻ */
static uint8_t   g_buf_dst[]  = "uart tx dma test running\r\n";

/** \brief Ŀݻ */
static uint8_t   g_buf_dst1[] = "uart tx dma test done\r\n";

/** \brief Ŀݻ */
static uint8_t   g_buf_dst2[] = "DMA tx transfer start:\r\n";

static int32_t             g_dma_chan = 0;    /**< \brief DMA ͨ */
static amhw_zsn700_uart_t *gp_hw_uart = NULL; /**< \brief UART  */

/**
 * \brief DMAжϷ
 *
 * \param[in] p_arg : ûԶͨ am_zsn700_dma_isr_connect() ݡ
 * \param[in] flag  : DMAжϱ־ɵײ룬òĿȡֵ
 *                    (# AM_zsn700_DMA_INT_NORMAL)  (# AM_zsn700_DMA_INT_ERROR)
 *
 * \return ޡ
 */
static void uart_dma_isr (void *p_arg , uint32_t flag)
{
    int flag_chan  = (int)p_arg;

    if (flag == AM_ZSN700_DMA_INT_COMPLETE) {
        if (flag_chan == g_dma_chan) {

            /* UARTʱʹDMA */
            amhw_zsn700_uart_disable(gp_hw_uart, AMHW_ZSN700_UART_DMA_TX);
            g_trans_done = AM_TRUE;
        }
    } else {
        /* ûԶִд */
    }

}

/**
 * \brief DMAá
 */
static int uart_tx_dma_tran_cfg (amhw_zsn700_uart_t *p_hw_uart,
                                 int32_t             dma_chan,
                                 const uint8_t      *p_txbuf,
                                 uint32_t            dma_tran_len)
{
    uint32_t flags;

    /* DMAжϷ */
    am_zsn700_dma_isr_connect(dma_chan, uart_dma_isr, (void *)dma_chan);

    /* DMA  */
       flags = AMHW_ZSN700_DMA_CHAN_TRANSFER_MODE_BLOCK    | /* SPIֻп鴫ģʽ */
               AMHW_ZSN700_DMA_CHAN_SIZE_8BIT              | /* λ 8bit */

               AMHW_ZSN700_DMA_CHAN_SRC_ADD_INC_ENABLE     | /* Դַ */
               AMHW_ZSN700_DMA_CHAN_RELOAD_SRC_ADD_DISABLE | /* Դַ*/

               AMHW_ZSN700_DMA_CHAN_DST_ADD_INC_DISABLE    | /* Ŀַ */
               AMHW_ZSN700_DMA_CHAN_RELOAD_DST_ADD_ENABLE  | /* Ŀַ */

               AMHW_ZSN700_DMA_CHAN_RELOAD_COUNTER_ENABLE  | /*  */
               AMHW_ZSN700_DMA_CHAN_INT_ERR_DISABLE        | /* жϽ */
               AMHW_ZSN700_DMA_CHAN_INT_TX_CMP_ENABLE      | /* жʹ */
               AMHW_ZSN700_DMA_CHAN_CIRCULAR_MODE_DISABLE ;  /* رѭģʽ */

    /* ͨ */
    am_zsn700_dma_xfer_desc_build(&g_desc,                       /* ͨ */
                                  (uint32_t)(p_txbuf),           /* Դݻ */
                                  (uint32_t)(&(p_hw_uart->sbuf)),/* Ŀݻ */
                                  dma_tran_len,                  /* ֽ */
                                  flags);                        /*  */

    /* DMA䣬Ͽʼ */
    if (am_zsn700_dma_xfer_desc_chan_cfg(&g_desc,
                                         AMHW_ZSN700_DMA_PER_TO_MER,/* ڴ浽 */
                                         dma_chan) == AM_ERROR) {
        return AM_ERROR;
    }

    return AM_OK;
}

/**
 * \brief UARTʼ
 */
static void uart_hw_init (amhw_zsn700_uart_t *p_hw_uart, uint32_t clk_rate)
{
    /* ģʽ  */
    amhw_zsn700_uart_mode_sel(p_hw_uart, AMHW_ZSN700_UART_WORK_MODE_1);

    /* Ƶϵ  */
    amhw_zsn700_uart_clk_div_sel(p_hw_uart, AMHW_ZSN700_UART_CLK_DIV_MODE13_8);

    /* ȴͿ */
    while (amhw_zsn700_uart_flag_check(p_hw_uart,
                                       AMHW_ZSN700_UART_FLAG_TX_EMPTY) ==
                                       AM_FALSE);

    /* ֹͣλ */
    amhw_zsn700_uart_stop_bit_sel(p_hw_uart  , AMHW_ZSN700_UART_STOP_1_0_BIT);

    /* У */
    amhw_zsn700_uart_parity_bit_sel(p_hw_uart, AMHW_ZSN700_UART_PARITY_NO);

    /*  */
    amhw_zsn700_uart_baudrate_set( p_hw_uart, clk_rate, UART_BAUDRATE);

    /* رдж */
    amhw_zsn700_uart_int_disable(p_hw_uart, AMHW_ZSN700_UART_INT_ALL);
}


/**
 * \brief UARTDMAʼ
 */
static void uart_hw_dma_init (amhw_zsn700_uart_t *p_hw_uart)
{
    /* ڷDMAʹ */
    amhw_zsn700_uart_enable(p_hw_uart, AMHW_ZSN700_UART_DMA_TX);

    /* ʹ
     * Mode0:     0; 1
     * Mode1/2/3: 0; 1 /
     */
    amhw_zsn700_uart_enable(p_hw_uart,AMHW_ZSN700_UART_RX);
}

/**
 * \brief 
 */
void demo_zsn700_hw_uart_tx_dma_entry (void    *p_hw_uart,
                                       uint32_t clk_rate,
                                       int32_t  dma_chan,
                                       int32_t  dma_src)
{
    uint8_t i = 0;
    uint8_t j = 0;

    gp_hw_uart = (amhw_zsn700_uart_t *)p_hw_uart;
    g_dma_chan = dma_chan;

    /* UARTʼ */
    uart_hw_init(gp_hw_uart, clk_rate);

    /* UARTDMAĳʼ */
    uart_hw_dma_init(gp_hw_uart);

    uart_tx_dma_tran_cfg(gp_hw_uart,
                         dma_chan,
                         g_buf_dst2,
                         sizeof(g_buf_dst2) - 1);

    /* Ĭͨ0ͨ1ȼһѯ*/
    am_zsn700_dma_priority_same();

    /* ôźԴ */
    am_zsn700_dma_chan_src_set (dma_chan, dma_src);

    /* ÿDMAСΪѿͨ1 */
    am_zsn700_dma_block_data_size(dma_chan, 1);

    /* ʼͨ */
    am_zsn700_dma_chan_start(dma_chan);

    while (1) {

        if (g_trans_done == AM_TRUE) {

            j++;
            g_trans_done = AM_FALSE;

            /* ڷDMAʹ */
            amhw_zsn700_uart_enable(p_hw_uart, AMHW_ZSN700_UART_DMA_TX);

            if (j < 3) {
                am_zsn700_dma_chan_stop(dma_chan);
                if (0 == i) {
                    uart_tx_dma_tran_cfg(gp_hw_uart,
                                         dma_chan,
                                         g_buf_dst,
                                         sizeof(g_buf_dst) - 1);
                } else {
                    uart_tx_dma_tran_cfg(gp_hw_uart,
                                         dma_chan,
                                         g_buf_dst1,
                                         sizeof(g_buf_dst1) - 1);
                }
                i++;
                am_zsn700_dma_chan_start(dma_chan);
            }

        }
    }
}
/** [src_zsn700116_hw_uart_tx_dma] */

/* end of file */
