/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
* e-mail:      ametal.support@zlg.cn
*******************************************************************************/

/**
 * \file
 * \brief ˯ģʽ̣ʹöʱڻѣͨӿʵ
 *
 * - ʵ
 *   1. "enter sleep!"ϵͳʱԴлΪ LSIʱ
 *      ˯ģʽJ-Link ԶϿʱûɲ˯ģʽĹģ
 *   2. ȴʱʱ䵽MCU ѣ"wake_up!"Ȼ½
 *      ˯ģʽ
 *
 * \par Դ
 * \snippet demo_zml165_drv_sleepmode_timer_wake_up.c src_zml165_drv_sleepmode_timer_wake_up
 *
 * \internal
 * \par Modification History
 * - 1.00 18-05-16  pea, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_zml165_drv_sleepmode_timer_wake_up
 * \copydoc demo_zml165_drv_sleepmode_timer_wake_up.c
 */

/** [src_zml165_drv_sleepmode_timer_wake_up] */
#include "ametal.h"
#include "am_timer.h"
#include "am_delay.h"
#include "am_vdebug.h"
#include "am_zml165.h"
#include "am_zml165_pwr.h"
#include "am_zml165_clk.h"
#include "hw/amhw_zlg_uart.h"
/**
 * \brief ʱص
 */
am_local void __tim_timing_callback (void *p_arg)
{
     am_kprintf("1111");
}

/**
 * \brief ϵͳʱԴлΪ LSI
 */
am_local void __sysclk_switch_to_lsi (void)
{

    /* ͣģʽʹ LSI Ϊϵͳʱ */
    amhw_zml165_rcc_lsi_enable();

    /* ȴ LSI ʱӾ */
    while (amhw_zml165_rcc_lsirdy_read() == AM_FALSE);

    /* лʱ */
    amhw_zml165_rcc_sys_clk_set(AMHW_ZML165_SYSCLK_LSI);

    /* ʧ PLL */
    amhw_zml165_rcc_hsion_disable();
}

/**
 * \brief ϵͳʱԴлΪ PLL
 */
am_local void __sysclk_switch_to_pll (void)
{
    amhw_zml165_rcc_hsion_enable();

    while (amhw_zml165_rcc_hsirdy_read() == AM_FALSE);

    /* ϵͳʱѡΪ PLL */
    amhw_zml165_rcc_sys_clk_set(AMHW_ZML165_SYSCLK_HSI);

    /* ģʽ½ LSI Ϊϵͳʱ */
    amhw_zml165_rcc_lsi_disable();
}

/**
 * \brief 
 */
void demo_zml165_drv_sleepmode_timer_wake_up_entry (am_timer_handle_t timer_handle,
                                                    uint32_t          timer_clk_rate)
{
    am_timer_callback_set(timer_handle, 0, __tim_timing_callback, NULL);

    /*  */
    am_zml165_wake_up_cfg(AM_ZML165_PWR_MODE_SLEEP, NULL, NULL);

    while (1) {

        AM_DBG_INFO("enter sleep!\r\n");

        /* ȴڷ */
        while((ZML165_UART1->csr & AMHW_ZLG_UART_TX_COMPLETE_FALG) == AM_FALSE);

        /* ϵͳʱԴлΪ LSI */
        __sysclk_switch_to_lsi();

        /* öʱжΪ 1Sʱ */
        am_timer_enable(timer_handle, 0, 40000 * 20);

        /* ˯ģʽ */
        am_zml165_pwr_mode_into(AM_ZML165_PWR_MODE_SLEEP);

        /* رնʱ */
        am_timer_disable(timer_handle, 0);

        /* ϵͳʱԴлΪ PLL */
        __sysclk_switch_to_pll();
//        am_zml165_uart1_inst_init();
        AM_DBG_INFO("wake_up!\r\n");

//        am_mdelay(10);
    }
}
/** [src_zml165_drv_sleepmode_timer_wake_up] */

/* end of file */
