/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief STD̺
 * \sa    demo_std_entries.h
 *
 * \internal
 * \par Modification history
 * - 1.00 17-05-02  sdy, first implementation
 * \endinternal
 */

#ifndef __DEMO_STD_ENTRIES_H
#define __DEMO_STD_ENTRIES_H

#include "am_cap.h"
#include "am_crc.h"
#include "am_i2c.h"
#include "am_i2c_slv.h"
#include "am_pwm.h"
#include "am_wdt.h"
#include "am_spi.h"
#include "am_spi_slv.h"
#include "am_adc.h"
#include "am_can.h"
#include "am_uart.h"
#include "am_temp.h"
#include "am_timer.h"
#include "am_rtc.h"
#include "am_pcf85063.h"
#include "am_hc595.h"
#include "am_sensor.h"
#include "am_sdcard.h"
#include "am_dac.h"
#include "am_sht20.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \brief ADC̣òѯʽȡADCתͨ׼ӿʵ
 *
 * \param[in] handle ADC ׼
 * \param[in] chan   ADC ͨ
 *
 * \return 
 */
void demo_std_adc_entry (am_adc_handle_t handle, int chan);

/**
 * \brief ADCڲ¶ȴ̣òѯʽȡADCתͨ׼ӿʵ
 *
 * \param[in] handle ADC ׼
 * \param[in] chan   ADC ͨ
 *
 * \return 
 */
void demo_std_adc_its_entry (am_adc_handle_t handle, int chan);

/**
 * \brief 
 */
void demo_std_multichan_adc_entry (am_adc_handle_t handle,
                                   int            *p_chan,
                                   int             chan_num);

/**
 * \brief ADC ðӵ(NTC)¶̣ͨ׼ӿʵ
 *
 * \param[in] handle    ADC ׼
 * \param[in] chan      ADC ͨţͨӦ NTC ˣ
 * \param[in] res_fixed ̶ѹֵλŷķӲ·
 *
 * \return 
 */
void demo_std_adc_ntc_entry (am_adc_handle_t handle,
                             int             chan,
                             uint32_t        res_fixed);

/**
 * \brief ̣ͨ׼ӿʵ
 *
 * \param 
 *
 * \return 
 */
void demo_std_buzzer_entry (void);

/**
 * \brief ʱʵֲܣͨ׼ӿʵ
 *
 * \param[in] cap_handle 벶׼
 * \param[in] pwm_handle PWM ׼
 * \param[in] cap_chan   ʱͨһĬʹòͨ 0
 * \param[in] pwm_chan   ʱͨһĬʹ PWM ͨ 0
 *
 * \return 
 */
void demo_std_timer_cap_entry (am_cap_handle_t cap_handle, int cap_chan);

/**
 * \brief CRC ̣ͨ׼ӿʵ
 *
 * \param[in] crc_handle CRC ׼
 *
 * \return 
 */
void demo_std_crc_entry (am_crc_handle_t crc_handle);

/**
 * \brief GPIO ̣ͨ׼ӿʵ
 *
 * \param[in] input_pin  GPIO ܽű (# PIO*_0)
 * \param[in] output_pin GPIO ܽű (# PIO*_0)
 *
 * \return 
 */
void demo_std_gpio_entry (int input_pin, int output_pin);

/**
 * \brief GPIO ж̣ͨ׼ӿʵ
 *
 * \param[in] pin GPIO ܽű (# PIO*_0)
 *
 * \return 
 */
void demo_std_gpio_trigger_entry (int pin);

/**
 * \brief I2C ȡ¶ȴ LM75 ̣ͨ׼ӿʵ
 *
 * \param[in] handle ¶ȱ׼
 *
 * \return 
 */
void demo_std_i2c_lm75_entry (am_temp_handle_t handle);

/**
 * \brief I2C  EEPROM 豸̣ͨ첽׼ӿʵ
 *
 * \param[in] handle      I2C ׼
 * \param[in] eeprom_addr EEPROM ַ
 * \param[in] test_len    ֽ
 *
 * \return 
 */
void demo_std_i2c_master_async_entry (am_i2c_handle_t handle,
                                      uint32_t        eeprom_addr,
                                      uint32_t        test_len);

/**
 * \brief I2C  EEPROM 豸̣ͨͬ׼ӿʵ
 *
 * \param[in] handle      I2C ׼
 * \param[in] eeprom_addr EEPROM ַ
 * \param[in] test_len    ֽ
 *
 * \return 
 */
void demo_std_i2c_master_sync_entry (am_i2c_handle_t handle,
                                     uint32_t        eeprom_addr,
                                     uint32_t        test_len);

/**
 * \brief I2C ӻģ TMP100 ̣ͨ׼ӿʵ
 *
 * \param[in] handle I2C ׼
 *
 * \return 
 */
void demo_std_i2c_slave_subaddr_entry (am_i2c_slv_handle_t handle);

/**
 * \brief I2C ӻ̣ͨ׼ӿʵ
 *
 * \param[in] handle   I2C ׼
 * \param[in] dev_addr ӻַ
 *
 * \return 
 */
void demo_std_i2c_slave_entry (am_i2c_slv_handle_t handle, uint16_t dev_addr);
 
/**
 * \brief ̣4
 * \param[in] led_id LED 
 * \return 
 */
void demo_std_4key_entry (void);

/**
 * \brief 
 * \return 
 */
void demo_std_key_entry (void);

/**
 * \brief ̣ʹʾǰµİ¼ڰص
 * \param[in] id  ܱ
 * \return 
 */
void demo_std_key_digitron_entry (int32_t id);

/**
 * \brief ̣ʹʾǰµİ¼浽λУ
 * \param[in] id  ܱ
 * \return 
 */
void demo_std_key_digitron_rngbuf_entry (int32_t id);

/**
 * \brief LED ̣ͨ׼ӿʵ
 * \param[in] led_id LED 
 * \return 
 */
void demo_std_led_entry (int led_id);

/**
 * \brief LED ˮ
 *
 * \param[in] led_id_start  LEDʼ
 * \param[in] num           ˮ̵ LED Ŀ
 *
 * \return 
 */
void demo_std_led_water_light_entry (int led_id_start, int num);

/**
 * \brief ʱ PWM ܣͨ׼ӿʵ
 *
 * \param[in] pwm_handle   PWM ׼
 * \param[in] pwm_chan     ͨ
 *
 * \return 
 */
void demo_std_timer_pwm_entry (am_pwm_handle_t pwm_handle, int pwm_chan);

/**
 * \brief ʱ̣ͨ׼ӿʵ
 * \return 
 */
void demo_std_softimer_entry (void);

/**
 * \brief SPI д FLASH(MX25L3206E) ̣ͨ׼ӿʵ
 *
 * \param[in] spi_handle  SPI ׼
 * \param[in] cs_pin      Ƭѡź
 * \param[in] test_addr   Եַ
 * \param[in] test_length ֽ
 *
 * \return 
 */
void demo_std_spi_flash_entry (am_spi_handle_t spi_handle,
                               int             cs_pin,
                               uint32_t        test_addr,
                               uint32_t        test_length);

/**
 * \brief SPI ̣ͨ׼ӿʵ
 *
 * \param[in] spi_handle SPI ׼
 * \param[in] cs_pin     Ƭѡź
 *
 * \return 
 */
void demo_std_spi_master_entry (am_spi_handle_t spi_handle,
                                int             cs_pin);

/**
 * \brief SPI ӻ̣ͨ׼ӿʵ
 *
 * \param[in] spi_handle SPI ׼
 * \param[in] cs_pin     Ƭѡź
 *
 * \return 
 */
void demo_std_spi_slave_entry (am_spi_slv_handle_t handle);

/**
 * \brief ʱ׼ӿ̣ͨ׼ӿʵ
 *
 * \param[in] led_id LED 
 *
 * \return 
 */
void demo_std_delay_entry (int led_id);

/**
 * \brief Systick ̣ͨ׼ӿʵ
 *
 * \param[in] handle ʱ׼
 * \param[in] led_id LED 
 *
 * \return 
 */
void demo_std_systick_timer_entry (am_timer_handle_t handle, int led_id);

/**
 * \brief ʱʵֱ׼ʱ̣ͨ׼ӿʵ
 *
 * \param[in] handle      ʱ׼
 * \param[in] timing_chan ʱͨ
 *
 * \return 
 */
void demo_std_timer_timing_entry (am_timer_handle_t handle,
                                  int               timing_chan);

/**
 * \brief UART ѯʽ½շ̣ͨ׼ӿʵ
 * \param[in] handle UART ׼
 * \return 
 */
void demo_std_uart_polling_entry (am_uart_handle_t handle);

/**
 * \brief UART λʽ½շ̣ͨ׼ӿʵ
 * \param[in] uart_handle UART ׼
 * \return 
 */
void demo_std_uart_ringbuf_entry (am_uart_handle_t uart_handle);

/**
 * \brief UART RS485
 * \param[in] uart_handle UART ׼
 * \return 
 */
void demo_std_uart_rs485_entry (am_uart_handle_t uart_handle);

/**
 * \brief WDT ʾ̣ͨ׼ӿʵ
 *
 * \param[in] handle       WDT ׼
 * \param[in] time_out_ms  Źʱʱ
 * \param[in] feed_time_ms ιʱ
 *
 * \return 
 */
void demo_std_wdt_entry (am_wdt_handle_t handle,
                         uint32_t        time_out_ms,
                         uint32_t        feed_time_ms);
                         
/**
 * \brief ʾ60ʱ
 * \param[in] id ܱ
 * \return 
 */          
void demo_std_digitron_60s_counting_entry (int32_t id);

/**
 * \brief ʵʱʾ¶
 *
 * \param[in] id          ܱ
 * \param[in] temp_handle ¶ȴ׼
 *
 * \return 
 */
void demo_std_digitron_temp_entry (int32_t id, am_temp_handle_t temp_handle);
 
/**
 * \brief HC595 ̣Ϊڹ۲󣬽齫HC5958ӵLED
 * \param[in] hc595_handle  HC595 ׼
 * \return 
 */
void demo_std_hc595_led_entry (am_hc595_handle_t hc595_handle);

/**
 * \brief RTC
 * \param[in] rtc_handle  RTC豸׼
 * \return 
 */
void demo_std_rtc_entry (am_rtc_handle_t rtc_handle);

/**
 * \brief HMI
 * \param[in] pcf85063_handle  PCF85063豸׼
 * \return 
 */
void demo_std_hmi_int_entry (am_pcf85063_handle_t pcf85063_handle);

/**
 * \brief NVRAM 
 *
 * ʹõĴ洢 __g_nvram_segs[] бж壨am_nvram_cfg.c ļУ
 *
 * \param[in] p_nvram_name  洢
 * \param[in] nvram_unit    洢εԪ
 * \param[in] test_lenth    Զдݵĳ
 *
 * \return 
 */
void demo_std_nvram_entry (char *p_nvram_name, int32_t nvram_unit, int32_t test_lenth);

/**
 * \brief can 
 *
 * \param[in] can_handle    can ׼
 * \param[in] can_btr_baud  ʲ
 *
 * \return 
 */
void demo_std_can_entry (am_can_handle_t can_handle, am_can_bps_param_t  *can_btr_baud);

/**
 * \brief ʪȴSHT20
 *
 * \param[in] handle   SHT20׼
 *
 * \return 
 */
void demo_std_sht20_entry (am_sht20_handle_t handle);

/**
 * \brief ʪȴHTS221̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_hts221_int_entry (am_sensor_handle_t handle);

/**
 * \brief ʪȴHTS221̣ͨѯʽʵ
 *
 * \return 
 */
void demo_std_hts221_entry (am_sensor_handle_t handle);

/**
 * \brief ѹ¶ȴBMP280̣ͨѯʽʵ
 *
 * \return 
 */
void demo_std_bmp280_entry (am_sensor_handle_t handle);

/**
 * \brief ѹʪȴBME280̣ͨѯʽʵ
 *
 * \return 
 */
void demo_std_bme280_entry (am_sensor_handle_t handle);

/**
 * \brief ѹ¶ȴLPS22HḄͨѯʽʵ
 *
 * \return 
 */
void demo_std_lps22hb_entry (am_sensor_handle_t handle);

/**
 * \brief ѹ¶ȴLPS22HḄͨģʽʵ
 *
 * \return 
 */
void demo_std_lps22hb_int_entry (am_sensor_handle_t handle);

/**
 * \brief ǴBMG160̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_bmg160_entry (am_sensor_handle_t handle);

/**
 * \brief ŴMMC5883MẠͨѯģʽʵ
 *
 * \return 
 */
void demo_std_mmc5883ma_entry (am_sensor_handle_t handle);

/**
 * \brief ᴫFXOS8700CQ̣ͨѯʽʵ
 *
 * \return 
 */
void demo_std_fxos8700cq_entry (am_sensor_handle_t handle);

/**
 * \brief ᴫFXOS8700CQ̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_fxos8700cq_int_entry (am_sensor_handle_t handle);

/**
 * \brief ѹ¶ȴMPL3115A2̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_mpl3115a2_entry (am_sensor_handle_t handle);

/**
 * \brief ѹ¶ȴMPL3115A2̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_mpl3115a2_int_entry (am_sensor_handle_t handle);

/**
 * \brief MAG3110̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_mag3110_entry (am_sensor_handle_t handle);

/**
 * \brief MAG3110̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_mag3110_int_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫӽ TMD3702VC̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tmd3702vc_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫӽ TMD3702VC̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tmd3702vc_int_entry (am_sensor_handle_t handle);

/**
 * \brief ⴫ TSL2540̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tsl2540_entry (am_sensor_handle_t handle);

/**
 * \brief ⴫ TSL2540̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tsl2540_int_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫ TCS3430̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tcs3430_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫ TCS3430̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tcs3430_int_entry (am_sensor_handle_t handle);

/**
 * \brief ӽ TMD2635̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tmd2635_entry (am_sensor_handle_t handle);

/**
 * \brief ӽ TMD2635̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tmd2635_int_entry (am_sensor_handle_t handle);

/**
 * \brief ⡢ӽ TMD2750̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tmd2750_entry (am_sensor_handle_t handle);

/**
 * \brief ⡢ӽ TMD2750̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tmd2750_int_entry (am_sensor_handle_t handle);

/**
 * \brief ¶ȴ AS621x ̣ͨȽģʽʵ
 *
 * \return 
 */
void demo_std_as621x_comparator_mode_entry (am_sensor_handle_t handle);

/**
 * \brief ¶ȴ AS621x ̣ͨжģʽʵ
 *
 * \return 
 */
void demo_std_as621x_interrupt_mode_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫӽ/ƴ TMG49037̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tmg49037_entry (am_sensor_handle_t handle);

/**
 * \brief /ɫӽ/ƴ TMG49037̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tmg49037_int_entry (am_sensor_handle_t handle);

/**
 * \brief ״ AS7341̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_as7341_entry (am_sensor_handle_t handle);

/**
 * \brief ״ AS7341̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_as7341_int_entry (am_sensor_handle_t handle);

/**
 * \brief ߹״ AS7421̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_as7421_entry (am_sensor_handle_t handle);

/**
 * \brief ߹״ AS7421̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_as7421_int_entry (am_sensor_handle_t handle);

/**
 * \brief ״ AS7262̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_as7262_entry (am_sensor_handle_t handle);

/**
 * \brief ״ AS7262̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_as7262_int_entry (am_sensor_handle_t handle);

/**
 * \brief Ƕȴ AS5600̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_as5600_entry (am_sensor_handle_t handle);

/**
 * \brief TOF TMF8801̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tmf8801_entry (am_sensor_handle_t handle);

/**
 * \brief TOF TMF8801̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tmf8801_int_entry (am_sensor_handle_t handle);

/**
 * \brief ⴫ TSL2560̣ͨѯģʽʵ
 *
 * \return 
 */
void demo_std_tsl2560_entry (am_sensor_handle_t handle);

/**
 * \brief ⴫ TSL2560̣ͨģʽʵ
 *
 * \return 
 */
void demo_std_tsl2560_int_entry (am_sensor_handle_t handle);

/**
 * \brief SD Cardд
 *
 * \return 
 */
//void demo_std_sdcard_entry (am_sdcard_handle_t handle);

/**
 * \brief DACѹ׼ӿڲʵ
 * \return 
 */
void demo_std_dac_entry (am_dac_handle_t dac0_handle,
                         uint8_t         channel,
                         uint32_t        mv_out);

#ifdef __cplusplus
}
#endif

#endif /* __DEMO_STD_ENTRIES_H */

/* end of file */
