/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ٶȴ BMA253 ̣ͨ׼ӿʵ
 *
 * - ʵ
 *   1. ÿһ룬ͨڴӡٶȺ¶ȵֵ
 *
 * \par Դ
 * \snippet demo_std_bma253.c src_std_bma253
 *
 * \internal
 * \par Modification history
 * - 1.00 19-02-20  yrz, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_std_bma253
 * \copydoc demo_std_bma253.c
 */

#include "ametal.h"
#include "am_vdebug.h"
#include "am_sensor.h"
#include "am_sensor_bma253.h"
#include "am_delay.h"

/**
 * \brief 
 */
void demo_std_bma253_entry (am_sensor_handle_t handle)
{
    uint8_t i = 0;
    
    /* BMA253ṩͨIDо */
    const int id[4] = {AM_BMA253_CHAN_1, AM_BMA253_CHAN_2,
                       AM_BMA253_CHAN_3, AM_BMA253_CHAN_4};

    /* ĸͨݵĻ */
    am_sensor_val_t data[4];
                       
    /*
     * гĸͨٶȺ¶ȣݵֺ͵λַڴӡ
     */
    const char *data_name_string[] = {"ACC_X", "ACC_Y", "ACC_Z", "temperature"};
    const char *data_unit_string[] = {"m/s^2", "m/s^2", "m/s^2", ""};

    am_sensor_enable(handle, id, 4, data);

    while(1) {
        am_sensor_data_get(handle, id, 4, data);

        for (i = 0; i < 4; i++) {
            if (AM_SENSOR_VAL_IS_VALID(data[i])) { /* ͨЧʹ */

                /* λתΪ AM_SENSOR_UNIT_MICROԴӡʾ6λС */
                am_sensor_val_unit_convert(&data[i], 1, AM_SENSOR_UNIT_MICRO);
                am_kprintf("The %s is : %d.%06d %s.\r\n", 
                           data_name_string[i],
                           (data[i].val)/1000000,
                           (uint32_t)(data[i].val)%1000000,
                           data_unit_string[i]);
            } else {       //ͨЧݻȡʧ
                am_kprintf("The %s get failed!\r\n", data_name_string[i]);
            }
        }
        am_mdelay(1000);
    }
}

/* end of file */
