/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʪȴ HTS221 ̣ͨ׼ӿʵ
 *
 * - ʵ
 *   1. ÿһ룬ͨڴӡʪȺ¶ȵֵ
 *
 * \par Դ
 * \snippet demo_std_hts221.c src_std_hts221
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-27  wan, first implementation
 * \endinternal
 */

/**
 * \addtogroup demo_if_std_hts221
 * \copydoc demo_std_hts221.c
 */

#include "ametal.h"
#include "am_vdebug.h"
#include "am_sensor.h"
#include "am_sensor_hts221.h"
#include "am_delay.h"

/**
 * \brief 
 */
void demo_std_hts221_entry (am_sensor_handle_t handle)
{
    /* HTS221ṩͨIDо */
    const int       id[2] = {AM_HTS221_CHAN_1, AM_HTS221_CHAN_2};

    /* ͨݵĻ */
    am_sensor_val_t data[2];

    int             i;

    /*
     * гͨʪȺ¶ȣݵֺ͵λַڴӡ
     */
    const char *data_name_string[] = {"humidity", "temperature"};
    const char *data_unit_string[] = {"%rH", ""};

    am_sensor_enable(handle, id, 2, data);

    while(1) {
        am_sensor_data_get(handle, id, 2, data);
        for(i=0; i<2; i++) {
            if (AM_SENSOR_VAL_IS_VALID(data[i])) { /* ͨЧʹ */
                /* λתΪ AM_SENSOR_UNIT_MICROԴӡʾ6λС */
                am_sensor_val_unit_convert(&data[i], 1, AM_SENSOR_UNIT_MICRO);
                am_kprintf("The %s is : %d.%06d %s.\r\n", data_name_string[i],
                                                          (data[i].val)/1000000,
                                                          (data[i].val)%1000000,
                                                          data_unit_string[i]);
            } else {       //ͨЧݻȡʧ
                am_kprintf("The %s get failed!\r\n", data_name_string[i]);
            }
        }
        am_mdelay(1000);
    }
}

/* end of file */
