/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief ѭУ(CRC)׼ӿ
 *
 * \internal
 * \par modification history
 * - 1.00 15-01-19  tee, first implementation
 * \endinternal
 */

#ifndef __AM_CRC_H
#define __AM_CRC_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_crc
 * \copydoc am_crc.h
 * @{
 */
#include "am_common.h"

/**
 * \brief CRC ģ
 */
typedef struct am_crc_pattern {
    uint8_t    width;     /**< \brief CRC(磺CRC5 ĿΪ 5)            */
    uint32_t   poly;      /**< \brief CRCɶʽ                           */
    uint32_t   initvalue; /**< \brief CRCʼֵ                               */
    am_bool_t  refin;     /**< \brief ҪλתֵΪTRUE    */
    am_bool_t  refout;    /**< \brief ֵҪλתֵΪTRUE  */
    uint32_t   xorout;    /**< \brief ֵ                              */
} am_crc_pattern_t;


/**
 * \brief CRCṹ
 */
struct am_crc_drv_funcs {

    /** \brief CRCģͳʼCRCΪCRC׼ */
    int (*pfn_crc_init) (void *p_cookie, am_crc_pattern_t *p_pattern);

    /** \brief CRC                                 */
    int (*pfn_crc_cal) (void *p_cookie,const uint8_t *p_data, uint32_t nbytes);

    /** \brief ȡCRC                         */
    int (*pfn_crc_final) (void *p_cookie, uint32_t *p_value);
};

/** 
 * \brief CRC
 */
typedef struct am_crc_serv {

    /** \brief CRCṹָ    */
    struct am_crc_drv_funcs *p_funcs;
    
    /** \brief ĵһ */
    void                    *p_drv;     
} am_crc_serv_t;

/** \brief CRC׼Ͷ  */
typedef am_crc_serv_t *am_crc_handle_t;


/** 
 * \brief CRCģͳʼCRCΪCRC׼
 * 
 * \param[in] handle    : CRC׼
 * \param[in] p_pattern : ָCRCģϢṹָ
 *
 * \retval  AM_OK       : ʼɹ
 * \retval -AM_EINVAL   : ʼʧ, 
 * \retval -AM_ENOTSUP  : ʼʧ, CRCģͲ֧
 */
am_static_inline
int am_crc_init (am_crc_handle_t handle, am_crc_pattern_t *p_pattern)
{
    return handle->p_funcs->pfn_crc_init(handle->p_drv, p_pattern);
}

/** 
 * \brief CRC(ݴ)
 * 
 * \param[in] handle  : CRC׼
 * \param[in] p_data  : ָݻ
 * \param[in] nbytes  : ݵĸ
 *
 * \retval  AM_OK     : CRCɹ
 * \retval -AM_EINVAL : CRCʧ, 
 */
am_static_inline
int am_crc_cal (am_crc_handle_t handle, const uint8_t *p_data, uint32_t nbytes)
{
    return handle->p_funcs->pfn_crc_cal(handle->p_drv, p_data, nbytes);
}

/** 
 * \brief ȡCRCֵ
 *
 * \param[in]  handle  : CRC׼
 * \param[out] p_value : ڻȡCRCֵ
 *
 * \retval  AM_OK      : ȡCRCֵɹ
 * \retval -AM_EINVAL  : ȡCRCֵʧ, 
 */
am_static_inline
int am_crc_final (am_crc_handle_t handle, uint32_t *p_value) 
{
    return handle->p_funcs->pfn_crc_final(handle->p_drv, p_value);
}

/** 
 * @}  
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_CRC_H */

/* end of file */
