/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ¼
 *
 * 
 * 1. event category Ӧevent type Ͷ event handler
 * 2. event type     Ӧevent handler
 * 3. event handler  Ӧһ¼
 *
 * ¼
 * ¼Сλ event type¼ʱ
 * 1.  event type  event category е event handler ִһ顣
 * 2. ¼־ AM_EVENT_PROC_FLAG_CAT_ONLY event typeе
 *    event handler Ҳִһ顣
 *
 * \internal
 * \par modification history:
 * - 1.00 17-05-12 tee, first implementation.
 * \endinternal
 */

#ifndef __AM_EVENT_H /* { */
#define __AM_EVENT_H

/**
 * \addtogroup am_if_event
 * \copydoc am_event.h
 * @{
 */

#include "am_common.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \name ¼־am_event_handler_t  flags Ա־ʹû
 * @{
 */

/** \brief ¼󣬸¼Զע   */
#define AM_EVENT_HANDLER_FLAG_AUTO_UNREG     (1u << 0)

/** @} */

/**
 * \name ¼־־ʹû
 * @{
 */

/* \brief ¼ֻᴥ  event category е event handler  */
#define AM_EVENT_PROC_FLAG_CAT_ONLY         (1u << 0)

/** @} */

/** \breif event_category ṹ */
struct am_event_category;
typedef struct am_event_category am_event_category_t;

/** \breif event_type ṹ */
struct am_event_type;
typedef struct am_event_type am_event_type_t;

/** \breif event_handler ṹ */
struct am_event_handler;
typedef struct am_event_handler am_event_handler_t;

/**
 * \brief ¼Ͷ
 *
 * \param[in]  p_evt_type : ָ¼
 * \param[in]  p_evt_data : ¼
 * \param[in]  p_hdl_data  ¼˽
 *
 * \return 
 */
typedef void am_event_function_t (am_event_type_t   *p_evt_type,
                                  void              *p_evt_data,
                                  void              *p_hdl_data);

/**
 * \brief ¼ṹ嶨
 */
struct am_event_handler {
    uint16_t                 flags;     /**< \brief ־AM_EVENT_HANDLER_FLAG_*  */
    am_event_function_t     *pfn_proc;  /**< \brief   */
    void                    *p_data;    /**< \brief ¼˽      */
    struct am_event_handler *p_next;    /**< \brief ָһ¼  */
};

/** \brief ʼ¼ */
am_static_inline
void am_event_handler_init (am_event_handler_t  *p_handler,
                            am_event_function_t *pfn_proc,
                            void                *p_data,
                            uint16_t             flags)
{
    p_handler->flags    = flags;
    p_handler->pfn_proc = pfn_proc;
    p_handler->p_data   = p_data;
    p_handler->p_next   = NULL;
}


/** \brief ¼ͽṹ */
struct am_event_type {
    am_event_handler_t  *p_handler;   /**< \brief ¼д */
    am_event_category_t *p_category;  /**< \brief ¼¼  */
    am_event_type_t     *p_next;      /**< \brief ָһ¼  */
};


/** \brief ʼ¼  */
am_static_inline
void am_event_init (am_event_type_t *p_event)
{
    p_event->p_category = NULL;
    p_event->p_handler  = NULL;
    p_event->p_next     = NULL;
}

/** \brief ע¼¼ */
int am_event_handler_register (am_event_type_t     *p_event,
                               am_event_handler_t  *p_handler);

/** \brief ¼ע¼ */
int am_event_handler_unregister (am_event_type_t     *p_event,
                                 am_event_handler_t  *p_handler);

/**
 * \brief һ¼
 *
 * ᴥ event type  event category е event handler ִһ顣
 * ¼־ AM_EVENT_PROC_FLAG_CAT_ONLY event typeе
 * event handler Ҳִһ顣
 *
 * \param p_event      ¼
 * \param p_evt_data   ¼
 * \param flags        ־, 0  AM_EVENT_PROC_FLAG_*
 *
 * \return ׼
 */
int am_event_raise (am_event_type_t *p_event, void *p_evt_data, int flags);

/**
 * \brief ¼ṹ嶨壬¼¼
 *
 * µ¼ʱµ¼
 */
struct am_event_category {
    am_event_type_t    *p_event;    /**< \brief ¼  */
    am_event_handler_t *p_handler;  /**< \brief ¼ */
};


/** \brief ʼ¼¼ */
am_static_inline
void am_event_category_init (am_event_category_t *p_category)
{
    p_category->p_event   = NULL;
    p_category->p_handler = NULL;
}

/** \brief ע¼¼ */
int am_event_category_handler_register (am_event_category_t *p_category,
                                        am_event_handler_t  *p_handler);

/** \brief ¼ע¼ */
int am_event_category_handler_unregister (am_event_category_t *p_category,
                                          am_event_handler_t  *p_handler);

/** \brief ע¼¼  */
int am_event_category_event_register (am_event_category_t *p_category,
                                      am_event_type_t     *p_event);

/** \brief ¼ע¼  */
int am_event_category_event_unregister (am_event_category_t *p_category,
                                        am_event_type_t     *p_event);

#ifdef __cplusplus
}
#endif

/** @} grp_am_if_event */

#endif /* } __AM_EVENT_H */

/* end of file */
