/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief I2Cӻ׼ӿ
 *
 * \note ûɵô˽ӿͨMCUģһI2C豸
 *
 * \internal
 * \par Modification History
 * - 1.00 17-09-06  vir, first implementation.
 * \endinternal
 */

#ifndef __AM_I2C_SLV_H
#define __AM_I2C_SLV_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"

/**
 * @addtogroup am_if_i2c_slv
 * @copydoc am_i2c_slv.h
 * @{
 */

/**
 * \name I2Cӻ豸  Ա־ am_i2c_slv_device  dev_flags Ա
 * @{
 */
#define AM_I2C_SLV_ADDR_7BIT          0x0000u            /**< \brief 7-bits 豸ַ(Ĭ) */
#define AM_I2C_SLV_ADDR_10BIT         0x0001u            /**< \brief 10-bits 豸ַ */

#define AM_I2C_SLV_GEN_CALL_NACK      0X0000u             /**< \brief Ӧ㲥ַ (Ĭ) */
#define AM_I2C_SLV_GEN_CALL_ACK       0X0002u             /**< \brief Ӧ㲥ַ  */

/* ںӵַ豸 */
#define AM_I2C_SLV_SUBADDR_1BYTE      0X0000u            /**< \brief ӵַ1ֽ(Ĭ) */
#define AM_I2C_SLV_SUBADDR_2BYTE      0X0004u            /**< \brief ӵַ2ֽ */


#define AM_I2C_SLV_SUBADDR_SELF_INCREASING       0X0000u   /**< \brief ֧ӵַ  (Ĭ)*/
#define AM_I2C_SLV_SUBADDR_NSELF_INCREASING      0X0100u   /**< \brief ֧ӵַ   */
/** @} */


/**
 * \name  صķֵ
 *
 * \ note ҪӲǷֿ֧ƴӻӦ
 * @{
 */
#define AM_I2C_SLV_ACK          0       /**< \brief ӻӦ  */
#define AM_I2C_SLV_NACK         1       /**< \brief ӻӦ */

/** @} */



struct am_i2c_slv_device;

/**
 * \brief I2Cӻ
 */
struct am_i2c_slv_drv_funcs {
    /** \brief ʹI2Cӻ豸ʼ */
    int (*pfn_i2c_slv_setup) (void *p_drv, struct am_i2c_slv_device *p_i2c_slv_dev);

    /** \brief رI2C豸 */
    int (*pfn_i2c_slv_shutdown) (void *p_drv, struct am_i2c_slv_device *p_i2c_slv_dev);

    /** \brief ȡɵĴӻ豸 */
    int (*pfn_i2c_slv_num_get) (void *p_drv);
};

/**
 * \brief I2Cӻ׼ṹ
 */

typedef struct am_i2c_slv_serv {
    struct am_i2c_slv_drv_funcs   *p_funcs;   /**< \brief I2C         */
    void                          *p_drv;     /**< \brief I2Cڲ */
} am_i2c_slv_serv_t;

/** \brief I2Cӻ׼ */
typedef am_i2c_slv_serv_t *am_i2c_slv_handle_t;

/**
 * \brief ص ڷӻ״̬
 *
 * \note ֵο صķֵ͡
 */
typedef struct am_i2c_slv_cb_funcs {

    /** \brief ӻַƥʱص is_rx ΪAM_TRUEʱʾ ӻ ,Ϊ AM_FALSEʱʾӻ   */
    int (*pfn_addr_match)(void *p_arg, am_bool_t is_rx);

    /** \brief ȡһֽڻص */
    int (*pfn_txbyte_get)(void *p_arg, uint8_t *p_byte);

    /** \brief ύһյֽڻص  */
    int (*pfn_rxbyte_put)(void *p_arg, uint8_t byte);

    /** \brief ֹͣص */
    void (*pfn_tran_stop)(void *p_arg);

    /** \brief 㲥ص   */
    int (*pfn_gen_call)(void *p_arg, uint8_t byte);

}am_i2c_slv_cb_funcs_t;


/**
 * \brief I2Cӻ豸ṹ  (Ƽʹ am_i2c_slv_mkdev() ñݽṹ)
 */
typedef struct am_i2c_slv_device {
    am_i2c_slv_handle_t    handle;              /**< \brief 豸I2C׼handle    */
    am_i2c_slv_cb_funcs_t *p_cb_funs;           /**< \brief ص,ûҪĻصֵΪNULL */
    uint16_t               dev_addr;            /**< \brief 豸ĵַ */
    uint16_t               dev_flags;           /**< \brief 豸ԣI2C豸Ա־ */
    void                  *p_arg;               /**< \brief ص */
}am_i2c_slv_device_t;

/**
 * \brief I2Cӻ豸 ṹ
 *
 * \param[in] p_dev                 : ָӻ豸ṹָ
 * \param[in] handle                : 豸I2C׼
 * \param[in] p_cb_funs             : ص
 * \param[in] dev_addr              : ӻ豸ַ
 * \param[in] dev_flags             : ӻ豸ԣI2C豸Ա־
 * \param[in] p_arg                 : ص
 *
 * \return 
 *
 * \par 
 * \code
 * #include "am_i2c_slv.h"
 *
 *   am_i2c_slv_device_t  i2c_slv_dev;
 *
 *   am_i2c_slv_mkdev(  &i2c_slv_dev,
 *                      i2c_slv_handle,
 *                      &__g__cb_funs,
 *                      0x55,
 *                      AM_I2C_SLV_ADDR_7BIT
 *                      &i2c_slv_dev);
 * \endcode
 */
am_static_inline
void am_i2c_slv_mkdev (am_i2c_slv_device_t    *p_dev,
                       am_i2c_slv_handle_t     handle,
                       am_i2c_slv_cb_funcs_t  *p_cb_funs,
                       uint16_t                dev_addr,
                       uint16_t                dev_flags,
                       void                   *p_arg)

{
    p_dev->handle           = handle;
    p_dev->dev_addr         = dev_addr;
    p_dev->dev_flags        = dev_flags;
    p_dev->p_cb_funs        = p_cb_funs;
    p_dev->p_arg            = p_arg;
}

/**
 * \brief I2Cӻ豸
 *
 * \param[in] p_dev  : I2Cӻ豸
 *
 * \retval  AM_OK      :ɹ
 * \retval  AM_EINVAL  :
 * \retval  AM_EAGAIN  :޿õĴӻ
 *
 * \note  am_i2c_slv_mkdevһӻ豸֮󣬱ô˺ ӻ
 *
 */
am_static_inline
int am_i2c_slv_setup (am_i2c_slv_device_t *p_dev)
{
    return p_dev->handle->p_funcs->pfn_i2c_slv_setup(p_dev->handle->p_drv, p_dev);
}

/**
 * \brief رI2Cӻ豸
 *
 * \param[in] p_dev  : I2Cӻ豸
 *
 * \retval  AM_OK      : رճɹ
 *
 * \note ر֮¿  am_i2c_slv_start 
 */
am_static_inline
int am_i2c_slv_shutdown ( am_i2c_slv_device_t *p_dev)
{
    return p_dev->handle->p_funcs->pfn_i2c_slv_shutdown(p_dev->handle->p_drv, p_dev);
}

/**
 * \brief ȡõĴӻ豸
 *
 * \param[in] handle   : I2Cӻ׼
 *
 * \retval  ֵΪõĴӻ
 *           0 ޿ôӻ  ٵ am_i2c_slv_setup 
 *           1 ôӻΪ 1ٵam_i2c_slv_setup һΣɵ豸
 *          ...
 *           n : ôӻΪ n,ٵam_i2c_slv_setup n,ɵ豸 .
 */
am_static_inline
int am_i2c_slv_num_get (am_i2c_slv_handle_t handle)
{
    return handle->p_funcs->pfn_i2c_slv_num_get(handle->p_drv);
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_I2C_SLV_H */

/* end of file */
