/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief жӳٴ׼ӿ
 *
 *     ʵӦУϣӲжϺܿĽˣжʵ
 * ҪɵıȽϺʱĹŵжӳд
 *     жӳʱָȼӵУִ
 * һʱȴȡһȼߵֵעǣȼ
 * ߵִУܴϵǰִеȼϵ͵񣬱ȴ
 * ǰִɡ
 *     ˳ִУΪ˱֤жӳҲɣ鲻Ҫжӳ
 * ʱ
 *
 * ʹñҪͷļ:
 * \code
 * #include "am_isr_defer.h"
 * \endcode
 *
 * \attention ʹøģҪɾƽ̨֧
 *
 * \internal
 * \par modification history:
 * - 1.00 15-09-17  tee, first implementation
 * \endinternal
 */

#ifndef __AM_ISR_DEFER_H
#define __AM_ISR_DEFER_H

/**
 * \addtogroup am_if_isr_defer
 * \copydoc am_isr_defer.h
 * @{
 */
#include "am_list.h"
#include "am_jobq.h"
#include <string.h>

/** \brief жӳ */
typedef am_jobq_job_t am_isr_defer_job_t;

/** 
 * \brief ڴ䣬ɸָͻȡϢ 
 *
 * ӦóֱͣӸʵʹ AM_ISR_DEFER_PRIORITY_NUM_DEF() 
 * 궨ȼɡ
 */
struct am_isr_defer_info {
    am_jobq_queue_t       jobq_queue;
    unsigned int          priority_num;
    unsigned int         *p_bitmap_job;
    struct am_list_head   pri_heads[1]; 
};

/**
 * \brief жӳģʹõȼĿ
 *
 * ֻҪʹøú궨һΣjobЧȼΪ0 ~ pri_num - 1
 *
 * \note ʱ붨Ϊȫֵģ.cļС
 */
#define AM_ISR_DEFER_PRIORITY_NUM_DEF(pri_num)                      \
    struct __isr_defer_jobqinfo{                                    \
        am_jobq_queue_t       jobq_queue;                           \
        unsigned int          priority_num;                         \
        unsigned int         *p_bitmap_job;                         \
        struct am_list_head   pri_heads[pri_num];                   \
        unsigned int          bitmap_job[((pri_num) + 31) >> 5];    \
    };                                                              \
    static struct __isr_defer_jobqinfo __isr_defer_jobq_info;       \
    static struct __isr_defer_jobqinfo __isr_defer_jobq_info =      \
                 {{0}, pri_num,__isr_defer_jobq_info.bitmap_job,};  \
    struct am_isr_defer_info *gp_isr_defer_info =         \
                 (struct am_isr_defer_info *)&__isr_defer_jobq_info
            
/**
 * \brief ص
 */
typedef void (*am_isr_defer_add_cb_t) (void *p_arg);
 
/**
 * \brief жӳģʼʹжӳǰʹøúʼ
 *
 * \param[in] pfn_cb : ӳҵʱĻصÿʹ am_isr_defer_job_add()
 *                     µӳҵʱøú
 * \param[in] p_arg  : صû
 *
 * \return 
 *
 * \note ͨ£ʹһȼ͵жжӳҵ
 * ҪÿжӳҵʱһӦжϣͿԷڸûص
 * Сرأжӳҵѭдκpfn_cb
 * ΪNULL
 *
 * \attention ڳʼǰʹ AM_ISR_DEFER_PRIORITY_NUM_DEF() ȼĿ
 */
void am_isr_defer_init (am_isr_defer_add_cb_t pfn_cb, void *p_arg);

/**
 * \brief жӳ
 *
 * һѭеøúѭûʱ һ
 * ȼ͵жд
 */
int am_isr_defer_job_process (void);

/**
 * \brief ʼһӳ
 *
 * ڽһ뵽֮ǰȷʹøúһʼ
 *
 * \param[in] p_job : ָָ
 * \param[in] func  : ӦĴ
 * \param[in] p_arg : Ӧû
 * \param[in] pri   : ȼ
 *
 * \retval AM_OK      ʼɹ
 * \retval -AM_EINVAL : 
 *
 * \note ʹøúǰʹ am_jobq_job_t һjobʹøúʼ
 *       еĸԱʵʴڶдʱ˶ʱ붨Ϊ
 *       ȫֱ̬
 */
void am_isr_defer_job_init (am_isr_defer_job_t  *p_job,
                            am_pfnvoid_t         func,
                            void                *p_arg,
                            uint16_t             pri);
                            
/**
 * \brief һӵжӳٹ
 *
 * \param[in] p_job   : ָָ
 *
 * \retval AM_OK      ɹ
 * \retval -AM_EINVAL : 
 * \retval -AM_EBUSY  : ǰѾڶУ޷ظ
 * \retval -AM_EPERM  : isr deferģδȷʼʹ
 */
int am_isr_defer_job_add (am_isr_defer_job_t *p_job);

/** @}  */

#ifdef __cplusplus
}
#endif  /* __cplusplus  */

#endif  /* __AM_ISR_DEFER_H */

/* end of file */

