/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief 
 *
 *      ԽŵһУںʵʱٿʼЩ
 *  ж¼ĴСͨ£жϺӦþܿĽӦ
 *  ʽ䣨ʱѯȴȣʱͿԽжҪ
 *  ŵУȻڷжϻ£ٵде
 *  
 *      رأʱָȼȼߵ񽫻
 *  дʱֵעǣֻȴȼߵ
 *  񣬲ܴȼ͵
 *
 * ʹñҪͷļ:
 * \code
 * #include "am_jobq.h"
 * \endcode
 *
 * \internal
 * \par modification history:
 * - 1.00 15-09-17  tee, first implementation
 * \endinternal
 */

#ifndef __AM_JOBQ_H
#define __AM_JOBQ_H

/**
 * \addtogroup am_if_jobq
 * \copydoc am_jobq.h
 * @{
 */
#include "am_list.h"
#include <string.h>


/**
 * \brief нṹ
 */
typedef struct am_jobq_queue {
    
    /** \brief ÿȼӦһͷ    */
    struct am_list_head  *p_heads;
    
    /** \brief еȼĿȼĿΪ1024   */
    unsigned int          pri_num;
    
     /** \brief ÿλʾһ飬Ϊ 1 ʾ       */
    unsigned int          bitmap_grp;
    
    /** \brief һ32λΪ 1 ʾȼ */
    unsigned int         *p_bitmap_job;
 
    /** \brief еһЩ״̬־      */
    uint32_t              flags;
} am_jobq_queue_t;

/**
 * \brief ׼еı׼þɳʼ 
 */
typedef struct am_jobq_queue *am_jobq_handle_t;

/** 
 * \brief ṹ壬ӦóӦֱӲṹԱ
 *
 * ʹøͶһjobӦam_jobq_mkjob()еĸԱ
 */
typedef struct am_jobq_job {
    am_pfnvoid_t        func;   /**< \brief ӦĴ */
    void               *p_arg;  /**< \brief ӦĲ   */
    uint16_t            pri;    /**< \brief ȼ               */
    uint16_t            flags;  /**< \brief һЩ־             */
    struct am_list_head node;   /**< \brief ڵ             */
} am_jobq_job_t;

/**
 * \brief ʼһ
 *
 * \param[in] p_jobq_queue : ָеָ
 * \param[in] pri_num      : ʹõȼĿ
 *                             - ʵЧȼΪ0 ~ priority_num - 1
                               - ֵԽȼԽͣ0Ϊȼ
 * \param[in] p_heads      : ڴ䣬СΪ priority_num 
 * \param[in] p_bitmap_job : ڴ䣬СΪ priority_num / 32 ȡ
 *                           (priority_num + 31) / 32
 *
 * \return еĲʼʧܣֵΪNULL
 *
 * \par 
 * \code
 *
 *  #define MY_QJOB_NUM_PRI  64    // ȼĿ64
 *
 *  am_jobq_queue_t      myqjob_queue;
 *  struct am_list_head  myqjob_head[MY_QJOB_NUM_PRI];
 *  unsigned int         myqjob_pri_active[(MY_QJOB_NUM_PRI + 31) / 32];
 *
 *  am_jobq_queue_init(&myqjob_queue,
 *                     MY_QJOB_NUM_PRI,
 *                     myqjob_head,
 *                     myqjob_pri_active);
 * \endcode
 *
 * \note ڸúҪڴ䣬Ϥ򲻽ֱʹøúʹø
 *       Ϊ򵥵ĺͬõһhandleʹ AM_JOBQ_QUEUE_DECL()С
 *       ʹ AM_JOBQ_QUEUE_INIT() ʼС
 *
 * \sa AM_JOBQ_QUEUE_DECL(), AM_JOBQ_QUEUE_INIT()
 */
am_jobq_handle_t am_jobq_queue_init (am_jobq_queue_t     *p_jobq_queue,
                                     unsigned int         pri_num,
                                     struct am_list_head *p_heads,
                                     unsigned int        *p_bitmap_job);

/**
 * \brief ʼһ
 *
 * ڽһ뵽֮ǰȷʹøúһʼ
 *
 * \param[in] p_job : ָָ
 * \param[in] func  : ӦĴ
 * \param[in] p_arg : Ӧû
 * \param[in] pri   : ȼ
 *
 * \retval AM_OK      ʼɹ
 * \retval -AM_EINVAL : 
 *
 * \note ʹøúǰʹ am_jobq_job_t һjobʹøúʼ
 *       еĸԱʵʴڶдʱ˶ʱ붨Ϊ
 *       ȫֱ̬
 */
void am_jobq_job_init (am_jobq_job_t  *p_job,
                       am_pfnvoid_t    func,
                       void           *p_arg,
                       uint16_t        pri);
 
/**
 * \brief һӵ
 *
 * \param[in] handle  : еı׼
 * \param[in] p_job   : ָָ
 *
 * \retval AM_OK      ɹ
 * \retval -AM_EINVAL : 
 * \retval -AM_EBUSY  : ǰѾڶУ޷ظ
 */
int am_jobq_post (am_jobq_handle_t handle, am_jobq_job_t *p_job);

/**
 * \brief һУϺ󷵻
 *
 * һ񱻴Զ˳УԱٴμ롣
 * δʱ޷ٴμ
 *
 * \param[in] handle  : еı׼
 *
 * \retval AM_OK      
 * \retval -AM_EINVAL : 
 * \retval -AM_EBUSY  : ǰڴ
 */
int am_jobq_process (am_jobq_handle_t handle);

/**
 * \brief ʵָʹõȼ
 *
 * \param[in] queue_name   : 
 * \param[in] priority_num : ʹõȼĿ
 *                             - ʵЧȼΪ0 ~ priority_num - 1;
 *                             - ֵԽȼԽͣ0Ϊȼ
 *
 * \note öΪڴ䣬ڶҪڳʼʱʹʱЧҪ
 *       Ϊȫֵģֻģʹãʹ AM_JOBQ_QUEUE_DECL_STATIC()
 *       Ϊ̬ġ
 */
#define AM_JOBQ_QUEUE_DECL(queue_name, priority_num)                        \
            struct __jobqinfo_##queue_name {                                \
                am_jobq_queue_t      jobq_queue;                            \
                struct am_list_head  pri_heads[priority_num];               \
                unsigned int         bitmap_job[(priority_num + 31) >> 5];  \
            } queue_name;

/**
 * \brief ʵ̬
 *
 * \param[in] queue_name   : 
 * \param[in] priority_num : ʹõȼĿ
 *                             - ʵЧȼΪ0 ~ priority_num - 1;
 *                             - ֵԽȼԽͣ0Ϊȼ
 */
#define AM_JOBQ_QUEUE_DECL_STATIC(queue_name, priority_num)            \
            static AM_JOBQ_QUEUE_DECL(queue_name, priority_num)
/**
 * \brief ʼ
 *
 * \param[in] queue_name : ƣAM_JOBQ_QUEUE_DECL_STATIC()
 *                          AM_JOBQ_QUEUE_DECL()С
 *
 * \return еĲʼʧܣֵΪNULL
 */
#define AM_JOBQ_QUEUE_INIT(queue_name)                                         \
            am_jobq_queue_init(                                                \
             &(queue_name.jobq_queue),                                         \
               sizeof(queue_name.pri_heads) / sizeof(queue_name.pri_heads[0]), \
               queue_name.pri_heads,                                           \
               queue_name.bitmap_job)

/** @}  */

#ifdef __cplusplus
}
#endif  /* __cplusplus  */

#endif  /* __AM_JOBQ_H */

/* end of file */

