/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief NVRAM(ʧԴ洢)׼ӿ
 *
 * \par ʾ
 * \code
 *  #include "am_nvram.h"
 *
 *  char ip[4] = {1, 1, 1, 1};
 *  char data[4];
 *
 *  am_nvram_set("ip", 0, &ip[0],   0, 4);    // ÷ʧ"ip"
 *  am_nvram_get("ip", 0, &data[0], 0, 4);    // ȡʧ"ip"
 * \endcode
 *
 * // ݴӡ
 *
 * \internal
 * \par modification history:
 * - 1.00 15-09-12  tee,first implementation
 * \endinternal
 */

#ifndef __AM_NVRAM_H
#define __AM_NVRAM_H

#ifdef __cplusplus
extern "C" {
#endif   /* __cplusplus  */

/**
 * \addtogroup am_if_nvram
 * \copydoc am_nvram.h
 * @{
 */
   
#include "ametal.h"

/** 
 * \brief 洢Ͷ
 *
 *      ýṹҪһ洢Σÿ洢ζ봦ĳ洢豸Уô
 *  豸ʹ p_dev_name  dev_unit ȷϵͳʹõд洢ζӦֱӶ
 *  \sa am_nvram_cfg() ļС
 *
 *      ٶӦҪ4洢Σֱ𱣴IPַ4ֽڡ2¶ֵ4ֽڣ
 *  ϵͳ50ֽڣϵͳпΪNVRAM豸Ϊ FM24C02Զ´洢
 *  б
 *  const am_nvram_segment_t g_nvram_segs[] = {
 *      {"ip",         0,  0,  4,   "fm24c02"},
 *      {"ip",         1,  4,  4,   "fm24c02"},
 *      {"temp_limit", 0,  8,  4,   "fm24c02"},
 *      {"system",     0,  12, 50,  "fm24c02"},
 *      {"test",       0,  62, 178, "fm24c02"},
 *      {NULL,         0,   0,   0,      NULL}  // մ洢Σ뱣
 * };
 */
typedef struct am_nvram_segment {
    char       *p_name;       /**< \brief 洢                    */
    int         unit;         /**< \brief 洢εԪ                  */
    uint32_t    seg_addr;     /**< \brief 洢ڴ洢еʼַ  */
    uint32_t    seg_size;     /**< \brief 洢εĴС                  */
    const char *p_dev_name;   /**< \brief 洢Ĵ洢豸      */
} am_nvram_segment_t;

/**
 * \brief NVRAM ṹ
 */
struct am_nvram_drv_funcs {
    
    /** \brief ָ NVRAM ݻȡ*/
    int (*pfn_nvram_get) (void       *p_drv,
                          int         offset,
                          uint8_t    *p_buf,
                          int         len);
 
    /** \brief ָ NVRAM ú */
    int (*pfn_nvram_set) (void          *p_drv,
                          int            offset,
                          uint8_t       *p_buf,
                          int            len);
};

/**
 * \brief NVRAM洢豸Ͷ
 */
typedef struct am_nvram_dev {
    const char                      *p_dev_name; /**< \brief 豸           */
    const struct am_nvram_drv_funcs *p_funcs;    /**< \brief Ӧ   */
    void                            *p_drv;      /**< \brief      */
    struct am_nvram_dev             *p_next;     /**< \brief ָһ豸   */
} am_nvram_dev_t;

/**
 * \brief NVRAM ʼ
 * \param[in] p_seglist : ϵͳ洢б
 * \return AM_OKʼɹֵʼʧܡ  
 * \note úһϵͳʱãӦóֱʹøú
 */
int am_nvram_init (const am_nvram_segment_t *p_seglist);

/**
 * \brief ϵͳעһNVRAM洢豸
 * \param[in] p_dev : ע豸
 * \return AM_OKעɹֵעʧܡ
 * \note úһɴ洢ãӦóֱʹøú
 */
int am_nvram_dev_register (am_nvram_dev_t *p_dev);

/**
 * \brief ȡһעNVRAM洢豸
 * \param[in] p_dev : ȡѾע NVRAM洢豸
 * \return AM_OKȡעɹֵȡעʧܡ
 * \note úһɴ洢ãӦóֱʹøú
 */
int am_nvram_dev_unregister (am_nvram_dev_t *p_dev);

/**
 * \brief ȡһʧԴ洢Ϣ
 *
 * ӷʧԴ洢豸жȡʧϢ浽ṩĻСκ
 * ҪʹNVRAMģ鶼ʹñ
 *
 * ʹ\a p_name \a unit ʶһʧϢ
 *
 * ʼλ\a offset ָ\a len ָָĴС
 * ˸÷ʧϢĴСΪδ塣
 *
 * \param[in] p_name  ʧԴ洢Ϣ
 * \param[in] unit    ʧԴ洢ϢĵԪ
 * \param[in] p_buf   дݻ
 * \param[in] offset  ڷʧԴ洢Ϣеƫ
 * \param[in] len     Ҫ洢ĳ
 *
 * \retval AM_OK      ɹ
 * \retval -AM_EINVAL  \a p_name  \a p_buf ΪNULL
 * \retval -AM_EIO    ָķʧԴ洢Ϣڻʧ
 *
 * \par ʾ
 * \code
 *  #include "aw_nvram.h"
 *
 *  char ip[4];
 *  aw_nvram_get("ip", 0, &ip[0], 0, 4);    // ȡʧ"ip"
 * \endcode
 *
 * \sa aw_nvram_set()
 */
int am_nvram_get (char *p_name, int unit, uint8_t *p_buf, int offset, int len);

/**
 * \brief дһʧԴ洢Ϣ
 *
 * ӵṩĻжȡϢ洢ʧԴ洢豸Сκ
 * ҪʹNVRAMģ鶼ʹñ
 *
 * ʹ\a p_name \a unit ʶһʧϢ
 *
 * 洢ʼλ\a offset ָ洢\a len ָָĴС
 * ˸÷ʧϢĴСΪδ塣
 *
 * \param[in] p_name  ʧԴ洢Ϣ
 * \param[in] unit    ʧԴ洢ϢĵԪ
 * \param[in] p_buf   дݻ
 * \param[in] offset  ڷʧԴ洢Ϣеƫ
 * \param[in] len     Ҫ洢ĳ
 *
 * \retval AM_OK      ɹ
 * \retval -AM_EINVAL  \a p_name  \a p_buf ΪNULL
 * \retval -AM_EIO    ָķʧԴ洢Ϣڻʧ
 *
 * \par ʾ
 * \code
 *  #include "am_nvram.h"
 *
 *  char ip[4] = {1, 1, 1, 1};
 *  am_nvram_set("ip", 0, &ip[0], 0, 4);    // дʧ"ip"
 * \endcode
 *
 * \sa am_nvram_get()
 */
int am_nvram_set (char *p_name, int unit, uint8_t *p_buf, int offset, int len);

/**
 * \brief ȡNVRAM洢εС
 *
 * \param[in]  p_name  ʧԴ洢Ϣ
 * \param[in]  unit    ʧԴ洢ϢĵԪ
 * \param[out] p_size  洢εС
 *
 * \retval AM_OK      ɹ
 * \retval -AM_EINVAL  \a p_name  \a p_buf ΪNULL
 * \retval -AM_EIO    ָķʧԴ洢Ϣڻʧ
 *
 * \par ʾ
 * \code
 *  #include "am_nvram.h"
 *  size_t size = 0;
 *  am_nvram_set("ip", 0, &size);    // дʧ"ip"
 * \endcode
 *
 * \sa am_nvram_get()
 */
int am_nvram_size_get (char *p_name, int unit, size_t *p_size);

/** @} am_if_nvram */

#ifdef __cplusplus
}
#endif   /* __cplusplus  */

#endif   /* __AM_NVRAM_H */

/* end of file */
