/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief PWM׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 15-01-05  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_PWM_H
#define __AM_PWM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"

/**
 * \addtogroup am_if_pwm
 * \copydoc am_pwm.h
 * @{
 */

/**
 * \brief PWMṹ
 */
struct am_pwm_drv_funcs {

    /** \brief һPWMͨ  */
    int (*pfn_pwm_config) (void          *p_drv,
                           int            chan,
                           unsigned long  duty_ns,
                           unsigned long  period_ns);
    
    /** \brief ʹPWM     */
    int (*pfn_pwm_enable) (void *p_drv, int chan);
    
    /** \brief PWM     */
    int (*pfn_pwm_disable) (void *p_drv,int chan);
};

/** 
 * \brief PWM
 */
typedef struct am_pwm_serv {

    /** \brief PWMṹָ   */
    struct am_pwm_drv_funcs   *p_funcs;
    
    /** \brief ĵһ */
    void                      *p_drv; 
} am_pwm_serv_t;

/** \brief PWM׼Ͷ */
typedef am_pwm_serv_t *am_pwm_handle_t;

/** 
 * \brief һPWMͨ
 * 
 * \param[in] handle    : PWM׼
 * \param[in] chan      : PWMͨ
 * \param[in] duty_ns   : PWMʱ䣨λ룩
 * \param[in] period_ns : PWMʱ䣨λ룩
 *
 * \retval  AM_OK       : PWMͨɹ
 * \retval -AM_EINVAL   : ʧ, 
 */
am_static_inline
int am_pwm_config (am_pwm_handle_t handle, 
                   int             chan,
                   unsigned long   duty_ns,
                   unsigned long   period_ns)
{
    return handle->p_funcs->pfn_pwm_config(handle->p_drv,
                                           chan,
                                           duty_ns,
                                           period_ns);
}

/** 
 * \brief ʹPWM
 * 
 * \param[in] handle  : PWM׼
 * \param[in] chan    : PWMͨ
 *
 * \retval  AM_OK     : ʹPWMɹ
 * \retval -AM_EINVAL : ʧ, 
 */
am_static_inline
int am_pwm_enable (am_pwm_handle_t handle, int chan)
{
    return handle->p_funcs->pfn_pwm_enable(handle->p_drv, chan);
}

/** 
 * \brief PWM
 * 
 * \param[in] handle  : PWM׼
 * \param[in] chan    : PWMͨ
 *
 * \retval  AM_OK     : PWMɹ
 * \retval -AM_EINVAL : ʧ, 
 */
am_static_inline
int am_pwm_disable (am_pwm_handle_t handle, int chan)
{
    return handle->p_funcs->pfn_pwm_disable(handle->p_drv, chan);
}

/** 
 * @} 
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_PWM_H */

/* end of file */
