/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
/**
 * \file
 * \brief ͨûλ
 * 
 * \internal
 * \par Modification history
 * - 1.00 15-12-09  tee, add implementation from AWorks
 * \endinternal
 */
#ifndef __AM_RNGBUF_H
#define __AM_RNGBUF_H

#include "am_common.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup am_if_rngbuf
 * \copydoc am_rngbuf.h
 * @{
 */
 
/**
 * \brief λṹ
 * \note ҪֱӲṹĳԱ
 */
struct am_rngbuf {
    int     in;     /**< \brief дλ */
    int     out;    /**< \brief ݶλ */
    int     size;   /**< \brief С */
    char   *buf;    /**< \brief      */
};

/** \brief λ */
typedef struct am_rngbuf *am_rngbuf_t;

/**
 * \brief ʼλ
 *
 * \param[in] p_rb    : ҪʼĻλ
 * \param[in] p_buf   : λʹõĻռ
 * \param[in] size    : Сϵͳһֽڣ
 *                      ʵʻλôСΪ size - 1
 *                    
 * \retval  AM_OK     : ʼ
 * \retval -AM_EINVAL : ʼʧܣЧ
 *
 * \warning رע⣬ռʹбһֽڿռ䣬λʵʿôСΪ
 *          \b size - \b 1
 */
int am_rngbuf_init (struct am_rngbuf *p_rb, char *p_buf, size_t size);

/**
 * \brief һֽڵλ
 *
 * \param[in] rb   : ҪĻλ
 * \param[in] data : Ҫŵֽ
 *
 * \retval 0 : ݴʧܣ
 * \retval 1 : ݳɹ
 */
int am_rngbuf_putchar (am_rngbuf_t rb, const char data);

/**
 * \brief ӻλȡһֽ
 *
 * \param[in] rb     : ҪĻλ
 * \param[in] p_data : ֽڵָ
 *
 * \retval 0 : ȡʧܣ
 * \retval 1 : ݳɹȡ
 */
int am_rngbuf_getchar (am_rngbuf_t rb, char *p_data);

/**
 * \brief ֽڵλ
 *
 * \param[in] rb     : ҪĻλ
 * \param[in] p_buf  : Ҫŵλݻ
 * \param[in] nbytes : Ҫŵλݸ
 *
 * \return ɹŵݸ
 */
size_t am_rngbuf_put (am_rngbuf_t rb, const char *p_buf, size_t nbytes);

/**
 * \brief ӻλȡ
 *
 * \param[in] rb     : ҪĻλ
 * \param[in] p_buf  : ŻȡݵĻ
 * \param[in] nbytes : Ҫȡݸ
 *
 * \return ɹȡݸ
 */
size_t am_rngbuf_get (am_rngbuf_t rb, char *p_buf, size_t nbytes);

/**
 * \brief ջλ
 *
 * ջλ֮ǰڻݻᶪʧ
 *
 * \param[in] rb : ҪĻλ
 *
 * \return 
 */
void am_rngbuf_flush (am_rngbuf_t rb);

/**
 * \brief ԻλǷΪ
 *
 * \param[in] rb : ҪԵĻλ
 *
 * \return λշAM_TRUE, 򷵻AM_FALSE
 */
am_bool_t am_rngbuf_isempty (am_rngbuf_t rb);

/**
 * \brief ԻλǷ
 *
 * \param[in] rb : ҪԵĻλ
 *
 * \return λAM_TRUE, 򷵻AM_FALSE
 */
am_bool_t am_rngbuf_isfull (am_rngbuf_t rb);

/**
 * \brief ȡλпռС
 *
 * \param[in] rb : ҪжϵĻλ
 *
 * \return λпռС
 */
size_t am_rngbuf_freebytes (am_rngbuf_t rb);

/**
 * \brief ȡλֽڸ
 *
 * \param[in] rb : ҪжϵĻλ
 *
 * \return λֽڸ
 */
size_t am_rngbuf_nbytes (am_rngbuf_t rb);

/**
 * @} 
 */

#ifdef __cplusplus
}
#endif
 
#endif /* __AM_RINGBUF_H */

/* end of file */
