/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/
    
/**
 * \file
 * \brief ӿ
 *
 * ʹñҪͷļ am_sensor.h
 *
 * \internal
 * \par modification history
 * - 1.00 18-11-20  wan, first implementation.
 * \endinternal
 */

#ifndef __AM_SENSOR_H
#define __AM_SENSOR_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"

/**
 * \addtogroup grp_am_if_sensor
 * \copydoc am_sensor.h
 * @{
 */

/**
 * \name Ͷ
 * @{
 */
#define AM_SENSOR_TYPE_VOLTAGE     (1)  /**< \brief ѹλ: V             */
#define AM_SENSOR_TYPE_CURRENT     (2)  /**< \brief λ: A             */
#define AM_SENSOR_TYPE_TEMPERATURE (3)  /**< \brief ¶ȣλ: ϶        */
#define AM_SENSOR_TYPE_PRESS       (4)  /**< \brief ѹǿλ: ˹        */
#define AM_SENSOR_TYPE_LIGHT       (5)  /**< \brief նȣλ: տ˹      */
#define AM_SENSOR_TYPE_ALTITUDE    (6)  /**< \brief Σλ:             */
#define AM_SENSOR_TYPE_DISTANCE    (7)  /**< \brief 룬λ:             */

/** \brief ֱ<=1um΢Ũȣλ: ug/m^3 */
#define AM_SENSOR_TYPE_PM_1             (100)

/** \brief ֱ<=2.5um΢Ũȣλ: ug/m^3 */
#define AM_SENSOR_TYPE_PM_2_5           (101)

/** \brief ֱ<=10um΢Ũȣλ: ug/m^3 */
#define AM_SENSOR_TYPE_PM_10            (102)

/** \brief ʪȣֵΪٷֱȣ1ʾ 1% */
#define AM_SENSOR_TYPE_HUMIDITY         (103)

/** \brief ӽʽֵźţ1 ʾнӽ */
#define AM_SENSOR_TYPE_PROXIMITY        (104)

/** \brief 򣬽Ƕ 0/90/180/270 ֱʾ/// */
#define AM_SENSOR_TYPE_ORIENT           (105)

/** \brief  */
#define AM_SENSOR_TYPE_ALS              (106)

/** \brief ⣬ɼ */
#define AM_SENSOR_TYPE_ALS_VISIBLE      (107)

/** \brief ⣬ */
#define AM_SENSOR_TYPE_ALS_IR           (108)

/** \brief  */
#define AM_SENSOR_TYPE_GESTURE          (109)

/** \brief  */
#define AM_SENSOR_TYPE_SPECTRAL         (110)

/**
 * \brief ٶȣλ: m/s^2
 *
 * ִԼļٶȣ磺x,y,z ᣬ£ʹͨ
 * ֲͬļٶȣxyz ʾ˲ͬͨ
 */
#define AM_SENSOR_TYPE_ACCELEROMETER    (200)

/**
 * \brief ٶȣǲλ: rad/s
 *
 * ִԼĽٶȣ磺x,y,z ᣬ£ʹͨ
 * ֲͬĽٶȣxyz ʾ˲ͬͨ
 */
#define AM_SENSOR_TYPE_GYROSCOPE        (201)

/**
 * \brief ŸӦǿȣλ: ˹
 *
 * ִԼĴŸӦǿȣ磺x,y,z ᣬ£ʹͨ
 * ֲͬĴŸӦǿȣxyz ʾ˲ͬͨ
 */
#define AM_SENSOR_TYPE_MAGNETIC         (202)

/**
 * \brief תʸ(Rotation Vector)Ƕơ
 *
 * תʸͨΪתǶȣ x,y,z ᣬ£ʹͨ
 * ֲͬķ
 */
#define AM_SENSOR_TYPE_ROTATION_VECTOR  (203)

/** @} */

/**
 * \name ģʽ
 * @{
 */

/**
 * \brief ׼
 */
#define AM_SENSOR_TRIGGER_DATA_READY   (1ul << 0)

/**
 * \brief ޴
 *
 * Σﵽ #AM_SENSOR_ATTR_DURATION_DATA ֵݾ
 * #AM_SENSOR_ATTR_THRESHOLD_UPPER ֵ
 * #AM_SENSOR_ATTR_THRESHOLD_LOWER ֵʱ
 */
#define AM_SENSOR_TRIGGER_THRESHOLD    (1ul << 1)

/**
 * \brief бʣ
 *
 * Σﵽ #AM_SENSOR_ATTR_DURATION_SLOPE ֵ
 * һβݵޣ #AM_SENSOR_ATTR_THRESHOLD_SLOPE ʱ
 * 
 */
#define AM_SENSOR_TRIGGER_SLOPE        (1ul << 2)

/**
 * \brief ͵Ĵ
 *
 * ӽʽ⴫ഫźǶֵźţֵΪʱ
 *0
 */
#define AM_SENSOR_TRIGGER_BOOL         (1ul << 3)

/** @} */

/**
 * \name ͨԶ
 * @{
 */

/** \brief ƵʣÿĴ */
#define AM_SENSOR_ATTR_SAMPLING_RATE          (1)

/** \brief ֵ */
#define AM_SENSOR_ATTR_FULL_SCALE             (2)

/** \brief ƫֵھ̬У׼ݣ = ʵʲֵ + offset */
#define AM_SENSOR_ATTR_OFFSET                 (3)

/** \brief ޣ޴ģʽݵڸֵʱ */
#define AM_SENSOR_ATTR_THRESHOLD_LOWER        (4)

/** \brief ޣ޴ģʽݸڸֵʱ */
#define AM_SENSOR_ATTR_THRESHOLD_UPPER        (5)

/** \brief ޣݱ仯죨бʹ󣩣ֵʱ */
#define AM_SENSOR_ATTR_THRESHOLD_SLOPE        (6)

/**
 * \brief ݳ޴ģʽ
 *
 * ֵЧʱʾΣﵽֵݾ޻
 * ʱŴ
 */
#define AM_SENSOR_ATTR_DURATION_DATA          (7)

/**
 * \brief ģʽ
 *
 * ֵЧʱʾΣﵽֵһβ
 * ʱŴ
 */
#define AM_SENSOR_ATTR_DURATION_SLOPE         (8)

/** @} */

/**
 * \name λ壬ڴݵ unit 
 *
 * \anchor table_unit
 *
 * \par λǰ׺
 *
 * | ָ10ݣ | ţSymbol | Ӣǰ׺ |  Ķ  |
 * | :------------: | :----------- : | :------: |:---------: |
 * |       24       |        Y       |   Yotta  |  Ң  |
 * |       21       |        Z       |   Zetta  |    |
 * |       18       |        E       |    Exa   |  |
 * |       15       |        P       |   Peta   |  ģ  |
 * |       12       |        T       |   Tera   |  ̫  |
 * |        9       |        G       |   Giga   |    |
 * |        6       |        M       |   Mega   |          |
 * |        3       |        k       |   kilo   |     ǧ     |
 * |        2       |        h       |   hecto  |          |
 * |        1       |        da      |   deca   |     ʮ     |
 * |        0       |        -       |     -    |     -      |
 * |       -1       |        d       |   deci   |          |
 * |       -2       |        c       |   centi  |          |
 * |       -3       |        m       |   milli  |          |
 * |       -6       |               |   micro  |     ΢     |
 * |       -9       |        n       |   nano   |  ɣŵ  |
 * |       -12      |        p       |   pico   |  Ƥɣ  |
 * |       -15      |        f       |   femto  | ɣĸУ |
 * |       -18      |        a       |   atto   |  У  |
 * |       -21      |        z       |   zepto  | ƣУ |
 * |       -24      |        y       |   yocto  | ۣУ |
 *
 * \note
 *
 *  - ָ 10ݣ磬24ʾ 10^24ָͨ3Ϊ1000Ϊ
 *  - SymbolִСдָǰ׺УΪдΨ kilo
 * ķ "k" Сдڴ¶ȵķţд "K"
 *  - ǰ׺ӢĵУͨӸǰ׺ʾ磬ȵλ׵Ӣĵ
 * Ϊmeterǧ׶ӦĵΪkilometer
 *  - ĶУڵڲ»¿ʡԡ
 *  - ٣10^2ʮ10^1֣10 ^-1壨10^-2ʹá
 * @{
 */

#define AM_SENSOR_UNIT_YOTTA      (24)       /**< \brief Ң10^(24)    */
#define AM_SENSOR_UNIT_ZETTA      (21)       /**< \brief 10^(21)    */
#define AM_SENSOR_UNIT_EXA        (18)       /**< \brief 10^(18)  */
#define AM_SENSOR_UNIT_PETA       (15)       /**< \brief ģ10^(15)    */
#define AM_SENSOR_UNIT_TERA       (12)       /**< \brief ̫10^(12)    */
#define AM_SENSOR_UNIT_GIGA       (9)        /**< \brief 10^(9)     */
#define AM_SENSOR_UNIT_MEGA       (6)        /**< \brief ף10^(6)           */
#define AM_SENSOR_UNIT_KILO       (3)        /**< \brief ǧ10^(3)           */
#define AM_SENSOR_UNIT_HECTO      (2)        /**< \brief ٣10^(2)           */
#define AM_SENSOR_UNIT_DECA       (1)        /**< \brief ʮ10^(1)           */
#define AM_SENSOR_UNIT_BASE       (0)        /**< \brief 10^(0)Ϊ1  */
#define AM_SENSOR_UNIT_DECI       (-1)       /**< \brief ֣10^(-1)          */
#define AM_SENSOR_UNIT_CENTI      (-2)       /**< \brief 壬10^(-2)          */
#define AM_SENSOR_UNIT_MILLI      (-3)       /**< \brief 10^(-3)          */
#define AM_SENSOR_UNIT_MICRO      (-6)       /**< \brief ΢10^(-6)          */
#define AM_SENSOR_UNIT_NANO       (-9)       /**< \brief ɣŵ10^(-9)    */
#define AM_SENSOR_UNIT_PICO       (-12)      /**< \brief Ƥɣ10^(-12)   */
#define AM_SENSOR_UNIT_FEMTO      (-15)      /**< \brief ɣĸУ10^(-15) */
#define AM_SENSOR_UNIT_ATTO       (-18)      /**< \brief У10^(-18)   */
#define AM_SENSOR_UNIT_ZEPTO      (-21)      /**< \brief ƣУ10^(-21) */
#define AM_SENSOR_UNIT_YOCTO      (-24)      /**< \brief ۣУ10^(-24) */

#define AM_SENSOR_UNIT_INVALID    (-32768)   /**< \brief Чֵ       */

/** @} */

/** \brief жϴĳһͨǷЧֵΪʱЧЧ */
#define AM_SENSOR_VAL_IS_VALID(data)    \
             ((data).unit != (int32_t)(AM_SENSOR_UNIT_INVALID))

/**
 * \brief ꣬ȡһλӦǰ׺ţ"M"ף"k"ǧ
 *
 * \param[in] unit : λAM_SENSOR_UNIT_* (eg: #AM_SENSOR_UNIT_MILLI)
 *
 * \return ַλЧ򷵻NULLunitΪ0(#AM_SENSOR_UNIT_BASE)
 * 򷵻ؿַ: ""رע⣬صһַһַΪ
 * ֵλķſĸ磺"da"ʮ
 */
#define AM_SENSOR_UNIT_SYMBOL_GET(unit) am_sensor_unit_symbol_get(unit)

/**
 * \name صͶ
 * @{
 */

/**
 * \brief ص
 *
 * \param[in] p_arg       : ûûصʱָû
 * \param[in] trigger_src : ԴAM_SENSOR_TRIGGER_*ǶĻֵ
 *
 * \return 
 */
typedef void (*am_sensor_trigger_cb_t) (void *p_arg, uint32_t trigger_src);

/** @} */

/**
 * \brief 
 *
 * ʵУݿΪСΪ˱ӰϵͳܣAMetalֱʹø
 * ʹá + λʾһݡʵʴΪСʱֻ
 * ʹøСĵλʾݣɽʹȫС
 *
 * 磬һѹɼĵѹΪ1.234VѹĻλΪVÿִ
 * ͶӦĻλڶ崫ͺʱ˵Ϊ˱С䵥λС
 * Ϊ mVΪ1234 mV
 *
 * ʹ val  unit зֱʾݵֵĵλ
 *
 * - val  : ֵз32λ
 * - unit λ"M"ף"k"ǧ"m"""΢ "p"Ƥȵȡ
 * λʹ10ݽбʾ"M"ʾ10^6unitֵΪ6ͨ£unitΪ
 * ԱʾȷСλ
 *
 * 轫ͳһΪλ罫ѹȫͳһΪλVͨ¹
 * ʽɣdata = val * (10 ^ unit)͵ļ±:
 *
 * |   dataʵֵѹ: V |    val    |   unit   |
 * | :-----------------------: | :-------: | :------: |
 * |           2.854           |  2854     |  -3(mV)  |
 * |           1.7             |  1700     |  -3(mV)  |
 * |           2.3433          |  2343300  |  -6(V)  |
 * |           2888000         |  2888     |   3(kV)  |
 * |           0               |     0     |     0    |
 * |          -2888000         |  -2888    |   3(kV)  |
 * |          -2.3433          |  -2343300 |  -6(V)  |
 * |          -2.854           |  -2854    |  -3(mV)  |
 * |          -1.7             |  -1700    |  -3(mV)  |
 *
 * \attention  unit ֵΪ -32768 ʱʾֵΪЧĴݡʹ
 * groupؽӿڲͨʱֵΪAM_OKʾĳЩͨ
 * ʧܣʧܵͨӦĴֵΪЧֵʹ AM_SENSOR_VAL_IS_VALID()
 * ԿжֵǷЧʱvalԱΪ׼룬Ծݴжʧܵԭ
 */
typedef struct am_sensor_val {

    /**
     * \brief ֵЧΧ-2147483648 ~ 2147483647
     *
     * رأ unit ֵΪ (#AM_SENSOR_UNIT_INVALID) ʱʾֵΪЧĴ
     * ֵʱvalԱֵʾ׼룬Ըûжϲʧܵԭ
     * 磬-AM_ENODEV ʾͨidڣ޶Ӧ豸
     */
    int32_t   val;

    /**
     * \brief λ
     *
     * ʹָ10ݣʾ磺6ʾ10^6"M"ף3ʾ10^3
     * "k"ǧ-3ʾ10^-3"m"
     *
     * ֱʹ֣ʹѾõĵλ꣺AM_SENSOR_UNIT_*
     * (eg: #AM_SENSOR_UNIT_MILLI)
     *
     * رע⣬ֵΪ (#AM_SENSOR_UNIT_INVALID) ʱʾֵΪЧĴֵ
     * ʱvalԱֵʾ׼룬Ըûжϲʧܵԭ
     *
     * ͨ£λӲ淴ӳһľȣˣһ̲
     * 䣬ôݵĵĵλһҲı䡣
     */
    int32_t   unit;

} am_sensor_val_t;

/**
 * \brief ṹ
 */
struct am_sensor_drv_funcs {

    /** \brief ȡôĳһͨ */
    am_err_t (*pfn_type_get)(void *p_drv, int id);

    /** \brief ȡͨ */
    am_err_t (*pfn_data_get)(void            *p_drv,
                             const int       *p_ids,
                             int              num,
                             am_sensor_val_t *p_buf);

    /** \brief ʹܴͨ */
    am_err_t (*pfn_enable)(void            *p_drv,
                           const int       *p_ids,
                           int              num,
                           am_sensor_val_t *p_result);

    /** \brief ܴͨ */
    am_err_t (*pfn_disable)(void            *p_drv,
                            const int       *p_ids,
                            int              num,
                            am_sensor_val_t *p_result);

    /** \brief ôͨ */
    am_err_t (*pfn_attr_set)(void                  *p_drv,
                             int                    id,
                             int                    attr,
                             const am_sensor_val_t *p_val);

    /** \brief ȡͨ */
    am_err_t (*pfn_attr_get)(void            *p_drv,
                             int              id,
                             int              attr,
                             am_sensor_val_t *p_val);

    /** \brief ôһͨһص */
    am_err_t (*pfn_trigger_cfg)(void                   *p_drv,
                                int                     id,
                                uint32_t                flags,
                                am_sensor_trigger_cb_t  pfn_cb,
                                void                   *p_arg);

    /** \brief 򿪴 */
    am_err_t (*pfn_trigger_on)(void *p_drv, int id);

    /** \brief رմ */
    am_err_t (*pfn_trigger_off)(void *p_drv, int id);

};

/**
 * \brief sensor
 */
typedef struct am_sensor_serv {

    /** \brief sensorṹָ    */
    const struct am_sensor_drv_funcs *p_funcs;

    /** \brief ĵһ  */
    void                             *p_drv;
    
} am_sensor_serv_t;

/** \brief sensor׼Ͷ  */
typedef am_sensor_serv_t *am_sensor_handle_t;

/**
 * \brief ȡĳһͨͣ磺¶ȡʪȡѹǿ
 *
 * һṩ·ݲɼͨÿͨͿܲͬ磺¶ȡ
 * ʪȡѹǿ֣֮ʹøýӿڿԿٻȡôĳһͨ(ÿ
 * ID0ʼα)
 *
 * \param[in] handle : ׼
 * \param[in] id     : ͨ id
 *
 * \retval  >=0       ͣAM_SENSOR_TYPE_*(eg: #AM_SENSOR_TYPE_VOLTAGE)
 * \retval -AM_ENODEV ͨ
 * \retval -AM_EINVAL Ч
 */
am_static_inline
am_err_t am_sensor_type_get (am_sensor_handle_t handle, int id)
{
    return handle->p_funcs->pfn_type_get(handle->p_drv, id);
}

/**
 * \brief Ӵָͨȡ
 *
 * \param[in]  handle   ׼
 * \param[in]  p_ids    ͨ idб
 * \param[in]  num      ͨĿ
 * \param[out] p_buf     num һ
 *
 * \retval  AM_OK     ɹһͨݶȡɹ
 * \retval -AM_ENODEV ֻͨ
 * \retval -AM_EINVAL Ч
 * \retval -AM_EPERM  
 * \retval   <0       ֻͨȡʧ
 *
 * \note p_idsбܰͨp_bufлȡݻᰴմͨIDһһӦ
 * ڶӦĻСúֵ<0ʾֻͨݶȡʧܣ
 * øAM_SENSOR_VAL_IS_VALID жÿͨݣΪ棬ʾֵͨ
 * ЧΪ٣ʾͨݻȡʧܡ
 *
 * \attention ĳһͨ׼ģʽֻڸͨĴص
 * øúȡֵͨмǲҪڸͨĻصȡͨĲ
 * 
 */
am_static_inline
am_err_t am_sensor_data_get (am_sensor_handle_t  handle,
                             const int          *p_ids,
                             int                 num,
                             am_sensor_val_t    *p_buf)
{
    return handle->p_funcs->pfn_data_get(handle->p_drv, p_ids, num, p_buf);
}

/**
 * \brief ʹܴһͨ
 *
 * ʹܺ󣬴ͨʼɼⲿźš˴ĲƵ
 * ֵ#AM_SENSOR_ATTR_SAMPLING_RATEֵΪ0ϵͳԶֵָ
 * ĲƵʻȡеĲֵû׼ÿݲ
 * 󣬶ûصرأƵΪ0ĬϣԶ
 * ÿεam_sensor_data_get()ʱŴӴлȡݡ
 *
 * \param[in]  handle   ׼
 * \param[in]  p_ids    ͨ idб
 * \param[in]  num      ͨĿ
 * \param[out] p_result ÿͨʹܵĽvalֵУ׼뺬һ
 *
 * \retval  AW_OK     ͨʹܳɹ
 * \retval -AM_ENODEV ֻͨ
 * \retval -AM_EINVAL Ч
 * \retval   <0       ֻͨʹʧܣÿһͨʹܵĽ val ֵ
 *
 * \attention p_result ָĻڴ洢ÿͨʹܵĽǱʾ״̬
 * ЧĴݣúֵ<0ͨ valֵж϶Ӧͨʹ
 * ɣvalֵĺ׼ĶӦϵһ¡رأ p_result Ϊ 
 * NULLÿͨʹܵĽ
 */
am_static_inline
am_err_t am_sensor_enable (am_sensor_handle_t  handle,
                           const int          *p_ids,
                           int                 num,
                           am_sensor_val_t    *p_result)
{
    return handle->p_funcs->pfn_enable(handle->p_drv, p_ids, num, p_result);
}

/**
 * \brief ܴһͨ
 *
 * ܺ󣬴رգֹͣɼⲿźţͬʱϵͳҲٴӴл
 * ȡֵ۲ƵǷΪ0
 *
 * \param[in]  handle   ׼
 * \param[in]  p_ids    ͨ idб
 * \param[in]  num      ͨĿ
 * \param[out] p_result ÿͨܵĽvalֵУ׼뺬һ
 *
 * \retval  AM_OK     ͨܳɹ
 * \retval -AM_ENODEV ֻͨ
 * \retval -AM_EINVAL Ч
 * \retval   < 0      ׼룬ֻͨʧ
 *
 * \attention p_result ָĻڴ洢ÿͨܵĽǱʾ״̬
 * ЧĴݣúֵ<0ͨ valֵж϶ӦͨĽ
 * ɣvalֵĺ׼ĶӦϵһ¡رأ p_result Ϊ
 *  NULLÿͨܵĽ
 */
am_static_inline
am_err_t am_sensor_disable (am_sensor_handle_t  handle,
                            const int          *p_ids,
                            int                 num,
                            am_sensor_val_t    *p_result)
{
    return handle->p_funcs->pfn_disable(handle->p_drv, p_ids, num, p_result);
}

/**
 * \brief ôͨ
 *
 * \param[in] handle : ׼
 * \param[in] id     : ͨ id
 * \param[in] attr   : ԣAM_SENSOR_ATTR_*(eg:#AM_SENSOR_ATTR_SAMPLING_RATE)
 * \param[in] p_val  : ֵ
 *
 * \retval   AM_OK       ɹ
 * \retval  -AM_EINVAL   Ч
 * \retval  -AM_ENOTSUP  ֧
 * \retval  -AM_ENODEV   ͨ
 *
 * \note ֵ֧崫أִ֧ܲκԡ
 */
am_static_inline
am_err_t am_sensor_attr_set (am_sensor_handle_t     handle,
                             int                    id,
                             int                    attr,
                             const am_sensor_val_t *p_val)
{
    return handle->p_funcs->pfn_attr_set(handle->p_drv, id, attr, p_val);
}

/**
 * \brief ȡͨ
 *
 * \param[in]  handle : ׼
 * \param[in]  id     : ͨ id
 * \param[in]  attr   : ԣAM_SENSOR_ATTR_*(eg:#AM_SENSOR_ATTR_SAMPLING_RATE)
 * \param[out] p_val  : ڻȡֵĻ
 *
 * \retval   AM_OK       ɹ
 * \retval  -AM_EINVAL   Ч
 * \retval  -AM_ENOTSUP  ֧
 * \retval  -AM_ENODEV   ͨ
 *
 * \note ֵ֧崫أִ֧ܲκԡ
 */
am_static_inline
am_err_t am_sensor_attr_get (am_sensor_handle_t handle,
                             int                id,
                             int                attr,
                             am_sensor_val_t   *p_val)
{
    return handle->p_funcs->pfn_attr_get(handle->p_drv, id, attr, p_val);
}

/**
 * \brief ôһͨһص
 *
 * \param[in] handle : ׼
 * \param[in] id     : ͨ id
 * \param[in] flags  : ָͣAM_SENSOR_TRIGGER_DATA_READY
 *                     (ҶͿ)
 * \param[in] pfn_cb : ʱִеĻصָ
 * \param[in] p_arg  : û
 *
 * \retval  AM_OK      ɹ
 * \retval -AM_EINVAL  Ч
 * \retval -AM_ENOTSUP ֵ֧Ĵģʽ
 * \retval -AM_ENODEV  ͨ
 *
 * \note ֵ֧Ĵģʽ崫أִ֧κδģʽģʽ
 * ʱҪͨI2CSPIͨŽӿ봫ͨţȽϺʱúжϻ
 * ʹá
 */
am_static_inline
am_err_t am_sensor_trigger_cfg (am_sensor_handle_t      handle,
                                int                     id,
                                uint32_t                flags,
                                am_sensor_trigger_cb_t  pfn_cb,
                                void                   *p_arg)
{
    return handle->p_funcs->pfn_trigger_cfg(handle->p_drv,
                                            id,
                                            flags,
                                            pfn_cb,
                                            p_arg);
}

/**
 * \brief 򿪴(򿪸ͨ am_sensor_trigger_cfg ùд)
 *
 * \param[in] handle : ׼
 * \param[in] id     : ͨ id
 *
 * \retval  AM_OK     򿪳ɹ
 * \retval -AM_EINVAL Ч
 * \retval -AM_ENODEV ͨ
 * \retval   < 0      ʧ
 */
am_static_inline
am_err_t am_sensor_trigger_on (am_sensor_handle_t handle,
                               int                id)
{
    return handle->p_funcs->pfn_trigger_on(handle->p_drv, id);
}

/**
 * \brief رմ(رոͨдģʽ)
 *
 * \param[in] handle : ׼
 * \param[in] id     : ͨ id
 *
 * \retval  AM_OK     رճɹ
 * \retval -AM_EINVAL Ч
 * \retval -AM_ENODEV ͨ
 * \retval   < 0      ʧ
 */
am_static_inline
am_err_t am_sensor_trigger_off (am_sensor_handle_t handle,
                                int                id)
{
    return handle->p_funcs->pfn_trigger_off(handle->p_drv, id);
}

/**
 * \brief ȡһλӦǰ׺ţ"M"ף"k"ǧ
 *
 * \param[in] unit : λAM_SENSOR_UNIT_* (eg: #AM_SENSOR_UNIT_MILLI)
 *
 * \return ַλЧ򷵻NULLunitΪ0(#AM_SENSOR_UNIT_BASE)
 * 򷵻ؿַ: ""رע⣬صһַһַΪ
 * ֵλķſĸ磺"da"ʮ
 */
const char *am_sensor_unit_symbol_get (int32_t unit);

/**
 * \brief ڴݵλת
 *
 * \param[in] p_buf   : ݻ
 * \param[in] num     : ݸ
 * \param[in] to_unit : Ŀ굥λAM_SENSOR_UNIT_* (eg: #AM_SENSOR_UNIT_MILLI)
 *
 * \retval AM_OK      תɹ
 * \retval -AM_EINVAL תʧܣ
 * \retval -AM_ERANGE ĳһתʧܣתᳬΧСλʱ
 *                    ֣,תʧܵݽԭֵԭλ䣬ûͨ
 *                    λǷΪĿ굥λжǷתɹ
 *
 * \note λתԭ
 *
 * - λunitֵٶunitӵֵΪnὫvalֵ10^n
 * ڴʹԭvalֵľȼСȼСʱѭ뷨磺
 * ԭΪ1860mVλתΪVתĽΪ2VԭΪ1245mVλ
 * תΪVתĽΪ1VڴھȵʧλӦýʹá
 *
 * - СλСunitֵٶunitСֵΪnὫvalֵ10^n
 * Ӧرע⣬valֵΪ32λзʾݷΧΪ-2147483648 ~
 * 2147483647Ӧʹvalֵ10^nݳ÷ΧСλھȵʧ
 * ӦעݵӦһС̫Сĵλ
 *
 * - رأתǰĵλûз仯ֲֵ䡣
 */
am_err_t am_sensor_val_unit_convert (am_sensor_val_t *p_buf,
                                     int              num,
                                     int32_t          to_unit);

/** @} grp_am_if_sensor */

 #ifdef __cplusplus
 }
 #endif

 #endif /* __AM_SENSOR_H */

 /* end of file */
