/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief  ʱ׼ӿ
 *
 * ʱʹһӲʱԴṩʱ
 * 
 * \internal
 * \par Modification history
 * - 1.00 15-07-31  tee,  first implementation.
 * \endinternal
 */

#ifndef __AM_SOFTIMER_H
#define __AM_SOFTIMER_H

#ifdef __cplusplus
extern "C" {
#endif
    
#include "am_common.h"
#include "am_list.h"
#include "am_timer.h"


/**
 * \addtogroup am_if_softimer
 * \copydoc am_softimer.h
 * @{
 */

/**
 * \brief ʱṹ壬˱ҪϢ
 */
struct am_softimer {
    struct am_list_head node;          /**< \brief γṹ           */
    unsigned int        ticks;         /**< \brief ʣʱtickֵ             */
    unsigned int        repeat_ticks;  /**< \brief ظʱtick     */
    void (*timeout_callback)( void *); /**< \brief ʱʱ䵽ص         */
    void               *p_arg;         /**< \brief صĲ             */
};

typedef struct am_softimer am_softimer_t;

/**
 * \brief ʱģʼ
 *
 * \param[in] clkrate : Ƶʣ밴ոƵʵ  am_softimer_module_tick()
 *
 * \retval AM_OK     : ģʼɹʹ
 * \retval -AM_EINVAL: Ч
 */
int am_softimer_module_init (unsigned int clkrate);

/**
 * \brief ʱ밴ճʼʱģʱָƵʵøú
 */
void am_softimer_module_tick (void);
    
/**
 * \brief ʼһʱ
 *
 * \param[in] p_timer  : ָһʱָ
 * \param[in] p_func   : ʱʱ䵽Ļص
 * \param[in] p_arg    : ص
 *
 * \retval AM_OK      : ʱʼɹ
 * \retval -AM_EINVAL : Ч
 * \retval -AM_EPERM  : ʱģ黹δʼУȷģȷʼ
 */
int am_softimer_init(am_softimer_t *p_timer, am_pfnvoid_t p_func, void *p_arg);


/**
 * \brief һʱ
 * \param[in] p_timer : ָһʱָ
 * \param[in] ms      : ʱʱ(ms)
 * \return 
 */
void am_softimer_start(am_softimer_t *p_timer, unsigned int ms);

/**
 * \brief ֹͣһʱ
 * \param[in] p_timer : ָһʱָ
 * \return 
 */
void am_softimer_stop(am_softimer_t *p_timer);

/** 
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_SOFTIMER_H */

/* end of file */
