/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief spiӻ׼ӿ
 *
 * \note ͨ˽ӿڶһspiӻ豸
 *
 * \internal
 * \par Modification History
 * -1.00 17-09-14 fra, first implementation
 * \endinternal
 */

#ifndef __AM_SPI_SLV_H
#define __AM_SPI_SLV_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"
#include "am_list.h"

/**
 * \addtogroup am_if_spi_slv
 * \copydoc am_spi_slv.h
 * @{
 */

/**
 * \name SPI豸ģʽ־am_spi_slv_mkdev()mode
 * @{
 */

#define AM_SPI_SLV_CPHA        0x01  /**< \brief ʱλ             */
#define AM_SPI_SLV_CPOL        0x02  /**< \brief ʱӼԿ             */
#define AM_SPI_SLV_CS_HIGH     0x04  /**< \brief ƬѡЧ                 */
#define AM_SPI_SLV_LSB_FIRST   0x08  /**< \brief λȳķʽ֡ */
#define AM_SPI_SLV_3WIRE       0x10  /**< \brief 3ģʽSI/SO ź߹  */
#define AM_SPI_SLV_LOOP        0x20  /**< \brief ػģʽ                   */
#define AM_SPI_SLV_NO_CS       0x40  /**< \brief 豸, Ƭѡ         */

#define AM_SPI_SLV_MODE_0      (0 | 0)                 /**< \brief SPIӻģʽ0 */
#define AM_SPI_SLV_MODE_1      (0 | AM_SPI_SLV_CPHA) /**< \brief SPIӻģʽ1 */
#define AM_SPI_SLV_MODE_2      (AM_SPI_SLV_CPOL | 0) /**< \brief SPIӻģʽ2 */
#define AM_SPI_SLV_MODE_3      (AM_SPI_SLV_CPOL | AM_SPI_SLV_CPHA) /**< \brief SPIӻģʽ3 */

/** @} */

struct am_spi_slv_device;        /**< \brief SPI豸Ľṹ */

/**
 * \brief SPI豸ṹ
 */
struct am_spi_slv_drv_funcs {

    /** \brief 豸  */
    int (*pfn_spi_slv_setup) (void *p_drv, struct am_spi_slv_device *p_dev);

    /** \brief رSPI豸   */
    int (*pfn_spi_slv_shutdown) (void *p_drv, struct am_spi_slv_device *p_dev);

};

/**
 * \brief SPI豸 ׼ṹ
 */
typedef struct am_spi_slv_serv {
    struct am_spi_slv_drv_funcs   *p_funcs;    /**< \brief SPI豸     */
    void                          *p_drv;      /**< \brief SPI豸 */
} am_spi_slv_serv_t;


/** \brief SPI豸 ׼ */
typedef am_spi_slv_serv_t *am_spi_slv_handle_t;


/**
 * \brief SPI ӻ
 *
 * - SPI ӻдĸǵڶĸЭӦṩ \a rx_buf /
 * \a tx_buf ĳЩ£ͬṩݴDMAַĻ
 * ʹDMAԽݴĴۡ
 *
 * 仺 tx_bufΪ NULL rx_bufΪNULL ʾӻ 0͵ϣܵĴ浽rx_buf
 * 仺 tx_bufΪ NULL rx_bufΪNULL ʾӻ ܵ ֻķ
 *
 * - ڴУǰCPUĵıֽ˳ţֽ˳ (ˣ
 * 豸ģʽ־б AM_SPI_LSB_FIRST)磬\a bits_per_word Ϊ
 * 16Ϊ 2N ֽڳ (\a len = 2N) CPUֽ˳㱣N16-bit֡
 *
 * -  SPI ִС2ݴα8-bitʱЩڴеֽbit
 * ڴУҶģˣδ (rx) δʹ (tx) λЧλ
 *
 */
typedef struct am_spi_slv_tansfer {
    /** \brief ָͻָ */
    const void *p_tx_buf;

    /** \brief ָջָ */
    void *p_rx_buf;

    /** \brief ݳ(ֽ) */
    size_t  nbytes;

    /** \brief ִСΪ0ʹ am_spi_device_t õֵ */
    uint8_t     bits_per_word;

}am_spi_slv_transfer_t;

/**
 * \brief SPI豸ص
 */
typedef struct am_spi_slv_cb_funs{

    /** \brief ƬѡCSЧص */
    int (*pfn_cs_active)(void *p_arg);

    /** \brief ƬѡCSЧص  (nbytesΪƬѡЧдֽ )*/
    int (*pfn_cs_inactive)(void *p_arg, size_t nbytes);

    /** \brief ȡ Ϣ  */
    int (*pfn_tansfer_get)(void *p_arg, am_spi_slv_transfer_t *p_trans);

} am_spi_slv_cb_funs_t;


/** \brief SPI豸ṹ */
typedef struct am_spi_slv_device {

     /** \brief 豸SPI׼handle */
     am_spi_slv_handle_t  handle;

     /** \brief  ݴ1֣ȽϳִСΪ8-bit12-bitڴ
      *   УִСӦ2ݴη磬20-bitԴСӦʹ32-bitڴ
      *   Ϊ0ʱĬѡΪ8bit
      */
     uint8_t                bits_per_word;

     /** \brief 豸SPIģʽ־οSPIӻģʽ־
      *
      * òSPI豸ʱλͼԣҪͬ
      */
     uint16_t               mode;

     /** \brief 豸ص */
     am_spi_slv_cb_funs_t *p_slv_cb_funcs;

     /** \brief ص */
     void                   *p_arg;

} am_spi_slv_device_t;

/**
 * \brief SPI豸ṹ
 *
 * \param[in] p_dev         : SPIӻ豸ָ
 * \param[in] handle        : SPI׼
 * \param[in] bits_per_word : ִСΪ0ʱʹĬϵġ8-bitִС
 * \param[in] mode          : 豸ģʽ־SPIģʽ־
 * \param[in] p_slv_cb_funcs : SPI豸ص
 * \param[in] p_arg         : SPI豸صĲ
 *
 * \return 
 *
 * \par 
 *  am_spi_slv_setup()
 */
am_static_inline
void am_spi_slv_mkdev (am_spi_slv_device_t  *p_dev,
                       am_spi_slv_handle_t   handle,
                       uint8_t               bits_per_word,
                       uint16_t              mode,
                       am_spi_slv_cb_funs_t *p_slv_cb_funcs,
                       void                 *p_arg)
{
    p_dev->handle             = handle;
    p_dev->bits_per_word      = bits_per_word;
    p_dev->mode               = mode;
    p_dev->p_slv_cb_funcs     = p_slv_cb_funcs;
    p_dev->p_arg              = p_arg;

}


/**
 * \brief SPIӻ豸
 *
 * \attention SPIӻ豸ʹǰȵñã籾
 *            һʹôSPIӻ
 *
 * \param[in] p_dev : SPIӻ豸
 *
 * \retval   AM_OK           : óɹ
 * \retval  -AM_ENOTSUP      : ʧܣֵ֧λģʽ
 *
 * \par ʾ
 * \code
 *  am_spi_slv_device_t spi_slv_dev;     // 豸ṹ
 *
 * // ʼ豸ṹ
 * am_spi_slv_mkdev(&spi_slv_dev,
 *                    handle,         // SPIӻ׼handle
 *                    8                                 // ִСΪ8-bit
 *                    AM_SPI_MODE_1,  // SPI ģʽ1
 *                    __g_spi_slv_cb_funs,   // ӻصΪ__g_spi_slv_cb_funs
 *                    &spi_slv_dev);          // ӻصڲ
 *
 * // 豸
 * am_spi_slv_setup(&spi_slv_dev);
 *
 * \endcode
 *
 */
am_static_inline
int am_spi_slv_setup (am_spi_slv_device_t *p_dev)
{
    return p_dev->handle->p_funcs->pfn_spi_slv_setup(p_dev->handle->p_drv, p_dev);
}



/**
 * \brief رSPIӻ
 *
 * \param[in]  handle : SPI׼
 * \param[out] p_dev  : SPIӻ豸
 *
 * \retval  AM_OK     : óɹ
 */
am_static_inline
int am_spi_slv_shutdown (am_spi_slv_device_t *p_dev)
{
    return p_dev->handle->p_funcs->pfn_spi_slv_shutdown(p_dev->handle->p_drv, p_dev);
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_SPI_SLV_H */

/* end of file */
