/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ϵͳط
 *
 * ֻҪ ametal.h Ϳʹñ
 *
 * \par ʾ:ִʱ
 * \code
 *  #include "ametal.h"
 *
 *  int main(){
 *      unsigned int tick;
 *
 *      tick = am_sys_tick_get();
 *      //  do something
 *      tick = am_sys_tick_get() - tick;
 *      am_kprintf("tick used=%d\n , time=%d ms",
 *                  tick,
 *                  am_ticks_to_ms(tick));
 *      return 0;
 *  }
 * \endcode
 *
 * //ݴӡ
 *
 * \internal
 * \par modification history:
 * - 1.00 13-02-27  zen, first implementation
 * \endinternal
 */

#ifndef __AM_SYSTEM_H
#define __AM_SYSTEM_H

#include "am_types.h"

#ifdef __cplusplus
extern "C" {
#endif	/* __cplusplus	*/

/**
 * \addtogroup am_if_system
 * \copydoc am_system.h
 * @{
 */

/**
 * \brief ϵͳģʼһϵͳʱã
 * \param[in] clkrate : Ƶʣ밴ոƵʵ  am_system_module_tick()
 * \retval AM_OK     : ģʼɹʹ
 */
int am_system_module_init (unsigned long clkrate);

/**
 * \brief һĳһʱжԵĵøú
 */
int am_system_module_tick (void);

/**
 * \brief ȡϵͳʱӽƵ
 *
 * \return ϵͳʱӽƵ, Ϊ unsigned long
 */
unsigned long am_sys_clkrate_get (void);

/**
 * \brief ȡϵͳǰĽļֵ,
 *
 * ϵͳ󣬽ļֵ0ʼÿ1tick1 ϵͳĵƵʿɵ
 * am_sys_clkrate_get() ȡ
 *
 * \return ϵͳǰĽļֵ, Ϊ unsigned int
 *
 * \par ʾ:ִʱ
 * \code
 *  #include "ametal.h"
 *
 *  int main(){
 *      unsigned int tick;
 *
 *      tick = am_sys_tick_get();
 *      //  do something
 *      tick = am_sys_tick_get() - tick;
 *      am_kprintf("tick used=%d\n , time=%d ms",
 *                  tick,
 *                  am_ticks_to_ms(tick));
 *      return 0;
 *  }
 * \endcode
 *
 * // ݴӡ
 */
am_tick_t am_sys_tick_get (void);

/**
 * \brief ʱtickĲֵ
 *
 *  ҪǷת: ıʾԶⷴת⣬0xfffffffʾ޷ŵֵ(32bit)
 *  Ҳʾз-1.
 * \return ϵͳǰʱֵ(ʱʱļֵ)
 */
static am_inline am_tick_t am_sys_tick_diff(am_tick_t __t0, am_tick_t __t1)
{
    return __t1 - __t0;
}

/**
 * \brief תʱΪϵͳʱӽĸ
 * \param ms ʱ
 * \return ʱӦĽĸ
 * \note һĵĽһġһΪ5룬1~5붼
 *      תΪ1ġ
 * \par ʾ
 * \code
 * #include "apollo.h"
 *
 * am_task_delay(am_ms_to_ticks(500));    // ʱ500ms
 * \endcode
 */
am_tick_t am_ms_to_ticks (unsigned int ms);

/**
 * \brief תϵͳʱӽĸΪʱ
 * \param ticks ĸ
 * \return  ϵͳʱӽӦĺʱ
 *
 * \par ʾ:ִʱ
 * \code
 *  #include "apollo.h"
 *
 *  int main(){
 *      unsigned int tick;
 *
 *      tick = am_sys_tick_get();
 *      //  do something
 *      tick = am_sys_tick_get() - tick;
 *      am_kprintf("tick used=%d\n , time=%d ms",
 *                  tick,
 *                  am_ticks_to_ms(tick));
 *      return 0;
 *  }
 * \endcode
 */
unsigned int am_ticks_to_ms (am_tick_t ticks);

 
/**
 * \brief ȡǰID
 *
 * \return ID
 */
uint32_t am_core_id_self(void);

/**
 * \brief ȡصַӦȫֵַ (ַ, DMAʹô˵ַ)
 *
 * \return ȫֵַ
 */
void *am_global_addr_get(void *p_addr);

/** @} am_if_system */

#ifdef __cplusplus
}
#endif  /* __cplusplus  */

#endif    /* __AM_SYSTEM_H    */

/* end of file */
