/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱ׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.01 15-12-07  hgo, del am_timer_connect().
 * - 1.00 15-01-05  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_TIMER_H
#define __AM_TIMER_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"

/**
 * \addtogroup am_if_timer
 * \copydoc am_timer.h
 * @{
 */

/**
 * \name ʱ
 *  
 *  - 8λʱλ32λʱ8λֵΪ32
 *  - 8 ~ 15 λʾʱͨ
 *  - ʱԽռһλӵ16λʼ AM_TIMER_FEATURE(0) ~ AM_TIMER_FEATURE(15)
 * @{
 */
 
/** \brief ʱԶ         */
#define AM_TIMER_FEATURE(feature_id)           ((uint32_t)(1u << (feature_id)))

/** \brief ʱԲж             */
#define AM_TIMER_CAN_INTERRUPT                  AM_TIMER_FEATURE(0)

/** \brief ʱԶȡǰֵ   */
#define AM_TIMER_INTERMEDIATE_COUNT             AM_TIMER_FEATURE(1)

/** \brief ʱֹܱͣ               */
#define AM_TIMER_CANNOT_DISABLE                 AM_TIMER_FEATURE(2)

/** \brief ʱڶȡֵʱֹͣ     */
#define AM_TIMER_STOP_WHILE_READ                AM_TIMER_FEATURE(3)

/** \brief ʱ֧Զװؼֵ     */
#define AM_TIMER_AUTO_RELOAD                    AM_TIMER_FEATURE(4)

/** \brief ʱУܸı䷭תֵ */
#define AM_TIMER_CANNOT_MODIFY_ROLLOVER         AM_TIMER_FEATURE(5)
 
/** 
 * \brief ʱԤƵֵ֧1ֵֵ֮
 * 
 * - ʱָ֧ԣʱϢе prescaler (am_timer_info_t)ʾֵ֧
 *   ԤƵֵ磬prescalerֵΪ 256ʾ֧ 1 ~ 256 ԤƵֵ
 *
 * - ʱָ֧ԣʱϢе prescaler ʾ֧ЩԤƵֵ
 *   NλNķΧ 0 ~ 31Ϊ 1ʾ֧ԤƵֵ2  Nη磬
 *   prescalerֵΪ0xFbit0123ֵΪ1ֵ֧ķƵֵУ1(2^0)2(2^1)
 *   4(2^2)8(2^3)
 *
 * - رأ prescaler ֵΪ0ʾʱ֧ԤƵӦ prescaler
 *   Ϊ 0x01
 */
#define AM_TIMER_SUPPORT_ALL_PRESCALE_1_TO_MAX  AM_TIMER_FEATURE(6)

/** @} */ 


/** 
 * \brief ʱϢṹ
 */
typedef struct am_timer_info {

    uint8_t   counter_width;               /**< \brief ʱλ             */
    uint8_t   chan_num;                    /**< \brief ʱͨ           */
    uint16_t  features;                    /**< \brief ʱ             */
 
    /** 
     * \brief ԤƵϢ
     *
     * ֵʾԤƵֵ֧ԤƵֵֵĺ붨ʱԤƵأ
     * ԵĽ #AM_TIMER_SUPPORT_ALL_PRESCALE_1_TO_MAX
     */
    uint32_t   prescaler; 
    
} am_timer_info_t;


/**
 * \brief ʱṹ
 */
struct am_timer_drv_funcs {

    /**
     * \brief ȡʱϢ
     *
     * ϢǶʱĹԣڲɶ壬úԷָó
     * Ϣָ룬Աûʹá
     */
    const am_timer_info_t * (*pfn_info_get) (void *p_drv);
    
    /**
     * \brief ȡʱʱƵʣжʱͨһƵʣ
     *
     * ʱƵʱáӲأƵʲǶʱļʱƵʣʱ
     * ʵʼʱƵʿͨһԤƵƵƵʡ
     */
    int (*pfn_clkin_freq_get) (void *p_drv, uint32_t *p_freq);
    
    /**
     * \brief öʱԤƵֵ
     *
     * ʱ֧ԤƵ úΪ NULL
     */
    int (*pfn_prescale_set) (void *p_drv, uint8_t chan, uint32_t prescale);

    /**
     * \brief ȡʱǰʹõԤƵֵ
     *
     * ʹƵʳԸԤƵֵɵõʱļƵ
     */
    int (*pfn_prescale_get) (void *p_drv, uint8_t chan, uint32_t *p_prescale);

    /**
     * \brief ȡǰʱֵ
     *
     * ʱλ32λ  p_count Ϊ  uint32_t* 
     * ʱλ32λ  p_count Ϊ  uint64_t* 
     */
    int (*pfn_count_get) (void *p_drv, uint8_t chan, void *p_count);

    /** 
     * \brief ȡʱתֵ
     * 
     * ʱλ32λ  p_count Ϊ  uint32_t* 
     * ʱλ32λ  p_count Ϊ  uint64_t* 
     */
    int (*pfn_rollover_get) (void *p_drv, uint8_t chan, void *p_rollover);
 
    /** 
     * \brief ʹܶʱͬʱ趨ʱcountֵ
     *
     * ʱλ32λ  p_count Ϊ  uint32_t* 
     * ʱλ32λ  p_count Ϊ  uint64_t* 
     *
     * 0ʼﵽֵʱû趨ĻصصЧ
     * ͬʱֵص0¿ʼ
     */
    int (*pfn_enable) (void *p_drv, uint8_t chan, void *p_count);

    /** \brief ܶʱ                         */
    int (*pfn_disable) (void *p_drv, uint8_t chan);

    /** \brief ûصÿһʱʱ */
    int (*pfn_callback_set)(void    *p_drv,
                            uint8_t  chan,
                            void   (*pfn_callback)(void *),
                            void    *p_arg);
};

/** 
 * \brief ʱ
 */
typedef struct am_timer_serv {

    /** \brief ʱṹָ */
    struct am_timer_drv_funcs *p_funcs; 
    
    /** \brief ĵһ */
    void                      *p_drv;   
} am_timer_serv_t;

/** \brief ʱ׼Ͷ */
typedef am_timer_serv_t *am_timer_handle_t;

/** 
 * \brief ȡʱϢ
 * \param[in]  handle : ʱ׼
 * \return ָʱϢָ룬ΪNULLʾϢȡʧ
 */
am_static_inline
const am_timer_info_t * am_timer_info_get (am_timer_handle_t handle)
{
    return handle->p_funcs->pfn_info_get(handle->p_drv);
}

/**
 * \brief ȡǰʱʱƵʣжʱͨһƵʣ
 *
 * ʱƵʲǶʱļƵʣʵʶʱƵɸƵʷƵĽ
 * ֵ֧ķƵֵԣ#AM_TIMER_SUPPORT_ALL_PRESCALE_1_TO_MAX Ƶ
 * ֵͨ  am_timer_prescale_set() ӿá
 *
 * \param[in]  handle : ʱ׼
 * \param[out] p_freq : ȡʱƵʵָ
 *
 * \return 
 */
am_static_inline
int am_timer_clkin_freq_get (am_timer_handle_t handle, uint32_t *p_freq)
{
    return handle->p_funcs->pfn_clkin_freq_get(handle->p_drv, p_freq);
}

/** 
 * \brief öʱԤƵֵ
 *
 * \param[in] handle   : ʱ׼
 * \param[in] chan     : ʱͨ
 * \param[in] prescale : ԤƵֵ
 *
 * \retval  AM_OK      : óɹ
 * \retval -AM_EINVAL  : ʧ, 
 * \retval -AM_ENOTSUP : ʧܣֵ֧ԤƵֵֵ֧ԤƵֵʱϢ
 */
am_static_inline
int am_timer_prescale_set (am_timer_handle_t handle, 
                           uint8_t           chan, 
                           uint32_t          prescale)
{
    return handle->p_funcs->pfn_prescale_set(handle->p_drv, chan, prescale); 
}

/** 
 * \brief öʱԤƵֵ
 *
 * \param[in] handle   : ʱ׼
 * \param[in] chan     : ʱͨ
 * \param[in] prescale : ԤƵֵ
 *
 * \retval  AM_OK      : óɹ
 * \retval -AM_EINVAL  : ʧ, 
 * \retval -AM_ENOTSUP : ʧܣֵ֧ԤƵֵֵ֧ԤƵֵʱϢ
 */
am_static_inline
int am_timer_prescale_get (am_timer_handle_t   handle,
                           uint8_t             chan,
                           uint32_t           *p_prescale)
{
    return handle->p_funcs->pfn_prescale_get(handle->p_drv, chan, p_prescale);
}

/**
 * \brief ȡʱǰļƵ
 *
 * \param[in]  handle  : ʱ׼
 * \param[in]  chan    : ʱͨ
 * \param[out] p_freq  : ڻȡʱǰƵʵָ
 *
 * \retval  AM_OK      : ȡʱǰֵɹ
 * \retval -AM_EINVAL  : ȡʧ, 
 */
int am_timer_count_freq_get (am_timer_handle_t handle,
                             uint8_t           chan,
                             uint32_t         *p_freq);

/** 
 * \brief ȡʱǰļֵ
 * 
 * صļֵӦǼ趨ʱϼģʽµĵǰֵ
 *
 * \param[in]  handle  : ʱ׼
 * \param[in]  chan    : ʱͨ
 * \param[out] p_count : ڻȡʱǰֵָ
 *
 * \retval  AM_OK      : ȡʱǰֵɹ
 * \retval -AM_EINVAL  : ȡʧ, 
 */
am_static_inline
int am_timer_count_get (am_timer_handle_t handle, 
                        uint8_t           chan, 
                        uint32_t         *p_count)
{
    return handle->p_funcs->pfn_count_get(handle->p_drv, chan, (void*)p_count);
}

/** 
 * \brief ȡʱתֵ
 *
 * \param[in]  handle     : ʱ׼
 * \param[in]  chan       : ʱͨ
 * \param[out] p_rollover : ڻȡʱתֵָ
 *
 * \retval  AM_OK         : ȡʱתֵɹ
 * \retval -AM_EINVAL     : ȡʧ, 
 */
am_static_inline
int am_timer_rollover_get (am_timer_handle_t  handle, 
                           uint8_t            chan, 
                           uint32_t          *p_rollover)
{
    return handle->p_funcs->pfn_rollover_get(handle->p_drv,
                                             chan,
                                            (void *)p_rollover);
}

/** 
 * \brief ܶʱֹͣʱ
 *
 * \param[in] handle  : ʱ׼
 * \param[in] chan    : ʱͨ
 *
 * \retval  AM_OK     : ܶʱɹ
 * \retval -AM_EINVAL : ʧ, 
 */
am_static_inline
int am_timer_disable (am_timer_handle_t handle, uint8_t chan)
{
    return handle->p_funcs->pfn_disable(handle->p_drv, chan);
}

/** 
 * \brief ʹܶʱͬʱ趨ʱcountֵ 
 *
 * \param[in] handle : ʱ׼
 * \param[in] chan   : ʱͨ
 * \param[in] count  : ʱcountֵ 
 *
 * \retval  AM_OK     : ʹܳɹ
 * \retval -AM_EINVAL : ʧ, 
 *
 * \note ʱֵﵽ趨Ķʱcountֵʱжϡͬʱλֵ
 *       Ϊ0żʱ
 */
am_static_inline
int am_timer_enable (am_timer_handle_t handle, uint8_t chan, uint32_t count)
{
     return handle->p_funcs->pfn_enable(handle->p_drv, chan, (void *)(&count));
}

/** 
 * \brief ûصÿһʱʱ
 *
 * \param[in] handle       : ʱ׼
 * \param[in] chan         : ʱͨ
 * \param[in] pfn_callback : ص
 * \param[in] p_arg        : صû
 *
 * \retval  AM_OK     : óɹ
 * \retval -AM_EINVAL : ʧ, 
 *
 */
am_static_inline
int am_timer_callback_set (am_timer_handle_t  handle, 
                           uint8_t            chan,
                           void             (*pfn_callback)(void *),
                           void              *p_arg)
{
    return handle->p_funcs->pfn_callback_set(handle->p_drv,
                                             chan,
                                             pfn_callback,
                                             p_arg);
}

/** 
 * \brief ȡ33 ~ 64λʱĵǰֵ
 *
 * صļֵӦǼ趨ʱϼģʽµĵǰֵ
 *
 * \param[in]  handle  : ʱ׼
 * \param[in]  chan    : ʱͨ
 * \param[out] p_count : ڻȡʱǰֵָ
 *
 * \retval  AM_OK      : ȡĵǰʱֵ
 * \retval -AM_EINVAL  : ȡʧ, 
 *
 * \note ʱλ3364֮䣬øúȡʱĵǰֵ
 */
am_static_inline
int am_timer_count_get64 (am_timer_handle_t  handle, 
                          uint8_t            chan,
                          uint64_t          *p_count)
{
    return handle->p_funcs->pfn_count_get(handle->p_drv, chan, (void *)p_count);
}

/** 
 * \brief ȡ33 ~ 64λʱķתֵ
 *
 * \param[in]  handle     : ʱ׼
 * \param[in]  chan       : ʱͨ
 * \param[out] p_rollover : ڻȡʱתֵָ
 *
 * \retval  AM_OK         : ȡתֵɹ
 * \retval -AM_EINVAL     : ȡתֵʧ, 
 *
 * \note ʱλ3364֮䣬øúȡתֵ
 */
am_static_inline
int am_timer_rollover_get64 (am_timer_handle_t  handle, 
                             uint8_t            chan,
                             uint64_t          *p_rollover)
{
    return handle->p_funcs->pfn_rollover_get(handle->p_drv,
                                             chan,
                                            (void *)p_rollover);
}

/** 
 * \brief ʹ3364λʱöʱcountֵ
 *
 * \param[in] handle : ʱ׼
 * \param[in] chan   : ʱͨ
 * \param[in] count  : ʱcountֵ
 *
 * \retval  AM_OK     : ʹܳɹ
 * \retval -AM_EINVAL : ʹʧ, 
 *
 * \note ʱλ3364֮䣬øúʹܶʱ
 */
am_static_inline
int am_timer_enable64 (am_timer_handle_t handle, uint8_t chan, uint64_t count)
{
    return handle->p_funcs->pfn_enable(handle->p_drv, chan, (void *)(&count));
}

/** 
 * \brief ʹܶʱֱ趨ʱʱ
 *
 * һ£ûҪʹһʱʱ䣬ҪƵʺͶʱλԤ
 * ƵֵͶʱ count ֵȻʹ am_timer_prescale_set() ԤƵֵʹ
 *  am_timer_enable()  am_timer_enable64() öʱcountֵʹܶʱ
 * 
 * ֶҪǶʱƵʡʱλʱԣֶʱ֧ܲ
 * ֻּ֧ԤƵֵΪڴˣûֱʹøúָʱ
 * ֵλusʹܶʱϵͳԶݶʱλʱԵúöʱ
 * 
 *
 * ʱʱܴƫʵʶʱʱ Ƶ  תֵ õתֵ
 * Ƶʵĵɡ
 *
 * ڶʱʱ䵽жϣˣ齫ʱõụ̀Ӧڼus
 * õ ms 
 *
 * \param[in] handle : ʱ׼
 * \param[in] chan   : ʱͨ
 * \param[in] nus    : õĶʱʱ䣨λus
 *
 * \retval  AM_OK     : ʹܳɹ
 * \retval -AM_EINVAL : ʧ, 
 * \retval -AM_NOTSUP ָ֧öʱʱ䣬ʱ̫ʱλ
 */
int am_timer_enable_us (am_timer_handle_t handle, uint8_t chan, uint32_t nus);

/**
 * @} 
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_TIMER_H */

/* end of file */
