/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief UART׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 14-11-01  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_UART_H
#define __AM_UART_H


#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"

/**
 * \addtogroup am_if_uart
 * \copydoc am_uart.h
 * @{
 */

/**
 * \name UARTģʽ
 * @{
 */

#define AM_UART_MODE_POLL         1    /**< \brief UART ѯģʽ */
#define AM_UART_MODE_INT          2    /**< \brief UART жģʽ */

/** @} */

/**
 * \name UARTͨÿָ
 * @{
 */

#define AM_UART_BAUD_SET          1   /**< \brief ò                  */
#define AM_UART_BAUD_GET          2   /**< \brief ȡ                  */

#define AM_UART_OPTS_SET          3   /**< \brief Ӳ            */
#define AM_UART_OPTS_GET          4   /**< \brief ȡӲ            */

#define AM_UART_MODE_SET          5   /**< \brief ģʽ                    */
#define AM_UART_MODE_GET          6   /**< \brief ȡǰģʽ                */
#define AM_UART_AVAIL_MODES_GET   7   /**< \brief ȡֵ֧Чģʽ          */

#define AM_UART_FLOWMODE_SET      8   /**< \brief ģʽ                */
#define AM_UART_FLOWSTAT_RX_SET   9   /**< \brief ý״̬          */
#define AM_UART_FLOWSTAT_TX_GET   10  /**< \brief ȡ״̬          */

#define AM_UART_RS485_SET         11  /**< \brief RS485ģʽ(ʹ  ) */
#define AM_UART_RS485_GET         12  /**< \brief ȡǰRS485ģʽ״̬     */

/** @} */

/**
 * \name ӲѡӲʱǶѡĻֵ
 * @{
 */

#define AM_UART_CSIZE    0xc   /**< \brief λ3 ~ λ4Ϊݿ                */
#define AM_UART_CS5      0x0   /**< \brief ݿΪ5λ                      */
#define AM_UART_CS6      0x4   /**< \brief ݿΪ6λ                      */
#define AM_UART_CS7      0x8   /**< \brief ݿΪ7λ                      */
#define AM_UART_CS8      0xc   /**< \brief ݿΪ8λ                      */

#define AM_UART_STOPB    0x20  /**< \brief ֹͣλΪ2λĬΪ1λ         */
#define AM_UART_PARENB   0x40  /**< \brief ʹżУ飬ĬżУǹرյ */
#define AM_UART_PARODD   0x80  /**< \brief УΪУ飬ĬżУ     */

/** @} */

/**
 * \name ѡ
 * @{
 */

#define AM_UART_FLOWCTL_NO    0xa0    /**< \brief              */
#define AM_UART_FLOWCTL_HW    0xa1    /**< \brief Ӳ           */
#define AM_UART_FLOWCTL_SW    0xa2    /**< \brief            */

#define AM_UART_FLOWSTAT_ON   0xb0    /**< \brief ݴ */
#define AM_UART_FLOWSTAT_OFF  0xb1    /**< \brief ֹͣݴ */

/** @} */

/**
 * \name 豸صͱ룬ָעֻص
 * @{
 */

#define AM_UART_CALLBACK_TXCHAR_GET   0  /**< \brief ȡһַ      */
#define AM_UART_CALLBACK_RXCHAR_PUT   1  /**< \brief ύһյַ  */
#define AM_UART_CALLBACK_ERROR        2  /**< \brief ص          */

/** @} */

/**
 * \name صĴ루code
 * @{
 */
#define AW_UART_ERR_CODE_NONE        (-1)        /**< \brief ޴          */
#define AW_UART_ERR_CODE_FRAMING      0          /**< \brief ֡          */
#define AW_UART_ERR_CODE_PARITY       1          /**< \brief У        */
#define AW_UART_ERR_CODE_OFLOW        2          /**< \brief over flow   */
#define AW_UART_ERR_CODE_UFLOW        3          /**< \brief under flow  */
#define AW_UART_ERR_CODE_CONNECT      4          /**< \brief Ӵ        */
#define AW_UART_ERR_CODE_DISCONNECT   5          /**< \brief ϿӴ    */
#define AW_UART_ERR_CODE_NO_CLK       6          /**< \brief ޿ʱ      */
#define AW_UART_ERR_CODE_UNKNWN       7          /**< \brief δ֪        */
/** @} */

/**
 * \name صͶ
 * @{
 */

/**
 * \brief ȡһַ
 *
 * \param[in]  p_arg  ûصʱָԶ
 * \param[out] p_char ȡݵָ
 *
 * \retval -AM_EEMPTY ȡʧܣ޸Ҫ
 * \retval  AM_OK     ȡݳɹ, p_char ȷװ˴͵
 */
typedef int (*am_uart_txchar_get_t)(void *p_arg, char *p_char);

/**
 * \brief ύһյַ
 *
 * \param[in] p_arg  ûصʱָԶ
 * \param[in] ch     յ
 *
 * \retval -AM_EFULL   ûʧܣû㹻ڴռ
 * \retval  AM_OK      ûݳɹ
 */
typedef int (*am_uart_rxchar_put_t)(void *p_arg, char  ch);

/**
 * \brief ص
 *
 * \param[in] p_arg  ûصʱָԶ
 * \param[in] code   
 * \param[in] p_data ĴϢƽ̨Զ壬ΪNULL
 * \param[in] size   : Ϣĳȣƽ̨Զ壬Ϊ0
 *
 * \return AM_OK
 */
typedef int (*am_uart_err_t)(void *p_arg, int code, void *p_data, int size);

/** @} */


/**
 * \brief UARTṹ
 */
struct am_uart_drv_funcs {

    /**\brief UARTƺ     */
    int (*pfn_uart_ioctl)(void *p_drv,int request, void *p_arg);

    /**\brief UARTͺ */
    int (*pfn_uart_tx_startup)(void *p_drv);

    /**\brief ôڻص */
    int (*pfn_uart_callback_set)(void  *p_drv,
                                 int    callback_type,
                                 void  *pfn_callback,
                                 void  *p_arg);

    /**\brief Ӵڻȡһַѯģʽ */
    int (*pfn_uart_poll_getchar)(void *p_drv, char *p_inchar);

    /**\brief һַѯģʽ       */
    int (*pfn_uart_poll_putchar)(void *p_drv, char outchar);

};

/**
 * \brief UART
 */
typedef struct am_uart_serv {

    /** \brief UARTṹָ    */
    struct am_uart_drv_funcs *p_funcs;

    /** \brief ĵһ  */
    void                     *p_drv;
} am_uart_serv_t;

/** \brief UART׼Ͷ  */
typedef am_uart_serv_t *am_uart_handle_t;

/**
 * \brief ڿƺ
 *
 * \param[in] handle  : UART׼
 * \param[in] request : ָ
 *   - AM_UART_BAUD_SET : ò, p_argΪ uint32_t,ֵΪ
 *   - AM_UART_BAUD_GET : ȡ, p_argΪ uint32_tָ
 *   - AM_UART_OPTS_SET Ӳp_arg Ϊ uint32_tͣ#AM_UART_CS8
 *   - AM_UART_OPTS_GET ȡǰӲãp_argΪ uint32_tָ
 *   - AM_UART_MODE_SET : ģʽ, p_argֵΪ AM_UART_MODE_POLL AM_UART_MODE_INT
 *   - AM_UART_MODE_GET : ȡǰģʽ, p_argΪ uint32_tָ
 *   - AM_UART_AVAIL_MODES_GET : ȡǰõģʽ, p_argΪ uint32_tָ
 *   - AM_UART_FLOWMODE_SET    : ģʽ, p_arg Ϊ AM_UART_FLOWCTL_NO
 *                                                         AM_UART_FLOWCTL_OFF
 *   - AM_UART_FLOWSTAT_RX_SET : ý״̬, p_arg ΪAM_UART_FLOWSTAT_ON 
 *                                                        AM_UART_FLOWSTAT_OFF
 *   - AM_UART_FLOWSTAT_TX_GET : ȡ״̬, p_arg ΪAM_UART_FLOWSTAT_ON 
 *                                                        AM_UART_FLOWSTAT_OFF
 *
 *   - AM_UART_RS485_SET : RS485ģʽp_argΪbool_tͣTUREʹܣFALSEܣ
 *   - AM_UART_RS485_GET ȡǰRS485ģʽ״̬Ϊ bool_t ָ
 *
 * \param[in,out] p_arg : ָӦĲ
 *
 * \retval AM_OK       : ִָгɹ
 * \retval -AM_EIO     : ִд
 * \retval -AM_ENOTSUP : ָ֧
 */
am_static_inline
int am_uart_ioctl (am_uart_handle_t handle,int request, void *p_arg)
{
    return handle->p_funcs->pfn_uart_ioctl(handle->p_drv,request,p_arg);
}

/**
 * \brief UARTжģʽݴ
 * \param[in] handle : UART׼
 * \retval AM_OK : ɹ
 */
am_static_inline
int am_uart_tx_startup (am_uart_handle_t handle)
{
    return handle->p_funcs->pfn_uart_tx_startup(handle->p_drv);
}

/**
 * \brief UARTص
 *
 * \param[in] handle         : UART׼
 * \param[in] callback_type  : ָõĺֻص
 *            - AM_UART_CALLBACK_GET_TX_CHAR  : ȡһַ
 *            - AM_UART_CALLBACK_PUT_RCV_CHAR : ύһյַӦó
 *            - AM_UART_CALLBACK_ERROR        : ص
 * \param[in] pfn_callback   : ָصָ
 * \param[in] p_arg          : صû
 *
 * \retval  AM_OK      : صóɹ
 * \retval -AM_EINVAL  : ʧܣ
 */
am_static_inline
int am_uart_callback_set (am_uart_handle_t  handle,
                          int               callback_type,
                          void             *pfn_callback,
                          void             *p_arg)
{
    return handle->p_funcs->pfn_uart_callback_set(handle->p_drv,
                                                  callback_type,
                                                  pfn_callback,
                                                  p_arg);
}

/**
 * \brief UARTһ(ѯģʽ)
 *
 * \param[in]  handle   : UART׼
 * \param[out] p_inchar : ڻȡݵָ
 *
 * \retval  AM_OK       : ݳɹ
 * \retval -AM_EAGAIN   : δ׼
 */
am_static_inline
int am_uart_poll_getchar (am_uart_handle_t handle, char *p_inchar)
{
    return handle->p_funcs->pfn_uart_poll_getchar(handle->p_drv, p_inchar);
}

/**
 * \brief UARTһ(ѯģʽ)
 *
 * \param[in] handle  : UART׼
 * \param[in] outchar : ͵
 *
 * \retval  AM_OK     : ݳɹ
 * \retval -AM_EAGAIN : δ
 */
am_static_inline
int am_uart_poll_putchar (am_uart_handle_t handle, char outchar)
{
    return handle->p_funcs->pfn_uart_poll_putchar(handle->p_drv, outchar);
}

/**
 * \brief UARTݷͣѯģʽ
 *
 * \param[in] handle  : UART׼
 * \param[in] p_txbuf : ݻ
 * \param[in] nbytes  : ݵĸ
 *
 * \return ɹݵĸ
 */
int am_uart_poll_send(am_uart_handle_t  handle,
                      const uint8_t    *p_txbuf,
                      uint32_t          nbytes);


/**
 * \brief UARTݽգѯģʽ
 *
 * \param[in] handle  : UART׼
 * \param[in] p_rxbuf : ݻ
 * \param[in] nbytes  : ݵĸ
 *
 * \return ɹݵĸ
 */
int am_uart_poll_receive(am_uart_handle_t  handle,
                         uint8_t          *p_rxbuf,
                         uint32_t          nbytes);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_UART_H */

/* end of file */
