/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief UART(ʹring bufferжģʽ)׼ӿ
 *
 * ļӿڵʵֻUART׼ӿڣΪûʹƣΪUARTӿں
 * ʹ÷
 *
 * \internal
 * \par Modification History
 * - 1.00 14-11-01  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_UART_RNGBUF_H
#define __AM_UART_RNGBUF_H


#ifdef __cplusplus
extern "C" {
#endif

#include "am_uart.h"
#include "am_rngbuf.h"
#include "am_wait.h"

/**
 * \addtogroup am_if_uart_rngbuf
 * \copydoc am_uart_rngbuf.h
 * @{
 */

/**
 * \name UARTĿָ
 * @{
 */

#define AM_UART_RNGBUF_NREAD     0x0100   /**< \brief ɶݸ        */
#define AM_UART_RNGBUF_NWRITE    0x0200   /**< \brief Ѿдݸ  */
#define AM_UART_RNGBUF_FLUSH     0x0300   /**< \brief ն/д     */
#define AM_UART_RNGBUF_WFLUSH    0x0400   /**< \brief д        */
#define AM_UART_RNGBUF_RFLUSH    0x0500   /**< \brief ն        */
#define AM_UART_RNGBUF_TIMEOUT   0x0600   /**< \brief õȴʱ        */

/** 
 * \brief صֵֽ
 *
 * ӦõֵɸӦĲ趨ֽСڸֵʱأ
 * δʱֵĬΪ 20%  С
 */                                               
#define AM_UART_RNGBUF_RX_FLOW_OFF_THR    0x0700
    
/**
 * \brief ֵֽ
 *
 * ӦõֵɸӦĲ趨ֽڸֵʱ
 * δʱֵĬΪ 80%  С
 *
 */
#define AM_UART_RNGBUF_RX_FLOW_ON_THR     0x0800

/** @} */

/**
 * \brief UARTring bufferжģʽ豸ṹ
 */
typedef struct am_uart_rngbuf_dev {

    /** \brief UART׼    */
    am_uart_handle_t  handle;

    /** \brief ݻλ      */
    struct am_rngbuf  rx_rngbuf;

    /** \brief ݻλ      */
    struct am_rngbuf  tx_rngbuf;
    
    /** \brief ֽڸֵʱ  */
    uint32_t          xon_threshold;
    
    /** \brief ֽڸֵʱ  */
    uint32_t          xoff_threshold;
    
    /** \brief ʱ                 */
    uint32_t          timeout_ms;
    
    /** \brief ǰ״̬ TRUE-򿪣FALSE-ر */
    am_bool_t         flow_stat;
    
    /** \brief ڽյȴ           */
    am_wait_t         rx_wait;

    /** \brief մʹ */
    am_bool_t         rx_trigger_enable;

    /** \brief ʹʹ */
    am_bool_t         tx_trigger_enable;

    /** \brief ֽڸֵʱջص */
    uint32_t          rx_trigger_threshold;

    /** \brief ջص */
    am_pfnvoid_t      pfn_rx_callback;

    /** \brief ջص */
    void             *p_rx_arg;

    /** \brief ֽڸֵʱͻص */
    uint32_t          tx_trigger_threshold;

    /** \brief ͻص */
    am_pfnvoid_t      pfn_tx_callback;

    /** \brief ͻص */
    void             *p_tx_arg;

} am_uart_rngbuf_dev_t;

/** \brief UARTring bufferжģʽ׼Ͷ */
typedef struct am_uart_rngbuf_dev * am_uart_rngbuf_handle_t;


/**
 * \brief ʼUARTΪring bufferжģʽ
 *
 * \param[in] p_dev      : UARTring bufferжģʽ豸ṹָ
 * \param[in] handle     : UART׼
 * \param[in] p_rxbuf    : ָջָ룬ʵֽջλ
 * \param[in] rxbuf_size : ջĴСС2^n
 * \param[in] p_txbuf    : ָͻָ룬ʵַͻλ
 * \param[in] txbuf_size : ͻĴСС2^n
 *
 * \return UARTring bufferжģʽ׼ֵΪNULL
 *         ʼʧ
 */
am_uart_rngbuf_handle_t am_uart_rngbuf_init(am_uart_rngbuf_dev_t *p_dev,
                                            am_uart_handle_t      handle,
                                            uint8_t              *p_rxbuf,
                                            uint32_t              rxbuf_size,
                                            uint8_t              *p_txbuf,
                                            uint32_t              txbuf_size);
                                              
                                              
/**
 * \brief UARTring bufferжģʽڿ
 *
 *     UARTƵ֧֣糣ĲáӲõȣֱʹá
 * ֵעǣʱڱ빤жģʽܹڲѯģʽģʽ
 * ָԡ
 *
 *
 * \param[in] handle  : UART׼
 * \param[in] request : ָ
 *            - AM_UART_RNGBUF_NREAD   : ɶݸΪuint32_tָ
 *            - AM_UART_RNGBUF_NWRITE  : ѾдݸΪuint32_tָ
 *            - AM_UART_RNGBUF_FLUSH   壬޲
 *            - AM_UART_RNGBUF_WFLUSH  д壬޲
 *            - AM_UART_RNGBUF_RFLUSH  : ն壬޲
 *            - AM_UART_RNGBUF_TIMEOUT : öĳʱʱ(ms)Ϊuint32_t,
 *                                        0ΪرճʱãΪһֱȴ
 *            - AM_UART_RNGBUF_FLOWMODE_SET : ģʽк꣺
 *                                               - AM_RNGBUF_UART_FLOWCTL_NO
 *                                               - AM_RNGBUF_UART_FLOWCTL_HW
 *                                               - AM_RNGBUF_UART_FLOWCTL_SW
 *            - AM_UART_RNGBUF_RX_FLOW_OFF_THR صֵֽ
 *            - AM_UART_RNGBUF_RX_FLOW_ON_THR  ֵֽ
 *
 * \param[in,out] p_arg : ָӦĲ
 *
 * \retval AM_OK       : ִָгɹ
 * \retval -AM_EIO     : ִд
 * \retval -AM_ENOTSUP : ָ֧
 */
int am_uart_rngbuf_ioctl(am_uart_rngbuf_handle_t   handle,
                         int                       request,
                         void                     *p_arg);

/**
 * \brief UARTݷͣring bufferжģʽ
 *
 * \param[in] handle  : UARTring bufferжģʽ׼
 * \param[in] p_txbuf : ݻ
 * \param[in] nbytes  : ݵĸ
 * 
 * \retval    >0      ɹݵĸ
 * \retval -AM_EINVAL : ȡʧܣ
 * \retval -AM_EIO    : ݴ
 */
int am_uart_rngbuf_send(am_uart_rngbuf_handle_t  handle,
                        const uint8_t           *p_txbuf,
                        uint32_t                 nbytes);

/**
 * \brief UARTݽգring bufferжģʽ
 *
 * \param[in] handle  : UARTring bufferжģʽ׼
 * \param[in] p_rxbuf : ݻ
 * \param[in] nbytes  : ݵĸ
 *
 * \retval    >0      ɹݵĸ
 * \retval -AM_EINVAL : ȡʧܣ
 * \retval -AM_EIO    : ݴ
 *
 * \note ˳ʱʱʱ᷵أֵͨжʵʶȡֽ
 */
int am_uart_rngbuf_receive(am_uart_rngbuf_handle_t  handle,
                           uint8_t                 *p_rxbuf,
                           uint32_t                 nbytes);

/**
 * \brief UARTմ
 *
 * \param[in] handle            : UARTring bufferжģʽ׼
 * \param[in] trigger_threshold : ֵ
 * \param[in] pfn_callback      : ص
 * \param[in] p_arg             : ص
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 *
 * \note յֽڸֵʹtriggerصǿյĻص
 */
int am_uart_rngbuf_rx_trigger_cfg (am_uart_rngbuf_handle_t  handle,
                                   uint32_t                 trigger_threshold,
                                   am_pfnvoid_t             pfn_callback,
                                   void                    *p_arg);

/**
 * \brief UARTմʹ
 *
 * \param[in] handle : UARTring bufferжģʽ׼
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 */
int am_uart_rngbuf_rx_trigger_enable (am_uart_rngbuf_handle_t  handle);

/**
 * \brief UARTմ
 *
 * \param[in] handle : UARTring bufferжģʽ׼
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 */
int am_uart_rngbuf_rx_trigger_disable (am_uart_rngbuf_handle_t  handle);

/**
 * \brief UARTʹ
 *
 * \param[in] handle            : UARTring bufferжģʽ׼
 * \param[in] trigger_threshold : ֵ
 * \param[in] pfn_callback      : ص
 * \param[in] p_arg             : ص
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 *
 * \note еֽڸֵʹtriggerصǿյĻص
 */
int am_uart_rngbuf_tx_trigger_cfg (am_uart_rngbuf_handle_t  handle,
                                   uint32_t                 trigger_threshold,
                                   am_pfnvoid_t             pfn_callback,
                                   void                    *p_arg);

/**
 * \brief UARTʹʹ
 *
 * \param[in] handle : UARTring bufferжģʽ׼
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 */
int am_uart_rngbuf_tx_trigger_enable (am_uart_rngbuf_handle_t  handle);

/**
 * \brief UARTʹ
 *
 * \param[in] handle : UARTring bufferжģʽ׼
 *
 * \retval AW_OK      : óɹ
 * \retval -AM_EINVAL : 
 */
int am_uart_rngbuf_tx_trigger_disable (am_uart_rngbuf_handle_t  handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_UART_RNGBUF_H */

/* end of file */
