/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ȴ(wait)׼ӿ
 *
 * ýӿڵʹ÷ʽǣȶһȴźţam_wait_t wait;
 * Ҫȴĵط:am_wait_on(&wait);
 * Ҫ֮ǰȴĵطãam_wait_done(&wait);
 *
 *
 * \internal
 * \par Modification History
 * - 1.01 15-09-07  tee, add am_wait_on_timeout() interface.
 * - 1.00 15-06-12  tee, first implementation.
 * \endinternal
 */

#ifndef __AM_WAIT_H
#define __AM_WAIT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"
#include "am_types.h"
#include "am_softimer.h"
    
/**
 * \addtogroup am_if_wait
 * \copydoc am_wait.h
 * @{
 */

 /**
  * \brief ȴͽṹ壬ӦóӦֱӲýṹԱ
  */
typedef struct am_wait {
    
    /** \brief ȴֵ                  */
    volatile uint8_t  val;
    
    /** \brief ڳʱʱ */
    am_softimer_t     timer;
    
    /** \brief ־ǰĵȴ״̬       */
    uint8_t           stat;

} am_wait_t;
    
 
/** 
 * \brief ȴźųʼ
 *
 * ʹõȴ֮ǰʹøúʼʼһμ
 *
 * \param[in] p_wait  : ָȴźŵָ
 *
* \retval  AM_OK      : ʼɹ
 * \retval -AM_EINVAL ʼʧܣ
 */
int am_wait_init(am_wait_t *p_wait);

/** 
 * \brief ȴ¼
 *
 * һֱȴֱ am_wait_done() ָȴ
 * 
 * \param[in] p_wait  : ָȴźŵָ
 *
 * \retval  AM_OK     ȴɹɣȴӦ¼
 * \retval -AM_EINVAL ȴʧܣ
 */
int am_wait_on(am_wait_t *p_wait);

/** 
 * \brief ȴ¼óʱʱ䣩
 *
 * һֱȴֱ am_wait_done() ָȴ
 * 
 * \param[in] p_wait      : ָȴźŵָ
 * \param[in] timeout_ms  : ȴʱʱ䣨λmsΪ0һֱȴ
 *
 * \retval  AM_OK     ȴɹɣȴӦ¼
 * \retval -AM_ETIME  ȴʱָmsʱΪյȴϢ
 * \retval -AM_EINVAL ȴʧܣ
 */
int am_wait_on_timeout(am_wait_t *p_wait, uint32_t timeout_ms);

/** 
 * \brief ȴ¼
 *
 *    øúam_wait_on()  am_wait_on_timeout() 
 * ĵȴɹȴɣȴ
 * 
 * \param[in] p_wait  : ָȴźŵָ
 *
 * \retval  AM_OK     ɹѾĵȴ
 * \retval -AM_EINVAL ȴʧܣ
 */
int am_wait_done(am_wait_t *p_wait);
 

/** 
 * @} 
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_WAIT_H */

/* end of file */
