/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief  WDT׼ӿ
 * 
 * \internal
 * \par Modification history
 * - 1.00 15-01-07  fft, first implementation.
 * \endinternal
 */

#ifndef __AM_WDT_H
#define __AM_WDT_H


#ifdef __cplusplus
extern "C" {
#endif

#include "am_common.h"
    
/** 
 * \addtogroup am_if_wdt
 * \copydoc am_wdt.h
 * @{
 */

/** 
 * \brief WDTʱϢ
 */
typedef struct am_wdt_info {
    uint32_t min_timeout_ms;  /**< \brief ֵ֧ʱʱ䣬λms */
    uint32_t max_timeout_ms;  /**< \brief ֵ֧Сʱʱ䣬λms */
} am_wdt_info_t;

/** 
 * \brief WDT
 */
struct am_wdt_drv_funcs {
    
    /** \brief ȡWDTϢ */
    int (*pfn_wdt_info_get)(void *p_drv, am_wdt_info_t *p_info);

    /** \brief óʱʱ䲢ʹWDT */
    int (*pfn_wdt_enable)(void *p_drv, uint32_t timeout_ms);
    
    /** \brief Źι */
    int (*pfn_wdt_feed)(void *p_drv);
};

/** 
 * \brief WDT׼
 */
typedef struct am_wdt_serv {

    /** \brief WDT */
    struct am_wdt_drv_funcs  *p_funcs; 
    
    /** \brief һڲ */
    void                     *p_drv; 
} am_wdt_serv_t;

/** \brief WDT׼ */
typedef am_wdt_serv_t *am_wdt_handle_t;


/**
 * \brief ȡWDTϢ
 *
 * \param[in] handle  : WDT׼
 * \param[out] p_info : ָWDTϢָ
 *
 * \retval AM_OK      : ɹ
 * \retval -AM_EINVAL : Ч
 */
am_static_inline
int am_wdt_info_get (am_wdt_handle_t handle, am_wdt_info_t *p_info)
{
    return handle->p_funcs->pfn_wdt_info_get(handle->p_drv,p_info);
}

/**
 * \brief óʱʱ䲢ʹWDT
 *
 * \param[in] handle     : WDT׼
 * \param[in] timeout_ms : ʱʱֵλms
 *
 * \retval  AM_OK        : óʱʱɹ
 * \retval -AM_EINVAL    : Ч趨ʱʱǷΧ
 *
 * \note 趨ĳʱʱֵΪ0WDTʹܡʱιʹоƬλ
 */
am_static_inline
int am_wdt_enable (am_wdt_handle_t handle, uint32_t timeout_ms)
{
    return handle->p_funcs->pfn_wdt_enable(handle->p_drv,timeout_ms);
}

/**
 * \brief Źι
 *
 * \param[in] handle : WDT׼
 *
 * \retval  AM_OK    : ɹ
 *
 * \note 趨ĳʱʱιŹλоƬ
 */
am_static_inline
int am_wdt_feed (am_wdt_handle_t handle)
{
    return handle->p_funcs->pfn_wdt_feed(handle->p_drv);
}

/**
 * @} 
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_WDT_H */

/* end of file */
