/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ADCADC׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 20-03-18  yrz, first implementation
 * \endinternal
 */

#ifndef  __AM_ZSN700_ADC_H
#define  __AM_ZSN700_ADC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_adc.h"

#include "hw/amhw_zsn700_adc.h"

/**
 * \addtogroup am_zsn700_if_adc
 * \copydoc am_zsn700_adc.h
 * @{
 */
/**
 * \brief ADCӦͨGPIOϢ
 */
typedef struct {
    amhw_zsn700_adc_chan_sel_t chan_sel;   /**< \brief ӦADCͨ */
    uint32_t gpio;                         /**< \brief ӦGPIOܽź */
    uint32_t func;                         /**< \brief ӦGPIO */
    uint32_t dfunc;                        /**< \brief ӦGPIOĬ */
} am_zsn700_adc_ioinfo_t;

/**
 * \brief ADC豸Ϣ
 */
typedef struct am_zsn700_adc_devinfo {

    /** \brief ADCĴĻַ */
    uint32_t   adc_reg_base;

    /** \brief ADCжϺ */
    int16_t    inum;

    /** \brief ʱID */
    int        clk_num;

    /* οѹѡ */
    amhw_zsn700_adc_refvoltage_choice_t vref_choice;

    /**
     * \brief ADCοѹλmV
     *
     * οѹ Vref = (Vrefp - Vrefn)  Ϊʱ
     * ȶADCȷVREFP = VDDA Vrefn ֵΪ Vss  Vssa 
     *
     * \note òοѹɾĵ·
     *
     */
    uint32_t   vref;

    /** \brief ADCڲ¶ȴʹ   1 0ر */
    uint8_t    temp_enable;

    /** \brief ת */
    uint8_t    bits_mode;

    /** \brief ADCӦͨϢ  */
    am_zsn700_adc_ioinfo_t *p_ioinfo;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

} am_zsn700_adc_devinfo_t;

/**
 * \brief ADC豸ʵ
 */
typedef struct am_zsn700_adc_dev {

    /** \brief ADC׼ */
    am_adc_serv_t                  adc_serve;

    /** \brief ָADC豸Ϣָ */
    const am_zsn700_adc_devinfo_t    *p_devinfo;

    /** \brief ûתĻص */
    am_adc_seq_cb_t                pfn_callback;

    /** \brief ûصĻص */
    void                          *p_arg;

    /** \brief ǰתͨ */
    int                            chan;

    /** \brief ADCתģʽѡ  */
    amhw_zsn700_adc_mode_t adc_mode;

    /** \brief ǰת׵ַ */
    am_adc_buf_desc_t             *p_desc;

    /** \brief ǰת */
    uint32_t                       desc_num;

    /** \brief תĴ */
    uint32_t                       count;

    /** \brief ת־ */
    uint32_t                       flags;

    /** \brief ԵǰѾĴ */
    uint32_t                       conv_cnt;

    /** \brief ִеǰ */
    uint32_t                       desc_index;

    /** \brief תɵĴ */
    uint32_t                       seq_cnt;

    /** \brief λ */
    uint16_t                       right_bit;

} am_zsn700_adc_dev_t;

/**
 * \brief ADCʼ
 *
 * ĬϳʼA
 *
 * \param[in] p_dev     : ָADC豸ָ
 * \param[in] p_devinfo : ָADC豸Ϣָ
 *
 * \return ADC׼ Ϊ NULLʼʧ
 */
am_adc_handle_t am_zsn700_adc_init (am_zsn700_adc_dev_t           *p_dev,
                                    const am_zsn700_adc_devinfo_t *p_devinfo);

/**
 * \brief ADCȥʼ
 *
 * ĬȥʼA
 *
 * \param[in] handle : am_zsn700_adc_init() ʼõADC
 *
 * \return 
 */
void am_zsn700_adc_deinit (am_adc_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_ADC_H */

/* end of file */
