/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ADC Peripheral Access Layer
 *
 * \internal
 * \par Modification history
 * - 1.00 20-03-17  yrz, first implementation
 *
 * \endinternal
 */

#ifndef __AMHW_ZSN700_ADC_H
#define __AMHW_ZSN700_ADC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_types.h"

/**
 * \addtogroup amhw_zsn700_if_adc
 * \copydoc amhw_zsn700_adc.h
 * @{
 */

/**
 * \brief ʹοʼ
 * @{
 */

#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
#elif defined(__GNUC__)

/* Ĭʹ */
#elif defined(__TMS470__)

/* Ĭʹ */
#elif defined(__TASKING__)
  #pragma warning 586
#else
  #warning Not supported compiler t
#endif

/** @} */

/**
 * \brief ADC - Register Layout Typedef
 */
typedef struct amhw_zsn700_adc {
    __I  uint32_t reserve0;       /**< \brief  */
    __IO uint32_t cr[2];          /**< \brief üĴ01 ƫƵַ0x0040x008*/
    __I  uint32_t reserve2[13];   /**< \brief  */
    __IO uint32_t sqr[3];         /**< \brief ˳ɨתͨüĴ012 */
    __IO uint32_t jqr;            /**< \brief ɨתͨüĴ */
    __I  uint32_t sqrresult[16];  /**< \brief ˳ɨתͨת(0~15) */
    __I  uint32_t jqrresult[4];   /**< \brief ɨתͨת(0~3) */
    __I  uint32_t result;         /**< \brief ת */
    __I  uint32_t resultacc;      /**< \brief תۼֵ */
    __IO uint32_t ht;             /**< \brief Ƚֵ */
    __IO uint32_t lt;             /**< \brief Ƚֵ */
    __IO uint32_t ifr;            /**< \brief жϱ־Ĵ */
    __IO uint32_t icr;            /**< \brief жĴ */
    __IO uint32_t exttrigger0;    /**< \brief ת˳ɨתⲿжϴԴüĴ */
    __IO uint32_t exttrigger1;    /**< \brief ɨתⲿжϴԴüĴ */
    __IO uint32_t sglstart;       /**< \brief תƼĴ */
    __IO uint32_t sqrstart;       /**< \brief ˳ɨתƼĴ */
    __IO uint32_t jqrstart;       /**< \brief ɨתƼĴ */
    __IO uint32_t allstart;       /**< \brief һֱתֹͣƼĴ */
} amhw_zsn700_adc_t;

typedef enum {
    AMHW_ZSN700_WORK_MODE_SINGLE = 0,      /**< \brief ת1ͨ*/
    AMHW_ZSN700_WORK_MODE_SQR,             /**< \brief ˳ɨת16ͨ */
    AMHW_ZSN700_WORK_MODE_JQR,             /**< \brief ɨת 4ͨ*/
}amhw_zsn700_adc_work_mode_t;

typedef enum {
    AMHW_ZSN700_CHAN_AIN0_PA0 = 0,      /**< \brief תͨ0 */
    AMHW_ZSN700_CHAN_AIN1_PA1,          /**< \brief תͨ1 */
    AMHW_ZSN700_CHAN_AIN2_PA2,          /**< \brief תͨ2 */
    AMHW_ZSN700_CHAN_AIN3_PA3,          /**< \brief תͨ3 */
    AMHW_ZSN700_CHAN_AIN4_PA4,          /**< \brief תͨ4 */
    AMHW_ZSN700_CHAN_AIN8_PB0 = 8,      /**< \brief תͨ8 */
    AMHW_ZSN700_CHAN_AIN9_PB1,          /**< \brief תͨ9 */
    AMHW_ZSN700_CHAN_AIN10_PC0,         /**< \brief תͨ10 */
    AMHW_ZSN700_CHAN_AIN11_PC1,         /**< \brief תͨ11 */
    AMHW_ZSN700_CHAN_AIN12_PC2,         /**< \brief תͨ12 */
    AMHW_ZSN700_CHAN_AIN13_PC3,         /**< \brief תͨ13 */
    AMHW_ZSN700_CHAN_AIN14_PC4,         /**< \brief תͨ14 */
    AMHW_ZSN700_CHAN_AIN15_PC5,         /**< \brief תͨ15 */
    AMHW_ZSN700_CHAN_AIN16_PB2,         /**< \brief תͨ16 */
    AMHW_ZSN700_CHAN_AIN17_PB10,        /**< \brief תͨ17 */
    AMHW_ZSN700_CHAN_AIN18_PB11,        /**< \brief תͨ18 */
    AMHW_ZSN700_CHAN_AIN19_PB12,        /**< \brief תͨ19 */
    AMHW_ZSN700_CHAN_AIN20_PB13,        /**< \brief תͨ20 */
    AMHW_ZSN700_CHAN_AIN21_PB14,        /**< \brief תͨ21 */
    AMHW_ZSN700_CHAN_AIN22_PB15,        /**< \brief תͨ22 */
    AMHW_ZSN700_CHAN_DAC_OUT = 26,      /**< \brief DACӣADC_CR0.BufΪ1 */
    AMHW_ZSN700_CHAN_VCC_DIV3,          /**< \brief ڲ1/3VCCӣADC_CR0.BufΪ1 */
    AMHW_ZSN700_CHAN_INSIDE_TEMP_SENSOR,/**< \brief ¶ȴѹӣADC_CR0.BufΪ1 */
    AMHW_ZSN700_CHAN_INSIDE_REFVCC_12,  /**< \brief ڲ׼1.2VѹӣADC_CR0.BufΪ1 */
}amhw_zsn700_adc_chan_sel_t;

/**
 * \brief IE жʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_int_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] |= (0x1ul << 15);
}

/**
 * \brief IE жϽ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_int_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] &= ~(0x1ul << 15);
}

/**
 * \brief En ADCʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] |= (0x1ul << 0);
}

/**
 * \brief En ADC
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] &= ~(0x1ul << 0);
}

/**
 * \brief InRefEn ADCڲοѹʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_inrefvol_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] |= (0x1ul << 14);
}

/**
 * \brief InRefEn ADCڲοѹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_inrefvol_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] &= ~(0x1ul << 14);
}

/**
 * \brief ADC 
 */
typedef enum {
    AMHW_ZSN700_ADC_SAMPLE_PERIOD_4 = 0,     /**< \brief 4ת */
    AMHW_ZSN700_ADC_SAMPLE_PERIOD_6,         /**< \brief 6ת */
    AMHW_ZSN700_ADC_SAMPLE_PERIOD_8,         /**< \brief 8ת */
    AMHW_ZSN700_ADC_SAMPLE_PERIOD_12,        /**< \brief 12ת */
}amhw_zsn700_adc_sample_period_t;

/**
 * \brief SAM ADCѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_sample_period_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sample_period_sel(amhw_zsn700_adc_t              *p_hw_adc,
                                       amhw_zsn700_adc_sample_period_t choice)
{
    p_hw_adc->cr[0] = (p_hw_adc->cr[0] & (~(0x3ul << 12))) |
                      ((choice & 0x3ul) << 12);
}

/**
 * \brief SAM ADCڻȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return amhw_zsn700_adc_sample_period_tö
 */
am_static_inline
amhw_zsn700_adc_sample_period_t amhw_zsn700_adc_sample_period_get(
                                    amhw_zsn700_adc_t *p_hw_adc)
{
    return (amhw_zsn700_adc_sample_period_t)((p_hw_adc->cr[0] >> 12) & 0x3ul);
}

/**
 * \brief Buf ADCźŷŴʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \note ¼ҪBUFܣʹBUFʱ200kbps
 *            1ⲿź
 *            21/3AVCC
 *            3temp sensor
 *            4VREF1P2
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_inamplify_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] |= (0x1ul << 11);
}

/**
 * \brief Buf ADCźŷŴ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \note ¼ҪBUFܣʹBUFʱ200kbps
 *            1ⲿź
 *            21/3AVCC
 *            3temp sensor
 *            4VREF1P2
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_inamplify_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[0] &= ~(0x1ul << 11);
}

/**
 * \brief ADC οѹѡ
 */
typedef enum {
    AMHW_ZSN700_ADC_REFVOL_INSIDE_1500MV = 0,
    AMHW_ZSN700_ADC_REFVOL_INSIDE_2500MV,
    AMHW_ZSN700_ADC_REFVOL_OUTSIDE_PB1,
    AMHW_ZSN700_ADC_REFVOL_AVCC,
}amhw_zsn700_adc_refvoltage_choice_t;

/**
 * \brief Ref ADCοѹѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_refvoltage_choice_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_refvol_sel(amhw_zsn700_adc_t                  *p_hw_adc,
                                amhw_zsn700_adc_refvoltage_choice_t choice)
{
    p_hw_adc->cr[0] = (p_hw_adc->cr[0] & (~(0x3ul << 9))) |
                      ((choice & 0x3ul) << 9);
}

/**
 * \brief Ref ADCοѹѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_refvoltage_choice_tö
 *
 * \return none
 */
am_static_inline
amhw_zsn700_adc_refvoltage_choice_t amhw_zsn700_adc_refvol_get(
                                        amhw_zsn700_adc_t *p_hw_adc)
{
    return (amhw_zsn700_adc_refvoltage_choice_t)((p_hw_adc->cr[0] >> 9) & 0x3ul);
}

/**
 * \brief SGLMux תģʽתͨѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_chan_sel_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sgl_chan_sel(amhw_zsn700_adc_t         *p_hw_adc,
                                  amhw_zsn700_adc_chan_sel_t choice)
{
    p_hw_adc->cr[0] = (p_hw_adc->cr[0] & (~(0x1ful << 4))) |
                      ((choice & 0x1ful) << 4);
}

/**
 * \brief ADCʱѡ
 */
typedef enum {
    AMHW_ZSN700_ADC_PCLK_DIV1 = 0,
    AMHW_ZSN700_ADC_PCLK_DIV2,
    AMHW_ZSN700_ADC_PCLK_DIV4,
    AMHW_ZSN700_ADC_PCLK_DIV8,
}amhw_zsn700_adc_pclk_div_t;

/**
 * \brief CkDiv ADCʱӷƵѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_pclk_div_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_pclk_div_sel(amhw_zsn700_adc_t         *p_hw_adc,
                                  amhw_zsn700_adc_pclk_div_t choice)
{
    p_hw_adc->cr[0] = (p_hw_adc->cr[0] & (~(0x3ul << 2))) |
                      ((choice & 0x3ul) << 2);
}

/**
 * \brief CkDiv ADCʱӷƵȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return amhw_zsn700_adc_pclk_div_töеһ
 */
am_static_inline
amhw_zsn700_adc_pclk_div_t amhw_zsn700_adc_pclk_div_get(amhw_zsn700_adc_t
                                                            *p_hw_adc)
{
    return (amhw_zsn700_adc_pclk_div_t)((p_hw_adc->cr[0] >> 2) & 0x3ul);
}

/**
 * \brief RAccClr ADCתۼӼĴADC_ResultAcc
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_acc_clr (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 15);
}

/**
 * \brief RegCmp ADCȽʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_interval_cmp_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 14);
}

/**
 * \brief RegCmp ADCȽϽ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_interval_cmp_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 14);
}

/**
 * \brief HtCmp ADCֵȽʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_ht_cmp_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 13);
}

/**
 * \brief HtCmp ADCֵȽϽ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_ht_cmp_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 13);
}

/**
 * \brief LtCmp ADCֵȽʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_lt_cmp_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 12);
}

/**
 * \brief LtCmp ADCֵȽϽ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_lt_cmp_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 12);
}

/**
 * \brief RAccEn ADCתԶۼʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_acc_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 11);
}

/**
 * \brief RAccEn ADCתԶۼӽ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_acc_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 11);
}

/**
 * \brief ADCתģʽѡ
 */
typedef enum {
    AMHW_ZSN700_ADC_MODE_SCAN   = 1,
    AMHW_ZSN700_ADC_MODE_SINGLE = 0,
}amhw_zsn700_adc_mode_t;
/**
 * \brief Mode ADCתģʽѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] mode     : amhw_zsn700_adc_mode_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_mode_sel (amhw_zsn700_adc_t     *p_hw_adc,
                               amhw_zsn700_adc_mode_t mode)
{
    p_hw_adc->cr[1] =  (p_hw_adc->cr[1] & (~(0x1ul << 10))) |
                       ((mode & 0X1ul) << 10);
}

/**
 * \brief DmaJqr ɨ败DMAȡʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_dma_jqr_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 9);
}

/**
 * \brief DmaJqr ɨ败DMAȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_dma_jqr_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 9);
}

/**
 * \brief DmaSqr ˳ɨ败DMAȡʹ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_dma_sqr_enable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] |= (0x1ul << 8);
}

/**
 * \brief DmaSqr ˳ɨ败DMAȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_dma_sqr_disable (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->cr[1] &= ~(0x1ul << 8);
}

/**
 * \brief ThCh ֵȽͨѡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_chan_sel_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_threshold_chan_sel(amhw_zsn700_adc_t         *p_hw_adc,
                                        amhw_zsn700_adc_chan_sel_t choice)
{
    p_hw_adc->cr[1] = (p_hw_adc->cr[1] & (~(0x1ful << 3))) |
                      ((choice & 0x1ful) << 3);
}

typedef enum {
    AMHW_ZSN700_ADC_DATA_ALIGN_RIGHT = 0,
    AMHW_ZSN700_ADC_DATA_ALIGN_LEFT  = 1,
}amhw_zsn700_adc_data_align_t;

/**
 * \brief ADC ת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] choice   : amhw_zsn700_adc_data_align_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_align_way_sel (amhw_zsn700_adc_t           *p_hw_adc,
                                    amhw_zsn700_adc_data_align_t mode)
{
    p_hw_adc->cr[1] =  (p_hw_adc->cr[1] & (~(0x1ul << 2))) |
                       ((mode & 0x1ul) << 2);
}

/**
 * \brief ˳ɨתͨ ˳ɨתͨ;ADCͨ໥ӣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] sqr_chan : sqrͨ
 * \param[in] choice   : amhw_zsn700_adc_chan_sel_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sqr_chan_sel(amhw_zsn700_adc_t         *p_hw_adc,
                                  uint8_t                    sqr_chan,
                                  amhw_zsn700_adc_chan_sel_t choice)
{
    if(sqr_chan < 16) {
        p_hw_adc->sqr[sqr_chan / 6] =
            (p_hw_adc->sqr[sqr_chan / 6] & (~(0x1ful<<((sqr_chan % 6) * 5)))) |
            ((choice & 0x1ful) << ((sqr_chan % 6) * 5));
    }
}

/**
 * \brief ˳ɨת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] num      : ת
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sqr_num_set(amhw_zsn700_adc_t *p_hw_adc,
                                 uint8_t            num)
{
    p_hw_adc->sqr[2] = (p_hw_adc->sqr[2] & (~(0xful << 20))) |
                       ((num & 0xful) << 20);
}

/**
 * \brief ɨתͨã ɨתͨ;ADCͨ໥ӣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] jqr_chan : jqrͨ
 * \param[in] choice   : amhw_zsn700_adc_chan_sel_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_chan_sel(amhw_zsn700_adc_t         *p_hw_adc,
                                  uint8_t                    jqr_chan,
                                  amhw_zsn700_adc_chan_sel_t choice)
{
    if(jqr_chan < 4) {
        p_hw_adc->jqr = (p_hw_adc->jqr & (~(0x1ful << (jqr_chan * 5)))) |
                         ((choice & 0x1ful) << (jqr_chan * 5));
    }
}

/**
 * \brief ɨת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] num      : ת
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_num_set(amhw_zsn700_adc_t *p_hw_adc,
                                 uint8_t            num)
{
    p_hw_adc->jqr = (p_hw_adc->jqr & (~(0x3ul << 20))) |
                    ((num & 0x3ul) << 20);
}

/**
 * \brief ˳ɨתͨ xת ɨADݻȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] sqr_chan : sqrͨ
 *
 * \return 12bitADCת
 */
am_static_inline
uint16_t amhw_zsn700_adc_sqr_chan_data_get(amhw_zsn700_adc_t *p_hw_adc,
                                           uint8_t            sqr_chan)
{
    if(sqr_chan < 16) {
        return p_hw_adc->sqrresult[sqr_chan];
    } else {
        return 0;
    }
}

/**
 * \brief ɨתͨ xת ɨADݻȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] jqr_chan : jqrͨ
 *
 * \return 12bitADCת
 */
am_static_inline
uint16_t amhw_zsn700_adc_jqr_chan_data_get(amhw_zsn700_adc_t *p_hw_adc,
                                           uint8_t            jqr_chan)
{
    if(jqr_chan < 4) {
        return p_hw_adc->jqrresult[jqr_chan];
    } else {
        return 0;
    }
}

/**
 * \brief ADCתȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return 12bitADCת
 */
am_static_inline
uint16_t amhw_zsn700_adc_data_get(amhw_zsn700_adc_t *p_hw_adc)
{
    return p_hw_adc->result;
}

/**
 * \brief ADCתۼֵȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return 16bit
 */
am_static_inline
uint16_t amhw_zsn700_adc_acc_data_get(amhw_zsn700_adc_t *p_hw_adc)
{
    return p_hw_adc->resultacc;
}

/**
 * \brief ADCȽֵȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return 12bit
 */
am_static_inline
uint16_t amhw_zsn700_adc_ht_get(amhw_zsn700_adc_t *p_hw_adc)
{
    return p_hw_adc->ht;
}

/**
 * \brief ADCȽֵ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] data     : ֵ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_ht_set(amhw_zsn700_adc_t *p_hw_adc,
                            uint16_t           data)
{
    p_hw_adc->ht = (p_hw_adc->ht & (~(0xffful))) |
                   (data & 0xffful);
}

/**
 * \brief ADCȽֵȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return 12bit
 */
am_static_inline
uint16_t amhw_zsn700_adc_lt_get(amhw_zsn700_adc_t *p_hw_adc)
{
    return p_hw_adc->lt;
}

/**
 * \brief ADCȽֵ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] data     : ֵ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_lt_set(amhw_zsn700_adc_t *p_hw_adc,
                            uint16_t           data)
{
    p_hw_adc->lt = (p_hw_adc->lt & (~(0xffful))) |
                   (data & 0xffful);
}

typedef enum {
    AMHW_ZSN700_ADC_FLAG_ALL         = 6,
    AMHW_ZSN700_ADC_FLAG_CONVERT_JQR = 5,   /* ɨת״̬־    1    0δ*/
    AMHW_ZSN700_ADC_FLAG_CONVERT_SQR = 4,   /* ˳ɨת״̬־    1    0δ*/
    AMHW_ZSN700_ADC_FLAG_COMPARE_REG = 3,   /* תǷλ[LT  HT)    1λ    0λ*/
    AMHW_ZSN700_ADC_FLAG_COMPARE_HT = 2,    /* תǷλ[HT  4095)    1λ    0λ*/
    AMHW_ZSN700_ADC_FLAG_COMPARE_LT = 1,    /* תǷλ[0  LT)    1λ    0λ*/
    AMHW_ZSN700_ADC_FLAG_CONVERT_SINGLE = 0,/* ת״̬־    1    0δ*/
}amhw_zsn700_adc_flag_type_t;

/**
 * \brief ADC־״̬ȡ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_flag_type_tö
 *
 * \return AM_TRUE  : 1
 *         AM_FALSE : 0
 */
am_static_inline
am_bool_t amhw_zsn700_adc_flag_check (amhw_zsn700_adc_t          *p_hw_adc,
                                      amhw_zsn700_adc_flag_type_t type)
{
    return ((p_hw_adc->ifr >> type) & 0x1u) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief ADC־״̬
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_flag_type_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_flag_clr (amhw_zsn700_adc_t          *p_hw_adc,
                               amhw_zsn700_adc_flag_type_t type)
{
    if(type == AMHW_ZSN700_ADC_FLAG_ALL) {
        p_hw_adc->icr &= ~(0x3ful);
    } else {
        p_hw_adc->icr &= ~(0x1ul << type);
    }

}

typedef enum {
    AMHW_ZSN700_ADC_INT_TRIGGER_PC15 = 31,
    AMHW_ZSN700_ADC_INT_TRIGGER_PB15 = 30,
    AMHW_ZSN700_ADC_INT_TRIGGER_PA15 = 29,
    AMHW_ZSN700_ADC_INT_TRIGGER_PC11 = 28,
    AMHW_ZSN700_ADC_INT_TRIGGER_PB11 = 27,
    AMHW_ZSN700_ADC_INT_TRIGGER_PA11 = 26,
    AMHW_ZSN700_ADC_INT_TRIGGER_PD7 = 25,
    AMHW_ZSN700_ADC_INT_TRIGGER_PC7 = 24,
    AMHW_ZSN700_ADC_INT_TRIGGER_PB7 = 23,
    AMHW_ZSN700_ADC_INT_TRIGGER_PA7 = 22,
    AMHW_ZSN700_ADC_INT_TRIGGER_PD3 = 21,
    AMHW_ZSN700_ADC_INT_TRIGGER_PC3 = 20,
    AMHW_ZSN700_ADC_INT_TRIGGER_PB3 = 19,
    AMHW_ZSN700_ADC_INT_TRIGGER_PA3 = 18,
    AMHW_ZSN700_ADC_INT_TRIGGER_DMA = 17,
    AMHW_ZSN700_ADC_INT_TRIGGER_SPI1 = 16,
    AMHW_ZSN700_ADC_INT_TRIGGER_SPI0 = 15,
    AMHW_ZSN700_ADC_INT_TRIGGER_PCA = 14,
    AMHW_ZSN700_ADC_INT_TRIGGER_RTC = 13,
    AMHW_ZSN700_ADC_INT_TRIGGER_VC1 = 12,
    AMHW_ZSN700_ADC_INT_TRIGGER_VC0 = 11,
    AMHW_ZSN700_ADC_INT_TRIGGER_LPUART1 = 10,
    AMHW_ZSN700_ADC_INT_TRIGGER_LPUART0 = 9,
    AMHW_ZSN700_ADC_INT_TRIGGER_UART1 = 8,
    AMHW_ZSN700_ADC_INT_TRIGGER_UART0 = 7,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM6 = 6,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM5 = 5,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM4 = 4,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM3 = 3,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM2 = 2,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM1 = 1,
    AMHW_ZSN700_ADC_INT_TRIGGER_TIM0 = 0,
}amhw_zsn700_adc_int_trigger_src_t;

/**
 * \brief ת˳ɨתⲿжϴԴ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_int_trigger_src_tö
 *
 * \note TIM4/5/6жϴ ADCԶתҪʹ TIM4/5/6Ӧж⣬ҪAdvanced Timer
 *       չƵжϴѡĴ TIMX_CRѡԴ ADC жԴ
 *
 *        ADCʹõǸжϱ־λءҪظҪжϱ־ҪжϷ
 *       벻Ҫʹ NVICжʹܡ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sgl_sqr_trigger_src_set (
         amhw_zsn700_adc_t                *p_hw_adc,
         amhw_zsn700_adc_int_trigger_src_t type)
{
    p_hw_adc->exttrigger0 |= (0x1ul << type);
}

/**
 * \brief ת˳ɨתⲿжϴԴ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_int_trigger_src_tö
 *
 * \note TIM4/5/6жϴ ADCԶתҪʹ TIM4/5/6 Ӧж⣬ҪAdvanced Timer
 *       չƵжϴѡĴ TIMX_CR ѡԴ ADC жԴ
 *
 *        ADC ʹõǸжϱ־λءҪظҪжϱ־ҪжϷ
 *       벻Ҫʹ NVIC жʹܡ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sgl_sqr_trigger_src_clr (
         amhw_zsn700_adc_t                *p_hw_adc,
         amhw_zsn700_adc_int_trigger_src_t type)
{
    p_hw_adc->exttrigger0 &= ~(0x1ul << type);
}

/**
 * \brief ɨתⲿжϴԴ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_int_trigger_src_tö
 *
 * \note TIM4/5/6жϴ ADCԶתҪʹ TIM4/5/6 Ӧж⣬ҪAdvanced Timer
 *       չƵжϴѡĴ TIMX_CR ѡԴ ADC жԴ
 *
 *        ADC ʹõǸжϱ־λءҪظҪжϱ־ҪжϷ
 *       벻Ҫʹ NVIC жʹܡ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_trigger_src_set (
         amhw_zsn700_adc_t                *p_hw_adc,
         amhw_zsn700_adc_int_trigger_src_t type)
{
    p_hw_adc->exttrigger1 |= (0x1ul << type);
}

/**
 * \brief ɨתⲿжϴԴ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 * \param[in] type     : ־amhw_zsn700_adc_int_trigger_src_tö
 *
 * \note TIM4/5/6жϴ ADCԶתҪʹ TIM4/5/6 Ӧж⣬ҪAdvanced Timer
 *       չƵжϴѡĴ TIMX_CRѡԴ ADCжԴ
 *
 *        ADCʹõǸжϱ־λءҪظҪжϱ־ҪжϷ
 *       벻Ҫʹ NVICжʹܡ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_trigger_src_clr (
         amhw_zsn700_adc_t                *p_hw_adc,
         amhw_zsn700_adc_int_trigger_src_t type)
{
    p_hw_adc->exttrigger1 &= ~(0x1ul << type);
}

/**
 * \brief ת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_single_convert_start (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->sglstart |= (0x1ul << 0);
}

/**
 * \brief תֹͣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_single_convert_stop (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->sglstart &= ~(0x1ul << 0);
}

/**
 * \brief ˳ɨת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sqr_convert_start (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->sqrstart |= (0x1ul << 0);
}

/**
 * \brief ˳ɨתֹͣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_sqr_convert_stop (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->sqrstart &= ~(0x1ul << 0);
}

/**
 * \brief ɨת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_convert_start (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->jqrstart |= (0x1ul << 0);
}

/**
 * \brief ɨתֹͣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_jqr_convert_stop (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->jqrstart &= ~(0x1ul << 0);
}


/**
 * \brief һֱת
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \note ֹͣADCһֱת,Ҫȴת
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_always_convert_start (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->jqrstart |= (0x1ul << 0);
}

/**
 * \brief һֱתֹͣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \note ֹͣADCһֱת,Ҫȴת
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_adc_always_convert_stop (amhw_zsn700_adc_t *p_hw_adc)
{
    p_hw_adc->jqrstart &= ~(0x1ul << 0);
}

/**
 * \brief һֱתֹͣ
 *
 * \param[in] p_hw_adc : ָADCĴָ
 *
 * \note ֹͣADCһֱת,Ҫȴת
 *
 * \return AM_TRUE : ת
 *         AM_FALSE: ת
 */
am_static_inline
am_bool_t amhw_zsn700_adc_always_convert_get (amhw_zsn700_adc_t *p_hw_adc)
{
    return (p_hw_adc->jqrstart & 0x1ul) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief ʹν
 * @{
 */

#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)

/* ʹ */
#elif defined(__GNUC__)

/* Ĭʹ */
#elif defined(__TMS470__)

/* Ĭʹ */
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler t
#endif
/** @} */

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZSN700_ADC_H */

/* end of file */
