/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱADTIMTimerʵ
 *
 * 1. ADTIM֧ṩֱ׼񣬱ṩǷTimer׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. һADTIMģ飬ֻһʱͨ
 *
 * \internal
 * \par Modification history
 * - 1.00 19-10-09  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_ADTIM_ADTIMING_H
#define __AM_ZLG118_ADTIM_ADTIMING_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_timer.h"
#include "hw/amhw_zlg118_adtim.h"

/**
 * \addtogroup am_zlg118_if_adtim_timing
 * \copydoc am_zlg118_adtim_timing.h
 * @{
 */

/**
 * \brief ADTIMʱص豸Ϣ
 */
typedef struct am_zlg118_adtim_timing_devinfo {

    uint32_t                        adtim_regbase;    /**< \brief ADTIMĴַ */

    uint8_t                         inum;           /**< \brief ADTIMжϺ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                            (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                            (*pfn_plfm_deinit)(void);

} am_zlg118_adtim_timing_devinfo_t;

/**
 * \brief ADTIMʱ豸
 */
typedef struct am_zlg118_adtim_timing_dev {

    am_timer_serv_t adtimer_serv;         /**< \brief ׼ʱ(Timer) */

    void (*pfn_callback)(void *);       /**< \brief ص */
    void  *p_arg;                       /**< \brief صû */

    uint16_t           prescale_to;     /**< \brief Ƶֵ  */
    uint16_t           prescale_in;     /**< \brief ʵʷƵֵ  */

    /** \brief ָADTIM(ʱ)豸Ϣָ */
    const am_zlg118_adtim_timing_devinfo_t  *p_devinfo;

} am_zlg118_adtim_timing_dev_t;

/**
 * \brief ʼADTIMΪʱ
 *
 * \param[in] p_dev     : ָADTIM(ʱ)豸ָ
 * \param[in] p_devinfo : ָADTIM(ʱ)豸Ϣָ
 *
 * \return Timer׼ֵΪNULLʱʼʧ
 */
am_timer_handle_t
am_zlg118_adtim_timing_init (am_zlg118_adtim_timing_dev_t           *p_dev,
                             const am_zlg118_adtim_timing_devinfo_t *p_devinfo);

/**
 * \brief ʹADTIMʱʱʼADTIMʱܣͷԴ
 *
 * \param[in] handle : am_zlg118_adtim_timing_init() ʼõTimer
 *
 * \return 
 */
void am_zlg118_adtim_timing_deinit (am_timer_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG118_ADTIM_ADTIMING_H */

/* end of file */
