/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMCAP׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 20-03-18  yrz, first implementation
 * \endinternal
 */

#ifndef __AM_ZSN700_ADTIM_CAP_H
#define __AM_ZSN700_ADTIM_CAP_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_cap.h"
#include "hw/amhw_zsn700_adtim.h"

/**
 * \addtogroup am_zsn700_if_adtim_cap
 * \copydoc am_zsn700_adtim_cap.h
 * @{
 */

#define  AM_ZSN700_ADTIM_CAP_CHA  0x00   /**< \brief CAPͨAʶ*/
#define  AM_ZSN700_ADTIM_CAP_CHB  0x01   /**< \brief CAPͨBʶ*/

/**
 * \brief TIMصGPIOϢ
 */
typedef struct am_zsn700_adtim_cap_ioinfo {
    int8_t   channel;        /**< \brief CAPʹõͨʶ */
    uint32_t gpio;           /**< \brief ӦGPIOܽ */
    uint32_t func;           /**< \brief ΪʱGPIO */
    uint32_t dfunc;          /**< \brief ܹܽŲʱĬGPIO */
} am_zsn700_adtim_cap_ioinfo_t;

/**
 * \brief TIMص豸Ϣ
 */
typedef struct am_zsn700_adtim_cap_devinfo {
    uint32_t                      tim_regbase;   /**< \brief TIMĴַ */
    uint8_t                       inum;          /**< \brief TIMӦжϺ */
    amhw_zsn700_adtim_pclk_div_t  clk_div;       /**< \brief ʱӷƵϵ */
    uint8_t                       channels_num;  /**< \brief ʹõͨΪ2 */
    am_zsn700_adtim_cap_ioinfo_t *p_ioinfo;      /**< \brief ָ򲶻ܽϢṹ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                          (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                          (*pfn_plfm_deinit)(void);
} am_zsn700_adtim_cap_devinfo_t;

/**
 * \brief TIM豸
 */
typedef struct am_zsn700_adtim_cap_dev {
    am_cap_serv_t          cap_serv;      /**< \brief ׼CAP */

    struct {
        am_cap_callback_t  callback_func; /**< \brief ص */
        void              *p_arg;         /**< \brief صû */
    } adtim_callback_info[2];             /**< \brief 洢2ͨĻصϢ */

    /** \brief ָTIM()豸Ϣָ */
    const am_zsn700_adtim_cap_devinfo_t *p_devinfo;

    uint8_t                chan_max;      /**< \brief Чͨ  */

} am_zsn700_adtim_cap_dev_t;

/**
 * \brief ʼTIMΪ
 *
 * \param[in] p_dev     : ָTIM()豸ָ
 * \param[in] p_devinfo : ָTIM()豸Ϣָ
 *
 * \return CAP׼ֵΪNULLʱʼʧ
 */
am_cap_handle_t am_zsn700_adtim_cap_init (am_zsn700_adtim_cap_dev_t              *p_dev,
                                        const am_zsn700_adtim_cap_devinfo_t *p_devinfo);

/**
 * \brief ʹTIMʱʼTIMܣͷԴ
 *
 * \param[in] handle : am_zsn700_adtim_cap_init() ʼõcap
 *
 * \return 
 */
void am_zsn700_adtim_cap_deinit (am_cap_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_ADTIM_CAP_H */

/* end of file */
