/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zsn700.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱADTIMPWM׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 20-03-17  yrz, first implementation
 * \endinternal
 */

#ifndef __AM_ZSN700_ADTIM_PWM_H
#define __AM_ZSN700_ADTIM_PWM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_pwm.h"
#include "hw/amhw_zsn700_adtim.h"

/**
 * \addtogroup am_zsn700_if_adtim_pwm
 * \copydoc am_zsn700_adtim_pwm.h
 * @{
 */

/* PWM */
#define  AM_ZSN700_ADTIM_PWM_OCPOLARITY_HIGH 0  /**< \brief ߵƽЧ */
#define  AM_ZSN700_ADTIM_PWM_OCPOLARITY_LOW  1  /**< \brief ͵ƽЧ */

/**
 * \brief ͨʶ
 *
 * \note CHA  CHBڵPWMҲڻPWM
 */
#define  AM_ZSN700_ADTIM_PWM_CHA  0x00   /**< \brief PWMͨAʶ*/
#define  AM_ZSN700_ADTIM_PWM_CHB  0x01   /**< \brief PWMͨBʶ*/

/**
 * \brief ADTIMPWMصGPIOϢ
 */
typedef struct am_zsn700_adtim_pwm_chaninfo {
    int8_t   channel;                  /**< \brief PWMʹõͨʶ */
    int8_t   gpio;                     /**< \brief PWMõGPIO */
    uint32_t func;                     /**< \brief PWMܵGPIOֵ */
    uint32_t dfunc;                    /**< \brief PWMģʽĬGPIOֵ */
} am_zsn700_adtim_pwm_chaninfo_t;

/**
 * \brief ADTIMPWMص豸Ϣ
 */
typedef struct am_zsn700_adtim_pwm_devinfo {
    uint32_t                     adtim_regbase;    /**< \brief ADTIMĴַ */

    uint8_t                      channels_num;   /**< \brief ʹõͨΪ2 */

    /** \brief PWMѡ  1PWM   0PWM */
    uint8_t                     comp;

    /** \brief PWM,AM_ZSN700_LPTIM_PWM_OCPOLARITY_HIGHAM_ZSN700_LPTIM_PWM_OCPOLARITY_LOW */
    uint8_t                     ocpolarity;

    am_zsn700_adtim_pwm_chaninfo_t  *p_chaninfo;     /**< \brief ָPWMͨϢṹ */


    /** \brief ƽ̨ʼʱӣŵȹ */
    void                      (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                      (*pfn_plfm_deinit)(void);

} am_zsn700_adtim_pwm_devinfo_t;

/**
 * \brief ADTIMPWM豸ṹ
 */
typedef struct am_zsn700_adtim_pwm_dev {

    am_pwm_serv_t                      pwm_serv;   /**< \brief ׼PWM */

    /** \brief ָADTIM(PWM)豸Ϣָ */
    const am_zsn700_adtim_pwm_devinfo_t *p_devinfo;

    uint8_t                            chan_max;   /**< \brief Чͨ  */

} am_zsn700_adtim_pwm_dev_t;

/**
 * \brief ʼADTIMΪPWM
 *
 * \param[in] p_dev     : ָADTIM(PWM)豸ָ
 * \param[in] p_devinfo : ָADTIM(PWM)豸Ϣָ
 *
 * \return PWM׼ֵΪNULLʱʼʧ
 */
am_pwm_handle_t am_zsn700_adtim_pwm_init(
                    am_zsn700_adtim_pwm_dev_t           *p_dev,
                    const am_zsn700_adtim_pwm_devinfo_t *p_devinfo);

/**
 * \brief ʹADTIMPWMʱʼADTIMPWMܣͷԴ
 *
 * \param[in] handle : am_zsn700_adtim_pwm_init() ʼõPWM
 *
 * \return 
 */
void am_zsn700_adtim_pwm_deinit (am_pwm_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_ADTIM_PWM_H */

/* end of file */
