/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ߼ʱADTIMӿ
 *
 * \internal
 * \par History
 * - 1.00 19-10-08  zp, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZSL42x_ADTIM_H
#define __AMHW_ZSL42x_ADTIM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"
#include "zsl42x_regbase.h"

/**
 * \addtogroup amhw_zsl42x_if_adtim
 * \copydoc amhw_zsl42x_adtim.h
 * @{
 */

/**
 * \brief ʱĴṹ
 */
typedef struct {
    __IO uint32_t cnter;          /**< \brief 0x000 ͨü׼ֵĴ */
    __IO uint32_t perar;          /**< \brief 0x004 ͨڻ׼ֵĴ */
    __IO uint32_t perbr;          /**< \brief 0x008 ͨڻ׼ֵĴ*/
    __IO uint32_t reserve0;       /**< \brief */
    __IO uint32_t gcmxr[4];       /**< \brief 0x010 ͨñȽABCD׼ֵĴ */
    __IO uint32_t reserve1[2];    /**< \brief */
    __IO uint32_t scmxr[2];       /**< \brief 0x028 רñȽAB׼ֵĴ */
    __IO uint32_t reserve2[4];    /**< \brief */
    __IO uint32_t dtuar;          /**< \brief 0x040 ʱ׼ֵĴ */
    __IO uint32_t dtdar;          /**< \brief 0x044 ʱ׼ֵĴ */
    __IO uint32_t reserve3[2];    /**< \brief */
    __IO uint32_t gconr;          /**< \brief 0x050 ͨÿƼĴ */
    __IO uint32_t iconr;          /**< \brief 0x054 жϿƼĴ */
    __IO uint32_t pconr;          /**< \brief 0x058 ˿ڿƼĴ */
    __IO uint32_t bconr;          /**< \brief 0x05C ƼĴ */
    __IO uint32_t dconr;          /**< \brief 0x060 ƼĴ */
    __IO uint32_t reserve4;       /**< \brief */
    __IO uint32_t fconr;          /**< \brief 0x068 ˲ƼĴ */
    __IO uint32_t vperr;          /**< \brief 0x06C ЧڼĴ */
    __IO uint32_t stflr;          /**< \brief 0x070 ״̬־Ĵ */
    __IO uint32_t hstar;          /**< \brief 0x074 Ӳ¼ѡĴ */
    __IO uint32_t hstpr;          /**< \brief 0x078 Ӳֹͣ¼ѡĴ */
    __IO uint32_t hcelr;          /**< \brief 0x07C Ӳ¼ѡĴ */
    __IO uint32_t hcpar;          /**< \brief 0x080 Ӳ¼ѡĴ */
    __IO uint32_t hcpbr;          /**< \brief 0x084 Ӳ¼ѡĴ */
    __IO uint32_t hcupr;          /**< \brief 0x088 Ӳݼ¼ѡĴ */
    __IO uint32_t hcdor;          /**< \brief 0x08C Ӳݼ¼ѡĴ */
    __IO uint32_t reserve5[28];   /**< \brief */
    __IO uint32_t ifr;            /**< \brief 0x100 жϱ־Ĵ */
    __IO uint32_t iclr;           /**< \brief 0x104 жĴ */
    __IO uint32_t cr;             /**< \brief 0x108 չƵжϴѡĴ */
    __IO uint32_t reserve6;       /**< \brief */
    __IO uint32_t aossr;          /**< \brief 0x110 AOSѡĴ,ͨ */
    __IO uint32_t aoscl;          /**< \brief 0x114 AOSɲ־Ĵ,ͨ */
    __IO uint32_t ptbks;          /**< \brief 0x118 ˿ɲƼĴ,ͨ */
    __IO uint32_t ttrig;          /**< \brief 0x11C ˿ڴƼĴ,ͨ */
    __IO uint32_t itrig;          /**< \brief 0x120 AOS ƼĴ,ͨ */
    __IO uint32_t ptbkp;          /**< \brief 0x124 ˿ɲԿƼĴ, ͨ */
    __IO uint32_t reserve7[179];  /**< \brief */
    __IO uint32_t sstar;          /**< \brief 0x3F4 ͬĴ */
    __IO uint32_t sstpr;          /**< \brief 0x3F8 ֹͬͣĴ */
    __IO uint32_t sclrr;          /**< \brief 0x3FC ͬĴ */
}amhw_zsl42x_adtim_t;

/**
 * \brief ADT CHxͨ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_CHX_A = 0u,            /**< CHx Aͨ */
    AMHW_ZSL42x_ADTIM_CHX_B = 1u,            /**< CHx Bͨ */
}amhw_zsl42x_adtim_chx_t;

/**
 * \brief ADT TRIG˿ڶ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_TRIG_PORT_A = 0u,   // TIMx A˿
    AMHW_ZSL42x_ADTIM_TRIG_PORT_B = 1u,   // TIMx B˿
    AMHW_ZSL42x_ADTIM_TRIG_PORT_C = 2u,   // TIMx C˿
    AMHW_ZSL42x_ADTIM_TRIG_PORT_D = 3u,   // TIMx D˿
}amhw_zsl42x_adtim_trig_port_t;

/**
 * \brief ADTͨÿ - Z
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_ZMASK_NO = 0u,  // ZιЧ
    AMHW_ZSL42x_ADTIM_ZMASK_4  = 1u,  // λü4ڵZ뱻
    AMHW_ZSL42x_ADTIM_ZMASK_8  = 2u,  // λü8ڵZ뱻
    AMHW_ZSL42x_ADTIM_ZMASK_16 = 3u,  // λü16ڵZ뱻
}amhw_zsl42x_adtim_zmask_t;

/**
 * \brief ADTͨÿ - ʱѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PCLK_DIV1    = 0ul,  // PCLK0
    AMHW_ZSL42x_ADTIM_PCLK_DIV2    = 1ul,  // PCLK0/2
    AMHW_ZSL42x_ADTIM_PCLK_DIV4    = 2ul,  // PCLK0/4
    AMHW_ZSL42x_ADTIM_PCLK_DIV8    = 3ul,  // PCLK0/8
    AMHW_ZSL42x_ADTIM_PCLK_DIV16   = 4ul,  // PCLK0/16
    AMHW_ZSL42x_ADTIM_PCLK_DIV64   = 5ul,  // PCLK0/64
    AMHW_ZSL42x_ADTIM_PCLK_DIV256  = 6ul,  // PCLK0/256
    AMHW_ZSL42x_ADTIM_PCLK_DIV1024 = 7ul,  // PCLK0/1024
}amhw_zsl42x_adtim_pclk_div_t;

/**
 * \brief ADTģʽ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_CNT_MODE_SAWTOOTH   = 0u,  // ݲģʽ
    AMHW_ZSL42x_ADTIM_CNT_MODE_TRIANGLE_A = 4u,  // ǲAģʽ
    AMHW_ZSL42x_ADTIM_CNT_MODE_TRIANGLE_B = 5u,  // ǲBģʽ
}amhw_zsl42x_adtim_cnt_mode_t;

/**
 * \brief ADT
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_CNT_DIR_DOWN = 0u,        // ݼ
    AMHW_ZSL42x_ADTIM_CNT_DIR_UP   = 1u,        // ݼӼ
}amhw_zsl42x_adtim_cnt_dir_t;

/**
 * \brief ADTͨñȽϻ׼
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_COMPARE_A = 0u,           // ͨñȽϻ׼A
    AMHW_ZSL42x_ADTIM_COMPARE_B = 1u,           // ͨñȽϻ׼B
    AMHW_ZSL42x_ADTIM_COMPARE_C = 2u,           // ͨñȽϻ׼C
    AMHW_ZSL42x_ADTIM_COMPARE_D = 3u,           // ͨñȽϻ׼D
}amhw_zsl42x_adtim_compare_x_t;

/**
 * \brief ADTרñȽϻ׼
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_SPCL_COMP_A = 0u,         // רñȽϻ׼A
    AMHW_ZSL42x_ADTIM_SPCL_COMP_B = 1u,         // רñȽϻ׼B
}amhw_zsl42x_adtim_special_compare_x_t;

/**
 * \brief ADT˿ڿ - TIMx״̬
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_DISVAL_NORM = 0u,  // ǿЧ0~3ʱCHx˿
    AMHW_ZSL42x_ADTIM_DISVAL_HIZ  = 1u,  // ǿЧ0~3ʱCHx˿̬
    AMHW_ZSL42x_ADTIM_DISVAL_LOW  = 2u,  // ǿЧ0~3ʱCHx˿͵ƽ
    AMHW_ZSL42x_ADTIM_DISVAL_HIGH = 3u,  // ǿЧ0~3ʱCHx˿ߵƽ
}amhw_zsl42x_adtim_disval_t;

/**
 * \brief ADT˿ڿ - CHxǿЧѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_DISSEL0 = 0u,      // ѡǿЧ0
    AMHW_ZSL42x_ADTIM_DISSEL1 = 1u,      // ѡǿЧ1
    AMHW_ZSL42x_ADTIM_DISSEL2 = 2u,      // ѡǿЧ2
    AMHW_ZSL42x_ADTIM_DISSEL3 = 3u,      // ѡǿЧ3
}amhw_zsl42x_adtim_dissel_t;

/**
 * \brief ADT˿ڿ - CHxֵƥʱ˿״̬趨
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PERIOD_LOW  = 0u,  // ֵֵʱCHx˿Ϊ͵ƽ
    AMHW_ZSL42x_ADTIM_PERIOD_HIGH = 1u,  // ֵֵʱCHx˿趨Ϊߵƽ
    AMHW_ZSL42x_ADTIM_PERIOD_KEEP = 2u,  // ֵֵʱCHx˿趨Ϊǰ״̬
    AMHW_ZSL42x_ADTIM_PERIOD_INV  = 3u,  // ֵֵʱCHx˿趨Ϊתƽ
}amhw_zsl42x_adtim_perc_t;

/**
 * \brief ADT˿ڿ - CHxȽֵƥʱ˿״̬趨
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_COMPARE_LOW  = 0u, // GCMxRʱCHx˿Ϊ͵ƽ
    AMHW_ZSL42x_ADTIM_COMPARE_HIGH = 1u, // GCMxRʱCHx˿趨Ϊߵƽ
    AMHW_ZSL42x_ADTIM_COMPARE_KEEP = 2u, // GCMxRʱCHx˿趨Ϊǰ״̬
    AMHW_ZSL42x_ADTIM_COMPARE_INV  = 3u, // GCMxRʱCHx˿趨Ϊתƽ
}amhw_zsl42x_adtim_cmpc_t;

/**
  * \brief ADT˿ڿ - CHx˿
  */
typedef enum {
    AMHW_ZSL42x_ADTIM_PORT_OUT_LOW  = 0u, // CHx˿趨Ϊ͵ƽ
    AMHW_ZSL42x_ADTIM_PORT_OUT_HIGH = 1u, // CHx˿趨Ϊߵƽ
}amhw_zsl42x_adtim_port_out_t;

/**
 * \brief ADT˿ڿ - CHx˿ڹģʽѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PORT_MODE_CMP_OUTPUT = 0u, // CHx˿趨ΪȽ
    AMHW_ZSL42x_ADTIM_PORT_MODE_CAP_INPUT  = 1u, // CHx˿趨Ϊ빦
}amhw_zsl42x_adtim_port_mode_t;

/**
 * \brief ADT˿ڿ - CHxʼֹͣ˿״̬ѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_STATE_SEL_SS   = 0u, // ʼֹͣʱCHx˿STACBSTPCB
    AMHW_ZSL42x_ADTIM_STATE_SEL_KEEP = 1u, // ʼֹͣʱCHx˿趨Ϊǰ״̬
}amhw_zsl42x_adtim_stastps_t;

/**
 * \brief ADT - CHx趨
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_DtSeperate = 0u,      // DTUARDTDARֱ趨
    AMHW_ZSL42x_ADTIM_DtEqual    = 1u,      // DTDARֵDTUARֵԶ
}amhw_zsl42x_adtim_sepa_t;

/**
 * \brief ADT˲ - TRIx/TIMxIx˿˲׼ʱѡ
 */
typedef enum
{
    AMHW_ZSL42x_ADTIM_FLTCLK_PCLK_DIV1  = 0u, // PCLK0
    AMHW_ZSL42x_ADTIM_FLTCLK_PCLK_DIV4  = 1u, // PCLK0/4
    AMHW_ZSL42x_ADTIM_FLTCLK_PCLK_DIV16 = 2u, // PCLK0/16
    AMHW_ZSL42x_ADTIM_FLTCLK_PCLK_DIV64 = 3u, // PCLK0/64
}amhw_zsl42x_adtim_fltclk_pclkdiv_t;

/**
 * \brief ADTЧ - TIMxЧѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PeriodCnts0 = 0u,       // ЧѡЧ
    AMHW_ZSL42x_ADTIM_PeriodCnts1 = 1u,       // ÿ1Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts2 = 2u,       // ÿ2Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts3 = 3u,       // ÿ3Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts4 = 4u,       // ÿ4Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts5 = 5u,       // ÿ5Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts6 = 6u,       // ÿ6Чһ
    AMHW_ZSL42x_ADTIM_PeriodCnts7 = 7u,       // ÿ7Чһ
}amhw_zsl42x_adtim_pcnts_t;

/**
 * \brief ADTЧ - ѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PeriodCnteDisable = 0u,  // ЧѡЧ
    AMHW_ZSL42x_ADTIM_PeriodCnteMin     = 1u,  // ݲϡǲΪ
    AMHW_ZSL42x_ADTIM_PeriodCnteMax     = 2u,  // ݲϡǲΪ
    AMHW_ZSL42x_ADTIM_PeriodCnteBoth    = 3u,  // ݲϡǲ壬Ϊ
}amhw_zsl42x_adtim_pcnte_t;

/**
 * \brief ADT˿ڴ - Դѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_TRIG_PA3  = 0u,    // PA3
    AMHW_ZSL42x_ADTIM_TRIG_PB3  = 1u,    // PB3
    AMHW_ZSL42x_ADTIM_TRIG_PC3  = 2u,    // PC3
    AMHW_ZSL42x_ADTIM_TRIG_PD3  = 3u,    // PD3
    AMHW_ZSL42x_ADTIM_TRIG_PA7  = 4u,    // PA7
    AMHW_ZSL42x_ADTIM_TRIG_PB7  = 5u,    // PB7
    AMHW_ZSL42x_ADTIM_TRIG_PC7  = 6u,    // PC7
    AMHW_ZSL42x_ADTIM_TRIG_PD7  = 7u,    // PD7
    AMHW_ZSL42x_ADTIM_TRIG_PA11 = 8u,    // PA11
    AMHW_ZSL42x_ADTIM_TRIG_PB11 = 9u,    // PB11
    AMHW_ZSL42x_ADTIM_TRIG_PC11 = 10u,   // PC11
    AMHW_ZSL42x_ADTIM_TRIG_PD1  = 11u,   // PD1
    AMHW_ZSL42x_ADTIM_TRIG_PA15 = 12u,   // PA15
    AMHW_ZSL42x_ADTIM_TRIG_PB15 = 13u,   // PB15
    AMHW_ZSL42x_ADTIM_TRIG_PC5  = 14u,   // PC5
    AMHW_ZSL42x_ADTIM_TRIG_PD5  = 15u,   // PD5
}amhw_zsl42x_adtim_trigsel_t;

/**
 * \brief ADT AOS - AOSxԴѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim0Int   = 0u,    // TIM0_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim1Int   = 1u,    // TIM1_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim2Int   = 2u,    // TIM2_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelLpTimInt  = 3u,    // LPTIMER_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim4Int   = 4u,    // TIM4_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim5Int   = 5u,    // TIM5_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelTim6Int   = 6u,    // TIM6_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelUart0Int  = 7u,    // UART0_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelUart1Int  = 8u,    // UART1_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelLpUartInt = 9u,    // LPUART_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelVc0Int    = 10u,   // VC0_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelVc1Int    = 11u,   // VC1_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelRtcInt    = 12u,   // RTC_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelPcaInt    = 13u,   // PCA_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelSpiInt    = 14u,   // SPI_INT
    AMHW_ZSL42x_ADTIM_AosxTrigSelAdcInt    = 15u,   // ADC_INT
}amhw_zsl42x_adtim_iaosxs_t;

/**
 * \brief ADTӲ(/ֹͣ//)¼ѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_HwTrigAos0        = 0u,       // AOS¼0Ч
    AMHW_ZSL42x_ADTIM_HwTrigAos1        = 1u,       // AOS¼1Ч
    AMHW_ZSL42x_ADTIM_HwTrigAos2        = 2u,       // AOS¼2Ч
    AMHW_ZSL42x_ADTIM_HwTrigAos3        = 3u,       // AOS¼3Ч
    AMHW_ZSL42x_ADTIM_HwTrigCHxARise    = 4u,       // CHxA˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigCHxAFall    = 5u,       // CHxA˿ϲ½
    AMHW_ZSL42x_ADTIM_HwTrigCHxBRise    = 6u,       // CHxB˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigCHxBFall    = 7u,       // CHxB˿ϲ½
    AMHW_ZSL42x_ADTIM_HwTrigTimTriARise = 8u,       // TIMTRIA˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigTimTriAFall = 9u,       // TIMTRIA˿ϲ½
    AMHW_ZSL42x_ADTIM_HwTrigTimTriBRise = 10u,      // TIMTRIB˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigTimTriBFall = 11u,      // TIMTRIB˿ϲ½
    AMHW_ZSL42x_ADTIM_HwTrigTimTriCRise = 12u,      // TIMTRIC˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigTimTriCFall = 13u,      // TIMTRIC˿ϲ½
    AMHW_ZSL42x_ADTIM_HwTrigTimTriDRise = 14u,      // TIMTRID˿ϲ
    AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall = 15u,      // TIMTRID˿ϲ½
}amhw_zsl42x_adtim_hw_trig_t;

/**
 * \brief ADTӲ(ݼ/ݼ)¼ѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_HwCntCHxALowCHxBRise   = 0u,  // CHxA˿Ϊ͵ƽʱCHxB˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntCHxALowCHxBFall   = 1u,  // CHxA˿Ϊ͵ƽʱCHxB˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntCHxAHighCHxBRise  = 2u,  // CHxA˿ΪߵƽʱCHxB˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntCHxAHighCHxBFall  = 3u,  // CHxA˿ΪߵƽʱCHxB˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntCHxBLowCHxARise   = 4u,  // CHxB˿Ϊ͵ƽʱCHxA˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntCHxBLowCHxAFall   = 5u,  // CHxB˿Ϊ͵ƽʱCHxA˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntCHxBHighChxARise  = 6u,  // CHxB˿ΪߵƽʱCHxA˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntCHxBHighCHxAFall  = 7u,  // CHxB˿ΪߵƽʱCHxA˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntTimTriARise       = 8u,  // TIMTRIA˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntTimTriAFall       = 9u,  // TIMTRIA˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntTimTriBRise       = 10u, // TIMTRIB˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntTimTriBFall       = 11u, // TIMTRIB˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntTimTriCRise       = 12u, // TIMTRIC˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntTimTriCFall       = 13u, // TIMTRIC˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntTimTriDRise       = 14u, // TIMTRID˿ϲ
    AMHW_ZSL42x_ADTIM_HwCntTimTriDFall       = 15u, // TIMTRID˿ϲ½
    AMHW_ZSL42x_ADTIM_HwCntAos0              = 16u, // AOS¼0Ч
    AMHW_ZSL42x_ADTIM_HwCntAos1              = 17u, // AOS¼1Ч
    AMHW_ZSL42x_ADTIM_HwCntAos2              = 18u, // AOS¼2Ч
    AMHW_ZSL42x_ADTIM_HwCntAos3              = 19u, // AOS¼3Ч
}amhw_zsl42x_adtim_hw_cnt_t;

/**
 * \brief ADT˿ɲԿ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PtBrkHigh = 0u,              // ˿ɲԸߵƽЧ
    AMHW_ZSL42x_ADTIM_PtBrkLow  = 1u,              // ˿ɲԵ͵ƽЧ
}amhw_zsl42x_adtim_ptbrk_polarity_t;

/**
 * \brief ADT PWMչƵѡ
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_PwmDitherUnderFlow = 0u,     // PWMչƵ
    AMHW_ZSL42x_ADTIM_PwmDitherOverFlow  = 1u,     // PWMչƵ
}amhw_zsl42x_adtim_pwm_dither_type_t;

/**
 * \brief ADTж
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_CMAIrq  = 0u,                // ƥA򲶻룩ж
    AMHW_ZSL42x_ADTIM_CMBIrq  = 1u,                // ƥB򲶻룩ж
    AMHW_ZSL42x_ADTIM_CMCIrq  = 2u,                // ƥCж
    AMHW_ZSL42x_ADTIM_CMDIrq  = 3u,                // ƥDж
    AMHW_ZSL42x_ADTIM_OVFIrq  = 6u,                // ƥж
    AMHW_ZSL42x_ADTIM_UDFIrq  = 7u,                // ƥж
    AMHW_ZSL42x_ADTIM_DTEIrq  = 8u,                // ʱж
    AMHW_ZSL42x_ADTIM_SAMLIrq = 14u,               // ͬж
    AMHW_ZSL42x_ADTIM_SAMHIrq = 15u,               // ͬж
}amhw_zsl42x_adtim_irq_type_t;

/**
 * \brief ADT־
 */
typedef enum {
    AMHW_ZSL42x_ADTIM_CMAF = 0,                    // ƥA־
    AMHW_ZSL42x_ADTIM_CMBF = 1,                    // ƥB־
    AMHW_ZSL42x_ADTIM_CMCF = 2,                    // ƥC־
    AMHW_ZSL42x_ADTIM_CMDF = 3,                    // ƥD־
    AMHW_ZSL42x_ADTIM_OVFF = 6,                    // ƥ־
    AMHW_ZSL42x_ADTIM_UDFF = 7,                    // ƥ־
    AMHW_ZSL42x_ADTIM_DTEF = 8,                    // ʱ־
    AMHW_ZSL42x_ADTIM_CMSAUF = 9,                  // ϼרñȽϻ׼ֵƥA־
    AMHW_ZSL42x_ADTIM_CMSADF = 10,                 // ¼רñȽϻ׼ֵƥB־
    AMHW_ZSL42x_ADTIM_CMSBUF = 11,                 // ϼרñȽϻ׼ֵƥA־
    AMHW_ZSL42x_ADTIM_CMSBDF = 12,                 // ¼רñȽϻ׼ֵƥB־
    AMHW_ZSL42x_ADTIM_CntDir = 31,                 // 
}amhw_zsl42x_adtim_state_type_t;

/**
 * \brief ADTͬ
 */
typedef struct {
    am_bool_t adtim4;                              // Timer 4
    am_bool_t adtim5;                              // Timer 5
    am_bool_t adtim6;                              // Timer 6
}amhw_zsl42x_adtim_sw_sync_t;

/**
 * \brief ADT AOS
 */
typedef struct {
    amhw_zsl42x_adtim_iaosxs_t   aos0trig_src;     // AOS0Դѡ
    amhw_zsl42x_adtim_iaosxs_t   aos1trig_src;     // AOS1Դѡ
    amhw_zsl42x_adtim_iaosxs_t   aos2trig_src;     // AOS2Դѡ
    amhw_zsl42x_adtim_iaosxs_t   aos3trig_src;     // AOS3Դѡ
}amhw_zsl42x_adtim_aos_trig_cfg_t;

/**
 * \brief ADT жϴ
 */
typedef struct {
    am_bool_t   specilmatch_B_trigdma;  // רñȽϻ׼ֵƥBʹܴDMA
    am_bool_t   specilmatch_A_trigdma;  // רñȽϻ׼ֵƥAʹܴDMA
    am_bool_t   underflow_trigdma;      // ƥʹܴDMA
    am_bool_t   overflow_trigdma;       // ƥʹܴDMA
    am_bool_t   cntmatch_D_trigdma;     // ƥDʹܴDMA
    am_bool_t   cntmatch_C_trigdma;     // ƥCʹܴDMA
    am_bool_t   cntmatch_B_trigdma;     // ƥBʹܴDMA
    am_bool_t   cntmatch_A_trigdma;     // ƥAʹܴDMA
    am_bool_t   specilmatch_B_trig;     // רñȽϻ׼ֵƥBʹܴADC
    am_bool_t   specilmatch_A_trig;     // רñȽϻ׼ֵƥAʹܴADC
    am_bool_t   underflow_trig;         // ƥʹܴADC
    am_bool_t   overflow_trig;          // ƥʹܴADC
    am_bool_t   cntmatch_D_trig;        // ƥDʹܴADC
    am_bool_t   cntmatch_C_trig;        // ƥCʹܴADC
    am_bool_t   cntmatch_B_trig;        // ƥBʹܴADC
    am_bool_t   cntmatch_A_trig;        // ƥAʹܴADC
}amhw_zsl42x_adtim_irq_trig_cfg_t;

/**
 * \brief ADT Trig˿
 */
typedef struct {
    amhw_zsl42x_adtim_trigsel_t        trigsrc;      // Դѡ
    am_bool_t                          flt_enable;   // Դ˲ʹ
    amhw_zsl42x_adtim_fltclk_pclkdiv_t fltclk;       // ˲׼ʱ
}amhw_zsl42x_adtim_port_trig_cfg_t;

/**
 * \brief ADT Zι
 */
typedef struct {
    amhw_zsl42x_adtim_zmask_t zmask_cycle;   // Zμѡ
    am_bool_t                 fltposcntmask; // Zʱڣλü㹦ܲΣFALSE(TRUE)
    am_bool_t                 fltrevcntmask; // ZʱڣתļܲΣFALSE(TRUE)
}amhw_zsl42x_adtim_zmask_cfg_t;

/**
 * \brief ADT TIMxX˿
 */
typedef struct {
    amhw_zsl42x_adtim_port_mode_t portmode;    // ˿ڹģʽ
    am_bool_t                     outenable;   // ʹ
    amhw_zsl42x_adtim_perc_t      perc;        // ֵƥʱ˿״̬
    amhw_zsl42x_adtim_cmpc_t      cmpc;        // Ƚֵƥʱ˿״̬
    amhw_zsl42x_adtim_stastps_t   stastps;     // ʼֹͣ˿״̬ѡ
    amhw_zsl42x_adtim_port_out_t  staout;      // ʼ˿״̬
    amhw_zsl42x_adtim_port_out_t  stpout;      // ֹͣ˿״̬
    amhw_zsl42x_adtim_disval_t    disval;      // ǿЧʱ״̬
    amhw_zsl42x_adtim_dissel_t    dissel;      // ǿЧѡ
    am_bool_t                     fltenable;   // ˿ڲ˲ʹ
    amhw_zsl42x_adtim_fltclk_pclkdiv_t fltclk; // ˿˲׼ʱ
}amhw_zsl42x_adtim_timx_chx_port_cfg_t;

/**
 * \brief ADTɲ˿
 */
typedef struct {
    am_bool_t                          portenable;    // ˿ʹ
    amhw_zsl42x_adtim_ptbrk_polarity_t polaritysel;   // ѡ
}amhw_zsl42x_adtim_break_port_cfg_t;

/**
 * \brief ADTЧ3
 */
typedef struct amhw_zsl42x_adtim_disable_3_cfg
{
    amhw_zsl42x_adtim_break_port_cfg_t stcbrkptcfg[16]; // ɲ˿
    am_bool_t                          fltenable;       // ɲ˿˲ʹ
    amhw_zsl42x_adtim_fltclk_pclkdiv_t fltclk;          // ˲׼ʱ
}amhw_zsl42x_adtim_disable_3_cfg_t;

/**
 * \brief ADTЧ1
 */
typedef struct {
    am_bool_t   tim6_outsh;     // TIM6ͬ
    am_bool_t   tim5_outsh;     // TIM5ͬ
    am_bool_t   tim4_outsh;     // TIM4ͬ
    am_bool_t   tim6_outsl;     // TIM6ͬ
    am_bool_t   tim5_outsl;     // TIM5ͬ
    am_bool_t   tim4_outsl;     // TIM4ͬ
}amhw_zsl42x_adtim_disable_1_cfg_t;

/**
 * \brief ADT PWMչƵ
 */
typedef struct {
    amhw_zsl42x_adtim_pwm_dither_type_t enAMHW_ZSL42x_ADTIM_PDType;// PWMչƵѡ
    am_bool_t   bTimxBPDEn;                      // PWMͨBչƵʹ
    am_bool_t   bTimxAPDEn;                      // PWMͨAչƵʹ
}amhw_zsl42x_adtim_pwm_dither_cfg_t;

/**
 * \brief ADT
 */
typedef struct {
    amhw_zsl42x_adtim_cnt_mode_t cntmode;        // ģʽ
    amhw_zsl42x_adtim_cnt_dir_t  cntdir;         // 
    amhw_zsl42x_adtim_pclk_div_t cntclkdiv;      // ʱѡ
}amhw_zsl42x_adtim_basecnt_cfg_t;

/**
 * \brief ADT״̬
 */
typedef struct {
    uint16_t  u16counter;                        // ǰļֵ
    am_bool_t cntdir;                            // 
    uint8_t   u8validperiod;                     // Чڼ
    am_bool_t cmsbdf;                            // ¼רñȽϻ׼ֵƥB־
    am_bool_t cmsbuf;                            // ϼרñȽϻ׼ֵƥA־
    am_bool_t cmsadf;                            // ¼רñȽϻ׼ֵƥB־
    am_bool_t cmsauf;                            // ϼרñȽϻ׼ֵƥA־
    am_bool_t dtff;                              // ʱ־
    am_bool_t udff;                              // ƥ־
    am_bool_t ovff;                              // ƥ־
    am_bool_t cmdf;                              // ƥD־
    am_bool_t cmcf;                              // ƥC־
    am_bool_t cmbf;                              // ƥB־
    am_bool_t cmaf;                              // ƥA־
}amhw_zsl42x_adtim_cntstate_cfg_t;

/**
 * \brief ADTЧ
 */
typedef struct {
    amhw_zsl42x_adtim_pcnts_t    validcnt;       // Чѡ
    amhw_zsl42x_adtim_pcnte_t    validcdt;       // Чڼ
    am_bool_t                    period_D;       // ͨźЧѡD
    am_bool_t                    period_C;       // ͨźЧѡC
    am_bool_t                    period_B;       // ͨźЧѡB
    am_bool_t                    period_A;       // ͨźЧѡA
}amhw_zsl42x_adtim_validper_cfg_t;

/**
 * \brief Ӳݼ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_cnt_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwcntup(amhw_zsl42x_adtim_t       *p_hw_adtim,
                                       amhw_zsl42x_adtim_hw_cnt_t choice) {

    if(choice > AMHW_ZSL42x_ADTIM_HwCntAos3) {
        return AM_FALSE;
    }

    p_hw_adtim->hcupr |= (1ul << choice);

    return AM_TRUE;
}

/**
 * \brief Ӳݼ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwcntup(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcupr = 0;

    return AM_TRUE;
}

/**
 * \brief Ӳݼ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_cnt_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwcntdown(amhw_zsl42x_adtim_t       *p_hw_adtim,
                                         amhw_zsl42x_adtim_hw_cnt_t choice) {
    if(choice > AMHW_ZSL42x_ADTIM_HwCntAos3) {
        return AM_FALSE;
    }

    p_hw_adtim->hcdor |= (1ul << choice);

    return AM_TRUE;
}

/**
 * \brief Ӳݼ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwcntdown(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcdor = 0;

    return AM_TRUE;
}

/**
 * \brief Ӳ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_trig_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwstart(amhw_zsl42x_adtim_t        *p_hw_adtim,
                                       amhw_zsl42x_adtim_hw_trig_t choice) {
    if(choice > AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall) {
        return AM_FALSE;
    }

    p_hw_adtim->hstar |= (1ul << choice);

    return AM_TRUE;
}

/**
 * \brief Ӳ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwstart(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hstar = 0;

    return AM_TRUE;
}

/**
 * \brief ʹӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_enablehwstart(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hstar |= (1ul << 31);

    return AM_TRUE;
}

/**
 * \brief ֹӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_disablehwstart(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hstar &= ~(1ul << 31);

    return AM_TRUE;
}

/**
 * \brief Ӳֹͣ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_trig_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwstop(amhw_zsl42x_adtim_t        *p_hw_adtim,
                                      amhw_zsl42x_adtim_hw_trig_t choice) {

    if(choice > AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall) {
        return AM_FALSE;
    }

    p_hw_adtim->hstpr |= (1ul << choice);

    return AM_TRUE;
}

/**
 * \brief Ӳֹͣ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwstop(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hstpr = 0;

    return AM_TRUE;
}

/**
 * \brief ʹӲֹͣ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_enablehwstop(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hstpr |= (1ul << 31);

    return AM_TRUE;
}

/**
 * \brief ֹӲֹͣ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_disablehwstop(amhw_zsl42x_adtim_t *p_hw_adtim){

    p_hw_adtim->hstpr &= ~(1ul << 31);

    return AM_TRUE;
}

/**
 * \brief Ӳ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_trig_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwclear(amhw_zsl42x_adtim_t        *p_hw_adtim,
                                       amhw_zsl42x_adtim_hw_trig_t choice) {

    if(choice > AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall) {
        return AM_FALSE;
    }

    p_hw_adtim->hcelr |= (1ul << choice);

    return AM_TRUE;
}

/**
 * \brief Ӳ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwclear(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcelr = 0;

    return AM_TRUE;
}

/**
 * \brief ʹӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_enablehwclear(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcelr |= (1ul << 31);

    return AM_TRUE;
}

/**
 * \brief ֹӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_disablehwclear(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcelr &= ~(1ul << 31);

    return AM_TRUE;
}

/**
 * \brief AͨӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_trig_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwcaptureA(amhw_zsl42x_adtim_t        *p_hw_adtim,
                                          amhw_zsl42x_adtim_hw_trig_t choice) {

    if(choice > AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall) {
        return AM_FALSE;
    }

    p_hw_adtim->hcpar |= (1ul << choice);
    p_hw_adtim->pconr |= (1ul << 0 );

    return AM_TRUE;
}

/**
 * \brief AͨӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwcaptureA(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcpar = 0;

    return AM_TRUE;
}

/**
 * \brief BͨӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] choice     : amhw_zsl42x_adtim_hw_trig_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfghwcaptureB(amhw_zsl42x_adtim_t        *p_hw_adtim,
                                          amhw_zsl42x_adtim_hw_trig_t choice) {

    if(choice > AMHW_ZSL42x_ADTIM_HwTrigTimTriDFall) {
        return AM_FALSE;
    }

    p_hw_adtim->hcpbr |= (1ul << choice);
    p_hw_adtim->pconr |= (1ul << 16 );

    return AM_TRUE;
}

/**
 * \brief BͨӲ¼
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearhwcaptureB(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->hcpbr = 0;

    return AM_TRUE;
}

/**
 * \brief ͬ
 *
 * \param[in] p_cfg : ָADTͬýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_swsyncstart(amhw_zsl42x_adtim_sw_sync_t *p_cfg) {

    if(p_cfg->adtim4) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstar = (1ul << 0);
    }

    if(p_cfg->adtim5) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstar = (1ul << 1);
    }

    if(p_cfg->adtim6) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstar = (1ul << 2);
    }

    return AM_TRUE;
}

/**
 * \brief ֹͬͣ
 *
 * \param[in] p_cfg : ָADTͬýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_swsyncstop(amhw_zsl42x_adtim_sw_sync_t *p_cfg) {

    if(p_cfg->adtim4) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstpr = (1ul << 0);
    }
    if(p_cfg->adtim5) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstpr = (1ul << 1);
    }
    if(p_cfg->adtim6) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sstpr = (1ul << 2);
    }

    return AM_TRUE;
}

/**
 * \brief ͬ
 *
 * \param[in] p_cfg : ָADTͬýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_swsyncclear(amhw_zsl42x_adtim_sw_sync_t *p_cfg) {

    if(p_cfg->adtim4) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sclrr = (1ul << 0);
    }
    if(p_cfg->adtim5) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sclrr = (1ul << 1);
    }
    if(p_cfg->adtim6) {
        ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->sclrr = (1ul << 2);
    }

    return AM_TRUE;
}

/**
 * \brief ȡͬ״̬
 *
 * \param[in] p_cfg : ָADTͬýṹָ
 *
 * \return AM_FALSE ȡʧ
 *         AM_TRUE  ȡɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setswsyncstate(amhw_zsl42x_adtim_sw_sync_t *p_cfg) {

    amhw_zsl42x_adtim_t *p_hw_adtim4 = (amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE;

    p_cfg->adtim4 = (p_hw_adtim4->sstar >> 0) & 1ul ? AM_TRUE : AM_FALSE;
    p_cfg->adtim5 = (p_hw_adtim4->sstar >> 1) & 1ul ? AM_TRUE : AM_FALSE;
    p_cfg->adtim6 = (p_hw_adtim4->sstar >> 2) & 1ul ? AM_TRUE : AM_FALSE;

    return AM_TRUE;
}

/**
 * \brief AOS
 *
 * \param[in] p_cfg : ָAOSýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_aostrigcfg(amhw_zsl42x_adtim_aos_trig_cfg_t *p_cfg){

    amhw_zsl42x_adtim_t *p_hw_adtim4 = (amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE;

    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim4->itrig  = 0;
    p_hw_adtim4->itrig |= (p_cfg->aos0trig_src << 0);
    p_hw_adtim4->itrig |= (p_cfg->aos1trig_src << 4);
    p_hw_adtim4->itrig |= (p_cfg->aos2trig_src << 8);
    p_hw_adtim4->itrig |= (p_cfg->aos3trig_src << 12);

    return AM_TRUE;
}

/**
 * \brief жϴʹ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] p_cfg      : ָжʹýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_bool_t amhw_zsl42x_adtim_irqtrigcfg(
              amhw_zsl42x_adtim_t              *p_hw_adtim,
              amhw_zsl42x_adtim_irq_trig_cfg_t *p_cfg);

/**
 * \brief ˿ڴ
 *
 * \param[in] trigport : amhw_zsl42x_adtim_trig_port_t˿ö
 * \param[in] p_cfg    : ָ˿ýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_bool_t amhw_zsl42x_adtim_porttrigcfg(
              amhw_zsl42x_adtim_trig_port_t      trigport,
              amhw_zsl42x_adtim_port_trig_cfg_t *p_cfg);

/**
 * \brief CHxX˿
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] port       : amhw_zsl42x_adtim_chx_tͨö
 * \param[in] p_cfg      : ָTIMxX˿ýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_bool_t amhw_zsl42x_adtim_timxchxportcfg(
              amhw_zsl42x_adtim_t                   *p_hw_adtim,
              amhw_zsl42x_adtim_chx_t                port,
              amhw_zsl42x_adtim_timx_chx_port_cfg_t *p_cfg);

/**
 * \brief ʹܶ˿ɲ
 *
 * \param[in] port       : ˿ڱţ0~15
 * \param[in] p_cfg      : ָTADTɲ˿ýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_enablebrakeport(
              uint8_t                             port,
              amhw_zsl42x_adtim_break_port_cfg_t *p_cfg) {

    amhw_zsl42x_adtim_t *p_hw_adtim4 = (amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE;

    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim4->ptbkp &= ~(1ul << port);
    p_hw_adtim4->ptbkp |= (p_cfg->polaritysel << port);
    p_hw_adtim4->ptbks |= (1ul << port);

    return AM_TRUE;
}

/**
 * \brief ˿ɲ
 */
am_static_inline
void amhw_zsl42x_adtim_clearbrakeport(void) {

    ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->ptbks = 0;
}

/**
 * \brief Ч3(˿ɲ)
 *
 * \param[in] p_cfg      : ָTADTЧ3ýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_bool_t amhw_zsl42x_adtim_disable3cfg(
              amhw_zsl42x_adtim_disable_3_cfg_t *p_cfg);

/**
 * \brief ɲ Enable/Disable(Ч3ʹܵ)
 *
 * \param[in] flag      : AM_FALSE()        AM_TRUE(ʹ)
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_swbrake(am_bool_t flag) {

    amhw_zsl42x_adtim_t *p_hw_adtim4 = (amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE;

    p_hw_adtim4->aossr &= ~(1ul << 7);
    p_hw_adtim4->aossr |= (flag << 7);

    return AM_TRUE;
}

/**
 * \brief ȡ˿ɲ־
 *
 * \return AM_FALSE ״̬
 *         AM_TRUE  ʹ״̬
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_getportbrakeflag(void) {
    return ((((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->aossr >> 0) & 1ul) ?
           AM_TRUE :
           AM_FALSE;
}

/**
 * \brief ˿ɲ־
 *
 */
am_static_inline
void amhw_zsl42x_adtim_clearportbrakeflag(void) {

    ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->aoscl &= ~(1ul << 0);
}

/**
 * \brief Ч1(ͬͬɲ)
 *
 * \param[in] p_cfg : ָTADTЧ1ýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_disable1Cfg(
              amhw_zsl42x_adtim_disable_1_cfg_t *p_cfg) {

    amhw_zsl42x_adtim_t *p_hw_adtim4 = (amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE;

    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 13))) |
                         (p_cfg->tim6_outsh << 13);
    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 12))) |
                         (p_cfg->tim5_outsh << 12);
    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 11))) |
                         (p_cfg->tim4_outsh << 11);
    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 10))) |
                         (p_cfg->tim6_outsl << 10);
    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 9))) |
                         (p_cfg->tim5_outsl << 9);
    p_hw_adtim4->aossr = (p_hw_adtim4->aossr & (~(1ul << 8))) |
                         (p_cfg->tim4_outsl << 8);

    return AM_TRUE;
}

/**
 * \brief ȡͬͬɲ־
 *
 * \return AM_FALSE 0
 *         AM_TRUE  1
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_getsamebrakeflag(void) {
    return ((((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->aossr >> 1) & 1ul) ?
           AM_TRUE :
           AM_FALSE;
}

/**
 * \brief ͬͬɲ־
 *
 */
am_static_inline
void amhw_zsl42x_adtim_clearsamebrakeflag(void) {
    ((amhw_zsl42x_adtim_t *)ZSL42x_TIM4_BASE)->aoscl &= ~(1ul << 1);
}

/**
 * \brief PWMչƵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] p_cfg      : ָPWMչƵýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_pwmdithercfg(
              amhw_zsl42x_adtim_t                *p_hw_adtim,
              amhw_zsl42x_adtim_pwm_dither_cfg_t *p_cfg) {
    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim->cr = (p_hw_adtim->cr & (~(1ul << 10))) |
                     (p_cfg->enAMHW_ZSL42x_ADTIM_PDType << 10);
    p_hw_adtim->cr = (p_hw_adtim->cr & (~(1ul << 9))) |
                     (p_cfg->bTimxBPDEn << 9);
    p_hw_adtim->cr = (p_hw_adtim->cr & (~(1ul << 8))) |
                     (p_cfg->bTimxAPDEn << 8);

    return AM_TRUE;
}

/**
 * \brief ADTIMʼ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] p_cfg      : ָADTýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_init(amhw_zsl42x_adtim_t             *p_hw_adtim,
                                 amhw_zsl42x_adtim_basecnt_cfg_t *p_cfg) {
    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    if((p_cfg->cntmode) > AMHW_ZSL42x_ADTIM_CNT_MODE_TRIANGLE_B) {
        return AM_FALSE;
    }

    p_hw_adtim->gconr &= ~(7ul << 1);
    p_hw_adtim->gconr &= ~(7ul << 4);
    p_hw_adtim->gconr &= ~(1ul << 8);

    p_hw_adtim->gconr |= (p_cfg->cntmode << 1);
    p_hw_adtim->gconr |= (p_cfg->cntclkdiv << 4);
    p_hw_adtim->gconr |= (p_cfg->cntdir << 8);

    return AM_TRUE;
}

am_static_inline
amhw_zsl42x_adtim_pclk_div_t
amhw_zsl42x_adtim_clkdiv_get(amhw_zsl42x_adtim_t *p_hw_adtim) {

    return (amhw_zsl42x_adtim_pclk_div_t)((p_hw_adtim->gconr >> 4) & 7ul);
}


/**
 * \brief ADTIMȥʼ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_bool_t amhw_zsl42x_adtim_deinit(amhw_zsl42x_adtim_t *p_hw_adtim);

/**
 * \brief ADTIM
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_startcount(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->gconr |= (1ul << 0);

    return AM_TRUE;
}

/**
 * \brief ADTIMֹͣ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_stopcount(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->gconr &= ~(1ul << 0);

    return AM_TRUE;
}

/**
 * \brief üֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] cnt         ֵ趨
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setcount(amhw_zsl42x_adtim_t *p_hw_adtim,
                                     uint16_t             cnt) {

    p_hw_adtim->cnter = cnt;

    return AM_TRUE;
}

/**
 * \brief ȡֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return ֵ
 */
am_static_inline
uint16_t amhw_zsl42x_adtim_getcount(amhw_zsl42x_adtim_t *p_hw_adtim) {
    return p_hw_adtim->cnter;
}

/**
 * \brief ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearcount(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->cnter = 0;

    return AM_TRUE;
}

/**
 * \brief ȡЧڼֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return Чڼֵ
 */
am_static_inline
uint8_t amhw_zsl42x_adtim_getvpernum(amhw_zsl42x_adtim_t *p_hw_adtim) {
    return ((p_hw_adtim->stflr >> 21) & 0x7ul);
}

/**
 * \brief ȡ״̬־
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] type       : amhw_zsl42x_adtim_state_type_t״̬־ö
 *
 * \return AM_FALSE ־Ч
 *         AM_TRUE  ־Ч
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_getstate(amhw_zsl42x_adtim_t           *p_hw_adtim,
                                     amhw_zsl42x_adtim_state_type_t type) {
    return ((p_hw_adtim->stflr >> type) & 1ul) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief ü
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] data       : 趨ֵ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setperiod(amhw_zsl42x_adtim_t *p_hw_adtim,
                                      uint16_t             data) {

    p_hw_adtim->perar = data;

    return AM_TRUE;
}

/**
 * \brief ȡ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return 
 */
am_static_inline
uint16_t amhw_zsl42x_adtim_getperiod(amhw_zsl42x_adtim_t *p_hw_adtim) {

    return p_hw_adtim->perar;
}

/**
 * \brief üڻ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] data       : ڻ趨ֵ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setperiodbuf(amhw_zsl42x_adtim_t *p_hw_adtim,
                                         uint16_t             data) {
    p_hw_adtim->perbr  = data;
    p_hw_adtim->bconr |= (1ul << 8);

    return AM_TRUE;
}

/**
 * \brief ڻ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearperiodbuf(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->bconr &= ~(1ul << 8);
    p_hw_adtim->perbr  = 0;

    return AM_TRUE;
}

/**
 * \brief Ч
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] p_cfg      : ָADTЧýṹָ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setvalidperiod(
              amhw_zsl42x_adtim_t              *p_hw_adtim,
              amhw_zsl42x_adtim_validper_cfg_t *p_cfg) {
    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim->vperr  = 0;
    p_hw_adtim->vperr |= (p_cfg->validcnt << 18);
    p_hw_adtim->vperr |= (p_cfg->validcdt << 16);
    p_hw_adtim->vperr |= (p_cfg->period_D << 3);
    p_hw_adtim->vperr |= (p_cfg->period_C << 2);
    p_hw_adtim->vperr |= (p_cfg->period_B << 1);
    p_hw_adtim->vperr |= (p_cfg->period_A << 0);

    return AM_TRUE;
}

/**
 * \brief ñȽ׼ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] compare    : amhw_zsl42x_adtim_compare_x_tö
 * \param[in] data       : 趨ֵ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setcomparevalue(
              amhw_zsl42x_adtim_t          *p_hw_adtim,
              amhw_zsl42x_adtim_compare_x_t compare,
              uint16_t                      data) {

    switch(compare) {
    case AMHW_ZSL42x_ADTIM_COMPARE_A:
        p_hw_adtim->gcmxr[0] = data;
        break;
    case AMHW_ZSL42x_ADTIM_COMPARE_B:
        p_hw_adtim->gcmxr[1] = data;
        break;
    case AMHW_ZSL42x_ADTIM_COMPARE_C:
        p_hw_adtim->gcmxr[2] = data;
        break;
    case AMHW_ZSL42x_ADTIM_COMPARE_D:
        p_hw_adtim->gcmxr[3] = data;
        break;
    default:
        return AM_FALSE;
    }

    return AM_TRUE;
}

/**
 * \brief רñȽϼ׼ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] compare    : amhw_zsl42x_adtim_special_compare_x_tö
 * \param[in] data       : 趨ֵ
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setspecilcomparevalue(
              amhw_zsl42x_adtim_t                  *p_hw_adtim,
              amhw_zsl42x_adtim_special_compare_x_t compare,
              uint16_t                              data) {
    switch(compare) {
    case AMHW_ZSL42x_ADTIM_SPCL_COMP_A:
        p_hw_adtim->scmxr[0] = data;
        break;
    case AMHW_ZSL42x_ADTIM_SPCL_COMP_B:
        p_hw_adtim->scmxr[1] = data;
        break;
    default:
        return AM_FALSE;
    }

    return AM_TRUE;
}

/**
 * \brief ͨñȽֵ/ֵĻ洫
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] compare    : amhw_zsl42x_adtim_chx_tö
 * \param[in] enable     : ʹ״̬AM_FALSEAM_TRUE
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_enablevaluebuf(amhw_zsl42x_adtim_t    *p_hw_adtim,
                                           amhw_zsl42x_adtim_chx_t port,
                                           am_bool_t               enable) {
    switch(port) {
    case AMHW_ZSL42x_ADTIM_CHX_A:
        p_hw_adtim->bconr = (p_hw_adtim->bconr & (~(1ul << 0))) |
                            (enable << 0);
        break;
    case AMHW_ZSL42x_ADTIM_CHX_B:
        p_hw_adtim->bconr = (p_hw_adtim->bconr & (~(1ul << 2))) |
                            (enable << 2);
        break;
    default:
        return AM_FALSE;
    }

    return AM_TRUE;
}

/**
 * \brief Ƚֵ/ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] port       : amhw_zsl42x_adtim_chx_tö
 *
 * \return AM_FALSE ʧ
 *         AM_TRUE  óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearvaluebuf(amhw_zsl42x_adtim_t    *p_hw_adtim,
                                          amhw_zsl42x_adtim_chx_t port) {
    switch(port) {
    case AMHW_ZSL42x_ADTIM_CHX_A:
        p_hw_adtim->gcmxr[2] = 0;
        break;
    case AMHW_ZSL42x_ADTIM_CHX_B:
        p_hw_adtim->gcmxr[3] = 0;
        break;
    default:
        return AM_FALSE;
    }

    return AM_TRUE;
}

/**
 * \brief ȡֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] port       : amhw_zsl42x_adtim_chx_tö
 *
 * \return ֵ
 */
am_static_inline
uint16_t amhw_zsl42x_adtim_getcapturevalue(amhw_zsl42x_adtim_t    *p_hw_adtim,
                                           amhw_zsl42x_adtim_chx_t port) {
    switch(port) {
    case AMHW_ZSL42x_ADTIM_CHX_A:
        return p_hw_adtim->gcmxr[0];
    case AMHW_ZSL42x_ADTIM_CHX_B:
        return p_hw_adtim->gcmxr[1];
    default:
        return AM_FALSE;
    }
}

/**
 * \brief ȡ񻺴ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] port       : amhw_zsl42x_adtim_chx_tö
 *
 * \return 񻺴ֵ
 */
am_static_inline
uint16_t amhw_zsl42x_adtim_getcapturebuf(amhw_zsl42x_adtim_t     *p_hw_adtim,
                                          amhw_zsl42x_adtim_chx_t port) {
    switch(port) {
    case AMHW_ZSL42x_ADTIM_CHX_A:
        return p_hw_adtim->gcmxr[2];
    case AMHW_ZSL42x_ADTIM_CHX_B:
        return p_hw_adtim->gcmxr[3];
    default:
        return AM_FALSE;
    }
}

/**
 * \brief ʱϻ׼ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] data       : 趨ֵ
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setdtua(amhw_zsl42x_adtim_t *p_hw_adtim,
                                    uint16_t             data) {
    p_hw_adtim->dtuar = data;

    return AM_TRUE;
}

/**
 * \brief ʱ»׼ֵ
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] data       : 趨ֵ
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_setdtda(amhw_zsl42x_adtim_t *p_hw_adtim,
                                    uint16_t data) {
    p_hw_adtim->dtdar = data;

    return AM_TRUE;
}

/**
 * \brief ʱ书
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] enable     : ʹܣAM_FALSEAM_TRUE
 * \param[in] equal      : DTDARֵDTUARֵԶʹܣAM_FALSEAM_TRUE
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfgdt(amhw_zsl42x_adtim_t *p_hw_adtim,
                                  am_bool_t            enable,
                                  am_bool_t            equal) {

    p_hw_adtim->dconr = (p_hw_adtim->dconr &(~(1ul << 0))) |
                        (enable << 0);

    p_hw_adtim->dconr = (p_hw_adtim->dconr &(~(1ul << 8))) |
                        (equal << 8);

    return AM_TRUE;
}

/**
 * \brief ж
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] type       : amhw_zsl42x_adtim_irq_type_tжö
 * \param[in] equal      : ӦжʹܣAM_FALSEAM_TRUE
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfgirq(amhw_zsl42x_adtim_t         *p_hw_adtim,
                                   amhw_zsl42x_adtim_irq_type_t type,
                                   am_bool_t                    enable) {
    if(enable == AM_TRUE) {
        p_hw_adtim->iconr |= (1ul << type);
    } else {
        p_hw_adtim->iconr &= ~(1ul << type);
    }

    return AM_TRUE;
}

/**
 * \brief ȡжϱ־
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] type       : amhw_zsl42x_adtim_irq_type_tжö
 *
 * \return AM_FALSE:־Ч
 *         AM_TRUE :־Ч
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_getirqflag(amhw_zsl42x_adtim_t         *p_hw_adtim,
                                       amhw_zsl42x_adtim_irq_type_t type) {
    return ((p_hw_adtim->ifr >> type) & 1ul) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief жϱ־
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] type       : amhw_zsl42x_adtim_irq_type_tжö
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearirqflag(amhw_zsl42x_adtim_t         *p_hw_adtim,
                                         amhw_zsl42x_adtim_irq_type_t type) {
    p_hw_adtim->iclr &= ~(1ul << type);

    return AM_TRUE;
}

/**
 * \brief жϱ־
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_clearallirqflag(amhw_zsl42x_adtim_t *p_hw_adtim) {

    p_hw_adtim->iclr = 0;

    return AM_TRUE;
}

/**
 * \brief Z
 *
 * \param[in] p_hw_adtim : ָADTIMʱĴָ
 * \param[in] p_cfg      : ָZιýṹָ
 *
 * \return AM_FALSE:ʧ
 *         AM_TRUE :óɹ
 */
am_static_inline
am_bool_t amhw_zsl42x_adtim_cfgzmask(amhw_zsl42x_adtim_t           *p_hw_adtim,
                                     amhw_zsl42x_adtim_zmask_cfg_t *p_cfg) {
    if(p_cfg == NULL) {
        return AM_FALSE;
    }

    p_hw_adtim->gconr = (p_hw_adtim->gconr & (~(3ul << 18))) |
                        (p_cfg->zmask_cycle << 18);

    p_hw_adtim->gconr = (p_hw_adtim->gconr & (~(1ul << 17))) |
                        (p_cfg->fltposcntmask << 17);

    p_hw_adtim->gconr = (p_hw_adtim->gconr & (~(1ul << 16))) |
                        (p_cfg->fltrevcntmask << 16);

    return AM_TRUE;
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZSL42x_ADTIM_H */

/* end of file */
