/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief AESAES׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 20-03-08
 * \endinternal
 */
#ifndef __AM_ZSN700_AES_H
#define __AM_ZSN700_AES_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/**
 * \brief AESԿ
 */
#define AM_ZSN700_AES_KEY_LEN_128_BIT    0    /**< \brief 128λԿ */
#define AM_ZSN700_AES_KEY_LEN_192_BIT    1    /**< \brief 192λԿ */
#define AM_ZSN700_AES_KEY_LEN_256_BIT    2    /**< \brief 256λԿ */

/**
 * \addtogroup am_zsn700_if_aes
 * \copydoc am_zsn700_aes.h
 * @{
 */
/**
 * \brief aes豸Ϣṹ
 */
typedef struct am_zsn700_aes_info {

    uint32_t    reg_base;  /**< \brief AESĴַ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);
}am_zsn700_aes_devinfo_t;

/**
 * \brief AES豸ʵ
 */
typedef struct am_zsn700_aes_dev {

    /** \brief ָAES豸Ϣָ */
    const am_zsn700_aes_devinfo_t *p_devinfo;

} am_zsn700_aes_dev_t;

/** \brief aes׼Ͷ */
typedef am_zsn700_aes_dev_t *am_aes_handle_t;

/**
 * \brief AES ʼ
 *
 * \param[in] p_dev     :AES豸ʼʵ
 * \param[in] p_devinfo :AES豸Ϣʼʵ
 *
 * \retval :
 *
 */
am_aes_handle_t am_zsn700_aes_init(am_zsn700_aes_dev_t           *p_dev,
                                   const am_zsn700_aes_devinfo_t *p_devinfo);

/**
 * \brief AES ȥʼ
 *
 * \param[in] handle     :AES׼豸
 *
 * \retval :
 *
 */
void am_zsn700_aes_deinit (am_aes_handle_t handle);

/**
 * \brief AES 
 *
 * \param[in] : handle ׼AES
 * \param[in] : key_len Կ
 * \param[in] : p_aes_data 
 * \param[in] : p_key_data Կ
 * \param[in] : p_ency_data ݻ
 *
 * \retval : AM_ERROR ɹ
 *           AM_ERROR ʧ
 */
uint32_t am_zsn700_aes_encrypt (am_aes_handle_t handle,
                                uint8_t         key_len,
                                uint32_t       *p_aes_data,
                                uint32_t       *p_key_data,
                                uint32_t       *p_ency_data);

/**
 * \brief AES 
 *
 * \param[in] : handle ׼AES
 * \param[in] : key_len Կ
 * \param[in] : p_ency_data 
 * \param[in] : p_key_data Կ
 * \param[in] : p_decy_data ݻ
 *
 * \retval : AM_OK 
 *           AM_ERROR ʧ
 */
uint32_t am_zsn700_aes_decrypt (am_aes_handle_t handle,
                                uint8_t         key_len,
                                uint32_t       *p_aes_data,
                                uint32_t       *p_key_data,
                                uint32_t       *p_decy_data);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_AES_H */

/* end of file */
