/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ݼĴӿ
 *
 * \internal
 * \par History
 * - 1.00 17-04-17  nwt, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZLG_BKP_H
#define __AMHW_ZLG_BKP_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/**
 * \addtogroup amhw_zlg_if_bkp
 * \copydoc amhw_zlg_bkp.h
 * @{
 */

/** \brief CSR register CTE bit mask */
#define AMHW_BKP_CSR_CTE_SET       ((uint16_t)0x0001)

/** \brief CSR register CTI bit mask */
#define AMHW_BKP_CSR_CTI_SET       ((uint16_t)0x0002)

/**
  * \brief ϵͳƼĴṹ
  */
typedef struct amhw_zlg_bkp {
    __I  uint32_t reserve;        /**< \brief  */
    __IO uint32_t reserve_dr[10]; /**< \brief ݼĴ.() */
    __IO uint32_t rtc_cr;         /**< \brief rtcƼĴ */
    __IO uint32_t cr;             /**< \brief BKPƼĴ */
    __IO uint32_t csr;            /**< \brief ʱӼ״̬Ĵ */
    __I  uint32_t reserve1[6];    /**< \brief  */
    __IO uint32_t dr[10];         /**< \brief ݼĴ, offest 0x50 */
} amhw_zlg_bkp_t;

/**
 * \brief Clears Tamper Pin Event pending flag.
 *
 * \param[in] p_hw_bkp : ָϵͳüĴָ
 * \param[in] flag     : see AMHW_BKP_CSR_CTE_SET or AMHW_BKP_CSR_CTI_SET
 *
 * \return None
 */
am_static_inline
void amhw_zlg_bkp_clear_flag (amhw_zlg_bkp_t *p_hw_bkp, uint32_t flag)
{
    /* Set CTE bit to clear Tamper Pin Event flag */
    p_hw_bkp->csr |= flag;
}

/**
 * \brief дݼĴ
 *
 * \param[in] p_hw_bkp ָϵͳüĴָ
 * \param[in] index    : ݼĴֵΪ 0 ~ 9
 * \param[in] value    : д뱸ݼĴֵֵΪ 0 ~ 65536
 *
 * \return 
 */
am_static_inline
void amhw_zlg_bkp_dr_write (amhw_zlg_bkp_t    *p_hw_bkp,
                            uint8_t            index,
                            uint16_t           value)
{
    p_hw_bkp->dr[index] = value;
}

/**
 * \brief дݼĴ
 *
 * \param[in] index    : ݼĴֵΪ 0 ~ 9
 * \param[in] p_hw_bkp ָϵͳüĴָ
 *
 * \return ضӦݼĴֵ
 */
am_static_inline
uint32_t amhw_zlg_bkp_dr_read (amhw_zlg_bkp_t *p_hw_bkp, uint8_t index)
{
    return (p_hw_bkp->dr[index]);
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZLG_BKP_H */

/* end of file */
