/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader flashbootloaderflash׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-21  yrh, first implementation
 * \endinternal
 */

#ifndef __AM_ZSN700_BOOT_FLASH_H
#define __AM_ZSN700_BOOT_FLASH_H

#include "am_zsn700_flash.h"
#include "am_boot.h"
#include "am_boot_flash.h"

typedef struct am_zsn700_boot_flash_devinfo {
    /**< \brief flashϢ */
    am_boot_flash_info_t  base_info;
    /**< \brief flashĴַ */
    uint32_t              flash_reg_rebese;
    /**< \brief ƽ̨ʼ */
    void                (*pfn_plfm_init)(void);
    /**< \brief ƽ̨ȥʼ */
    void                (*pfn_plfm_deinit)(void);

} am_zsn700_boot_flash_devinfo_t;

typedef struct am_zsn700_boot_flash_dev {
    /**< \brief flash׼ */
    am_boot_flash_serv_t             flash_serv;
    /**< \brief flashĴṹ */
    amhw_zsn700_flash_t             *amhw_zsn700_flash;
    /**< \brief 豸Ϣṹ */
    am_zsn700_boot_flash_devinfo_t  *p_devinfo;
}am_zsn700_boot_flash_dev_t;

/**
 * \brief ʼflashflash׼
 *
 * \param[in] p_dev     : ָflash豸ָ
 * \param[in] p_devinfo : ָflash豸Ϣָ
 *
 * \return flash׼ֵΪNULLʱʼʧ
 */
am_boot_flash_handle_t am_zsn700_boot_flash_init(am_zsn700_boot_flash_dev_t     *p_dev,
                                                 am_zsn700_boot_flash_devinfo_t *p_devinfo);


#endif /* __AM_ZSN700_BOOT_FLASH_H */

/* end of file */
