/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief CAN豸Ϣ
 *
 * \internal
 * \par Modification history
 * - 1.00 19-07-31  zc, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG237_CAN_H
#define __AM_ZLG237_CAN_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_can.h"
#include "amhw_zlg237_can.h"

/**
 * \addtogroup am_zlg237_if_can
 * \copydoc am_zlg237_can.h
 * @{
 */


/**
 * \brief can ʼϢ
 */
typedef struct am_zlg237_can_init_info {

    /** \brief 0 ͨģʽ   1 ػģʽ */
    amhw_zlg237_can_test_mode_t     can_mode;

    /** \brief ʱ䴥ͨģʽ  0 Ǵ  1  */
    am_bool_t   can_ttcm;

    /** \brief Զ߹
     *   0 MCRINRQλá1  塮0 һӲ⵽12811λλ˳ģʽ
     *   1 һӲ⵽12811λλ˳ģʽ
     */
    am_bool_t   can_abom;

    /** \brief Զģʽ
     *   0 ˯ģʽͨCAN_MCRSLEEPλ  
     *   1 ˯ģʽͨCANģӲԶѡѵͬʱӲԶCAN_MSR SLEEPSLAK塮0
     */
    am_bool_t   can_awum;

    /** \brief ֹԶش
     *   0 Ӳڷͱʧʱһֱشͳɹ
     *   1 CANֻһ
     */
    am_bool_t   can_nart;

    /** \brief FIFOģʽ
     *   0 ڽʱFIFOδFIFOıδһյıĻḲԭеı
     *   1 ڽʱFIFOFIFOıδһյıĻᱻ
     */
    am_bool_t   can_rflm;

    /** \brief FIFOȼ
     *   0 ȼɱĵıʶ
     *   1 ȼɷ˳
     */
    am_bool_t   can_txfp;

}am_zlg237_can_init_info_t;

/**<brief ˲Ϣ  */
typedef struct {
    uint8_t  can_fliter_fifo;        /** <brief FIFO 0 FIFO0 1 FIFO1*/
    uint8_t  can_filter_mode;        /** <brief ˲ģʽ 0 ʶλ  1 ʶбλ  */
    uint8_t  can_filter_scale;       /** <brief ˲λ 0 216λ   1 32λ*/
    uint8_t  filter_state;           /** <brief ˲״̬  0  1  */

}amhw_zlg237_can_filter_t;

/**
 * \brief жϻصϢ
 */
typedef struct am_zlg237_can_intcb_info {

    /** \brief ص */
    am_pfnvoid_t  pfn_callback;

    /** \brief صĲ */
    void         *p_arg;
} am_zlg237_can_intcb_info_t;

/**
 * \brief CAN 豸Ϣ
 */
typedef struct am_zlg237_can_devinfo {

    /** \brief Ĵַ */
    uint32_t                         regbase;

    /** \brief жϺ */
    uint32_t                         int_num;

    /** \brief صϢ */
    am_zlg237_can_intcb_info_t      *p_intcb_info;

    /** \brief صϢڴС */
    uint8_t                          p_intcb_num;

    /** \brief ƽ̨ʼ */
    void                           (*pfn_plfm_init)(void);

    /** \brief ƽ̨ȥʼ */
    void                           (*pfn_plfm_deinit)(void);

    amhw_zlg237_can_filter_t       *filter;

    am_zlg237_can_init_info_t      *init_info;

} am_zlg237_can_devinfo_t;

/**
 * \brief 豸
 */
typedef struct am_zlg237_can_dev {
    am_can_serv_t                   handle;

    /** \brief ģʽ */
    amhw_zlg237_can_mode_t          mode;

    /** \brief ƥ*/
    uint8_t                         fmi;


    const am_zlg237_can_devinfo_t  *p_devinfo;
} am_zlg237_can_dev_t;

/**
 * \brief CANʼ
 *
 * \param[in] p_dev     : 豸ʵ
 * \param[in] p_devinfo : 豸Ϣ
 *
 * \return handle
 */
am_can_handle_t am_zlg237_can_init (am_zlg237_can_dev_t           *p_dev,
                                    const am_zlg237_can_devinfo_t *p_devinfo);

/**
 * \brief ʼ
 *
 * \param[in] p_dev     : 豸ʵ
 *
 * \return 
 */
void am_zlg237_can_deinit (am_can_handle_t handle);

/**
 * @} am_s32k14x_if_can
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_S32K14X_CAN_H */

/* end of file */

