/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief CLKTRIM׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 20-03-18
 * \endinternal
 */

#ifndef  __AM_ZSN700_CLKTRIM_H
#define  __AM_ZSN700_CLKTRIM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "hw/amhw_zsn700_clktrim.h"

/**
 * \addtogroup am_zsn700_if_clktrim
 * \copydoc am_zsn700_clktrim.h
 * @{
 */

/**
 * \brief CLKTRIMģʽ
 *
 * \param[in] rcntval    : οֵ
 * \param[in] rcntval    : У׼ֵ
 * \param[in] refclk_sel : οʱѡ
 * \param[in] calclk_sel : ʱѡ
 *
 * \return <0ʱʧЧ
 *        AM_OK
 */
uint8_t am_zsn700_clktrim_monitor (uint32_t                     rcntval,
                                   uint32_t                     ccntval,
                                   amhw_clktrim_refclk_sel_t    refclk_sel,
                                   amhw_clktrim_calclk_sel_t    calclk_sel);

/**
 * \brief CLKTRIMУ׼ģʽ
 *
 * \param[in] rcntval    : οֵ
 * \param[in] refclk_sel : οʱѡ
 * \param[in] calclk_sel : У׼ʱѡ
 *
 * \return У׼ʱӼֵ
 */
uint32_t am_zsn700_clktrim_calibrate (uint32_t                    rcntval,
                                     amhw_clktrim_refclk_sel_t    refclk_sel,
                                     amhw_clktrim_calclk_sel_t    calclk_sel);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_CLKTRIM_H */

/* end of file */
