/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief DACDAC׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 17-08-28  fra, first implementation
 * \endinternal
 */

#ifndef  __AM_ZLG_DAC_H
#define  __AM_ZLG_DAC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_dac.h"
#include "hw/amhw_zlg_dac.h"

/**
 * \addtogroup am_zlg_if_dac
 * \copydoc am_zlg_dac.h
 * @{
 */
/**
 * \brief DAC豸Ϣ
 */
typedef struct am_zlg_dac_devinfo {

    /** \brief DACĴַ */
    uint32_t   dac_reg_base;

    /** \brief DACת */
    uint8_t    bits;

    /**
     * \brief DACοѹλmV
     *
     * \note òοѹɾĵ·
     *
     */
    uint32_t   vref;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

} am_zlg_dac_devinfo_t;

/**
 * \brief DAC豸ʵ
 */
typedef struct am_zlg_dac_dev {

    /** \brief DAC׼ */
    am_dac_serv_t               dac_serve;

    /** \brief ָDAC豸Ϣָ */
    const am_zlg_dac_devinfo_t *p_devinfo;

    /** \brief ǰתͨ */
    uint32_t                    chan;

} am_zlg_dac_dev_t;

/**
 * \brief DACʼ
 *
 *
 * \param[in] p_dev     : ָDAC豸ָ
 * \param[in] p_devinfo : ָDAC豸Ϣָ
 *
 * \return DAC׼ Ϊ NULLʼʧ
 */
am_dac_handle_t am_zlg_dac_init (am_zlg_dac_dev_t           *p_dev,
                                 const am_zlg_dac_devinfo_t *p_devinfo);

/**
 * \brief DACȥʼ
 *
 *
 * \param[in] handle : DAC豸ľֵ
 *
 * \return 
 */
void am_zlg_dac_deinit (am_dac_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG_DAC_H */

/* end of file */
