/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief DACDAC׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-24
 * \endinternal
 */

#ifndef  __AM_ZSL42x_DAC_H
#define  __AM_ZSL42x_DAC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_dac.h"

/**
 * \addtogroup am_zsl42x_if_dac
 * \copydoc am_zsl42x_dac.h
 * @{
 */

/**
 * \brief DACݶ뷽ʽ
 */
#define AM_ZSL42x_DAC_ALIGN_WAY_12_RIGHT 0  /** \brief 12λҶ */
#define AM_ZSL42x_DAC_ALIGN_WAY_12_LEFT  1  /** \brief 12λ */
#define AM_ZSL42x_DAC_ALIGN_WAY_8_RIGHT  2  /** \brief 8 λҶ */

/**
 * \brief DACʽ
 */
#define AM_ZSL42x_DAC_CHAN_TIM0_TRGO    (0U)    /** \brief TIM0 */
#define AM_ZSL42x_DAC_CHAN_TIM1_TRGO    (1U)    /** \brief TIM1 */
#define AM_ZSL42x_DAC_CHAN_TIM2_TRGO    (2U)    /** \brief TIM2 */
#define AM_ZSL42x_DAC_CHAN_TIM3_TRGO    (3U)    /** \brief TIM3 */
#define AM_ZSL42x_DAC_CHAN_TIM4_TRGO    (4U)    /** \brief TIM4 */
#define AM_ZSL42x_DAC_CHAN_TIM5_TRGO    (5U)    /** \brief TIM5 */
#define AM_ZSL42x_DAC_CHAN_SOFTWARE_TRG (6U)    /** \brief  */
#define AM_ZSL42x_DAC_CHAN_EXTER        (7U)    /** \brief ⲿ¼ */

/**
 * \brief DAC豸Ϣ
 */
typedef struct am_zsl42x_dac_devinfo {

    /** \brief DACĴַ */
    uint32_t   dac_reg_base;

    /** \brief DACת */
    uint8_t    bits;

    /**
     * \brief DACοѹԴ
     */
    uint32_t   vref_rsc;

    /**
     * \brief DACοѹλmV
     *
     * \note òοѹɾĵ·
     *
     */
    uint32_t   vref;

    /**
     * \brief DACݶ뷽ʽ
     */
    uint8_t    align_way;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

} am_zsl42x_dac_devinfo_t;

/**
 * \brief DAC豸ʵ
 */
typedef struct am_zsl42x_dac_dev {

    /** \brief DAC׼ */
    am_dac_serv_t               dac_serve;

    /** \brief ָDAC豸Ϣָ */
    const am_zsl42x_dac_devinfo_t *p_devinfo;

    /** \brief ǰתͨ */
    uint32_t                    chan;

} am_zsl42x_dac_dev_t;

/**
 * \brief DACʼ
 *
 *
 * \param[in] p_dev     : ָDAC豸ָ
 * \param[in] p_devinfo : ָDAC豸Ϣָ
 *
 * \return DAC׼ Ϊ NULLʼʧ
 */
am_dac_handle_t am_zsl42x_dac_init (am_zsl42x_dac_dev_t           *p_dev,
                                    const am_zsl42x_dac_devinfo_t *p_devinfo);

/**
 * \brief DACȥʼ
 *
 *
 * \param[in] handle : DAC豸ľֵ
 *
 * \return 
 */
void am_zsl42x_dac_deinit (am_dac_handle_t handle);

/**
 * \brief DAC ʽѡ
 */
int am_zsl42x_dac_tri_way_sel (am_dac_handle_t handle, uint32_t tri_way);

/**
 * \brief DAC
 *
 * \param[in] handle : 豸
 *
 * \return : 
 */
void am_zsl42x_dac_soft_tri (am_dac_handle_t handle);

/**
 * \brief DAC תݻȡ
 */
void am_zsl42x_dac_convt_data_get (am_dac_handle_t handle, uint16_t *p_out_data);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_DAC_H */

/* end of file */
