/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief DMADMAӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 17-04-11  ari, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_DMA_H
#define __AM_ZLG_DMA_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "hw/amhw_zlg_dma.h"

/**
 * \addtogroup am_zlg_if_dma
 * \copydoc am_zlg_dma.h
 * @{
 */

/**
 * \name ͨжϱ־
 * \anchor am_zlg_dma_chan_cfg_flags
 * @{
 */

/** \brief жϱʶ */
#define AM_ZLG_DMA_INT_NORMAL         0

/** \brief жϱʶ */
#define AM_ZLG_DMA_INT_ERROR          1

/** @} */

/** \brief DMAжϻص */
typedef void (*am_zlg_pfn_dma_isr_t)(void *p_arg, uint32_t flag);

/** \brief DMAжϻصϢ */
struct am_zlg_dma_int_info {

    /** \brief DMAص */
    am_zlg_pfn_dma_isr_t  pfn_isr;

    /** \brief صĵһڲ */
    void                    *p_arg;
};

/** \brief DMA豸Ϣ */
typedef struct am_zlg_dma_devinfo {

    /** \brief ָDMAĴָ */
    uint32_t   dma_reg_base;

    /** \brief DMAжϺſʼ */
    uint8_t    inum_start;

    /** \brief DMAжϺŽ */
    uint8_t    inum_end;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

} am_zlg_dma_devinfo_t;

/**
 * \brief DMA豸ʵ
 */
typedef struct am_zlg_dma_dev {

    /** \brief ָDMA豸Ϣָ */
    const am_zlg_dma_devinfo_t *p_devinfo;

}am_zlg_dma_dev_t;

/**
 * \brief DMAͨ
 *
 * \param[in] chan  : DMA ͨţֵΪDMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 *
 * \retval AM_OK    : óɹ
 * \retval AM_ERROR : ô󣬸֮ͨǰù
 */
int am_zlg_dma_chan_start (int chan);

/**
 * \brief ֹͣͨ
 * \param[in] chan : DMA ͨţֵΪDMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 *
 * \retval AM_OK   : ɹ
 */
int am_zlg_dma_chan_stop (int chan);

/**
 * \brief 
 *
 * \param[in] p_desc   : ָDMAָ
 * \param[in] src_addr : Դ׵ַ
 * \param[in] dst_addr : Ŀ׵ַ
 * \param[in] nbytes   : ֽ
 * \param[in] flags    : ò
 *
 * \retval  AM_OK      : ɹ
 * \retval -AM_EINVAL  : δ룬Ч
 */
int am_zlg_dma_xfer_desc_build (amhw_zlg_dma_xfer_desc_t *p_desc,
                                uint32_t                  src_addr,
                                uint32_t                  dst_addr,
                                uint32_t                  nbytes,
                                uint32_t                  flags);

/**
 * \brief ʼDMA
 *
 * \param[in] p_desc  : ָDMAָ
 * \param[in] type    : DMAģʽ жӦödma_transfer_type_t
 * \param[in] chan    : DMA ͨţֵΪDMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 *
 * \retval  AM_OK     : ɹ
 * \retval -AM_EINVAL : Ч
 */
int am_zlg_dma_xfer_desc_chan_cfg (amhw_zlg_dma_xfer_desc_t    *p_desc,
                                   amhw_zlg_dma_transfer_type_t type,
                                   uint8_t                      chan);

/**
 * \brief DMAص
 *
 * \attention ûصĵڶɴãòȡֵΧ AM_ZLG_DMA_INT*
 *            (#AM_ZLG_DMA_INT_ERROR)(#AM_ZLG_DMA_INT_NORMAL)
 *
 * \param[in] chan    : DMA ͨţֵΪDMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 * \param[in] pfn_isr : صָ
 * \param[in] p_arg   : صĵһڲ ӹУӦͨд϶Ӧ֣
 *                      DMA0ͨòΪ(void *)0
 *
 * \retval  AM_OK     : ӳɹ
 * \retval -AM_EPERM  : 
 */
int am_zlg_dma_isr_connect (int                       chan,
                            am_zlg_pfn_dma_isr_t      pfn_isr,
                            void                     *p_arg);

/**
 * \brief ɾDMAص
 *
 * \attention ûصĵڶɴãòȡֵΧ AM_ZLG_DMA_INT*
 *            (#AM_ZLG_DMA_INT_ERROR)(#AM_ZLG_DMA_INT_NORMAL)
 *            ûصĵǲжϵͨȡֵΧDMA_CHAN_* (#DMA_CHAN_1)
 *
 * \param[in] chan    : DMA ͨţֵΪDMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 * \param[in] pfn_isr : صָ
 * \param[in] p_arg   : صĵһڲӹУӦͨд϶Ӧ֣
 *                      DMA0ͨòΪ(void *)0
 *
 * \retval  AM_OK     : ɾɹ
 * \retval -AM_EPERM  : 
 */
int am_zlg_dma_isr_disconnect (int                      chan,
                               am_zlg_pfn_dma_isr_t     pfn_isr,
                               void                    *p_arg);

/**
 * \breif ȡ  ĳͨǰʣֽ
 *
 * \param[in] chan DMA ͨţֵΪ DMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 *
 * \retval  ֽ
 */
uint16_t am_zlg_dma_tran_data_get (int chan);

/**
 * \breif  ĳͨǰʣֽ
 *
 * \param[in] chan            DMA ͨţֵΪ DMA_CHAN_* (#DMA_CHAN_1)  (#DMA_CHAN_UART1_TX)
 * \param[in] trans_data_byte Ҫֽ
 *
 * \retval  
 *
 * \note ôֽ֮ǰֹͣͨ
 */
void am_zlg_dma_tran_data_size (int chan, uint32_t trans_data_byte);

/**
 * \brief DMAʼ
 *
 * \param[in] p_dev         : ָDMA豸ָ
 * \param[in] p_dma_devinfo : ָDMA豸Ϣָ
 *
 * \retval  AM_OK       : ʼɹ
 */
int am_zlg_dma_init (am_zlg_dma_dev_t           *p_dev,
                     const am_zlg_dma_devinfo_t *p_dma_devinfo);

/**
 * \brief DMAȥʼ
 *
 * \return 
 */
void am_zlg_dma_deinit (void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG_DMA_H */

/* end of file */
