/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2019 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Flashӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-04  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_FLASH_H
#define __AM_ZLG118_FLASH_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"
#include "soc_cfg.h"
#include "hw/amhw_zlg118_flash.h"

/**
 * \addtogroup am_zlg118_if_flash
 * \copydoc am_zlg118_flash.h
 * @{
 */

#if defined ( __CC_ARM   )
#pragma anon_unions
#endif

/**
 * \brief öFLASH
 *
 * \param[in] p_hw_flash  ָFLASHĴָ
 * \param[in] waitcycle   
 *
 * \return ִн
 */
int32_t am_zlg118_flash_waitcycle(amhw_zlg118_flash_t              *p_hw_flash,
                                  amhw_zlg118_flash_read_waittime   waitcycle);

/**
 * \brief 
 *
 * \param[in] p_hw_flash  ָFLASHĴָ
 * \param[in] start_addr  ʼַ
 *
 * \return >0: ִн, -AM_EINVAL: ַ
 */
int32_t am_zlg118_flash_sector_erase (amhw_zlg118_flash_t  *p_hw_flash,
                                      uint32_t              addr);

/**
 * \brief ̻򲿷
 *
 * \param[in] p_hw_flash ָFLASHĴָ
 * \param[in] dst_addr   д뵽flashʼַ
 * \param[in] p_src      Ҫд뵽flashеݵʼַ
 * \param[in] size       д(32bit)ĸ
 *
 * \retval 0 ʵʳɹд
 */
int32_t am_zlg118_flash_sector_program (amhw_zlg118_flash_t    *p_hw_flash,
                                        uint32_t                dst_addr,
                                        uint32_t               *p_src,
                                        uint32_t                size);

/**
 * \brief (SRAMЧ)
 *
 * \param[in] p_hw_flash ָFLASHĴָ
 *
 * \return ִн
 *
 */
int32_t am_zlg118_flash_all_sector_erase (amhw_zlg118_flash_t *p_hw_flash);

/**
 * \brief Flashģʼ
 *
 * \param[in] p_hw_flash ָFLASHĴָ
 * \param[in] freqcfg    flashʱ
 * \param[in] dpstb_able dpstbʹܿ
 *
 * \return 
 */
int32_t am_zlg118_flash_init(amhw_zlg118_flash_t   *p_hw_flash,
                             uint8_t                freqcfg,
                             am_bool_t              dpstb_able);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /** __AM_ZLG118_FLASH_H */
