/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIOGPIO׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-07  ari,first implementation
 * \endinternal
 */

#ifndef __AM_ZLG116_GPIO_H
#define __AM_ZLG116_GPIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"
#include "hw/amhw_zlg_gpio.h"
#include "hw/amhw_zlg_syscfg.h"
#include "hw/amhw_zlg_exti.h"
#include "am_zlg116_gpio_util.h"

/**
 * \addtogroup am_zlg116_if_gpio
 * \copydoc am_zlg116_gpio.h
 * @{
 */

/**
 * \brief ŵĴϢ
 */
struct am_zlg116_gpio_trigger_info {

    /** \brief ص */
    am_pfnvoid_t pfn_callback;

    /** \brief صĲ */
    void        *p_arg;
};

/**
 * \brief GPIO 豸Ϣ
 */
typedef struct am_zlg116_gpio_devinfo {

    /** \brief GPIOĴַ */
    uint32_t     gpio_regbase;

    /** \brief ϵͳSYSCFGĴַ */
    uint32_t     syscfg_regbase;

    /** \brief ⲿ¼EXTIƼĴַ */
    uint32_t     exti_regbase;

    /** \brief GPIOжϺб */
    const int8_t inum_pin[3];

    /** \brief GPIOֵ֧жϺ */
    size_t       pint_count;

    /** \brief Ϣӳ */
    uint8_t     *p_infomap;

    /** \brief ָŴϢָ */
    struct am_zlg116_gpio_trigger_info *p_triginfo;

    void (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ȥʼ */

} am_zlg116_gpio_devinfo_t;

/**
 * \brief GPIO豸ʵ
 */
typedef struct am_zlg116_gpio_dev {

    /** \brief ָGPIO豸Ϣָ */
    const am_zlg116_gpio_devinfo_t *p_devinfo;

    /** \brief Ч־ */
    am_bool_t                       valid_flg;

} am_zlg116_gpio_dev_t;

/**
 * \brief GPIOʼ
 *
 * \param[in] p_dev     : ָGPIO豸ָ
 * \param[in] p_devinfo : ָGPIO豸Ϣָ
 *
 * \retval AM_OK : ɹ
 */
int am_zlg116_gpio_init (am_zlg116_gpio_dev_t           *p_dev,
                         const am_zlg116_gpio_devinfo_t *p_devinfo);

/**
 * \brief GPIOȥʼ
 *
 * \param[in] 
 *
 * \return 
 */
void am_zlg116_gpio_deinit (void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG116_GPIO_H */

/* end of file */
