/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIOGPIO׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.01 20-04-26 zcb, Fix the problem that only one pin can be
 *                      configured as external interrupt
 * - 1.00 19-09-06  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZSL42x_GPIO_H
#define __AM_ZSL42x_GPIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"
#include "hw/amhw_zsl42x_gpio.h"
#include "am_zsl42x_gpio_util.h"

/**
 * \addtogroup am_zsl42x_if_gpio
 * \copydoc am_zsl42x_gpio.h
 * @{
 */

/**
 * \brief ŵĴϢ
 */
struct am_zsl42x_gpio_trigger_info {

    /** \brief ص */
    am_pfnvoid_t                        pfn_callback;

    /** \brief صĲ */
    void                               *p_arg;
};

/**
 * \brief GPIO 豸Ϣ
 */
typedef struct am_zsl42x_gpio_devinfo {

    /** \brief GPIOĴַ */
    uint32_t                            gpio_regbase;

    /** \brief жϺб */
    const int8_t                        inum_pin[4];

    /** \brief ֧ⲿжϵ GPIO ű */
    const uint8_t                       exti_num_max;

    /** \brief ʽ */
    uint8_t                            *p_trigger;

    /** \brief ָŴϢָ */
    struct am_zsl42x_gpio_trigger_info   *p_triginfo;

    /** \brief ƽ̨ʼ */
    void                              (*pfn_plfm_init) (void);

    /** \brief ƽ̨ȥʼ */
    void                              (*pfn_plfm_deinit) (void);

} am_zsl42x_gpio_devinfo_t;

/**
 * \brief GPIO豸ʵ
 */
typedef struct am_zsl42x_gpio_dev {

    /** \brief ָGPIO豸Ϣָ */
    const am_zsl42x_gpio_devinfo_t       *p_devinfo;

    /** \brief Ч־ */
    am_bool_t                           valid_flg;

} am_zsl42x_gpio_dev_t;

/**
 * \brief GPIOʼ
 *
 * \param[in] p_dev     : ָGPIO豸ָ
 * \param[in] p_devinfo : ָGPIO豸Ϣָ
 *
 * \retval AM_OK : ɹ
 */
int am_zsl42x_gpio_init (am_zsl42x_gpio_dev_t           *p_dev,
                       const am_zsl42x_gpio_devinfo_t *p_devinfo);

/**
 * \brief GPIOʼ
 *
 * \param[in] 
 *
 * \return 
 */
void am_zsl42x_gpio_deinit (void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_GPIO_H */

/* end of file */
