/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIOGPIO׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 20-03-17  yrz, first implementation
 * \endinternal
 */

#ifndef __AM_ZSN700_GPIO_H
#define __AM_ZSN700_GPIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"
#include "hw/amhw_zsn700_gpio.h"
#include "am_zsn700_gpio_util.h"

/**
 * \addtogroup am_zsn700_if_gpio
 * \copydoc am_zsn700_gpio.h
 * @{
 */

/**
 * \brief ŵĴϢ
 */
struct am_zsn700_gpio_trigger_info {

    /** \brief ص */
    am_pfnvoid_t  pfn_callback;

    /** \brief صĲ */
    void         *p_arg;
};

/**
 * \brief GPIO 豸Ϣ
 */
typedef struct am_zsn700_gpio_devinfo {

    /** \brief GPIOĴַ */
    uint32_t      gpio_regbase;

    /** \brief жϺб */
    const int8_t  inum_pin[4];

    /** \brief GPIO */
    const uint8_t pin_count;

    /** \brief GPIOʹõⲿж߱+1 */
    const uint8_t exti_num_max;

    /** \brief Ϣӳ */
    uint8_t      *p_infomap;

    /** \brief ӳϢ */
    amhw_zsn700_gpio_afio_t              *p_afio;

    /** \brief ָŴϢָ */
    struct am_zsn700_gpio_trigger_info   *p_triginfo;

    void (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ȥʼ */

} am_zsn700_gpio_devinfo_t;

/**
 * \brief GPIO豸ʵ
 */
typedef struct am_zsn700_gpio_dev {

    /** \brief ָGPIO豸Ϣָ */
    const am_zsn700_gpio_devinfo_t *p_devinfo;

    /** \brief Ч־ */
    am_bool_t                       valid_flg;

    /** \brief Ŵж */
    uint8_t                         int_type;

} am_zsn700_gpio_dev_t;

/**
 * \brief GPIOʼ
 *
 * \param[in] p_dev     : ָGPIO豸ָ
 * \param[in] p_devinfo : ָGPIO豸Ϣָ
 *
 * \retval AM_OK : ɹ
 */
int am_zsn700_gpio_init (am_zsn700_gpio_dev_t           *p_dev,
                         const am_zsn700_gpio_devinfo_t *p_devinfo);

/**
 * \brief GPIOʼ
 *
 * \param[in] 
 *
 * \return 
 */
void am_zsn700_gpio_deinit (void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_GPIO_H */

/* end of file */
