/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief GPIOƽ̨ߺ
 *
 * ļ \sa zsn700_pin.h. 䶨GPIOƽ̨ŵĸܡ
 *
 * \internal
 * \par Modification History
 * - 1.00 20-03-18  yrz, first implementation
 * \endinternal
 */

#ifndef __AM_ZSN700_GPIO_UTIL_H
#define __AM_ZSN700_GPIO_UTIL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/**
 * \addtogroup am_zsn700_if_gpio_util
 * \copydoc am_zsn700_gpio_util.h
 * @{
 */

/**
 * \brief ƽ̨궨
 *
 * bit[31:12] ƽ̨
 *
 */

/**
 * \name λ
 * @{
 */
#define AM_ZSN700_GPIO_OUTRES_RATE                  AM_BIT(13)     /**< \brief ܽӦ */
#define AM_ZSN700_GPIO_MODE                         AM_BIT(14)     /**< \brief ܽģʽ */
#define AM_ZSN700_GPIO_REMAP                        AM_BIT(15)     /**< \brief ܽŸùʹ */

#define AM_ZSN700_GPIO_OUTRESRATEBITS_START         18        /**< \brief Ӧʼλ */
#define AM_ZSN700_GPIO_OUTRESRATEBITS_LEN           2         /**< \brief Ӧ볤 */

/** \brief Ӧ */
#define AM_ZSN700_GPIO_OUTRES_RATE_CODE(a)          (AM_SBF((a), AM_ZSN700_GPIO_OUTRESRATEBITS_START) |  \
                                                      AM_ZSN700_GPIO_OUTRES_RATE)

/** \brief ȡӦ */
#define AM_ZSN700_GPIO_OUTRES_RATE_GET(data)        AM_BITS_GET((data), AM_ZSN700_GPIO_OUTRESRATEBITS_START, \
                                                                          AM_ZSN700_GPIO_OUTRESRATEBITS_LEN)

#define AM_ZSN700_GPIO_MODEBITS_START               20        /**< \brief ģʽʼλ */
#define AM_ZSN700_GPIO_MODEBITS_LEN                 4         /**< \brief ģʽ볤 */

/** \brief ģʽ */
#define AM_ZSN700_GPIO_MODE_CODE(a)                 (AM_SBF((a), AM_ZSN700_GPIO_MODEBITS_START) |  \
                                                      AM_ZSN700_GPIO_MODE)

/** \brief ȡģʽ */
#define AM_ZSN700_GPIO_MODE_GET(data)               AM_BITS_GET((data), AM_ZSN700_GPIO_MODEBITS_START, \
                                                                          AM_ZSN700_GPIO_MODEBITS_LEN)

#define AM_ZSN700_GPIO_REMAP_PERIPHERAL_START       24  /**< \brief ӳʼλ */
#define AM_ZSN700_GPIO_REMAP_PERIPHERAL_LEN         4   /**< \brief ӳ볤 */

/** \brief ȡӳ */
#define AM_ZSN700_GPIO_REMAP_PERIPHERAL_GET(data)   AM_BITS_GET((data), AM_ZSN700_GPIO_REMAP_PERIPHERAL_START, \
                                                                          AM_ZSN700_GPIO_REMAP_PERIPHERAL_LEN)

#define AM_ZSN700_GPIO_REMAP_MODE_START             28  /**< \brief ӳģʽʼλ */
#define AM_ZSN700_GPIO_REMAP_MODE_LEN               3   /**< \brief ӳģʽ볤 */

/** \brief ȡӳģʽ */
#define AM_ZSN700_GPIO_REMAP_MODE_GET(data)         AM_BITS_GET((data), AM_ZSN700_GPIO_REMAP_MODE_START, \
                                                                          AM_ZSN700_GPIO_REMAP_MODE_LEN)

/** \brief ȡӳ  (PERIPHERAL,MODE) */
#define AM_ZSN700_GPIO_REMAP_CODE(a,b)              (AM_SBF((AM_SBF(b, AM_ZSN700_GPIO_REMAP_PERIPHERAL_LEN) | a), \
                                                                         AM_ZSN700_GPIO_REMAP_PERIPHERAL_START) |   \
                                                                         AM_ZSN700_GPIO_REMAP)
/** @} */

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_GPIO_UTIL_H */

/* end of file */
