/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief I2CӻI2Cӻ׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 17-09-06  vir, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_I2C_SLV_H
#define __AM_ZLG_I2C_SLV_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_int.h"
#include "am_i2c_slv.h"
#include "am_softimer.h"

/**
 * \addtogroup am_zlg_if_i2c_slv
 * \copydoc am_zlg_i2c_slv.h
 * @{
 */

/**
 * \brief I2C豸Ϣṹ
 */
typedef struct am_zlg_i2c_slv_devinfo {

    /** \brief I2C Ĵַ */
    uint32_t  i2c_regbase;

    /** \brief I2C жϺ */
    uint16_t  inum;

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

} am_zlg_i2c_slv_devinfo_t;

/**
 * \brief I2C豸ṹ
 */
typedef struct am_zlg_i2c_slv_dev {

    /** \brief ׼I2C豸 */
    am_i2c_slv_serv_t                  i2c_slv_serv;

   /** \brief ӻ豸,ֻܴһӻַ,ֻһ豸 */
    am_i2c_slv_device_t               *p_i2c_slv_dev[1];

    /** \brief ZLGĴӻɷŶٸӻַ, p_i2c_slv_devһ, */
    uint8_t                            zlg_i2c_slv_dev_num;

    /** \brief 㲥 ־ */
    am_bool_t                          is_gen_call;

    /** ʱ,ڳʱ */
    am_softimer_t                      softimer;

    /** \brief ָI2C豸Ϣָ */
    const am_zlg_i2c_slv_devinfo_t    *p_devinfo;

} am_zlg_i2c_slv_dev_t;

/**
 * \brief I2Cʼ
 *
 * \param[in] p_dev     : ָI2C豸ṹָ
 * \param[in] p_devinfo : ָI2C豸Ϣṹָ
 *
 * \return I2C׼
 */
am_i2c_slv_handle_t am_zlg_i2c_slv_init (am_zlg_i2c_slv_dev_t           *p_dev,
                                         const am_zlg_i2c_slv_devinfo_t *p_devinfo);

/**
 * \brief I2Cʼ
 * \param[in] handle : 豸ĴI2C׼
 * \return 
 */
void am_zlg_i2c_slv_deinit (am_i2c_slv_handle_t handle);

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG_I2C_SLV_H */

/* end of file */
