/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LCDLCD׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-15
 * \endinternal
 */
#ifndef __AM_ZSL42x_LCD_H
#define __AM_ZSL42x_LCD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

#define AM_ZSL42x_LCD_MODE_0    0  /**< \brief LCD ģʽ0 */
#define AM_ZSL42x_LCD_MODE_1    1  /**< \brief LCD ģʽ1 */

/**
 * \addtogroup am_zsl42x_if_lcd
 * \copydoc am_zsl42x_lcd.h
 * @{
 */

/**
 * \brief LCD COM-SEG˿ڳʼϢṹ
 *
 * \note : ûʹLCDʱҪԼһṹ岢
 *         ûڿƶ˿ʱ1ʾ0ʾرգ
 */
typedef struct am_zsl42x_lcd_com_seg {
    uint32_t seg0_31;          /**< \brief seg0-31˿ */
    uint8_t  seg32_35;         /**< \brief seg32-35˿ */
    uint8_t  seg36com7_39com4; /**< \brief seg36-3 com4-7ܽŹѡCR0.DUTY*/
    uint16_t seg40_51;         /**< \brief seg40-51˿ */
    uint8_t  mux;              /**< \brief SEG32~SEG35˿ڹѡ */
    uint8_t  com0_3;           /**< \brief COM0-3˿ڹѡ */
}am_zsl42x_lcd_com_seg_t;

/**
 * \brief LCD豸Ϣṹ
 */
typedef struct am_zsl42x_lcd_info {

    uint32_t    reg_base;  /**< \brief LCDĴַ */

    uint8_t     inum;      /**< \brief LCDжϱ */

    uint8_t     bias_src;  /**< \brief LCDƫԴ */

    uint8_t     duty;      /**< \brief LCDռձ */

    uint8_t     bias;      /**< \brief LCDƫõѹ */

    uint8_t     cpclk;     /**< \brief LCDѹʱƵ*/

    uint8_t     scanclk;   /**< \brief LCDɨƵ*/

    uint8_t     clk_src;   /**< \brief LCDʱԴ*/

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

}am_zsl42x_lcd_devinfo_t;

/**
 * \brief LCD豸ʵ
 */
typedef struct am_zsl42x_lcd_dev {

    /** \brief ָLCD豸Ϣָ */
    const am_zsl42x_lcd_devinfo_t *p_devinfo;

    /** \brief жϴص */
    void (*pfn_trigger_cb)(void *);

    /** \brief ûص */
    void *p_arg;

    /** \brief LCDʾģʽ */
    uint8_t mode;

} am_zsl42x_lcd_dev_t;

/** \brief LCD׼Ͷ */
typedef am_zsl42x_lcd_dev_t *am_lcd_handle_t;

/**
 * \brief LCD ʼ
 *
 * \param[in] p_dev     : LCD 豸ʵ
 * \param[in] p_devinfo : LCD 豸Ϣʵ
 *
 * \retval : ׼LCD
 *
 */
am_lcd_handle_t  am_zsl42x_lcd_init (am_zsl42x_lcd_dev_t           *p_dev,
                                     const am_zsl42x_lcd_devinfo_t *p_devinfo);

/**
 * \brief LCD ȥʼ
 *
 * \param[in] handle : ׼LCD
 *
 * \retval : 
 *
 */
void am_zsl42x_lcd_deinit (am_lcd_handle_t handle);


/**
 * \brief LCD 
 *
 * \param[in] handle: ׼LCD
 *
 * \retval AM_OK    : ɹ
 *         AM_ERROR : ʧ
 *
 */
int am_zsl42x_lcd_disp_clr (am_lcd_handle_t handle);

/**
 * \brief LCD 
 *
 * \param[in] handle: ׼LCD
 * \param[in] addr  : Դַ
 * \param[in] data  : д뵽Դ
 *
 * \retval AM_OK    : ɹ
 *         AM_ERROR : ʧ
 *
 */
int am_zsl42x_lcd_disp_write (am_lcd_handle_t handle,
                              uint32_t addr,
                              uint32_t data);

/**
 * \brief LCD DMAģʽ жϴ
 *
 * \param[in] handle   : ׼LCD
 * \param[in] p_lcd_cb : ûص
 * \param[in] p_arg    : ûص
 *
 * \retval AM_OK    : ɹ
 *         AM_ERROR : ʧ
 *
 */
int am_zsl42x_lcd_dma_int_set (am_lcd_handle_t handle,
                               void (*p_lcd_cb) (void *),
                               void *p_arg);

/**
 * \brief LCD ʹ
 *
 * \param[in] handle   : ׼LCD
 * \param[in] lcd_mode : LCDʾģʽ
 *
 * \retval AM_OK    : ɹ
 *         AM_ERROR : ʧ
 *
 */
int am_zsl42x_lcd_enable (am_lcd_handle_t handle, uint8_t lcd_mode);

/**
 * \brief LCD COM SEG ˿
 *
 * \param[in] handle : ׼LCD
 * \param[in] p_port : LCD COM-SEG˿ýṹָ
 *
 * \retval AM_OK    : ɹ
 *         AM_ERROR : ʧ
 *
 */
int am_zsl42x_lcd_com_seg_init (am_lcd_handle_t         handle,
                                am_zsl42x_lcd_com_seg_t *p_port);


/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_LCD_H */

/* end of file */
