/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zsn700.cn/
*******************************************************************************/

/**
 * \file
 * \brief LCD ײӿ
 * \internal
 * \par Modification History
 * - 1.00 20-03-13
 * \endinternal
 */

#ifndef __AMHW_ZSN700_LCD_H
#define __AMHW_ZSN700_LCD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_types.h"

/**
 * \addtogroup amhw_zsn700_if_lcd
 * \copydoc amhw_zsn700_lcd.h
 * @{
 */

/**
 * \brief LCD - Ĵ
 */
typedef struct amhw_zsn700_lcd {
    __IO uint32_t lcdcr0;        /**< \brief LCDüĴ0 */
    __IO uint32_t lcdcr1;        /**< \brief LCDüĴ1 */
    __IO uint32_t lcdintclr;     /**< \brief LCDжĴ */
    __IO uint32_t lcdpoen0;      /**< \brief LCDüĴ0 */
    __IO uint32_t lcdpoen1;      /**< \brief LCDüĴ1 */
         uint32_t res[11];       /**< \brief  */
    __IO uint32_t lcdram0_f[16]; /**< \brief LCD RAM0~f */
} amhw_zsn700_lcd_t;

/**
 * \brief LCDԱȶ,contrastֵһ16ȼ
 */
typedef enum amhw_zsn700_lcd_ctr_val {
    AHHW_ZSN700_CTR_1 = 0,
    AHHW_ZSN700_CTR_2,
    AHHW_ZSN700_CTR_3,
    AHHW_ZSN700_CTR_4,
    AHHW_ZSN700_CTR_5,
    AHHW_ZSN700_CTR_6,
    AHHW_ZSN700_CTR_7,
    AHHW_ZSN700_CTR_8,
    AHHW_ZSN700_CTR_9,
    AHHW_ZSN700_CTR_10,
    AHHW_ZSN700_CTR_11,
    AHHW_ZSN700_CTR_12,
    AHHW_ZSN700_CTR_13,
    AHHW_ZSN700_CTR_14,
    AHHW_ZSN700_CTR_15,
    AHHW_ZSN700_CTR_16
}amhw_zsn700_lcd_ctr_val_t;

/**
 * \brief LCDԱȶȵ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : contrastֵοöٶ壺LCDԱȶ
 *
 * \note : BiasѹԴѡڲѹʱЧ
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_lcd_ctr_set (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 = (p_hw_lcd->lcdcr0 & (~(0xf << 12))) | (flag << 12);
}

/**
 * \brief BiasѹԴѡ
 */
#define AMHW_ZSN700_LCD_BIAS_EXT_RES  (0U)   /**< \brief ⲿģʽҪⲿ· */
#define AMHW_ZSN700_LCD_BIAS_CAP_DIV  (1U)   /**< \brief ݷѹģʽҪⲿ·*/

/**< \brief ڲѹйģʽ*/
#define AMHW_ZSN700_LCD_BIAS_INT_RES_DIV_POWER_MID   (2U)
/**< \brief ڲѹСģʽ*/
#define AMHW_ZSN700_LCD_BIAS_INT_RES_DIV_POWER_LOW   (4U)
/**< \brief ڲѹ󹦺ģʽ*/
#define AMHW_ZSN700_LCD_BIAS_INT_RES_DIV_POWER_HIGH  (6U)

/**
 * \brief BiasѹԴѡ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ƫõѹοö궨壺BiasѹԴѡ
 *
 */
am_static_inline
void amhw_zsn700_lcd_bias_rsc_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 = (p_hw_lcd->lcdcr0 & (~(0x7 << 9))) | (flag << 9);
}

/**
 * \brief LCD duty
 */
typedef enum amhw_zsn700_lcd_duty {
    AMHW_ZSN700_DUTY_STATIC = 0,
    AMHW_ZSN700_DUTY_1_2,
    AMHW_ZSN700_DUTY_1_3,
    AMHW_ZSN700_DUTY_1_4,
    AMHW_ZSN700_DUTY_1_6 = 5,
    AMHW_ZSN700_DUTY_1_8 = 7,
}amhw_zsn700_lcd_duty_t;

/**
 * \brief LCD duty
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ƫõѹοöٶ壺LCD duty
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_duty_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 = (p_hw_lcd->lcdcr0 & (~(0x7 << 6))) | (flag << 6);
}

/**
 * \biref ƫõѹ
 */
#define AMHW_ZSN700_BIAS_1_3  (0U)  /**< \brief 1/3 bias */
#define AMHW_ZSN700_BIAS_1_2  (1U)  /**< \brief 1/2 bias */

/**
 * \brief LCD duty
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ƫõѹο궨壺ƫõѹ
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_bias_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 |= (p_hw_lcd->lcdcr0 & ~(0x1 << 5)) | (flag << 5);
}

/**
 * \biref ѹʱƵѡ
 */
#define AMHW_ZSN700_CPCLK_2K_HZ  (0U)  /**< \brief 2k Hz */
#define AMHW_ZSN700_CPCLK_4K_HZ  (1U)  /**< \brief 4k Hz */
#define AMHW_ZSN700_CPCLK_8K_HZ  (2U)  /**< \brief 8k Hz */
#define AMHW_ZSN700_CPCLK_16K_HZ (3U)  /**< \brief 16k Hz */

/**
 * \brief ѹʱƵѡ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ƫõѹο궨壺ѹʱƵѡ
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_cpclk_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 = (p_hw_lcd->lcdcr0 & (~(0x3 << 3))) | (flag << 3);
}

/**
 * \biref LCDɨƵѡ
 */
#define AMHW_ZSN700_LCDCLK_64_HZ   (0U)  /**< \brief 64 Hz */
#define AMHW_ZSN700_LCDCLK_128_HZ  (1U)  /**< \brief 128 Hz */
#define AMHW_ZSN700_LCDCLK_256_HZ  (2U)  /**< \brief 256 Hz */
#define AMHW_ZSN700_LCDCLK_512_HZ  (3U)  /**< \brief 512 Hz */

/**
 * \brief LCDɨƵѡ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ƫõѹο궨壺LCDɨƵѡ
 *
 * \note : LCD֡Ƶ = LCDɨƵʡDuty
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_cldclk_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr0 = (p_hw_lcd->lcdcr0 & (~(0x3 << 1))) | (flag << 1);
}

/**
 * \brief LCDʹ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_enable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr0 |= (1 << 0);
}

/**
 * \brief LCD
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 * \retval : 
 *
 */
am_static_inline
void amhw_zsn700_lcd_disable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr0 &= ~(1 << 0);
}

/**
 * \brief LCDж״̬ȡ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 * \retval : 1 ж  0 ж
 *
 */
am_static_inline
int amhw_zsn700_lcd_int_stu_check (amhw_zsn700_lcd_t *p_hw_lcd)
{
    return (p_hw_lcd->lcdcr0 >> 11);
}

/**
 * \brief жʹ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 */
am_static_inline
void amhw_zsn700_lcd_int_enable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr1 |= (1 << 9);
}

/**
 * \brief жϽ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 */
am_static_inline
void amhw_zsn700_lcd_int_disable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr1 &= ~(1 << 9);
}

/**
 * \brief жϱ־
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 */
am_static_inline
void amhw_zsn700_lcd_int_flag_clr (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdintclr &= ~(1 << 10);
}

/**
 * \brief DMAӲʹ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 */
am_static_inline
void amhw_zsn700_lcd_dma_enable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr1 |= (1 << 10);
}

/**
 * \brief DMAӲ
 *
 * \param[in] p_hw_lcd: ָLCDĴָ
 *
 */
am_static_inline
void amhw_zsn700_lcd_dma_disable (amhw_zsn700_lcd_t *p_hw_lcd)
{
    p_hw_lcd->lcdcr1 &= ~(1 << 10);
}

/**
 * \brief LCD RAMʾģʽѡ
 */
#define AMHW_ZSN700_LCD_MODE_0  (0U)
#define AMHW_ZSN700_LCD_MODE_1  (1U)

/**
 * \brief LCD RAMʾģʽѡ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ģʽο궨壺LCD RAMʾģʽѡ
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_lcd_mode_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr1 = (p_hw_lcd->lcdcr1 & ~(1 << 8)) | (flag << 8);
}

/**
 * \brief LCDʱԴѡ
 */
#define AMHW_ZSN700_LCD_CLK_SRC_XTL  (1U)
#define AMHW_ZSN700_LCD_CLK_SRC_RCL  (0U)

/**
 * \brief LCDʱԴѡѡ
 *
 * \param[in] p_hw_lcd  : ָLCDĴָ
 * \param[in] flag      : ʱԴο궨壺LCDʱԴѡ
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_lcd_clk_rsc_sel (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{
    p_hw_lcd->lcdcr1 = (p_hw_lcd->lcdcr1 & ~(1 << 7)) | (flag << 7);
}

/**
 * \brief ƵLCDжϼ
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] val      : Blinkcntֵ
 *
 * \note : עLCD˸ƵΪ = LCD֡Ƶ / (BlinkCnt+1)
 *            LCDжϼ= (BlinkCnt+1)*(1/LCD ֡Ƶ)
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_blink_cnt_set (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t val)
{
    p_hw_lcd->lcdcr1 = (p_hw_lcd->lcdcr1 & (~(0x3f))) | (val << 0);
}

/**
 * \brief Seg0_31
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : ҪƿرյSegλ
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_seg0_31_ctr (amhw_zsn700_lcd_t *p_hw_lcd, uint32_t flag)
{

    p_hw_lcd->lcdpoen0 &= ~flag;
}

/**
 * \brief Seg32_51_Com0_8
 */
#define AMHW_ZSN700_LCD_SEG32_35_CTR  0    /**< \brief seg32-35 */
#define AMHW_ZSN700_LCD_COM0_3_CTR    1    /**< \brief COM0-3 */
#define AMHW_ZSN700_LCD_COMSEG_CTR    2    /**< \brief COM4-7 seg36-39 */
#define AMHW_ZSN700_LCD_MUX_CTR       3    /**< \brief SEG32~SEG35˿ڹѡ */
#define AMHW_ZSN700_LCD_SEG40_51_CTR  4    /**< \brief seg40-51 */
#define AMHW_ZSN700_LCD_ALL_CLOSE     5    /**< \brief пر*/

/**
 * \brief Seg32_51_Com0_8
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] flag     : Seg32_51_Com0_8
 * \param[in] data     : (ͬݸʽͬ磺AMHW_ZSN700_LCD_MUX_CTR
 *                       data = 1AMHW_ZSN700_LCD_COM0_3_CTRȫرգdata = 0x0)
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_seg32_51_com0_8_ctr(amhw_zsn700_lcd_t *p_hw_lcd,
                                     uint32_t           flag,
                                     uint32_t           data)
{



    switch (flag){

        case AMHW_ZSN700_LCD_ALL_CLOSE:
            p_hw_lcd->lcdpoen1 = (p_hw_lcd->lcdpoen1 | 0xffffffff) & data;
            break;
        case AMHW_ZSN700_LCD_SEG40_51_CTR :
            p_hw_lcd->lcdpoen1 = (p_hw_lcd->lcdpoen1) & (~(data << 8));
            break;
        case AMHW_ZSN700_LCD_MUX_CTR :
            if (data == 0){
                p_hw_lcd->lcdpoen1 &= ~(1 << 12);
            }else{
                p_hw_lcd->lcdpoen1 |=  (1 << 12);
            }
            break;
        case AMHW_ZSN700_LCD_COMSEG_CTR :
            p_hw_lcd->lcdpoen1 = (p_hw_lcd->lcdpoen1)  & (~(data << 4));
            break;
        case AMHW_ZSN700_LCD_COM0_3_CTR :
            p_hw_lcd->lcdpoen1 =
                         (p_hw_lcd->lcdpoen1 ) & (~(data << 21));
            break;
        case AMHW_ZSN700_LCD_SEG32_35_CTR :
            p_hw_lcd->lcdpoen1 =
                         (p_hw_lcd->lcdpoen1) & ~data;
            break;
        default : return ;
    }
}

/**
 * \brief LCD-RAM_0_f 
 *
 * \param[in] p_hw_lcd : ָLCDĴָ
 * \param[in] data     : ramд
 * \param[in] addr     : ַ
 *
 * \retval : 
 */
am_static_inline
void amhw_zsn700_lcd_ram_write (amhw_zsn700_lcd_t *p_hw_lcd ,
                                uint32_t           data,
                                uint8_t            addr)
{
    p_hw_lcd->lcdram0_f[addr] =
                           (p_hw_lcd->lcdram0_f[addr] & (~(0xffffffff))) | data;
}


/**
 * @} amhw_if_zsn700_lcd
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZSN700_lcd_H */

/* end of file */
