/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Software Timer ʱ
 *
 * \details
 *        һӲʱֳɶʱsoftimerÿtickִһΣ
 *        Ӳʱƥ䣨matchʵּϵشڵ͹ĳϡ
 *        Ӳʱ֧ڵ͹ģʽйܲɻѵжϣ
 *        ýӿʵֵʱ߱͹Ļѹܡ
 *
 * \internal
 * \par Modification history
 * - 1.0.0 17-06-13  sky, ebi, ӿڶ
 * \endinternal
 */

#ifndef __SOFTIMER_H
#define __SOFTIMER_H

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @addtogroup if_softimer
 * @copydoc softimer.h
 * @{
 */

#include <stdio.h>
#include <stdint.h>

/**
 * \brief softimer ʱ
 */
typedef uint32_t am_lpsoftimer_time_t;

/**
 * \brief softimer
 */
typedef struct am_lpsoftimer {

    am_lpsoftimer_time_t  dest_time;                 /**< \brief Ŀʱ(ms) */
    am_lpsoftimer_time_t  reload_time;               /**< \brief صʱ(ms) */
    uint8_t               is_running;                /**< \brief Ƿ */
    void                 (*pfn_cb) (void *p_arg);    /**< \brief ʱص */
    void                  *p_arg;                    /**< \brief ص */

    struct am_lpsoftimer *p_next;                    /**< \brief ָһʱ */

} am_lpsoftimer_t;

/**
 * \brief softimer ʱʵʼ
 *
 * \param[in] p_obj        : Ҫʼsoftimerʵ
 * \param[in] pfn_callback : ָöʱص
 * \param[in] p_cb_arg     : صp_arg
 *
 * \return 
 */
void am_lpsoftimer_init (am_lpsoftimer_t *p_obj,
                         void           (*pfn_callback)(void *p_arg),
                         void            *p_arg);

/**
 * \brief softimer 趨ʱֵ
 *
 * \param[in] p_obj : ָsoftimerʵ
 * \param[in] time  : ָöʱʱֵms
 *
 * \note Ϊ0ʱЧڲΪ1.
 * \return 
 */
void am_lpsoftimer_value_set (am_lpsoftimer_t *p_obj, am_lpsoftimer_time_t time);

/**
 * \brief softimer ʱ
 * \param[in] p_obj : softimerʵ
 * \return 
 */
void am_lpsoftimer_start (am_lpsoftimer_t *p_obj);

/**
 * \brief softimer ʱֹͣ
 * \param[in] p_obj : softimerʵ
 * \return 
 */
void am_lpsoftimer_stop (am_lpsoftimer_t *p_obj);

/**
 * \brief softimer ʱ
 * \param[in] p_obj : softimerʵ
 * \return 
 */
void am_lpsoftimer_restart (am_lpsoftimer_t *p_obj);

/**
 * \brief  ȡ lpsoftimer ǷΪգǰǷжʱ
 * \return 1 : ǰûʱ
 *         0 : ǰһʱڹ
 */
uint8_t am_lpsoftimer_list_isempty (void);

/**
 * \brief softimer ȡȥʱ
 * \param[in] saved_time : οʱ(Ҫδʱ䣬ᵼ¼ֵ)
 * \return ȥʱ
 */
am_lpsoftimer_time_t am_lpsoftimer_elapsed_get (am_lpsoftimer_time_t saved_time);

/**
 * \brief softimer ȡǰʱֵ(ϵͳ)
 * \param[in] 
 * \return ʱֵ
 */
am_lpsoftimer_time_t am_lpsoftimer_current_get (void);

/**
 * \brief softimer һγʱ
 * \param[in] timeout : ڿʼ֮붨ʱж
 * \return 
 */
void am_lpsoftimer_timeout_set (am_lpsoftimer_time_t timeout);

/**
 * \brief softimer ¶Ȳ
 *
 * \param[in] period      : ʱ
 * \param[in] temperature : ¶
 *
 * \return ʱ
 */
uint32_t am_lpsoftimer_temp_compensation (uint32_t period, float temperature);

/**
 * \brief softimer MsʱתΪϵͳtickʱ
 * \param[in] timeout : ڿʼ֮붨ʱж
 * \return 
 */
uint32_t am_lpsoftimer_ms_to_tick (am_lpsoftimer_time_t ms, float temp);

/**
 * \brief softimer ϵͳtickתΪMsʱ
 * \param[in] timeout : ڿʼ֮붨ʱж
 * \return 
 */
am_lpsoftimer_time_t am_lpsoftimer_tick_to_ms (uint32_t tick, float temp);

/**
 * \brief softimer жϷ
 * \param[in] 
 * \return 
 * \note ƽ̨ĶʱжϷлصú
 */
void am_lpsoftimer_isr (void);

/**
 * \brief رCPU
 * \attention رʱһҪұ am_lpsoftimer_cpu_unlock() ʹ
 * \param[in] 
 * \return    CPUϢ
 */
uint32_t am_lpsoftimer_cpu_lock (void);

/**
 * \brief CPU
 * \attention  am_lpsoftimer_cpu_lock() ʹ
 * \param[in] lock : Ϣ
 * \return    
 */
void am_lpsoftimer_cpu_unlock (uint32_t lock);

#ifdef __cplusplus
}
#endif

/**
 * @}
 */

#endif /* __SOFTIMER_H */

/* end of file */
