/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg118.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱLPTIMTimerʵ
 *
 * 1. LPTIM֧ṩֱ׼񣬱ṩǷTimer׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. һLPTIMģ飬ֻһʱͨ
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-27  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_LPTIM_LPTIMING_H
#define __AM_ZLG118_LPTIM_LPTIMING_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_timer.h"
#include "hw/amhw_zlg118_lptim.h"

/**
 * \addtogroup am_zlg118_if_lptim_timing
 * \copydoc am_zlg118_lptim_timing.h
 * @{
 */

/**
 * \brief LPTIMʱص豸Ϣ
 */
typedef struct am_zlg118_lptim_timing_devinfo {

    uint32_t               lptim_regbase;   /**< \brief LPTIMĴַ */

    uint8_t                inum;            /**< \brief LPTIMжϺ */

    amhw_zlg118_lptim_clk_src_t   clk_src;  /**< \brief /ʱʱԴѡ */

    /** \brief /ʱѡ.ѡʱҪʼETRţⲿ½ؽм */
    amhw_zlg118_lptim_function_t  fun_sel;

    amhw_zlg118_lptim_mode_t      mode;     /**< \brief /ģʽѡ  */

    am_bool_t                     gate_enable; /**< \brief ſʹܿ  */

    am_bool_t                     gate_state;  /**< \brief ſЧź  */

    /** \brief AM_FALSE:TOG,TOGNͬʱ0    AM_TRUE: TOG,TOGNλ෴ź*/
    am_bool_t                     tog_state;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                 (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                 (*pfn_plfm_deinit)(void);

} am_zlg118_lptim_timing_devinfo_t;

/**
 * \brief LPTIMʱ豸
 */
typedef struct am_zlg118_lptim_timing_dev {

    am_timer_serv_t timer_serv;         /**< \brief ׼ʱ(Timer) */

    void (*pfn_callback)(void *);       /**< \brief ص */
    void  *p_arg;                       /**< \brief صû */

    /** \brief ָLPTIM(ʱ)豸Ϣָ */
    const am_zlg118_lptim_timing_devinfo_t  *p_devinfo;

    uint32_t  clk_rate;                 /**< \brief ʱƵ */

    am_timer_info_t  timer_info;        /**< \brief ʱ */
} am_zlg118_lptim_timing_dev_t;

/**
 * \brief ʼLPTIMΪʱ
 *
 * \param[in] p_dev     : ָLPTIM(ʱ)豸ָ
 * \param[in] p_devinfo : ָLPTIM(ʱ)豸Ϣָ
 *
 * \return Timer׼ֵΪNULLʱʼʧ
 */
am_timer_handle_t
am_zlg118_lptim_timing_init (am_zlg118_lptim_timing_dev_t           *p_dev,
                               const am_zlg118_lptim_timing_devinfo_t *p_devinfo);

/**
 * \brief ʹLPTIMʱʱʼLPTIMʱܣͷԴ
 *
 * \param[in] handle : am_zlg118_lptim_timing_init() ʼõTimer
 *
 * \return 
 */
void am_zlg118_lptim_timing_deinit (am_timer_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG118_LPTIM_LPTIMING_H */

/* end of file */
