/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ͹ĶʱLPTIMӿ
 *
 * \internal
 * \par History
 * - 1.00 20-03-18  yrz, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZSN700_LPTIM_H
#define __AMHW_ZSN700_LPTIM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"

/**
 * \addtogroup amhw_zsn700_if_lptim
 * \copydoc amhw_zsn700_lptim.h
 * @{
 */

/**
  * \brief ʱĴṹ
  */
typedef struct amhw_zsn700_lptim {
    __I  uint32_t cnt;         /**< \brief ֵֻĴ */
    __IO uint32_t arr;         /**< \brief ؼĴ */
    __IO uint32_t reserve;     /**< \brief λ */
    __IO uint32_t cr;          /**< \brief ƼĴ */
    __I  uint32_t ifr;         /**< \brief жϱ־Ĵ */
    __IO uint32_t iclr;        /**< \brief жĴ */
} amhw_zsn700_lptim_t;

/**
 * \brief õǰֵ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return ǰֵ
 */
am_static_inline
uint16_t amhw_zsn700_lptim_cnt16_count_get (amhw_zsn700_lptim_t *p_hw_lptim)
{
    return p_hw_lptim->cnt;
}

/**
 * \brief ؼĴֵ
 *
 * \param[in] p_hw_lptim :    ָLPTIMʱĴָ
 * \param[in] value      :    õؼĴֵ
 *
 * \note  д ARRǰҪȡ CR.WT_FLAGҾ WT_FLAGΪ1ʱдʱдݡ
 *        дARRĴ WT_FLAG͡
 *
 *        עڶʱʱʱֵװصʱСʱֵġ
 *
 *\ return 
 */
am_static_inline
void amhw_zsn700_lptim_arr_count_set (amhw_zsn700_lptim_t *p_hw_lptim,
                                      uint16_t value)
{
    p_hw_lptim->arr = value;
}

/**
 * \brief ؼĴֵ
 *
 * \param[in] p_hw_lptim :    ָLPTIMʱĴָ
 * \param[in] value      :    õؼĴֵ
 *
 * \note  д ARRǰҪȡ CR.WT_FLAGҾ WT_FLAGΪ1ʱдʱдݡ
 *        дARRĴ WT_FLAG͡
 *
 *        עڶʱʱʱֵװصʱСʱֵġ
 *
 *\ return 
 */
am_static_inline
uint16_t amhw_zsn700_lptim_arr_count_get (amhw_zsn700_lptim_t *p_hw_lptim)
{
    return p_hw_lptim->arr;
}

/**
 * \brief ʱӷƵѡڶʱʱԸģ
 */
typedef enum {
    AMHW_ZSN700_LPTIM_CLK_DIV1 = 0,    /* 1Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV2,        /* 2Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV4,        /* 4Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV8,        /* 8Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV16,       /* 16Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV32,       /* 32Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV64,       /* 64Ƶ */
    AMHW_ZSN700_LPTIM_CLK_DIV256,      /* 256Ƶ */
}amhw_zsn700_lptim_clk_div_t;

/**
 * \brief PRS ڲʱӷƵѡ   ȡ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return õķƵϵamhw_zsn700_lptim_clk_div_tö
 */
am_static_inline
amhw_zsn700_lptim_clk_div_t
amhw_zsn700_lptim_clk_div_get (amhw_zsn700_lptim_t *p_hw_lptim)
{
    return (amhw_zsn700_lptim_clk_div_t)((p_hw_lptim->cr >> 11) & 0x7ul);
}

/**
 * \brief PRS ڲʱӷƵѡ   
 *
 * \param[in] p_hw_lptim : ָTIMʱĴָ
 * \param[in] clkdiv   : õķƵϵamhw_zsn700_lptim_clkdiv_tö
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_clk_div_set (amhw_zsn700_lptim_t        *p_hw_lptim,
                                    amhw_zsn700_lptim_clk_div_t clkdiv)
{
    p_hw_lptim->cr = (p_hw_lptim->cr & (~(0x7ul << 11))) |
                     ((clkdiv & 0x7ul) << 11);
}

/**
 * \brief IE жϽ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_int_disable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr &= ~(0x1ul << 10);
}

/**
 * \brief IE жʹ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_int_enable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr |= (0x1ul << 10);
}

/**
 * \brief GATEP ˿GATEԿ   ߵƽ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_gate_high (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr &= ~(0x1ul << 9);
}

/**
 * \brief GATEP ˿GATEԿ   ͵ƽ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_gate_low (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr |= (0x1ul << 9);
}

/**
 * \brief GATE ʱſؽ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_gate_disable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr &= ~(0x1ul << 8);
}

/**
 * \brief GATE ʱſʹ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_gate_enable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr |= (0x1ul << 8);
}

/**
 * \brief WT_FLAG     WT,дͬ־
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return AM_TRUE  : ͬɣɸARR
 *         AM_FALSE : ͬ дARRЧ
 */
am_static_inline
am_bool_t amhw_zsn700_lptim_write_into_arr_stat (amhw_zsn700_lptim_t *p_hw_lptim)
{
   return ((p_hw_lptim->cr >> 7) & 0x1ul) ? AM_TRUE : AM_FALSE;
}

typedef enum {
    AMHW_ZSN700_LPTIM_CLK_SRC_PCLK = 0ul,    /* LPTIMʱΪ  PCLK */
    AMHW_ZSN700_LPTIM_CLK_SRC_XTL  = 2ul,    /* LPTIMʱΪ  ⲿʱ */
    AMHW_ZSN700_LPTIM_CLK_SRC_RCL  = 3ul,    /* LPTIMʱΪ  ڲʱ */
}amhw_zsn700_lptim_clk_src_t;

/**
 * \brief LPTIM ʱѡ
 *
 * \param[in] p_hw_lptim : ָLPTIMĴṹָ
 * \param[in] clk_src    : amhw_zsn700_lptim_clk_src_tö
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_lptim_clk_src_sel (amhw_zsn700_lptim_t          *p_hw_lptim,
                                    amhw_zsn700_lptim_clk_src_t   clk_src)
{
    p_hw_lptim->cr = (p_hw_lptim->cr & (~(0x3ul << 4))) | (clk_src << 4);
}

/**
 * \brief LPTIM ʱӻȡ
 *
 * \param[in] p_hw_lptim : ָUALPTIMRTĴṹָ
 *
 * \return amhw_zsn700_lptim_clk_src_tö
 */
am_static_inline
amhw_zsn700_lptim_clk_src_t
amhw_zsn700_lptim_clk_src_get (amhw_zsn700_lptim_t *p_hw_lptim)
{
    return (amhw_zsn700_lptim_clk_src_t)((p_hw_lptim->cr >> 4) & 0x3ul);
}

/**
 * \brief TOG             ͬʱ0
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \note 0 TOG,TOGN ͬʱ0
 *       1 TOG,TOGN λ෴źšɹ buzzer ʹá
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_tog_disable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr &= ~(0x1ul << 3);
}

/**
 * \brief TOG ʹ            λ෴ź
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \note 0 TOG,TOGN ͬʱ0
 *       1 TOG,TOGN λ෴źšɹ buzzer ʹá
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_tog_enable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr |= (0x1ul << 3);
}

typedef enum {
    AMHW_ZSN700_LPTIM_FUNCTION_TIMER   = 0,    /* ʱ */
    AMHW_ZSN700_LPTIM_FUNCTION_COUNTER = 1,    /*  */
}amhw_zsn700_lptim_function_t;

/**
 * \brief /ʱѡ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 * \param[in] type       : amhw_zsn700_lptim_function_tö
 *
 * \note    ʱʹTCK_SELѡʱӽм
 *
 *          ʹⲿ½ؽмʱʹTCK_SELѡʱӣ
 *          ⲿʱҪ 1/2 ʱ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_function_sel (amhw_zsn700_lptim_t         *p_hw_lptim,
                                     amhw_zsn700_lptim_function_t type)
{
    p_hw_lptim->cr = (p_hw_lptim->cr & (~(0x1ul << 2))) |
                     ((type & 0x1ul) << 2);
}

typedef enum {
    AMHW_ZSN700_LPTIM_MODE_NORELOAD = 0,    /*  */
    AMHW_ZSN700_LPTIM_MODE_RELOAD   = 1,    /* Զװ */
}amhw_zsn700_lptim_mode_t;

/**
 * \brief ʱģʽѡ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 * \param[in] type       : amhw_zsn700_lptim_mode_tö
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_mode_sel (amhw_zsn700_lptim_t     *p_hw_lptim,
                                 amhw_zsn700_lptim_mode_t type)
{
    p_hw_lptim->cr = (p_hw_lptim->cr & (~(0x1ul << 1))) |
                     ((type & 0x1ul) << 1);
}

/**
 * \brief TR ʱ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_disable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr &= ~(0x1ul << 0);
}

/**
 * \brief TR ʱʹ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zsn700_lptim_enable (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->cr |= (0x1ul << 0);
}

/**
 * \brief ȡ־ǷЧ
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return AM_TRUE  : ־Ч
 *         AM_FALSE : ־Ч
 */
am_static_inline
am_bool_t amhw_zsn700_lptim_int_flag_check (amhw_zsn700_lptim_t *p_hw_lptim)
{
    return (p_hw_lptim->ifr & 0x1ul) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief ־
 *
 * \param[in] p_hw_lptim : ָLPTIMʱĴָ
 *
 * \return none
 */
am_static_inline
void amhw_zsn700_lptim_int_flag_clr (amhw_zsn700_lptim_t *p_hw_lptim)
{
    p_hw_lptim->iclr &= ~0x1ul;
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZSN700_LPTIM_H */

/* end of file */
