/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LPUARTLPUART׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-26  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZSL42x_LPUART_H
#define __AM_ZSL42x_LPUART_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_uart.h"
#include "hw/amhw_zsl42x_lpuart.h"

/**
 * \addtogroup am_zsl42x_if_lpuart
 * \copydoc am_zsl42x_lpuart.h
 * @{
 */

/**
 * \name ţصcodeݸûָǰĴ
 *
 *  صĲԭͣ\n
 *  int lpuart_err(void *p_arg, int code, void *p_data, int size);
 *  p_argûעûp_datasizeͬĴͰϢͬ
 *  ʹam_lpuart_callback_set() ôڴص
 * @{
 */

/**
 * \brief ûָжϷ,p_dataΪuint32_tֵΪڵж״̬
 *        ûжϾжԴsizeΪ1
 */
#define AM_ZSL42x_LPUART_ERRCODE_LPUART_OTHER_INT  3

/** @} */

/**
 * \brief 豸Ϣṹ壬豸Ϣڴڳʼ
 */
typedef struct am_zsl42x_lpuart_devinfo {

    uint32_t    lpuart_reg_base;    /**< \brief ָLPUARTĴָ */

    uint8_t     inum;               /**< \brief жϺ */

    amhw_zsl42x_lpuart_sclk_src_t sclk_src;   /**< \brief ͨŴʱ  */

    uint32_t    cfg_flags;          /**< \brief ñ־ */

    am_bool_t   asyn_hd;            /**< \brief 첽˫ģʽߣ־ */

    uint32_t    baud_rate;          /**< \brief ʼ */

    /**
     * \brief ָʹܵж,AMHW_ZSL42x_LPUART_INT_*ֵAMHW_ZSL42x_LPUART_INT_*
     */
    uint32_t    other_int_enable;

    /** \brief RS485 ƺ, AM_TRUE: ģʽ AM_FALSE: ģʽ */
    void (*pfn_rs485_dir) (am_bool_t is_txmode);

    void (*pfn_plfm_init)(void);    /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void);  /**< \brief ƽ̨ȥʼ */

} am_zsl42x_lpuart_devinfo_t;

/**
 * \brief 豸ṹ嶨
 */
typedef struct am_zsl42x_lpuart_dev {

    am_uart_serv_t  lpuart_serv; /**< \brief ׼LPUART */

    /** \brief ָûעtxchar_get */
    int (*pfn_txchar_get)(void *, char *);

    /** \brief ָûעrxchar_put */
    int (*pfn_rxchar_put)(void *, char);

    /** \brief ָûעĴص */
    int (*pfn_err)(void *, int, void *, int);

    void     *txget_arg;                    /**< \brief txchar_get */
    void     *rxput_arg;                    /**< \brief rxchar_put */
    void     *err_arg;                      /**< \brief صû */

    uint8_t   channel_mode;                 /**< \brief ģʽ ж/ѯ */
    uint32_t  clk_rate;                     /**< \brief ģʽʱƵ */
    uint32_t  baud_rate;                    /**< \brief ڲ */
    uint16_t  options;                      /**< \brief Ӳѡ */

    uint32_t  other_int_enable;             /**< \brief ָʹܵж */

    am_bool_t rs485_en;                     /**< \brief Ƿʹ 485 ģʽ */

    const am_zsl42x_lpuart_devinfo_t *p_devinfo; /**< \brief ָ豸Ϣָ */

} am_zsl42x_lpuart_dev_t;

/**
 * \brief ʼLPUARTLPUART׼
 *
 * \param[in] p_dev     : ָ򴮿豸ָ
 * \param[in] p_devinfo : ָ򴮿豸Ϣָ
 *
 * \return LPUART׼ֵΪNULLʱʼʧ
 */
am_uart_handle_t am_zsl42x_lpuart_init(am_zsl42x_lpuart_dev_t           *p_dev,
                                       const am_zsl42x_lpuart_devinfo_t *p_devinfo);

/**
 * \brief ʹLPUARTʱʼLPUARTͷԴ
 *
 * \param[in] p_dev : ָ򴮿豸ָ
 */
void am_zsl42x_lpuart_deinit (am_zsl42x_lpuart_dev_t *p_dev);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_LPUART_H */

/* end of file */
