/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief LVD  LVD ׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.01 20-04-27 zcb, Add callback function parameters
 * - 1.00 19-10-08
 * \endinternal
 */
#ifndef __AM_ZSL42x_LVD_H
#define __AM_ZSL42x_LVD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/**
 * \addtogroup am_zsl42x_if_lvd
 * \copydoc am_zsl42x_lvd.h
 * @{
 */
/**
 * \brief LVD豸Ϣṹ
 */
typedef struct am_zsl42x_lvd_info {

    /** \brief LVD Ĵַ */
    uint32_t                     reg_base;

    /** \brief LVD жϱ */
    uint8_t                      inum;

    /** \brief LVD  */
    uint32_t                     tri_type;

    /** \brief LVD ˲ʱ */
    int                          deb_time;

    /** \brief LVD ֵѹ */
    int                          vids;

    /** \brief LVD Դ */
    int                          src_sel;

    /** \brief LVD  */
    int                          tri_act;

    /** \brief LVD ƽ̨ʼʱӣŵȹ */
    void                       (*pfn_plfm_init)(void);

    /** \brief LVD ƽ̨ʼ */
    void                       (*pfn_plfm_deinit)(void);

}am_zsl42x_lvd_devinfo_t;

/**
 * \brief LVD豸ʵ
 */
typedef struct am_zsl42x_lvd_dev {

    /** \brief ָLVD豸Ϣָ */
    const am_zsl42x_lvd_devinfo_t *p_devinfo;

    /** \brief жϴص*/
    am_pfnvoid_t                 pfn_trigger_cb;

    /** \brief жϴص*/
    void                        *p_arg;

} am_zsl42x_lvd_dev_t;

/** \brief LVD ׼Ͷ */
typedef am_zsl42x_lvd_dev_t       *am_zsl42x_lvd_handle_t;

/**
 * \brief LVD ʼ
 *
 * \param[in] p_dev     : LVD 豸ʵ
 * \param[in] p_devinfo : LVD 豸Ϣʵ
 *
 * \retval : ׼LVD
 *
 */
am_zsl42x_lvd_handle_t am_zsl42x_lvd_init (am_zsl42x_lvd_dev_t           *p_dev,
                                       const am_zsl42x_lvd_devinfo_t *p_devinfo);

/**
 * \brief LVD ȥʼ
 *
 * \param[in] handle : ׼LVD
 *
 * \retval : 
 *
 */
void am_zsl42x_lvd_deinit (am_zsl42x_lvd_handle_t     handle);

/**
 * \brief LVD ʹ
 *
 * \param[in] handle : ׼LVD
 *
 * \retval AM_OK     : ʹܳɹ
 *         AM_ERROR  : ʹʧ
 *
 */
int am_zsl42x_lvd_enable (am_zsl42x_lvd_handle_t      handle);

/**
 * \brief LVD жϴ
 *
 * \param[in] handle     : ׼LVD
 * \param[in] pfn_tri_cb : ûĻص
 *
 * \retval AM_OK         : ӳɹ
 * \retval AM_ERROR      : ʧ
 */
int am_zsl42x_lvd_tri_set (am_zsl42x_lvd_handle_t     handle,
                         am_pfnvoid_t             pfn_tri_cb,
                         void                    *p_arg);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_LVD_H */

/* end of file */
