/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief Flashӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-10-08
 * \endinternal
 */

#ifndef __AM_ZSL42x_RAM_H
#define __AM_ZSL42x_RAM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "hw/amhw_zsl42x_ram.h"

/**
 * \addtogroup am_zsl42x_if_ram
 * \copydoc am_zsl42x_ram.h
 * @{
 */

/* RAMַΧ */
#define RAM_SIZE            0x7FFF
#define RAM_ADDRESS_BASE    0x20000000
#define RAM_ADDRESS_SIZE   (0x20000000 + RAM_SIZE)

/**
 * \brief RAMʼ
 *
 * \param[in] p_hw_ram ָRAMĴָ
 *
 * \return 
 */
void am_zsl42x_ram_init (amhw_zsl42x_ram_t *p_hw_ram);

/**
 * \brief RAM
 *
 * \param[in] p_hw_ram    ָRAMĴָ
 * \param[in] start_addr  ʼַ
 * \param[in] size        С
 *
 * \return >0: ִн, -AM_EINVAL: ַ
 */
int32_t am_zsl42x_ram_erase (amhw_zsl42x_ram_t *p_hw_ram,
                             uint32_t           start_addr,
                             uint16_t           size);

/**
 * \brief RAM
 *
 * \param[in] p_hw_ram   ָRAMĴָ
 * \param[in] dst_addr   д뵽ramʼַ
 * \param[in] p_src      Ҫд뵽ramеݵʼַ
 * \param[in] size       дֽڵĸ
 *
 * \retval i ʵʳɹд
 */
int32_t am_zsl42x_ram_write (amhw_zsl42x_ram_t *p_hw_ram,
                             uint32_t           dst_addr,
                             uint8_t           *p_src,
                             uint16_t           size);

/**
 * \brief RAMȡ
 *
 * \param[in] p_hw_ram   ָRAMĴָ
 * \param[in] dst_addr   ȡramʼַ
 * \param[in] p_src      Ҫȡramеݵʼַ
 * \param[in] size       ȡֽڵĸ
 *
 * \retval i ʵʳɹȡ
 */
int32_t am_zsl42x_ram_read (amhw_zsl42x_ram_t *p_hw_ram,
                            uint32_t           dst_addr,
                            uint8_t           *p_src,
                            uint16_t           size);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /** __AM_ZSL42x_RAM_H */
