/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-04  zp, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZSL42x_RCC_H
#define __AMHW_ZSL42x_RCC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "zsl42x_regbase.h"

/*
 * \brief ṹεĿʼ
 */
#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
#elif defined(__GNUC__)
#elif defined(__TMS470__)
#elif defined(__TASKING__)
  #pragma warning 586
#else
  #warning Not supported compiler t
#endif

/**
 * \addtogroup amhw_zsl42x_if_rcc
 * \copydoc amhw_zsl42x_rcc.h
 * @{
 */

/**
 * \brief CRCĴṹ
 */
typedef struct amhw_zsl42x_rcc {
  __IO uint32_t sysctrl[3];       /**< \brief ϵͳƼĴ012 */
  __IO uint32_t rch_cr;           /**< \brief ڲʱӿƼĴ */
  __IO uint32_t xth_cr;           /**< \brief ⲿʱӿƼĴ */
  __IO uint32_t rcl_cr;           /**< \brief ڲʱӿƼĴ */
  __IO uint32_t xtl_cr;            /**< \brief ⲿʱӿƼĴ */
  __IO uint32_t reserve0;         /**< \brief λ */
  __IO uint32_t peri_clken[2];    /**< \brief ʱʹܼĴ */
  __IO uint32_t reserve1[5];         /**< \brief λ */
  __IO uint32_t pll_cr;           /**< \brief PLLʱӿƼĴ */
} amhw_zsl42x_rcc_t;

#define ZSL42x_RCCCTRL            ((amhw_zsl42x_rcc_t *)ZSL42x_RCC_BASE)

/**
 * \brief ö
 */
typedef enum {

    /* peri_clken[0]ĴƵʹλ  */
    AMHW_ZSL42x_RCC_FLASH   = 31,
    AMHW_ZSL42x_RCC_DMA     = 29,
    AMHW_ZSL42x_RCC_GPIO    = 28,
    AMHW_ZSL42x_RCC_AES     = 27,
    AMHW_ZSL42x_RCC_CRC     = 26,
    AMHW_ZSL42x_RCC_SWD     = 25,
    AMHW_ZSL42x_RCC_TICK    = 24,
    AMHW_ZSL42x_RCC_LCD     = 22,
    AMHW_ZSL42x_RCC_TRIM    = 21,
    AMHW_ZSL42x_RCC_RTC     = 20,
    AMHW_ZSL42x_RCC_PCNT    = 19,
    AMHW_ZSL42x_RCC_RNG     = 18,
    AMHW_ZSL42x_RCC_VC      = 17,
    AMHW_ZSL42x_RCC_ADC     = 16,
    AMHW_ZSL42x_RCC_WDT     = 15,
    AMHW_ZSL42x_RCC_PCA     = 14,
    AMHW_ZSL42x_RCC_OPA     = 13,
    AMHW_ZSL42x_RCC_TIM3    = 11,
    AMHW_ZSL42x_RCC_ADVTIM  = 10,
    AMHW_ZSL42x_RCC_LPTIM0  = 9,
    AMHW_ZSL42x_RCC_BASETIM = 8,
    AMHW_ZSL42x_RCC_SPI1    = 7,
    AMHW_ZSL42x_RCC_SPI0    = 6,
    AMHW_ZSL42x_RCC_I2C1    = 5,
    AMHW_ZSL42x_RCC_I2C0    = 4,
    AMHW_ZSL42x_RCC_LPUART1 = 3,
    AMHW_ZSL42x_RCC_LPUART0 = 2,
    AMHW_ZSL42x_RCC_UART1   = 1,
    AMHW_ZSL42x_RCC_UART0   = 0,

    /* peri_clken[1]ĴƵʹλ  */
    AMHW_ZSL42x_RCC_UART3   = 9 + 31,
    AMHW_ZSL42x_RCC_UART2   = 8 + 31,
    AMHW_ZSL42x_RCC_LPTIM1  = 4 + 31,
    AMHW_ZSL42x_RCC_DAC     = 3 + 31,
}amhw_zsl42x_peripheral;

/**
 * \brief ϵͳʱԴ
 */
typedef enum {
    AMHW_ZSL42x_SYSCLK_RCH = 0,   /**< \brief ڲʱΪϵͳʱ */
    AMHW_ZSL42x_SYSCLK_XTH,       /**< \brief ⲿʱΪϵͳʱ */
    AMHW_ZSL42x_SYSCLK_RCL,       /**< \brief ڲʱΪϵͳʱ */
    AMHW_ZSL42x_SYSCLK_XTL,       /**< \brief ⲿʱΪϵͳʱ */
    AMHW_ZSL42x_SYSCLK_PLL = 4,   /**< \brief ڲPLLΪϵͳʱ */
}amhw_zsl42x_sys_clk_src;

/**
 * \brief HCLKʱԴ
 */
typedef enum {
    AMHW_ZSL42x_HCLK_SYSCLK = 0,        /**< \brief ϵͳʱ/1  ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV2,       /**< \brief ϵͳʱ/2  ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV4,       /**< \brief ϵͳʱ/4  ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV8,       /**< \brief ϵͳʱ/8  ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV16,      /**< \brief ϵͳʱ/16 ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV32,      /**< \brief ϵͳʱ/32 ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV64,      /**< \brief ϵͳʱ/64 ΪHCLKԴ */
    AMHW_ZSL42x_HCLK_SYSCLK_DIV128,     /**< \brief ϵͳʱ/128ΪHCLKԴ */
}amhw_zsl42x_hclk_src;

/**
 * \brief PCLKʱԴ
 */
typedef enum {
    AMHW_ZSL42x_PCLK_HCLK = 0,        /**< \brief HCLKʱ/1  ΪPCLKԴ */
    AMHW_ZSL42x_PCLK_HCLK_DIV2,       /**< \brief HCLKʱ/2  ΪPCLKԴ */
    AMHW_ZSL42x_PCLK_HCLK_DIV4,       /**< \brief HCLKʱ/4  ΪPCLKԴ */
    AMHW_ZSL42x_PCLK_HCLK_DIV8,       /**< \brief HCLKʱ/8  ΪPCLKԴ */
}amhw_zsl42x_pclk_src;

/**
 * \brief SYSCTRL2 Ĵ SYSCTL0SYSCTRL1ϵпƼĴ
 *
 * \param[in]  data д
 *
 * \note Ĵ SYSCTL0SYSCTRL1ϵпƼĴ
 *        SYSCTRL2д0x5A5Aд 0xA5A5ڼĴ SYSCTL0SYSCTRL1д
 *       ֻҪԼĴ SYSCTL0 SYSCTRL1дˣλԶظ״̬Ҫдϵд򿪱
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_set_start (uint16_t data)
{
    ZSL42x_RCCCTRL->sysctrl[2] = data;
}

/**
 * \brief  wakeup_byRCH  deepsleepѺϵͳʱԴΪRCHԭʱӼʹ
 *
 * \return 
 *
 */
am_static_inline
void amhw_zsl42x_rcc_wakeup_sysclk_rch (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 15);
}

/**
 * \brief wakeup_byRCH  deepsleepѺ󣬲ıϵͳʱԴ
 *
 * \return 
 *
 */
am_static_inline
void amhw_zsl42x_rcc_wakeup_sysclk_nochange (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 15);
}

/**
 * \brief PCLK_PRS PCLKʱԴл
 *
 * \param[in]  src PCLKʱԴ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pclk_set (amhw_zsl42x_pclk_src src)
{

    ZSL42x_RCCCTRL->sysctrl[0] = (ZSL42x_RCCCTRL->sysctrl[0] & ~(0x3ul << 11)) |
                                 ((src & 0x3ul) << 11);
}

/**
 * \brief HCLK_PRS HCLKʱԴл
 *
 * \param[in]  src HCLKʱԴ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_hclk_set (amhw_zsl42x_hclk_src src)
{

    ZSL42x_RCCCTRL->sysctrl[0] = (ZSL42x_RCCCTRL->sysctrl[0] & ~(0x7ul << 8)) |
                                 ((src & 0x7ul) << 8);
}

/**
 * \brief CLKSW ϵͳʱԴл
 *
 * \param[in]  src ϵͳʱԴ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_sys_clk_set (amhw_zsl42x_sys_clk_src src)
{

    ZSL42x_RCCCTRL->sysctrl[0] &= ~(0x7ul << 5);

    amhw_zsl42x_rcc_set_start(0x5A5A);
    amhw_zsl42x_rcc_set_start(0xA5A5);
    ZSL42x_RCCCTRL->sysctrl[0] |= (src  << 5);
}

/**
 * \brief PLL_EN PLL
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 4);
}

/**
 * \brief PLL_EN PLLʹ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 4);
}

/**
 * \brief XTL_EN ⲿپXTL
 *
 * \note ҪPC14 PC15óģ˿.
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 3);
}

/**
 * \brief XTL_EN ⲿپXTLʹ
 *
 * \note ҪPC14 PC15óģ˿.
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 3);
}

/**
 * \brief RCL_EN ڲʱRCL
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rcl_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 2);
}

/**
 * \brief RCL_EN ڲʱRCLʹ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rcl_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 2);
}

/**
 * \brief ȡڲʱRCLǷʹ
 *
 * \return 
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_rcl_enable_get (void)
{
    return (ZSL42x_RCCCTRL->sysctrl[0] & (1ul << 2)) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief XTH_EN ⲿپXTH
 *
 * \note ϵͳDeepSleep˸ʱӻԶرա
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 1);
}

/**
 * \brief XTH_EN ⲿپXTHʹ
 *
 * \note ϵͳDeepSleep˸ʱӻԶرա
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 1);
}

/**
 * \brief RCH_EN ڲʱRCH
 *
c
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rch_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] &= ~(1ul << 0);
}

/**
 * \brief RCH_EN ڲʱRCHʹ
 *
 * \note ϵͳDeepSleep˸ʱӻԶرա
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rch_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[0] |= (1ul << 0);
}

/**
 * \brief ȡڲʱRCHǷʹ
 *
 * \return 
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_rch_enable_get (void)
{
    return (ZSL42x_RCCCTRL->sysctrl[0] & (1ul << 0)) ? AM_TRUE : AM_FALSE;
}

/**
 * \brief RTCʱӲʱƵѡ
 */
typedef enum {
    AMHW_ZSL42x_RTCCLK_ADJUST_4M = 0,    /**< \brief 4  MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_6M,        /**< \brief 6  MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_8M,        /**< \brief 8  MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_10M,       /**< \brief 10 MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_16M,       /**< \brief 16 MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_20M,       /**< \brief 20 MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_24M,       /**< \brief 24 MHzʱƵ */
    AMHW_ZSL42x_RTCCLK_ADJUST_32M,       /**< \brief 32 MHzʱƵ */
}amhw_zsl42x_rtcclk_adjust;

/**
 * \brief RTC_FREQ_ADJUST RTCʱӲʱƵѡ
 *
 * \param[in]  choice ʱƵ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rtcclk_adjust_set (amhw_zsl42x_rtcclk_adjust choice)
{
    ZSL42x_RCCCTRL->sysctrl[1] = (ZSL42x_RCCCTRL->sysctrl[1] & (~(0x7ul << 9))) |
                                 ((choice & 0x7ul) << 9);
}


/**
 * \brief SWD_USE_IO SWD˿ڹãSWD
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_swdio_debug (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] &= ~(1ul << 8);
}

/**
 * \brief SWD_USE_IO SWD˿ڹãGPIO
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_swdio_gpio (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] |= (1ul << 8);
}

/**
 * \brief LOCKUP_EN Cortex-M0+ LockUp
 *
 * \note ʹܺCPUЧָʱḴλMCUǿϵͳɿԡ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_lockup_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] &= ~(1ul << 6);
}

/**
 * \brief LOCKUP_EN Cortex-M0+ LockUpʹ
 *
 * \note ʹܺCPUЧָʱḴλMCUǿϵͳɿԡ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_lockup_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] |= (1ul << 6);
}

/**
 * \brief RTC_LPW RTCģ͹Ľ
 *
 * \note ʹܺ RTCģ͹״̬ĴԶд
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rtc_lowpower_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] &= ~(1ul << 5);
}

/**
 * \brief RTC_LPW RTCģ͹ʹ
 *
 * \note ʹܺ RTCģ͹״̬ĴԶд
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rtc_lowpower_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] |= (1ul << 5);
}

/**
 * \brief XTL_ALWAYS_ON XTL߼ʹܿƽ
 *
 * \note ʹܺ sysctrl[0].XTL_ENֻλ
 *       ܺ sysctrl[0].XTL_ENλ㡣
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_alwayson_disable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] &= ~(1ul << 3);
}

/**
 * \brief XTL_ALWAYS_ON XTL߼ʹܿʹ
 *
 * \note ʹܺ sysctrl[0].XTL_ENֻλ
 *       ܺ sysctrl[0].XTL_ENλ㡣
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_alwayson_enable (void)
{
    ZSL42x_RCCCTRL->sysctrl[1] |= (1ul << 3);
}


/**
 * \brief ⲿ XTLʱ
 */
typedef enum {
    AMHW_ZSL42x_XTL_INPUT_XTAL = 0,    /**< \brief XTLɾ */
    AMHW_ZSL42x_XTL_INPUT_PC14,        /**< \brief XTL PC14 */
}amhw_zsl42x_xtl_input;

/**
 * \brief EXTL_EN XTLʱ
 *
 * \param[in]  choice XTLʱѡ
 *
 * \note ʹPC14ʱʱsysctrl[0].XTL_ENΪ1
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_input_set (amhw_zsl42x_xtl_input choice)
{
    ZSL42x_RCCCTRL->sysctrl[1] = (ZSL42x_RCCCTRL->sysctrl[1] & (~(0x1ul << 2))) |
                                 ((choice & 0x1ul) << 2);
}

/**
 * \brief ⲿ XTHʱ
 */
typedef enum {
    AMHW_ZSL42x_XTH_INPUT_XTAL = 0,    /**< \brief XTHɾ */
    AMHW_ZSL42x_XTH_INPUT_PF00,        /**< \brief XTHPF00 */
}amhw_zsl42x_xth_input;

/**
 * \brief EXTH_EN XTHʱ
 *
 * \param[in]  choice XTHʱѡ
 *
 * \note ʹPC14ʱʱsysctrl[0].XTH_ENΪ1
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_input_set (amhw_zsl42x_xth_input choice)
{
    ZSL42x_RCCCTRL->sysctrl[1] = (ZSL42x_RCCCTRL->sysctrl[1] & (~(0x1ul << 1))) |
                                 ((choice & 0x1ul) << 1);
}


/**
 * \brief stable RCHʱȶ־λ
 *
 * \retval TRUE  : ѾȶԱڲ·ʹá
 * \retval FALSE : δȶԱڲ·ʹá
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_rch_state_get (void)
{
    return (am_bool_t)((ZSL42x_RCCCTRL->rch_cr & (0x1ul << 11)) ?
                       AM_TRUE :
                       AM_FALSE);
}

typedef enum {
    AMHW_ZSL42x_RCH_FRE_24MHz = 0x00100C00,
    AMHW_ZSL42x_RCH_FRE_22MHz = 0x00100C02,   // 22.12MHz
    AMHW_ZSL42x_RCH_FRE_16MHz = 0x00100C04,
    AMHW_ZSL42x_RCH_FRE_8MHz = 0x00100C06,
    AMHW_ZSL42x_RCH_FRE_4MHz = 0x00100C08,
}amhw_zsl42x_rch_fre_t;
/**
 * \brief TRIM ʱƵʵ
 *
 * \param[in]  data д
 *
 * \note ʱƵʵ Flashб5ƵʵУ׼ֵ
 *       FlashڵУ׼ֵдRCH_CR.TRIMɻþ׼Ƶʡ
 *
 *       24MУ׼ֵַ          0x00100C00 - 0x00100C01
 *       22.12MУ׼ֵַ 0x00100C02 - 0x00100C03
 *       16MУ׼ֵַ          0x00100C04 - 0x00100C05
 *       8MУ׼ֵַ             0x00100C06 - 0x00100C07
 *       4MУ׼ֵַ             0x00100C08 - 0x00100C09
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rch_trim_set (uint16_t data)
{
    ZSL42x_RCCCTRL->rch_cr = (ZSL42x_RCCCTRL->rch_cr & (~0x07FFul)) |
                         (data & 0x07FFul);
}

/**
 * \brief TRIM ʱƵʻȡ
 *
 * \return ĴڲʱƵУ׼ֵ
 */
am_static_inline
uint16_t amhw_zsl42x_rcc_rch_trim_get (void)
{
    return (ZSL42x_RCCCTRL->rch_cr & 0x07FFul);
}

/**
 * \brief stable XTHʱȶ־λ
 *
 * \retval TRUE  : ѾȶԱڲ·ʹá
 * \retval FALSE : δȶԱڲ·ʹá
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_xth_state_get (void)
{
    return (am_bool_t)((ZSL42x_RCCCTRL->xth_cr & (0x1ul << 6)) ?
                       AM_TRUE :
                       AM_FALSE);
}


/**
 * \brief ⲿʱXTHȶʱѡ
 */
typedef enum {
    AMHW_ZSL42x_XTH_WAITTIME_256 = 0,       /**< \brief ȶʱΪ256 */
    AMHW_ZSL42x_XTH_WAITTIME_1024,          /**< \brief ȶʱΪ1024 */
    AMHW_ZSL42x_XTH_WAITTIME_4096,          /**< \brief ȶʱΪ4096 */
    AMHW_ZSL42x_XTH_WAITTIME_16384,         /**< \brief ȶʱΪ16384 */
}amhw_zsl42x_xth_waittime;

/**
 * \brief Startup ⲿʱXTHȶʱѡ
 *
 * \param[in]  data д
 *
 * \note ǿҽ齫 XTH ȶʱΪ 11AMHW_ZSL42x_XTH_WAITTIME_16384
 *       XTHȶʱ䲻㣬ڽʱлʱ߻ʱϵͳȶ
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_waittime_set (amhw_zsl42x_xth_waittime time_set)
{
    ZSL42x_RCCCTRL->xth_cr = (ZSL42x_RCCCTRL->xth_cr & (~(0x3ul << 4))) |
                         ((time_set & 0x3ul) << 4);
}

/**
 * \brief ⲿƵѡ
 */
typedef enum {
    AMHW_ZSL42x_XTH_XTAL_FRE_4_8 = 0,       /**< \brief 4M~6M */
    AMHW_ZSL42x_XTH_XTAL_FRE_8_16,          /**< \brief 6M~12M */
    AMHW_ZSL42x_XTH_XTAL_FRE_16_24,         /**< \brief 12M~20M */
    AMHW_ZSL42x_XTH_XTAL_FRE_24_32,         /**< \brief 20M~32M */
}amhw_zsl42x_xth_xtal_fre;

/**
 * \brief xth_fsel ⲿƵѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_xtal_fre_set (amhw_zsl42x_xth_xtal_fre fre)
{
    ZSL42x_RCCCTRL->xth_cr = (ZSL42x_RCCCTRL->xth_cr & (~(0x3ul << 2))) |
                         ((fre & 0x3ul) << 2);
}

/**
 * \brief ⲿѡ
 */
typedef enum {
    AMHW_ZSL42x_XTH_XTAL_DRIVER_MIN = 0,       /**< \brief  */
    AMHW_ZSL42x_XTH_XTAL_DRIVER_SMALL,         /**< \brief  */
    AMHW_ZSL42x_XTH_XTAL_DRIVER_DEFAULT,       /**< \brief Ĭ (Ƽֵ) */
    AMHW_ZSL42x_XTH_XTAL_DRIVER_MAX,           /**< \brief ǿ */
}amhw_zsl42x_xth_xtal_driver;

/**
 * \brief Driver ⲿѡ
 *
 * \param[in]  data д
 *
 * \note ҪݾԡصԼ·ļѡʵ
 *       Խ򹦺ԽԽ򹦺ԽС
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xth_xtal_driver_set (amhw_zsl42x_xth_xtal_driver driver_set)
{
    ZSL42x_RCCCTRL->xth_cr = (ZSL42x_RCCCTRL->xth_cr & (~(0x3ul << 0))) |
                             ((driver_set & 0x3ul) << 0);
}

/**
 * \brief stable RCLʱȶ־λ
 *
 * \retval TRUE  : ѾȶԱڲ·ʹá
 * \retval FALSE : δȶԱڲ·ʹá
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_rcl_state_get (void)
{
    return (am_bool_t)((ZSL42x_RCCCTRL->rcl_cr & (0x1ul << 12)) ?
                       AM_TRUE :
                       AM_FALSE);
}

/**
 * \brief ڲʱRCLȶʱѡ
 */
typedef enum {
    AMHW_ZSL42x_RCL_WAITTIME_4 = 0,       /**< \brief ȶʱΪ4 */
    AMHW_ZSL42x_RCL_WAITTIME_16,          /**< \brief ȶʱΪ16 */
    AMHW_ZSL42x_RCL_WAITTIME_64,          /**< \brief ȶʱΪ64 */
    AMHW_ZSL42x_RCL_WAITTIME_256,         /**< \brief ȶʱΪ256 */
}amhw_zsl42x_rcl_waittime;

/**
 * \brief Startup ڲʱRCLȶʱѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rcl_waittime_set (amhw_zsl42x_rcl_waittime time_set)
{
    ZSL42x_RCCCTRL->rcl_cr = (ZSL42x_RCCCTRL->rcl_cr & (~(0x3ul << 10))) |
                             ((time_set & 0x3ul) << 10);
}

typedef enum {
    AMHW_ZSL42x_RCl_FRE_38400Hz = 0x00100C20,
    AMHW_ZSL42x_RCl_FRE_32768Hz = 0x00100C22,
}amhw_zsl42x_rcl_fre_t;

/**
 * \brief TRIM ʱƵʵ
 *
 * \param[in]  data д
 *
 * \note ڲʱƵʵ Flashб2ƵʵУ׼ֵ
 *       FlashڵУ׼ֵдRCL_CR.TRIMɻþ׼Ƶʡ
 *
 *       38.4KУ׼ֵַ       0x00100C20 - 0x00100C21
 *       32.768KУ׼ֵַ 0x00100C22 - 0x00100C23
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_rcl_trim_set (uint16_t data)
{
    ZSL42x_RCCCTRL->rcl_cr = (ZSL42x_RCCCTRL->rcl_cr & (~0x03FFul)) |
                         (data & 0x03FFul);
}

/**
 * \brief TRIM ʱƵʻȡ
 *
 * \return ĴڲʱƵУ׼ֵ
 */
am_static_inline
uint16_t amhw_zsl42x_rcc_rcl_trim_get (void)
{
    return (ZSL42x_RCCCTRL->rcl_cr & 0x07FFul);
}

/**
 * \brief stable XTLʱȶ־λ
 *
 * \retval TRUE  : ѾȶԱڲ·ʹá
 * \retval FALSE : δȶԱڲ·ʹá
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_xtl_state_get (void)
{
    return (am_bool_t)((ZSL42x_RCCCTRL->xtl_cr & (0x1ul << 6)) ?
                       AM_TRUE :
                       AM_FALSE);
}

/**
 * \brief ڲʱRCLȶʱѡ
 */
typedef enum {
    AMHW_ZSL42x_XTL_WAITTIME_256 = 0,       /**< \brief ȶʱΪ256 */
    AMHW_ZSL42x_XTL_WAITTIME_1024,          /**< \brief ȶʱΪ1024 */
    AMHW_ZSL42x_XTL_WAITTIME_4096,          /**< \brief ȶʱΪ4096 */
    AMHW_ZSL42x_XTL_WAITTIME_16384,         /**< \brief ȶʱΪ16384 */
}amhw_zsl42x_xtl_waittime;

/**
 * \brief Startup ڲʱXTLȶʱѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_waittime_set (amhw_zsl42x_xtl_waittime time_set)
{
    ZSL42x_RCCCTRL->xtl_cr = (ZSL42x_RCCCTRL->xtl_cr & (~(0x3ul << 4))) |
                             ((time_set & 0x3ul) << 4);
}

/**
 * \brief XTL񵴷ȵĵ
 */
typedef enum {
    AMHW_ZSL42x_XTL_XTAL_AMPLITUDE_MIN = 0,       /**< \brief С */
    AMHW_ZSL42x_XTL_XTAL_AMPLITUDE_NORMAL,        /**< \brief  */
    AMHW_ZSL42x_XTL_XTAL_AMPLITUDE_BIG_DEFAULT,   /**< \brief ϴƼֵ */
    AMHW_ZSL42x_XTL_XTAL_AMPLITUDE_MAX,           /**< \brief  */
}amhw_zsl42x_xtl_xtal_amplitude;

/**
 * \brief Driver XTL񵴷ȵĵ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_xtal_amplitude_set (amhw_zsl42x_xtl_xtal_amplitude driver_set)
{
    ZSL42x_RCCCTRL->xtl_cr = (ZSL42x_RCCCTRL->xtl_cr & (~(0x3ul << 2))) |
                             ((driver_set & 0x3ul) << 2);
}

/**
 * \brief ⲿѡ
 */
typedef enum {
    AMHW_ZSL42x_XTL_XTAL_DRIVER_MIN = 0,       /**< \brief  */
    AMHW_ZSL42x_XTL_XTAL_DRIVER_DEFAULT,       /**< \brief һ Ƽֵ */
    AMHW_ZSL42x_XTL_XTAL_DRIVER_BIG,           /**< \brief ǿ */
    AMHW_ZSL42x_XTL_XTAL_DRIVER_MAX,           /**< \brief ǿ */
}amhw_zsl42x_xtl_xtal_driver;

/**
 * \brief Driver ⲿپѡ
 *
 * \param[in]  data д
 *
 * \note ҪݾԡصԼ·ļѡʵ
 *       Խ򹦺ԽԽ򹦺ԽС
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_xtl_xtal_driver_set (amhw_zsl42x_xtl_xtal_driver driver_set)
{
    ZSL42x_RCCCTRL->xtl_cr = (ZSL42x_RCCCTRL->xtl_cr & (~(0x3ul << 0))) |
                             ((driver_set & 0x3ul) << 0);
}

/**
 * \brief stable PLLȶ־
 *
 * \retval TRUE  : ѾȶԱڲ·ʹá
 * \retval FALSE : δȶԱڲ·ʹá
 */
am_static_inline
am_bool_t amhw_zsl42x_rcc_pll_state_get (void)
{
    return (am_bool_t)((ZSL42x_RCCCTRL->pll_cr & (0x1ul << 18)) ?
                       AM_TRUE :
                       AM_FALSE);
}

/**
 * \brief PLLȶʱѡ
 */
typedef enum {
    AMHW_ZSL42x_PLL_WAITTIME_128 = 0,      /**< \brief ȶʱΪ128 */
    AMHW_ZSL42x_PLL_WAITTIME_256,          /**< \brief ȶʱΪ256 */
    AMHW_ZSL42x_PLL_WAITTIME_512,          /**< \brief ȶʱΪ512 */
    AMHW_ZSL42x_PLL_WAITTIME_1024,         /**< \brief ȶʱΪ1024 */
    AMHW_ZSL42x_PLL_WAITTIME_2048,         /**< \brief ȶʱΪ2048 */
    AMHW_ZSL42x_PLL_WAITTIME_4096,         /**< \brief ȶʱΪ4096 */
    AMHW_ZSL42x_PLL_WAITTIME_8192,         /**< \brief ȶʱΪ8192 */
    AMHW_ZSL42x_PLL_WAITTIME_16384,        /**< \brief ȶʱΪ16384 */
}amhw_zsl42x_pll_waittime;

/**
 * \brief Startup PLLȶʱѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_waittime_set (amhw_zsl42x_pll_waittime time_set)
{
    ZSL42x_RCCCTRL->pll_cr = (ZSL42x_RCCCTRL->pll_cr & (~(0x7ul << 15))) |
                         ((time_set & 0x7ul) << 15);
}

/**
 * \brief PLLƵѡ
 */
typedef enum {
    AMHW_ZSL42x_PLL_INPUT_FRE_4_6 = 0,       /**< \brief 4M~6M */
    AMHW_ZSL42x_PLL_INPUT_FRE_6_12,          /**< \brief 6M~12M */
    AMHW_ZSL42x_PLL_INPUT_FRE_12_20,         /**< \brief 12M~20M */
    AMHW_ZSL42x_PLL_INPUT_FRE_20_24,         /**< \brief 20M~32M */
}amhw_zsl42x_pll_input_fre;

/**
 * \brief FRSEL PLLƵѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_input_fre_set (amhw_zsl42x_pll_input_fre fre)
{
    ZSL42x_RCCCTRL->pll_cr = (ZSL42x_RCCCTRL->pll_cr & (~(0x3ul << 13))) |
                             ((fre & 0x3ul) << 13);
}

/**
 * \brief DIVN PLLʱӵıƵϵ
 *
 * \param[in]  data д, Χ0X2~0XC
 *
 * \note Ƶ = DIVN*Ƶʣ
 *       data Χ0X2~0XC
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_divn_set (uint8_t data)
{
    ZSL42x_RCCCTRL->pll_cr = (ZSL42x_RCCCTRL->pll_cr & (~(0xful << 5))) |
                             ((data & 0xful) << 5);
}

/**
 * \brief PLLƵʷΧѡ
 */
typedef enum {
    AMHW_ZSL42x_PLL_OUTPUT_FRE_8_12 = 0,      /**< \brief 8M~12M  */
    AMHW_ZSL42x_PLL_OUTPUT_FRE_12_18,         /**< \brief 12M~18M */
    AMHW_ZSL42x_PLL_OUTPUT_FRE_18_24,         /**< \brief 18M~24M */
    AMHW_ZSL42x_PLL_OUTPUT_FRE_24_36,         /**< \brief 24M~36M */
    AMHW_ZSL42x_PLL_OUTPUT_FRE_36_48,         /**< \brief 36M~48M */
}amhw_zsl42x_pll_output_fre;

/**
 * \brief FOSC PLLƵʷΧѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_output_fre_set (amhw_zsl42x_pll_output_fre fre)
{
    ZSL42x_RCCCTRL->pll_cr = (ZSL42x_RCCCTRL->pll_cr & (~(0x7ul << 2))) |
                             ((fre & 0x7ul) << 2);
}

/**
 * \brief PLLʱѡ
 */
typedef enum {
    AMHW_ZSL42x_PLL_INPUT_FRE_SRC_XTH_XTAL = 0,   /**< \brief XTHɵʱ  */
    AMHW_ZSL42x_PLL_INPUT_FRE_SRC_XTH_PF00 = 1,   /**< \brief XTHӹܽPF00ʱ */
    AMHW_ZSL42x_PLL_INPUT_FRE_SRC_RCH      = 3,   /**< \brief RCHʱ */
}amhw_zsl42x_pll_input_fre_src;

/**
 * \brief FRSEL PLLʱѡ
 *
 * \param[in]  data д
 *
 * \return 
 */
am_static_inline
void amhw_zsl42x_rcc_pll_input_fre_src_set (amhw_zsl42x_pll_input_fre_src fre)
{
    ZSL42x_RCCCTRL->pll_cr = (ZSL42x_RCCCTRL->pll_cr & (~0x3ul)) |
                             (fre & 0x3ul);
}

/**
 * \brief ʹ
 *
 * \param[in]  peri Ҫʹܵ
 *
 * \return 
 *
 */
void amhw_zsl42x_rcc_peripheral_enable (amhw_zsl42x_peripheral peri);

/**
 * \brief ĳʱǷʹ
 *
 * \param[in]  peri Ҫʹܵ
 *
 * \return 1: ǰʱʹܣٴʹ
 *         0: ǰʱδʹ
 *
 */
int amhw_zsl42x_rcc_peripheral_enable_check (amhw_zsl42x_peripheral peri);

/**
 * \brief 
 *
 * \param[in]  peri Ҫܵ
 *
 * \return 
 *
 */
void amhw_zsl42x_rcc_peripheral_disable (amhw_zsl42x_peripheral peri);

/**
 * @}
 */
/*
 * \brief ṹεĽ
 */

#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)
#elif defined(__GNUC__)
#elif defined(__TMS470__)
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler t
#endif

#ifdef __cplusplus
}
#endif /* __ZSL42x_RCC_H */

#endif

/* end of file */
