/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief SDIOSDIO׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-06-04  ipk, first implementation
 * \endinternal
 */

#ifndef __AM_ZMF159_SDIO_H
#define __AM_ZMF159_SDIO_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_int.h"
#include "am_sdio.h"
#include "am_list.h"
#include "am_wait.h"
#include "am_softimer.h"

#include "am_vdebug.h"

/**
 * \addtogroup am_zlg_if_sdio
 * \copydoc am_zlg_sdio.h
 * @{
 */

/**
 * \brief SDIO豸Ϣṹ
 */
typedef struct am_zmf159_sdio_devinfo {

    /** \brief SDIOĴַ */
    uint32_t              regbase;

    /** \brief SDIOжϺ */
    uint32_t              inum;

    /** \brief SDIOʱID */
    int                   clk_num;

    /** \brief SDIOģʽ */
    uint8_t               speed_mode;

    /** \brief ƽ̨ʼ */
    void    (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void    (*pfn_plfm_deinit)(void);

} am_zmf159_sdio_devinfo_t;

/**
 * \brief SDIO豸ṹ
 */
typedef struct am_zmf159_sdio_dev {

    /** \brief SDIO׼  */
    am_sdio_serv_t                  sdio_serv;

    /** \brief ָSDIO豸Ϣ  */
    const am_zmf159_sdio_devinfo_t *p_devinfo;

    /** \brief waitȴ  */
    am_wait_t                       wait;

    /** \brief ж״̬  */
    uint16_t                        int_status;

} am_zmf159_sdio_dev_t;

/**
 * \brief SDIOʼ
 *
 * \param[in] p_dev     : ָSDIO豸ṹָ
 * \param[in] p_devinfo : ָSDIO豸Ϣṹָ
 *
 * \return SDIO׼
 */
am_sdio_handle_t am_zmf159_sdio_init (am_zmf159_sdio_dev_t           *p_dev,
                                     const am_zmf159_sdio_devinfo_t *p_devinfo);

/**
 * \brief SDIOʼ
 *
 * \param[in] handle : 豸SDIO׼
 *
 * \return 
 */
void am_zmf159_sdio_deinit (am_sdio_handle_t handle);

/** @} */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZMF159_SDIO_H */

/* end of file */
