/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg118.cn/
*******************************************************************************/

/**
 * \file
 * \brief SPISPI׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-17  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_SPI_INT_H
#define __AM_ZLG118_SPI_INT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_zlg118_spi_int.h"

#include "am_types.h"
#include "am_spi.h"
#include "am_int.h"

#include "hw/amhw_zlg118_spi.h"

/**
 * \addtogroup am_zlg118_if_spi_int
 * \copydoc am_zlg118_spi_int.h
 * @{
 */

/**
 * \name SPIģʽ
 * @{
 */

/** @} */

/**
 * \brief SPI豸Ϣṹ
 */
typedef struct am_zlg118_spi_int_devinfo {
    uint32_t  spi_reg_base;   /**< \brief SPIĴĻַ */
    int       clk_id;         /**< \brief ʱID */
    uint16_t  inum;           /**< \brief SPIжϱ */
    uint32_t  flags;          /**< \brief SPIñʶ */

    uint16_t  mosi_pin;       /**< brief mosiź */

    /** \brief SPIƽ̨ʼʱӣŵȹ */
    void    (*pfn_plfm_init)(void);

    /** \brief SPIƽ̨ʼ */
    void    (*pfn_plfm_deinit)(void);

} am_zlg118_spi_int_devinfo_t;

/**
 * \brief SPI豸
 */
typedef struct am_zlg118_spi_int_dev {

    am_spi_serv_t                   spi_serve;         /**< \brief SPI׼ */
    const am_zlg118_spi_int_devinfo_t *p_devinfo; /**< \brief SPI豸Ϣָ */

    struct am_list_head             msg_list;          /**< \brief SPIϢ */

    /** \brief ָSPIϢṹָ,ͬһʱֻܴһϢ */
    am_spi_message_t          *p_cur_msg;

    /** \brief ָSPIṹָ,ͬһʱֻܴһ */
    am_spi_transfer_t         *p_cur_trans;

    am_spi_device_t           *p_cur_spi_dev;     /**< \brief ǰSPI豸 */
    am_spi_device_t           *p_tgl_dev;         /**< \brief ǰSPI豸 */

    uint32_t                   nbytes_to_recv;    /**< \brief յֽ */
    uint32_t                   data_ptr;          /**< \brief ݴ */

    am_bool_t                  lsbfirst;          /**< \brief λȷͱ־ */
    am_bool_t                  busy;              /**< \brief SPIæʶ */
    uint32_t                   state;             /**< \brief SPI״̬״̬ */

} am_zlg118_spi_int_dev_t;

/**
 * \brief SPIʼ
 *
 * \param[in] p_dev     : ָSPI豸ṹָ
 * \param[in] p_devinfo : ָSPI豸Ϣṹָ
 *
 * \return SPI׼
 */
am_spi_handle_t am_zlg118_spi_int_init (am_zlg118_spi_int_dev_t              *p_dev,
                                        const am_zlg118_spi_int_devinfo_t *p_devinfo);

/**
 * \brief SPIʼ
 *
 * \param[in] handle : SPI׼
 *
 * \return 
 */
void am_zlg118_spi_int_deinit (am_spi_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG118_SPI_INT_H */

/* end of file */
