/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief SPI ӻ SPI ӻ׼ӿ
 *
 * \internal
 * \par Modification History
 * -1.00 17-09-15 fra, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_SPI_SLV_DMA_H
#define __AM_ZLG_SPI_SLV_DMA_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_spi_slv.h"
#include "am_softimer.h"
#include "am_zlg_dma.h"
#include "hw/amhw_zlg_dma.h"

/**
 * \addtogroup am_zlg_if_spi_slv_dma
 * \copydoc am_zlg_spi_slv_dma.h
 * @{
 */

/**
 * \brief SPI ӻ豸Ϣṹ
 */
typedef struct am_zml165_spi_slv_dma_devinfo {
    uint32_t spi_reg_base;           /**< \brief ӻ SPI ĴĻַ */
    int      clk_id;                 /**< \brief ʱ ID */
    uint32_t dma_chan_tx;            /**< \brief DMA ͨ */
    uint32_t dma_chan_rx;            /**< \brief DMA ͨ */
    int      cs_pin;                 /**< \breif Ƭѡ */
    void   (*pfn_plfm_init)(void);   /**< \brief SPI ƽ̨ʼ */
    void   (*pfn_plfm_deinit)(void); /**< \brief SPI ƽ̨ʼ */
} am_zlg_spi_slv_dma_devinfo_t;

/**
 * \brief SPI 豸ṹ
 */
typedef struct am_zml165_spi_slv_dma_dev {

    /** \brief SPI ӻ׼ */
    am_spi_slv_serv_t                      spi_slv_serve;

    /** \brief SPI ӻ豸Ϣָ */
    const am_zlg_spi_slv_dma_devinfo_t    *p_devinfo;

    /** \brief ӻ豸  */
    am_spi_slv_device_t                   *p_spi_slv_dev;

    /** \brief  */
    am_spi_slv_transfer_t                  tansfer;

    /** \brief ƬѡЧƬѡЧֽ */
    size_t                                 sum_nbytes;

    /** \brief DMA ͨ */
    amhw_zlg_dma_xfer_desc_t               g_desc[2];

    uint32_t                               dma_flags;

    /** \breif ܵݻͿ */
    uint32_t                               dummy_dma_flags;

    uint32_t                               dummy_txbuf;

    uint32_t                               dummy_rxbuf;

} am_zlg_spi_slv_dma_dev_t;

/**
 * \brief SPI ӻʼ
 *
 * \param[in] p_dev     ָ SPI 豸ṹָ
 * \param[in] p_devinfo ָ SPI 豸Ϣṹָ
 *
 * \return SPI ׼
 */
am_spi_slv_handle_t
am_zlg_spi_slv_dma_init (am_zlg_spi_slv_dma_dev_t           *p_dev,
                         const am_zlg_spi_slv_dma_devinfo_t *p_devinfo);

/**
 * \brief  SPI ӻʼ
 *
 * \param[in] handle SPI 豸׼
 *
 * \return 
 */
void am_zlg_spi_slv_dma_deinit (am_spi_slv_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG_SPI_SLV_DMA_H */

/* end of file */
