/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ϵͳƽӿ
 *
 * 1. ӳ䲿ִ TIM16  TIM17UART1  ADC  DMA Դͬ DMAͨϣ
 * 2. ӵ GPIOڵⲿжϣ
 * 3. ӳ洢ʼ
 * 4. ⲿжã
 *
 * \internal
 * \par History
 * - 1.00 17-04-07  nwt, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZLG_SYSCFG_H
#define __AMHW_ZLG_SYSCFG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"

/**
 * \addtogroup amhw_zlg_if_syscfg
 * \copydoc amhw_zlg_syscfg.h
 * @{
 */

/**
 * \name ⲿж϶˿Դ
 * @{
 */

#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOA       ((uint8_t)0x00)
#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOB       ((uint8_t)0x01)
#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOC       ((uint8_t)0x02)
#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOD       ((uint8_t)0x03)
#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOE       ((uint8_t)0x04)
#define AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOF       ((uint8_t)0x05)

#define AMHW_ZLG_SYSCFG_IS_EXTI_PORTSOURCE(portsource) \
           (((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOA) || \
            ((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOB) || \
            ((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOC) || \
            ((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOD) || \
            ((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOE) || \
            ((portsource) == AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOF))

/** @} */

/**
 * \name ⲿжϵԴ
 * @{
 */
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_0            ((uint8_t)0x00)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_1            ((uint8_t)0x01)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_2            ((uint8_t)0x02)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_3            ((uint8_t)0x03)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_4            ((uint8_t)0x04)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_5            ((uint8_t)0x05)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_6            ((uint8_t)0x06)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_7            ((uint8_t)0x07)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_8            ((uint8_t)0x08)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_9            ((uint8_t)0x09)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_10           ((uint8_t)0x0A)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_11           ((uint8_t)0x0B)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_12           ((uint8_t)0x0C)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_13           ((uint8_t)0x0D)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_14           ((uint8_t)0x0E)
#define AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_15           ((uint8_t)0x0F)

#define AMHW_ZLG_SYSCFG_IS_EXTI_PIN_SOURCE(pinsource) \
           (((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_0)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_1)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_2)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_3)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_4)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_5)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_6)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_7)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_8)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_9)  || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_10) || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_11) || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_12) || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_13) || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_14) || \
            ((pinsource) == AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_15))

/** @} */

/**
  * \brief ϵͳƼĴṹ
  */
typedef struct amhw_zlg_syscfg {
    __IO uint32_t cfgr;        /**< \brief ϵͳüĴ */
    __I  uint32_t reserve;     /**< \brief  */
    __IO uint32_t exticr[4];   /**< \brief ⲿжüĴ */
} amhw_zlg_syscfg_t;

/**
 * \brief ϵͳڴӳ䣬ӳ洢ʼ
 */
typedef enum amhw_zlg_syscfg_bootmode_remap {
    AMHW_ZLG_SYSCFG_REMAP_BOOT_MAIN_FLASH = 0,  /**< \brief 洢ӳ䵽 0x00000000 */
    AMHW_ZLG_SYSCFG_REMAP_BOOT_SYS_FLASH  = 1,  /**< \brief ϵͳӳ䵽 0x00000000 */
    AMHW_ZLG_SYSCFG_REMAP_BOOT_SRAM       = 3,  /**< \brief Ƕʽ RAM ӳ䵽 0x00000000 */
} amhw_zlg_syscfg_bootmode_remap_t;

/**
 * \brief ĳЩ(UART1, TIM16TIM17)DMAͨӳ
 */
typedef enum amhw_zlg_syscfg_dma_chan_remap {
    AMHW_ZLG_SYSCFG_REMAP_TIM17_DMA    = (1 << 12), /**< \brief ʱ17DMAͨӳ */
    AMHW_ZLG_SYSCFG_REMAP_TIM16_DMA    = (1 << 11), /**< \brief ʱ16DMAͨӳ */
    AMHW_ZLG_SYSCFG_REMAP_UART1_RX_DMA = (1 << 10), /**< \brief UART1_RX_DMAͨӳ */
    AMHW_ZLG_SYSCFG_REMAP_UART1_TX_DMA = (1 << 9),  /**< \brief UART1_TX_DMAͨӳ */
    AMHW_ZLG_SYSCFG_REMAP_ADC_DMA      = (1 << 8),  /**< \brief ADC_DMͨӳ */
} amhw_zlg_syscfg_dma_chan_remap_t;

/**
 * \brief ӳ洢ʼ
 *
 * \param[in] remap       ӳʼĴ洢λ
 * \param[in] p_hw_syscfg ָϵͳüĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_syscfg_mem_mode_remap_set (
                                amhw_zlg_syscfg_t               *p_hw_syscfg,
                                amhw_zlg_syscfg_bootmode_remap_t remap)
{
    AM_BITS_SET(p_hw_syscfg->cfgr, 0, 2, remap);
}

/**
 * \brief ȡ洢ʼӳֵ
 *
 * \param[in] p_hw_syscfg ָϵͳüĴָ
 *
 * \return ʼӳֵ
 */
am_static_inline
int amhw_zlg_syscfg_mem_mode_remap_get (amhw_zlg_syscfg_t *p_hw_syscfg)
{
    return (amhw_zlg_syscfg_bootmode_remap_t)p_hw_syscfg->cfgr;
}

/**
 * \brief ӳĳЩ(UART1, TIM16TIM17)DMAͨ
 *
 * \param[in] remap       ӳDMAֵͨΪ amhw_zlg_syscfg_dma_chan_remap_t
 *                         öͣʹû
 * \param[in] p_hw_syscfg ָϵͳüĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_syscfg_dma_chan_remap_set (
                                   amhw_zlg_syscfg_t               *p_hw_syscfg,
                                   amhw_zlg_syscfg_dma_chan_remap_t remap)
{
    AM_BITS_SET(p_hw_syscfg->cfgr, 8, 5, remap);
}

/**
 * \brief ѡ EXTIx(x=A...D) ⲿжϵԴ
 *
 * \param[in] p_hw_syscfg ָϵͳüĴָ
 * \param[in] portsource  ˿Դ,ֵΪ AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE* һ
 *                          (# AMHW_ZLG_SYSCFG_EXTI_PORTSOURCE_GPIOA)
 * \param[in] pinsource   ԴֵΪ  AMHW_ZLG_SYSCFG_EXTI_PINSOURCE* һ
 *                          (# AMHW_ZLG_SYSCFG_EXTI_PINSOURCE_0)
 *
 * \return 
 */
am_static_inline
void amhw_zlg_syscfg_exti_line_config (amhw_zlg_syscfg_t *p_hw_syscfg,
                                       uint8_t            portsource,
                                       uint8_t            pinsource)
{
    uint32_t tmp = 0x00;

    /*
     * ԭѡ0ţӦ4λ4λΪ0PA0
     */

    tmp = ((uint32_t)0x0F) << (0x04 * (pinsource & (uint8_t)0x03));

    p_hw_syscfg->exticr[pinsource >> 0x02] &= ~tmp;
    p_hw_syscfg->exticr[pinsource >> 0x02] |= \
               (((uint32_t)portsource) << (0x04 * (pinsource & (uint8_t)0x03)));
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZLG_SYSCFG_H */

/* end of file */
