/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMCAP׼ӿ
 *
 * 1. TIM֧ṩֱ׼񣬱ṩǷ񡰲񡱱׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. TIM1TIM2TIM34ͨTIM14TIM16TIM171ͨ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-4-21  nwt, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_TIM_CAP_H
#define __AM_ZLG118_TIM_CAP_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_cap.h"
#include "hw/amhw_zlg118_tim.h"

/**
 * \addtogroup am_zlg118_if_tim_cap
 * \copydoc am_zlg118_tim_cap.h
 * @{
 */

/**
 * \brief ͨʶ
 *
 * \note ڶʱ012ֻCH0ACH0Bͨ
 *       ڶʱ36ֱͨΪCH0ACH0B
 *                              CH1ACH1B
 *                              CH2ACH2B
 */
#define  AM_ZLG118_TIM_CAP_CH0A        0x00   /**< \brief CAPͨ0ʶ*/
#define  AM_ZLG118_TIM_CAP_CH0B        0x01   /**< \brief CAPͨ1ʶ*/
#define  AM_ZLG118_TIM_CAP_CH1A        0x02   /**< \brief CAPͨ2ʶ*/
#define  AM_ZLG118_TIM_CAP_CH1B        0x03   /**< \brief CAPͨ3ʶ*/
#define  AM_ZLG118_TIM_CAP_CH2A        0x04   /**< \brief CAPͨ4ʶ*/
#define  AM_ZLG118_TIM_CAP_CH2B        0x05   /**< \brief CAPͨ5ʶ*/

/**
 * \brief TIMصGPIOϢ
 */
typedef struct am_zlg118_tim_cap_ioinfo {
    int8_t   channel;        /**< \brief CAPʹõͨʶ */
    uint32_t gpio;           /**< \brief ӦGPIOܽ */
    uint32_t func;           /**< \brief ΪʱGPIO */
    uint32_t dfunc;          /**< \brief ܹܽŲʱĬGPIO */
} am_zlg118_tim_cap_ioinfo_t;

/**
 * \brief TIMص豸Ϣ
 */
typedef struct am_zlg118_tim_cap_devinfo {
    uint32_t                    tim_regbase;   /**< \brief TIMĴַ */
    uint8_t                     inum;          /**< \brief TIMӦжϺ */
    amhw_zlg118_tim_clkdiv_t    clk_div;       /**< \brief ʱӷƵϵ */
    uint8_t                     channels_num;  /**< \brief ʹõͨΪ2 */
    amhw_zlg118_tim_type_t      tim_type;      /**< \brief ʱ */
    am_zlg118_tim_cap_ioinfo_t *p_ioinfo;      /**< \brief ָ򲶻ܽϢṹ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                      (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                      (*pfn_plfm_deinit)(void);
} am_zlg118_tim_cap_devinfo_t;

/**
 * \brief TIM豸
 */
typedef struct am_zlg118_tim_cap_dev {
    am_cap_serv_t          cap_serv;      /**< \brief ׼CAP */

    struct {
        am_cap_callback_t  callback_func; /**< \brief ص */
        void              *p_arg;         /**< \brief صû */
    } callback_info[6];                   /**< \brief 洢6ͨĻصϢ */

    /** \brief ָTIM()豸Ϣָ */
    const am_zlg118_tim_cap_devinfo_t *p_devinfo;

    uint8_t                chan_max;      /**< \brief Чͨ  */

} am_zlg118_tim_cap_dev_t;

/**
 * \brief ʼTIMΪ
 *
 * \param[in] p_dev     : ָTIM()豸ָ
 * \param[in] p_devinfo : ָTIM()豸Ϣָ
 *
 * \return CAP׼ֵΪNULLʱʼʧ
 */
am_cap_handle_t am_zlg118_tim_cap_init (am_zlg118_tim_cap_dev_t              *p_dev,
                                        const am_zlg118_tim_cap_devinfo_t *p_devinfo);

/**
 * \brief ʹTIMʱʼTIMܣͷԴ
 *
 * \param[in] handle : am_zlg118_tim_cap_init() ʼõcap
 *
 * \return 
 */
void am_zlg118_tim_cap_deinit (am_cap_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG118_TIM_CAP_H */

/* end of file */
