/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMPWM׼ӿ
 *
 * 1. TIM֧ṩֱ׼񣬱ṩǷPWM׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. TIM1TIM2TIM34·PWMͨԵмģʽ
 *    TIM14TIM16TIM171·PWMͨԵģʽ
 *
 * \note һTIMPWMֵҲ˵TIM
 * PWMͬƵͬ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-21  nwt, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_TIM_PWM_H
#define __AM_ZLG_TIM_PWM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_pwm.h"
#include "hw/amhw_zlg_tim.h"

/**
 * \addtogroup am_zlg_if_tim_pwm
 * \copydoc am_zlg_tim_pwm.h
 * @{
 */

/**
 * \brief ͨʶλΪ1ͨ7λӦͨţ
 */
#define  AM_ZLG_TIM_PWM_CH1         0x00   /**< \brief PWMͨ1ʶ*/
#define  AM_ZLG_TIM_PWM_CH2         0x01   /**< \brief PWMͨ2ʶ*/
#define  AM_ZLG_TIM_PWM_CH3         0x02   /**< \brief PWMͨ3ʶ*/
#define  AM_ZLG_TIM_PWM_CH4         0x03   /**< \brief PWMͨ4ʶ*/

#define  AM_ZLG_TIM_PWM_CH1N        0x80   /**< \brief PWMͨ1ʶ*/
#define  AM_ZLG_TIM_PWM_CH2N        0x81   /**< \brief PWMͨ2ʶ*/
#define  AM_ZLG_TIM_PWM_CH3N        0x82   /**< \brief PWMͨ3ʶ*/
#define  AM_ZLG_TIM_PWM_CH4N        0x83   /**< \brief PWMͨ4ʶ*/


/**
 * \brief TIMPWMصGPIOϢ
 */
typedef struct am_zlg_tim_pwm_chaninfo {
    int8_t   channel;                  /**< \brief PWMʹõͨʶ */
    int8_t   gpio;                     /**< \brief PWMõGPIO */
    uint32_t func;                     /**< \brief PWMܵGPIOֵ */
    uint32_t dfunc;                    /**< \brief PWMģʽĬGPIOֵ */
} am_zlg_tim_pwm_chaninfo_t;

/**
 * \brief TIMPWMص豸Ϣ
 */
typedef struct am_zlg_tim_pwm_devinfo {
    uint32_t                    tim_regbase;    /**< \brief TIMĴַ */

    int                         clk_num;        /**< \brief ʱID */

    uint8_t                     channels_num;   /**< \brief ʹõͨΪ4 */

    /** \brief PWMģʽ AMHW_ZLG_TIM_PWM_MODE2  AMHW_ZLG_TIM_PWM_MODE1 */
    uint8_t                     pwm_mode;

    /** \brief PWM,0ΪߵƽЧ, 1Ϊ͵ƽЧ */
    uint8_t                     ocpolarity;

    am_zlg_tim_pwm_chaninfo_t  *p_chaninfo;     /**< \brief ָPWMͨϢṹ */

    amhw_zlg_tim_type_t         tim_type;       /**< \brief ʱ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                      (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                      (*pfn_plfm_deinit)(void);

} am_zlg_tim_pwm_devinfo_t;

/**
 * \brief TIMPWM豸ṹ
 */
typedef struct am_zlg_tim_pwm_dev {

    am_pwm_serv_t                      pwm_serv; /**< \brief ׼PWM */

    /** \brief ָTIM(PWM)豸Ϣָ */
    const am_zlg_tim_pwm_devinfo_t    *p_devinfo;

} am_zlg_tim_pwm_dev_t;

/**
 * \brief ʼTIMΪPWM
 *
 * \param[in] p_dev     : ָTIM(PWM)豸ָ
 * \param[in] p_devinfo : ָTIM(PWM)豸Ϣָ
 *
 * \return PWM׼ֵΪNULLʱʼʧ
 */
am_pwm_handle_t am_zlg_tim_pwm_init(am_zlg_tim_pwm_dev_t              *p_dev,
                                    const am_zlg_tim_pwm_devinfo_t    *p_devinfo);

/**
 * \brief ʹTIMPWMʱʼTIMPWMܣͷԴ
 *
 * \param[in] handle : am_zlg_tim_pwm_init() ʼõPWM
 *
 * \return 
 */
void am_zlg_tim_pwm_deinit (am_pwm_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG_TIM_PWM_H */

/* end of file */
