/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMPWM׼ӿ
 *
 * 1. TIM֧ṩֱ׼񣬱ṩǷPWM׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. TIM1TIM2TIM34·PWMͨԵмģʽ
 *    TIM14TIM16TIM171·PWMͨԵģʽ
 *
 * \note һTIMPWMֵҲ˵TIM
 * PWMͬƵͬ
 *
 * \internal
 * \par Modification history
 * - 1.00 19-09-16  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZSL42x_TIM_PWM_H
#define __AM_ZSL42x_TIM_PWM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_pwm.h"
#include "hw/amhw_zsl42x_tim.h"

/**
 * \addtogroup am_zsl42x_if_tim_pwm
 * \copydoc am_zsl42x_tim_pwm.h
 * @{
 */

/**
 * \brief ͨʶ
 *
 * \note CHxA  CHxBڵPWMҲڻPWM
 *       ڶʱ012ֻCH0ACH0Bͨ
 *       ڶʱ36ֱͨΪCH0ACH0B1
 *                            CH1ACH1B2
 *                            CH2ACH2B3
 */
#define  AM_ZSL42x_TIM_PWM_CH0A        0x00   /**< \brief PWMͨ0ʶ*/
#define  AM_ZSL42x_TIM_PWM_CH0B        0x01   /**< \brief PWMͨ1ʶ*/
#define  AM_ZSL42x_TIM_PWM_CH1A        0x02   /**< \brief PWMͨ2ʶ*/
#define  AM_ZSL42x_TIM_PWM_CH1B        0x03   /**< \brief PWMͨ3ʶ*/
#define  AM_ZSL42x_TIM_PWM_CH2A        0x04   /**< \brief PWMͨ4ʶ*/
#define  AM_ZSL42x_TIM_PWM_CH2B        0x05   /**< \brief PWMͨ5ʶ*/

/* PWM */
#define  AM_ZSL42x_TIM_PWM_OCPOLARITY_HIGH 6  /**< \brief ߵƽЧ */
#define  AM_ZSL42x_TIM_PWM_OCPOLARITY_LOW  7  /**< \brief ͵ƽЧ */

/**
 * \brief TIMPWMصGPIOϢ
 */
typedef struct am_zsl42x_tim_pwm_chaninfo {
    int8_t   channel;                  /**< \brief PWMʹõͨʶ */
    int8_t   gpio;                     /**< \brief PWMõGPIO */
    uint32_t func;                     /**< \brief PWMܵGPIOֵ */
    uint32_t dfunc;                    /**< \brief PWMģʽĬGPIOֵ */
} am_zsl42x_tim_pwm_chaninfo_t;

/**
 * \brief TIMPWMص豸Ϣ
 */
typedef struct am_zsl42x_tim_pwm_devinfo {
    uint32_t                    tim_regbase;    /**< \brief TIMĴַ */

    uint8_t                     channels_num;   /**< \brief ʹõͨΪ6 */

    /** \brief PWMѡ  1PWM   0PWM */
    uint8_t                     comp;

    /** \brief PWM,AM_ZSL42x_TIM_PWM_OCPOLARITY_HIGHAM_ZSL42x_TIM_PWM_OCPOLARITY_LOW */
    uint8_t                     ocpolarity;

    am_zsl42x_tim_pwm_chaninfo_t  *p_chaninfo;     /**< \brief ָPWMͨϢṹ */

    amhw_zsl42x_tim_type_t         tim_type;       /**< \brief ʱ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                      (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                      (*pfn_plfm_deinit)(void);

} am_zsl42x_tim_pwm_devinfo_t;

/**
 * \brief TIMPWM豸ṹ
 */
typedef struct am_zsl42x_tim_pwm_dev {

    am_pwm_serv_t                      pwm_serv;   /**< \brief ׼PWM */

    /** \brief ָTIM(PWM)豸Ϣָ */
    const am_zsl42x_tim_pwm_devinfo_t *p_devinfo;

    uint8_t                            chan_max;   /**< \brief Чͨ  */

} am_zsl42x_tim_pwm_dev_t;

/**
 * \brief ʼTIMΪPWM
 *
 * \param[in] p_dev     : ָTIM(PWM)豸ָ
 * \param[in] p_devinfo : ָTIM(PWM)豸Ϣָ
 *
 * \return PWM׼ֵΪNULLʱʼʧ
 */
am_pwm_handle_t am_zsl42x_tim_pwm_init(am_zsl42x_tim_pwm_dev_t              *p_dev,
                                    const am_zsl42x_tim_pwm_devinfo_t    *p_devinfo);

/**
 * \brief ʹTIMPWMʱʼTIMPWMܣͷԴ
 *
 * \param[in] handle : am_zsl42x_tim_pwm_init() ʼõPWM
 *
 * \return 
 */
void am_zsl42x_tim_pwm_deinit (am_pwm_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_TIM_PWM_H */

/* end of file */
