/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMTimerʵ
 *
 * 1. TIM֧ṩֱ׼񣬱ṩǷTimer׼
 *     - ʱ
 *     - PWM
 *     - 
 * 2. һTIMģ飬ֻһʱͨ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-21  nwt, first implementation
 * \endinternal
 */

#ifndef __AM_ZSL42x_TIM_TIMING_H
#define __AM_ZSL42x_TIM_TIMING_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_timer.h"
#include "hw/amhw_zsl42x_tim.h"

/**
 * \addtogroup am_zsl42x_if_tim_timing
 * \copydoc am_zsl42x_tim_timing.h
 * @{
 */

/**
 * \brief TIMʱص豸Ϣ
 */
typedef struct am_zsl42x_tim_timing_devinfo {

    uint32_t                        tim_regbase;    /**< \brief TIMĴַ */

    uint8_t                         inum;           /**< \brief TIMжϺ */

    amhw_zsl42x_tim_type_t          tim_type;       /**< \brief ʱ */

    /** \brief 16/32λ    ע⣺32λǲװصģ16λװ*/
    amhw_zsl42x_tim_mode0_counter_t counter_type;

    /** \brief ſʹܣƽЧſҪöӦʱGATEţ*/
    amhw_zsl42x_tim_gate_t          gate_enable;

    /** \brief ſصƽЧѡ    AM_TRUEߵƽ              AM_FALSE͵ƽ */
    am_bool_t                       gate_state;

    /** \brief ʱѡڲⲿⲿҪöӦʱETR */
    amhw_zsl42x_tim_clk_src_t       clk_src;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void                            (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void                            (*pfn_plfm_deinit)(void);

} am_zsl42x_tim_timing_devinfo_t;

/**
 * \brief TIMʱ豸
 */
typedef struct am_zsl42x_tim_timing_dev {

    am_timer_serv_t timer_serv;         /**< \brief ׼ʱ(Timer) */

    void (*pfn_callback)(void *);       /**< \brief ص */
    void  *p_arg;                       /**< \brief صû */

    uint16_t           prescale_to;     /**< \brief Ƶֵ  */
    uint16_t           prescale_in;     /**< \brief ʵʷƵֵ  */

    /** \brief ָTIM(ʱ)豸Ϣָ */
    const am_zsl42x_tim_timing_devinfo_t  *p_devinfo;

} am_zsl42x_tim_timing_dev_t;

/**
 * \brief ʼTIMΪʱ
 *
 * \param[in] p_dev     : ָTIM(ʱ)豸ָ
 * \param[in] p_devinfo : ָTIM(ʱ)豸Ϣָ
 *
 * \return Timer׼ֵΪNULLʱʼʧ
 */
am_timer_handle_t
am_zsl42x_tim_timing_init (am_zsl42x_tim_timing_dev_t              *p_dev,
                           const am_zsl42x_tim_timing_devinfo_t *p_devinfo);

/**
 * \brief ʹTIMʱʱʼTIMʱܣͷԴ
 *
 * \param[in] handle : am_zsl42x_tim_timing_init() ʼõTimer
 *
 * \return 
 */
void am_zsl42x_tim_timing_deinit (am_timer_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_TIM_TIMING_H */

/* end of file */
