/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ʱTIMӿ
 *
 * 1. 16 λϡ¡/Զװؼ
 * 2. 16 λɱ̣ʵʱ޸ģԤƵʱƵʵķƵϵΪ 1 ~ 65536 ֵ֮
 * 3.  4ͨ(TIM1TIM2TIM3ֻһͨ)
 *    -  벶
 *    -  Ƚ
 *    -  PWM ɣԵмģʽ
 *    -  ģʽ
 *    -  ʱɱ̵Ļ
 *    -  ʹⲿźſƶʱͶʱͬ·
 * 4. ָĿļ֮¶ʱĴظ
 * 5. ɲźſԽʱźڸλ״̬һ֪״̬
 * 6. ¼ʱж/DMA
 *    -  £/ʼͨڲ/ⲿ
 *    -  ¼ֹͣʼڲ/ⲿ
 *    -  벶
 *    -  Ƚ
 *    -  ɲź
 * 7.  ֧Զλͻ·
 * 8.  Ϊⲿʱӻ߰ڵĵ
 *
 * \note ͨöʱTIMXûrcr bdtrĴ
 *       ͨöʱTIM14ֻһccmrccrĴ ûrcr bdtrµļĴ
 *       ͨöʱTIM1617ֻһccmrccrĴ
 *
 * \internal
 * \par History
 * - 1.00 17-04-17  nwt, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZLG_TIM_H
#define __AMHW_ZLG_TIM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "am_bitops.h"

/**
 * \addtogroup amhw_zlg_if_tim
 * \copydoc amhw_zlg_tim.h
 * @{
 */

/**
  * \brief ʱĴṹ
  */
typedef struct amhw_zlg_tim {
    __IO uint32_t cr[2];         /**< \brief ƼĴ */
    __IO uint32_t smcr;          /**< \brief ģʽƼĴ */
    __IO uint32_t dier;          /**< \brief DMA/жʹܼĴ */
    __IO uint32_t sr;            /**< \brief ״̬Ĵ */
    __O  uint32_t egr;           /**< \brief ¼Ĵ */
    __IO uint32_t ccmr[2];       /**< \brief ׽/ȽģʽĴ */
    __O  uint32_t ccer;          /**< \brief ׽/ȽʹܼĴ */
    __IO uint32_t cnt;           /**< \brief  */
    __IO uint32_t psc;           /**< \brief ԤƵ */
    __IO uint32_t arr;           /**< \brief ԶװؼĴ */
    __IO uint32_t rcr;           /**< \brief ظĴ */
    __IO uint32_t ccr[4];        /**< \brief /ȽϼĴ */
    __IO uint32_t bdtr;          /**< \brief ɲĴ */
    __IO uint32_t dcr;           /**< \brief ʱ DMAƼĴ */
    __IO uint32_t dmar;          /**< \brief ģʽ DMA ַ */
} amhw_zlg_tim_t;

/**
 * \brief õǰֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return ǰֵ
 */
am_static_inline
uint32_t amhw_zlg_tim_count_get (amhw_zlg_tim_t *p_hw_tim)
{
    return p_hw_tim->cnt;
}

/**
 * \brief õǰֵ
 *
 * \param[in] p_hw_tim :    ָTIMʱĴָ
 * \param[in] value    :    õļֵ
 *
 * \note: ͨöʱTIM2TIM3ֵΪ32λ, Ϊ16λ
 *
 *\ return 
 */
am_static_inline
void amhw_zlg_tim_count_set (amhw_zlg_tim_t *p_hw_tim, uint32_t value)
{
    p_hw_tim->cnt = value;
}

/**
 * \brief ԤƵĴֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] value    : õԤƵĴֵյķƵΪ value+1
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_prescale_set (amhw_zlg_tim_t *p_hw_tim, uint16_t value)
{
    p_hw_tim->psc = value;
}

/**
 * \brief ȡԤƵĴֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return ԤƵĴֵ
 */
am_static_inline
uint32_t amhw_zlg_tim_prescale_get (amhw_zlg_tim_t *p_hw_tim)
{
    return p_hw_tim->psc;
}

/**
 * \brief ԶװؼĴֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] value    : ԶװؼĴֵ
 *
 * \note: ͨöʱTIM2TIM3ֵΪ32λ, Ϊ16λ, ֵһһθ¼ʱŻЧ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_arr_set (amhw_zlg_tim_t *p_hw_tim, uint32_t value)
{
    p_hw_tim->arr = value;
}

/**
 * \brief ȡԶװؼĴֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return ԶװؼĴֵ
 */
am_static_inline
uint32_t amhw_zlg_tim_arr_get (amhw_zlg_tim_t *p_hw_tim)
{
    return p_hw_tim->arr;
}

/**
 * \brief ʹܶʱ(ʼ)
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_enable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 0 , 1);
}

/**
 * \brief ֹʱ(ֹͣ)
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_disable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 0, 0);
}

/**
 * \brief UDISλ¼UEV
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_udis_enable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 1 , 0);
}

/**
 * \brief UDISλֹ¼UEV
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_udis_disable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 1, 1);
}

/**
 * \brief ԶװԤװʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_arpe_enable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 7 , 1);
}

/**
 * \brief ԶװԤװ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_arpe_disable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 7, 0);
}

/**
 * \brief øԴ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] urs_opt  : Դֵ
 *                       0 UGλ  ģʽĸ¡ж/DMA
 *                       1 ֻж/DMA
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_urs_set (amhw_zlg_tim_t *p_hw_tim, uint8_t urs_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 2, urs_opt);
}

/**
 * \brief øԴ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] opm_opt  : Ƿѡģʽ
 *                       0ڷ¼ʱֹͣ
 *                       1 ڷһθ¼ CEN λʱֹͣ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_opm_set (amhw_zlg_tim_t *p_hw_tim, uint8_t opm_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 3, opm_opt);
}

/**
 * \brief üķ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] dir_opt  : ѡ
 *                       0ϼ
 *                       1¼
 *
 *\note :ΪģʽģʽʱλΪֻ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dir_set (amhw_zlg_tim_t *p_hw_tim, uint8_t dir_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[0], 4, dir_opt);
}

/**
 * \brief ģʽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] cms_opt  : ģʽѡ
 *                       0: ضģʽ
 *                       1: ģʽ 1
 *                       2: ģʽ 2
 *                       3: ģʽ 3
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_cms_set (amhw_zlg_tim_t *p_hw_tim, uint8_t cms_opt)
{
    AM_BITS_SET(p_hw_tim->cr[0], 5, 2, cms_opt);
}

/**
 * \brief ʱӷƵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ckd_opt  : ʱӷƵѡ
 *                       0: tDTS = tCK_INT(ʱʱ)
 *                       1: tDTS = 2 * tCK_INT(ʱʱ)
 *                       2: tDTS = 4 * tCK_INT(ʱʱ)
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ckd_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ckd_opt)
{
    AM_BITS_SET(p_hw_tim->cr[0], 8, 2, ckd_opt);
}

/**
 * \brief /ȽԤװؿʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \note : λֻԾлͨá
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccpc_enable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[1], 1, 0);
}

/**
 * \brief /ȽԤװؿƽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \note : λֻԾлͨá
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccpc_disable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->cr[1], 0, 0);
}

/**
 * \brief /ȽϿƸ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccus_opt : /ȽϿƸѡ
 *                       0: /ȽϿλԤװصģCCPC = 1ֻͨ COM λ
 *                       1: /ȽϿλԤװصģCCPC = 1ͨ COM λ TRGIϵһظ
 *
 * \note : λֻԾлͨá
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccus_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ccus_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[1], 2, ccus_opt);
}

/**
 * \brief /Ƚϵ DMA
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccds_opt : /Ƚϵ DMA ѡѡ
 *                       0:  CCx¼ʱͳ CCx DMA
 *                       1: ¼ʱͳ CCx DMA
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccds_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ccds_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[1], 3, ccds_opt);
}

/**
 * \brief ģʽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] mms_opt  : ģʽѡ
 *                       0: λ; 1: ʹ; 2: ; 3: Ƚ
 *                       4: Ƚ  C OC1REF źűΪTRGO
 *                       5: Ƚ  C OC2REF źűΪTRGO
 *                       6: Ƚ  C OC3REF źűΪTRGO
 *                       7: Ƚ  C OC4REF źűΪTRGO
 * \return 
 */
am_static_inline
void amhw_zlg_tim_mms_set (amhw_zlg_tim_t *p_hw_tim, uint8_t mms_opt)
{
    AM_BITS_SET(p_hw_tim->cr[1], 4, 3, mms_opt);
}

/**
 * \brief TI1
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ti1s_opt : TI1ѡ
 *                       0: TIMx_CH1 ܽ TI1 
 *                       1: TIMx_CH1TIMx_CH2  TIMx_CH3 ܽž TI1 
 * \return 
 */
am_static_inline
void amhw_zlg_tim_tils_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ti1s_opt)
{
    AM_BIT_MODIFY(p_hw_tim->cr[1], 7, ti1s_opt);
}

/**
 * \brief ״̬ö
 */
typedef enum amhw_zlg_tim_ois {
    AMHW_ZLG_TIM_OIS4   = (1UL << 14),  /**< \brief ״̬ 4(OC4 ) */
    AMHW_ZLG_TIM_OIS3N  = (1UL << 13),  /**< \brief ״̬ 3(OC3N ) */
    AMHW_ZLG_TIM_OIS3   = (1UL << 12),  /**< \brief ״̬ 3(OC3 ) */
    AMHW_ZLG_TIM_OIS2N  = (1UL << 11),  /**< \brief ״̬ 2(OC2N ) */
    AMHW_ZLG_TIM_OIS2   = (1UL << 10),  /**< \brief ״̬ 2(OC2 ) */
    AMHW_ZLG_TIM_OIS1N  = (1UL << 9),   /**< \brief ״̬ 1(OC1N) */
    AMHW_ZLG_TIM_OIS1   = (1UL << 8),   /**< \brief ״̬ 1(OC1) */
} amhw_zlg_tim_ois_t;

/**
 * \brief ״̬1
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ois_opt  : ״̬ѡ, ֵΪ amhw_zlg_tim_ois_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ois_set (amhw_zlg_tim_t    *p_hw_tim,
                              amhw_zlg_tim_ois_t ois_opt)
{
    p_hw_tim->cr[1] |= ois_opt;
}

/**
 * \brief ״̬0
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ois_opt  : ״̬ѡ, ֵΪ amhw_zlg_tim_ois_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ois_clr (amhw_zlg_tim_t    *p_hw_tim,
                              amhw_zlg_tim_ois_t ois_opt)
{
    p_hw_tim->cr[1] &= ~ois_opt;
}

/**
 * \brief ģʽѡö
 */
typedef enum amhw_zlg_tim_sms {
    AMHW_ZLG_TIM_SLAVE_MODE_DISABLED  = 0,  /**< \brief رմģʽ */
    AMHW_ZLG_TIM_ENCODER_MODE1        = 1,  /**< \brief ģʽ 1 */
    AMHW_ZLG_TIM_ENCODER_MODE2        = 2,  /**< \brief ģʽ 2 */
    AMHW_ZLG_TIM_ENCODER_MODE3        = 3,  /**< \brief ģʽ 3 */
    AMHW_ZLG_TIM_RESET_MODE           = 4,  /**< \brief λģʽ */
    AMHW_ZLG_TIM_GATED_MODE           = 5,  /**< \brief ſģʽ */
    AMHW_ZLG_TIM_TRIGGER_MODE         = 6,  /**< \brief ģʽ */
    AMHW_ZLG_TIM_EXTERNAL_CLOCK_MODE1 = 7,  /**< \brief ⲿʱģʽ 1 */
} amhw_zlg_tim_sms_t;

/**
 * \brief ģʽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] sms_opt  : ģʽѡ, ֵΪ amhw_zlg_tim_sms_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_sms_set (amhw_zlg_tim_t *p_hw_tim, uint8_t sms_opt)
{
    AM_BITS_SET(p_hw_tim->smcr, 0, 3, sms_opt);
}

/**
 * \brief ѡö
 */
typedef enum amhw_zlg_tim_ts {
    AMHW_ZLG_TIM_ITR0       = 0,  /**< \brief ڲ 0 */
    AMHW_ZLG_TIM_ITR1       = 1,  /**< \brief ڲ 1 */
    AMHW_ZLG_TIM_ITR2       = 2,  /**< \brief ڲ 2 */
    AMHW_ZLG_TIM_ITR3       = 3,  /**< \brief ڲ 3 */
    AMHW_ZLG_TIM_TI1F_ED    = 4,  /**< \brief TI1ıؼ */
    AMHW_ZLG_TIM_TI1FP1     = 5,  /**< \brief ˲Ķʱ1 */
    AMHW_ZLG_TIM_TI2FP2     = 6,  /**< \brief ˲Ķʱ2 */
    AMHW_ZLG_TIM_ETRF       = 7,  /**< \brief ⲿ */
} amhw_zlg_tim_ts_t;

/**
 * \brief ʱ
 */
typedef enum amhw_zlg_tim_type {
    AMHW_ZLG_TIM_TYPE0       = 0,  /**< \brief TIM1 */
    AMHW_ZLG_TIM_TYPE1       = 1,  /**< \brief TIM2TIM3 */
    AMHW_ZLG_TIM_TYPE2       = 2,  /**< \brief TIM14 */
    AMHW_ZLG_TIM_TYPE3       = 3,  /**< \brief TIM16TIM17 */
} amhw_zlg_tim_type_t;

/**
 * \brief 
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ts_opt   : ѡ, ֵΪ  amhw_zlg_tim_ts_t һö
 *
 * \note : Щλֻδõ SMS = 000ʱı䣬Աڸıʱıؼ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ts_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ts_opt)
{
    AM_BITS_SET(p_hw_tim->smcr, 4, 3, ts_opt);
}

/**
 * \brief /ģʽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] msm_opt  : /ģʽѡ
 *                       0 
 *                       1 루TRGIϵ¼ӳˣڵǰʱͨ TRGOĴӶʱ
 *                             ͬҪѼʱͬһһⲿ¼ʱǷǳõ
 *
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_msm_set (amhw_zlg_tim_t *p_hw_tim, uint8_t msm_opt)
{
    AM_BIT_MODIFY(p_hw_tim->smcr, 7, msm_opt);
}

/**
 * \brief ⲿ˲ѡö
 */
typedef enum amhw_zlg_tim_etf {
    AMHW_ZLG_TIM_ETF_FSAMPLING0   = 0,  /**< \brief ˲ */
    AMHW_ZLG_TIM_ETF_FSAMPLING1   = 1,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 2 */
    AMHW_ZLG_TIM_ETF_FSAMPLING2   = 2,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 4 */
    AMHW_ZLG_TIM_ETF_FSAMPLING3   = 3,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 8 */
    AMHW_ZLG_TIM_ETF_FSAMPLING4   = 4,  /**< \brief Ƶ fSAMPLING = fDTS/2N = 6 */
    AMHW_ZLG_TIM_ETF_FSAMPLING5   = 5,  /**< \brief Ƶ fSAMPLING = fDTS/2N = 8 */
    AMHW_ZLG_TIM_ETF_FSAMPLING6   = 6,  /**< \brief Ƶ fSAMPLING = fDTS/4N = 6 */
    AMHW_ZLG_TIM_ETF_FSAMPLING7   = 7,  /**< \brief Ƶ fSAMPLING = fDTS/4N = 8 */
    AMHW_ZLG_TIM_ETF_FSAMPLING8   = 8,  /**< \brief Ƶ fSAMPLING = fDTS/8N = 6 */
    AMHW_ZLG_TIM_ETF_FSAMPLING9   = 9,  /**< \brief Ƶ fSAMPLING = fDTS/8N = 8 */
    AMHW_ZLG_TIM_ETF_FSAMPLING10  = 10, /**< \brief Ƶ fSAMPLING = fDTS/16N = 5 */
    AMHW_ZLG_TIM_ETF_FSAMPLING11  = 11, /**< \brief Ƶ fSAMPLING = fDTS/16N = 6 */
    AMHW_ZLG_TIM_ETF_FSAMPLING12  = 12, /**< \brief Ƶ fSAMPLING = fDTS/16N = 8 */
    AMHW_ZLG_TIM_ETF_FSAMPLING13  = 13, /**< \brief Ƶ fSAMPLING = fDTS/32N = 5 */
    AMHW_ZLG_TIM_ETF_FSAMPLING14  = 14, /**< \brief Ƶ fSAMPLING = fDTS/32N = 6 */
    AMHW_ZLG_TIM_ETF_FSAMPLING15  = 15, /**< \brief Ƶ fSAMPLING = fDTS/32N = 8 */
} amhw_zlg_tim_etf_t;

/**
 * \brief ⲿ˲
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] etf_opt  : ˲ѡ, ֵΪ amhw_zlg_tim_etf_t һ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_etf_set (amhw_zlg_tim_t *p_hw_tim, uint8_t etf_opt)
{
    AM_BITS_SET(p_hw_tim->smcr, 8, 4, etf_opt);
}

/**
 * \brief ⲿԤƵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] etps_opt : ⲿԤƵѡ,
 *                       0: رԤƵ;     1: ETRPƵʳ 2;
 *                       2: ETRPƵʳ 4; 3: ETRPƵʳ 8;
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_etps_set (amhw_zlg_tim_t *p_hw_tim, uint8_t etps_opt)
{
    AM_BITS_SET(p_hw_tim->smcr, 12, 2, etps_opt);
}

/**
 * \brief ⲿʱʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \note : λֻԾлͨá
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ece_enable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->smcr, 14, 1);
}

/**
 * \brief ⲿʱӽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \note : λֻԾлͨá
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ece_disable (amhw_zlg_tim_t *p_hw_tim)
{
    AM_BIT_MODIFY(p_hw_tim->smcr, 14, 0);
}

/**
 * \brief ⲿ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] etp_opt  : ⲿѡ
 *                       0: ETR ࣬ߵƽЧ;
 *                       1: ETR ࣬͵ƽ½Ч;
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_etp_set (amhw_zlg_tim_t *p_hw_tim, uint8_t etp_opt)
{
    AM_BIT_MODIFY(p_hw_tim->smcr, 15, etp_opt);
}

/**
 * \brief ʱصDMAö
 */
typedef enum amhw_zlg_tim_dma_req {
    AMHW_ZLG_TIM_UDE     = (1UL << 8),   /**< \brief  DMA  */
    AMHW_ZLG_TIM_CC1DE   = (1UL << 9),   /**< \brief /Ƚ 1 DMA */
    AMHW_ZLG_TIM_CC2DE   = (1UL << 10),  /**< \brief /Ƚ 2 DMA */
    AMHW_ZLG_TIM_CC3DE   = (1UL << 11),  /**< \brief /Ƚ 3 DMA */
    AMHW_ZLG_TIM_CC4DE   = (1UL << 12),  /**< \brief /Ƚ 4 DMA */
    AMHW_ZLG_TIM_COMDE   = (1UL << 13),  /**< \brief  COM DMA */
    AMHW_ZLG_TIM_TDE     = (1UL << 14),  /**< \brief DMA */
} amhw_zlg_tim_dma_req_t;

/**
 * \brief ʱصDMAʹ
 *
 * \param[in] p_hw_tim   : ָTIMʱĴָ
 * \param[in] dmareq_opt : ʱصDMAѡ, ֵΪ amhw_zlg_tim_dma_req_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dma_req_enable (amhw_zlg_tim_t    *p_hw_tim,
                                  uint8_t            dmareq_opt)
{
    p_hw_tim->dier |= dmareq_opt;
}

/**
 * \brief ʱصDMAͽ
 *
 * \param[in] p_hw_tim   : ָTIMʱĴָ
 * \param[in] dmareq_opt : ʱصDMAѡ, ֵΪ amhw_zlg_tim_dma_req_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dma_req_disable (amhw_zlg_tim_t    *p_hw_tim,
                                   uint8_t            dmareq_opt)
{
    p_hw_tim->dier &= ~dmareq_opt;
}

/**
 * \brief ʱжö
 */
typedef enum amhw_zlg_tim_int {
    AMHW_ZLG_TIM_UIE     = (1UL << 0),  /**< \brief ж */
    AMHW_ZLG_TIM_CC1IE   = (1UL << 1),  /**< \brief /Ƚ 1 ж */
    AMHW_ZLG_TIM_CC2IE   = (1UL << 2),  /**< \brief /Ƚ 2 ж */
    AMHW_ZLG_TIM_CC3IE   = (1UL << 3),  /**< \brief /Ƚ 3 ж */
    AMHW_ZLG_TIM_CC4IE   = (1UL << 4),  /**< \brief /Ƚ 4 ж */
    AMHW_ZLG_TIM_COMIE   = (1UL << 5),  /**< \brief COMж */
    AMHW_ZLG_TIM_TIE     = (1UL << 6),  /**< \brief ж */
    AMHW_ZLG_TIM_BIE     = (1UL << 7),  /**< \brief ɲж */
} amhw_zlg_tim_int_t;

/**
 * \brief ʱжʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] int_opt  : ʱжѡ, ֵΪ amhw_zlg_tim_int_t һö
 *                       Ի (# (AMHW_ZLG_TIM_UIE | AMHW_ZLG_TIM_CC1IE))
 * \return 
 */
am_static_inline
void amhw_zlg_tim_int_enable (amhw_zlg_tim_t *p_hw_tim, uint8_t int_opt)
{
    p_hw_tim->dier |= int_opt;
}

/**
 * \brief ʱжͽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] int_opt  : ʱжѡ, ֵΪ amhw_zlg_tim_int_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_int_disable (amhw_zlg_tim_t *p_hw_tim, uint8_t int_opt)
{
    p_hw_tim->dier &= ~int_opt;
}

/**
 * \brief ʱ״̬λö
 */
typedef enum amhw_zlg_tim_status_flag {
    AMHW_ZLG_TIM_UIF     = (1UL << 0),  /**< \brief жϱ */
    AMHW_ZLG_TIM_CC1IF   = (1UL << 1),  /**< \brief /Ƚ 1 жϱ */
    AMHW_ZLG_TIM_CC2IF   = (1UL << 2),  /**< \brief /Ƚ 2 жϱ */
    AMHW_ZLG_TIM_CC3IF   = (1UL << 3),  /**< \brief /Ƚ 3 жϱ */
    AMHW_ZLG_TIM_CC4IF   = (1UL << 4),  /**< \brief /Ƚ 4 жϱ */
    AMHW_ZLG_TIM_COMIF   = (1UL << 5),  /**< \brief COMжϱ */
    AMHW_ZLG_TIM_TIF     = (1UL << 6),  /**< \brief жϱ */
    AMHW_ZLG_TIM_BIF     = (1UL << 7),  /**< \brief ɲжϱ */
    AMHW_ZLG_TIM_CC1OF   = (1UL << 9),  /**< \brief /Ƚ1ظ */
    AMHW_ZLG_TIM_CC2OF   = (1UL << 10), /**< \brief /Ƚ2ظ */
    AMHW_ZLG_TIM_CC3OF   = (1UL << 11), /**< \brief /Ƚ3ظ */
    AMHW_ZLG_TIM_CC4OF   = (1UL << 12), /**< \brief /Ƚ4ظ */
} amhw_zlg_tim_status_flag_t;

/**
 * \brief ȡöʱ״̬
 *
 * \param[in] p_hw_tim   : ָTIMʱĴָ
 * \param[in] status_flg : ʱ״̬ѡ, ֵΪ  amhw_zlg_tim_status_flag_t һö
 *
 * \return amhw_zlg_tim_status_flag_t һö͵ֵ(Էػ)
 */
am_static_inline
uint32_t amhw_zlg_tim_status_flg_get (amhw_zlg_tim_t    *p_hw_tim,
                                      uint32_t           status_flg)
{
    return (p_hw_tim->sr & status_flg);
}

/**
 * \brief ʱر־
 *
 * \param[in] p_hw_tim   : ָTIMʱĴָ
 * \param[in] status_flg : ʱ״̬ѡ, ֵΪ  amhw_zlg_tim_status_flag_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_status_flg_clr (amhw_zlg_tim_t    *p_hw_tim,
                                  uint32_t           status_flg)
{
    p_hw_tim->sr = ~status_flg;
}

/**
 * \brief ʱ¼ö
 */
typedef enum amhw_zlg_tim_egr {
    AMHW_ZLG_TIM_UG     = (1UL << 0),  /**< \brief ¼ */
    AMHW_ZLG_TIM_CC1G   = (1UL << 1),  /**< \brief /Ƚ 1¼ */
    AMHW_ZLG_TIM_CC2G   = (1UL << 2),  /**< \brief /Ƚ 2¼ */
    AMHW_ZLG_TIM_CC3G   = (1UL << 3),  /**< \brief /Ƚ 3¼ */
    AMHW_ZLG_TIM_CC4G   = (1UL << 4),  /**< \brief /Ƚ 4¼ */
    AMHW_ZLG_TIM_COMG   = (1UL << 5),  /**< \brief COM¼ */
    AMHW_ZLG_TIM_TG     = (1UL << 6),  /**< \brief ¼ */
    AMHW_ZLG_TIM_BG     = (1UL << 7),  /**< \brief ɲ¼ */
} amhw_zlg_tim_egr_t;

/**
 * \brief ʱ¼
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] egr_opt  : ʱ¼ѡ, ֵΪ  amhw_zlg_tim_egr_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_egr_set (amhw_zlg_tim_t *p_hw_tim, uint8_t egr_opt)
{
    p_hw_tim->egr |= egr_opt;
}

/**
 * \brief 
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] utg_opt  : ѡ, ʱΪ
 *
 *                       0  15875nSʱΪ 125nS
 *                       6uS  31750nSʱΪ 250nS
 *                       32uS  63uSʱΪ 1uS
 *                       64uS  126uSʱΪ 2 uS
 * \return 
 */
am_static_inline
void amhw_zlg_tim_utg_set (amhw_zlg_tim_t *p_hw_tim, uint8_t utg_opt)
{
    AM_BITS_SET(p_hw_tim->bdtr, 0, 7, utg_opt);
}

/**
 * \brief 
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] lock_opt : ѡ
 *                       0: رգĴд
 *                       1:  1д TIMx_BDTRĴ DTG BKE BKP AOEλ
 *                          TIMx_CR2Ĵ OISx/OISxN λ
 *                       2:  2д 1еĸλҲд CC λһͨ
 *                          ͨCCxSλΪCCλ TIMx_CCERĴ CCxP/CCNxPλ
 *                          OSSR/OSSI λ
 *                       3: 3д 2еĸλҲдCCλһͨͨ
 *                           CCxSλΪCCλ TIMx_CCMRx Ĵ OCxM/OCxPEλ
 *
 * \noteϵͳλֻдһ LOCKλһдTIMx_BDTRĴݶֱλ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_lock_set (amhw_zlg_tim_t *p_hw_tim, uint8_t lock_opt)
{
    AM_BITS_SET(p_hw_tim->bdtr, 8, 2, lock_opt);
}

/**
 * \brief ģʽ¡ر״̬
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ossi_opt : ģʽ¡ر״̬ѡ
 *                       0: ʱʱֹOC/OCNOC/OCNʹź  = 0
 *                       1: ʱʱһ CCxE = 1  CCxNE = 1ȿ OC/OCN Ч
 *                              ƽȻ OC/OCN ʹź  = 1
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ossi_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ossi_opt)
{
    AM_BIT_MODIFY(p_hw_tim->bdtr, 10, ossi_opt);
}

/**
 * \brief ģʽ¡ر״̬
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ossr_opt : ģʽ¡ر״̬ѡ
 *                       0: ʱʱֹOC/OCNOC/OCNʹź  = 0
 *                       1: ʱʱһ CCxE = 1  CCxNE = 1ȿ OC/OCN Ч
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ossr_set (amhw_zlg_tim_t *p_hw_tim, uint8_t ossr_opt)
{
    AM_BIT_MODIFY(p_hw_tim->bdtr, 11, ossr_opt);
}

/**
 * \brief ʱʹö
 */
typedef enum amhw_zlg_tim_bdtr_en {
    AMHW_ZLG_TIM_MOE   = (1UL << 15),  /**< \brief ʹ */
    AMHW_ZLG_TIM_AOE   = (1UL << 14),  /**< \brief Զʹ */
    AMHW_ZLG_TIM_BKE   = (1UL << 12),  /**< \brief ɲʹ */
} amhw_zlg_tim_bdtr_en_t;

/**
 * \brief ʱʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] bdtr_opt : ʱʹѡ, ֵΪ  amhw_zlg_tim_bdtr_en_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_bdtr_enable (amhw_zlg_tim_t    *p_hw_tim,
                               uint32_t           bdtr_opt)
{
    p_hw_tim->bdtr |= bdtr_opt;
}

/**
 * \brief ʱͽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] bdtr_opt : ʱͽѡ, ֵΪ  amhw_zlg_tim_bdtr_en_t һö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_bdtr_disable (amhw_zlg_tim_t    *p_hw_tim,
                                uint32_t           bdtr_opt)
{
    p_hw_tim->bdtr &= ~bdtr_opt;
}

/**
 * \brief ɲ뼫
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] bkp_opt  : ɲ뼫ѡ, 0: ɲ͵ƽЧ; 1: ɲߵƽЧ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_bkp_set (amhw_zlg_tim_t *p_hw_tim, uint8_t bkp_opt)
{
    AM_BIT_MODIFY(p_hw_tim->bdtr, 13, bkp_opt);
}

/**
 * \brief ʱDMAַ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] dba_opt  : ʱDMAַѡ, ֵΪ0 ~ 31
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dba_set (amhw_zlg_tim_t *p_hw_tim, uint8_t dba_opt)
{
    AM_BITS_SET(p_hw_tim->dcr, 0, 5, dba_opt);
}

/**
 * \brief ʱDMA ͳ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] dbl_opt  : DMA ͳѡ, ֵΪ0 ~ 31
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dbl_set (amhw_zlg_tim_t *p_hw_tim, uint8_t dbl_opt)
{
    AM_BITS_SET(p_hw_tim->dcr, 8, 5, dbl_opt);
}

/**
 * \brief ʱDMAģʽĻַ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] dmab_opt : ʱDMAģʽĻַѡ, ֵΪ0 ~ 65536
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_dmab_set (amhw_zlg_tim_t *p_hw_tim, uint16_t dmab_opt)
{
    p_hw_tim->dcr = dmab_opt;
}

/**
 * \brief ʱ벶/Ƚͨö
 */
typedef enum amhw_zlg_tim_ccs_chan {
    AMHW_ZLG_TIM_CC1S   = 0,  /**< \brief CC1S */
    AMHW_ZLG_TIM_CC2S   = 1,  /**< \brief CC2S */
    AMHW_ZLG_TIM_CC3S   = 2,  /**< \brief CC3S */
    AMHW_ZLG_TIM_CC4S   = 3,  /**< \brief CC4S */

} amhw_zlg_tim_ccs_chan_t;

/**
 * \brief /Ƚccsͨ
 *
 * \param[in] p_hw_tim  : ָTIMʱĴָ
 * \param[in] ccs_opt   : /Ƚccs ͨѡ
 *                        0: CC*ͨΪ
 *                        1: CC*ͨΪ룬IC1 ӳ TI1
 *                        2: CC*ͨΪ룬IC2 ӳ TI1
 *                        3: CC*ͨΪ룬IC* ӳ TRC
 *
 * \note :  When ccs_opt is 1, TIM Input 1, 2, 3 or 4 is selected to be
 *          connected  to IC1, IC2, IC3 or IC4, respectively
 *
 * \note :  When ccs_opt is 2, TIM Input 1, 2, 3 or 4 is selected to be
 *          connected  to IC2, IC1, IC4 or IC3, respectively
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \note : CC*S ͨرʱTIMx_CCER Ĵ CC*E = 0ǿд
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_set (amhw_zlg_tim_t    *p_hw_tim,
                           uint8_t            ccs_opt,
                           uint32_t           ccs_chan)
{
    AM_BITS_SET(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01)) , 2, ccs_opt);
}

/*******************************************************************************
                   ºccmrĴcc*sλΪ Ƚģʽʱ
*******************************************************************************/

/**
 * \brief ͨȽϿʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_ocfe_enable (amhw_zlg_tim_t    *p_hw_tim,
                                   uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 2), 1);
}

/**
 * \brief ͨȽϿٽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_ocfe_disable (amhw_zlg_tim_t    *p_hw_tim,
                                    uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 2), 0);
}

/**
 * \brief ͨȽԤװʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_ocpe_enable (amhw_zlg_tim_t    *p_hw_tim,
                                   uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 3), 1);
}

/**
 * \brief ͨȽԤװؽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_ocpe_disable (amhw_zlg_tim_t    *p_hw_tim,
                                    uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 3), 0);
}

/**
 * \brief ͨȽ0ʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_occe_enable (amhw_zlg_tim_t    *p_hw_tim,
                                   uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 7), 1);
}

/**
 * \brief ͨȽ0
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccs_occe_disable (amhw_zlg_tim_t    *p_hw_tim,
                                    uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 7), 0);
}

/**
 * \brief ʱȽö
 */
typedef enum amhw_zlg_tim_output_cmp_mode {
    AMHW_ZLG_TIM_FROZEN                   = 0,  /**< \brief  */
    AMHW_ZLG_TIM_MATCH_CHANNAL_SETACTIVE  = 1,  /**< \brief ƥʱͨΪЧƽ */
    AMHW_ZLG_TIM_MATCH_CHANNAL_SETINACTIV = 2,  /**< \brief ƥʱͨ ΪЧƽ */
    AMHW_ZLG_TIM_TOGGLE                   = 3,  /**< \brief ת */
    AMHW_ZLG_TIM_FORCE_INACTIVE_LEVEL     = 4,  /**< \brief ǿΪЧƽ */
    AMHW_ZLG_TIM_FORCE_ACTIVE_LEVEL       = 5,  /**< \brief ǿΪЧƽ */
    AMHW_ZLG_TIM_PWM_MODE1                = 6,  /**< \brief PWMģʽ1 */
    AMHW_ZLG_TIM_PWM_MODE2                = 7,  /**< \brief PWMģʽ2 */
} amhw_zlg_tim_output_cmp_mode_t;

/**
 * \brief ͨȽģʽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ocm_opt  : Ƚģʽѡ, ֵΪ amhw_zlg_tim_output_cmp_mode_t һö
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \note : 1. OC*M һ LOCK Ϊ 3 TIMx_BDTR Ĵе LOCK λ CC*S = 00 
 *           ͨóλܱ޸
 *         2.  PWM ģʽ 1  PWM ģʽ 2 УֻеȽϽı˻Ƚģʽд
 *           ģʽл PWM ģʽʱOC*REF ƽŸı
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ocm_set (amhw_zlg_tim_t    *p_hw_tim,
                           uint8_t            ocm_opt,
                           uint8_t            ccs_chan)
{
    AM_BITS_SET(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 4) , 3, ocm_opt);
}

/**
 * \brief ͨȽƽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccp_opt  : ͨȽƽѡ, 0: OC1ߵƽЧ; 1: OC1͵ƽЧ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccp_output_set (amhw_zlg_tim_t    *p_hw_tim,
                                  uint8_t            ccp_opt,
                                  uint32_t           ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan + 1), ccp_opt);
}

/**
 * \brief Ƚͨʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_cce_output_enable (amhw_zlg_tim_t    *p_hw_tim,
                                     uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan ), 1);
}

/**
 * \brief Ƚͨ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_cce_output_disable (amhw_zlg_tim_t    *p_hw_tim,
                                      uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan ), 0);
}

/**
 * \brief ȡñȽͨԤװֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ch       : ƥͨ  Чֵ0-3
 *
 * \note:  ͨöʱTIM2TIM3üĴΪ32λΪ16λ

 * \return ȽͨԤװصֵ
 */
am_static_inline
uint32_t amhw_zlg_tim_ouput_reload_val_get (amhw_zlg_tim_t    *p_hw_tim,
                                            uint8_t            ch)
{
    return p_hw_tim->ccr[ch];
}

/**
 * \brief ñȽͨԤװֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] value    : ȽͨԤװֵ
 * \param[in] ch       : ͨЧֵ0-3
 *
 *\ note:  ͨöʱTIM2TIM3üĴΪ32λΪ16λ
 *
 * \return ָͨĲֵ
 */
am_static_inline
void amhw_zlg_tim_ccr_ouput_reload_val_set (amhw_zlg_tim_t    *p_hw_tim,
                                            uint32_t           value,
                                            uint8_t            ch)
{
    p_hw_tim->ccr[ch] = value;
}

/*******************************************************************************
                   ºccmrĴcc*sλΪȽģʽʱ
*******************************************************************************/

/**
 * \brief ͨ/ԤƵ
 *
 * \param[in] p_hw_tim  : ָTIMʱĴָ
 * \param[in] icpsc_opt : /Ƚ Ƶѡ
 *                        0: ޷Ƶ;              1: ÿ 2¼һβ
 *                        2: ÿ 4¼һβ;   3: ÿ 8¼һβ
 *
 * \param[in] ccs_chan  : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_icpsc_set (amhw_zlg_tim_t    *p_hw_tim,
                             uint8_t            icpsc_opt,
                             uint8_t            ccs_chan)
{
    AM_BITS_SET(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 2) , 2, icpsc_opt);
}

/**
 * \brief ͨ벶˲ѡö
 */
typedef enum amhw_zlg_tim_icf {
    AMHW_ZLG_TIM_ICF_FSAMPLING0   = 0x00,  /**< \brief ˲ */
    AMHW_ZLG_TIM_ICF_FSAMPLING1   = 0x08,  /**< \brief Ƶ fSAMPLING = fDTS/8N = 6 */
    AMHW_ZLG_TIM_ICF_FSAMPLING2   = 0x01,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 2 */
    AMHW_ZLG_TIM_ICF_FSAMPLING3   = 0x09,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 4 */
    AMHW_ZLG_TIM_ICF_FSAMPLING4   = 0x02,  /**< \brief Ƶ fSAMPLING = fDTS/16N = 5 */
    AMHW_ZLG_TIM_ICF_FSAMPLING5   = 0x0A,  /**< \brief Ƶ fSAMPLING = fCK_INTN = 8 */
    AMHW_ZLG_TIM_ICF_FSAMPLING6   = 0x03,  /**< \brief Ƶ fSAMPLING = fDTS/16N = 6 */
    AMHW_ZLG_TIM_ICF_FSAMPLING7   = 0x0B,  /**< \brief Ƶ fSAMPLING = fDTS/2N = 6 */
    AMHW_ZLG_TIM_ICF_FSAMPLING8   = 0x04,  /**< \brief Ƶ fSAMPLING = fDTS/16N = 8 */
    AMHW_ZLG_TIM_ICF_FSAMPLING9   = 0x0C,  /**< \brief Ƶ fSAMPLING = fDTS/2N = 8 */
    AMHW_ZLG_TIM_ICF_FSAMPLING10  = 0x05,  /**< \brief Ƶ fSAMPLING = fDTS/16N = 5 */
    AMHW_ZLG_TIM_ICF_FSAMPLING11  = 0x0D,  /**< \brief Ƶ fSAMPLING = fDTS/4N = 6 */
    AMHW_ZLG_TIM_ICF_FSAMPLING12  = 0x06,  /**< \brief Ƶ fSAMPLING = fDTS/32N = 6 */
    AMHW_ZLG_TIM_ICF_FSAMPLING13  = 0x0E,  /**< \brief Ƶ fSAMPLING = fDTS/4N = 8 */
    AMHW_ZLG_TIM_ICF_FSAMPLING14  = 0x07,  /**< \brief Ƶ fSAMPLING = fDTS/4N = 8 */
    AMHW_ZLG_TIM_ICF_FSAMPLING15  = 0x0F,  /**< \brief Ƶ fSAMPLING = fDTS/32N = 8 */
} amhw_zlg_tim_icf_t;

/**
 * \brief ͨ벶˲Ƶ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] icf_opt  : 벶˲ƵѡֵΪ amhw_zlg_tim_icf_t һö
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_icf_set (amhw_zlg_tim_t    *p_hw_tim,
                           uint8_t            icf_opt,
                           uint8_t            ccs_chan)
{
    AM_BITS_SET(p_hw_tim->ccmr[ccs_chan >> 1], (8 * (ccs_chan & 0x01) + 4) , 4, icf_opt);
}

/**
 * \brief 벶(ⲿ)ƽ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] type     : ʱ
 * \param[in] ccp_opt  : 벶ͨƽѡ
 *                       1: ࣺ ICx أⲿʱICx;
 *                       2: ࣺ ICx ½أⲿʱ ICx
 *                        xͨݶʱĲͬͨҲͬΪ4ͨ
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \note : һ LOCK TIMx_BDTR Ĵе LCCK λΪ 3  2λܱ޸
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccp_captrigger_set (amhw_zlg_tim_t        *p_hw_tim,
                                      amhw_zlg_tim_type_t    type,
                                      uint8_t                ccp_opt,
                                      uint8_t                ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan + 1), ccp_opt >> 1);
}

/**
 * \brief 벶ͨʹ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_cce_cap_enable (amhw_zlg_tim_t    *p_hw_tim,
                                  uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan), 1);
}

/**
 * \brief 벶/Ƚͨ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_cce_cap_disable (amhw_zlg_tim_t    *p_hw_tim,
                                   uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan), 0);
}

/**
 * \brief 벶񻥲
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccnp_opt : 벶񻥲ѡ
 *                       0: OCNߵƽЧ;
 *                       1: OCN͵ƽЧ;
 *
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \note : һ LOCK TIMx_BDTR Ĵе LCCK λΪ 3  2λܱ޸
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccne_set (amhw_zlg_tim_t    *p_hw_tim,
                            uint8_t            ccnp_opt,
                            uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan + 3), ccnp_opt);
}

/**
 * \brief 벶񻥲ͨʹ
 *
 * \param[in] p_hw_tim :    ָTIMʱĴָ
 * \param[in] ccs_chan :  ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccne_enable (amhw_zlg_tim_t    *p_hw_tim,
                               uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan + 2), 1);
}

/**
 * \brief 벶񻥲ͨ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ccs_chan : ccsͨѡֵΪ amhw_zlg_tim_ccs_chan_t һ͵ö
 *
 * \return 
 */
am_static_inline
void amhw_zlg_tim_ccne_cap_disable (amhw_zlg_tim_t    *p_hw_tim,
                                    uint8_t            ccs_chan)
{
    AM_BIT_MODIFY(p_hw_tim->ccer, (4 * ccs_chan + 2), 0);
}

/**
 * \brief һͨȡֵ
 *
 * \param[in] p_hw_tim : ָTIMʱĴָ
 * \param[in] ch       : ͨЧֵ0-3
 *
 * \return ָͨĲֵ
 */
am_static_inline
uint32_t amhw_zlg_tim_ccr_cap_val_get (amhw_zlg_tim_t    *p_hw_tim,
                                       uint8_t            ch)
{
    return p_hw_tim->ccr[ch];
}

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AMHW_ZLG_TIM_H */

/* end of file */
