/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief trngtrng׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 20-03-10
 * \endinternal
 */
#ifndef __AM_ZSN700_trng_H
#define __AM_ZSN700_trng_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/**
 * \addtogroup am_zsn700_if_trng
 * \copydoc am_zsn700_trng.h
 * @{
 */

/**
 * \brief ɻ
 */
#define  AM_ZSN700_TRNG_POWER_ON      0     /**< \brief һϵ */
#define  AM_ZSN700_TRNG_POWER_NON     1     /**< \brief ǵһϵ */

/**
 * \brief TRNG豸Ϣṹ
 */
typedef struct am_zsn700_trng_info {

    uint32_t    reg_base;  /**< \brief trngĴַ */

    uint8_t     rng_cnt;   /**< \brief trngλ */

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit)(void);

}am_zsn700_trng_devinfo_t;

/**
 * \brief TRNG豸ʵ
 */
typedef struct am_zsn700_trng_dev {

    /** \brief ָtrng豸Ϣָ */
    const am_zsn700_trng_devinfo_t *p_devinfo;

} am_zsn700_trng_dev_t;

/** \brief TRNG׼Ͷ */
typedef am_zsn700_trng_dev_t *am_trng_handle_t;

/**
 * \brief trng ʼ
 *
 * \param[in] p_dev     : trng 豸ʵ
 * \param[in] p_devinfo : trng 豸Ϣʵ
 *
 * \retval : ׼TRNG
 *
 */
am_trng_handle_t am_zsn700_trng_init (am_zsn700_trng_dev_t          *p_dev,
                                     const am_zsn700_trng_devinfo_t *p_devinfo);

/**
 * \brief TRNG ȥʼ
 *
 * \param[in] handle : ׼TRNG
 *
 * \retval : 
 *
 */
void am_zsn700_trng_deinit (am_trng_handle_t handle);

/**
 * \brief 
 *
 * \param[in] handle   : TRNG ׼
 * \param[in] env_flag :  ϵϵ
 * \param[in] p_data   : 64λ
 *
 * \retval : AM_ERROR 
 *           AM_OK    ɹ
 */
int am_zsn700_trng_generate (am_trng_handle_t handle,
                             uint8_t          env_flag,
                             uint32_t         *p_data);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSN700_TRNG_H */

/* end of file */
