/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg118.cn/
*******************************************************************************/

/**
 * \file
 * \brief UARTUART׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.00 19-09-19  zp, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG118_UART_H
#define __AM_ZLG118_UART_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_uart.h"
#include "hw/amhw_zlg118_uart.h"

/**
 * \addtogroup am_zlg118_if_uart
 * \copydoc am_zlg118_uart.h
 * @{
 */

/**
 * \name ţصcodeݸûָǰĴ
 *
 *  صĲԭͣ\n
 *  int uart_err(void *p_arg, int code, void *p_data, int size);
 *  p_argûעûp_datasizeͬĴͰϢͬ
 *  ʹam_uart_callback_set() ôڴص
 * @{
 */

/**
 * \brief ûָжϷ,p_dataΪuint32_tֵΪڵж״̬
 *        ûжϾжԴsizeΪ1
 */
#define AM_ZLG118_UART_ERRCODE_UART_OTHER_INT  3

/**
 * \brief صXONַ壬Ĭ0x11
 */
#define AM_ZLG118_UART_XON       0x11

/**
 * \brief صXOFFַ壬Ĭ0x13
 */
#define AM_ZLG118_UART_XOFF      0x13

/** @} */

/**
 * \brief 豸Ϣṹ壬豸Ϣڴڳʼ
 */
typedef struct am_zlg118_uart_devinfo {

    uint32_t uart_reg_base;     /**< \brief ָUARTĴָ */

    uint8_t  inum;              /**< \brief жϺ */

    amhw_zlg118_uart_work_mode_t work_mode; /**< \brief ڹģʽ */

    uint32_t cfg_flags;         /**< \brief ñ־ */

    uint32_t baud_rate;         /**< \brief ʼ */

    /**
     * \brief ָʹܵж,AMHW_ZLG118_UART_INT_*ֵAMHW_ZLG118_UART_INT_*
     */
    uint32_t other_int_enable;

    struct {
        am_bool_t enable;          /**< \brief ʹλ */
        uint8_t   addr;            /**< \brief 豸ַ */
        uint8_t   addr_mask;       /**< \brief 豸ַ루ϵַʹ 0   1ƥ䣩 */
    } mut_addr;                    /**< \brief ַԶʶϢ */


    struct {
        am_bool_t enable;          /**< \brief ǷʹӲ */
        uint32_t  cts_pin;         /**< \brief cts ض */
        uint32_t  rts_pin;         /**< \brief rts ض */
    }hwflowctl_cfg;

    /** \brief RS485 ƺ, AM_TRUE: ģʽ AM_FALSE: ģʽ */
    void (*pfn_rs485_dir) (am_bool_t is_txmode);

    void (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ȥʼ */

} am_zlg118_uart_devinfo_t;

/**
 * \brief 豸ṹ嶨
 */
typedef struct am_zlg118_uart_dev {

    am_uart_serv_t  uart_serv; /**< \brief ׼UART */

    /** \brief ָûעtxchar_get */
    int (*pfn_txchar_get)(void *, char *);

    /** \brief ָûעrxchar_put */
    int (*pfn_rxchar_put)(void *, char);

    /** \brief ָûעĴص */
    int (*pfn_err)(void *, int, void *, int);

    void     *txget_arg;                    /**< \brief txchar_get */
    void     *rxput_arg;                    /**< \brief rxchar_put */
    void     *err_arg;                      /**< \brief صû */

    uint8_t   flowctl_mode;                 /**< \brief ģʽޣӲ   */
    uint8_t   flowctl_tx_stat;              /**< \brief ط״̬أ */

    amhw_zlg118_uart_work_mode_t work_mode; /**< \brief ڹģʽ*/
    uint8_t   channel_mode;                 /**< \brief ģʽ ж/ѯ */
    uint32_t  clk_rate;                     /**< \brief ģʽʱƵ */
    uint32_t  baud_rate;                    /**< \brief ڲ */
    uint16_t  options;                      /**< \brief Ӳѡ */

    uint32_t  other_int_enable;             /**< \brief ָʹܵж */

    am_bool_t rs485_en;                     /**< \brief Ƿʹ 485 ģʽ */

    const am_zlg118_uart_devinfo_t *p_devinfo; /**< \brief ָ豸Ϣָ */

} am_zlg118_uart_dev_t;

/**
 * \brief ʼUARTUART׼
 *
 * \param[in] p_dev     : ָ򴮿豸ָ
 * \param[in] p_devinfo : ָ򴮿豸Ϣָ
 *
 * \return UART׼ֵΪNULLʱʼʧ
 */
am_uart_handle_t am_zlg118_uart_init(am_zlg118_uart_dev_t           *p_dev,
                                     const am_zlg118_uart_devinfo_t *p_devinfo);

/**
 * \brief ʹUARTʱʼUARTͷԴ
 *
 * \param[in] p_dev : ָ򴮿豸ָ
 */
void am_zlg118_uart_deinit (am_zlg118_uart_dev_t *p_dev);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZLG118_UART_H */

/* end of file */
