/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief VCVC׼ӿ
 *
 * \internal
 * \par Modification History
 * - 1.01 20-04-27 zcb, Add callback function parameters
 * - 1.00 19-09-27
 * \endinternal
 */
#ifndef __AM_ZSL42x_VC_H
#define __AM_ZSL42x_VC_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"
#include "hw/amhw_zsl42x_vc.h"

/**
 * \addtogroup am_zsl42x_if_vc
 * \copydoc am_zsl42x_vc.h
 * @{
 */

/**
 * \brief VC豸Ϣṹ
 */
typedef struct am_zsl42x_vc_info {

    /** \brief VC Ĵַ */
    uint32_t    vc_reg_base;

    /** \brief VC жϱ */
    uint8_t     vc_inum;

    /** \brief VC ͨ ѡ*/
    uint32_t    vc_chan;

    /** \brief VC ο ѡ*/
    uint32_t    vc_vref;

    /** \brief VC ʱ ѡ*/
    uint32_t    vc_delay;

    /** \brief VC  ѡ*/
    uint32_t    vc_bias;

    /** \brief VC ˲ʱ ѡ 粻ʹ˲ΪNULL*/
    uint32_t    vc_flt_time;

    /** \brief VC p ѡ*/
    uint32_t    vc_p_in;

    /** \brief VC n ѡ*/
    uint32_t    vc_n_in;

    /** \brief VC */
    uint32_t    vc_out_cfg;

    /** \brief VC жѡ*/
    uint32_t    vc_out_int;

    /** \brief ƽ̨ʼʱӣŵȹ */
    void     (*pfn_plfm_init) (void);

    /** \brief ƽ̨ʼ */
    void     (*pfn_plfm_deinit) (void);

}am_zsl42x_vc_devinfo_t;

/**
 * \brief VC豸ʵ
 */
typedef struct am_zsl42x_vc_dev {

    /** \brief ָVC豸Ϣָ */
    const am_zsl42x_vc_devinfo_t *p_devinfo;

    /** \brief ǰתͨ */
    uint32_t                    chan;

    /** \brief жϴص  */
    am_pfnvoid_t                pfn_trigger_cb;

    /** \brief жϴص  */
    void                       *p_arg;

} am_zsl42x_vc_dev_t;

/** \brief VC ׼Ͷ */
typedef am_zsl42x_vc_dev_t *am_zsl42x_vc_handle_t;

/**
 * \brief VC ʼ
 *
 * \param[in] p_dev     : VC豸ʵ
 * \param[in] p_devinfo : VC豸Ϣʵ
 *
 * \retval ׼VC
 */
am_zsl42x_vc_handle_t am_zsl42x_vc_init (am_zsl42x_vc_dev_t           *p_dev,
                                     const am_zsl42x_vc_devinfo_t *p_devinfo);

/**
 * \brief VC ȥʼ
 *
 * \param[in] handle    : ׼VC
 */
void am_zsl42x_vc_deinit (am_zsl42x_vc_handle_t        handle);

/**
 * \brief жϴ
 *
 * \param[in] handle    : ׼VC
 * \param[in] pfn_cb    : ûжϴص
 * \param[in] p_arg     : ûжϴص
 *
 * \retval AM_ERROR ʧ
 * \retval AM_ERROR ӳɹ
 *
 */
int am_zsl42x_tri_set (am_zsl42x_vc_handle_t           handle,
                     am_pfnvoid_t                  pfn_cb,
                     void                         *p_arg);

/**
 * \brief VCͨʹ
 *
 * \param[in] handle    : ׼VC
 *
 * \retval AM_ERROR ʹʧ
 * \retval AM_ERROR ʹܳɹ
 */
int am_zsl42x_vc_chan_enable (am_zsl42x_vc_handle_t    handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __AM_ZSL42x_VC_H */

/* end of file */
