/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief IWDGӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 15-07-07  sss, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_IWDG_H
#define __AM_ZLG_IWDG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_wdt.h"

/**
 * \addtogroup am_zlg_if_iwdg
 * \copydoc am_zlg_iwdg.h
 * @{
 */

/**
 * \brief IWDG豸Ϣṹ
 */
typedef struct am_zlg_iwdg_devinfo {

    /** \brief IWDGĴַ */
    uint32_t iwdg_regbase;

    /** \brief ƽ̨ʼ */
    void   (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void   (*pfn_plfm_deinit)(void);

} am_zlg_iwdg_devinfo_t;

/**
 * \brief IWDG豸ṹ
 */
typedef struct am_zlg_iwdg_dev {

    /** \brief IWDGṩı׼ */
    am_wdt_serv_t                 wdt_serv;

    /** \brief ԤƵ */
    uint16_t                      div;

    /** \brief ָIWDG豸Ϣָ */
    const am_zlg_iwdg_devinfo_t  *p_devinfo;
} am_zlg_iwdg_dev_t;

/**
 * \brief IWDGʼ
 *
 * \param[in] p_dev     : ָIWDG豸
 * \param[in] p_devinfo : ָIWDG豸Ϣ
 *
 * \return IWDG׼ʧ򷵻NULL
 */
am_wdt_handle_t am_zlg_iwdg_init (am_zlg_iwdg_dev_t              *p_dev,
                                     const am_zlg_iwdg_devinfo_t *p_devinfo);

/**
 * \brief IWDG豸ʼ
 *
 * \param[in] handle : ʹIWDGʼam_zlg_iwdg_init()ȡhandle
 *
 * \return 
 */
void am_zlg_iwdg_deinit (am_wdt_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif /* __AMHW_IWDG_H */

#endif

/* end of file */

