/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief WWDGӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 15-07-07  sss, first implementation
 * \endinternal
 */

#ifndef __AM_ZLG_WWDG_H
#define __AM_ZLG_WWDG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "ametal.h"
#include "am_wdt.h"

/**
 * \addtogroup am_zlg_if_wwdg
 * \copydoc am_zlg_wwdg.h
 * @{
 */

/**
 * \brief WWDG汾0豸Ϣṹ
 */
typedef struct am_zlg_wwdg_devinfo {

    /** \brief WWDGĴַ */
    uint32_t  wwdg_regbase;

    /** \brief ʱID */
    int       clk_num;

    /** \brief ƽ̨ʼ */
    void    (*pfn_plfm_init)(void);

    /** \brief ƽ̨ʼ */
    void    (*pfn_plfm_deinit)(void);

} am_zlg_wwdg_devinfo_t;

/**
 * \brief WWDG汾0豸ṹ
 */
typedef struct am_zlg_wwdg_dev {

    /** \brief WWDGṩı׼ */
    am_wdt_serv_t                   wdt_serv;

    /** \brief ԤƵ */
    uint16_t                        div;

    /** \brief ֵ */
    uint8_t                         count;

    /** \brief ָWWDG汾0豸Ϣָ */
    const am_zlg_wwdg_devinfo_t *p_devinfo;
} am_zlg_wwdg_dev_t;

/**
 * \brief WWDG汾0ʼ
 *
 * \param[in] p_dev     : ָWWDG汾0豸
 * \param[in] p_devinfo : ָWWDG汾0豸Ϣ
 *
 * \return WWDG׼ʧ򷵻NULL
 */
am_wdt_handle_t am_zlg_wwdg_init (am_zlg_wwdg_dev_t               *p_dev,
                                  const am_zlg_wwdg_devinfo_t  *p_devinfo);

/**
 * \brief WWDG汾0豸ʼ
 *
 * \param[in] handle : ʹWWDG汾0ʼam_zlg_wwdg_init()ȡhandle
 *
 * \return 
 */
void am_zlg_wwdg_deinit (am_wdt_handle_t handle);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif /* __AM_ZLG_WWDG_H */

#endif

/* end of file */

