/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief IWDGӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-13  sdy, first implementation
 * \endinternal
 */

#ifndef __AMHW_ZLG_IWDG_H
#define __AMHW_ZLG_IWDG_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_types.h"

/*
 * \brief ṹεĿʼ
 */
#if defined(__CC_ARM)
  #pragma push
  #pragma anon_unions
#elif defined(__ICCARM__)
  #pragma language=extended
#elif defined(__GNUC__)
#elif defined(__TMS470__)
#elif defined(__TASKING__)
  #pragma warning 586
#else
  #warning Not supported compiler t
#endif

/**
 * \addtogroup amhw_zlg_if_iwdg
 * \copydoc amhw_zlg_iwdg.h
 * @{
 */

/**
 * \brief IWDGĴṹ
 */
typedef struct amhw_zlg_iwdg {
    __IO uint32_t kr;  /**< \brief Ĵ */
    __IO uint32_t pr;  /**< \brief ԤƵĴ */
    __IO uint32_t rlr; /**< \brief װؼĴ */
    __IO uint32_t sr;  /**< \brief ״̬Ĵ */
} amhw_zlg_iwdg_t;

/**
 * \brief дֵ
 *
 * \param[in] p_hw_iwdg : ָIWDGĴָ
 * \param[in] key       : ֵ
 *
 *      - 0x5555  IWDG_PR  IWDG_RLR Ĵ
 *      - 0xAAAA ι
 *      - 0xCCCC Ź
 *
 * \return 
 */
am_static_inline
void amhw_zlg_iwdg_keyvalue_set (amhw_zlg_iwdg_t    *p_hw_iwdg,
                                 uint16_t            key)
{
    p_hw_iwdg->kr = key;
}

/**
 * \brief ԤƵֵ
 *
 * \param[in] p_hw_iwdg : ָIWDGĴָ
 * \param[in] div       : Ƶֵ
 *
 *      - 0 ԤƵ  = 4
 *      - 1 ԤƵ  = 8
 *      - 2 ԤƵ  = 16
 *      - 3 ԤƵ  = 32
 *      - 4 ԤƵ  = 64
 *      - 5 ԤƵ  = 128
 *      - 6 ԤƵ  = 256
 *      - 7 ԤƵ  = 256
 *
 * \return 
 */
am_static_inline
void amhw_zlg_iwdg_div_set (amhw_zlg_iwdg_t    *p_hw_iwdg,
                            uint8_t             div)
{
    p_hw_iwdg->pr = (div & 0x7ul);
}

/**
 * \brief װֵ
 *
 * \param[in] p_hw_iwdg : ָIWDGĴָ
 * \param[in] val       : ֵ
 *
 * \return 
 */
am_static_inline
void amhw_zlg_iwdg_reload_set (amhw_zlg_iwdg_t    *p_hw_iwdg,
                               uint16_t            val)
{
    p_hw_iwdg->rlr = (val & 0xffful);
}

/**
 * \brief Ź״̬
 *
 * \param[in] p_hw_iwdg : ָIWDGĴָ
 *
 * \return ״ֵ̬״̬ǻĹϵ
 *
 *        - 0  ״̬
 *        - 1  ŹԤƵ
 *        - 2  Źװֵ
 */
am_static_inline
uint8_t amhw_zlg_iwdg_status_get (amhw_zlg_iwdg_t *p_hw_iwdg)
{
   return (uint8_t)(p_hw_iwdg->sr & 0x3);
}

/**
 * @}
 */
/*
 * \brief ṹεĽ
 */

#if defined(__CC_ARM)
  #pragma pop
#elif defined(__ICCARM__)
#elif defined(__GNUC__)
#elif defined(__TMS470__)
#elif defined(__TASKING__)
  #pragma warning restore
#else
  #warning Not supported compiler t
#endif

#ifdef __cplusplus
}
#endif /* __AMHW_ZLG_IWDG_H */

#endif

/* end of file */
