/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader drivers for standard interface
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-15  yrh, first implementation
 * \endinternal
 */

#ifndef __AM_ZML165_BOOT_H
#define __AM_ZML165_BOOT_H

#include "am_boot.h"
#include "amhw_zlg_flash.h"
#include "am_boot_flash.h"

typedef struct am_zml165_boot_devinfo {
    uint32_t  app_start_addr;      /**< \brief Ӧôʼַ*/
    uint32_t  update_start_addr;   /**< \brief ʼַ*/
    uint32_t  update_flag_addr;    /**< \brief ־ĴŵַһǷӦôʼַǰ4ֽ*/
    /**< \brief Ӧôռõռõͬ*/
    uint32_t  app_region_sector_count;
    uint32_t  flash_start_addr;    /**< \brief flashʼַ*/
    uint32_t  flash_size;          /**< \brief flashĴС */

    uint32_t  ram_start_addr;      /**< \brief ramʼַ */
    uint32_t  ram_size;            /**< \brief ramĴС */

    void (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ȥʼ */
}am_zml165_boot_devinfo_t;

typedef struct am_zml165_boot_dev {
    am_zml165_boot_devinfo_t *p_devinfo;
    am_boot_flash_handle_t    flash_handle;   /**< \brief flash */

}am_zml165_boot_dev_t;

/**
 * \brief ʼBootLoaderBootLoader׼
 *
 * \param[in] p_dev     : ָBootLoader豸ָ
 * \param[in] p_devinfo : ָBootLoader豸Ϣָ
 *
 * \return BootLoader׼ֵΪNULLʱʼʧ
 */
int am_zml165_boot_init(am_zml165_boot_dev_t      *p_dev,
                        am_zml165_boot_devinfo_t  *p_devinfo,
                        am_boot_flash_handle_t     flash_handle);


#endif /* __AM_ZML165_BOOT_H */
