/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader ̼洢flash̼洢׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-21  yrh, first implementation
 * \endinternal
 */

#ifndef __AM_ZML165_BOOT_FIRMWARE_H
#define __AM_ZML165_BOOT_FIRMWARE_H

#include "am_boot_flash.h"
#include "am_boot_firmware.h"
typedef struct am_zml165_boot_firmware_flash_devinfo {
    uint32_t firmware_dst_addr;    /**< \brief ̼flashŵĿĵַ */
    uint32_t buf_size;

    void (*pfn_plfm_init)(void);   /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void); /**< \brief ƽ̨ȥʼ */
}am_zml165_boot_firmware_flash_devinfo_t;

typedef struct am_zml165_boot_firmware_flash_dev {
    /**< \brief ̼ŵı׼ */
    am_boot_firmware_serv_t           firmware_flash_serv;
    /**< \brief flashĲ*/
    am_boot_flash_handle_t            flash_handle;
    /**< \brief 豸Ϣ */
    am_zml165_boot_firmware_flash_devinfo_t *p_devinfo;
    /**< \brief ݻ */
    uint8_t                           buf_data[1024];
    /**< \brief ĴС */
    uint32_t                          buf_data_size;
    /**< \brief ǰеݴС */
    uint32_t                          curr_buf_data_size;
    /**< \brief ʼַ */
    uint32_t                          erase_sector_start_addr;
    /**< \brief ǰдflashĵַ */
    uint32_t                          curr_program_flash_addr;
    /**< \brief ̼ŵĿصַ */
    uint32_t                          firmware_dst_addr;
    /**< \brief ̼ܵĴС */
    uint32_t                          firmware_total_size;
    am_bool_t                         firmware_size_is_unknow;
}am_zml165_boot_firmware_flash_dev_t;

/**
 * \brief ʼ̼źر׼
 *
 * \param[in] p_dev     : ָ̼豸ָ
 * \param[in] p_devinfo : ָ̼豸Ϣָ
 *
 * \return ̼ű׼ֵΪNULLʱʼʧ
 */
am_boot_firmware_handle_t am_zml165_boot_firmware_flash_init (
    am_zml165_boot_firmware_flash_dev_t     *p_dev,
    am_zml165_boot_firmware_flash_devinfo_t *p_devinfo,
    am_boot_flash_handle_t                   flash_handle);


/**
 * \brief ̼flash洢ʼ
 */
void am_zml165_boot_firmware_flash_deint(void);

#endif /* __AM_ZML165_BOOT_FIRMWARE_H */

/* end of file */
