/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief bootloader flashbootloaderflash׼ӿ
 *
 * \internal
 * \par Modification history
 * - 1.00 18-11-21  yrh, first implementation
 * \endinternal
 */

#ifndef __AM_ZML165_BOOT_FLASH_H
#define __AM_ZML165_BOOT_FLASH_H
#include "am_zlg_flash.h"
#include "am_boot.h"
#include "am_boot_flash.h"

typedef struct am_zml165_boot_flash_devinfo {
    uint32_t  flash_start_addr;     /**< \brief flashʼַ */
    uint32_t  flash_size;           /**< \brief flashĴС */
    uint32_t  flash_sector_size;    /**< \brief flashС */
    uint32_t  flash_sector_count;   /**< \brief flashĿ */

    uint32_t  flash_reg_rebese;     /**< \brief flashĴַ */
    void (*pfn_plfm_init)(void);    /**< \brief ƽ̨ʼ */

    void (*pfn_plfm_deinit)(void);  /**< \brief ƽ̨ȥʼ */

} am_zml165_boot_flash_devinfo_t;

typedef struct am_zml165_boot_flash_dev {
    am_boot_flash_serv_t            flash_serv;     /**< \brief flash׼ */
    am_boot_flash_info_t            flash_info;     /**< \brief flashϢṹ */
    amhw_zlg_flash_t               *amhw_zlg_flash; /**< \brief flashĴṹ */
    am_zml165_boot_flash_devinfo_t *p_devinfo;      /**< \brief 豸Ϣṹ */
}am_zml165_boot_flash_dev_t;

/**
 * \brief ʼflashflash׼
 *
 * \param[in] p_dev     : ָflash豸ָ
 * \param[in] p_devinfo : ָflash豸Ϣָ
 *
 * \return flash׼ֵΪNULLʱʼʧ
 */
am_boot_flash_handle_t am_zml165_boot_flash_init(am_zml165_boot_flash_dev_t     *p_dev,
                                                 am_zml165_boot_flash_devinfo_t *p_devinfo);


#endif /* __AM_ZML165_BOOT_FLASH_H */

/* end of file */
