/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZML165 жϺŶ
 *
 * \internal
 * \par Modification history
 * - 1.00 17-04-07  sdy, first implementation
 * \endinternal
 */

#ifndef __ZLG_INUM_H
#define __ZLG_INUM_H

#ifdef __cplusplus
extern "C" {

#endif

#include "ametal.h"

/**
 * \addtogroup zml165_if_inum
 * \copydoc zml165_inum.h
 * @{
 */

/**
 * \name ZML165 CPU жϺ
 * @{
 */

#define INUM_WWDT                 0    /**< \brief ڶʱж */
#define INUM_PVD                  1    /**< \brief Դѹж */

#define INUM_FLASH                3    /**< \brief ȫж */
#define INUM_RCC_CRS              4    /**< \brief RCCCRS*ȫж */
#define INUM_EXTI0_1              5    /**< \brief EXTI[10]ж */
#define INUM_EXTI2_3              6    /**< \brief EXTI[32]ж */
#define INUM_EXTI4_15             7    /**< \brief EXTI[154]ж */

#define INUM_DMA1_1               9    /**< \brief DMA1ͨ1ȫж */
#define INUM_DMA1_2_3             10   /**< \brief DMA1ͨ23ȫж */
#define INUM_DMA1_4_5             11   /**< \brief DMA1ͨ45ȫж */
#define INUM_ADC_COMP             12   /**< \brief ADCͱȽж( EXTI1920һ) */
#define INUM_TIM1_BRK_UP_TRG_COM  13   /**< \brief TIM1ɲ¡COM */
#define INUM_TIM1_CC              14   /**< \brief TIM1׽Ƚж */
#define INUM_TIM2                 15   /**< \brief TIM2ȫж */
#define INUM_TIM3                 16   /**< \brief TIM3ȫж */

#define INUM_TIM14                19   /**< \brief TIM14ȫж */

#define INUM_TIM16                21   /**< \brief TIM16ȫж */
#define INUM_TIM17                22   /**< \brief TIM17ȫж */
#define INUM_I2C1                 23   /**< \brief I2C1ȫж */

#define INUM_SPI1                 25   /**< \brief SPI1ȫж */
#define INUM_SPI2                 26   /**< \brief SPI2ȫж */
#define INUM_UART1                27   /**< \brief UART1ȫж */
#define INUM_UART2                28   /**< \brief UART2ȫж */
#define INUM_AES                  29   /**< \brief AESȫж */
#define INUM_CAN                  30   /**< \brief CANȫж */
#define INUM_USB                  31   /**< \brief USBȫж */

/** @} */

/**
 * \brief жΪ(INUM_USB - INUM_WWDT + 1),
 *
 */
#define INUM_INTERNAL_COUNT     (INUM_USB - INUM_WWDT + 1)

/**
 * \brief жϺΪ INUM_USB
 */
#define INUM_INTERNAL_MAX        INUM_USB

/** \brief СжϺ: INUM_WWDT */
#define INUM_INTERNAL_MIN        INUM_WWDT

/**
 * \cond
 * жϺŶ壬Ϊ core_cm0.hļ
 */
typedef enum {

    /* ----------------------  Cortex-M0쳣  ------------------- */

    /** \brief 2  ж, ֹܱͣռ */
    NonMaskableInt_IRQn      = -14,

    /** \brief 3  Ӳж */
    HardFault_IRQn           = -13,

    /** \brief 11  ϵͳͨSVCָ */
    SVCall_IRQn              =  -5,

    /** \brief 14  ϵͳĹ */
    PendSV_IRQn              =  -2,

    /** \brief 15  ϵͳδʱ */
    SysTick_IRQn             =  -1,

    /******  ZML165 Specific Interrupt Numbers *******************************************************/
    WWDT_IRQn                 = 0,        /**< \brief ڶʱж */
    PVD_IRQn                  = 1,        /**< \brief Դѹж */
    Reserved0                 = 2,        /**< \brief RESERVED */
    FLASH_IRQn                = 3,        /**< \brief ȫж */
    RCC_CRS_IRQn              = 4,        /**< \brief RCCCRS*ȫж */
    EXTI0_1_IRQn              = 5,        /**< \brief EXTI[10]ж */
    EXTI2_3_IRQn              = 6,        /**< \brief EXTI[32]ж */
    EXTI4_15_IRQn             = 7,        /**< \brief EXTI[154]ж */
    Reserved1                 = 8,        /**< \brief RESERVED */
    DMA1_1_IRQn               = 9,        /**< \brief DMA1ͨ1ȫж */
    DMA1_2_3_IRQn             = 10,       /**< \brief DMA1ͨ23ȫж */
    DMA1_4_5_IRQn             = 11,       /**< \brief DMA1ͨ45ȫж */
    ADC_COMP_IRQn             = 12,       /**< \brief ADCͱȽж */
    TIM1_BRK_UP_TRG_COM_IRQn  = 13,       /**< \brief TIM1ɲ¡COM */
    TIM1_CC_IRQn              = 14,       /**< \brief TIM1׽Ƚж */
    TIM2_IRQn                 = 15,       /**< \brief TIM2ȫж */
    TIM3_IRQn                 = 16,       /**< \brief TIM3ȫж */
    Reserved2                 = 17,       /**< \brief RESERVED */
    Reserved3                 = 18,       /**< \brief RESERVED */
    TIM14_IRQn                = 19,       /**< \brief TIM14ȫж */
    Reserved4                 = 20,       /**< \brief RESERVED */
    TIM16_IRQn                = 21,       /**< \brief TIM16ȫж */
    TIM17_IRQn                = 22,       /**< \brief TIM17ȫж */
    I2C1_IRQn                 = 23,       /**< \brief I2C1ȫж */
    Reserved5                 = 24,       /**< \brief RESERVED */
    SPI1_IRQn                 = 25,       /**< \brief SPI1ȫж */
    SPI2_IRQn                 = 26,       /**< \brief SPI2ȫж */
    UART1_IRQn                = 27,       /**< \brief UART1ȫж */
    UART2_IRQn                = 28,       /**< \brief UART2ȫж */
    AES_IRQn                  = 29,       /**< \brief AESȫж */
    CAN_IRQn                  = 30,       /**< \brief CANȫж */
    USB_IRQn                  = 31,       /**< \brief USBȫж */
} IRQn_Type;

/**
 * \endcond
 */

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

#endif /* __ZLG_INUM_H */

/* end of file */
