/*******************************************************************************
*                                 AMetal
*                       ----------------------------
*                       innovating embedded platform
*
* Copyright (c) 2001-2018 Guangzhou ZHIYUAN Electronics Co., Ltd.
* All rights reserved.
*
* Contact information:
* web site:    http://www.zlg.cn/
*******************************************************************************/

/**
 * \file
 * \brief ZML165 GPIO ò
 *
 * \note: ŹܵʱһҪͬʱŵģʽģʽģʽ
 *
 * \internal
 * \par Modification History
 * - 1.00 17-04-07  nwt, first implementation
 * \endinternal
 */

#ifndef __ZML165_PIN_H
#define __ZML165_PIN_H

#ifdef __cplusplus
extern "C" {
#endif

#include "am_zml165_gpio_util.h"

#ifdef PIN_OUTSET
    #include "zml165_pin_outset.h"
#endif

 /**
 * \addtogroup zml165_if_pin
 * \copydoc zml165_pin.h
 * @{
 */

/**
 * \name ZML165 GPIO ű
 * \anchor grp_gpio_pin_number
 * @{
 */

#define PIOA            0         /**< \brief ˿Aʼ */
#define PIOA_0          0         /**< \brief PIOA_0 ź */
#define PIOA_1          1         /**< \brief PIOA_1 ź */
#define PIOA_2          2         /**< \brief PIOA_2 ź */
#define PIOA_3          3         /**< \brief PIOA_3 ź */
#define PIOA_4          4         /**< \brief PIOA_4 ź */
#define PIOA_5          5         /**< \brief PIOA_5 ź */
#define PIOA_6          6         /**< \brief PIOA_6 ź */
#define PIOA_7          7         /**< \brief PIOA_7 ź */
#define PIOA_8          8         /**< \brief PIOA_8 ź */
#define PIOA_9          9         /**< \brief PIOA_9 ź */
#define PIOA_10         10        /**< \brief PIOA_10 ź */
#define PIOA_11         11        /**< \brief PIOA_11 ź */
#define PIOA_12         12        /**< \brief PIOA_13 ź */
#define PIOA_13         13        /**< \brief PIOA_13 ź */
#define PIOA_14         14        /**< \brief PIOA_14 ź */
#define PIOA_15         15        /**< \brief PIOA_15 ź */

#define PIOB            16        /**< \brief ˿Bʼ */
#define PIOB_0          16        /**< \brief PIOB_8 ź */
#define PIOB_1          17        /**< \brief PIOB_1 ź */
#define PIOB_2          18        /**< \brief PIOB_2 ź */
#define PIOB_3          19        /**< \brief PIOB_3 ź */
#define PIOB_4          20        /**< \brief PIOB_4 ź */
#define PIOB_5          21        /**< \brief PIOB_5 ź */
#define PIOB_6          22        /**< \brief PIOB_3 ź */
#define PIOB_7          23        /**< \brief PIOB_4 ź */
#define PIOB_8          24        /**< \brief PIOB_5 ź */
#define PIOB_9          25        /**< \brief PIOB_5 ź */
#define PIOB_10         26        /**< \brief PIOB_10ź */
#define PIOB_11         27        /**< \brief PIOB_11ź */
#define PIOB_12         28        /**< \brief PIOB_12ź */
#define PIOB_13         29        /**< \brief PIOB_13ź */
#define PIOB_14         30        /**< \brief PIOB_14ź */
#define PIOB_15         31        /**< \brief PIOB_15ź */

#define PIOC            32        /**< \brief ˿Cʼ */
#define PIOC_13         45        /**< \brief PIOC_13ź */
#define PIOC_14         46        /**< \brief PIOC_14ź */
#define PIOC_15         47        /**< \brief PIOC_15ź */

#define PIOD            48        /**< \brief ˿Dʼ */
#define PIOD_0          48        /**< \brief PIOD_0ź */
#define PIOD_1          49        /**< \brief PIOD_1ź */
#define PIOD_2          50        /**< \brief PIOD_2ź */
#define PIOD_3          51        /**< \brief PIOD_3ź */

/**
 * \brief ĿΪ39
 */
#define PIN_NUM         39

/**
 * \brief ֧ͬʱж16
 */
#define PIN_INT_MAX     16

/** @} */

/**
 * \name ZML165Ŷ,SWCKSWIO֮⣬ŸλʱĬΪGPIO()
 * @{
 */

/******************************************************************************/

/**
 * \name PIOA_0Ÿù
 * @{
 */

#define PIOA_0_UART2_CTS      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_CTS */
#define PIOA_0_TIM2_CH1_ETR   AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH1_ETR */
#define PIOA_0_COMP1_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP1_OUT */
#define PIOA_0_ADC_IN0        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN0 */
#define PIOA_0_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_0Ÿʱģʽ
 * @{
 */

#define PIOA_0_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_0_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_0_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_0_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_0_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_0_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_0_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_0_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_0Ӧ
 * @{
 */

#define PIOA_0_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_0_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_0_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_1Ÿù
 * @{
 */

#define PIOA_1_UART2_RTS      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_RTS */
#define PIOA_1_TIM2_CH2       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH2 */
#define PIOA_1_ADC_IN1        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN1 */
#define PIOA_1_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_1Ÿʱģʽ
 * @{
 */

#define PIOA_1_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_1_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_1_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_1_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_1_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_1_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_1_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_1_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_1Ӧ
 * @{
 */

#define PIOA_1_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_1_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_1_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_2Ÿù
 * @{
 */

#define PIOA_2_UART2_TX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_TX */
#define PIOA_2_TIM2_CH3       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH3 */
#define PIOA_2_COMP2_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP2_OUT */
#define PIOA_2_ADC_IN2        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN2 */
#define PIOA_2_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */
/** @} */

/**
 * \name PIOA_2Ÿʱģʽ
 * @{
 */

#define PIOA_2_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_2_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_2_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_2_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_2_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_2_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_2_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_2_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_2Ӧ
 * @{
 */

#define PIOA_2_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_2_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_2_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_3Ÿù
 * @{
 */

#define PIOA_3_UART2_RX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_RX */
#define PIOA_3_TIM2_CH4       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH4 */
#define PIOA_3_ADC_IN3        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN3 */
#define PIOA_3_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_3Ÿʱģʽ
 * @{
 */

#define PIOA_3_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_3_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_3_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_3_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_3_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_3_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_3_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_3_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_3Ӧ
 * @{
 */

#define PIOA_3_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_3_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_3_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_4Ÿù
 * @{
 */

#define PIOA_4_SPI1_NSS       AM_ZML165_GPIO_FUNC_CODE(0x00)    /**< \brief SPI1_NSS */
#define PIOA_4_TIM14_CH1      AM_ZML165_GPIO_FUNC_CODE(0x04)    /**< \brief TIM14_CH1 */
#ifdef  ZML165
#define PIOA_4_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C_SDA */
#endif
#define PIOA_4_ADC_IN4        AM_ZML165_GPIO_FUNC_CODE(0x0F)    /**< \brief ADC_IN4 */
#define PIOA_4_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)    /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_4Ÿʱģʽ
 * @{
 */

#define PIOA_4_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_4_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_4_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_4_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_4_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_4_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_4_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_4_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_4Ӧ
 * @{
 */

#define PIOA_4_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_4_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_4_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_5Ÿù
 * @{
 */

#define PIOA_5_SPI1_SCK       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_SCK */
#define PIOA_5_TIM2_CH1_ETR   AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH1_ETR */
#ifdef  ZML165
#define PIOA_5_TIM1_CH3N      AM_ZML165_GPIO_FUNC_CODE(0x06)   /**< \brief TIM1_CH3N */
#define PIOA_5_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C1_SCL */
#endif
#define PIOA_5_ADC_IN5        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN5 */
#define PIOA_5_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_5Ÿʱģʽ
 * @{
 */

#define PIOA_5_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_5_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_5_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_5_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_5_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_5_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_5_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_5_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_5Ӧ
 * @{
 */

#define PIOA_5_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_5_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_5_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_6Ÿù
 * @{
 */

#define PIOA_6_SPI1_MISO      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MISO */
#define PIOA_6_TIM3_CH1       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH3 */
#define PIOA_6_TIM1_BKIN      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_BKIN */
#define PIOA_6_TIM16_CH1      AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief TIM3_CH3 */
#define PIOA_6_COMP1_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP1_OUT */
#define PIOA_6_ADC_IN6        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN6 */
#define PIOA_6_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_6Ÿʱģʽ
 * @{
 */

#define PIOA_6_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_6_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_6_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_6_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_6_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_6_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_6_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_6_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_6Ӧ
 * @{
 */

#define PIOA_6_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_6_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_6_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_7Ÿù
 * @{
 */

#define PIOA_7_SPI1_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MOSI */
#define PIOA_7_TIM3_CH2       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH2 */
#define PIOA_7_TIM1_CH1N      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH1N */
#define PIOA_7_TIM14_CH1      AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief TIM14_CH1 */
#define PIOA_7_TIM17_CH1      AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief TIM17_CH1 */
#define PIOA_7_COMP2_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP2_OUT */
#define PIOA_7_ADC_IN7        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN7 */
#define PIOA_7_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */
/** @} */

/**
 * \name PIOA_7Ÿʱģʽ
 * @{
 */

#define PIOA_7_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_7_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_7_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_7_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_7_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_7_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_7_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_7_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_7Ӧ
 * @{
 */

#define PIOA_7_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_7_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_7_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_8Ÿù
 * @{
 */

#define PIOA_8_MCO            AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief MCO */
#define PIOA_8_TIM1_CH1       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH1 */
#define PIOA_8_CRS_SYNC       AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief CRS_SYNC */
#define PIOA_8_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_8Ÿʱģʽ
 * @{
 */

#define PIOA_8_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_8_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_8_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_8_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_8_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_8_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_8_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_8_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_8Ӧ
 * @{
 */

#define PIOA_8_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_8_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_8_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_9Ÿù
 * @{
 */

#define PIOA_9_UART1_TX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART1_TX */
#define PIOA_9_TIM1_CH2       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH2 */
#define PIOA_9_UART1_RX       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief UART1_RX */
#define PIOA_9_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief I2C_SCL */
#define PIOA_9_MCO            AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief MCO */
#define PIOA_9_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */
/** @} */

/**
 * \name PIOA_9Ÿʱģʽ
 * @{
 */

#define PIOA_9_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_9_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_9_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_9_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_9_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_9_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_9_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_9_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_9Ӧ
 * @{
 */

#define PIOA_9_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_9_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_9_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_10Ÿù
 * @{
 */

#define PIOA_10_TIM17_BKIN     AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief TIM17_BKIN */
#define PIOA_10_UART1_RX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART1_RX */
#define PIOA_10_TIM1_CH3       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH3 */
#define PIOA_10_UART1_TX       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief UART1_TX */
#define PIOA_10_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief I2C_SDA */
#define PIOA_10_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */
/** @} */

/**
 * \name PIOA_10Ÿʱģʽ
 * @{
 */

#define PIOA_10_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_10_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_10_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_10_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_10_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_10_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_10_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_10_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_10Ӧ
 * @{
 */

#define PIOA_10_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_10_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_10_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_11Ÿù
 * @{
 */

#define PIOA_11_UART1_CTS      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART1_CTS */
#define PIOA_11_TIM1_CH4       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH4 */
#define PIOA_11_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C_SCL */
#define PIOA_11_COMP1_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP1_OUT */
#define PIOA_11_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_11Ÿʱģʽ
 * @{
 */

#define PIOA_11_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_11_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_11_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_11_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_11_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_11_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_11_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_11_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_11Ӧ
 * @{
 */

#define PIOA_11_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_11_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_11_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_12Ÿù
 * @{
 */

#define PIOA_12_UART1_RTS      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART1_RTS */
#define PIOA_12_TIM1_ETR       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_ETR */
#define PIOA_12_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C_SDA */
#define PIOA_12_COMP2_OUT      AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief COMP2_OUT */
#define PIOA_12_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_12Ÿʱģʽ
 * @{
 */

#define PIOA_12_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_12_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_12_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_12_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_12_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_12_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_12_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_12_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_12Ӧ
 * @{
 */

#define PIOA_12_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_12_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_12_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_13Ÿù
 * @{
 */

#define PIOA_13_SWDIO          AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SWDIO */
#define PIOA_13_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_13Ÿʱģʽ
 * @{
 */

#define PIOA_13_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_13_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_13_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_13_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_13_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_13_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_13_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_13_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_13Ӧ
 * @{
 */

#define PIOA_13_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_13_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_13_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_14Ÿù
 * @{
 */

#define PIOA_14_SWDCLK         AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SWDCLK */
#define PIOA_14_UART2_TX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_TX */
#define PIOA_14_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_14Ÿʱģʽ
 * @{
 */

#define PIOA_14_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_14_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_14_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_14_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_14_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_14_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_14_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_14_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_14Ӧ
 * @{
 */

#define PIOA_14_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_14_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_14_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOA_15Ÿù
 * @{
 */

#define PIOA_15_SPI1_NSS       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief SPI1_NSS */
#define PIOA_15_UART2_RX       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief UART2_RX */
#define PIOA_15_TIM2_CH1_ETR   AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH1_ETR */
#define PIOA_15_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOA_15Ÿʱģʽ
 * @{
 */

#define PIOA_15_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOA_15_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOA_15_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOA_15_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOA_15_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOA_15_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOA_15_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOA_15_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOA_15Ӧ
 * @{
 */

#define PIOA_15_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOA_15_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOA_15_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_0Ÿù
 * @{
 */

#define PIOB_0_TIM3_CH3        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH3 */
#ifdef ZML165
#define PIOB_0_TIM1_CH3        AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief TIM3_CH3 */
#endif
#define PIOB_0_TIM1_CH2N       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH2N */
#define PIOB_0_ADC_IN8         AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN8 */
#define PIOB_0_GPIO            AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_8Ÿʱģʽ
 * @{
 */

#define PIOB_0_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_0_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_0_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_0_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_0_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_0_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_0_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_0_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_0Ӧ
 * @{
 */

#define PIOB_0_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_0_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_0_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_1Ÿù
 * @{
 */

#define PIOB_1_TIM14_CH1      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief TIM14_CH1 */
#define PIOB_1_TIM3_CH4       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH4 */
#define PIOB_1_TIM1_CH3N      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH3N */
#define PIOB_1_ADC_IN9        AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN9 */
#define PIOB_1_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_1Ÿʱģʽ
 * @{
 */

#define PIOB_1_AIN           AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_1_INPUT_FLOAT   AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_1_INPUT_PD      AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_1_INPUT_PU      AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_1_OUT_PP        AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_1_OUT_OD        AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_1_AF_PP         AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_1_AF_OD         AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_1Ӧ
 * @{
 */

#define PIOB_1_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_1_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_1_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_2Ÿù
 * @{
 */

#define PIOB_2_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_2Ÿʱģʽ
 * @{
 */

#define PIOB_2_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_2_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_2_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_2_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_2_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_2_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_2_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_2_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_2Ӧ
 * @{
 */

#define PIOB_2_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_2_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_2_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_3Ÿù
 * @{
 */

#define PIOB_3_SPI1_SCK       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_SCK */
#define PIOB_3_TIM2_CH2       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH2 */
#ifdef  ZML165
#define PIOB_3_UART1_TX       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief TIM2_CH2 */
#define PIOB_3_TIM1_CH1       AM_ZML165_GPIO_FUNC_CODE(0x06)   /**< \brief TIM1_CH1 */

#define PIOB_3_ADC_IN10       AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN10 */
#endif
#define PIOB_3_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_3Ÿʱģʽ
 * @{
 */

#define PIOB_3_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_3_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_3_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_3_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_3_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_3_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_3_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_3_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_3Ӧ
 * @{
 */

#define PIOB_3_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_3_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_3_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_4Ÿù
 * @{
 */
#define PIOB_4_SPI1_MISO      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MISO */
#define PIOB_4_TIM3_CH1       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH1 */
#ifdef  ZML165
#define PIOB_4_UART1_RX       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief TIM3_CH1 */
#define PIOB_4_TIM1_CH2       AM_ZML165_GPIO_FUNC_CODE(0x06)   /**< \brief TIM2_CH2 */
#define PIOB_4_TIM2_CH2       AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief TIM2_CH2 */

#define PIOB_4_ADC_IN11       AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief ADC_IN11 */
#endif
#define PIOB_4_TIM17_BKIN     AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief TIM17_BKIN */
#define PIOB_4_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_4Ÿʱģʽ
 * @{
 */

#define PIOB_4_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_4_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_4_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_4_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_4_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_4_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_4_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_4_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_4Ӧ
 * @{
 */

#define PIOB_4_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_4_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_4_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_5Ÿù
 * @{
 */
#define PIOB_5_SPI1_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MOSI */
#define PIOB_5_TIM3_CH2       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief TIM3_CH2 */
#define PIOB_5_TIM16_BKIN     AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM16_BKIN */
#ifdef  ZML165
#define PIOB_5_TIM1_CH3       AM_ZML165_GPIO_FUNC_CODE(0x06)   /**< \brief TIM1_CH3 */
#define PIOB_5_TIM2_CH3       AM_ZML165_GPIO_FUNC_CODE(0x07)   /**< \brief TIM2_CH3 */
#endif
#define PIOB_5_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)  /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_5Ÿʱģʽ
 * @{
 */

#define PIOB_5_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_5_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_5_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_5_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_5_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_5_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_5_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_5_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_5Ӧ
 * @{
 */

#define PIOB_5_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_5_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_5_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_6Ÿù
 * @{
 */
#define PIOB_6_UART1_TX      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief UART1_TX */
#define PIOB_6_I2C_SCL       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SCL */
#define PIOB_6_TIM16_CH1N    AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM16_CH1N */
#define PIOB_6_GPIO          AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_6Ÿʱģʽ
 * @{
 */

#define PIOB_6_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_6_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_6_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_6_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_6_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_6_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_6_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_6_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_6Ӧ
 * @{
 */

#define PIOB_6_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_6_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_6_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_7Ÿù
 * @{
 */
#define PIOB_7_UART1_RX       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief UART1_RX */
#define PIOB_7_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SDA */
#define PIOB_7_TIM17_CH1N     AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM17_CH1N */
#define PIOB_7_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_7ܽŸʱŸʱģʽ
 * @{
 */

#define PIOB_7_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_7_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽ(Ĭ) */
#define PIOB_7_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_7_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_7_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_7_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_7_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_7_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_7Ӧ
 * @{
 */

#define PIOB_7_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_7_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_7_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_8Ÿù
 * @{
 */

#define PIOB_8_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SCL */
#define PIOB_8_TIM16_CH1      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM16_CH1 */
#define PIOB_8_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_8Ÿʱģʽ
 * @{
 */

#define PIOB_8_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_8_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_8_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_8_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_8_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_8_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_8_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_8_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_8Ӧ
 * @{
 */

#define PIOB_8_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_8_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_8_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_9Ÿù
 * @{
 */

#define PIOB_9_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SDA */
#define PIOB_9_TIM17_CH1      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM17_CH1 */
#define PIOB_9_SPI2_NSS       AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief SPI2_NSS */
#define PIOB_9_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_9Ÿʱģʽ
 * @{
 */

#define PIOB_9_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_9_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_9_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_9_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_9_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_9_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_9_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_9_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_9Ӧ
 * @{
 */

#define PIOB_9_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_9_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_9_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_10Ÿù
 * @{
 */
#define PIOB_10_I2C_SCL       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SCL */
#define PIOB_10_TIM2_CH3      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH3 */
#define PIOB_10_SPI2_SCK      AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief SPI2_SCK */
#define PIOB_10_GPIO          AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_10Ÿʱģʽ
 * @{
 */

#define PIOB_10_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_10_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_10_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_10_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_10_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_10_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_10_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_10_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_10Ӧ
 * @{
 */

#define PIOB_10_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_10_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_10_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_11Ÿù
 * @{
 */

#define PIOB_11_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SDA */
#define PIOB_11_TIM2_CH4       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM2_CH4 */
#define PIOB_11_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_11Ÿʱģʽ
 * @{
 */

#define PIOB_11_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_11_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_11_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_11_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_11_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_11_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_11_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_11_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_11Ӧ
 * @{
 */

#define PIOB_11_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_11_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_11_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_12Ÿù
 * @{
 */

#define PIOB_12_SPI1_NSS       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_NSS */
#define PIOB_12_SPI2_SCK       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief SPI2_SCK */
#define PIOB_12_TIM1_BKIN      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_BKIN */
#define PIOB_12_SPI2_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief SPI2_MOSI */
#define PIOB_12_SPI2_MISO      AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief SPI2_MISO */
#define PIOB_12_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_12Ÿʱģʽ
 * @{
 */

#define PIOB_12_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_12_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ*/
#define PIOB_12_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_12_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_12_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_12_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_12_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_12_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_12Ӧ
 *
 * @{
 */

#define PIOB_12_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_12_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_12_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_13Ÿù
 * @{
 */

#define PIOB_13_SPI1_SCK       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_SCK */
#define PIOB_13_SPI2_MISO      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief SPI2_MISO */
#define PIOB_13_TIM1_CH1N      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH1N */
#define PIOB_13_SPI2_NSS       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief SPI2_NSS */
#define PIOB_13_SPI2_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief SPI2_MOSI */
#define PIOB_13_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C_SCL */
#define PIOB_13_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_13Ÿʱģʽ
 * @{
 */

#define PIOB_13_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_13_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_13_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_13_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_13_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_13_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_13_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_13_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_13Ӧ
 * @{
 */

#define PIOB_13_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_13_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_13_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_14Ÿù
 * @{
 */

#define PIOB_14_SPI1_MISO      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MISO */
#define PIOB_14_SPI2_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief SPI2_MOSI */
#define PIOB_14_TIM1_CH2N      AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH2N */
#define PIOB_14_SPI2_SCK       AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief SPI2_SCK */
#define PIOB_14_SPI2_NSS       AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief SPI2_NSS */
#define PIOB_14_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x05)   /**< \brief I2C_SDA */
#define PIOB_14_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_14Ÿʱģʽ
 * @{
 */

#define PIOB_14_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_14_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_14_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_14_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_14_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_14_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_14_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_14_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_14Ӧ
 * @{
 */

#define PIOB_14_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_14_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_14_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOB_15Ÿù
 * @{
 */
#define PIOB_15_SPI1_MOSI      AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief SPI1_MOSI */
#define PIOB_15_SPI2_NSS       AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief SPI2_NSS */
#define PIOB_15_TIM1_CH3       AM_ZML165_GPIO_FUNC_CODE(0x02)   /**< \brief TIM1_CH3N */
#define PIOB_15_SPI2_MISO      AM_ZML165_GPIO_FUNC_CODE(0x03)   /**< \brief SPI2_MISO */
#define PIOB_15_SPI2_SCK       AM_ZML165_GPIO_FUNC_CODE(0x04)   /**< \brief SPI2_SCK */
#define PIOB_15_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOB_15Ÿʱģʽ
 * @{
 */

#define PIOB_15_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOB_15_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOB_15_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOB_15_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOB_15_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOB_15_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOB_15_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOB_15_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOB_15Ӧ
 * @{
 */

#define PIOB_15_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOB_15_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOB_15_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOC_13Ÿù
 * @{
 */
#define PIOC_13_GPIO            AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOC_13Ÿʱģʽ
 * @{
 */

#define PIOC_13_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOC_13_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOC_13_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOC_13_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOC_13_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOC_13_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOC_13_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOC_13_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOC_13Ӧ
 * @{
 */

#define PIOC_13_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOC_13_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOC_13_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOC_14Ÿù
 * @{
 */
#define PIOC_14_GPIO            AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOC_14Ÿʱģʽ
 * @{
 */

#define PIOC_14_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOC_14_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOC_14_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOC_14_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOC_14_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOC_14_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOC_14_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOC_14_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOC_14Ӧ
 * @{
 */

#define PIOC_14_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOC_14_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOC_14_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOC_15Ÿù
 * @{
 */
#define PIOC_15_GPIO            AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOC_15Ÿʱģʽ
 * @{
 */

#define PIOC_15_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOC_15_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOC_15_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOC_15_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOC_15_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOC_15_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOC_15_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOC_15_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOC_15Ӧ
 * @{
 */

#define PIOC_15_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOC_15_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOC_15_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOD_0Ÿù
 * @{
 */

#define PIOD_0_CRS_SYNC       AM_ZML165_GPIO_FUNC_CODE(0x00)   /**< \brief CRS_SYNC */
#define PIOD_0_I2C_SDA        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SDA */
#define PIOD_0_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOD_0Ÿʱģʽ
 * @{
 */

#define PIOD_0_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOD_0_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOD_0_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOD_0_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOD_0_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOD_0_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOD_0_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOD_0_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOD_0Ӧ
 * @{
 */

#define PIOD_0_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOD_0_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOD_0_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOD_1Ÿù
 * @{
 */

#define PIOD_1_I2C_SCL        AM_ZML165_GPIO_FUNC_CODE(0x01)   /**< \brief I2C_SCL */
#define PIOD_1_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOD_1Ÿʱģʽ
 * @{
 */

#define PIOD_1_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOD_1_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOD_1_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOD_1_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOD_1_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOD_1_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOD_1_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOD_1_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOD_1Ӧ
 * @{
 */

#define PIOD_1_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOD_1_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOD_1_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOD_2Ÿù
 * @{
 */

#define PIOD_2_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOD_2Ÿʱģʽ
 * @{
 */

#define PIOD_2_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOD_2_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOD_2_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOD_2_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOD_2_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOD_2_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOD_2_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOD_2_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOD_2Ӧ
 * @{
 */

#define PIOD_2_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOD_2_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOD_2_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * \name PIOD_3Ÿù
 * @{
 */

#define PIOD_3_GPIO           AM_ZML165_GPIO_FUNC_CODE(0x0F)   /**< \brief GPIO */

/** @} */

/**
 * \name PIOD_3Ÿʱģʽ
 * @{
 */

#define PIOD_3_AIN            AM_ZML165_GPIO_MODE_CODE(0x0)   /**< \brief ģģʽ */
#define PIOD_3_INPUT_FLOAT    AM_ZML165_GPIO_MODE_CODE(0x1)   /**< \brief 븡ģʽĬϣ */
#define PIOD_3_INPUT_PD       AM_ZML165_GPIO_MODE_CODE(0x2)   /**< \brief ģʽ */
#define PIOD_3_INPUT_PU       AM_ZML165_GPIO_MODE_CODE(0x3)   /**< \brief ģʽ */
#define PIOD_3_OUT_PP         AM_ZML165_GPIO_MODE_CODE(0x4)   /**< \brief ͨģʽ */
#define PIOD_3_OUT_OD         AM_ZML165_GPIO_MODE_CODE(0x5)   /**< \brief ͨÿ©ģʽ */
#define PIOD_3_AF_PP          AM_ZML165_GPIO_MODE_CODE(0x6)   /**< \brief ģʽ */
#define PIOD_3_AF_OD          AM_ZML165_GPIO_MODE_CODE(0x7)   /**< \brief ÿ©ģʽ */

/** @} */

/**
 * \name PIOD_3Ӧ
 * @{
 */

#define PIOD_3_SPEED_10MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x03)   /**< \brief 10MHzӦ */
#define PIOD_3_SPEED_20MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x02)   /**< \brief 20MHzӦ */
#define PIOD_3_SPEED_50MHz    AM_ZML165_GPIO_OUTRES_RATE_CODE(0x01)   /**< \brief 50MHzӦ */

/** @} */

/******************************************************************************/

/**
 * @}
 */

/**
 * @}if_zml165_pin
 */

#ifdef __cplusplus
}
#endif

#endif /* __ZML165_PIN_H */

/* end of file */
